c
c    **************************************************************
c           parallel and perspective projection of a cluster
c                    in crystals and quasicrystals
c           In quasicrystals, all atom positions in 3D space
c           have been given, while in crystals, those for
c           independent atoms and symmetry operations should
c           be given
c    **************************************************************
c
c                             by A. Yamamoto
c                             Jan. 30, 2004
c
c
c     (0) icase itempf
c         icase: 0 for qcstrc output format for (9) (no symmetry operators)
c                1 for iatom output file for    (9) (use symmetry operators)
c                for icase=0, cartesian coordinates with the unit
c                vectors of 1A are used
c                for icase=1 unit vectors given in (2) are used
c         itempf: 1 anisotropic temperature factor
c         itempf: 0 and icase=0 see (9)
c         
c     (1) title
c          ****** if icase=0 skip (2) *****
c     (2) a,b,c,cosa,cosb,cosc
c         (lattice constants a,b,c in angstrome)
c     (3) na,ne,ng,ip,iat
c         na  number of independent atoms ( <= 20000)
c         ne  number of elements (1<=ne<=200)  (OD number)
c         ng  number of pages (default: 1)
c         ip  0: atom position is given in this file
c             1: atom position is read from another file
c         iat 0: occupation domain number in the second data in (9) for quasicrystals
c             1: element name 'Na' etc. in the second data in (9) for crystals

c         ****** if icase=0 skip (4)-(6) *****
c     (4) ns,ig,ic,brv
c         ns  number of symmetry operators or their generators  (ns<=1<=48)
c         ig  0: symmetry operator  1: generator
c         ic  1:centrocymmetric, 0:noncentrosymmetric
c         brv bravais lattice ('p', 'a', 'b', 'c', 'i', 'f', 'r')
c             or non periodic structure (' ')
c     (5) symmetry operator   (header)
c     (6) symmetry operations in the format of I.T.
c                for example x,y,z  1/2-x, y, 1/2+z etc.
c                repeat (6) ns times

c     (7) ldev,iww,iwb,iwc,iwa,ips,ccol,jmod,iornt
c         ldev : 1 black and white, 2 color
c         iww  : 1  print out x y z coordinates and bonded pairs
c         iwb 0: write bonds                  1: no bond
c         iwc 0: write unit cell              1: no unit cell
c         iwa 0: write atoms joined by bond   1: all atoms
c         ips 0: parallel projection          1: perspective projection
c         ccol : unit cell color (color display) or pen number (plotter)
c            for display
c            1:blue,2:red,3:purple,4:green,5:sky blue,6:yellow,7:white
c                  (default: white)
c         jmod : 0 non-shaded atoms  without atom number
c                1 shaded atoms
c                2 non-shaded atoms with atom number
c                3 bs-file output for using xbs
c                4 mld-file output for using vics
cc               5 non-shaded atoms with color determined by p1,p2,p3
c         iornt : orientation 1: portrait 2: landscape
c
c       ****** if ip=0 skip (8)
c     (8) flnm
c         flnm : file name of file including data (9)
c     (8') flnm1
c         flnm1 : file name for x,y,z,ui output  (jmod=0,1,2,5)
c                 prefix for bs files (nb files are created. see (16).)
c                                   (jmod=3)
c                 prefix of the file name for mld file  (jmod= 4)
c                 
c                 ****** bs file ******
c                 prefix of the file name for atom species, x, y, z
c                 spec name radius color
c                 bonds name1 name2 min-length max-length radius color

c                 ****** mld file ******
c                 title
c                 na (number of atoms)
c                 atom species x,y,z en (en : element number, repeat na times)
c                 nb (number of bonds)
c                 atom number pair for a bond  (repeat nb times)
c                        (en : 1 for H, 2 for He etc.)
c                ****** skip (8") if jmod > 2 *****
c     (8") flnm2
c         flnm2 : prefix of the file name for bonds
c         
c       ****** if ip=1 skip (9) but the same date should be given
c              as a separate file

c          if icase=0 or iat=0  (for quasicrystals)
c     (9)  atom number, od number, element number,x,y,z, p1, p2, p3 (*)
c          if itempf=1 u11,u22,u33,u23,u31,u12 should be followed at
c          the end of each line of (9) else p1,p2,p3 be followed
c          p1,p2,p3 : partial occupation prb for the 1st, 2nd and 3rd atoms

c          if iat=1   (for crystals)
c     (9)  atom number, symbol, element number,x,y,z (*)
c            if itempf=1 u11,u22,u33,u23,u31,u12 should be followed at
c            the end of each line of (9)
c
c        ******  repeat (9) na times

c     (10) rad,acol,symbol
c         rad:  atom radii (in angstrome)
c         acol: atom color
c         symbol: 'Al', 'Mn' etc.
c         repeat (10) ne times

c  ******* repeat (11)-(18) ng times ***********

c     (11) (S(i,j),j=1,3),T(i)    (*)
c            S :transformation matrix of the coordinate (integer)
c            T :translation vector
c             repeat (11) three times (i=1,2,3)
c  ********************************************

c     (12) atom selection   ias(1)-ias(na)   (80i1)
c         ias(i):1 i-th atom is selected, :0 neglected
c     (13) hp,xp,amgn,xvp
c         hp(1)-hp(3) : projection axis
c            hp = hp(1)a* + hp(2)b* + hp(3)c*
c         xp(1)-xp(3) : y axis
c         amgn  magnification of x,y,radius  (cm/angstrome)
c               (default: 1.0)
c          xvp  distance from visual point to origin (in angstrom)
c               (default: 20.0)
c     (14) lxmin,lxmax,lymin,lymax,lzmin,lzmax
c          from a give atom with the coordinate x,y,z 
c          atoms with the coordinates x+lx, y+ly, z+lz within the ranges
c          lxmin<=lx<=lxmax,lymin<=ly<=lymax,lzmin<=lz<=lzmax are generated
c          (for quasicrystals, lxmin=lxmax=lymin=lymax=lzmin=lzmax=0)
c     (15) fxyz
c          fxyz(1)-fxyz(3): fixed point for rotation etc.
c                           (origin of the plotter system)
c              ******* data for choosing shells in the cluster *********
c              we can choose atoms which construct a cluster by rmin,rmax,
c              zmin,zmax,iaslct,jaslct specified below
c  
c     (16) nb,nclc
c          nb : number of shells   ( 0 < nb )
c          nclc: number of cluster centers
c     (17) hb
c          hb(1)-hb(3): projection axis  
c     (17') xo,rmin,rmax,jc,zmin,zmax,ns0
c              hb = hb(1)a* + hb(2)b* + hb(3)c*
c          xo(1)-xo(3): center of the cluster
c              xo = xo(1)a  + xo(2)b  + xo(3)c
c          rmin  minimum radius of the shell in angstrome
c          rmax  maximum radius of the shell in angstrome
c          jc : 0 place cluster center at the origin
c               1 place cluster center at average of xo
c             **** added
c          ns0  : symmetry operator number which is applied to xo
c                 if centrosymmetric and it is rotoinversion
c                 give nsymo+ns for ns0
c                 ns0=1 means identity operation
c          ********** repeat (17') nclc times ************

c     (18) shiftx,shifty
c          sift of origin (in cm) before plot
c  **************if iwb=1 skip (19,20)************
c     (19)  np,iaslct
c           np  number of element pairs to be joined by bonds(<=20)
c           iaslct 0,1,2, or 3 for no selection,
c                  select by element No, OD No  or serial No.
c           iaslct=0 means all atoms are selected.
c           for iaslct>0 give jaslct in (21) for choosing atoms or ODs
c     (20) ie1,ie2,dmin,dmax,bwdt,bcol
c         ie1,ie2  element pair to be joined by a line (bond)
c         dmin     min. distance to be joined
c         dmax     max. distance to be joined
c         bwdt     bond width (pen number)
c         bcol     bond color (for color display)
c            ***** if iaslct=0 skip (21)
c     (21)  jaslct (80i1)
c           (for iaslct=1) 1 for selected element 0 others
c           (for iaslct=2) 1 for selected OD 0 others
c           (for iaslct=3) 1 for selected atom (serial No.) 0 others
c           repeat (20) np times
c           repeat (16)-(20) nb times
c******************limiting conditions******************************
c      maximum number of atoms in a unit cell   namax
c      maximum number of atoms in each elements namax/ne
c*******************************************************************
c
      include "cluster.inc"
      real h(3),x(3)
      real rad(nemax)
      common /crad/ rad
      integer ias(namax)
      common /cias/ ias
      real d(6*nemax*nemax)
      integer iflag(namax)

      integer inumb(namax),jnumb(namax)
      real dmin(namax),dmax(namax)
      character(8) jsymb(namax)
      common /cpatom/inumb,jnumb,dmin,dmax,jsymb

      integer ie1(nemax),ie2(nemax),jas(namax)
      common /cpatom1/ ie1,ie2,jas

      integer iaw(namax)
      integer acol,bwdt,bcol,ccol,dcol
      common /ccolor/ acol(nemax),bwdt(nemax),bcol(nemax),ccol,dcol,
     *                jmod,ldev
      common /cidm/ jdm, czmin(nemax), czmax(nemax)
      common /cwtxyz/ iel0(nemax)  ! for jmod=4

      integer pcol
      common /cpcol/ pcol
      common /ctwait/ iwt1,iwt2,iwt3
      common /cwflag/ iwb,iwc,iwa,iww
      dimension xx(3),hb(3,6*nemax),icd(8),jcd(4),iscl(7)
      common /cgetrmm/ rmin(nemax),rmax(nemax),shiftx(nemax),
     *     shifty(nemax),xo(3,nemax),jc(nemax)
      integer iaslct(nbmax)
      real dmind(nemax,nbmax),dmaxd(nemax,nbmax)
      integer bwdtd(namax,nbmax),bcold(namax,nbmax)
      integer jasd(namax,nbmax)
      integer ie1d(nemax,nbmax),ie2d(nemax,nbmax)
      integer nend(nbmax)
      real xr(2),yr(2),zr(2)
      integer np(nbmax)

      integer atom
      character(8) atomsymb
      character brv
      common /cltc/ atom(namax), atomsymb(namax)
      common /ccnst/na,ne,ng,ip,iat
      real x0(3)
      integer sij
      common /ctrns/ sij(3,3),tj(3)
      real or(3,3)
      real fxyz(3),rxyz(3),rang,pxyz(3),on(3,3),xvp(3)
      common /crotat/ fxyz,rxyz,rang,pxyz,on,xvp,amgn
      common /clrng/ lxmin,lxmax,lymin,lymax,lzmin,lzmax
      real hp(3),xp(3),hd(3)
      integer hmax(2)
      character(80) flnm,flnm1,flnm2,flnm1d
      character(2) symbol
      common /csymb/ symbol(nemax)
      
      integer getiaslct,getatomno
      data iflag/namax*0/
      data nbd/6/
      data icd/7,1,2,3,4,5,6,7/
      data jcd/3,2,0,1/
      data hb/-1.,0.,0.,1.,0.,0.,0.,-1.,0.,0.,1.,0.,
     *   0.,0.,-1.,0.,0.,1.,nem5*0/
c*****initial pen color
      pcol=1
      call setinp(5)
      call setout(6)
      call setskp(0)
c*****read title and lattice constants************************
      call freadi('icase=',1,icase,1)
      call freadi('itempf=',1,itempf,0)
      write(6,'(2(a,i3))') 'icase=',icase,' itempf=',itempf
      call rdlc(icase)
      call freadi('na=',1,na,1)
      call freadi('ne=',1,ne,0)
      call freadi('ng=',1,ng,0)
      call freadi('ip=',1,ip,0)
      call freadi('iat=',1,iat,0)
c      if(icase.eq.0) then
c         if(icase.eq.0.and.iat.ne.0) then
c            iat=0
c            write(6,*) 'reset at iat=0'
c         end if
c      end if
      write(6,200) na,ne,ng,ip,iat
      call rdsym(icase)
      hmax(1)=ne
      hmax(2)=namax/ne
      call sethmax(hmax)
      if(ng.eq.0) ng=1
      call freadi('ldev=',1,ldev,1)
      call freadi('iww=',1,iww,0)
      call freadi('iwb=',1,iwb,0)
      call freadi('iwc=',1,iwc,0)
      call freadi('iwa=',1,iwa,0)
      call freadi('ips=',1,ips,0)
      call freadi('ccol=',1,ccol,0)
      call freadi('jmod=',1,jmod,0)
      call freadi('iornt=',1,iornt,0)
      if(ldev.eq.0) ldev=1
      if(ldev.eq.5) then
          ccol=icd(ccol+1)
      end if
      write(6,201) ldev,iww,iwb,iwc,iwa,ips,ccol,jmod,iornt
      call setjmod(jmod)

      if(ip.eq.1) then
         call freadc('flnm=',1,flnm,1)
         call openfile(50,flnm,'OLD')
      end if

      if(jmod.le.2.or.jmod.eq.5) then
         call freadc('flnm1=',1,flnm1,1)
         call openfile(51,flnm1,'UNKNOWN')
         call freadc('flnm2=',1,flnm2,1)
         call openfile(52,flnm2,'UNKNOWN')
      else if(jmod.eq.3.or.jmod.eq.4) then
         call freadc('flnm1=',1,flnm1,1)
         call openfile(51,flnm1,'UNKNOWN')
      end if

      call rdap(na,ip,iat,icase,itempf)
      call sitesy(na) 
      if(na.gt.namax) then
         call quit('na > namax')
      end if
c*****read radii and color of atoms**********
      do i=1,ne
         call freadr('rad=',1,rad(i),1)
         call freadi('acol=',1,acol(i),0)
         call freadc('symbol=',1,symbol(i),0)
         iel0(i)=getatomno(symbol(i))
      end do
      call setacol(acol,ne)
      if(ldev.eq.5) then
         do i=1,ne
            if(acol(i).eq.0) acol(i)=1
         end do
      end if
      write(6,*) 'atom radius, color and symbol'
      do i=1,ne
         write(6,'(f10.5,i3,2x,a)') rad(i),acol(i),symbol(i)
      end do
c**** find unused color
      if(ldev.eq.5) then
         do i=1,7
            iscl(i)=0
         end do
         iscl(7)=1
         do i=1,ne
            iscl(acol(i))=1
         end do
         do i=1,7
            if(iscl(i).eq.0) then
               dcol=i
               go to 57
            end if
         end do
 57      continue
      end if
c******** 
      do jg=1,ng
         do i=1,3
            read(5,*) (sij(i,j),j=1,3),tj(i)
         end do
         do i=1,3
            write(6,*) (sij(i,j),j=1,3),tj(i)
         end do
         read(5,'(80i1)') (ias(i),i=1,na)
         n=0
         do i=1,na
            n=n+1
            if(ias(i).ne.0) then
               iaw(n)=i
            end if
         end do
         write(6,208) (iaw(i),i=1,n)
c*****read projection axis,y axis and magnification**********
c     read(5,102) hp,xp,amgn,xvp(3)
         call zerovr(xvp,3)
         call freadra('hp=',3,hp,1)
         call freadra('xp=',3,xp,0)
         call freadr('amgn=',1,amgn,0)
         call freadr('xvp=',1,xvp(3),0)
         if(hp(1).eq.0.and.hp(2).eq.0.and.hp(3).eq.0) then
            hp(1)=-0.4
            hp(2)=-0.2
            hp(3)=-0.05
         end if
         if(xp(1).eq.0.and.xp(2).eq.0.and.xp(3).eq.0) then
            xp(1)=0.0
            xp(2)=0.0
            xp(3)=1.0
         end if
         if(amgn.eq.0) amgn=1.
         write(6,2040) hp,xp,amgn

         if(ips.eq.0) then
            call zerovr(xvp,3)
         else
            if(xvp(3).eq.0) then
               xvp(3)=20.
            end if
            write(6,2041) xvp
         end if
         
c*****transformationmatrixto the plotter system
         call xxx(hp)
         call xxx(xp)
         call ormtrx(hp,xp,on)
         
c     transformation to the plotter system
         call mxv(on,xvp) 
c     lattice vector range
         call freadi('lxmin=',1,lxmin,1)
         call freadi('lxmax=',1,lxmax,0)
         call freadi('lymin=',1,lymin,0)
         call freadi('lymax=',1,lymax,0)
         call freadi('lzmin=',1,lzmin,0)
         call freadi('lzmax=',1,lzmax,0)
         if(icase.eq.0.or.iat.eq.0) then  ! quasicrystal
            lxmin=0
            lxmax=0
            lymin=0
            lymax=0
            lzmin=0
            lzmax=0
         end if
         write(6,*) 'lxmin=',lxmin,' lxmax=',lxmax
         write(6,*) 'lxmin=',lxmin,' lxmax=',lxmax
         write(6,*) 'lymin=',lymin,' lymax=',lymax
         write(6,*) 'lzmin=',lzmin,' lzmax=',lzmax
         call freadra('fxyz=',3,fxyz,1)
         write(6,*) 'fxyz=',fxyz

c*****readboundaryconditions*********
         call freadi('nb=',1,nb,1)
         call freadi('nclc=',1,nclc,0)
         call setnb(nb)

         if(ne*nclc.gt.nemax) then
            write(6,*) 'ne=',ne,' nclc=',nclc,' nemax=',nemax
            call quit('ne*nclc should be less than nemax')
         end if

         if(nclc.le.0) then
            call quit('nclc should be positive')
         end if

         write(6,*) 'nb=',nb,  ' nclc=',nclc
         call setnclc(nclc)
         if(abs(nb).lt.4) ie=1
         if(abs(nb).ge.4) ie=abs(nb)
c     if(abs(nb).ge.4) write(6,213)
         call getnpod(npod)
         do i=1,nb
            if(jmod.eq.3) then
               call getflnm(i,flnm1,flnm1d,'.bs')
               call openfile(51,flnm1d,'UNKNOWN')
            else if(jmod.eq.4) then
               call getflnm(i,flnm1,flnm1d,'.mld')
               call openfile(51,flnm1d,'UNKNOWN')
            end if

            call freadra('hb=',3,hb(1,i),1)
            write(6,'(a,3f10.5)') 'hb=',(hb(j,i),j=1,3)
            do k=1,nclc
               ik=i+(k-1)*nb
               call freadra('xo=',3,x0,1)
               call freadr('rmin=',1,rmin(ik),0)
               call freadr('rmax=',1,rmax(ik),0)
               call freadi('jc=',1,jc(ik),0)
               call freadi('ns0=',1,ns0,0)
               write(6,'((a,3f10.5),2(a,f10.5),a,i3,a,i3)')
     *              ' xo=',(x0(j),j=1,3),' rmin=',rmin(ik),
     *              ' rmax=',rmax(ik),' jc=',jc(ik),' ns0=',ns0
               call rednsic(ns0,ns,ic)
               write(6,*) 'ns0,ns,ic=',ns0,ns,ic
               call getrx(x0,xo(1,ik),ns,ic)
               if(iat.eq.1) then
                  call reduc(xo(1,ik))
               end if
c               write(6,'((a,3f10.5),2(a,f10.5),a,i3,a,i3)')
c     *              ' xo=',(xo(j,ik),j=1,3),' rmin=',rmin(ik),
c     *              ' rmax=',rmax(ik),' jc=',jc(ik),' ns0=',ns0
            end do

c**********readsiftof origin **********
            call freadr('shiftx=',1,shiftx(i),1)
            call freadr('shifty=',1,shifty(i),0)
            write(6,210) shiftx(i),shifty(i)

            call freadi('np=',1,np(i),1)
            call freadi('iaslct=',1,iaslct(i),0)
            call setiaslct(iaslct(i))
c*****read element pairs joined by bonds**********************
            do j=1,np(i)
               call freadi('ie1=',1,ie1d(j,i),1)
               call freadi('ie2=',1,ie2d(j,i),0)
               call freadr('dmin=',1,dmind(j,i),0)
               call freadr('dmax=',1,dmaxd(j,i),0)
               call freadi('bwdt=',1,bwdtd(j,i),0)
               call freadi('bcol=',1,bcold(j,i),0)
            end do
            call readjasd(i,iaslct(i),jasd(1,i),nend(i))
            if(ldev.eq.2) then
               do j=1,np(i)
c     defalt bond color ==> black
                  if(bcold(j,i).eq.0) bcold(j,i)=0
               end do
            end if
            do j=1,np(i)
               write(6,'(a,2i3,2(a,f10.5),2(a,i3))') 
     *              'pair',ie1d(j,i),ie2d(j,i),
     *              ' dmin=',dmind(j,i),' dmax=',dmaxd(j,i),
     *              ' bwdt=',bwdtd(j,i),' bcol=',bcold(j,i)
            end do
c     end do                 ! nb loop
            if(i.eq.1) then
c*********read rotation conditions *******
               write(6,'(a,3f10.5)') 'fxyz=',fxyz(1),fxyz(2),fxyz(3)
c     transfrmation to the orthogonal system
               call xxx(fxyz)
c     transformation to the plotter system
               call mxv(on,fxyz)
c     
               call orient(iornt) ! set portrait or landscape
               call plots(0.,0.,ldev)
            end if
c     do i=1,nb
c     write(6,*) '****iaslct(i)=',iaslct(i)
            call setiaslct(iaslct(i))
c     write(6,*) '****getiaslct()=',getiaslct()
c     orientation matrix for each shell
c     call cpyvec(hb(1,i),hd,3)
            call vcpyr(hb(1,i),hd,3)
            call xxx(hd)        ! projection axis
            call ormtrx(hd,xp,on) ! set orientation matrix
            call vcpyi(jasd(1,i),jas,nend(i))
c     call wtvctri('jas=',jas,nend(i))  ! printout vector jas
            if(iwb.eq.0) then
               call vcpyi(ie1d(1,i),ie1,np(i))
               call vcpyi(ie2d(1,i),ie2,np(i))
               call vcpyr(dmind(1,i),dmin,np(i))
               call vcpyr(dmaxd(1,i),dmax,np(i))
               call vcpyi(bwdtd(1,i),bwdt,np(i))
               call vcpyi(bcold(1,i),bcol,np(i))
            end if
            if(jmod.le.2.or.jmod.eq.5) then
               write(6,'(a,i2,a)') '********* shell ',i,' ***********'
               write(51,'(a,i2,a)') '********* shell ',i,' ***********'
            else if(jmod.eq.4) then
               write(51,'(3a)') '"','No Title','"'
            end if
            call plot(shiftx(i),shifty(i),-3)
            call patom(na,i,np(i),rad,ne,hb,d,iflag,ips,iat,icase)
         end do
         if(jmod.eq.3.or.jmod.eq.4) then
            close(51)
         end if
         call plote('end of plot')
      end do
c     if(ldev.eq.1.or.ldev.eq.2) call getzap()      
      stop
 200  format('na=',i5,1x,'ne=',i3,1x,'ng=',i3,1x,'ip=',i1,1x,
     *      'iat=',i3)
 201  format('ldev=',i1,2x,'iww=',i1,2x,'iwb=',i1,2x,'iwc=',i1,
     *     2x,'iwa=',i1,2x,'ips=',i1,2x,'ccol=',i1,2x,'jmod=',i1,
     *     2x,'iornt=',i1)
 2040 format('plane normal',3f8.5/'y-axis',6x,3f8.5/
     *       'magnif.',5x,f8.5)
 2041 format('visual point',5x,3f8.5)
c 206  format(3f10.5,2x,3f10.5,2f10.5,i2)
c 207  format('atom radius and color'/(8(f8.5,i2)))
 208  format('selected atom'/(20(i4)))
 210  format('origin',2x,2f9.5)
      end

      subroutine setacol(acold,ne)
      integer acold(*)
      include "cluster.inc"
      integer acol
      common /cacol/ acol(nemax)
      if(ne.gt.nemax) call quit('ne > nemax in setacol')
      do i=1,ne
         acol(i)=acold(i)
      end do
      return
      end

      subroutine getacol(acold,ne)
      integer acold(*)
      include "cluster.inc"
      integer acol
      common /cacol/ acol(nemax)
      if(ne.gt.nemax) call quit('ne > nemax in setacol')
      do i=1,ne
         acold(i)=acol(i)
      end do
      return
      end

      function getrad(i)
      include "cluster.inc"
      real rad(nemax)
      common /crad/ rad
      getrad=rad(i)
      return
      end

      subroutine setjmod(jmodd)
      common /cjmod/ jmod
      jmod=jmodd
      return
      end

      subroutine getjmod(jmodd)
      common /cjmod/ jmod
      jmodd=jmod
      return
      end

      subroutine getflnm(i,flnm1,flnm1d,ext)
      integer i
      character(*) flnm1,flnm1d,ext
      character*2 chr
      iln1=istrln(flnm1)
      if(i.le.9) then
         iln2=1
         write(chr,'(i1)') i
      else if(i.le.99) then
         iln2=2
         write(chr,'(i2)') i
      else
         write(6,*) 'nb should be 0 < nb < 99'
         stop
      end if
      flnm1d=flnm1(1:iln1)//'_'//chr(1:iln2)//ext
      write(6,*) 'filenm1d=',flnm1d
      return
      end

      subroutine readjasd(i,iaslct,jasd,nend)
      integer jasd(*)
      include "cluster.inc"
      integer ias(namax)
      common /cias/ ias
      common /ccnst/na,ne,ng,ip,iat
      call getnpod(npod)
      if(iaslct.eq.1) then
         nend=ne
         read(5,'(80i1)') (jasd(n),n=1,nend)
      else if(iaslct.eq.2) then
         nend=npod
         read(5,'(80i1)') (jasd(n),n=1,nend)
      else if(iaslct.eq.3) then
         nend=na
         read(5,'(80i1)') (jasd(n),n=1,nend)
      else                      ! default
         iaslct=0
         nend=npod
         call vcpyi(ias,jasd,npod)
      end if
      return
      end

      subroutine reduc(x)
      real x(*)
      data eps/0.00001/
      do ix=1,3
          x(ix)=amod(x(ix),1.0)
          if(x(ix).le.-0.5+eps) then
              x(ix)=x(ix)+1.0
          else if(x(ix).gt. 0.5+eps) then
              x(ix)=x(ix)-1.0
          end if
       end do
      return
      end

      subroutine setiaslct(iaslctd)
      common /ciaslct/ iaslct
      iaslct=iaslctd
      return
      end

      integer function getiaslct()
      common /ciaslct/ iaslct
      getiaslct=iaslct
      return
      end

      subroutine setnpod(npodd)
      common /cnpod/ npod
      npod=npodd
      return
      end

      integer function getiat()
      common /ccnst/na,ne,ng,ip,iat
      getiat=iat
      return
      end

      subroutine getnpod(npodd)
      common /cnpod/ npod
      npodd=npod
      return
      end

      subroutine xxx(r)
      dimension rr(3),r(3)
      common /mtrtns/ gabx(3,3),gaby(3,3),gabcx(3,3),gabcy(3,3)
      do i=1,3
         rr(i)=0.0
         do j=1,3
            rr(i)=rr(i)+gabcx(i,j)*r(j)
         end do
      end do
      r(1)=rr(1)
      r(2)=rr(2)
      r(3)=rr(3)
      return
      end

      subroutine yyy(r)
      common /mtrtns/ gabx(3,3),gaby(3,3),gabcx(3,3),gabcy(3,3)
      dimension rr(3),r(3)
      do i=1,3
         rr(i)=0.0
         do j=1,3
            rr(i)=rr(i)+r(j)*gabcy(j,i)
         end do
      end do
      r(1)=rr(1)
      r(2)=rr(2)
      r(3)=rr(3)
      return
      end

      function iend(ip,nelmx,ne)
      integer ip(*),nelmx(*)
      iend=0
      do i=1,ne
         if(ip(i).ne.nelmx(i)) then
            return
         end if
      end do
      iend=1
      return
      end

      subroutine atmout(x,y,r,col,xl,yl)
      integer col
c       x,y: x,y cordinates in cm
c       r  : radius of atom in cm
c       col: color
c       xl,yl: direction cosine of light direction
      character(80) str
      cl=mod(col/10.,1.0)
      write(str,'(7f9.3,a)') x,y,r,cl,0.02,xl,yl,' atom '
      call psout(ldev,str)
      return
      end

      subroutine pltat10(x1,r1,ncol)
      real x1(3),xx(25),yy(25),xa(2)
      integer color
      data pi/3.14159/, eps/0.03/
      data sqrt2/1.414213/, sqrt6/2.44949/, sqrt12/3.46410/
      call fillarea(1)
      kcol=ncol-mod(ncol,10)
      color=ncol-5+1
      if(color.lt.kcol+1) then
           color=kcol+1
      else if(color.gt.kcol+9) then
           color=kcol+9
      end if
      call setcol(color)
      call circle(0.,360.,r1,x1,0)
      r2=r1**2
      do i=2,6
         t=pi-pi*i/6
         color=ncol-5+i
         if(color.lt.kcol+1) then
            color=kcol+1
         else if(color.gt.kcol+9) then
            color=kcol+9
         end if
         sint=sin(t)
         cost=cos(t)
         zd=r1*cost
         call setcol(color)
         nt=20
         m=0
         do j=-nt/2,nt/2
            f=2*pi*j/nt
            xd=r1*sint*cos(f)
            yd=r1*sint*sin(f)
c     a'=(-2-22)/sqrt(12)
c     b'=(1-10)/sqrt(2)
c     c'=(112)/sqrt(6)
            x=-2*xd/sqrt12+yd/sqrt2+zd/sqrt6
            y=-2*xd/sqrt12-yd/sqrt2+zd/sqrt6
            z= 2*xd/sqrt12       +2*zd/sqrt6
            rr2=x**2+y**2
            rdif=r2-rr2
            if(z.gt.0) then
               m=m+1
               xx(m)=x+x1(1)
               yy(m)=y+x1(2)
            end if
         end do
c 120     continue
         n=m
         if(n.gt.0) then
c     center of an ellipse
            xx(n+1)=zd/sqrt6+x1(1)
            yy(n+1)=zd/sqrt6+x1(2)
c     initial point
            xx(n+2)=xx(1)
            yy(n+2)=yy(1)
c     
            xx(n+3)=0
            yy(n+3)=0
            xx(n+4)=1
            yy(n+4)=1
            call plylin(xx,yy,n+2,1,0,0)
c     angle calculation
            xa(1)=xx(1)-x1(1)
            xa(2)=yy(1)-x1(2)
            call atanf(xa,ae)
            xa(1)=xx(n)-x1(1)
            xa(2)=yy(n)-x1(2)
            call atanf(xa,as)
            call circle(as*360,ae*360,r1,x1,0)
            xx(1)=xx(1)
            yy(1)=yy(1)
            xx(2)=xx(n)
            yy(2)=yy(n)
            xx(3)=xx(n+1)
            yy(3)=yy(n+1)
            xx(4)=0
            yy(4)=0
            xx(5)=1
            yy(5)=1
            call plylin(xx,yy,3,1,0,0)
         end if
      end do
      return
      end

      subroutine pltat2(elmx,r,acol,nelmx,sarc,nnarc,ne)
      real elmx(3,*),r(*),sarc(2,*),arc(2,500),x1(2)
      include "cluster.inc"
      integer acol(*),nelmx(*),nnarc(*),iarc(nemax)
      integer gethkltoj
      do ie=1,ne
         iarc(ie)=0
         do je=1,nelmx(ie)
            ieje=gethkltoj(ie,je)
            narc=nnarc(ieje)
            do ia=1,narc
               iarc(ie)=iarc(ie)+1
               ieiarc=gethkltoj(ie,iarc(ie))
               arc(1,ia)=sarc(1,ieiarc)
               arc(2,ia)=sarc(2,ieiarc)
               rc=r(ieje)
               x1(1)=elmx(1,ieje)
               x1(2)=elmx(2,ieje)
               call circle(arc(1,ia)*360,arc(2,ia)*360,
     *              rc,x1,0)
            end do
         end do
      end do
      return
      end
c
      subroutine rdlc(icase)
      character(80) mater
      common /ctitle/ mater
      call freadc('title=',1,mater,1)
      if(icase.eq.0) then  ! non-periodic crystal
         a=1
         b=1
         c=1
         cosa=0
         cosb=0
         cosc=0
         iat=0
      else                 ! periodic crystal
c     read(5,99) mater
c     read(5,100) a,b,c,cosa,cosb,cosc
         call freadr('a=',1,a,1)
         call freadr('b=',1,b,0)
         call freadr('c=',1,c,0)
         call freadr('cosa=',1,cosa,0)
         call freadr('cosb=',1,cosb,0)
         call freadr('cosc=',1,cosc,0)
      end if

      write(6,299) mater
      write(6,300) a,b,c,cosa,cosb,cosc
      call setmtrtns(a,b,c,cosa,cosb,cosc)
 299  format(a)
 300  format('lattice constants  ','a=',f10.6,'(a)',2x,'b=',f10.6,
     *  '(a)',2x,'c=',f10.6,'(a)',2x,'cosa=',f10.6,2x,'cosb=',f10.6,2x,
     *   'cosc=',f10.6)
      return
      end

      subroutine setmtrtns(a,b,c,cosa,cosb,cosc)
      common /mtrtns/ gabx(3,3),gaby(3,3),gabcx(3,3),gabcy(3,3)
      real bb(3)
      gabx(1,1)=a**2
      gabx(2,2)=b**2
      gabx(3,3)=c**2
      gabx(1,2)=a*b*cosc
      gabx(2,3)=b*c*cosa
      gabx(3,1)=c*a*cosb
      gabx(2,1)=gabx(1,2)
      gabx(3,2)=gabx(2,3)
      gabx(1,3)=gabx(3,1)

      call mcpyr3(gabx,gaby)
      call matinv3(gaby,bb,0,det)

      sina=sqrt(1.0-cosa**2)
      sinb=sqrt(1.0-cosb**2)
      sinc=sqrt(1.0-cosc**2)
      gabcx(1,1)=a*sqrt(1.0-cosa**2-cosb**2-cosc**2+
     *           2.0*cosa*cosb*cosc)/sina
      gabcx(1,2)=0.0
      gabcx(1,3)=0.0
      gabcx(2,1)=a*(cosc-cosa*cosb)/sina
      gabcx(2,2)=b*sina
      gabcx(2,3)=0.0
      gabcx(3,1)=a*cosb
      gabcx(3,2)=b*cosa
      gabcx(3,3)=c
      vc=gabcx(1,1)*gabcx(2,2)*gabcx(3,3)
      gabcy(1,1)=gabcx(2,2)*gabcx(3,3)/vc
      gabcy(1,2)=0.0
      gabcy(1,3)=0.0
      gabcy(2,1)=(-gabcx(2,1)*gabcx(3,3))/vc
      gabcy(2,2)=(gabcx(1,1)*gabcx(3,3))/vc
      gabcy(2,3)=0.0
      gabcy(3,1)=(gabcx(2,1)*gabcx(3,2)-gabcx(2,2)*gabcx(3,1))/vc
      gabcy(3,2)=(-gabcx(1,1)*gabcx(3,2))/vc
      gabcy(3,3)=(gabcx(1,1)*gabcx(2,2))/vc
      return
      end

      function absx(x)
      real x(*)
      common /mtrtns/ gabx(3,3),gaby(3,3),gabcx(3,3),gabcy(3,3)

      absx=0
      do i=1,3
         do j=1,3
            absx=absx+x(i)*gabx(i,j)*x(j)
         end do
      end do
      absx=sqrt(absx)
      return
      end

      function absy(x)
      real x(*)
      common /mtrtns/ gabx(3,3),gaby(3,3),gabcx(3,3),gabcy(3,3)

      absy=0
      do i=1,3
         do j=1,3
            absy=absy+x(i)*gaby(i,j)*x(j)
         end do
      end do
      absy=sqrt(absy)
      return
      end

      function absvec(x)
      real x(*)
      absvec=0.
      do i=1,3
         absvec=absvec+x(i)**2
      end do
      absvec=sqrt(absvec)
      return
      end

      
      subroutine savex(rx,rxs)
      real rx(*),rxs(*)
      common /cdim/ idm,nde
      do i=1,idm
         rxs(i)=rx(i)
      end do
      return
      end

      subroutine quit(str)
      character(*) str
      write(6,*) str
      close(unit=3)
      close(unit=4)
      close(unit=91)
      close(unit=92)
      stop
      end

      subroutine getrmm(i,x0,rmn,rmx,ic)
c     get x0,rmin and rmax for i-th shell
      real x0(3)
      include "cluster.inc"
      common /cgetrmm/ rmin(nemax),rmax(nemax),shiftx(nemax),
     *     shifty(nemax),xo(3,nemax),jc(nemax)
      call vcpyr(xo(1,i),x0,3)
      rmn=rmin(i)
      rmx=rmax(i)
      ic=jc(i)
c      write(6,'(a,i3,5f10.5)') "i,rmn,rmx,x0",i,rmn,rmx,x0
      return
      end

      subroutine getavrx0(nclc,x0)
c     get x0,rmin and rmax for i-th shell
      real x0(3)
      include "cluster.inc"
      common /cgetrmm/ rmin(nemax),rmax(nemax),shiftx(nemax),
     *     shifty(nemax),xo(3,nemax),jc(nemax)
      call zerov(x0,3)
      do i=1,nclc
         call vsumr(x0,xo(1,i),x0,3)
      end do
      fact=1.0/nclc
      call vfact(x0,fact,3) ! multiplied by fact
      return
      end

      subroutine openfile(iun,flnm,st)
      integer iun
      character(*) flnm,st

      lflnm=istrln(flnm)
      lst=istrln(st)
      open (unit=iun,file=flnm(1:lflnm),status=st(1:lst),err=910)
      go to 810
 910  write(6,*) 'can''t open ',flnm(1:lflnm)
      call exit(1)
 810  continue
      return
      end

      integer function getndm()  ! for gethkl
      getndm=2
      return
      end

      subroutine sethmax(hmaxd)
      integer hmaxd(*)
      integer hmax
      common /chmax/ hmax(6)
      integer getndm
      ndm=getndm()
      call vcpyi(hmaxd,hmax,ndm)
      return
      end

      subroutine gethmax(hmaxd)
      integer hmaxd(*)
      integer hmax
      common /chmax/ hmax(6)
      integer getndm
      ndm=getndm()
      call vcpyi(hmax,hmaxd,ndm)
      return
      end


      subroutine getuijtoui(uij,ui)
      real uij(3,3),ui(6)
      ui(1)=uij(1,1)
      ui(2)=uij(2,2)
      ui(3)=uij(3,3)
      ui(4)=uij(2,3)
      ui(5)=uij(3,1)
      ui(6)=uij(1,2)
      return
      end

      subroutine getuitouij(ui,uij)
      real ui(6),uij(3,3)
      uij(1,1)=ui(1)
      uij(2,2)=ui(2)
      uij(3,3)=ui(3)
      uij(2,3)=ui(4)
      uij(3,2)=ui(4)
      uij(3,1)=ui(5)
      uij(1,3)=ui(5)
      uij(1,2)=ui(6)
      uij(2,1)=ui(6)
c      do i=1,3
c         write(6,*) (uij(i,j),j=1,3)
c      end do
      return
      end

c      subroutine exit(i)
c      stop
c      end

      subroutine setitempf(itempfd)
      common /ctempf/ itempf
      itempf=itempfd
      return
      end

      integer function getitempf()
      common /ctempf/ itempf
      getitempf=itempf
      return
      end

      subroutine setnclc(nclcd)
      common /cnclc/ nclc
      nclc=nclcd
      return
      end

      integer function getnclc()
      common /cnclc/ nclc
      getnclc=nclc 
      return
      end

      subroutine setnb(nbd)
      common /cnb/ nb
      nb=nbd
      return
      end

      integer function getnb()
      common /cnb/ nb
      getnb=nb 
      return
      end

      
