      subroutine rotui(uixy)  ! rotation of aniso tempf by on
      real uixy(*)  ! ui in the common orthogonal system (q system)
c     rotation of anisotropic temp. fact. uij in physical space
c     symmetric tensor does not depend on inversion
c     rotation matrix depends on OD in this case
      real fxyz(3),rxyz(3),rang,pxyz(3),on(3,3),xvp(3)
      common /crotat/ fxyz,rxyz,rang,pxyz,on,xvp,amgn
      real uij(3,3) 
      real m1(3,3)
      real ont(3,3)
      call mcpyr(on,ont,3)
      call trnspr3(ont)
c     uij times rei transpose
      call getuitouij(uixy,uij)   ! get symmetric matrix uij from ui
      call mtmplr3(uij,ont,m1)
c     uij= ret*uij*re 
      call mtmplr3(on,m1,uij)
      call getuijtoui(uij,uixy)   ! get ui from uij
      return
      end

      subroutine rmx(x,xd,ips,fact)
      real x(*),xd(*)
      real fxyz(3),rxyz(3),rang,pxyz(3),on(3,3),xvp(3)
      common /crotat/ fxyz,rxyz,rang,pxyz,on,xvp,amgn
      real s(3)
      call vcpyr(x,s,3)
c     transform into the orthogonal system
c      call xxx(s)
c     take origin at the fixed point 
      call vsubr(s,fxyz,s,3)
      call xxx(s)
c     orthogonal transformation by the orientation matrix
      call mxv(on,s)
c     viewing transformation and restore the origin
      if(ips.eq.0) fact=1
      if(ips.eq.1) fact=xvp(3)/(xvp(3)-s(3))
      do kk=1,2
         xd(kk)=s(kk)*fact*amgn
      end do
      xd(3)=s(3)*amgn
      return
      end
      
      subroutine mxv(rm,s)
      real rm(3,*),s(*)
      real xd(3)
      call mtmplrmno(rm,s,xd,3,3,1)
      call vcpyr(xd,s,3)
      return
      end

      subroutine rotz(rm,angl)
      real rm(3,*),angl
      data pi2/6.28318/
      cosa=cos(pi2*angl)
      sina=sin(pi2*angl)
      rm(1,1)=cosa
      rm(1,2)=sina
      rm(1,3)=0
      rm(2,1)=-sina
      rm(2,2)=cosa
      rm(2,3)=0
      rm(3,1)=0
      rm(3,2)=0
      rm(3,3)=1
      return
      end

      subroutine ormtrx(h,x,on)  ! calculate orientation matrix
      real h(*),x(*),on(3,3)
      real n1(3),n2(3),n3(3),n3x

c*****unit vectors in the projection plane (n1,n2)*******
c     normalization of n3
c      call wtvctrrf('h=',h,3,'(3f10.5)')
c      call wtvctrrf('x=',x,3,'(3f10.5)')
      absh=vabs(h,3)
      do i=1,3
         n3(i)=-h(i)/absh
      end do
c     projection of y-axis onto the projection plane
      n3x=vinpr(n3,x,3)
c      write(6,*) 'n3x=',n3x
      do i=1,3
         n2(i)=x(i)-n3x*n3(i)
      end do
c     normalization of n2
      absn1=vabs(n2,3)
      do i=1,3
         n2(i)=n2(i)/absn1
      end do
c     calculation of n1
      n1(1)=n2(2)*n3(3)-n2(3)*n3(2)
      n1(2)=n2(3)*n3(1)-n2(1)*n3(3)
      n1(3)=n2(1)*n3(2)-n2(2)*n3(1)
c***   orthogonal matrix on
      on(1,1)=n1(1)
      on(1,2)=n1(2)
      on(1,3)=n1(3)
      on(2,1)=n2(1)
      on(2,2)=n2(2)
      on(2,3)=n2(3)
      on(3,1)=n3(1)
      on(3,2)=n3(2)
      on(3,3)=n3(3)
c*** test write ***
c      write(6,*) 'on=',on
c      call wtmtrxrf('orientation matrix',on,3,'(3f12.6)')
      return
      end
      
      subroutine yaxis(z,y)
      real z(*),y(*)
      real u(3),v(3),w(3)
      data u/1.,0.,0./, v/0.,1.,0./ w/0.,0.,1./
      data eps/0.0001/

      d1=vinpr(z,u,3)
      d2=vinpr(z,v,3)
      d3=vinpr(z,w,3)

      if(abs(min(d1,d2,d3)-d1).lt.eps) call vcpyr(u,y,3)
      if(abs(min(d1,d2,d3)-d2).lt.eps) call vcpyr(v,y,3)
      if(abs(min(d1,d2,d3)-d3).lt.eps) call vcpyr(w,y,3)
      return
      end

      subroutine rotaxs(or,ori,angl,rm)
      real or(3,*),ori(3,*),rm(3,*)
      real rd(3,3)
c     rm: rotation matrix around z axis
      call rotz(rm,angl)
      call mtmplr3(rm,or,rd)
      call mtmplr3(ori,rd,rm)
c     rm: rotation matrix around a given axis
      return
      end

      subroutine settng1(uixy,uit,sij)  ! transformation of Uij
c     setting dependent transformation for ui
      real uixy(*),uit(*)
      integer sij(3,*)
      integer sijt(3,3)
      real uijxy(3,3),m1(3,3),m2(3,3)
      call mcpyi(sij,sijt,3)
      call trnspi3(sijt)
      call getuitouij(uixy,uijxy)
      call mtmplri3(uijxy,sijt,m1)
      call mtmplir3(sij,m1,m2)
      call getuijtoui(m2,uit)
      return
      end

      subroutine settng(sx,sij,tj)   ! transformation of x
c     setting dependent transformation for x
      real sx(*),tj(*)
      integer sij(3,3)
      real sy(3)
c      call wtmtrxi('sij=',sij,3)
c      call wtvctrr('sx=',sx,3)
      call mtmplirmno(sij,sx,sy,3,3,1)
c      call wtvctrr('sy=',sy,3)
      call vsumr(sy,tj,sy,3)      
c      call wtvctrr('sy=',sy,3)
      call vcpyr(sy,sx,3)
      return
      end
