c
c       calculation of electron density of atoms
c
c     (1) ne,iand,inpd
c         ne: number of atomic-scattering-factor tables
c         iand: give 1 when the anomalous dispersion correction is
c               made, otherwise give 0.
c         inpd: give 0 when atomic scattering table is given
c               give 1 when coefficients of 4-exponential-function
c               approximation of the atomic scattering factors are
c               given
c     (2) atomic scatteirng factor table with interval of 0.05
c         (asct(i),i=1,35) (12f6.3) or the coefficients
c               of 4 gaussian approximation
c         (a(i),b(i),i=1,4),c  (9f8.5)
c         ***** repeat (7) ne*2 times *****
c         ***** odd tables : the first component ****
c         ***** even tables : the second component ****
c  **********        if(anad=0 skip (13)

      parameter (nemax=20)
      parameter (namax=20)
      common /asft/ ne,ascf(35,nemax),df1(nemax),df2(nemax),iand,
     *              iel(3,nemax)
      common /cpnf1/ atp(3),atp0(3),datpdp(3,3,namax)
      complex pi
      pi=(0.,3.1415926536)

      call setinp(5)
      call setout(6)
      sctmdl=0
      id=1
      call rdasf(sctmdl)
      call savasf(sctmdl,id)
      do i=1,ne
         do ir=0,100
            r=0.02*ir
            dr=0
            do j=0,100
               absqe=0.05*j
               ascfq=asf(absqe/2,i)
               dr=dr+0.05*real(ascfq*cexp(pi*2*absqe*r))
            end do
            write(6,'(a,f6.3,a,f6.3)') 'r=',r, ' dr=',dr
         end do
      end do
      stop
      end

      subroutine rdasf(sctmdl)
      integer sctmdl
      parameter (nemax=20)
      parameter (namax=20)
      common /asft/ ne,ascf(35,nemax),df1(nemax),df2(nemax),iand,
     *              iel(3,nemax)
      common /cpnf1/ atp(3),atp0(3),datpdp(3,3,namax)
      dimension a(4,nemax),b(4,nemax),c(nemax)
      character dummy*80
      do 10 i=1,nemax
      df1(i)=0.0
 10   df2(i)=0.0
      write(6,*) 'sctmdl=',sctmdl
c      read(5,101) ne,iand,ia,iel
      call freadi('ne=',1,ne,1)
      call freadi('iand=',1,iand,0)
      call freadi('inpd=',1,ia,0)
      do 11 i=1,ne
          call freadi('iel=',3,iel(1,i),0)
 11   continue
      call freadr('atp=',3,atp0,0)
      write(6,*) ' ne=',ne,' iand=',iand,' inpd=',ia,
     *    (' iel=',(iel(i,j),i=1,3),j=1,ne),' atp=',(atp0(i),i=1,3)
      call freadc('scattering factor',0,dummy,1)
      do 20 ik=1,ne
      if(ia.eq.0) read(5,100) (ascf(i,ik),i=1,35)
      if(ia.eq.1) read(5,102) (a(i,ik),b(i,ik),i=1,4),c(ik)
      if(iand.eq.1) read(5,102) df1(ik),df2(ik)
      if(sctmdl.eq.-1) then
          if(ia.eq.1) read(5,102) (a(i,ik+ne),b(i,ik+ne),
     *        i=1,4),c(ik+ne)
          if(ia.eq.0) read(5,100) (ascf(i,ik+ne),i=1,35)
          if(iand.eq.1) read(5,100) df1(ik+ne),df2(ik+ne)
      else if(sctmdl.eq.-2) then
          if(ia.eq.1) read(5,102) (a(i,ik+ne),b(i,ik+ne),
     *        i=1,4),c(ik+ne)
          if(ia.eq.0) read(5,100) (ascf(i,ik+ne),i=1,35)
          if(iand.eq.1) read(5,100) df1(ik+ne),df2(ik+ne)

          if(ia.eq.1) read(5,102) (a(i,ik+ne*2),b(i,ik+ne*2),
     *        i=1,4),c(ik+ne*2)
          if(ia.eq.0) read(5,100) (ascf(i,ik+ne*2),i=1,35)
          if(iand.eq.1) read(5,100) df1(ik+ne*2),df2(ik+ne*2)
      end if
 20   continue
      write(6,202)
      do 30 ik=1,ne
      if(ia.eq.1) then
          do 31 i=1,35
          sint=((i-1)*0.05)**2
          ascf(i,ik)=c(ik)
          if(sctmdl.eq.-1) then
                ascf(i,ik+ne)=c(ik+ne)
          else if(sctmdl.eq.-2) then
                ascf(i,ik+ne)=c(ik+ne)
                ascf(i,ik+ne*2)=c(ik+ne*2)
          end if
              do 32 j=1,4
              ascf(i,ik)=ascf(i,ik)+a(j,ik)*exp(-b(j,ik)*sint)
              if(sctmdl.eq.-1) then
                   ascf(i,ik+ne)=ascf(i,ik+ne)+a(j,ik+ne)*
     *             exp(-b(j,ik+ne)*sint)
              else if(sctmdl.eq.-2) then
                   ascf(i,ik+ne)=ascf(i,ik+ne)+a(j,ik+ne)*
     *             exp(-b(j,ik+ne)*sint)

                   ascf(i,ik+ne*2)=ascf(i,ik+ne*2)+a(j,ik+ne*2)*
     *             exp(-b(j,ik+ne*2)*sint)
              end if
 32           continue
 31       continue
      end if
      if(iand.ne.1) write(6,2001) ik
      if(iand.eq.1) write(6,2002) ik,df1(ik),df2(ik)
      if(ia.eq.1) write(6,203) (i,a(i,ik),i,b(i,ik),i=1,4),c(ik)
      write(6,201) (ascf(i,ik),i=1,35)
      if(sctmdl.eq.-1) then
          if(iand.ne.1) write(6,2041)
          if(iand.eq.1) write(6,2042) df1(ik+ne),df2(ik+ne)
          if(ia.eq.1) write(6,203) (i,a(i,ik+ne),i,b(i,ik+ne),i=1,4),
     *          c(ik+ne)
          write(6,201) (ascf(i,ik+ne),i=1,35)
      else if(sctmdl.eq.-2) then
          if(iand.ne.1) write(6,2041)
          if(iand.eq.1) write(6,2042) df1(ik+ne),df2(ik+ne)
          if(ia.eq.1) write(6,203) (i,a(i,ik+ne),i,b(i,ik+ne),i=1,4),
     *          c(ik+ne)
          write(6,201) (ascf(i,ik+ne),i=1,35)

          if(iand.ne.1) write(6,2043)
          if(iand.eq.1) write(6,2044) df1(ik+ne*2),df2(ik+ne*2)
          if(ia.eq.1) write(6,203)
     *          (i,a(i,ik+ne*2),i,b(i,ik+ne*2),i=1,4),c(ik+ne*2)
          write(6,201) (ascf(i,ik+ne*2),i=1,35)
      end if
 30   continue
      return
 100  format(12f6.3)
 101  format(3i3)
 102  format(9f8.5)
 2001 format(1h ,'table',i3)
 2002 format(1h ,'table',i2,8x,'real and imaginary parts of dispersion
     *         correction',2f10.5)
 201  format((1h ,12(f6.3,4x)))
 202  format(1h ,'atomic scattering factor table')
 203  format(1h ,'input data'/1h ,4('a',i1,'=',f10.6,1x,'b',i1,'=',
     *         f10.6,1x),'c=',f10.6)
 2041 format(1h ,'second species')
 2042 format(1h ,'second species real and imaginary parts of dispersion
     *          correction',2f10.5)
 2043 format(1h ,'third species')
 2044 format(1h ,'third species real and imaginary parts of dispersion
     *          correction',2f10.5)
      end

      subroutine freadi(prfx,n,var,nl)
      integer var(*)
      character*(*) prfx
      integer ip,ep
      parameter (bufsiz=512)
      character*512 buf
      common /cbuf/ buf,ip
      call getinp(inpu)
      call getout(iout)
      call getskp(iskp)
 100  continue
      if(nl.eq.1) then
           read(inpu,'(a)',end=200) buf
           ip=1
      end if
      if(prfx.eq.' ') then
         ipd=1
      else
         ipd=index(buf(ip:bufsiz),prfx)
      end if
c     ip beginning of the prfx
      ip=ipd+ip-1
      if(ipd.eq.0) then
           if(iskp.eq.0) then
               write(iout,'(2a)') prfx,' not found'
               call quit(' ')
           else
               go to 100
           end if
      end if
      ep=len(prfx)+ip-1
c     ep: end of the prefix
      if(n.eq.0) return
c       skip blanks between prefix and value or value and value
      if(prfx.ne.' ') then
          jp=ep+1
      else
          jp=ep
      end if
      do 150 i=1,n
          do 10 j=jp,bufsiz
              if(buf(j:j).ne.' ') go to 20
 10       continue
 20       continue
          jp=j
c         jp: beginning of i-th value
          ipd1=index(buf(jp:bufsiz),' ')
          ipd2=index(buf(jp:bufsiz),',')
          if(ipd1.gt.0.and.ipd2.gt.0) then
              jp=min(ipd1,ipd2)+jp
          else if(ipd1.gt.0) then
              jp=ipd1+jp
          else if(ipd2.gt.0) then
              jp=ipd2+jp
          else
              jp=bufsiz
          end if
c         jp: beginning of next prefix or value
 150  continue
      if(jp.eq.bufsiz) then
          write(iout,'(3a)') 'value of ',prfx,' not fund'
          call quit(' ')
      end if
      if(prfx.ne.' ') then
         read(buf(ep+1:jp-1),*) (var(i),i=1,n)
         ip=jp
      else
         read(buf(ep:jp-1),*) (var(i),i=1,n)
         ip=jp-1
      end if
      return
 200  continue
           write(iout,'(2a)') prfx,' not found'
           call quit(' ')
      return
      end

      subroutine freadr(prfx,n,var,nl)
      real var(*)
      character*(*) prfx
      integer ip,ep
      parameter (bufsiz=512)
      character*512 buf
      common /cbuf/ buf,ip
      call getinp(inpu)
      call getout(iout)
      call getskp(iskp)
 100  continue
      if(nl.eq.1) then
           read(inpu,'(a)',end=200) buf
           ip=1
      end if
      if(prfx.eq.' ') then
          ipd=1
      else
          ipd=index(buf(ip:bufsiz),prfx)
      end if
      ip=ipd+ip-1
      if(ipd.eq.0) then
           if(iskp.eq.0) then
               write(iout,'(2a)') prfx,' not found'
               call quit(' ')
           else
               go to 100
           end if
      end if
      ep=len(prfx)+ip-1
c     ep: end of the prefix
      if(n.eq.0) return
c       skip blanks between prefix and value or value and value
      if(prfx.ne.' ') then
          jp=ep+1
      else
          jp=ep
      end if
      do 150 i=1,n
          do 10 j=jp,bufsiz
              if(buf(j:j).ne.' ') go to 20
 10       continue
 20       continue
          jp=j
c         jp: beginning of i-th value
          ipd1=index(buf(jp:bufsiz),' ')
          ipd2=index(buf(jp:bufsiz),',')
          if(ipd1.gt.0.and.ipd2.gt.0) then
              jp=min(ipd1,ipd2)+jp
          else if(ipd1.gt.0) then
              jp=ipd1+jp
          else if(ipd2.gt.0) then
              jp=ipd2+jp
          else
              jp=bufsiz
          end if
c         jp: beginning of next prefix or value
 150  continue
      if(jp.eq.bufsiz) then
          write(iout,'(3a)') 'value of ',prfx,' not fund'
          call quit(' ')
      end if
      if(prfx.ne.' ') then
         read(buf(ep+1:jp-1),*) (var(i),i=1,n)
         ip=jp
      else
         read(buf(ep:jp-1),*) (var(i),i=1,n)
         ip=jp-1
      end if
      return
 200  continue
          write(iout,'(2a)') prfx,' not found'
          call quit(' ')
      return
      end

      subroutine freadc(prfx,n,var,nl)
      character*(*) var(*)
      character*(*) prfx
      integer ip,ep
      parameter (bufsiz=512)
      character*512 buf
      common /cbuf/ buf,ip
      call getinp(inpu)
      call getout(iout)
      call getskp(iskp)
 100  continue
      lval=len(var(1))
      if(nl.eq.1) then
c           read(inpu,'(a)') buf
           read(inpu,'(a)',end=200) buf
           ip=1
      end if
      if(prfx.eq.' ') then
          ipd=1
      else
          ipd=index(buf(ip:bufsiz),prfx)
      end if
      ip=ipd+ip-1
      if(ipd.eq.0) then
           if(iskp.eq.0) then
               write(iout,'(2a)') prfx,' not found'
               call quit(' ')
           else
               go to 100
           end if
      end if
      if(ipd.eq.0) then
           write(iout,'(2a)') prfx,' not found'
           call quit(' ')
      end if
      ep=len(prfx)+ip-1
c     ep: end of the prefix
      if(n.eq.0) return
c       skip blanks between prefix and value or value and value
      if(prfx.ne.' ') then
          jp=ep+1
      else
          jp=ep
      end if
c      jp=ep+1
      do 150 i=1,n
          do 10 j=jp,bufsiz
              if(buf(j:j).ne.' ') go to 20
 10       continue
 20       continue
          jp=j
c         jp: beginning of i-th value
          ipd1=index(buf(jp+1:bufsiz),'''')
          if(ipd1.gt.0) then
              jp=ipd1+jp+1
          else
              jp=bufsiz
          end if
c         jp: beginning of the next prefix or value
 150  continue
      if(jp.eq.bufsiz) then
          write(iout,'(3a)') 'value of ',prfx,' not fund'
          call quit(' ')
      end if
      read(buf(ep+1:jp-1),*) (var(i)(1:lval),i=1,n)
      ip=jp
      return
 200  continue
           write(iout,'(2a)') prfx,' not found'
           call quit(' ')
      return
      end

      function istrln(c)
      character*(*) c
      l=len(c)
      do 10 i=l,1,-1
      if(c(i:i).ne.' ') then
          istrln=i
          return
      end if
 10   continue
      istrln=0
      return
      end

      subroutine setinp(inpu)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      cinpu=inpu
      return
      end

      subroutine setout(iout)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      coutu=iout
      return
      end

      subroutine getinp(inpu)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      inpu=cinpu
      return
      end

      subroutine getout(iout)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      iout=coutu
      return
      end

      subroutine setskp(iskp)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      cskip=iskp
      return
      end

      subroutine getskp(iskp)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      iskp=cskip
      return
      end

      subroutine savasf(sctmdl,id)
      integer sctmdl,id
      parameter (nemax=20)
      parameter (namax=20)
      parameter (idsmax=1)
      common /asft/ ne,ascf(35,nemax),df1(nemax),df2(nemax),iand,
     *              iel(3,nemax)
      common /casftd/ ned(idsmax),ascfd(35,nemax,idsmax),
     *         df1d(nemax,idsmax),df2d(nemax,idsmax),iandd(idsmax),
     *         ield(3,nemax,idsmax)
      ned(id)=ne
      do 20 ik=1,ne
           do 30 i=1,35
           ascfd(i,ik,id)=ascf(i,ik)
 30        continue
           ield(1,ik,id)=iel(1,ik)
           ield(2,ik,id)=iel(2,ik)
           ield(3,ik,id)=iel(3,ik)
      if(iand.eq.1) then
           df1d(ik,id)=df1(ik)
           df2d(ik,id)=df2(ik)
      end if
      if(sctmdl.eq.-1) then
           do 31 i=1,35
           ascfd(i,ik+ne,id)=ascf(i,ik+ne)
 31        continue
           if(iand.eq.1) then
               df1d(ik+ne,id)=df1(ik+ne)
               df2d(ik+ne,id)=df2(ik+ne)
           end if
      else if(sctmdl.eq.-2) then
           do 32 i=1,35
           ascfd(i,ik+ne,id)=ascf(i,ik+ne)
 32        continue
           if(iand.eq.1) then
               df1d(ik+ne,id)=df1(ik+ne)
               df2d(ik+ne,id)=df2(ik+ne)
           end if
           do 33 i=1,35
           ascfd(i,ik+ne*2,id)=ascf(i,ik+ne*2)
 33        continue
           if(iand.eq.1) then
               df1d(ik+ne*2,id)=df1(ik+ne*2)
               df2d(ik+ne*2,id)=df2(ik+ne*2)
           end if
      end if
 20   continue
      iandd(id)=iand
      return
      end

      function asf(yb,jk)
      parameter (nemax=20)
      parameter (namax=20)
      common /asft/ ne,ascf(35,nemax),df1(nemax),df2(nemax),iand,
     *              iel(3,nemax)
      i=yb/0.05+1.0
      if(i.ge.29) i=(yb-1.4)/0.1+29.0
      if(i.ge.35) go to 20
      j=i+1
      if(i.ge.29) go to 21
      ai=float(i-1)*0.05
      asf=ascf(i,jk)+(ascf(j,jk)-ascf(i,jk))*(yb-ai)/0.05+df1(jk)
      return
 21   ai=float(i-29)*0.1+1.4
      asf=ascf(i,jk)+(ascf(j,jk)-ascf(i,jk))*(yb-ai)/0.1+df1(jk)
      return
 20   continue
      asf=0.0
      return
      end

      subroutine quit(str)
      character*(*) str
      write(6,*) str
      call exit(0)
c     stop
      end
