
c      written by onodera
      subroutine cft2(f,n,iopt,c,wk,ier)
c     complex fast fourier transfromation, radix 2.
c     slave subroutines used = cf22m, cf23m, sf00m
      implicit real*4 (a-h, o-z)
      integer alpha, beta, p, b2
      dimension f(0:n/2-1,0:3), c(0:n/2-1,0:3), wk(0:*)
      data no /0/
c
      if(n.lt.8) go to 2000
      if(n.eq.no) then
         if(wk(1).eq.sn.and.wk(n4-1).eq.cs) go to 20
      else
         fn=n
         p=alog(fn)*1.45
         if(n.ne.2**p) go to 2000
         no=n
         n4=n/4
         n2=n4+n4
         nu=n4+1
         nv=n2+1
         wx=1/fn
         wy=-wx
         z=0
         pi2=4*acos(z)
c
         step=pi2*wx
      end if
c     sin-cos table
      do 10 j=0,n4-1
 10   wk(j)=sin(j*step)
      wk(n4)=1
c     sin(2 pi j/n)=wk(j)
c     cos(2 pi j/n)=wk(n4-j)
      sn=wk(1)
      cs=wk(n4-1)
 20   continue
c     the first stage (l=0)
      if(iopt.eq.1) then
         do 31 j=0,n2-1
c     real parts
            c(j,0)=f(2*j,0)+f(2*j,2)
            c(j,1)=f(2*j,0)-f(2*j,2)
c     imaginary parts
            c(j,2)=f(2*j+1,0)+f(2*j+1,2)
            c(j,3)=f(2*j+1,0)-f(2*j+1,2)
 31      continue
      else
c     when iopt=2, complex conjugation
         do 32 j=0,n2-1
c     real parts
            c(j,0)=(f(2*j,0)+f(2*j,2))*wx
            c(j,1)=(f(2*j,0)-f(2*j,2))*wx
c     imaginary parts
            c(j,2)=(f(2*j+1,0)+f(2*j+1,2))*wy
            c(j,3)=(f(2*j+1,0)-f(2*j+1,2))*wy
 32      continue
      end if
      key=1
c     key=-1, when the data is stored in the array f
c     key=1,  when the data is stored in the array c
      alpha=2
      bata=n4
c     outermost loop begins
c     alpha*bate=n/2
 100  continue
c     ---beta>=alpha, earlier stages
      if(key.lt.0) then
         call cf22m(alphs,beta,f,c,wk,wk(nu),wk(nv))
      else
         call cf22m(alpha,beta,c,f,wk,wk(nu),wk(nv))
      end if
      key=-key
      alpha=alpha+alpha
      beta=beta/2
      if(beta.ge.alpha) go to 100
c     when alpha exceeds beta the data is transposed
      b2=beta+beta
      if(key.lt.0) then
         call sfoom(alpha,b2,f,c)
         call sfoom(alpha,b2,f(0,2),c(0,2))
      else
         call sfoom(alpha,b2,c,f)
         call sfoom(alpha,b2,c(0,2),f(0,2))
      end if
      key=-key
      if(beta.eq.1) go to 200
 120  continue
c     ---alpha > beta, later stages
      if(key.lt.0) then
         call cf23m(alpha,beta,f,c,wk,wk(n4),wk(n2))
      else
         call cf23m(alpha,beta,c,f,wk,wk(n4),wk(n2))
      end if
      key=-key
      alpha=alpha+alpha
      beta=beta/2
      if(beta.ge.2) go to 120
 200  continue
c     ---alpha=n/2, beta=1, final stage
      if(key.ge.0) then
         do 210 k=0,2*n-1
 210     f(k,0)=c(k,0)
      end if
      call cf24m(n2,f,c,wk)
      if(iopt.eq.2) then
         do 220 k=1,n
 220     c(2*k-1,0)=-c(2*k-1,0)
      end if
c     exit
      ier=0
      return
 2000    continue
      ier=2000
      return
      end

c     written by onodera
      subroutine sfoom(m,n,f,g)
c     matrix transposition
      implicit real*4 (a-h,o-z)
      dimension f(n,m),g(m,n)
c
      if(m.ge.n) then
         do 20 j=1,n
            do 10 i=1,m
               g(i,j)=f(j,i)
 10         continue
 20      continue
      else
         do 40 i=1,m
            do 30 j=1,n
               g(i,j)=f(j,i)
 30         continue
 40      continue
      end if
      return
      end

c     written by onodera
      subroutine cf22m(a,b,f,g,s,u,v)
c     slave subroutine used in the earlier (a a<=b) stages
c     of complex fft, radix 2. continuous access
c        a        2**l
c        b        n/( 2a )
c      f(0:n-1)   input data
c      g(0,n-1)   output data
c      s(0:n/4)   table of sin(2 pi j/n)
c
      implicit real*4 (A-Z)
      integer a,b,j,k,a2
      dimension f(0:2*b-1,0:a-1,2),
     *          g(0:b-1,0:a-1,0:3),
     *          s(0:b-1,0:*),
     *          u(0:*),
     *          v(0:*)
c     for k=0: cs=1, sn=0
      do 210 j=0,b-1
         g(j,0,0)=f(j,0,1)+f(j+b,0,1)
         g(j,0,1)=f(j,0,1)-f(j+b,0,1)
         g(j,0,2)=f(j,0,2)+f(j+b,0,2)
         g(j,0,3)=f(j,0,2)-f(j+b,0,2)
 210  continue
      if(a.eq.1) return
         a2=a/2
c     for k=a/2: cs=0, sn=1
         do 220 j=0,b-1
            g(j,a2,0)=f(j,a2,1)+f(j+b,a2,2)
            g(j,a2,1)=f(j,a2,1)-f(j+b,a2,2)
            g(j,a2,2)=f(j,a2,2)-f(j+b,a2,1)
            g(j,a2,3)=f(j,a2,2)+f(j+b,a2,1)
 220     continue
      if(a.eq.2) return
c
      do 240 k=1,a-1
         if(k.eq.a2) go to 240
         if(k.lt.a2) then
            cs=s(0,a2-k)
c     =cos(2 pi b k/n)=cos(pi k/a)
            sn=s(0,k)
c     =sin(2 pi b k/n)=sin(pi k/a)
         else
            cs=-s(0,k-a2)
            sn=s(0,a-k)
         end if
c
         do 230 j=0,b-1
            u(j)=sn*f(j+b,k,2)
            u(j)=u(j)+cs*f(j+b,k,1)
            v(j)=cs*f(j+b,k,2)
            v(j)=v(j)-sn*f(j+b,k,1)
            g(j,k,0)=f(j,k,1)+u(j)
            g(j,k,1)=f(j,k,1)-u(j)
            g(j,k,2)=f(j,k,2)+v(j)
            g(j,k,3)=f(j,k,2)-v(j)
 230     continue
 240  continue
      return
      end

c     written by onodera
      subroutine cf23m(a,b,f,g,s,cs,sn)
c     slave subroutine used in the later(a > b) stages
c     of complex fft. radix 2, continuous access
      implicit real*4 (a-z)
      integer a,b,j,k,a2
      dimension f(0:a-1,0:b-1,0:3),
     *          g(0:a-1,0:1,0:b-1,2),
     *          s(0:b-1,0:*),
     *          cs(0:a/2-1,0:1), sn(0:a/2-1,0:1)
      a2=a/2
      do 250 k=0,a2-1
         cs(k,0)=s(0,a2-k)
         sn(k,1)=cs(k,0)
         sn(k,0)=s(0,k)
         cs(k,1)=-sn(k,0)
 250  continue
c
      do 270 j=0,b-1
         do 260 k=0,a-1
            u=sn(k,0)*f(k,j,3)+cs(k,0)*f(k,j,1)
            v=cs(k,0)*f(k,j,3)-sn(k,0)*f(k,j,1)
            g(k,0,j,1)=f(k,j,0)+u
            g(k,1,j,1)=f(k,j,0)-u
            g(k,0,j,2)=f(k,j,2)+v
            g(k,1,j,2)=f(k,j,2)-v
 260     continue
 270  continue
      return
      end

c     written by onodera
      subroutine cf24m(n2,f,g,s)
c     slave subroutine used in the final (a=n/2, b=1) stage
c     of complex fft, radix 2, continuous access.
      implicit real*4 (a-z)
      integer k,n2,n4
      dimension f(0:n2-1,0:3),
     *          g(0:2*n2-1,0:1),
     *          s(0:*)
      n4=n2/2
c     =n/4
      do 280 k=0,n4-1
         u=s(n4-k)*f(k,1)*s(k)*f(k,3)
         v=s(n4-k)*f(k,3)-s(k)*f(k,1)
         g(2*k,0)=f(k,0)+u
         g(2*k,1)=f(k,0)-u
         g(2*k+1,0)=f(k,2)+v
         g(2*k+1,1)=f(k,2)-v
 280  continue
      do 290 k=n4,n2-1
         w=s(k-n4)*f(k,1)-sn(n2-k)*f(k,3)
         x=s(k-n4)*f(k,3)+sn(n2-k)*f(k,1)
         g(2*k,0)=f(k,0)-w
         g(2*k,1)=f(k,0)+w
         g(2*k+1,0)=f(k,2)-x
         g(2*k+1,1)=f(k,2)+x
 290  continue
      return
      end
