c      subroutine setf000(iset,f0) ! for using denmod.f
c      return
c      end

      subroutine denmodLdem(f000)
      include 'abcdri.inc'
c     xr0 : independent part of electron density
c     new phases are set to ar0 and ai0
      integer getnt
c     frc=getpfrac()            ! for lde this does not use for MemLde
      frc=0.                    ! dummy for MemLde
      iset=1
      nt=getnt()
      call getbrfromxr0()       ! get density br from independent part xr0
      call savexr0()            ! save xr0 for restore
      call denmod(br,frc,iset,izero) ! get modified density br by LDE
c     call wtvctrr('br=',br,10) ! for test
      call setxr0()             ! set new independent part xr0
      call calcbrbi(f000)       ! get normalized br,bi from xr0
      call setf0()              ! set calculated structure factor for observed reflections
      call setnewphs(avr)       ! set new phase by lde. avr : average phase diff.
      call phsnga()             ! new phase factor for ar0,ai0
      call restorexr0()
      write(6,'(a,f10.3)') 'avrphsd=',avr
      return
      end

      subroutine denmodMem(f000)
c     xr0 (electron density for independent grids) should be defined here
c     density modification by MEM
c     replace xr0 by modified one and 
c     calculate its structure factors (br0,bi0)
      include 'abcdri.inc'
      common /cdenmodMem/ ic,n1,n2,ex
c     call wtvctrr('xr0',xr0,ntx0)
c     write(6,*) 'ic,imode,n1,n2,ex=',ic,imode,n1,n2,ex
c     get difference density from observed and calculated F
c     call wtvctrr('xr0',xr0,ntx0)
      call difxyz(f000)
c     br : difference density
      call expand(ex,f000)      ! replace xr0 by modified xr0
c     call wtvctrr('xr1',xr0,ntx0)
      call getdmx()             ! calculate new dmin and dmax from xr0
c     get normalized structure factor br,bi from xr0
c     also normalize br so that number of electorns in a cell is f000
c     the following is for r-factor calculations and for next cycle
      call calcbrbi(f000)
      call setf0()              ! set calculated structure factor for observed reflections
      return
      end

c     function avrphsd()        ! average phase difference in degree
      subroutine setnewphs(avrphsd) ! average phase difference in degree
      include 'nhmax.inc'
      include 'hklf.inc'       ! independent reflections
      include 'abcdri.inc'
      integer gethkltoj,caliph,redphs,phs1,phs2
      sum=0
      do i=1,is
         j=gethkltoj(hkln(1,i))
         call calphsr(br(j),bi(j),phr,phi)
         phs1=caliph(phsr(i),phsi(i))
         phs1=redphs(phs1)
         phs2=caliph(phr,phi)
         sum=sum+abs(phs1-phs2)
         phsr(i)=phr   ! set new phase
         phsi(i)=phi   ! set new phase
c     this does not change ar,ai
c        write(6,*) 'phs1,phs2=',phs1,phs2
      end do
      if(is.eq.0) call quit('number of reflections is zero')
      avrphsd=sum/is
      return
      end

      integer function redphs(phs)
      integer phs
      phs=mod(phs,360)
      if(phs.le.-180) then
         phs=phs+360
      else if(phs.gt.180) then
         phs=phs-360            
      end if
      redphs=phs
      return
      end

c     Fourier synthesis of electron density in nD
      subroutine mapxyz()
c     this assumes that structure factor br and bi are set in advance
c     and replace br with electron density
      include 'abcdri.inc'
      integer hmax(6)
      integer getnt
      call getidm(idm)
      call gethmax(hmax)
c     write(6,*) 'hmax in mapxyz=',hmax
c     call wtvctrr('br=',br,20)  ! for test
c     call wtvctrr('bi=',bi,20)  ! for test
      call cft1(br,bi,hmax,idm,1,icon) ! Fourier synthesis
c     call wtvctrr('br=',br,20)  ! for test
c     call wtvctrr('bi=',bi,20)  ! for test
      vol=getvol()
      nt=getnt()
c      write(6,*) 'nt in mapxyz=',nt
c      write(6,*) 'vol in mapxyz=',vol
      scl=1.0/vol
      call vscaler(br,scl,br,nt) ! get electron density br
      return
      end

      subroutine maphkl()
c     get structure factor (br,bi) from independent electron density
c     this is necessary for mem
c     real br(0:*),bi(0:*)
      include 'abcdri.inc'
      integer hmax(6)
      integer getnt
      nt=getnt()
      vol=getvol()
      call geticent(icent)
      call getidm(idm)
c      write(6,*) 'nt,idm,vol in maphkl=',nt,idm,vol
      call gethmax(hmax)
      call getbrfromxr0()         ! get br from independent part xr0
c     write(6,*) 'br before cft1=',(br(j),j=0,9)
      call cft1(br,bi,hmax,idm,-1,icon)
c      write(6,*) 'idm,icon=',idm,icon
c      write(6,*) 'hmax=',(hmax(j),j=1,idm)
c      write(6,*) 'br after cft1=',(br(j),j=0,9)
c      write(6,*) 'bi=',(bi(j),j=0,9)
c     call quit('stop in maphkl')

      dv=vol/nt                 ! dv
      if(icent.eq.0) then
         call vscaler(br,dv,br,nt)
         call vscaler(bi,dv,bi,nt)
      else
         call vscaler(br,dv,br,nt)
         call zerovr(bi,nt)
      end if
c     br,bi : real and imaginary parts of the structure factor
      return
      end

      subroutine calcbrbi(f000)
c     calculate new structure factor br and bi from independent electron
c     density
      include 'abcdri.inc'
c     set br before calling maphkl
      call maphkl()             ! new calculated br,bi for all from xr0
      call getiplt(iplot)
      if(abs(iplot).eq.6) then
         return
      end if

      fac=f000/br(0)
      write(6,*) 'normalization factor=',fac
      call normalb(fac)   ! normalize br,bi so as to br(0)=f000
      call normala(fac)   ! normalize xr0 so as to br(0)=f000
      return
      end

      subroutine normalb(fac)   ! normalize br,bi so as to br(0)=f000
      include 'abcdri.inc'
      integer getnt
      nt=getnt()
      do i=0,nt-1
         br(i)=br(i)*fac
         bi(i)=bi(i)*fac
      end do
      return
      end

      subroutine normala(fac)   !  normalize xr0 so as to br(0)=f000
      include 'abcdri.inc'
      integer getnt
      real*8 sum
      sum=0
      do i=0,ntx0-1
         xr0(i)=xr0(i)*fac
         sum=sum+xr0(i)
      end do
c     write(6,*) 'sum=',sum  ! this value can change
c     because this is an independent part (multiplicity
c     does not taken into account
      return
      end

      subroutine expand(ex,f000)
      include 'abcdri.inc'
c     call expand1(ex,f000)  ! from qcmem.f
      call expand2(ex,f000)  ! from mem.f
      return
      end

      subroutine expand1(ex,f000)  ! from qcmem.f
c     get electron density at independent grid points in a unit cell
c     br is supposed to be difference density
      include 'abcdri.inc'
      integer getnt,getimode
      imode=getimode()
c     write(6,*) 'enter expand'
      dmax=getdmax()            ! maximum electron density
      nt=getnt()
      vol=getvol()              ! unit cell volume
      f000=getf0()              ! structure factor at the origin
c     eps,tmp,dr should be nondimension number so that
c     density (xr0 and br) should be multiplied by vol
      eps=f000/1000
      do i=0,nt0-1              ! independent grid points
         j=ix0(i)
         tmp=xr0(i)*vol         ! old electron density times volume
         dr=br(j)*vol           ! difference electron density times volume
         if(imode.eq.1) then
            ddd=sqrt(tmp)+eps
         else if(imode.eq.2) then
            ddd=sqrt(dmax*vol)
         else
            write(6,*) 'imode=',imode
            call quit('invalid imode in expand1')
         end if
         xr0(i)=xr0(i)*exp(ex*dr/ddd) ! new density
      end do
c      if(abs(dmin-dmax)*vol.lt.eps) then
c        write(6,*) 'f000=',f000,' dmin,dmax,nt',dmin,dmax,nt
c        call quit('|dmin-dmax| < eps ')
c      end if
      return
      end

      subroutine expand2(ex,f000) ! from mem.f
c     get electron density at independent grid points in a unit cell
c     br is supposed to be difference density
      include 'abcdri.inc'
      integer getimode,getnt
      imode=getimode()
      dmin=getdmin()
      dmax=getdmax()
      nt=getnt()
      vol=getvol()
c     write(6,*) 'vol=',vol
c     call quit('stop in expand2')

      f000=getf0()
c      write(6,*) 'ntx0,vol,imode,f000=',ntx0,vol,imode,f000
c     call quit('stop in expand2')

      eps=f000/1000
c     call wtvctrr('xr0',xr0,ntx0)
      do i=0,ntx0-1
         j=ix0(i)               ! 1D index for independent grid points
         tmp=xr0(i)*vol         ! old electron density times volume
         dr=br(j)*vol           ! difference electron density times volume
         if(imode.eq.1) then
            ddd=sqrt(tmp+eps)   ! different from expand1
         else if(imode.eq.2) then
            ddd=sqrt(dmax*vol)
         else
            write(6,*) 'imode=',imode
            call quit('invalid imode in expand2')
         end if
         xr0(i)=xr0(i)*exp(ex*dr/ddd) ! new density
      end do
c     call wtvctrr('xr0',xr0,ntx0)
c      if(abs(dmin-dmax)*vol.lt.eps) then
c         write(6,*) 'dmin,dmax,nt',dmin,dmax,nt
c         write(6,*) 'f000=',f000,' dmin,dmax,nt',dmin,dmax,nt
c         call quit('|dmin-dmax| < eps ')
c      end if
      return
      end

      subroutine setdf()        ! set equivalent br,bi from observed parts
c     set difference of structure factors for difference Fourier
c     for observed (both independent and equivalent) reflections
      include 'abcdri.inc'
      integer getnt,getnind,gethkltoj
      integer h(6),hr(6)
      complex fctmp,a,b,ao,bo
      pi2=2*getpi()
c     initialize br,bi
      nt=getnt()
      call zerovr(br,nt)        ! zero vector
      call zerovr(bi,nt)        ! zero vector

      call getnsymo(nsymo)
      call geticent(icent)
c     calculate equivalent structure factor from observed ones
      nind=getnind()            ! number of observed reflections
      do i=1,nind
         j=hklo1d(i)            ! 1D index for observed reflections
         ao=cmplx(ar0(i),ai0(i)) ! observed structure factor
         bo=cmplx(br0(i),bi0(i)) ! calculated structure factor
         call getitohkl(j,h)    ! hkl : hkl indices
         do ns=1,nsymo          ! symmetry operation loop
            do ic=0,icent       ! inverstion operation loop
               call gethr(h,hr,ns,ic) ! hr : equivalent indices
               k=gethkltoj(hr)  ! 1D index for hr
               yt=getyt(h,ns,ic) ! inner produnt between h and nonp. translation
               fctmp=cexp(pi2*yt*(0.,-1.)) ! extra phase factor due to yt
               a=ao*fctmp
               b=bo*fctmp
               br(k)=real(a-b)/(sgm0(i))  ! structure factor for hr reflection
               bi(k)=aimag(a-b)/(sgm0(i)) ! structure factor for hr reflection
c     write(6,*) 'br,bi in setdf=',br(k),bi(k)
            end do
         end do
      end do
      return
      end

      subroutine setxr0()       ! set independent parts of electron density br
      include 'abcdri.inc'
      integer x(6)
c     write(6,*) 'ntx0=',ntx0
      do i=0,ntx0-1
         j=ix0(i)               ! 1D index for independent grid points
         call getitoxyz(j,x)    ! nD coordinates for j
c        write(6,*) 'j=',j
         xr0(i)=br(j)           ! structure factor for independent reflection
c        call testbreak(xr0(i),j,br)  ! for trace back
      end do
      return
      end

      subroutine testbreak(xr0,j,x,br)
      integer x(*),br(0:*)
      logical isMem
      if(isMem().and.xr0.le.0) then ! for test
         write(6,*) 'j,br(j),x',j,br(j),(x(k),k=1,6)
         istop=-1               ! for test break
         br(istop)=0            ! for test break
         call quit('xr0 <= 0 so mem does not work')
      end if
      return
      end

      subroutine savexr0()
      include 'abcdri.inc'
      call vcpyr(xr0,xrs0,ntx0)
      return
      end

      subroutine restorexr0()
      include 'abcdri.inc'
      call vcpyr(xrs0,xr0,ntx0)
      return
      end

      subroutine setf0()        ! set observed parts of br,bi for diff. Fourier
      include 'abcdri.inc'
      integer getnind,gethkltoj
      integer hkl(6)
      nind=getnind()            ! number of independent reflections
c     write(6,*) 'nind=',nind
      do i=1,nind
         j=hklo1d(i)            ! 1D index for observed reflections
c        write(6,*) 'j=',j
         br0(i)=br(j)           ! structure factor for independent reflection
         bi0(i)=bi(j)           ! structure factor for independent reflection
      end do
      n=min(nind,10)
c      call wtvctri('ind',hklo1d,n)
c      call wtvctrr('ar0',ar0,n)
c      call wtvctrr('ai0',ai0,n)
c      call wtvctrr('br0',br0,n)
c      call wtvctrr('bi0',bi0,n)
      return
      end

      subroutine getbrfromxr0()  ! set hole density br,bi from independent part
      include 'abcdri.inc'
      integer getxyztoj,getnt
      integer xyz(6),xyzr(6)
      logical isMem
      call getnsymo(nsymo)
      call geticent(icent)
      nt=getnt()
      call zerovr(br,nt)        ! imaginary part
      call zerovr(bi,nt)        ! imaginary part is zero
      n=0
      do i=0,ntx0-1
         j=ix0(i)               ! index for independent grid points
         x0=xr0(i)
         call getitoxyz(j,xyz)  ! xyz : grid points 
         if(isMem().and.x0.lt.0) then
            write(6,*) 'x0=',x0
            write(6,*) 'xyz=',(xyz(k),k=1,6)
            call quit('electron density is negative')
         end if
         do ns=1,nsymo
            do ic=0,icent
               call getrxi(xyz,xyzr,ns,ic) ! symmetry operation for grid points
               k=getxyztoj(xyzr)
               br(k)=x0
c              call testwt(n,k,x0)
            end do
         end do
      end do
c      write(6,*) 'br in getbrfromxr0=',(br(j),j=1,9)
c      call quit('stop in getbrfromxr0')
      return
      end

      subroutine testwt(n,k,x0)
      if(n.le.100) then
         n=n+1
         write(6,*) 'k,x0=',k,x0
      end if
      return
      end

      subroutine reduci(x)      ! reduce grid points in the unit cell
      integer x(*) 
      integer hmax(6)
      common /chmax/ hmax
      common /cdim/ idm,nde,ied
      do i=1,idm
         x(i)=mod(x(i),hmax(i))
         if(x(i).lt.0) then
            x(i)=x(i)+hmax(i)
         end if
      end do
      return
      end

************************************************************************
      subroutine difxyz(f000)
      include 'abcdri.inc'
c     difference Fourier synthesis
      integer hmax(6)
      integer getnt
      data eps/1.e-6/
      call getidm(idm)
      call gethmax(hmax)
      call setdf()              ! set equivalent br,bi from observed parts
      call cft1(br,bi,hmax,idm,1,icon)
      nt=getnt()
      vol=getvol()
      scl=1.0/vol
      call vscaler(br,scl,br,nt) ! get difference electron density br
      return
      end


      function getdmin()  ! return current dmin
      common /cdmx/ dmin,dmax
      getdmin=dmin
      return
      end

      function getdmax()  ! return current dmax
      common /cdmx/ dmin,dmax
      getdmax=dmax
      return
      end

      subroutine getdmx()
      common /cdmx/ dmin,dmax
      include 'abcdri.inc'
      dmin=xr0(0)
      dmax=xr0(0)
      do i=0,ntx0-1
         tmp=xr0(i)
         dmin=min(tmp,dmin)
         dmax=max(tmp,dmax)
      end do
c     write(6,*) 'dmin,dmax=',dmin,dmax
c     call quit('stop in getdmx')
      return
      end
