      subroutine drwxline(xy,nx,nz)
      real xy(0:nx,0:nz)        ! function value at (ix,iz)
      real x(3)
      real x1(3),x2(3),x3(3),x4(3),r(3)
      common /cdrwxz/x1,x2,x3,x4,r
      common /cuminmax/ umin,umax
      real uvw(3,3)
      common /cmtrx/uvw
      common /cdrwline/ ru,rv,fx,fy,xd,yd
      real dx(3)
      common /cdxdz/ dx,ul,ur
      parameter (ndmax=2000)
      parameter (ndmax1=ndmax+1)
      common /cynmx/ynmax(0:ndmax),ynmin(0:ndmax),istat(0:ndmax)
      real xw(ndmax+2),yw(ndmax+2)
      common /cxwyw/ xw,yw
      real dxuvw(3)
      shftz = getshftz()
      call initdrwline(nx,nz)
      ii=1
      jj=3
      uw=getuw(uvw(1,ii))
      dxuvw(ii)=uvw(1,ii)*dx(ii)
      dxuvw(jj)=uvw(1,jj)*dx(jj)
      rzx=dxuvw(jj)/dxuvw(ii)
      call prj(x1,u,v)
      ua=u-ru
      ixda=int((ua-uw)/dxuvw(ii)+0.5)        ! number of points in a line
      ixdmx=abs(int((ur-ul)/dxuvw(ii)+0.5))  ! number of total divisions along u

      if(ixdmx.gt.ndmax) then
         call quit('ixdmx > ndmax')
      end if
c     initialize minimum and maximum function value at ixd
      call initistat()

      call geti123(i1,i2,i3,uvw(3,jj),nz)
      do i=i1,i2,i3            ! change z value from front to back
         x(jj)=x1(jj)+i*dx(jj)-r(jj)
         ioffs=int(ixda+i*rzx+0.5)
         n=0
         do j=0,nx        ! scan j from minimum to maximum
            x(ii)=x1(ii)+j*dx(ii)-r(ii)       ! x value from the center of the box
            x(2)=xy(j,i)
            x(2)=(x(2)+shftz)/100-r(2) ! y value 
            call drwfragment(n,x,j,ioffs,ixdmx)
         end do
         call drwln(xw,yw,n)
      end do
      return
      end

      subroutine drwzline(xy,nx,nz)
      real xy(0:nx,0:nz)       ! function value at (ix,iz)
      real x(3)
      real x1(3),x2(3),x3(3),x4(3),r(3)
      common /cdrwxz/x1,x2,x3,x4,r
      common /cuminmax/ umin,umax
      real uvw(3,3)
      common /cmtrx/uvw
      common /cdrwline/ ru,rv,fx,fy,xd,yd
      real dx(3)
      common /cdxdz/ dx,ul,ur
      parameter (ndmax=2000)
      parameter (ndmax1=ndmax+1)
      common /cynmx/ynmax(0:ndmax),ynmin(0:ndmax),istat(0:ndmax)
      real xw(ndmax+2),yw(ndmax+2)
      common /cxwyw/ xw,yw
      real dxuvw(3)
      shftz = getshftz()
      call initdrwline(nx,nz)
      ii=3
      jj=1
      uw=getuw(uvw(1,ii))
      dxuvw(ii)=uvw(1,ii)*dx(ii)
      dxuvw(jj)=uvw(1,jj)*dx(jj)
      rxz=dxuvw(jj)/dxuvw(ii)
      call prj(x1,u,v)
      ua=u-ru
      izda=int((ua-uw)/dxuvw(ii)+0.5)
      izdmz=abs(int((ur-ul)/dxuvw(ii)+0.5))  ! number of divisions along u

      if(izdmz.gt.ndmax) then
         call quit('izdmz > ndmax')
      end if

c     initialize minimum and maximum function value at ixd
      call initistat()
      call geti123(i1,i2,i3,uvw(3,jj),nx)
      do i=i1,i2,i3
         x(jj)=x1(jj)+i*dx(jj)-r(jj)
         ioffs=int(izda+i*rxz+0.5)
         n=0
         do j=0,nz
            x(ii)=x1(ii)+j*dx(ii)-r(ii)
            x(2)=xy(i,j)
            x(2)=(x(2)+shftz)/100-r(2)
            call drwfragment(n,x,j,ioffs,izdmz)
         end do
         call drwln(xw,yw,n)  ! drw last fragment
      end do
      return
      end
