c     University of Canterbury, Fourier Synthesis Program
c     this is a rewritten version of fordap (a.zalkin) and retains
c     the basic structure of that program.
c     current dimensions.   88  points/line,   101 lines/section
*     hkl, f(o), f(c), etc. are read in from file #12 (indata=12)
*     results of fourier synthesis are stored in file #13 (ivxx=13)
*     scratch file #10 (recfm=vb,lrecl=100,blksize=3624) is made during
*     excution of this program (ixx=10)
      program tofour
*sun
      character*50 file5
      common/const/iii,in,indata,ivxx,ixx,lpsect,nblock,nequiv,nmemmx,
     anpline,nx,ny,nz,norien,xmin,ymin,zmin,xmax,ymax,zmax,dx,dy,dz,
     baa(3,3),bb(3,3),dcell(9),detu,fs(3,3,24),isst(8),jmax,kmax,kmin,
     cncd,nef,rcell(9),rmax,scale,title(20),ts(3,24),u(3,3),uinv(3,3),
     dvol
      common/rdrt/ncode,iend
      common noint,npunch
*     data iend/0/
      iend=0
c-vax-
c-vax-equivalence logical unit numbers to general i/o files
c-vax-files pertinent to a specific run are opened in setup, rip,
c-vax-and frpeak
c-vax-
*     open (unit=5,readonly,status='old',disp='keep')
*except sun
*     open (unit=5)
*sun
      call getarg(1,file5)
*sun
      open(unit=5,file=file5)
*vax
*     open (unit=6,status='new',disp='print/delete')
*except sun
*     open (unit=6)
*     open (unit=10,status='scratch',disp='delete',recl=100,
*    1 blocksize=3624,recordtype='variable',form='unformatted',
*    2 buffercount=1,access='sequential')
      open (unit=10,status='scratch',access='sequential',
     &  form='unformatted')
c-vax-
      ncode=0
c     read control parameters,cell constants and symmetry cards
c     calculate cosine table
      call setup
      if(isst(2))20,20,10
c     calculate u matrix for fourier parallel to a general plane
   10 call trans
   20 if(isst(1))40,40,30
   30 continue
c     set fourier limits and write data file containing expanded data
      call rip
      if(iend.ne.0) go to 100
c     calculate fourier, section by section
      call sig100
   40 noint=0
      npunch=-1
      if(isst(4).eq.1) go to 60
      if(isst(5))70,70,60
   60  continue
c     peak search and/or alphameric printout
      call frpeak
   70 if(noint)80,80,90
   80 if(isst(3))100,100,90
   90  continue
c     peak interpolation and/or numeric printout
      call ipeak
  100  continue
c-vax-
c-vax-close all files pertinent to a specific run
c-vax-
*     close (unit=5,disp='keep')
*     close (unit=6,disp='print/delete')
*     close (unit=6)
*     close (unit=10,disp='delete')
      close (unit=10,status='delete')
*     if(isst(6).ne.0.or.ncode.ne.0) close (unit=12,disp='keep')
      if(isst(6).ne.0.or.ncode.ne.0) close (unit=12,status='keep')
      if(iend.ne.0) go to 115
      if(isst(1).eq.0.or.isst(4).eq.2) go to 105
*     close (unit=13,disp='delete')
*     temporary
*     close (unit=13,status='delete')
      go to 110
  105 continue
*     close (unit=13,disp='keep')
*     temporary
*     close (unit=13,status='keep')
  110 continue
*     if(npunch.lt.0) close (unit=2,disp='keep')
      if(npunch.lt.0) close (unit=2,status='keep')
      go to 130
  115 continue
      if(isst(1).eq.0) go to 120
*     close (unit=13,disp='delete')
*     temporary
*     close (unit=13,status='delete')
      go to 125
  120 continue
*     close (unit=13,disp='keep')
*     temporary
*     close (unit=13,status='keep')
  125 continue
*     if(npunch.lt.0) close (unit=2,disp='delete')
      if(npunch.lt.0) close (unit=2,status='delete')
  130 continue
c-vax-
*     plot a fourier map
      if (isst(4) .eq. 2) then
         step=0.0
         read(5,*) step,fmag,x0,y0 
         call plfmap(ivxx,dcell,zmin,zmax,dz,step,fmag,x0,y0)
      end if
      close (unit=5,status='keep')
      end
      subroutine cardin(jj,kk,ll,aaa,bbb)
c   subroutine to read data from cards
      data in/5/
      read (in,1090) rjj,rkk,rll,aaa,bbb
 1090 format(1x,f3.0,2f4.0,2f9.0)
      jj=rjj+.5
      kk=rkk+.5
      ll=rll+.5
      return
      end
      subroutine chekup(xmin,xmax,norien,n,dx)
   10 diffx=xmax-xmin
      if(diffx)20,70,30
   20 xmin=xmax
      xmax=xmin-diffx
      go to 10
   30 if(diffx-1.)80,80,40
   40 xmax=.5
      xmin=-.5
      go to 10
   50 if(diffx.gt..5*dx) go to 60
   55 xmax=xmin
      go to 70
   60 if(dx)55,55,65
   65 dx=diffx/aint(diffx/dx+.5)
      go to 100
   70 norien=n
      dx=.000001
      go to 100
   80 if(xmax-1.)50,50,90
   90 xmin=-.5
      xmax=xmin+diffx
      go to 10
  100 return
      end
      subroutine cross(a,x,y,z)
      real a(3,3),b(3,3),x(3),y(3),z(6),zz(3)
      zz(1)=x(2)*y(3)-x(3)*y(2)
      zz(2)=x(3)*y(1)-x(1)*y(3)
      zz(3)=x(1)*y(2)-x(2)*y(1)
      do 5 i=1,3
    5 z(i)=a(i,1)*zz(1)+a(i,2)*zz(2)+a(i,3)*zz(3)
      return
      entry mi3(a,b,d)
      b(1,1)=  a(2,2)*a(3,3)-a(2,3)*a(3,2)
      b(1,2)=-(a(1,2)*a(3,3)-a(1,3)*a(3,2))
      b(1,3)=  a(1,2)*a(2,3)-a(1,3)*a(2,2)
      b(2,1)=-(a(2,1)*a(3,3)-a(2,3)*a(3,1))
      b(2,2)=  a(1,1)*a(3,3)-a(1,3)*a(3,1)
      b(2,3)=-(a(1,1)*a(2,3)-a(1,3)*a(2,1))
      b(3,1)=  a(2,1)*a(3,2)-a(2,2)*a(3,1)
      b(3,2)=-(a(1,1)*a(3,2)-a(1,2)*a(3,1))
      b(3,3)=  a(1,1)*a(2,2)-a(1,2)*a(2,1)
      d=a(1,1)*b(1,1)+a(2,1)*b(1,2)+a(3,1)*b(1,3)
      if(d)10,15,10
*     i should be less or equal to 3
*  10 do 12 i=1,9
*  12 b(i,1)=b(i,1)/d
   10 do 12 i=1,3
      do 12 j=1,3
   12 b(i,j)=b(i,j)/d
   15 return
      entry mvpv(a,x,y,z)
      do 20 i=1,3
   20 z(i)=a(i,1)*x(1)+a(i,2)*x(2)+a(i,3)*x(3)+y(i)
      return
      entry norm(a,x)
      alpha=sqrt(1./vmv(x,a,x))
      x(1)=alpha*x(1)
      x(2)=alpha*x(2)
      x(3)=alpha*x(3)
      return
      entry rotate(d,e)
      alpha=d
      d=e
      e=alpha
      return
      entry stoaa(z,a)
      a(1,1)=z(1)*z(1)
      a(1,2)=z(1)*z(2)*z(6)
      a(1,3)=z(1)*z(3)*z(5)
      a(2,1)=a(1,2)
      a(2,2)=z(2)*z(2)
      a(2,3)=z(2)*z(3)*z(4)
      a(3,1)=a(1,3)
      a(3,2)=a(2,3)
      a(3,3)=z(3)*z(3)
      return
      entry vm(x,a,y)
      do 30 i=1,3
   30 zz(i)=x(1)*a(1,i)+x(2)*a(2,i)+x(3)*a(3,i)
      y(1)=zz(1)
      y(2)=zz(2)
      y(3)=zz(3)
      return
      end

      subroutine edint(psv,ii)
c     electron density interpolation    -     rollett page 35
      common/const/iii,in,indata,ivxx,ixx,lpsect,nblock,nequiv,nmemmx,
      anpline,nx,ny,nz,norien,xmin,ymin,zmin,xmax,ymax,zmax,dx,dy,dz,
      baa(3,3),bb(3,3),dcell(9),detu,fs(3,3,24),isst(8),jmax,kmax,kmin,
      cncd,nef,rcell(9),rmax,scale,title(20),ts(3,24),u(3,3),uinv(3,3),
      dvol
      real*8 label,a,c,d,xp,yp,zp,alogp,dj
      integer*2 nnx,nny,nnz,ibor,ibornx,iborny,ibornz
      common noint,npunch,nsearc,ntran,icent,indexh,indexv,indexs,iswap
      a,iswap2,const,fill,label(250),xx(250),yy(250),zz(250),height(250),
      bibor(250),nnx(250),nny(250),nnz(250),xxint(3),yyy(101),label1(101)
      c,label2(101),ibornx(19,80),iborny(19,80),ibornz(19,80),rsave(27,
      d250),a(55),c(10),d(10),p(19)
     *     real psv(3,3,3),xm(19)/0.,-1.,0.,1.,0.,-1.,0.,1.,-1.,0.,1.,-1.,0.,
     *    a1.,0.,-1.,0.,1.,0./,    ym(19)/1.,0.,0.,0.,-1.,1.,1.,1.,0.,0.,0.,
     *    b-1.,-1.,-1.,1.,0.,0.,0.,-1./,       zm(19)/-1.,-1.,-1.,-1.,-1.,0.,
     *    c0.,0.,0.,0.,0.,0.,0.,0.,1.,1.,1.,1.,1./
      real psv(3,3,3),xm(19),ym(19),zm(19)
      data xm/0.,-1.,0.,1.,0.,-1.,0.,1.,-1.,0.,1.,-1.,0.,
      a1.,0.,-1.,0.,1.,0./,    ym/1.,0.,0.,0.,-1.,1.,1.,1.,0.,0.,0.,
      b-1.,-1.,-1.,1.,0.,0.,0.,-1./,       zm/-1.,-1.,-1.,-1.,-1.,0.,
      c0.,0.,0.,0.,0.,0.,0.,0.,1.,1.,1.,1.,1./
      x=xx(ii)
      y=yy(ii)
      z=zz(ii)
      p( 1)=psv(2,3,1)
      p( 2)=psv(1,2,1)
      p( 3)=psv(2,2,1)
      p( 4)=psv(3,2,1)
      p( 5)=psv(2,1,1)
      p( 6)=psv(1,3,2)
      p( 7)=psv(2,3,2)
      p( 8)=psv(3,3,2)
      p( 9)=psv(1,2,2)
      p(10)=psv(2,2,2)
      p(11)=psv(3,2,2)
      p(12)=psv(1,1,2)
      p(13)=psv(2,1,2)
      p(14)=psv(3,1,2)
      p(15)=psv(2,3,3)
      p(16)=psv(1,2,3)
      p(17)=psv(2,2,3)
      p(18)=psv(3,2,3)
      p(19)=psv(2,1,3)
      if(p(10))10,20,20
   10 do 15 i=1,19
   15 p(i)=-p(i)
   20 do 22 i=1,19
      if(p(i).gt.p(10)) go to 160
   22 continue
      ibor(ii)=1
      psml=p(1)
      do 25 i=1,19
   25 if(p(i).lt.psml) psml=p(i)
      if(psml)30,30,50
   30 psm=1.-2.*psml
      do 35 i=1,19
   35 p(i)=p(i)+psm
   50 do 60 i=1,10
   60 c(i)=0.d0
      do 70 i=1,55
   70 a(i)=0.d0
      do 80 i=1,19
      xxint(1)=xm(i)*dx+x
      xxint(2)=ym(i)*dy+y
      xxint(3)=zm(i)*dz+z
      if(isst(2))76,73,76
   73 call rotate(xxint(iswap1),xxint(iswap2))
      call vm(xxint,u,xxint)
      call rotate(xxint(iswap1),xxint(iswap2))
   76 xp=xxint(1)
      yp=xxint(2)
      zp=xxint(3)
      d( 1)=1.d0
      d( 2)=xp
      d( 3)=yp
      d( 4)=zp
      d( 5)=xp*xp
      d( 6)=yp*yp
      d( 7)=zp*zp
      d( 8)=yp*zp
      d( 9)=zp*xp
      d(10)=xp*yp
      alogp=alog(p(i))
      l=1
      do 80 j=1,10
      dj=d(j)
      c(j)=c(j)+dj*alogp
      do 80 k=j,10
      a(l)=a(l)+dj*d(k)
   80 l=l+1
      call solve(a,c,10,nfail)
      if(nfail)150,90,150
   90 d(4)=-2.d0*c(5)
      d(5)=-c(10)
      d(6)=-c(9)
      d(7)=-2.d0*c(6)
      d(8)=-c(8)
      d(9)=-2.d0*c(7)
      d(1)=c(2)
      d(2)=c(3)
      d(3)=c(4)
      call solve(d(4),d,3,nfail)
      if(nfail)150,100,150
  100 xxint(1)=d(1)
      xxint(2)=d(2)
      xxint(3)=d(3)
      if(isst(2))106,103,106
  103 call rotate(xxint(iswap1),xxint(iswap2))
      call vm(xxint,uinv,xxint)
      call rotate(xxint(iswap1),xxint(iswap2))
  106 if(abs(xxint(1)-x).ge.dx.or.abs(xxint(2)-y).ge.dy.or.abs(xxint(3)
     a -z).ge.dz) go to 150
      psm=exp(sngl(c(1)+c(2)*d(1)+c(3)*d(2)+c(4)*d(3)+c(5)*d(1)*d(1)
     a            +c(6)*d(2)*d(2)+c(7)*d(3)*d(3)+c(8)*d(2)*d(3)
     b            +c(9)*d(3)*d(1)+c(10)*d(1)*d(2)))
      if(psv(2,2,2))110,120,120
  110 psm=-psm
  120 if(psml)130,130,140
  130 psm=psm+2.*psml-1.
  140 height(ii)=psm
      return
  150 ibor(ii)=4
      return
  160 ibor(ii)=3
      return
      end
      subroutine frpeak
      real label(2,250),xxx(250),yyy(250),zzz(250),height(250)
      integer*2 nnx,nny,nnz,nnnx,nnny,nxprev,nyprev,ibord(250),nxn(250),
     anyn(250),nzn(250)
      character*4 labell(2,250)
*     integer jlast(2)     ,lp(2)     ,npeak(2),border*2(2)/'  ',' *'/
      integer jlast(2)     ,lp(2)     ,npeak(2)
      character*2 border(2)
*     real posneg*8(2,2)/'positive',' peaks  ','negative',' troughs'/,
*    axkim(3),xyz(3)
      character*8 posneg(2,2)
      real xkim(3),xyz(3)
      common/const/iii,in,indata,ivxx,ixx,lpsect,nblock,nequiv,nmemmx,
     anpline,nx,ny,nz,norien,xmin,ymin,zmin,xmax,ymax,zmax,dx,dy,dz,
     baa(3,3),bb(3,3),dcell(9),detu,fs(3,3,24),isst(8),jmax,kmax,kmin,
     cncd,nef,rcell(9),rmax,scale,title(20),ts(3,24),u(3,3),uinv(3,3),
     dvol
      common noint,npunch,nsearc,ntran,icent,indexh,indexv,indexs,iswap
     a,iswap2,const,fill,label1(101),label2(101),label3(101),yy(101),
     bnnnx(2,250),nnny(2,250),nxprev(2,250),nyprev(2,250),rrr(2,250),
     crprev(2,250),nnx(2,1500),nny(2,1500),nnz(2,1500),rr(2,1500),
     dsect(90,103)
*     two-dimensional arrays are expressed as one-dimensional ones
*     equivalence (label(1),label1(1)),(xxx(1),nnnx(193)),
*    a (yyy(1),nnny(193)),(zzz(1),nxprev(193)),(height(1),nyprev(193)),
*    b (ibord(1),rrr(97)),(nxn(1),rrr(222)),(nyn(1),rrr(347)),
*    c (nzn(1),rrr(472))
      equivalence (label,label1(1)),(xxx(1),nnnx(1,97)),
     & (yyy(1),nnny(1,97)),(zzz(1),nxprev(1,97)),
     & (height(1),nyprev(1,97)),
     & (ibord(1),rrr(1,49)),(nxn(1),rrr(2,111)),(nyn(1),rrr(1,174)),
     & (nzn(1),rrr(2,236))
      data border/'  ',' *'/
      data posneg/'positive',' peaks  ','negative',' troughs'/
 1000 format('0too many ',2a8,' on section',i4)
 1010 format('0too many ',2a8,' in this fourier map - present section is
     a no.',i4)
corrected on 1988.8.11
c1020 format('9'/'1list of ',2a8,' (those on borders are marked *)'/
 1020 format('1list of ',2a8,' (those on borders are marked *)'/
     a'-ed = electron density (in e/a**3 if input data are in electrons)
     b = scale*(2./vol)*(rho/999.)*rmax'/   '0if listed, x(a) etc (in an
     cgstroms) refer to new orthogonal cell b with b2 parallel to a2, b
     d parallel to a2xa3, b3 parallel to b1xb2'/   '0if listed, oldx etc
     e (in fractional coordinates) refer to the original cell'/'-  no.',
     f10x'x',10x'y',10x'z',12x'rho',9x'ed(e/a**3)')
 1030 format('+',87x'oldx',8x'oldy',8x'oldz'/)
 1040 format('+',87x'x(a)',8x'y(a)',8x'z(a)',8x'd(000)'/)
 1050 format('0',i4,4x3f11.4,4xi8,3xf16.3,a4,3x3f12.3,f14.3)
 1060 format('-npos=',i4,4x'nneg=',i4,4x'noint=',i4,4x'npunch=',i4,4x
     a'ntran=',i3,4x'icent=',i3,4x'rmin',f6.0)
 1070 format(6i5,f5.0)
 1080 format(5x,i3,2x,3f10.6)
 1100 format(1hp,i3)
      ipun=2
      if(isst(5))3,3,5
    3 npos=0
      nneg=0
      go to 8
    5 read(in,1070)     npos,nneg,noint,npunch,ntran,icent,rmin
c-vax-
c-vax-open coded peak output file if necessary
c-vax-
*     if(npunch.gt.0) open (unit=2,status='new',recl=80,
*    1 blocksize=4560,recordtype='fixed',disp='keep',
*    2 buffercount=1)
      if(npunch.gt.0) open (unit=2)
      if(npunch.eq.0) npunch=-1
c-vax-
      write(iii,1060)   npos,nneg,noint,npunch,ntran,icent,rmin
      jlast(1)=0
      jlast(2)=0
      lp(1)=0
      lp(2)=0
      rmin=rmax*rmin/999.
*   8 read(ivxx) nx,ny,nz,norien,xmin,xmax,ymin,ymax,zmin,zmax,dx,dy,dz
    8 read(ivxx,'(4i5/9f14.0)')
     &nx,ny,nz,norien,xmin,xmax,ymin,ymax,zmin,zmax,dx,dy,dz
      i=alog10(float(norien)+.1)
      indexs=3-i
      indexv=mod(indexs,3)+1
      indexh=mod(indexv,3)+1
      iswap1=i+1
      iswap2=mod(iswap1,3)+1
      if(isst(4).ne.1) go to 13
      call frplot
   13 nxx=nx+1
      nyy=ny+1
      nxxx=nxx+1
      nyyy=nyy+1
      do 230 i=1,nz
      do 16 j=1,nyyy
      sect(1,j)=rmin
   16 sect(nxxx,j)=rmin
      do 18 j=2,nxx
      sect(j,1)=rmin
   18 sect(j,nyyy)=rmin
      do 20 j=2,nyy
*  20 read(ivxx) (sect(k,j),k=2,nxx)
   20 read(ivxx,*) (sect(k,j),k=2,nxx)
      if(npos)30,30,60
   30 if(nneg)40,40,70
   40 if(isst(4).ne.1) go to 230
      call plot2a
      go to 230
   60 if(lp(1).eq.1500) go to 30
      ipn=1
      npeak(1)=0
      go to 100
   70 if(lp(2).eq.1500) go to 40
      ipn=2
      npeak(2)=0
*     assign 100 to nxit
      nxit=100
   80 do 90 j=2,nyy
      do 90 k=2,nxx
   90 sect(k,j)=-sect(k,j)
*     go to nxit,(40,100)
      if (nxit .eq. 40) go to 40
  100 do 180 j=2,nyy
      jj=j-1
      jjj=j+1
      do 180 k=2,nxx
      ans=sect(k,j)
      if(ans.le.rmin) go to 180
      kk=k-1
      kkk=k+1
      do 110 l=jj,jjj
      do 110 m=kk,kkk
      if(ans.lt.sect(m,l)) go to 180
  110 continue
      npeak(ipn)=npeak(ipn)+1
      l=npeak(ipn)
      if(l.le.250) go to 120
      write(iii,1000) posneg(1,ipn),posneg(2,ipn),i
      npeak(ipn)=250
      go to 190
  120 rrr(ipn,l)=ans
      nnnx(ipn,l)=kk
      nnny(ipn,l)=jj
      m=jlast(ipn)
      if(m) 145,145,130
  130 do 140 l=1,m
      if(iabs(jj-nyprev(ipn,l)).gt.1) go to 140
      if(iabs(kk-nxprev(ipn,l)).gt.1) go to 140
      if(ans.lt.rprev(ipn,l)) go to 180
  140 continue
  145 m=lp(ipn)
      if(m)165,165,150
  150 do 160 l=1,m
      if(i-nnz(ipn,l).ne.1) go to 160
      if(iabs(jj-nny(ipn,l)).gt.1) go to 160
      if(iabs(kk-nnx(ipn,l)).gt.1) go to 160
      if(ans-rr(ipn,l)) 180,170,170
  160 continue
  165 l=m+1
      lp(ipn)=l
      if(l.le.1500) go to 170
      write(iii,1010) posneg(1,ipn),posneg(2,ipn),i
      lp(ipn)=1500
      go to 190
  170 rr(ipn,l)=ans
      nnx(ipn,l)=kk
      nny(ipn,l)=jj
      nnz(ipn,l)=i
  180 continue
  190 m=npeak(ipn)
      jlast(ipn)=m
      if(m)220,220,200
  200 do 210 l=1,m
      rprev(ipn,l)=rrr(ipn,l)
      nxprev(ipn,l)=nnnx(ipn,l)
  210 nyprev(ipn,l)=nnny(ipn,l)
  220 if(ipn.eq.1) go to 30
*     assign 40 to nxit
      nxit=40
      go to 80
  230 continue
      if(rmax)240,240,250
* 240 read(ivxx) rmax
  240 read(ivxx,*) rmax
  250 rewind ivxx
      nsearc=0
      pmult=2.*scale/vol
      if(npos)260,260,280
  260 if(nneg)460,460,270
  270 ipn=2
      jjj=nneg
      go to 290
  280 ipn=1
      jjj=npos
  290 write(iii,1020) posneg(1,ipn),posneg(2,ipn)
      if(isst(2))300,300,310
  300 call setu(u,uinv,aa,bb)
      write(iii,1040)
      go to 320
  310 write(iii,1030)
  320 const=999./rmax
      m=lp(ipn)
      if(m)450,450,330
  330 if(jjj.gt.m) jjj=m
      do 440 jj=1,jjj
      if(nsearc.eq.250) go to 460
      do 332 j=1,m
      if(rr(ipn,j).gt.rmin) go to 333
  332 continue
      go to 450
  333 ans=rr(ipn,j)
      do 335 i=1,m
      if(ans.ge.rr(ipn,i)) go to 335
      ans=rr(ipn,i)
      j=i
  335 continue
      rr(ipn,j)=rmin
      nrr=ans*const+.5
      ed=ans*pmult
      ix=nnx(ipn,j)
      iy=nny(ipn,j)
      iz=nnz(ipn,j)
      xyz(1)=(ix-1)*dx+xmin
      xyz(2)=(iy-1)*dy+ymin
      xyz(3)=(iz-1)*dz+zmin
      if(ix.eq.1.or.ix.eq.nx.or.iy.eq.1.or.iy.eq.ny.or.iz.eq.1.or.iz.eq.
     anz) go to 340
      ibor=1
      go to 350
  340 ibor=2
  350 nsearc=nsearc+1
      if(ipn.eq.1) go to 360
      nrr=-nrr
      ed=-ed
      ans=-ans
  360 continue
      label(1,nsearc)=title(1)
      write(labell(2,nsearc),1100) j
      xxx(nsearc)=xyz(1)
      yyy(nsearc)=xyz(2)
      zzz(nsearc)=xyz(3)
      height(nsearc)=ans
      ibord(nsearc)=ibor
      nxn(nsearc)=ix
      nyn(nsearc)=iy
      nzn(nsearc)=iz
      call rotate(xyz(iswap1),xyz(iswap2))
      call vm(xyz,u,xkim)
      if(isst(2))410,410,420
  410 dpat=sqrt(xkim(1)*xkim(1)+xkim(2)*xkim(2)+xkim(3)*xkim(3))
      go to 430
  420 dpat=0.
  430 write(iii,1050) nsearc,xyz,nrr,ed,border(ibor),xkim,dpat
      if(noint)433,433,440
  433 write(ixx) title(1),j,xyz
      if(npunch)440,440,436
  436 write(ipun,1080) j,xyz
      npunch=npunch-1
  440 continue
  450 if(ipn.eq.1) go to 260
  460 rewind ixx
      return
      end
*
      block data chinit
      character*4 symb,plus,minus,blank
      common /spmb/ symb(40),plus,minus,blank
      data symb/'(   ','+   ','\   ','*   ','=   ','/   ','a   ',
     &'b   ','c   ','d   ','e   ','f   ','g   ','h   ','j   ','k   ',
     &'l   ','m   ','n   ','p   ','q   ','r   ','s   ','t   ','u   ',
     &'v   ','w   ','x   ','y   ','z   ','0   ','1   ','2   ','3   ',
     &'4   ','5   ','6   ','7   ','8   ','9   '/,
     & plus/'+   '/,  minus/'-   '/,  blank/'    '/
      end
*
      subroutine frplot
      common/const/iii,in,indata,ivxx,ixx,lpsect,nblock,nequiv,nmemmx,
     anpline,nx,ny,nz,norien,xmin,ymin,zmin,xmax,ymax,zmax,dx,dy,dz,
     baa(3,3),bb(3,3),dcell(9),detu,fs(3,3,24),isst(8),jmax,kmax,kmin,
     cncd,nef,rcell(9),rmax,scale,title(20),ts(3,24),u(3,3),uinv(3,3),
     dvol
      character*4 head1(3),head2(3),fmt(8),skip(3),format(4),fmth(5),
     a ihead1,ihead2
      integer*2 nnx,nny,nnz,nnnx,nnny,nxprev,nyprev
      common noint,npunch,nsearc,ntran,icent,indexh,indexv,indexs,iswap
     a,iswap2,const,fill,label1(101),label2(101),label3(101),yy(101),
     bnnnx(2,250),nnny(2,250),nxprev(2,250),nyprev(2,250),rrr(2,250),
     crprev(2,250),nnx(2,1500),nny(2,1500),nnz(2,1500),rr(2,1500),
     dsect(90,103)
      integer isect(9270)
*     equivalence(sect(1),isect(1))
      equivalence(sect,isect)
*     integer symb(40)/'(','+','\','*','=','/','a','b','c','d','e','f',
*    a'g','h','j','k','l','m','n','p','q','r','s','t','u','v','w','x',
*    b'y','z','0','1','2','3','4','5','6','7','8','9'/
*    c plus/'+'/,  minus/'-'/,  blank/' '/
*     symb, plus, minus and blank are initiallized in block data chinit
*     to avoid warning messages issued by the compiler
      integer*4 symb,plus,minus,blank
      common /spmb/ symb(40),plus,minus,blank
      data head1/'x   ','y   ','z   '/,
*    a     head2/' x =',' y =',' z ='/,
     a     head2/'x = ','y = ','z = '/,
     b     fmt/'(1h ','   x',' ,4h',' x =','f8.5',',3x,','116a','1)  '/,
     c     skip/'(1h ','(1h0','(1h-'/,
     d     format/'1)  ','2)  ','3)  ','4)  '/,
     e     fmth/'(1h ','   x',',15x','116a','1)  '/
*1000 format('9'/'1',52x'****************'/' rmax=',e13.6,34x'*  ',a4,
*    af8.5,'*',32x'c =',e13.6/' ',52x'****************'/)
corrected on 1988.8.11
c1000 format('9'/'1',52x'****************'/' rmax =',e13.6,'   edmax =',
 1000 format('1',52x'****************'/' rmax =',e13.6,'   edmax =',
     &e13.6,10x,'* ',a4,f8.5,' *',32x'c =',e13.6/' ',52x,
     &'****************'/)
 1010 format(8i5)
 1020 format('-nhsp=',i3,4x'nvsp=',i3,4x'ndisp=',i4,4x'rhomin=',i6,4x
     a'rhomax=',i6,4x'ipos=',i3,4x'ineg=',i4/)
 1040 format(' ')
 1050 format('-contour intervals (on the normalised scale) and related s
     aymbols'/ ('-',21i6/'0',5x20a6))
 1100 format(i3,'x')
      read(in,1010) nhsp,nvsp,ndisp,imin,imax,ipos,ineg
      write(iii,1020) nhsp,nvsp,ndisp,imin,imax,ipos,ineg
      nxx=nx+1
      nyy=ny+1
      if(rmax)10,10,30
   10 n=ny*nz
      do 20 i=1,n
*  20 read(ivxx)
   20 read(ivxx,'()')
*     read(ivxx) rmax
      read(ivxx,'(f14.0)') rmax
      rewind ivxx
*     read(ivxx)
      read(ivxx,'()')
   30 c=999./rmax
      nhsp=nhsp+1
      if(nhsp.le.0.or.nhsp.gt.4) nhsp=1
      nvsp=nvsp+1
      if(nvsp.le.0.or.nvsp.gt.3) nvsp=1
   40 if(nx*nhsp+iabs(ndisp)*(ny-1).le.116) go to 90
      if(ndisp)50,60,50
   50 ndisp=ndisp-isign(1,ndisp)
      go to 40
   60 if(nhsp-1)90,90,70
   70 nhsp=nhsp-1
      if(nvsp-1)40,40,80
   80 nvsp=nvsp-1
      go to 40
   90 ihead1=head2(indexs)
      ihead2=head1(indexh)
      fmt(4)=head2(indexv)
      fmt(1)=skip(nvsp)
      fmt(8)=format(nhsp)
      fmth(5)=fmt(8)
      nstart=117-nx*nhsp
      if(ndisp)110,110,100
  100 nstart=nstart-ndisp*(ny-1)
  110 write(fmth(2),1100) nstart
      xx=xmin
      do 150 i=1,nx
      j=mod(ifix(xx*100.+sign(.5,xx)),100)
      if(j)120,130,130
  120 label1(i)=minus
      go to 140
  130 label1(i)=plus
  140 k=iabs(j)
      label2(i)=symb(k/10+31)
      label3(i)=symb(mod(k,10)+31)
  150 xx=xx+dx
      zz=zmin
      rrmin=imin
      grid=40./float(imax-imin)
      y=ymin
      do 160 i=1,ny
      yy(i)=y
  160 y=y+dy
      xx=1./grid
      y=rrmin
      do 170 i=1,41
      isect(i)=y+sign(.5,y)
  170 y=y+xx
      write(iii,1050) (isect(i),i=1,21),(symb(i),i=1,20),
     a (isect(i),i=21,41),(symb(i),i=21,40)
      return
      entry plot2a
      k=nstart
      l=1
      do 250 i=2,nyy
      do 250 j=2,nxx
      ipoint=(sect(j,i)*c-rrmin)*grid+1.0001
      if(ipoint)190,190,220
  190 if(ineg)200,210,200
  200 isect(l)=minus
      go to 250
  210 isect(l)=blank
      go to 250
  220 if(ipoint.gt.40) go to 230
      isect(l)=symb(ipoint)
      go to 250
  230 if(ipos)240,210,240
  240 isect(l)=plus
  250 l=l+1
*     write(iii,1000) rmax,ihead1,zz,c
      write(iii,1000) rmax,2.0*scale*rmax/vol,ihead1,zz,c
      write(iii,fmth) (ihead2,i=1,nx)
      write(iii,fmth) (label1(i),i=1,nx)
      write(iii,fmth) (label2(i),i=1,nx)
      write(iii,fmth) (label3(i),i=1,nx)
      write(iii,1040)
      l=1
      do 260 i=1,ny
      write(fmt(2),1100) k
      j=l-1+nx
      write(iii,fmt) yy(i),(isect(n),n=l,j)
      l=l+nx
  260 k=k+ndisp
      zz=zz+dz
      return
      end
      subroutine frprnt
      common/const/iii,in,indata,ivxx,ixx,lpsect,nblock,nequiv,nmemmx,
     anpline,nx,ny,nz,norien,xmin,ymin,zmin,xmax,ymax,zmax,dx,dy,dz,
     baa(3,3),bb(3,3),dcell(9),detu,fs(3,3,24),isst(8),jmax,kmax,kmin,
     cncd,nef,rcell(9),rmax,scale,title(20),ts(3,24),u(3,3),uinv(3,3),
     dvol
      real*8 label
      integer*2 nnx,nny,nnz,ibor,ibornx,iborny,ibornz
      common noint,npunch,nsearc,ntran,icent,indexh,indexv,indexs,iswap
     a,iswap2,const,fill,label(250),xx(250),yy(250),zz(250),height(250),
     bibor(250),nnx(250),nny(250),nnz(250),xxint(3),yyy(101),label1(101)
     c,label2(101),ibornx(19,80),iborny(19,80),ibornz(19,80),rsave(27,
     d250),sect(88,101)
      integer iray(8888)
*     equivalence (sect(1),iray(1))
      equivalence (sect,iray)
*     integer head(3)/'x =,','y =,','z =,'/,  skip(3)/'(1h ','(1h0','(1h
*    a-'/,fmt(7)/'(1h ',',4h ','y =,','f8.5',',3x,','29i4',')'/
      character*4 head(3),skip(3),fmt(7),ihead1,ihead2
      data head/'x = ','y = ','z = '/,  skip/'(1h ','(1h0','(1h-'/
     a,fmt/'(1h ',',4h ','y =,','f8.5',',3x,','29i4',')'/
*1000 format('9'/'1',52x'****************'/' rmax=',e13.6,34x'*  ',a4,
*    af8.5,'*',32x'c =',e13.6/' ',52x'****************'/)
corrected on 1988.8.11
c1000 format('9'/'1',52x'****************'/' rmax =',e13.6,'   edmax =',
 1000 format('1',52x'****************'/' rmax =',e13.6,'   edmax =',
     &e13.6,10x,'* ',a4,f8.5,' *',32x,'c =',e13.6/' ',52x,
     &'****************'/)
 1010 format(' ',15x29a4)
 1020 format(' ',15x29i4)
corrected on 1988.8.11
c1030 format('9'/'1'///)
 1030 format('1'///)
      ihead1=head(indexs)
      ihead2=head(indexh)
      fmt(3)=head(indexv)
      j=isst(3)
      if(j.gt.3) j=2
      fmt(1)=skip(j)
      xxx=xmin
      do 10 i=1,nx
      j=mod(ifix(100000.*xxx+sign(.5,xxx)),100000)
      label1(i)=j/1000
      label2(i)=iabs(mod(j,1000))
   10 xxx=xxx+dx
      zzz=zmin
      if(rmax)20,20,40
   20 j=ny*nz
      do 30 i=1,j
*  30 read(ivxx)
   30 read(ivxx,'()')
*     read(ivxx) rmax
      read(ivxx,'(f14.0)') rmax
      rewind ivxx
*     read(ivxx)
      read(ivxx,'()')
   40 c=999./rmax
      nrun=(nx+28)/29
      y=ymin
      do 45 i=1,ny
      yyy(i)=y
   45 y=y+dy
      return
      entry print
      k=1
      do 50 i=1,ny
      do 50 j=1,nx
      iray(k)= sect(j,i)*c+sign(.5,sect(j,i))
   50 k=k+1
      write(iii,1000) rmax,2.0*scale*rmax/vol,ihead1,zzz,c
      m=0
      j=-28
   60 j=j+29
      k=j
      l=k+28
      if(l.gt.nx) l=nx
      write(iii,1010) (ihead2,n=k,l)
      write(iii,1020) (label1(n),n=k,l)
      write(iii,1020) (label2(n),n=k,l)
      write(iii,1020)
      do 70 i=1,ny
      write(iii,fmt) yyy(i),(iray(n),n=k,l)
      k=k+nx
   70 l=l+nx
      m=m+1
      if(m.eq.nrun) go to 80
      write(iii,1030)
      go to 60
   80 zzz=zzz+dz
      return
      end
      subroutine gp1(plane,d,aa,u)
      real plane(3),u1(3),u2(3),u3(3),u(3,3),aa(3,3),bb(3,3)
c     s/r to find transformation matrix to axes appropiate to plane
c     cell2=u*cell1     cell2(1) is normal to plane
      call mi3(aa,bb,deta)
      if(d)10,20,20
   10 plane(1)=-plane(1)
      plane(2)=-plane(2)
      plane(3)=-plane(3)
   20 alpha=1./sqrt(vmv(plane,bb,plane))
      plane(1)=alpha*plane(1)
      plane(2)=alpha*plane(2)
      plane(3)=alpha*plane(3)
      call vm(plane,bb,u1)
      k=1
      if(abs(plane(1)).ge.abs(plane(2))) k=2
      if(abs(plane(k)).ge.abs(plane(3))) k=3
      alpha=-sign(plane(k),u1(k))
      u2(1)=alpha*u1(1)
      u2(2)=alpha*u1(2)
      u2(3)=alpha*u1(3)
      u2(k)=u2(k)+1.
      call norm(aa,u2)
      call cross(bb,u1,u2,u3)
      call norm(aa,u3)
      do 30 k=1,3
      u(1,k)=u1(k)
      u(2,k)=u2(k)
   30 u(3,k)=u3(k)
      return
      end
      subroutine ipeak
      common/const/iii,in,indata,ivxx,ixx,lpsect,nblock,nequiv,nmemmx,
     anpline,nx,ny,nz,norien,xmin,ymin,zmin,xmax,ymax,zmax,dx,dy,dz,
     baa(3,3),bb(3,3),dcell(9),detu,fs(3,3,24),isst(8),jmax,kmax,kmin,
     cncd,nef,rcell(9),rmax,scale,title(20),ts(3,24),u(3,3),uinv(3,3),
     dvol
*     real*8 label,xkim*4(3)
      real*8 label
      real xkim(3)
      integer*2 nnx,nny,nnz,ibor,ibornx,iborny,ibornz
      character*4 border(4)
      integer*2 nbp(19)
      integer nxyz(3)
      real xm(19),ym(19),zm(19),transl(15),xyzmin(3),xyzmax(3),dxyz(3),
     &  tran(3,4),xyz(3),txyz(3),ttxyz(3)
      common noint,npunch,nsearc,ntran,icent,indexh,indexv,indexs,iswap
     a,iswap2,const,fill,label(250),xx(250),yy(250),zz(250),height(250),
     bibor(250),nnx(250),nny(250),nnz(250),xxint(3),yyy(101),label1(101)
     c,label2(101),ibornx(19,80),iborny(19,80),ibornz(19,80),rsave(27,
     d250),sect(88,101)
      equivalence(xmin,xyzmin(1)),(xmax,xyzmax(1)),(dx,dxyz(1))
*     integer border(4)/' ','*','**','****'/,   nbp*2(19)/2,4,5,6,8,10,
*    a11,12,13,14,15,16,17,18,20,22,23,24,26/,   nxyz(3)
*     real xm(19)/0.,-1.,0.,1.,0.,-1.,0.,1.,-1.,0.,1.,-1.,0.,1.,0.,-1.,
*    a0.,1.,0./,   ym(19)/-1.,0.,0.,0.,1.,-1.,-1.,-1.,0.,0.,0.,1.,1.,1.,
*    b-1.,0.,0.,0.,1./,   zm(19)/-1.,-1.,-1.,-1.,-1.,0.,0.,0.,0.,0.,0.,
*    c0.,0.,0.,1.,1.,1.,1.,1./,   transl(15)/0.,0.,0.,0.,.5,.5,.5,0.,.5,
*    d.5,.5,0.,.5,.5,.5/,   xyzmin(3),xyzmax(3),dxyz(3),tran(3,4),xyz(3)
*    e,txyz(3),ttxyz(3)
      data border/' ','*','**','****'/
      data nbp/2,4,5,6,8,10,11,12,13,14,15,16,17,18,20,22,23,24,26/
      data xm/0.,-1.,0.,1.,0.,-1.,0.,1.,-1.,0.,1.,-1.,0.,1.,0.,-1.,
     a0.,1.,0./,   ym/-1.,0.,0.,0.,1.,-1.,-1.,-1.,0.,0.,0.,1.,1.,1.,
     b-1.,0.,0.,0.,1./,   zm/-1.,-1.,-1.,-1.,-1.,0.,0.,0.,0.,0.,0.,
     c0.,0.,0.,1.,1.,1.,1.,1./,   transl/0.,0.,0.,0.,.5,.5,.5,0.,.5,
     d.5,.5,0.,.5,.5,.5/
corrected on 1988.8.11
c1000 format('9'/'1interpolated coordinates for peaks'/   '0those marked
 1000 format(    '1interpolated coordinates for peaks'/   '0those marked
     a *    are on a border and have not been interpolated'/   '0those m
     barked **   are high points on a border but are not true peaks'/
     c'0those marked **** moved outside the box when interpolation was c
     darried out'/   '-  no.',10x'x',10x'y',10x'z',12x'rho','ed(e/a**3)'
     e)
 1010 format('+',87x'x(a)',8x'y(a)',8x'z(a)',8x'd(000)'/)
 1020 format('+',87x'oldx',8x'oldy',8x'oldz'/)
 1030 format('0',i4,4x3f11.4,4xi8,3xf16.3,a6,1x3f12.3,f14.3)
 1040 format(a8,2x,3f10.6)
      ipun=2
*     read(ivxx) nx,ny,nz,norien,xmin,xmax,ymin,ymax,zmin,zmax,dx,dy,dz
      read(ivxx,'(4i5)') nx,ny,nz,norien
      read(ivxx,*) xmin,xmax,ymin,ymax,zmin,zmax,dx,dy,dz
      i=alog10(float(norien)+.1)
      indexs=3-i
      indexv=mod(indexs,3)+1
      indexh=mod(indexv,3)+1
      iswap1=i+1
      iswap2=mod(iswap1,3)+1
      if(isst(3))10,20,10
*temporary
   10 call frprnt
   20 if(noint.gt.nsearc) noint=nsearc
      if(noint)240,240,30
   30 do 40 i=1,12
   40 tran(i,1)=transl(i)
      if(ntran)50,50,60
   50 ntran=1
      go to 90
   60 if(ntran-5)80,70,50
   70 ntran=4
      go to 90
   80 i=3*ntran+1
      ntran=2
      tran(1,2)=transl(i)
      tran(2,2)=transl(i+1)
      tran(3,2)=transl(i+2)
   90 nbord=1
      if(isst(2))240,100,240
* 100 assign 190 to nxit
  100 nxit=190
      do 220 i=1,noint
      if(ibor(i).eq.1) go to 220
      x=xx(i)
      y=yy(i)
      z=zz(i)
      do 210 j=1,19
      xyz(1)=xm(j)*dx+x
      xyz(2)=ym(j)*dy+y
      xyz(3)=zm(j)*dz+z
      call rotate(xyz(iswap1),xyz(iswap2))
      do 190 k=1,nequiv
      call mvpv(fs(1,1,k),xyz,ts(1,k),txyz)
      do 190 l=1,ntran
      ttxyz(1)=txyz(1)+tran(1,l)
      ttxyz(2)=txyz(2)+tran(2,l)
      ttxyz(3)=txyz(3)+tran(3,l)
      call rotate(ttxyz(iswap1),ttxyz(iswap2))
*     if(icent.le.1) assign 180 to nxit
      if(icent.le.1) nxit=180
  110 n=0
      do 170 m=1,3
      point=ttxyz(m)
  120 if(point-xyzmin(m)+.00001)140,160,130
  130 point=point-1.
      go to 120
  140 point=point+1.
      if(point-xyzmin(m)+.00001)140,160,150
  150 if(point.gt.xyzmax(m)+.00001) go to 170
  160 n=n+1
      nxyz(n)=(point-xyzmin(m))/dxyz(m)+1.1
  170 continue
      if(n.eq.3) go to 200
*     go to nxit,(180,190)
      if (nxit .eq. 190) go to 190
  180 ttxyz(1)=-ttxyz(1)
      ttxyz(2)=-ttxyz(2)
      ttxyz(3)=-ttxyz(3)
*     assign 190 to nxit
      nxit=190
      go to 110
  190 continue
      ibor(i)=2
      go to 220
  200 ibor(i)=0
      ibornx(j,nbord)=nxyz(1)
      iborny(j,nbord)=nxyz(2)
  210 ibornz(j,nbord)=nxyz(3)
      nbord=nbord+1
      if(nbord.gt.80) go to 240
  220 continue
  240 do 330 i=1,nz
      do 250 j=1,ny
* 250 read(ivxx) (sect(k,j),k=1,nx)
  250 read(ivxx,'(29f14.0)') (sect(k,j),k=1,nx)
      if(noint)260,260,270
  260 if(isst(3))265,330,265
  265 call print
      go to 330
  270 nbord=1
      do 320 j=1,noint
      if(ibor(j)-1)300,280,320
  280 k=i-nnz(j)
      if(iabs(k).gt.1) go to 320
      k=9*k+10
      l=nny(j)-2
      m=nnx(j)-2
      do 290 n=1,3
      do 290 nn=1,3
      rsave(k,j)=sect(m+nn,l+n)
  290 k=k+1
      go to 320
  300 do 310 k=1,19
      if(ibornz(k,nbord).ne.i) go to 310
      rsave(nbp(k),j)=sect(ibornx(k,nbord),iborny(k,nbord))
  310 continue
      nbord=nbord+1
  320 continue
      go to 260
  330 continue
      rewind ivxx
      rewind ixx
      pmult=2.*scale/vol
      if(noint)460,460,340
  340 write(iii,1000)
      if(isst(2))350,360,350
  350 write(iii,1020)
      go to 370
  360 write(iii,1010)
  370 do 450 i=1,nsearc
      if(i.gt.noint) go to 380
      if(ibor(i).le.1) go to 390
  380 xxint(1)=xx(i)
      xxint(2)=yy(i)
      xxint(3)=zz(i)
      go to 400
  390 call edint(rsave(1,i),i)
      if(ibor(i).ge.3) go to 380
  400 call rotate(xxint(iswap1),xxint(iswap2))
      call vm(xxint,u,xkim)
      if(isst(2))410,420,410
  410 dpat=0.
      go to 430
  420 dpat=sqrt(xkim(1)*xkim(1)+xkim(2)*xkim(2)+xkim(3)*xkim(3))
  430 ans=height(i)
      nrr=ans*const+sign(.5,ans)
      ed=ans*pmult
      write(iii,1030) i,xxint,nrr,ed,border(ibor(i)),xkim,dpat
      write(ixx) label(i),xxint
      if(npunch) 450,450,440
  440 npunch=npunch-1
      write(ipun,1040) label(i),xxint
  450 continue
      rewind ixx
  460 return
      end
      subroutine rip
      character*2 axis(3),xl,yl,zl
*sun
      character*50 file12
      common/const/iii,in,indata,ivxx,ixx,lpsect,nblock,nequiv,nmemmx,
     anpline,nx,ny,nz,norien,xmin,ymin,zmin,xmax,ymax,zmax,dx,dy,dz,
     baa(3,3),bb(3,3),dcell(9),detu,fs(3,3,24),isst(8),jmax,kmax,kmin,
     cncd,nef,rcell(9),rmax,scale,title(20),ts(3,24),u(3,3),uinv(3,3),
     dvol
      common/rdrt/ncode,iend
      integer*2 jh,kh,lh,hin
      common trgtbl(1001),a(24),ah(25),b(24),bh(25),hin(5,10),hkl(3),
     aj(24),k(24),l(24),m1(24,3),m2(24,3),m3(24,3),mtx(24),mty(24),
     bmtz(24),xin(6,10),jh(25),kh(25),lh(25)
      common/rej/aaa,bbb,cosaa,del,fcalc,fobs,jj,kk,ll,nrej,sinaa
*     real xsin(16)/0.,.5,.866025,1.,.866025,.5,0.,-.5,-.866025,-1.,
*    a-.866025,-.5,0.,.5,.866025,1./
      real xsin(16)
      data xsin/0.,.5,.866025,1.,.866025,.5,0.,-.5,-.866025,-1.,
     a-.866025,-.5,0.,.5,.866025,1./
*     integer*2 axis(3)/' z',' y',' x'/,   xl/'x'/,yl/'y'/,zl/'z'/
      data axis/' z',' y',' x'/,   xl/'x'/,yl/'y'/,zl/'z'/
      data nread/0/
      nucalc(n)=mod(n,12)-(isign(1,n)-1)*6
*     ifixr(a)=ifix(a+sign(.5,a))
      ifixr(x)=ifix(x+sign(.5,x))
 1000 format('-input data from cards')
*1010 format('-input data from unit 12 created by tofls')
 1010 format('-input data from unit 12 created by rietan')
 1020 format(4i5,f5.2)
 1030 format(9f5.5,i5)
 1050 format(60x'(the indices are transformed to the new cell)')
 1060 format('-',5x'h',5x'k',5x'l',12x'a',14x'b'/)
 1070 format('-insufficient space to store the expanded data - therefore
     a, all data not used')
 1080 format('-no end of data marker in the input file')
 1100 format(' ',3i6,2f15.2)
 1110 format('-compute difference fourier excluding ''unobserved'' data'
     a)
 1120 format('-compute difference fourier including ''unobserved'' data'
     a)
*1130 format('-compute fourier based on obs with phases from calc')
 1130 format('-compute fourier based on f(o) with phases from f(c)')
*1140 format('-compute fourier based on calc')
 1140 format('-compute fourier based on f(c)')
*1150 format('-compute patterson based on obs')
 1150 format('-compute patterson based on f(o)')
*1160 format('-compute patterson based on calc')
 1160 format('-compute patterson based on f(c)')
 1170 format('-compute alpha synthesis')
 1180 format('0input file contains data based on f')
 1190 format('0input file contains data based on f squared')
 1200 format('0use all input data')
 1210 format('0use only first',i6,' input data')
 1220 format('0calculation code word',i6,' is illegal')
 1230 format('-up to',i6,' expanded reflections will be listed')
 1240 format('-no data available for this summation')
 1250 format('-number of points/line is',i6/   '0number of lines/section
     a is',i4/   '0number of sections is',i9/  '0total number of output
     brecords is',i5)
 1260 format('0sinth/l limit for this calculation is',f7.3)
 1270 format('-compute sections along the',a2,' axis')
 1280 format('0',a2,'limits are from',f9.5,' to',f9.5,' in steps of',
     af8.5,'(',f6.3,' angstroms)')
 1290 format('-there is not enough disk space available')
 1300 format('-the',i6,' independent reflections have been expanded to',
     ai7,' terms')
 1310 format('-the cd table requires',i6,' memory locations'/  '0the ef
     atable requires',i6,' memory locations'/)
 1320 format('-insufficient core storage available')
 1350 format('-one or both of the first two exceed program dimensions')
      nexpan=0
      ntotal=0
      nbuff=0
      jmax=0
      kmax=0
      kmin=0
      numb=10
      read(in,1020)        nref,ncode,nontap,nrec,snlmax
      if(ncode)5,5,10
    5 write(iii,1000)
      assign 420 to nxit
      nontap = 20000
      go to 150
   10 continue
c-vax-
c-vax-open coded reflection input file if necessary
c-vax-
      if(nread.ne.0) go to 15
      if(isst(6).ne.0) go to 14
      if(ncode.eq.0) go to 14
*     open (unit=12,status='old',disp='keep')
*sun
      call getarg(2,file12)
*sun
      open(unit=12,file=file12)
*except sun
*     open (unit=12)
   14 continue
      nread=1
   15 continue
c-vax-
      if(isst(6).ne.0) write(iii,1010)
      ncode1=mod(ncode,100)
      if(ncode1.le.7) go to 20
      write(iii,1220)
      iend=1
      return
   20 go to (30,40,50,60,70,80,90),ncode1
   30 write(iii,1110)
      go to 100
   40 write(iii,1120)
      go to 100
   50 write(iii,1130)
      go to 100
   60 write(iii,1140)
      go to 100
   70 write(iii,1150)
      go to 100
   80 write(iii,1160)
      go to 100
   90 write(iii,1170)
  100 if(ncode.lt.100) go to 110
      write(iii,1190)
      go to 120
  110 write(iii,1180)
  120 assign 430 to nxit
      if(nontap)130,130,140
  130 write(iii,1200)
      nontap=20000
      go to 150
  140 write(iii,1210) nontap
  150 if(snlmax)170,170,160
  160 write(iii,1260) snlmax
  170 isst2=isst(2)-1
      if(isst2)180,180,190
  180 read(in,1030) xmin,xmax,ymin,ymax,zmin,zmax,dx,dy,dz,norien
      dx=dx/dcell(1)
      dy=dy/dcell(2)
      dz=dz/dcell(3)
      go to 200
  190 norien=100
  200 call chekup(xmin,xmax,norien,100,dx)
      call chekup(ymin,ymax,norien, 10,dy)
      call chekup(zmin,zmax,norien,  1,dz)
      fjx=dx*dcell(1)
      fkx=dy*dcell(2)
      flx=dz*dcell(3)
      i=alog10(float(norien)+.1)+1.
      write(iii,1270) axis(i)
      write(iii,1280)xl,xmin,xmax,dx,fjx,yl,ymin,ymax,dy,fkx,zl,zmin,
     azmax,dz,flx
      if(norien-10)210,220,230
  210 call rotate(xmin,ymin)
      call rotate(xmax,ymax)
      call rotate(dx,dy)
      go to 240
  220 call rotate(ymin,zmin)
      call rotate(ymax,zmax)
      call rotate(dy,dz)
      go to 240
  230 call rotate(xmin,zmin)
      call rotate(xmax,zmax)
      call rotate(dx,dz)
  240 do 330 i=1,nequiv
      do 250 m=1,3
      m1(i,m)=fs(1,m,i)
      m2(i,m)=fs(2,m,i)
  250 m3(i,m)=fs(3,m,i)
      if(m1(i,1)+m2(i,1))270,260,270
  260 if(m1(i,1))290,320,290
  270 if(m1(i,2)+m2(i,2))320,280,320
  280 if(m1(i,2))290,320,290
  290 if(m1(i,1)+m2(i,2))310,300,310
*     arguments of rotate must be real
* 300 call rotate(m1(i,2),m2(i,1))
  300 itemp=m1(i,2)
      m1(i,2)=m2(i,1)
      m2(i,1)=itemp
      go to 320
*     arguments of rotate must be real
* 310 call rotate(m1(i,1),m2(i,2))
  310 itemp=m1(i,1)
      m1(i,1)=m2(i,2)
      m2(i,2)=itemp
  320 mtx(i)=nucalc(ifixr(12.*ts(1,i)))
      mty(i)=nucalc(ifixr(12.*ts(2,i)))
  330 mtz(i)=nucalc(ifixr(12.*ts(3,i)))
      nx=(xmax-xmin)/dx+1.1
      ny=(ymax-ymin)/dy+1.1
      nz=(zmax-zmin)/dz+1.1
      if(nrec.eq.0) nrec=nblock
      n=ny*nz+2
      write(iii,1250) nx,ny,nz,n
      if(n.le.nrec) go to 335
      write(iii,1290)
      iend=1
      return
  335 if(nx.le.npline.and.ny.le.lpsect) go to 340
      write(iii,1350)
      iend=1
      return
  340 if(nref)345,345,350
  345 nref=5
  350 write(iii,1060)
  380 if(isst2)400,390,390
  390 write(iii,1050)
  400 if(nontap)910,910,410
  410 nontap=nontap-1
      go to nxit,(420,430)
  420 call cardin(jj,kk,ll,aaa,bbb)
      if(jj-99) 530,910,910
  430 continue
      if(isst(6).ne.0) go to 435
*     read(indata,2000,end=900) jj,kk,ll,sinlo,fobs,fcalc,cosaa,sinaa,de
*    1l
*2000 format(1x,3i3,6f10.4)
*      read(indata,*,end=900) jj,kk,ll,sinlo,fobs,fcalc,cosaa,sinaa,del
      read(indata,*,end=900) jj,kk,ll,fobs,wght
      fcalc=fobs
      go to 440
* 435 read(indata,end=900) jj,kk,ll,sinlo,fobs,fcalc,cosaa,sinaa,del
*  435 read(indata,*,end=900) jj,kk,ll,sinlo,fobs,fcalc,cosaa,sinaa,del
  435 read(indata,*,end=900) jj,kk,ll,fobs,wght
      fcalc=fobs
  440 continue
      del=fobs-fcalc
      if(ncode.eq.105) go to 520
      if(ncode.lt.100) go to 450
      fobs=sign(sqrt(abs(fobs)),fobs)
      fcalc=sqrt(fcalc)
      del=fobs-fcalc
  450 go to (460,460,470,480,490,500,510),ncode1
  460 aaa=del*cosaa
      bbb=del*sinaa
      if(ncode1.eq.2) go to 530
      if(fobs)400,400,530
  470 aaa=fobs*cosaa
      bbb=fobs*sinaa
      go to 530
  480 aaa=fcalc*cosaa
      bbb=fcalc*sinaa
      go to 530
  490 aaa=fobs*fobs
      bbb=0.
      go to 530
  500 aaa=fcalc*fcalc
      bbb=0.
      go to 530
  510 aaa=fobs*fobs*fcalc*cosaa
      bbb=fobs*fobs*fcalc*sinaa
      go to 530
  520 aaa=fobs
      bbb=0.
  530 if(aaa)550,540,550
  540 if(bbb)550,400,550
  550 hkl(1)=jj
      hkl(2)=kk
      hkl(3)=ll
      sinl=.5*sqrt(vmv(hkl,bb,hkl))
      if(snlmax)570,570,560
  560 if(sinl.gt.snlmax) go to 400
  570 call reject
      if(nrej)400,580,400
  580 ntotal=ntotal+1
      do 740 n=1,nequiv
      j(n)=m1(n,1)*jj+m2(n,1)*kk+m3(n,1)*ll
      k(n)=m1(n,2)*jj+m2(n,2)*kk+m3(n,2)*ll
      l(n)=m1(n,3)*jj+m2(n,3)*kk+m3(n,3)*ll
      nu=nucalc(j(n)*mtx(n)+k(n)*mty(n)+l(n)*mtz(n))+1
      a(n)=aaa*xsin(nu+3)-bbb*xsin(nu)
      b(n)=bbb*xsin(nu+3)+aaa*xsin(nu)
      if(isst2)600,590,590
  590 fjx=j(n)
      fkx=k(n)
      flx=l(n)
      j(n)=ifixr(u(1,1)*fjx+u(1,2)*fkx+u(1,3)*flx)
      k(n)=ifixr(u(2,1)*fjx+u(2,2)*fkx+u(2,3)*flx)
      l(n)=ifixr(u(3,1)*fjx+u(3,2)*fkx+u(3,3)*flx)
  600 if(norien-10)610,620,630
* 610 call rotate(j(n),k(n))
  610 itemp=j(n)
      j(n)=k(n)
      k(n)=itemp
      go to 640
* 620 call rotate(k(n),l(n))
  620 itemp=k(n)
      k(n)=l(n)
      l(n)=itemp
      go to 640
* 630 call rotate(j(n),l(n))
  630 itemp=j(n)
      j(n)=l(n)
      l(n)=itemp
  640 if(j(n))680,650,710
  650 if(k(n))690,660,710
  660 if(l(n))700,670,710
  670 a(n)=.5*a(n)
      b(n)=.5*b(n)
      go to 710
  680 j(n)=-j(n)
  690 k(n)=-k(n)
  700 l(n)=-l(n)
      b(n)=-b(n)
  710 if(a(n))730,720,730
  720 if(b(n))730,740,730
  730 if(j(n).gt.jmax) jmax=j(n)
      if(k(n).gt.kmax) kmax=k(n)
      if(k(n).lt.kmin) kmin=k(n)
  740 continue
*     do 860 i=1,nequiv
      i=1
 9860 continue
      if(a(i))760,750,760
  750 if(b(i))760,860,760
  760 m=i+1
      if(m.gt.nequiv) go to 800
      do 790 n=m,nequiv
      if(a(n))780,770,780
  770 if(b(n))780,790,780
  780 if(j(i).ne.j(n).or.k(i).ne.k(n).or.l(i).ne.l(n)) go to 790
      a(n)=0.
      b(n)=0.
  790 continue
  800 nexpan=nexpan+1
      nbuff=nbuff+1
      jh(nbuff)=j(i)
      kh(nbuff)=k(i)
      lh(nbuff)=l(i)
      ah(nbuff)=a(i)
      bh(nbuff)=b(i)
      if(nbuff.lt.25) go to 810
*     assign 810 to nzit
      nzit=810
      go to 880
  810 if(nref)860,860,820
  820 if(norien-10)830,840,850
  830 write(iii,1100) k(i),j(i),l(i),a(i),b(i)
      go to 860
  840 write(iii,1100) j(i),l(i),k(i),a(i),b(i)
      go to 860
  850 write(iii,1100) l(i),k(i),j(i),a(i),b(i)
  860 continue
*     end loop 860
      i=i+1
      if (i .le. nequiv) go to 9860
      if(nref)400,400,870
  870 nref=nref-1
      write(iii,1100)
      go to 400
* 880 write(ixx,end=890) ah,bh,jh,kh,lh
  880 write(ixx) ah,bh,jh,kh,lh
      nbuff=0
*     go to nzit,(810,950)
      if (nzit .eq. 810) then
         go to 810
      else if (nzit .eq. 950) then
         go to 950
      end if
  890 write(iii,1070)
      go to 950
  900 write(iii,1080)
  910 if(nbuff)950,950,920
  920 m=nbuff+1
      do 940 i=m,25
      jh(i)=0
      kh(i)=0
      lh(i)=0
      ah(i)=0.
  940 bh(i)=0.
*     assign 950 to nzit
      nzit=950
      go to 880
  950 rewind ixx
      ncd=(jmax+1)*(kmax-kmin+1)*2
      nef=(jmax+1)*ny*2
      if(ntotal)960,960,970
  960 write(iii,1240)
      iend=1
      return
  970 if(nexpan)960,960,980
  980 write(iii,1300) ntotal,nexpan
      write(iii,1310) ncd,nef
      if(ncd+nef.le.nmemmx) return
      write(iii,1320)
      iend=1
      return
      end
      subroutine setu(v,u,aa,bb)
      real v(3,3),        u1(3),u2(3),u3(3),u(3,3),aa(3,3),bb(3,3)
      do 10 i=1,3
      u1(i)=0.
   10 u2(i)=0.
      u1(2)=1.
      u2(3)=1.
      call norm(aa,u1)
      call norm(aa,u2)
      call cross(bb,u1,u2,u3)
      call norm(aa,u3)
      call cross(bb,u3,u1,u2)
      call norm(aa,u2)
      do 20 i=1,3
      u(1,i)=u3(i)
      u(2,i)=u1(i)
   20 u(3,i)=u2(i)
      call mi3(u,v,det)
      return
      end
      subroutine setup
*sun
      character*50 file12
      common/const/iii,in,indata,ivxx,ixx,lpsect,nblock,nequiv,nmemmx,
     anpline,nx,ny,nz,norien,xmin,ymin,zmin,xmax,ymax,zmax,dx,dy,dz,
     baa(3,3),bb(3,3),dcell(9),detu,fs(3,3,24),isst(8),jmax,kmax,kmin,
     cncd,nef,rcell(9),rmax,scale,title(20),ts(3,24),u(3,3),uinv(3,3),
     dvol
      common/rdrt/ncode,iend
      common trgtbl(1001)
*     real*8 arg,darg/6.28318530718d-3/,dpr*4/57.29578/
      double precision arg,darg
      data darg/6.28318530718d-3/,dpr/57.29578/
      data nread/0/
 1000 format(20a4)
corrected on 1988.8.11
c1010 format('9'/'1',20a4)
 1010 format('1',20a4)
 1020 format(8i1,i2,f5.0,e15.6)
 1030 format('0control integers ',8i1,3x'scale=',f5.1,3x'rmax=',e15.6)
 1040 format(6f10.6,3a4)
 1050 format('-',7x'a*',10x'b*',10x'c*',8x'cos alpha*',4x'cos beta*',5x'
     acos gamma*',5x'alpha*',5x'beta*',6x'gamma*'/  '0',3f12.6,3f14.6,3f
     b11.2)
 1060 format('-',9x'a',11x'b',11x'c',7x'cos alpha',5x'cos beta',6x'cos g
     aamma',6x'alpha',6x'beta',7x'gamma'   /'0',3f12.3,3f14.6,3f11.2)
 1070 format('-compute a fourier summation')
 1080 format('0print fourier answers numerically')
 1090 format('0print fourier answers alphamerically')
 1095 format('0save binary unit 13 for use in contour plot routine')
 1100 format('0peak search to be carried out')
 1110 format('0transform unit cell before fourier summation')
 1120 format(3(f15.6,3f3.0))
 1130 format('-no. of equivalent reflections (hkl) is',i3/   '0',15x'tra
     ansformed x',19x'transformed y',19x'transformed z'/)
 1140 format(3(13xf7.4,3f4.0))
      nmemmx=40000
      in=5
      iii=6
      ixx=10
      ivxx=13
      indata=12
      nblock=1000
      npline=88
      lpsect=101
      rewind ixx
      arg=0.d0
      do 10 i=1,1001
      trgtbl(i)=cos(sngl(arg))
   10 arg=arg+darg
      read(in,1000) title
      write(iii,1010) title
      read(in,1020) isst,nequiv,scale,rmax
c-vax-
c-vax-open grid storage and binary reflection input if necessary
c-vax-files if necessary
c-vax-
      if(isst(6).eq.0) go to 5
*     open (unit=12,status='old',disp='keep',recl=64,
*    1 blocksize=644,recordtype='variable',form='unformatted',
*    2 buffercount=1,access='sequential')
*sun
      call getarg(2,file12)
*sun
      open(unit=12,file=file12)
*except sun
*     open (unit=12)
    5 continue
      if(nread.gt.0) go to 9
      if(isst(1).ne.0) go to 6
*     open (unit=13,status='old',disp='keep',recl=100,
*    1 blocksize=3624,recordtype='variable',form='unformatted',
*    2 buffercount=1,access='sequential')
*sun (file to store the result of fourier (d) synthesis)
      open(unit=13,status='scratch')
*except sun
*     open (unit=13)
      go to 8
    6 continue
      if(isst(4).ne.2) go to 7
*     open (unit=13,status='new',disp='keep',recl=100,
*    1 blocksize=3624,recordtype='variable',form='unformatted',
*    2 buffercount=1,access='sequential')
*sun
      open(unit=13,status='scratch')
*except sun
*     open (unit=13)
      go to 8
    7 continue
*     open (unit=13,status='scratch',disp='delete',recl=100,
*    1 blocksize=3624,recordtype='variable',form='unformatted',
*    2 buffercount=1,access='sequential')
*sun
      open(unit=13,status='scratch')
*except sun
*     open (unit=13)
    8 continue
      nread=1
    9 continue
      rewind ivxx
      rewind indata
c-vax-
      write(iii,1030) isst,scale,rmax
      if(isst(6).ne.0) go to 15
      read(in,1040) dcell
      go to 14
*  15 read(indata) (dcell(i),i=1,6)
   15 read(indata,*) (dcell(i),i=1,6)
      do 13 i=7,9
   13 dcell(i)=0.0
*     read(indata) nequiv
      read(indata,*) nequiv
   14 continue
      if(dcell(4).lt.1.) go to 30
      do 20 i=4,6
   20 dcell(i)=cos(dcell(i)/dpr)
   30 call stoaa(dcell,aa)
      call mi3(aa,bb,vol)
      vol=sqrt(vol)
      rcell(1)=sqrt(bb(1,1))
      rcell(2)=sqrt(bb(2,2))
      rcell(3)=sqrt(bb(3,3))
      rcell(4)=bb(2,3)/(rcell(2)*rcell(3))
      rcell(5)=bb(1,3)/(rcell(1)*rcell(3))
      rcell(6)=bb(1,2)/(rcell(1)*rcell(2))
      do 40 i=4,6
      dcell(i+3)=atan2(sqrt(1.-dcell(i)*dcell(i)),dcell(i))*dpr
   40 rcell(i+3)=atan2(sqrt(1.-rcell(i)*rcell(i)),rcell(i))*dpr
      if(dcell(1).ge.1.) go to 60
      vol=1./vol
      do 50 i=1,9
      call rotate(dcell(i),rcell(i))
   50 call rotate(aa(i,1),bb(i,1))
   60 write(iii,1060) dcell
      write(iii,1050) rcell
      write(iii,1130)  nequiv
      if(isst(6).ne.0) go to 65
      read(in,1120)((ts(m,n),(fs(i,m,n),i=1,3),m=1,3),n=1,nequiv)
      go to 64
   65 do 67 ir=1,nequiv
*     read(indata) ((fs(i,j,ir),i=1,3),ts(j,ir),j=1,3)
      read(indata,*) ((fs(i,j,ir),i=1,3),ts(j,ir),j=1,3)
   67 continue
   64 continue
      write(iii,1140)((ts(m,n),(fs(i,m,n),i=1,3),m=1,3),n=1,nequiv)
      if(isst(1))70,80,70
   70 write(iii,1070)
   80 if(isst(2))90,100,90
   90 write(iii,1110)
  100 if(isst(3))110,120,110
  110 write(iii,1080)
  120 if(isst(4).le.0) go to 140
      if(isst(4).eq.1) write(iii,1090)
      if(isst(4).eq.2) write(iii,1095)
  140 if(isst(5))150,160,150
  150 write(iii,1100)
  160 return
      end
      subroutine sig100
      common/const/iii,in,indata,ivxx,ixx,lpsect,nblock,nequiv,nmemmx,
     anpline,nx,ny,nz,norien,xmin,ymin,zmin,xmax,ymax,zmax,dx,dy,dz,
     baa(3,3),bb(3,3),dcell(9),detu,fs(3,3,24),isst(8),jmax,kmax,kmin,
     cncd,nef,rcell(9),rmax,scale,title(20),ts(3,24),u(3,3),uinv(3,3),
     dvol
      integer*2 jh,kh,lh,fill
      common trgtbl(1001),jh(25),kh(25),lh(25),fill,a(25),b(25),locee,
     anj,nk,ns,ykmin,z,r(100),table(40000)
 1000 format('0fourier section',i4)
 1010 format('-rmax=',e13.6//)
      rmax=0.
      nsec=0
      nj=jmax+1
      nk=kmax-kmin+1
      ne=nef/2
      nc=ncd/2
      ns=(nmemmx-nef)/ncd
      ykmin=kmin
      locee=nmemmx-nef+1
*     write(ivxx)nx,ny,nz,norien,xmin,xmax,ymin,ymax,zmin,zmax,dx,dy,dz
      write(ivxx,'(4i5/1p,9g14.6)')
     &nx,ny,nz,norien,xmin,xmax,ymin,ymax,zmin,zmax,dx,dy,dz
      z=zmin
   50 if(ns.gt.nz-nsec) ns=nz-nsec
      do 60 i=1,nmemmx
   60 table(i)=0.
*     assign 80 to nxit
      nxit=80
   70 read(ixx,end=100) a,b,jh,kh,lh
*     do 90 i=1,25
      i=1
 9090 continue
      locc=jh(i)*nk+(kh(i)-kmin)+1
      locd=locc+nc
      zl=lh(i)
      zz=zl*z
      zdz=zl*dz
*     do 90 j=1,ns
      j=1
 9091 continue
      arg=zz
      go to 10000
   80 table(locc)=table(locc)+a(i)*cosarg+b(i)*sinarg
      table(locd)=table(locd)-a(i)*sinarg+b(i)*cosarg
      locc=locc+ncd
      locd=locc+nc
   90 zz=zz+zdz
*     end loop 90
      j=j+1
      if (j .le. ns) go to 9091
*     end loop 90
      i=i+1
      if (i .le. 25) go to 9090
      go to 70
  100 rewind ixx
      locc=1
      locd=locc+nc
*     do 220 i=1,ns
      i=1
 9220 continue
      nsec=nsec+1
      write(iii,1000) nsec
      do 110 j=locee,nmemmx
  110 table(j)=0.
*     assign 120 to nxit
      nxit=120
      locei=locee
*     do 150 j=1,nj
      j=1
 9150 continue
      y=ykmin*ymin
      ydy=ykmin*dy
*     do 140 k=1,nk
      k=1
 9140 continue
      loce=locei
      locf=loce+ne
      yy=y
      arg1=table(locc)
      arg2=table(locd)
*     do 130 l=1,ny
      l=1
 9130 continue
      arg=yy
      go to 10000
  120 table(loce)=table(loce)+arg1*cosarg+arg2*sinarg
      table(locf)=table(locf)-arg1*sinarg+arg2*cosarg
      loce=loce+nj
      locf=loce+ne
  130 yy=yy+ydy
*     end loop 130
      l=l+1
      if (l .le. ny) go to 9130
      y=y+ymin
      ydy=ydy+dy
      locc=locc+1
  140 locd=locc+nc
*     end loop 140
      k=k+1
      if (k .le. nk) go to 9140
  150 locei=locei+1
*     end loop 150
      j=j+1
      if (j .le. nj) go to 9150
      loce=locee
      locf=loce+ne
*     assign 170 to nxit
      nxit=170
*     do 210 j=1,ny
      j=1
 9210 continue
      do 160 k=1,nx
  160 r(k)=0.
      xdx=0.
      x=0.
*     do 190 l=1,nj
      l=1
 9190 continue
      arg1=table(loce)
      arg2=table(locf)
      xx=x
*     do 180 m=1,nx
      m=1
 9180 continue
      arg=xx
      go to 10000
  170 r(m)=r(m)+arg1*cosarg+arg2*sinarg
  180 xx=xx+xdx
*     end loop 180
      m=m+1
      if (m .le. nx) go to 9180
      xdx=xdx+dx
      x=x+xmin
      loce=loce+1
  190 locf=loce+ne
*     end loop 190
      l=l+1
      if (l .le. nj) go to 9190
      do 200 m=1,nx
      if(r(m).gt.rmax) rmax=r(m)
  200 continue
* 210 write(ivxx) (r(m),m=1,nx)
  210 write(ivxx,'(1p,29g14.6)') (r(m),m=1,nx)
*     end loop 210
      j=j+1
      if (j .le. ny) go to 9210
      locc=locc+nc
      locd=locc+nc
  220 z=z+dz
*     end loop 220
      i=i+1
      if (i .le. ns) go to 9220
      if(nsec.lt.nz) go to 50
*     write(ivxx) rmax
      write(ivxx,'(1p,2g14.6)') rmax,2.0*scale/vol
      rewind ivxx
      write(iii,1010) rmax
      return
10000 arg=amod(arg,1.)
      if(arg.lt.0.) arg=arg+1.
      narg1=1000.*arg+1.5
      narg2=narg1+250
      if(narg2.gt.1000) narg2=narg2-1000
      sinarg=-trgtbl(narg2)
      cosarg= trgtbl(narg1)
*     go to nxit,(80,120,170)
      if (nxit .eq. 80) then
         go to 80
      else if (nxit .eq. 120) then
         go to 120
      else if (nxit .eq. 170) then
         go to 170
      end if
      end
      subroutine solve(a,b,n,nfail)
      real*8 a(1),b(1),suma,term,denom
      l=1
      do 60 i=1,n
      imax=i-1
      do 60 j=i,n
      suma=0.d0
      ij=i
      ik=j
      if(imax)30,30,10
   10 ijd=n-1
      do 20 k=1,imax
      suma=suma+a(ij)*a(ik)
      ij=ij+ijd
      ik=ik+ijd
   20 ijd=ijd-1
   30 term=a(l)-suma
      if(j.gt.i) go to 50
      if(term)150,150,40
   40 denom=dsqrt(term)
      a(l)=denom
      go to 60
   50 a(l)=term/denom
   60 l=l+1
      do 90 i=1,n
      suma=0.d0
      ij=i
      ijd=n-1
      imax=i-1
      if(imax)90,90,70
   70 do 80 j=1,imax
      suma=suma+a(ij)*b(j)
      ij=ij+ijd
   80 ijd=ijd-1
   90 b(i)=(b(i)-suma)/a(ij)
      ij=n*(n+1)/2
      do 130 i=1,n
      k=n
      imax=i-1
      suma=0.d0
      if(imax)120,120,100
  100 do 110 j=1,imax
      suma=suma+a(ij)*b(k)
      k=k-1
  110 ij=ij-1
  120 b(k)=(b(k)-suma)/a(ij)
  130 ij=ij-1
      nfail=0
      return
  150 nfail=l
      return
      end
      subroutine trans
      common/const/iii,in,indata,ivxx,ixx,lpsect,nblock,nequiv,nmemmx,
     anpline,nx,ny,nz,norien,xmin,ymin,zmin,xmax,ymax,zmax,dx,dy,dz,
     baa(3,3),bb(3,3),dcell(9),detu,fs(3,3,24),isst(8),jmax,kmax,kmin,
     cncd,nef,rcell(9),rmax,scale,title(20),ts(3,24),u(3,3),uinv(3,3),
     dvol
      real plane(3),cell(3),gnew(3,3),xyzmin(3),xyzmax(3),dxyz(3)
      equivalence (xyzmin(1),xmin),(xyzmax(1),xmax),(dxyz(1),dx)
 1000 format(9f8.4)
 1010 format('-transformation matrix read from cards')
 1020 format(7f10.5)
 1030 format('-transformation matrix defined by the plane'/   '0',10x
     af10.5,' x +',f10.5,' y +',f10.5,' z =',f10.5)
 1040 format('0new axis',i2,' runs from',f10.5,' to',f10.5,' in steps of
     a',f10.5,' angstroms')
 1050 format('0new cell constants are',3f12.3,3f12.5)
 1060 format('0',10x'newa',i1,' =',f12.6,' a1 +',f12.6,' a2 +',f12.6,' a
     a3')
 1070 format('0the determinant of the u matrix is',f15.6)
 1080 format('0the matrix inverse to u is as follows'/ ('0',10x3f15.6))
      if(isst(2)-1)10,10,20
   10 read(in,1000) ((u(i,j),j=1,3),i=1,3)
      write(iii,1010)
      go to 60
   20 read(in,1020) plane,dplane,cell
      write(iii,1030) plane,dplane
      call gp1(plane,dplane,aa,u)
      read(in,1000) xmin,xmax,ymin,ymax,zmin,zmax,dx,dy,dz
      do 50 i=1,3
      write(iii,1040) i,xyzmin(i),xyzmax(i),dxyz(i)
      ddcell=amax1(2.*abs(xyzmin(i)),2.*abs(xyzmax(i)),10.,cell(i))
      u(i,1)=u(i,1)*ddcell
      u(i,2)=u(i,2)*ddcell
      u(i,3)=u(i,3)*ddcell
      xyzmin(i)=xyzmin(i)/ddcell
      xyzmax(i)=xyzmax(i)/ddcell
      dxyz(i)=dxyz(i)/ddcell
      dcell(i)=ddcell
   50 dcell(i+3)=0.
      go to 80
   60 do 70 i=1,3
      do 70 j=1,3
      gnew(i,j)=0.
      do 70 k=1,3
      do 70 kk=1,3
   70 gnew(i,j)=gnew(i,j)+u(i,k)*u(j,kk)*aa(k,kk)
      dcell(1)=sqrt(gnew(1,1))
      dcell(2)=sqrt(gnew(2,2))
      dcell(3)=sqrt(gnew(3,3))
      dcell(6)=gnew(1,2)/(dcell(1)*dcell(2))
      dcell(5)=gnew(1,3)/(dcell(1)*dcell(3))
      dcell(4)=gnew(2,3)/(dcell(2)*dcell(3))
   80 write(iii,1050) (dcell(i),i=1,6)
      write(iii,1060) (i,(u(i,j),j=1,3),i=1,3)
      call mi3(u,uinv,detu)
      write(iii,1070) detu
      write(iii,1080) ((uinv(i,j),j=1,3),i=1,3)
      return
      end
      function vmv(x,a,y)
      real x(3),a(3,3),y(3)
      vmv=0.
      do 10 i=1,3
   10 vmv=vmv+x(i)*(a(i,1)*y(1)+a(i,2)*y(2)+a(i,3)*y(3))
      return
      end
      subroutine reject
      common/rej/aaa,bbb,cosaa,del,fcalc,fobs,jj,kk,ll,nrej,sinaa
      nrej=0
      return
      end

************************************************************************

      subroutine plfmap(ivxx,dcell,zmin,zmax,dz,step,fmag,x0,y0)
*     plot fourier map
*     cell edge of the y-axis and interval between two maps
*facom
*     parameter (edge=18.0,space=7.0)
*sun
*     parameter (edge=18.0,space=1.5)
*sun
      parameter (edge=18.0)
*facom
*     character value*5
*sun
      character value*5,xaxis*1,yaxis*1,zaxis*1
      real hh(256,256),dcell(*)
*     data xlim /space/
*     a function to rotate the figure in a 180-degree arc
      yy(t)=edge*sinphi-t

      space=x0
      xlim=x0
*     at first, rmax and scale factor to convert rmax into ed are read
      rewind ivxx
      read(ivxx,'(4i5/9f14.0)')
     &nx,ny,nz,norien,xmin,xmax,ymin,ymax,zmin,zmax,dx,dy,dz
      do ij=1,nz
         do i=1,ny
            read(ivxx,*) (temp,j=1,nx)
         end do
      end do
      read(ivxx,*) rmax,fac
      rmax=fac*rmax
      if (step .eq. 0.0) then
         step = rmax/float(15)
      end if
      rewind ivxx
      read(ivxx,'()')
      read(ivxx,'()')

      do ij=1,nz
         rmin=0.0
         do i=1,ny
            read(ivxx,*) (hh(i,j),j=1,nx)
            do j=1,nx
               hh(i,j)=hh(i,j)*fac
               if (hh(i,j) .lt. rmin) rmin=hh(i,j)
            end do
         end do

*     dcell(1): a, dcell(2): b, dcell(3): c,
*     dcell(4): cos(alpha), dcell(5): cos(beta), dcell(6): cos(gamma)
         if (norien .eq. 1) then
*     edge*b/a cm (nx data)
*     c------> b
*     | gamma
*     edge cm  |
*     (ny data) v
*     a
            cosphi=dcell(6)
            factx=dcell(2)/dcell(1)
*     facom
*     ix=136
*     iy=135
*     iz=184
*     sun
            xaxis='b'
            yaxis='a'
            zaxis='z'
         else if (norien .eq. 10) then
*     edge*a/c cm (nx data)
*     b------> a
*     | beta
*     edge cm  |
*     (ny data) v
*                c
            cosphi=dcell(5)
            factx=dcell(1)/dcell(3)
*     facom
*     ix=135
*     iy=137
*     iz=183
*     sun
            xaxis='a'
            yaxis='c'
            zaxis='y'
         else
*     edge*c/b cm (nx data)
*     a------> c
*     | alpha
*     edge cm  |
*     (ny data) v
*     b
            cosphi=dcell(4)
            factx=dcell(3)/dcell(2)
*     facom
*     ix=137
*     iy=136
*     iz=135
*     sun
            xaxis='c'
            yaxis='b'
            zaxis='x'
         end if
         sinphi=sin(acos(cosphi))
         if (edge*cosphi .lt. 0.0) then
            if (ij .eq. 1) then
*     sun
*     call plots(xlim+abs(edge*cosphi),3.0,4)
               call plots(xlim+abs(edge*cosphi),y0,4)
            else
*     call plot(xlim+abs(edge*cosphi),0.0,-3)
               call plot(xlim+abs(edge*cosphi),0.0,-3)
            end if
         else
            if (ij .eq. 1) then
*     sun
*     call plots(xlim,3.0,4)
               call plots(xlim,y0,4)
            else
               call plot(xlim,0.0,-3)
            end if
         end if
*     sun
*     call factor(0.76)
         call factor(fmag)
*     sun
         call newpen(2)
*     plot the unit cell edge
         call plot(0.0,yy(0.0),3)
         call plot(edge*factx*cosphi,yy(edge*sinphi),2)
         call plot(edge*factx*(1.0+cosphi),yy(edge*sinphi),2)
         call plot(edge*factx,yy(0.0),2)
         call plot(0.0,yy(0.0),2)
         
         xlim=space+max(edge*factx*(1.0+cosphi),edge*factx)
         call symbol(-0.5,yy(0.0)+0.2,0.5,'0',0.0,1)
         call symbol(edge*factx*cosphi-0.56,yy(edge*sinphi)-0.56,0.5,
*     facom
*     &  iy,0.0,0)
*     sun
     &        yaxis,0.0,1)
*     facom
*     call symbol(edge*factx+0.3,yy(0.0)+0.2,0.5,ix,0.0,0)
*     sun
         call symbol(edge*factx+0.3,yy(0.0)+0.2,0.5,xaxis,0.0,1)
         
         write(value,'(f5.1)') step
         call symbol(1.0,yy(0.0)+3.5,0.4,'delta = '//value,0.0,13)
         write(value,'(f5.3)') zmin
*     facom
*     call symbol(1.0,yy(0.0)+2.3,0.4,iz,0.0,0)
*     sun
         call symbol(1.0,yy(0.0)+2.3,0.4,zaxis,0.0,1)
         call symbol(1.6,yy(0.0)+2.3,0.4,' = '//value,0.0,8)
         minus=rmin/step
*     p1: step in cm between two points for the x axis
         p1=edge/float(nx-1)
*     p2: step in cm between two points for the y axis
         p2=edge/float(ny-1)
         do h = minus*step, rmax, step
*     the orger of p1 and p2 is reversed (x and y coordinates
*     are exchanged in contpl
            call contpl(hh,h,1,ny,1,nx,p2,p1,cosphi,sinphi,factx)
         end do
      end do
      call plote(' ')
    9 close(unit=ivxx)
      end

************************************************************************

c s.contpl : sub to contour plot *********************************
c  contpl(hh,h,is,ie,js,je,fx,fy,cosphi,sinphi,factx)            *
c    *subroutine to plot contour line of height h                *
c     within (is-ie),(js-je) of 2d array hh(i,j)                 *
c     fx: increment of x in cm per data                          *
c     fy: increment of y in cm per data                          *
c     the above fx and fy values are evaluated by setting        *
c     the cell edges of the x and y axes to be edge cm.          *
c     x and y coordinates are adjusted using cosphi, sinphi,     *
c     and factx in this subroutine.                              *
c    *contour points: got by linear interpolation of adjacent    *
c     lattice points (thus, at most 1 contour point between      *
c     adjacent lattice points, and 0, 1 or at most 2 contour     *
c     lines in a unit cell of the lattice)                       *
c    *if 2 contour points on a unit cell boundary, these are     *
c     connected uncoditionally                                   *
c    *if 4 contour points on a unit cell boundary (thus, 2       *
c     contour lines in a cell), point connection be determined   *
c     on condition that line be less curved                      *
c    *to do above (check curvature), need 1 former point,        *
c     thus, 1st point to start a contour line be chosen among    *
c     2-contour-point cells                                      *
c    *contour lines are classified into 2 types                  *
c     1) line(s) running from boundary to boundary               *
c     2) loop(s) self-closed                                     *
c---- arrays ----------------------------------------------------*
c   (a,ia): coordinate data of contour points                    *
c           (x,iy): for y-axes data (m points)                   *
c           (y,ix): for x-axes data (n-m points)                 *
c   (x,y) : coordinate data for 'line' routine                   *
c---- control indices -------------------------------------------*
c    m  : number of y-axes data           (a,ia array)           *
c    n  : number of total data (y + x)    (a,ia array)           *
c    im : start of 'live' y-axes data     (a,ia array)           *
c    in : end of 'live' x-axes data       (a,ia array)           *
c    imm: temporary 'im'                  (a,ia array)           *
c    inn: tnmporary 'in'                  (a,ia array)           *
c    ist: start point of line             (a,ia array)           *
c    ib : boundary index                                         *
c    np : number of 'next' points                                *
c    j  : index of line to be plotted     (x,y array)            *
c---- co-subroutines --------------------------------------------*
c   contpn(h,is,ie,js,je)                                       *
c       find contour points of height h within (is-ie),(js-je)   *
c       set (a,ia) array and m,n                                 *
c   ib=bndry(i,is,ie,js,je)  (function)                          *
c       if i-th point is not on boundary, ib=0                   *
c       if i is on upper- or left- boundary, ib= 1               *
c       if i is on lower- or right-boundary, ib=-1               *
c   exchng(i,im,in,j,fx,fy)                                      *
c       if(j.eq.-1), only exchange                               *
c       if(j.le.-2), not exchange, j=-j                          *
c       if(j.ne.-1), j=j+1, set x(j)=fx*(x-coordinate of i) &    *
c                               y(j)=fy*(y-coordinate of i)      *
c       if(i.le.m), exchange im and i, set i=im, im=im+1         *
c       if(i.gt.m), exchange i and in, set i=in, in=in-1         *
c   search(ib,i0,i1,im,in,np)                                    *
c       search (i0)->(i1)->'next'? among im-in                   *
c       if(i0=0), get search direction from ib                   *
c       if(i0.ne.0), ib: not used                                *
c       np=number of found 'next' points                         *
c       if(i0.ge.1), i0=optimal 'next' among np points           *
c       if(np.ge.1), set i0=i1, i1='next'                        *
c    line(x,y,j,inc,ltp,iem) : plotter routine 'line'            *
c*****************************************************************
c
      subroutine contpl(hh,h,is,ie,js,je,fx,fy,cosphi,sinphi,factx)
*     iis is used because is is a variable in this subroutine
      parameter (iis=2,ndata=200)
      real hh(256,256),p(iis,ndata)
      common /cont/ ch(200),x(500),y(500),a(1000),ia(1000),m,n
*     a function to rotate the figure in a 180-degree arc
      parameter (edge=18.0)
      yy(t)=edge*sinphi-t

c *** find points to form contour line of height h
      call contpn(hh,h,is,ie,js,je)
      if(n.le.0) return
      if(n.ge.1001) return
      im=1
      in=n
      ib=1
c *** select first point to start contour line
   10 continue
      j=-1
      imm=im
      inn=in
   20 continue
      do 30 i1=imm,inn
      ib=bndry(i1,is,ie,js,je)
      if(ib.ne.0) goto 40
   30 continue
      i1=imm
   40 continue
      call exchng(i1,imm,inn,j,fx,fy)
      i0=0
c *** search next (second) point
      call search(ib,i0,i1,im,in,np)
      if(np.gt.1) then
       goto 20
      else
       j=0
      endif
c *** evaluate first point coordinate
      call exchng(i0,im,in,j,fx,fy)
c *** store first point location
      ist=i0
   50 continue
c *** evaluate next point coordinate
      call exchng(i1,im,in,j,fx,fy)
c *** check if terminal point
      ib=bndry(i1,is,ie,js,je)
      if(im.gt.in) goto 60
      if(ib.ne.0) goto 70
c *** search next point
      call search(ib,i0,i1,im,in,np)
      if(np.eq.0) goto 60
      goto 50
   60 continue
c *** check if terminal point is connected to first point
      call search(ib,i0,i1,ist,ist,np)
      if(np.eq.1) j=-j
      if(np.eq.1) call exchng(i1,im,in,j,fx,fy)
   70 continue

c *** plot found contour line
      do 80 i=1,j
*        x and y coordinates are exchanged in this routine
*        cf. the hitac note
         temp1=(y(i)+x(i)*cosphi)*factx
         temp2=x(i)*sinphi
*        x(i)=temp1
*        y(i)=yy(temp2)
         p(1,i)=temp1
         p(2,i)=yy(temp2)
   80 continue
      call smooth(p,j,x,y,npoint)
      call plot(x(1),y(1),3)
      if (h .gt. 0.0 .or. abs(h) .lt. 0.0015) then
         do 85 i=2,npoint
            call plot(x(i),y(i),2)
   85    continue
      else
*        plot minus contours
         k=2
*        remainder of the previous plot
         rem=0.0
         do 90 i=2,npoint
*           distance between the previous and present points
            delta = sqrt( (x(i)-x(i-1))**2 + (y(i)-y(i-1))**2 )
*           plot the remainder x(i-1) --> x1, y(i-1) --> y1
            if (delta .lt. rem) then
               call plot(x(i),y(i),k)
               rem=rem-delta
               go to 90
            end if
            x1=x(i-1)+rem*(x(i)-x(i-1))/delta
            y1=y(i-1)+rem*(y(i)-y(i-1))/delta
            if (i .ne. 2) then
               call plot(x1,y1,k)
               if (k .eq. 3) then
                  k=2
               else
                  k=3
               end if
            end if
            delta = sqrt( (x(i)-x1)**2 + (y(i)-y1)**2 )
*           step = 0.1 cm
            n=delta/0.1
            if (n .eq. 0) then
               call plot(x(i),y(i),k)
               rem=0.1-delta
            else
               deltax=0.1*(x(i)-x1)/delta
               deltay=0.1*(y(i)-y1)/delta
               do 87 ii=1,n
                  call plot(x1+ii*deltax,y1+ii*deltay,k)
                  if (k .eq. 3) then
                     k=2
                  else
                     k=3
                  end if
   87          continue
*              go to the last point
               call plot(x(i),y(i),k)
               rem=0.1-mod(delta,0.1)
            end if
   90    continue
      end if
c *** if data left, recycle process to find next contour line
      if(im.lt.in) goto 10
      end

************************************************************************

      subroutine smooth(p,n,x,y,npoint)
      parameter (ndata=200,is=2,ntotal=(ndata-1)*10+1)
      real p(is,ndata),rslt(is,ntotal),x(*),y(*)

      iz=3
      call spline(p,n,iz,rslt,npoint)
      do 10 i=1,npoint
         x(i)=rslt(1,i)
         y(i)=rslt(2,i)
   10 continue
      end

************************************************************************

      subroutine spline(p,n,iz,rslt,npoint)
**    input data
*             p: coordinates of points
*             n: number of data
*            iz: number of interpolated points
**    output data
*          rslt: coordinates of total points
*        npoint: number of total points

      parameter (ndata=200,is=2,ntotal=(ndata-1)*10+1)
      real p(is,ndata),rslt(is,ntotal),pi(is),pe(is)
      common /spl1/ a(ndata,3),b(is,ndata),u(is,ndata),xl(ndata)

*     corrected (iz in the original program = number of interpolated
*     points + 1)
      iz2=iz+1
      ic1=1
      ic2=1
*     pi and pe is not used in the present program because ic1=ic2=1
*     input pi here if ic1=2
*     input pe here if ic2=2
      call endpnt(p,n,ic1,ic2,pi,pe)
      call gauss(p,n)
      call curgen(p,n,iz2,rslt)
      npoint=(n-1)*iz2+1
      end

************************************************************************

      subroutine endpnt(p,n,ic1,ic2,pi,pe)
      parameter (ndata=200,is=2,ntotal=(ndata-1)*10+1)
      real p(is,ndata),pi(is),pe(is)
      common /spl1/ a(ndata,3),b(is,ndata),u(is,ndata),xl(ndata)

      if (ic1 .eq. 1) then
         a(1,2)=1.0
         a(1,3)=0.5
      else
         a(1,2)=1.0
         a(1,3)=0.0
         do 10 k=1,is
            b(k,1)=pi(k)
            u(k,1)=pi(k)
   10    continue
      end if

      do 30 k=1,n-1
         xd=0.0
         do 20 j=1,is
            xd=xd+(p(j,k+1)-p(j,k))*(p(j,k+1)-p(j,k))
   20    continue
         xl(k)=sqrt(xd)
   30 continue
      if (ic1 .ne. 2) then
         do 40 k=1,is
            b(k,1)=(3.0/(2.0*xl(1)))*(p(k,2)-p(k,1))
   40    continue
      end if
      if (ic2 .eq. 1) then
         a(n,1)=1.0
         a(n,2)=2.0
         do 50 k=1,is
            b(k,n)=(3.0/xl(n-1))*(p(k,n)-p(k,n-1))
   50    continue
      else
         a(n,1)=0.0
         a(n,2)=1.0
         do 60 k=1,is
            b(k,n)=pe(k)
            u(k,n)=pe(k)
   60    continue
      end if
      end

************************************************************************

      subroutine gauss(p,n)
      parameter (ndata=200,is=2,ntotal=(ndata-1)*10+1)
      real p(is,ndata)
      common /spl1/ a(ndata,3),b(is,ndata),u(is,ndata),xl(ndata)

      do 20 j=2,n-1
         a(j,1)=xl(j)
         a(j,2)=2.0*(xl(j)+xl(j-1))
         a(j,3)=xl(j-1)
         do 10 k=1,is
            b(k,j)=(3.0*(xl(j-1)*xl(j-1)*(p(k,j+1)-p(k,j)))
     &      +3.0*xl(j)*xl(j)*(p(k,j)-p(k,j-1)))/(xl(j)*xl(j-1))
   10    continue
   20 continue

      do 50 i=2,n
         d=a(i-1,2)/a(i,1)
         a(i,1)=0.0
         a(i,2)=a(i,2)*d-a(i-1,3)
         a(i,3)=a(i,3)*d
         do 30 k=1,is
            b(k,i)=b(k,i)*d-b(k,i-1)
   30    continue
         q=a(i,2)
         a(i,2)=1.0
         a(i,3)=a(i,3)/q
         do 40 k=1,is
            b(k,i)=b(k,i)/q
   40    continue
   50 continue
      do 70 k=1,is
         u(k,n)=b(k,n)
         do 60 j=1,n-1
            u(k,n-j)=b(k,n-j)-a(n-j,3)*u(k,n+1-j)
   60    continue
   70 continue
      end

************************************************************************

      subroutine curgen(p,n,iz,rslt)
      parameter (ndata=200,is=2,ntotal=(ndata-1)*10+1)
      real p(is,ndata),rslt(is,ntotal),f(4,is)
      common /spl1/ a(ndata,3),b(is,ndata),u(is,ndata),xl(ndata)

      i=1
      do 40 j=1,n-1
         do 10 k=1,is
            f(1,k)=p(k,j)
            f(2,k)=u(k,j)
            f(3,k)=(3.0/(xl(j)*xl(j)))*(p(k,j+1)-p(k,j))
     &      -(1.0/xl(j))*(u(k,j+1)+2.0*u(k,j))
            f(4,k)=(-2.0/(xl(j)*xl(j)*xl(j)))*(p(k,j+1)-p(k,j))
     &      +(1.0/(xl(j)*xl(j)))*(u(k,j+1)+u(k,j))
   10    continue
         t=0.0
         do 30 l=1,iz
            do 20 k=1,is
               rslt(k,i)=((f(4,k)*t+f(3,k))*t+f(2,k))*t+f(1,k)
   20       continue
            i=i+1
            t=t+xl(j)/iz
   30    continue
   40 continue
      do 50 k=1,is
         rslt(k,i)=p(k,n)
   50 continue
      end

************************************************************************

c s.contpn: find contour points (max:225x73)
c
c     (a,ia): coordinate data of contour points
c             (x,iy): for y-axes data (m points)
c             (y,ix): for x-axes data (n-m points)
c
      subroutine contpn(hh,h,i1,i2,j1,j2)
      real hh(256,256)
      common /cont/ ch(200),x(500),y(500),a(1000),ia(1000),m,n
*     common /origin/i0,j0
*     set the origin (1988.7.1)
      data i0,j0/0,0/

      m=0
      do 10 j=j1-j0,j2-j0
      do 10 i=i1-i0,i2-i0-1
      if((hh(i,j)-h)*(hh(i+1,j)-h).gt.0.) goto 10
      if(hh(i,j).ge.h.and.hh(i+1,j).ge.h) goto 10
      m=m+1
      d=(hh(i,j)-h)/(hh(i,j)-hh(i+1,j))
      if(d.lt.0.01) d=0.01
      if(d.gt.0.99) d=0.99
*     a(m)=i+i0+d
      a(m)=float(i)+float(i0)+d
      ia(m)=j+j0
c  20 continue
   10 continue
      n=m
      do 40 i=i1-i0,i2-i0
      do 40 j=j1-j0,j2-j0-1
      if((hh(i,j)-h)*(hh(i,j+1)-h).gt.0.) goto 40
      if(hh(i,j).ge.h.and.hh(i,j+1).ge.h) goto 40
      n=n+1
      if(n.ge.1001) goto 90
      d=(hh(i,j)-h)/(hh(i,j)-hh(i,j+1))
      if(d.lt.0.01) d=0.01
      if(d.gt.0.99) d=0.99
      a(n)=float(j)+float(j0)+d
      ia(n)=i+i0
c  50 continue
   40 continue
*     display(10,1010,line=14) h,i1,i2,j1,j2,m,n
      write(6,1010) h,i1,i2,j1,j2,m,n
 1010 format(' h=',f7.1,' (',2i4,') (',2i4,') m=',i4,' n=',i4)
      return
*  90 display(10,1020,line=14) h,i1,i2,j1,j2
   90 write(6,1020) h,i1,i2,j1,j2
 1020 format(' h=',f7.1,' (',2i4,')  (',2i4,') overflow')
      return
      end

************************************************************************

c s.bndry : support contplt routine
c     check if boundary point
      function bndry(i,is,ie,js,je)
      common /cont/ ch(200),x(500),y(500),a(1000),ia(1000),m,n
      bndry=0
      if(i.le.m) then
      if(ia(i).eq.js) bndry=1
      if(ia(i).eq.je) bndry=-1
      else
      if(ia(i).eq.is) bndry=1
      if(ia(i).eq.ie) bndry=-1
      endif
      return
      end

************************************************************************

c s.exchng : support contplt routine
c     replace data in (a,ia) array for contour plot
c
      subroutine exchng(i,im,in,j,fx,fy)
      common /cont/ ch(200),x(500),y(500),a(1000),ia(1000),m,n
      if(j.eq.-1) goto 10
      ib=1
      if(j.le.-2) then
      ib=-1
      j=-j
      endif
      j=j+1
      if(i.le.m) then
      x(j)=(a(i)-1.)*fx
      y(j)=(ia(i)-1)*fy
*     write(6,'(4f6.2,2f8.5)') x(j),y(j),a(i),float(ia(i)),fx,fy
      else
      x(j)=(ia(i)-1)*fx
      y(j)=(a(i)-1.)*fy
*     write(6,'(4f6.2,2f8.5)') x(j),y(j),float(ia(i)),a(i),fx,fy
      endif
      if(ib.eq.-1) return
   10 continue
      if(i.le.m) ib=im
      if(i.gt.m) ib=in
      buf=a(ib)
      a(ib)=a(i)
      a(i)=buf
      ibuf=ia(ib)
      ia(ib)=ia(i)
      ia(i)=ibuf
      i=ib
      if(i.le.m) im=im+1
      if(i.gt.m) in=in-1
      return
      end

************************************************************************

c s.search : support contplt routine
c     search 'next' point
c
      subroutine search(ib,i0,i1,im,in,np)
      common /cont/ ch(200),x(500),y(500),a(1000),ia(1000),m,n
      dimension ik(3)
      ixy1=a(i1)
      iyx1=ia(i1)
      if(i0.le.0) goto 10
      if(i0.le.m) then
       x0=a(i0)
       ix0=x0
       iy0=ia(i0)
       y0=iy0
      else
       ix0=ia(i0)
       x0=ix0
       y0=a(i0)
       iy0=y0
      endif
      if(i1.le.m) then
       ib=iyx1-iy0
       x1=a(i1)
       y1=iyx1
      else
       ib=iyx1-ix0
       x1=iyx1
       y1=a(i1)
      endif
   10 continue
      if(ib.le.0) ib=-1
      if(ib.gt.0) ib=0
      k=0
      do 20 i=im,in
      if(i.eq.i1) goto 20
      if(i1.le.m.and.i.le.m) goto 20
      if(i1.gt.m.and.i.gt.m) goto 20
      if(ifix(a(i)).ne.iyx1+ib) goto 20
      if(.not.(ia(i).eq.ixy1.or.ia(i).eq.ixy1+1)) goto 20
      k=k+1
      ik(k)=i
   20 continue
      if(ib.eq.0) ib=1
      do 30 i=im,in
      if(i1.le.m.and.i.gt.m) goto 30
      if(i1.gt.m.and.i.le.m) goto 30
      if(ia(i).ne.iyx1+ib) goto 30
      if(ifix(a(i)).ne.ixy1) goto 30
      k=k+1
      ik(k)=i
   30 continue
      np=k
      if(np.eq.0) return
      if(np.eq.1) then
       i0=i1
       i1=ik(1)
       return
      endif
      d1=(x1-x0)**2+(y1-y0)**2
      tmin=10.
      do 40 k=1,np
      i=ik(k)
      if(i.le.m) then
       if(i1.le.m) goto 40
       x2=a(i)
       y2=ia(i)
      else
       if(i1.gt.m) goto 40
       x2=ia(i)
       y2=a(i)
      endif
      d=(x2-x1)**2+(y2-y1)**2
      d2=(x2-x0)**2+(y2-y0)**2
      t=(d1+d-d2)/sqrt(d*d1)
      if(t.ge.tmin) goto 40
       imin=i
       tmin=t
   40 continue
   50 continue
      i0=i1
      i1=imin
      return
      end
