c
c
c
c                             fourier map
c
c     data cards
c     (0) file names 
c         flnm1 :  file name of Fobs (/temp/work1)          (a)
c         flnm2 :  file name of Fcal (/temp/work2)          (a)
c         flnm3 :  file name of work file (/temp/work3)     (a)
c     (1) title card
c     (2) lattice constants   a,b,c,cosa,cosb,cosc
c     (3) lgr: laue group: m3m,m3,4/mmm,4/m,mmm,2/m,-1,6/mmm,6/m,-3/m,-31
c                laue group (number of equivalent positions)
c            m3m(48),m3(24),4/mmm(16),4/m(8),mmm(8),2/m(4),-1(2)
c                   6/mmm(24),6/m(12),-3/m(12),-31(6)
c         when lgr=2/m,(h2>=0 or h2<=0) and (h3>=0 or h3<=0) are assumed
c         when lgr=-1, h3>=0 or h3<=0 is assumed
c
c     (4) ndm,nsymo,icent,ige,iskip,nextnc
c         if centrosymmetric icent=1, if generating element ige=1
c                iskip and nextnc should be zero
c     (5) k (a*, b* c* components of wavevector), icorc, ndiv              (*)
c             icorc=ndiv=0
c     (6) symmetry operatores in modulated structure and if ige=1 order
c            in the format of I.T. x,y,z,t,u,v etc
c     (7) reflection selection card ng,
c         ng=0 all reflections are included
c         ng>0 give h4, (h5,h6 for 2d and 3d) specifying reflection
c                groups in (8) else skip (8)
c     (8)       h3+i
c     (9) is,jbcq,irs,dmgn 
c         is: no. of total reflections
c         jbc: kind of map
c         (  this program only write a plane normal to a*, b* or c*.
c              to write arbitrary plane, give jbc<0 and 
c              specify transformation matrix (9') which defines
c                                   new a*,b*,c* from old ones.)
c              iabs(jbc)=1  fourier map                      
c              iabs(jbc)=2  fc fourier map                   
c              iabs(jbc)=3  difference fourier map           
c              iabs(jbc)=4  patterson map                    
c              iabs(jbc)=5  fc patterson map                 
c         irs(i): maximum miller indices to be included
c         dmgn: magnification for electron density
c                    (for new indices if jbc<0)
c              default iw=0,jbc=1,irs=24,24,24,10,10,10, mgnd=1.
c              **if jbc>0 skip (9')**
c     (9') transformation matrix for miller index itr(6,6) (18i3)
c              which is equivalent to transformation matrix for
c              unit vectors in direct space
c     (10) iax: selection of axes (iax(1)-iax(6))
c          write (electron) density in iax(1)-iax(2) plane
c     (11) xs:starting coordinate  (xs(1)-xs(6))
c           (coordinates of the map origin in the new coordinate system
c            specified at (10))
c     (12) hmw,kmw,iwmlp
c          hmw, kmw: number of points for 1-st and 2-nd axes
c               (these sould be the power of 2: 32,64,128 etc.)
c          iwmlp: 1 output map to lp
c     (13) ns: number of sheets
c     (14) xi:intervals for third to sixth coordinates (xi(1)-xi(4))
c     (15) hm: maximum miller indices of data used  (hm(i)-hm(6))
c                      default 24,24,24,10,10,10
c     (16) f000,ex1,ex2,icycle
c            f000: fc at the origin
c            ex1,ex2:  1+arctan(ex2(d(x,y)*v/(f000*ex1)-1))/(pai/2)
c            icycle: number of iterations
c          *********     limitting conditions   **********
c          *               hmw,kmw: power of 2           *
c          *               hmw*kmw<=256*128              *
c          *               hmw<=512 and kmw<=512         *
c          ***********************************************
c             data for plotter
c     (17) ax,bx,coscx (length of axes in cm and cos(angle))
c     (18) ldev,iw,ndiv,ncopy,amgn 
c         iw=1 output calculated x,y coordinates on contour line
c         ndiv: number of divisions   (in each divisions
c                    the same interval is used)   (see (19)) 
c         ncopy: number of copys
c         amgn:  magnification for map, title, and shift
c               default iw=0,ndiv=1,ncopy=1,amgn=1.
c     (19) hmin,div,lf
c         hmin: minimum hight (density) in the division
c         div : interval of hight
c         lf  : number of contour lines
c            ****** repeat (19) ndiv times *****
c     (20) shftxb,shftyb,shftxa,shftya
c         shifts before and after each copy
c     (21) iwtitl,wts,angl
c         if iwtitl=1, title is written
c         wts size of letter in cm, angle is the angle
c                     from the x axis in degree
c
      implicit integer (h)
      dimension irs(6)
      real dmgn
      common /const/ pai2,is,dmgn,irs
      common /islct/ hd(3),h4(3,40),nslct
      common /cdim/ idm,nde
      character*80 title
      common /ctitle/ title
      common /cjbc/ jbc,xs(6),iax(6)
c      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      common /cwght/ iwg
      common /cwflag/ iwflag(6)
      common /ctr/ itr(6,6)
      integer hm
      common /chkln/ iex(6),hm(6)
      real xi(4)
      complex ahkl(128,128),bhkl(128,128)
      common /cabxy/ ax,bx,coscx,sincx,irl
      integer wtitl
      common /name/ shftxb,shftyb,shftxa,shftya,wtitl,wts,angl
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      real a(2000),b(2000),hmin(10),div(10)
      integer lf(10),isk(1,48)
      character*80 flnm3, flnm4, flnm5
      character*5 lgrp(11),lgr
      data lgrp/'m3m','m3','4/mmm','4/m','mmm','2/m','-1',
     *           '6/mmm','6/m','-3/m','-31'/
      data zmtrx /1,2,3,4,5,6,1,2,3,4,5,6,1,2,3,4,5,6/
      data nsub /1/

      call setinp(5)
      call setout(6)
      call setskp(1)
      read(5,'(a)') flnm3
      read(5,'(a)') flnm4
      read(5,'(a)') flnm5
      write(6,'(1h ,a)') flnm3
      write(6,'(1h ,a)') flnm4
      write(6,'(1h ,a)') flnm5
      open(unit=91,file=flnm3,access='direct',recl=1200)
      open(unit=92,file=flnm4,access='direct',recl=800)
      open(unit=93,file=flnm5,access='direct',recl=2052)
      pai2=6.28318
      call rdlc
      call getgij(zmtrx,nsub)
      v=gabx(1,1)*gabx(2,2)*gabx(3,3)
c      read(5,'(a)') lgr
      call freadc('lgr=',1,lgr,1)
      write(6,*) 'lgr=',lgr
      iwg=0
      do  310 i=1,11
      if(lgr.eq.lgrp(i)) then
          iwg=i
      end if
 310  continue
      if(iwg.eq.0) call quit('lgr is wrong')
      na=1
      call rdsymo(na,isk)
c      read(5,120) nslct,((h4(i,j),i=1,nde),j=1,nslct)
      call freadi('ng=',1,nslct,1)
      do 211 j=1,nslct
      call freadi('h3+i=',nde,h4(1,j),1)
 211  continue
      write(6,220) nslct,((h4(i,j),i=1,nde),j=1,nslct)
      if(nde.ne.3) then
      j=nde+1
      do 212 k=1,nslct
      do 212 i=j,3
 212  h4(i,k)=0
      end if
c      read(5,103) is,jbc,irs,dmgn
      call freadi('is=',1,is,1)
      call freadi('jbc=',1,jbc,0)
      call freadi('irs=',6,irs,0)
      call freadr('dmgn=',1,dmgn,0)
      if(jbc.eq.0) jbc=1
      do 500 k=1,6
          if(irs(k).ne.0) go to 501
 500  continue
      do 502 k=1,3
          irs(k)=24
          irs(k+3)=10
 502  continue
 501  continue
      if(dmgn.eq.0.) dmgn=1.
      write(6,228) is,jbc,irs,dmgn
      if(jbc.lt.0) read(5,105) ((itr(i,j),j=1,6),i=1,6)
      if(jbc.lt.0) write(6,202) ((itr(i,j),j=1,6),i=1,6)
c      read(5,100) iax
      call freadi('iax=',6,iax,1)
c      read(5,104) xs
      call freadr('xs=',6,xs,1)
c      read(5,101) hmw,kmw,iwmlp
      call freadi('hmw=',1,hmw,1)
      call freadi('kmw=',1,kmw,0)
      call freadi('iwmlp=',1,iwmlp,0)
      write(6,221) iax,xs,hmw,kmw,iwmlp
      lmw=1
      lw=1
c      read(5,100) ns
      call freadi('ns=',1,ns,1)
c      read(5,104) xi
      call freadr('xi=',4,xi,1)
c      read(5,106) hm
      call freadi('hm=',6,hm,1)
      do 21 i=1,6
      if(hm(i).ne.0) go to 20
 21   continue
      do 22 i=1,3
          hm(i)=24
          hm(i+3)=10
 22   continue
 20   continue
      write(6,222) ns,xi,hm
      iex(6)=1
      do 24 i=1,5
      j=6-i
 24   iex(j)=iex(j+1)*(hm(j+1)*2+1)
c      read(5,107) f000,ex1,ex2,icycle
      call freadr('f000=',1,f000,1)
      call freadr('ex1=',1,ex1,0)
      call freadr('ex2=',1,ex2,0)
      call freadi('icycle=',1,icycle,0)
      write(6,203) f000,ex1,ex2,icycle
c      read(5,111) ax,bx,coscx
      call freadr('ax=',1,ax,1)
      call freadr('bx=',1,bx,0)
      call freadr('coscx=',1,coscx,0)
      sincx=sqrt(1-coscx**2)
      write(6,223) ax,bx,coscx
c      read(5,110) ldev,iw,ndiv,ncopy,amgn
      call freadi('ldev=',1,ldev,1)
      call freadi('iw=',1,iw,0)
      call freadi('ndiv=',1,ndev,0)
      call freadi('ncopy=',1,ncopy,0)
      call freadr('amgn=',1,amgn,0)
      if(ndiv.eq.0) ndiv=1
      if(ncopy.eq.0) ncopy=1
      if(amgn.eq.0.) amgn=1.
      write(6,224) ldev,iw,ndiv,ncopy,amgn
c      read(5,113) (hmin(i),div(i),lf(i),i=1,ndiv)
      do 60 i=1,ndiv
          call freadr('hmin=',1,hmin(i),1)
          call freadr('div=',1,div(i),0)
          call freadi('lf=',1,lf(i),0)
          write(6,225) hmin(i),div(i),lf(i)
 60   continue
c      read(5,111) shftxb,shftyb,shftxa,shftya
      call freadr('shftxb=',1,shftxb,1)
      call freadr('shftyb=',1,shftyb,0)
      call freadr('shftxa=',1,shftxa,0)
      call freadr('shftya=',1,shftya,0)
      write(6,226) shftxb,shftyb,shftxa,shftya
c      read(5,114) wtitl,wts,angl
      call freadi('iwtitl=',1,wtitl,1)
      call freadr('wts=',1,wts,0)
      call freadr('angl=',1,angl,0)
      write(6,227) wtitl,wts,angl
      ax=ax/float(hmw)
      bx=bx/float(kmw)
      write(6,201)
      h1d=hmw/2
      h2d=kmw/2
      im=hmw+1
      jm=kmw+1
      jb=2
      do 10 i=1,ns
      if(i.gt.1) then
          do 11 j=3,6
 11       xs(j)=xs(j)+xi(j-2)
      end if
      write(6,'(1h ,a,4f7.3)') 'xs=',(xs(j),j=3,idm)
      call symstf(ahkl,h1d,h2d,jb,f000)
      call ahtobh(ahkl,bhkl,h1d,h2d)
      call mapxy(ahkl,h1d,h2d,v,jb,iwmlp)
c
c      do 122 ic=1,icycle
c      call expand(ahkl,h1d,h2d,f000,v,ex1,ex2,dmgn)
c      call maphk(ahkl,h1d,h2d,v,jb)
c      call phasng(ahkl,bhkl,h1d,h2d)
c 122  call mapxy(ahkl,h1d,h2d,v,jb,iwmlp)
c
      call map(hmin,div,lf,ndiv,ncopy,im,jm,a,b,2000,amgn,iw,
     *                      ahkl,h1d,h2d,ldev)
  10   continue
      close(unit=91)
      close(unit=92)
      close(unit=93)
      stop
 100  format(6i3)
 101  format(4i3)
 102  format(20a4)
 103  format(i6,7i3,f12.6)
 104  format(6f12.6)
 105  format(18i3)
 106  format(6i3)
 107  format(3f10.6,i3)
 110  format(4i3,f12.6)
 111  format(4f12.6)
 112  format(20a4)
 113  format(2f12.6,i3)
 114  format(i3,4f10.4)
 120  format(24i3)
 200  format(1h ,20a4)
 201  format(1h1)
 202  format(1h ,'transformation matrix for miller indices'/(1h ,6i3))
 203  format(1h ,'f000=',f10.6,3x,'ex1=',f10.6,3x,'ex2=',f10.6,3x,
     *      'icycle=',i3)
 220  format(1h ,'nslct=',i3,3x,23i3)
 221  format(1h ,'first to sixth axis in map',6i3
     *      /1h ,'coordinates of origin',6f12.6
     *     /1h ,'hmw=',i3,2x,'kmw=',i3,2x,'iwmlp=',i3)
 222  format(1h ,'number of sheets=',i3,2x,'interval of third to sixth
     *     axis',4f12.6/1h ,'maximum miller indices',6i5)
 223  format(1h ,'a=',f12.6,2x,'b=',f12.6,2x,'cosc=',f12.6)
 224  format(1h ,'ldev=',i3,2x,'iw=',i3,2x,'ndiv=',i3,2x,'ncopy=',i3,2x,
     *       'amgn=',f12.6)
 225  format(1h ,'hmin=',f12.6,2x,'div=',f12.6,2x,'lf=',i3)
 226  format(1h ,'shftxb=',f12.6,2x,'shftyb=',f12.6,2x,'shftxa=',
     *     f12.6,2x,'shftya=',f12.6)
 227  format(1h ,'wtitl=',i3,2x,'letter size=',f12.6,2x,'angl=',f12.6)
 228  format(1h ,'total ref.=',i6,2x,'jbc=',i3,2x,'irs',6i3,
     *                                    2x,' dmgn=',f12.6,)
      end


      subroutine symstf(ahkl,h1d,h2d,jb,f000)
      implicit integer (h)
      common /cjbc/ jbc,xs(6),iax(6)
      dimension irs(6)
      real dmgn
      common /const/ pai2,is,dmgn,irs
      common /atomp2/ y(3,3)
      integer rr
      common /sym/ rr(6,6,48),tt(6,48),nsymo,icent
      complex fcal
      integer hkln
      common /fhkl/hkln(100),fobs(100),fcal(100),wght(100)
      common /ctr/ itr(6,6)
      common /cdim/ idm,nde
      common /islct/ hd(3),h4(3,40),nslct
      integer h(6),hr(6)
      dimension ih(6),ahkl(jb,h1d,h2d,1),ar(4),ai(4)
      complex ahkl
      j=0
      n1=iax(1)
      n2=iax(2)
      n3=iax(3)
      do 101 h1=1,h1d
      do 101 h2=1,h2d
      do 101 i=1,jb
 101  ahkl(i,h1,h2,1)=(0.0,0.0)
      if(jbc.eq.3.or.jbc.eq.4.or.jbc.eq.5) go to 100
      ahkl(1,1,1,1)=cmplx(f000,0.0)
 100  ir1=0
      j=0
      do 102 i=1,is
      j=j+1
      j=mod(j-1,100)+1
      if(j.eq.1) ir1=ir1+1
      if(j.eq.1) read(unit=91,rec=ir1) hkln,fobs,wght
      if(j.eq.1) read(unit=92,rec=ir1) fcal
      if(wght(j).eq.0.0) go to 102
      call ihkln(ih,hkln(j))
      if(nslct.ne.0) then
          do 141 ia=1,nslct
          do 141 n=1,nsymo
          do 142 l=1,nde
          hd(l)=0
          do 142 k=1,nde
 142      hd(l)=hd(l)+ih(k+3)*rr(k+3,l+3,n)
          do 143 l=1,nde
              if(abs(hd(l)-h4(l,ia)).gt.0) go to 144
 143      continue
          go to 131
 144      continue
          do 145 l=1,nde
              if(abs(hd(l)+h4(l,ia)).gt.0) go to 141
 145      continue
          go to 131
 141  continue
          go to 102
      end if
 131  ac=real(fcal(j))
      bc=aimag(fcal(j))
      fc=sqrt(ac**2+bc**2)
      argr=1.0
      argi=0.0
      if(fc.ne.0.0) argr=ac/fc
      if(fc.ne.0.0) argi=bc/fc
      if(iabs(jbc).eq.1.or.jbc.eq.6) then
c     fo fourier
          a=fobs(j)*argr
          b=fobs(j)*argi
      else if(iabs(jbc).eq.2) then
c     fc fourier
          a=ac
          b=bc
      else if(iabs(jbc).eq.3) then
c     difference fourier
          a=fobs(j)*argr-ac
          b=fobs(j)*argi-bc
      else if(iabs(jbc).eq.4) then
c     fo patterson
          a=fobs(j)**2
          b=0.0
      else if(iabs(jbc).eq.5) then
c     fc patterson
          a=ac**2+bc**2
          b=0.0
      end if
      am=fam(ih)*2.0
      do 20 ns=1,nsymo
      do 202 k=1,idm
      hr(k)=0
          do 203 l=1,idm
          hr(k)=hr(k)+ih(l)*rr(l,k,ns)
 203      continue
 202  continue
      yt=0
      do 204 l=1,idm
      yt=yt+ih(l)*tt(l,ns)
 204  continue
      if(jbc.eq.4.or.jbc.eq.5) yt=0.0
c        axis transformaton
      if(jbc.lt.0) then
          do 112 k=1,idm
 112      h(k)=hr(k)
          do 113 k=1,idm
 113      hr(k)=itr(k,1)*h(1)+itr(k,2)*h(2)+itr(k,3)*h(3)+
     *          itr(k,4)*h(4)+itr(k,5)*h(5)+itr(k,6)*h(6)
          do 12 nd=1,idm
              if(iabs(ih(nd)).gt.irs(nd)) go to 20
 12       continue
      end if
c
      h1=abs(hr(n1))+1
      h2=abs(hr(n2))+1
      h3=1
c********ih=>hr******** nov. 26 1988
      if(h1.gt.h1d.or.h2.gt.h2d) go to 20
      arg=0.0
      do 103 k=1,idm
      nn=iax(k)
 103  arg=arg+hr(nn)*xs(k)
      arc=(arg+yt)*pai2
      coshx=cos(arc)
      sinhx=sin(arc)
      aa=a*coshx+b*sinhx
      bb=b*coshx-a*sinhx
      do 13 l=1,4
      ar(l)=0.0
 13   ai(l)=0.0
      ar(1)=aa
      ar(2)=-aa*isign(1,hr(n1))*isign(1,hr(n2))
c     ar(3)=-aa*isign(1,hr(n1))*isign(1,hr(n3))
c     ar(4)=-aa*isign(1,hr(n2))*isign(1,hr(n3))
      ai(1)=bb*isign(1,hr(n1))
      ai(2)=bb*isign(1,hr(n2))
c     ai(3)=bb*isign(1,hr(n3))
c     ai(4)=-bb*isign(1,hr(n1))*isign(1,hr(n2))*isign(1,hr(n3))
 151  continue
      ahkl(1,h1,h2,h3)=ahkl(1,h1,h2,h3)+cmplx(ar(1),ai(1))*am
      ahkl(2,h1,h2,h3)=ahkl(2,h1,h2,h3)+cmplx(ar(2),ai(2))*am
c     ahkl(3,h1,h2,h3)=ahkl(3,h1,h2,h3)+cmplx(ar(3),ai(3))*am
c     ahkl(4,h1,h2,h3)=ahkl(4,h1,h2,h3)+cmplx(ar(4),ai(4))*am
 20   continue
 102  continue
      return
      end

      subroutine mapxy(ahkl,hm,km,v,jb,iwmlp)
      implicit integer (h,x,y,z,p)
      common /cjbc/ jbc,xs(6),iax(6)
      dimension irs(6)
      real dmgn
      common /const/ pai2,is,dmgn,irs
      character*80 title
      common /ctitle/ title
      real xs,xe,ys,ye,a,b
      character*12 wjob(6)
      complex ahkl
      dimension a(513),b(513),ahkl(jb,hm,km),ia(513)
      data wjob/'fo fourier','fc fourier','dif.fourier','fo patterson',
     *     'fc patterson','prog.check'/
      v2=dmgn/(2*2*v)
      xm=hm*2
      ym=km*2
      do 13 k=1,km
      do 10 h=1,hm
          hd=h*2-1
          a(hd)=real(ahkl(1,h,k))
          a(hd+1)=aimag(ahkl(1,h,k))
          b(hd)=aimag(ahkl(2,h,k))
 10   b(hd+1)=real(ahkl(2,h,k))
      a(1)=a(1)*2
      b(1)=b(1)*2
      a(2)=0.0
      b(2)=0.0
      call rft(a,xm,-1,icon)
      call rft(b,xm,-1,icon)
      if(icon.eq.30000) go to 800
c     real x=odd
c     imag x=even
      do 11 x=1,hm
          xd=x*2-1
          ahkl(1,x,k)=cmplx(a(xd),a(xd+1))
 11   ahkl(2,x,k)=cmplx(b(xd),b(xd+1))
 13   continue
      iw=0
      do 14 x=1,hm
      do 15 k=1,km
          kd=k*2-1
          a(kd)=real(ahkl(1,x,k))*v2
          a(kd+1)=real(ahkl(2,x,k))*v2
          b(kd)=aimag(ahkl(1,x,k))*v2
          b(kd+1)=aimag(ahkl(2,x,k))*v2
 15   continue
      a(1)=a(1)*2
      b(1)=b(1)*2
      a(2)=0.0
      b(2)=0.0
      call rft(a,ym,-1,icon)
      call rft(b,ym,-1,icon)
      if(icon.eq.30000) go to 800
c     complex ahkl(i,x,y)
c     real:x odd
c     imag:x even
c     i=1 :y odd
c     i=2 :y even
      do 16 y=1,km
          yd=y*2-1
          ahkl(1,x,y)=cmplx(a(yd),b(yd))
          ahkl(2,x,y)=cmplx(a(yd+1),b(yd+1))
 16   continue
      ym1=ym+1
      a(ym1)=a(1)
      b(ym1)=b(1)
      iw=iw+1
      if(iwmlp.eq.1) write(93,rec=iw) (a(y),y=1,ym1)
      iw=iw+1
      if(iwmlp.eq.1) write(93,rec=iw) (b(y),y=1,ym1)
 14   continue
      if(iwmlp.ne.1) return
      write(93,rec=iw+1) (real(ahkl(1,1,y)),real(ahkl(2,1,y)),y=1,ym)
     *      ,real(ahkl(1,1,1))
      pm=(ym-2)/32+1
      do 31 page=1,pm
      yps=1+(page-1)*32
      ype=1+page*32
      if(page.eq.pm) ype=ym+1
      xe=xs(1)+1
      ys=xs(2)+float(yps-1)/float(ym)
      ye=xs(2)+float(ype-1)/float(ym)
      i=iabs(jbc)
      write(6,203) wjob(i),title,page
      write(6,204) irs
      write(6,202) iax(1),xs(1),xe,iax(2),ys,ye,(iax(k),xs(k),k=3,6),
     *                                       dmgn
      xm1=xm+1
      ym1=ym+1
      iw=0
      do 30 x=1,xm1
          iw=iw+1
          read(93,rec=iw) (a(y),y=1,ym1)
          do 32 y=yps,ype
 32       ia(y)=a(y)
 30   write(6,200) (ia(y),y=yps,ype)
 31   write(6,201)
      return
 800  write(6,801)
      return
 200  format(1h ,33i4)
 201  format(1h1)
 202  format(1h ,'coordinates',2x,'x(',i1,')=',f6.3,'-',f6.3,2x,'x(',
     * i1,')=',f6.3,'-',f6.3,2x,4('x(',i1,')=',f6.3,2x),'dmgn=',f9.6)
 203  format(1h ,a,5x,a,5x,' page ',i3)
 204  format(1h ,'h1m=',i3,3x,'h2m=',i3,3x,'h3m=',i3,3x,
     *   'h4m=',i3,3x,'h5m=',i3,3x,'h6m=',i3)
 801  format(1h ,'hmw, kmw, or lmw is invalid')
      end


      function fam(ih)
      common /cwght/ iwg
      common /atomp2/ y(3,3)
      common /cdim/ idm,nde
      dimension ih(6),q(3)
      data eps/1.0e-3/
      do 30 j=1,3
      q(j)=ih(j)
      do 30 i=1,nde
 30   q(j)=q(j)+y(i,j)*ih(3+i)
      if(iwg.le.11) then
           do 31 j=1,3
 31        q(j)=abs(q(j))
      end if
      fam=1.0
c         iwg:laue group(number of equivalent positions)
c           1:m3m(48),2:m3(24),3:4/mmm(16),4:4/m(8),5:mmm(8),
c           6:2/m(4),7:-1(2),8:6/mmm(24),9:6/m(12),10:-3/m(12),
c          11:-31(6)
      go to (11,12,13,14,14,15,16,17,18,18,19),iwg
 11   if(abs(q(1)-q(2)).lt.eps.or.abs(q(2)-q(3)).lt.eps.or.
     *   abs(q(3)-q(1)).lt.eps.or.abs(q(1)+q(2)).lt.eps.or.
     *   abs(q(2)+q(3)).lt.eps.or.abs(q(3)+q(1)).lt.eps) fam=fam*0.5
 12   if(abs(q(1)-q(2)).lt.eps.and.abs(q(2)-q(3)).lt.eps.or.
     *   abs(q(1)+q(2)).lt.eps.and.abs(q(2)-q(3)).lt.eps.or.
     *   abs(q(1)-q(2)).lt.eps.and.abs(q(2)+q(3)).lt.eps.or.
     *   abs(q(1)+q(2)).lt.eps.and.abs(q(2)+q(3)).lt.eps)
     *   fam=fam*0.333333
      go to 14
 13   if(abs(q(1)-q(2)).lt.eps.or.abs(q(1)+q(2)).lt.eps) fam=0.5
 14   if(abs(q(1)).lt.eps) fam=fam*0.5
c    h2>=0 or h2<=0 is assumed in iwg=6
 15   if(abs(q(2)).lt.eps) fam=fam*0.5
c    h3>=0 or h3<=0 is assumed in iwg=7
 16   if(abs(q(3)).lt.eps) fam=fam*0.5
      return
 17   if(abs(q(1)-q(2)).le.eps.or.abs(q(1)+2.0*q(2)).le.eps.or.
     *   abs(2.0*q(1)+q(2)).le.eps) fam=fam*0.5
 18   if(abs(q(1)).le.eps.or.abs(q(2)).le.eps.or.abs(q(1)+q(2)).le.eps)
     *      fam=fam*0.5
 19   if(abs(q(1)).le.eps.and.abs(q(2)).le.eps) fam=fam*0.333333
      if(abs(q(3)).lt.eps) fam=fam*0.5
      return
      end

      subroutine saxis(ih)
      dimension ih(6)
      return
      end

      subroutine ahtobh(ahkl,bhkl,hm,km)
      implicit integer (h)
      complex ahkl(2,hm,km),bhkl(2,hm,km)
      do 10 h=1,hm
      do 10 k=1,km
      do 10 i=1,2
 10   bhkl(i,h,k)=ahkl(i,h,k)
      return
      end

      subroutine phasng(ahkl,bhkl,hm,km)
      implicit integer (h)
      real iahkl,ibhkl
      complex ahkl(2,hm,km),bhkl(2,hm,km)
      do 10 h=1,hm
      do 10 k=1,km
      do 10 i=1,2
      rahkl=real(ahkl(i,h,k))
      iahkl=aimag(ahkl(i,h,k))
      zahkl=sqrt(rahkl**2+iahkl**2)
      argr=1.0
      argi=0.0
      if(zahkl.ne.0.0) argr=rahkl/zahkl
      if(zahkl.ne.0.0) argi=iahkl/zahkl
      rbhkl=real(bhkl(i,h,k))
      ibhkl=aimag(bhkl(i,h,k))
      zbhkl=sqrt(rbhkl**2+ibhkl**2)
 10   ahkl(i,h,k)=cmplx(zbhkl*argr,zbhkl*argi)
      return
      end

      subroutine expand(ahkl,hm,km,f000,v,ex1,ex2,dmgn)
      implicit integer (h)
      real iahkl,dmgn
      complex ahkl(2,hm,km)
      fex(x)=1.0+atan(ex2*(x-1))/1.5707
      avdnst=f000*ex1*dmgn/v
      do 10 h=1,hm
      do 10 k=1,km
      do 10 i=1,2
      rahkl=real(ahkl(i,h,k))
      iahkl=aimag(ahkl(i,h,k))
      rahkl=fex(rahkl/avdnst)
      iahkl=fex(iahkl/avdnst)
 10   ahkl(i,h,k)=cmplx(rahkl,iahkl)
      return
      end

      subroutine ihkln(ih,hkln)
      integer ih(6),hkln,hm
      common /chkln/ iex(6),hm(6)
      ih(1)=hkln/iex(1)-hm(1)
      do 10 i=2,6
 10   ih(i)=mod(hkln,iex(i-1))/iex(i)-hm(i)
      return
      end

      subroutine map(hmin,div,lf,ndiv,ncpy,im,jm,a,b,ii,amgn,iw,
     *       ahkl,ih,ik,ldev)
      dimension hmin(*),div(*),lf(*),a(*),b(*)
      dimension ahkl(2,2,ih,ik)
      common /cjbc/ jbc,xs(6),iax(6)
      integer wtitl
      common /name/ shftxb,shftyb,shftxa,shftya,wtitl,wts,angl
      character*80 title, coord, cmap, tmap
      common /ctitle/ title
      dimension ar(500),br(500),xb(7),yb(7)
      common /cdim/ idm,nde
c
c     hmin(i): minimum hight in i-th range
c     div(i) : increase of hight in i-th range
c     lf(i)  : number of contour lines in i-th range
c     ndiv(i): number of ranges
c     ncpy: number of copies
c     im  : number of lattice points along x-axis
c     jm  : number of lattice points along y-axis
c     a,b : work array to store the x,y coordinates on a contour line
c     ahkl(i,j): hight of the function at the lattice point (i,j)
c     ih,jh : size of to dimensional array ahkl
c
c
      np=8
c
      do 80 i=0,79
          j=80-i
          if(title(j:j).ne.' ') go to 81
 80   continue
 81   ntitle=j
      if(iabs(jbc).eq.1) then
          cmap='Fo Fourier  '
      else if(iabs(jbc).eq.2) then
          cmap='Fc Fourier  '
      else if(iabs(jbc).eq.3) then
          cmap='D-Fourier   '
      else if(iabs(jbc).eq.4) then
          cmap='Fo Patterson'
      else if(iabs(jbc).eq.5) then
          cmap='Fc Patterson'
      end if
      write(coord,'(a,4f7.3)') 'z=',(xs(j),j=3,idm)
      do 300 ncoo=80,1,-1
        if(coord(ncoo:ncoo).ne.' ') go to 301
 300  continue
 301  continue
      nmap=ncoo+14
      tmap(1:nmap)=cmap(1:12)//'  '//coord(1:ncoo)
      dlm=2.001
      bim=float(im-1)
      ajm=float(jm-1)
      wtxd=wtx*amgn
      wtyd=wty*amgn
      wtsd=wts*amgn
      shftxd=shftx*amgn
      shftyd=shfty*amgn
c
      do 50 nc=1,ncpy
      call plots(5.0,3.0,ldev)
c     shift before plot
      call plot(shftxb,shftyb,-3)
c     plot title
      if(wtitl.eq.1) then
           call symbol(0.0,0.0,wtsd,title,angl,ntitle)
           call plot(0.0,wtsd*2.0,-3)
      end if
c     write coordinates normal to the plane
      call symbol(0.0,0.0,wtsd,tmap,angl,nmap)
      call plot(0.0,wtsd*2.0,-3)
c     plot boundary
      xb(1)=0.0
      yb(1)=0.0
      xb(2)=bim*amgn
      yb(2)=0.0
      xb(3)=bim*amgn
      yb(3)=ajm*amgn
      xb(4)=0.0
      yb(4)=ajm*amgn
      xb(5)=0.0
      yb(5)=0.0
      xb(6)=0.0
      yb(6)=0.0
      xb(7)=1.0
      yb(7)=1.0
      call abtoxy(xb,yb,5)
      call line(xb,yb,5,1,0,0,10)
c     coordinates on a contour line
      idv=(im-2)/np+1
      jdv=(jm-2)/np+1
      do 10 id=1,idv
      is0=(id-1)*np+1
      ie0=is0+np
      do 10 jd=1,jdv
      js0=(jd-1)*np+1
      je0=js0+np
      do 10 nd=1,ndiv
      le=lf(nd)
      do 10 l=1,le
      al=hmin(nd)+div(nd)*float(l-1)
      is=is0
      ie=ie0
      js=js0
      je=je0
 15   if(ie.ne.ie0) is=ie
      ie=ie0
      m=0
      mf=0
      md=0
 39   continue
      do 36 i=is,ie
      do 34 j=js,je
c
      ix1=(i-1)/2+1
      ix2=i/2+1
      ixd1=mod(i-1,2)+1
      ixd2=mod(i,2)+1
      iy1=(j-1)/2+1
      iy2=j/2+1
      iyd1=mod(j-1,2)+1
      iyd2=mod(j,2)+1
      if(i.eq.im) ix1=1
      if(i.eq.im) ixd1=1
      if(i+1.eq.im) ix2=1
      if(i+1.eq.im) ixd2=1
      if(j.eq.jm) iy1=1
      if(j.eq.jm) iyd1=1
      if(j+1.eq.jm) iy2=1
      if(j+1.eq.jm) iyd2=1
c        hights at cube corner
c    h1:(i,j), h2:(i,j+1), h3:(i+1,j), h4:(i+1,j+1)
                              h1=ahkl(ixd1,iyd1,ix1,iy1)-al
      if(j.ne.je)             h2=ahkl(ixd1,iyd2,ix1,iy2)-al
      if(i.ne.ie)             h3=ahkl(ixd2,iyd1,ix2,iy1)-al
      if(i.ne.ie.and.j.ne.je) h4=ahkl(ixd2,iyd2,ix2,iy2)-al
c       point in the range h1-h2
      if(j.ne.je) then
        if(sign(1.0,h1).ne.sign(1.0,h2)) then
           m=m+1
           if(m.gt.ii) go to 36
           a(m)=float(j-1)+h1/(h1-h2)
           b(m)=float(i-1)
        end if
      end if
c     point in the range h1-h3
      if(i.ne.ie) then
        if(sign(1.0,h1).ne.sign(1.0,h3)) then
            m=m+1
            if(m.gt.ii) go to 36
            a(m)=float(j-1)
            b(m)=float(i-1)+h1/(h1-h3)
        end if
      end if
c     point in the range h1-h4
      if(i.ne.ie.and.j.ne.je) then
        if(sign(1.0,h1).ne.sign(1.0,h4)) then
        m=m+1
        if(m.gt.ii) go to 36
        a(m)=float(j-1)+h1/(h1-h4)
        b(m)=float(i-1)+h1/(h1-h4)
        end if
      end if
c     point in the range h2-h3
      if(i.ne.ie.and.j.ne.je) then
          if(sign(1.0,h2).ne.sign(1.0,h3)) then
             m=m+1
             if(m.gt.ii) go to 36
             a(m)=float(j  )-h2/(h2-h3)
             b(m)=float(i-1)+h2/(h2-h3)
           end if
      end if
 34   continue
      md0=md
      mf0=mf
      mf=m
      md=mf-mf0
      iend=i
 36   continue
      if(m.gt.ii) then
c         number of points on a contour line exceeds
c                array size of a and b
          if(iend.eq.im) then
              is=max0(iend-2,1)
              ie=max0(iend-1,1)
              m=mf0-md0
              go to 39
          else
              is=max0(iend-1,1)
              ie=iend
              m=mf0
              go to 39
          end if
      end if
      if(mf.le.1) go to 10
c
c       write coordinates on a contour line if necessary
      if(iw.eq.1) then
           write(6,202) title
           write(6,200) al,mf
           write(6,201) (b(m),a(m),m=1,mf)
      end if
c
c         find contour line
c     a,b: coordinates on a contour line
c     mf : number of points on the contour line
c
      ais=is-1
      aie=ie-1
      ajs=js-1
      aje=je-1
      i=0
      it=1
 42   n=0
 46   i=i+1
      i1=i+1
c    find nearest point on the contour line
      call fdmin(i1,mf,it,m1,dmin,a,b,ii)
      if(n.eq.0) is=it
c          point in the boundary
      if(a(is).eq.ajs.or.b(is).eq.ais.or.a(is).eq.aje.or.
     *     b(is).eq.aie.or.is.ne.i-n) go to 12
      if(a(m1).ne.ajs.and.b(m1).ne.ais.and.a(m1).ne.aje.and.
     *         b(m1).ne.aie) go to 12
      call intch(a(is),b(is),a(m1),b(m1))
      i=is-1
      it=is
      go to 42
c         point on the boundary
 12   call intch(a(i1),b(i1),a(m1),b(m1))
      n=n+1
      it=i1
      if(dmin.lt.dlm.and.i1.ne.mf) go to 46
 41   if(dmin.lt.dlm.and.i1.eq.mf) n=n+1
      if(dmin.lt.dlm.and.i1.eq.mf) i=i+1
      if(n.eq.1) go to 45
      br(1)=b(is)*amgn
      ar(1)=a(is)*amgn
      do 44 k=2,n
      ki=i-n+k
      br(k)=b(ki)*amgn
 44   ar(k)=a(ki)*amgn
      if(a(i).eq.ajs.or.b(i).eq.ais.or.
     *       a(i).eq.aje.or.b(i).eq.aie)  go to 11
      call fdmin(is,is,i,m1,dmin,a,b,ii)
      if(dmin.le.dlm) go to 14
      i2=max0(i-n-1,i-4)
      if(i2.lt.1) go to 11
      call fdmin(1,i2,i ,m1,dmin,a,b,ii)
      if(dmin.gt.dlm) go to 11
 14   continue
      n=n+1
      if(n.gt.500) then
          write(6,*) ' ar(n), br(n), n > 500 stop in map '
          stop
      end if
      br(n)=b(m1)*amgn
      ar(n)=a(m1)*amgn
      it=m1
      if(i.ne.mf) i=i-1
 11   continue
c     plot contour line
      call abtoxy(br,ar,n)
      if(al.gt.0.0) call clin(br,ar,n,1,amgn)
      if(al.eq.0.0) call clin(br,ar,n,2,amgn)
      if(al.lt.0.0) call clin(br,ar,n,3,amgn)
 45   if(i1.ne.mf) go to 42
      if(ie.ne.ie0) go to 15
 10   continue
c
c     write boundary lines
c
      call plote('end of plot')
 50   continue
      return
 200  format(1h ,6hhight=,f12.6,5x,16hnumber of points,i6)
 201  format((1h ,10(2f6.1,1x)))
 202  format(1h ,a)
      end

      subroutine abtoxy(x,y,n)
      common /cabxy/ ax,bx,coscx,sincx,irl
      dimension x(*),y(*)
      do 10 i=1,n
          x(i)=x(i)*ax+y(i)*bx*coscx
          y(i)=y(i)*bx*sincx
          if(irl.eq.1) y(i)=-y(i)
 10   continue
      return
      end

      subroutine axs(amin,amax,bmin,bmax,diva,divb,xx,yy)
      dimension xx(3),yy(3),ax(4),ay(4)
      call plot(xx(1),yy(1),3)
      call plot(xx(2),yy(2),2)
      call plot(xx(1),yy(1),3)
      call plot(xx(3),yy(3),2)
      ax(3)=0.0
      ay(3)=0.0
      ax(4)=1.0
      ay(4)=1.0
      im=(amax-amin)/diva+0.001
      jm=(bmax-bmin)/divb+0.001
      do 60 i=1,im
      ax(1)=amin +diva*float(i)
      ay(1)=bmin
      call abtoxy(ax,ay,1)
      ax(2)=ax(1)
      if(irl.ne.1) ay(2)=ay(1)-0.1
      if(irl.eq.1) ay(2)=ay(1)+0.1
 60   call line(ax,ay,2,1,0,0,10)
      do 61 j=1,jm
      ax(1)=amin
      ay(1)=bmin +divb*float(j)
      call abtoxy(ax,ay,1)
      ax(2)=ax(1)-0.1
      ay(2)=ay(1)
 61   call line(ax,ay,2,1,0,0,10)
      return
      end

      subroutine fdmin(i1,i2,i,m1,dmin,a,b,ii)
      dimension a(ii),b(ii)
      m1=i1
      do 10 j=i1,i2
      d=(a(j)-a(i))**2+(b(j)-b(i))**2
      if(j.eq.i1) dmin=d
      if(d.ge.dmin) go to 10
      dmin=d
      m1=j
 10   continue
      return
      end

      subroutine intch(x1,y1,x2,y2)
      x=x1
      y=y1
      x1=x2
      y1=y2
      x2=x
      y2=y
      return
      end

      subroutine clin(a,b,n,ltyp,pitch)
      dimension a(*),b(*),ad(512),bd(512),d1(4)
      if(ltyp.eq.1) then
          a(n+1)=0.0
          b(n+1)=0.0
          a(n+2)=1.0
          b(n+2)=1.0
          call line(a,b,n,1,0,0,10)
          return
      end if
      if(ltyp.eq.2) d1(1)=pitch*0.1
      if(ltyp.eq.3) d1(1)=pitch*0.2
      d1(2)=d1(1)
      d1(3)=d1(1)
      if(ltyp.eq.2) d1(4)=pitch*0.5
      if(ltyp.eq.3) d1(4)=d1(1)
      k=0
      is=2
      j=1
      ad(1)=a(1)
      bd(1)=b(1)
      dab=0.0
      dx=0.0
      i=1
      i1=1
 12   continue
      k=k+1
      k=mod(k-1,4)+1
      ad(1)=ad(j)
      bd(1)=bd(j)
      j=1
      dd=-dx
      do 10 i=is,n
          j=j+1
          if(j.gt.500) then
              write(6,*) ' ad(j),bd(j), j>500 in clin '
              stop
          end if
          da=a(i)-a(i-1)
          db=b(i)-b(i-1)
          dab=sqrt(da**2+db**2)
          d=dd+dab
          ad(j)=a(i)
          bd(j)=b(i)
          if(i.eq.n.and.d.lt.d1(k)) go to 11
          if(d.lt.d1(k)) go to 10
          dx=d1(k)-dd
          ad(j)=a(i-1)+da*dx/dab
          bd(j)=b(i-1)+db*dx/dab
          is=i
          if((k.eq.1.or.k.eq.3).and.i.ne.n) go to 12
 11       if((k.eq.1.or.k.eq.3).and.i.eq.n) go to 10
          ad(j+1)=0.0
          bd(j+1)=0.0
          ad(j+2)=1.0
          bd(j+2)=1.0
          call line(ad,bd,j,1,0,0,10)
          if(i.ne.n) go to 12
 10   dd=d
      return
      end

      subroutine maphk(ahkl,hm,km,v,jb)
      implicit integer (h,x,y,z,p)
      common /cjbc/ jbc,xs(6),iax(6)
      dimension irs(6)
      real dmgn
      common /const/ pai2,is,dmgn,irs
      character*80 title
      common /ctitle/ title
      real xs,a,b
      character*12 wjob(6)
      complex ahkl
      dimension a(513),b(513),ahkl(jb,hm,km)
      data wjob/'fo fourier','fc fourier','dif.fourier','fo patterson',
     *      'fc patterson','prog.check'/
      xm=hm*2
      ym=km*2
      v2=v/(xm*ym*dmgn)
      do 13 y=1,km
      do 10 x=1,hm
      xd=x*2-1
      a(xd)=real(ahkl(1,x,y))
      a(xd+1)=aimag(ahkl(1,x,y))
      b(xd)=real(ahkl(2,x,y))
 10   b(xd+1)=aimag(ahkl(2,x,y))
      call rft(a,xm,1,icon)
      call rft(b,xm,1,icon)
      if(icon.eq.30000) go to 800
      do 11 h=1,hm
      hd=h*2-1
      ahkl(1,h,y)=cmplx(a(hd),a(hd+1))
 11   ahkl(2,h,y)=cmplx(b(hd),b(hd+1))
 13   continue
      iw=0
      do 14 h=1,hm
      do 15 y=1,km
      yd=y*2-1
      a(yd)=real(ahkl(1,h,y))*v2
      a(yd+1)=real(ahkl(2,h,y))*v2
      b(yd)=aimag(ahkl(1,h,y))*v2
 15   b(yd+1)=aimag(ahkl(2,h,y))*v2
      call rft(a,ym,1,icon)
      call rft(b,ym,1,icon)
      if(icon.eq.30000) go to 800
      do 16 k=1,km
      kd=k*2-1
      fct=1.0
      if(h.eq.1) fct=fct/2.0
      if(k.eq.1) fct=fct/2.0
      ahkl(1,h,k)=cmplx(a(kd),b(kd))*fct
 16   ahkl(2,h,k)=cmplx(b(kd+1),a(kd+1))*fct
 14   continue
      return
 800  write(6,801)
      return
 801  format(1h ,'hmw, kmw, or lmw is invalid')
      end

      subroutine matinv(a,nm,n,b,m,determ,ipivot,index,pivot)
c
c    n*n matrix a is replaced by its inverse matrix a**-1
c    if m is nonzero vector b is replaced by a**-1*b
c
      dimension a(nm,nm),b(nm),ipivot(nm),index(nm,2),pivot(nm)
      equivalence (irow,jrow),(icolum,jcolum),(amax,t,swap)
      determ=1.0
      do 20 j=1,n
  20  ipivot(j)=0
      do 555 i=1,n
      amax=0.0
      do 105 j=1,n
      if(ipivot(j).eq.1) go to 105
      do 100 k=1,n
      if(ipivot(k)-1) 80,100,740
  80  if(abs(amax).ge.abs(a(j,k))) go to 100
      irow=j
      icolum=k
      amax=a(j,k)
 100  continue
 105  continue
      ipivot(icolum)=ipivot(icolum)+1
      if(irow.eq.icolum) go to 260
      determ=-determ
      do 200 l=1,n
      swap=a(irow,l)
      a(irow,l)=a(icolum,l)
 200  a(icolum,l)=swap
      if(m.eq.0) go to 260
      swap=b(irow)
      b(irow)=b(icolum)
      b(icolum)=swap
 260  index(i,1)=irow
      index(i,2)=icolum
      pivot(i)=a(icolum,icolum)
      determ=determ*pivot(i)
      a(icolum,icolum)=1.0
      do 350 l=1,n
 350  a(icolum,l)=a(icolum,l)/pivot(i)
      if(m.eq.0) go to 380
      b(icolum)=b(icolum)/pivot(i)
 380  do 550 l1=1,n
      if(l1.eq.icolum) go to 550
      t=a(l1,icolum)
      a(l1,icolum)=0.0
      do 450 l=1,n
 450  a(l1,l)=a(l1,l)-a(icolum,l)*t
      if(m.eq.0) go to 550
      b(l1)=b(l1)-b(icolum)*t
 550  continue
 555  continue
      do 710 i=1,n
      l=n+1-i
      if(index(l,1).eq.index(l,2)) go to 710
      jrow=index(l,1)
      jcolum=index(l,2)
      do 700  k=1,n
      swap=a(k,jrow)
      a(k,jrow)=a(k,jcolum)
 700  a(k,jcolum)=swap
 710  continue
 740  continue
      return
      end

      subroutine quit(str)
      character*(*) str
      write(6,*) str
      stop
      end
