c
c      check number of reflections included under the specified hmax
c                   (face centered icosahedral case)
c
c     (1) flnm1   filename of hkl,fo,fc,sg file
c     (2) frmt    its format
c     (3) hmax    maximum indices for six axes
c
      integer hmax(6)
      character*40 frmt
      character*80 flnm1
      character brv
      data brv/'f'/
      call setinp(5)
      call setout(6)
      call setskp(0)
      call setbrv(brv)
      call freadc('flnm1=',1,flnm1,1)
      call freadc('frmt=',1,frmt,1)
      call freadi('hmax=',6,hmax,1)
      open(unit=2,file=flnm1)
      call rdhklq(frmt,hmax)
      stop
      end

      subroutine setbrv(brv)
      character brv,brvs
      common /cbrv/ brvs
      brvs=brv
      return
      end

      subroutine getbrv(brv)
      character brv,brvs
      common /cbrv/ brvs
      brv=brvs
      return
      end

      subroutine rdhklq(frmt,hmax)
      character*(*) frmt
      integer hmax(*)
      integer h(6),hd(6)
      real q(6)
      i=0
      k=0
 100  continue
      read(2,frmt) (h(j),j=1,6),fo,fc,sg
      if(h(1).eq.999) go to 300
      call vcpyi(h,hd,6)
      call ctoph(hd)
      k=k+1
      if(iskip(hd,hmax).eq.0) then
c        write(6,'(6i3,1x,6i3)') h,hd
         i=i+1
      end if
      go to 100
 300  continue
      is=i
      write(6,'(a,i5)') 'number of total reflections',k
      write(6,'(a,i5)') 'number of reflections used ',is
      close(2)
      close(3)
      return
      end

      subroutine ctoph(h)
      integer h(*)
      integer hd(6)
      character brv
c      transformation of indices from centered to primitive
      call getbrv(brv)
      if(brv.eq.'p') then
         return
      else if(brv.eq.'f') then
         call ftoph(h,hd)
         call vcpyi(hd,h,6)
      else if(brv.eq.'i') then
         call quit('brv=i is not allowed in the present ver.')
      else
         call quit('invalid brv')
      end if
      return
      end

      subroutine ptoch(h)
      integer h(*)
      integer hd(6)
      character brv
c      transformation of indices from primitive to centered
      call getbrv(brv)
      if(brv.eq.'p') then
         return
      else if(brv.eq.'f') then
         call ptofh(h,hd)
         call vcpyi(hd,h,6)
      else if(brv.eq.'i') then
         call quit('brv=i is not allowed in the present ver.')
      else
         call quit('invalid brv')
      end if
      return
      end

      subroutine ctopx(x)
      real x(*)
      real xd(6)
      character brv
c      transformation of indices from centered to primitive
      call getbrv(brv)
      if(brv.eq.'p') then
         return
      else if(brv.eq.'f') then
         call ftopx(x,xd)
         call vcpyr(xd,x,6)
      else if(brv.eq.'i') then
         call quit('brv=i is not allowed in the present ver.')
      else
         call quit('invalid brv')
      end if
      return
      end

      subroutine ptocx(x)
      real x(*)
      real xd(6)
      character brv
c      transformation of indices from primitive to centered
      call getbrv(brv)
      if(brv.eq.'p') then
         return
      else if(brv.eq.'f') then
         call ptofx(x,xd)
         call vcpyr(xd,x,6)
      else if(brv.eq.'i') then
         call quit('brv=i is not allowed in the present ver.')
      else
         call quit('invalid brv')
      end if
      return
      end


      subroutine ptofx(x,y)
      real x(*),y(*)
      integer qm(6,6)
      data qm / 0, 1, 0, -1, 0, 0,
     *          0, 0, 1, 0, 0, -1,
     *          1, 0, 0, 0, 1, 0,
     *          0, 0, 0, 0, -1, 1,
     *          0, 0, 0, 1, -1, 0,
     *          0, 0, 0, 1, 0, 1/
c      coordinate transformation from primitive to face-centerd
      do i=1,6
         y(i)=0
         do j=1,6
            y(i)=y(i)+qm(i,j)*x(j)/2
         end do
      end do
      return
      end

      subroutine ftopx(x,y)
      real x(*),y(*)
      integer qm(6,6)
      data qm / 0, 0, 2, 1, 1, -1,
     *          2, 0, 0, -1, 1, 1,
     *          0, 2, 0, 1, -1, 1,
     *          0, 0, 0, -1, 1, 1,
     *          0, 0, 0, -1, -1, 1,
     *          0, 0, 0, 1, -1, 1/
c      coordinate transformation from face-centerd to primitive
      do i=1,6
         y(i)=0
         do j=1,6
            y(i)=y(i)+qm(i,j)*x(j)
         end do
      end do
      return
      end

      subroutine ftoph(x,y)
      integer x(*),y(*)
      integer qm(6,6)
      data qm / 0, 1, 0, -1, 0, 0,
     *          0, 0, 1, 0, 0, -1,
     *          1, 0, 0, 0, 1, 0,
     *          0, 0, 0, 0, -1, 1,
     *          0, 0, 0, 1, -1, 0,
     *          0, 0, 0, 1, 0, 1/
c      coordinate transformation from face-centerd to primitive
      do i=1,6
         y(i)=0
         do j=1,6
            y(i)=y(i)+x(j)*qm(j,i)
         end do
         y(i)=y(i)/2
      end do
      return
      end

      subroutine ptofh(x,y)
      integer x(*),y(*)
      integer qm(6,6)
      data qm / 0, 0, 2, 1, 1, -1,
     *          2, 0, 0, -1, 1, 1,
     *          0, 2, 0, 1, -1, 1,
     *          0, 0, 0, -1, 1, 1,
     *          0, 0, 0, -1, -1, 1,
     *          0, 0, 0, 1, -1, 1/
c      coordinate transformation from primitive to face-centerd
      do i=1,6
         y(i)=0
         do j=1,6
            y(i)=y(i)+x(j)*qm(j,i)
         end do
      end do
      return
      end

      function iskip(hkln,hmax)
      integer hkln(*),hmax(*)
      do i=1,6
         if(abs(hkln(i)).gt.hmax(i)/2) then
            iskip=1
            return
         end if
      end do
      iskip=0
      return
      end

      subroutine vcpyr(a,b,n)
      real a(*),b(*)
      do 100 i=1,n
         b(i)=a(i)
 100  continue
      return
      end

      subroutine vcpyi(a,b,n)
      integer a(*),b(*)
      do 100 i=1,n
         b(i)=a(i)
 100  continue
      return
      end

      subroutine quit(str)
      character*(*) str
      write(6,*) str
      time=etime(tarray)
      write(6,*) '******elapsed time=',time,'sec******'
      close(unit=2)
      close(unit=3)
      call exit()
      end

      subroutine freadi(prfx,n,var,nl)
      integer var(*)
      character*(*) prfx
      integer ip,ep
      character*256 buf
      common /cbuf/ buf,ip
      call getinp(inpu)
      call getout(iout)
      call getskp(iskp)
 100  continue
      if(nl.eq.1) then
           read(inpu,'(a)',end=200) buf
           ip=1
      end if
      ipd=index(buf(ip:256),prfx)
      ip=ipd+ip-1
      if(ipd.eq.0) then
           if(iskp.eq.0) then
               write(iout,'(2a)') prfx,' not found'
               call quit(' ')
           else if(nl.eq.0) then
               write(iout,'(2a)') prfx,' not found'
               call quit(' ')
           else
               go to 100
           end if
      end if
      ep=len(prfx)+ip-1
c     ep: end of the prefix
      if(n.eq.0) return
c       skip blanks between prefix and value or value and value
      jp=ep+1
      do 150 i=1,n
          do 10 j=jp,256
              if(buf(j:j).ne.' ') go to 20
 10       continue
 20       continue

          jp=j
c         jp: beginning of i-th value
          ipd1=index(buf(jp:256),' ')
          ipd2=index(buf(jp:256),',')
          if(ipd1.gt.0.and.ipd2.gt.0) then
              jp=min(ipd1,ipd2)+jp
          else if(ipd1.gt.0) then
              jp=ipd1+jp
          else if(ipd2.gt.0) then
              jp=ipd2+jp
          else
              jp=256
          end if
c         jp: beginning of next prefix or value
 150  continue
      if(jp.eq.256) then
          write(iout,'(3a)') 'value of ',prfx,' not fund'
          call quit(' ')
      end if
      read(buf(ep+1:jp),*) (var(i),i=1,n)
      ip=jp
      return
 200  continue
           write(iout,'(2a)') prfx,' not found'
           call quit(' ')
      return
      end

      subroutine freadr(prfx,n,var,nl)
      real var(*)
      character*(*) prfx
      integer ip,ep
      character*256 buf
      common /cbuf/ buf,ip
      call getinp(inpu)
      call getout(iout)
      call getskp(iskp)
 100  continue
      if(nl.eq.1) then
           read(inpu,'(a)',end=200) buf
           ip=1
      end if
      ipd=index(buf(ip:256),prfx)
      ip=ipd+ip-1
      if(ipd.eq.0) then
           if(iskp.eq.0) then
               write(iout,'(2a)') prfx,' not found'
               call quit(' ')
           else if(nl.eq.0) then
               write(iout,'(2a)') prfx,' not found'
               call quit(' ')
           else
               go to 100
           end if
      end if
c      if(ipd.eq.0) then
c           write(iout,'(2a)') prfx,' not found'
c           call quit(' ')
c      end if
      ep=len(prfx)+ip-1
c     ep: end of the prefix
      if(n.eq.0) return
c       skip blanks between prefix and value or value and value
      jp=ep+1
      do 150 i=1,n
          do 10 j=jp,256
              if(buf(j:j).ne.' ') go to 20
 10       continue
 20       continue
          jp=j
c         jp: beginning of i-th value
          ipd1=index(buf(jp:256),' ')
          ipd2=index(buf(jp:256),',')
          if(ipd1.gt.0.and.ipd2.gt.0) then
              jp=min(ipd1,ipd2)+jp
          else if(ipd1.gt.0) then
              jp=ipd1+jp
          else if(ipd2.gt.0) then
              jp=ipd2+jp
          else
              jp=256
          end if
c         jp: beginning of next prefix or value
 150  continue
      if(jp.eq.256) then
          write(iout,'(3a)') 'value of ',prfx,' not fund'
          call quit(' ')
      end if
      read(buf(ep+1:jp-1),*) (var(i),i=1,n)
      ip=jp
      return
 200  continue
          write(iout,'(2a)') prfx,' not found'
          call quit(' ')
      return
      end

      subroutine freadc(prfx,n,var,nl)
      character*(*) var(*)
      character*(*) prfx
      integer ip,ep
      character*256 buf
      common /cbuf/ buf,ip
      call getinp(inpu)
      call getout(iout)
      call getskp(iskp)
 100  continue
      lval=len(var(1))
      if(nl.eq.1) then
           read(inpu,fmt='(a)',end=200) buf(1:256)
           ip=1
      end if
      ipd=index(buf(ip:256),prfx)
      ip=ipd+ip-1
      if(ipd.eq.0) then
           if(iskp.eq.0) then
               write(iout,'(2a)') prfx,' not found'
               call quit(' ')
           else if(nl.eq.0) then
               write(iout,'(2a)') prfx,' not found'
               call quit(' ')
           else
               go to 100
           end if
      end if
c      if(ipd.eq.0) then
c           write(iout,'(2a)') prfx,' not found'
c           call quit(' ')
c      end if
      ep=len(prfx)+ip-1
c     ep: end of the prefix
      if(n.eq.0) return
c       skip blanks between prefix and value or value and value
      jp=ep+1
      do 150 i=1,n
          do 10 j=jp,256
              if(buf(j:j).ne.' ') go to 20
 10       continue
 20       continue
          jp=j
c         jp: beginning of i-th value
          ipd1=index(buf(jp+1:256),'''')
          if(ipd1.gt.0) then
              jp=ipd1+jp+1
          else
              jp=256
          end if
c         jp: beginning of the next prefix or value
 150  continue
      if(jp.eq.256) then
          write(iout,'(3a)') 'value of ',prfx,' not fund'
          call quit(' ')
      end if
      read(buf(ep+1:jp-1),*) (var(i)(1:lval),i=1,n)
      ip=jp
      return
 200  continue
           write(iout,'(2a)') prfx,' not found'
           call quit(' ')
      return
      end

      function istrln(c)
      character*(*) c
      l=len(c)
      do 10 i=l,1,-1
      if(c(i:i).ne.' ') then
          istrln=i
          return
      end if
 10   continue
      istrln=0
      return
      end

      subroutine setinp(inpu)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      cinpu=inpu
      return
      end

      subroutine setout(iout)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      coutu=iout
      return
      end

      subroutine getinp(inpu)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      inpu=cinpu
      return
      end

      subroutine getout(iout)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      iout=coutu
      return
      end

      subroutine setskp(iskp)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      cskip=iskp
      return
      end

      subroutine getskp(iskp)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      iskp=cskip
      return
      end
