      subroutine matinv(a,nm,n,b,m,determ,ipivot,index,pivot)
c     
c     n*n matrix a is replaced by its inverse matrix a**-1
c     if m is nonzero vector b is replaced by a**-1*b
c     
c     dimension a(nm,nm),b(nm),ipivot(nm),index(nm,2),pivot(nm)
      real a(nm,nm),b(nm),pivot(nm)
      integer ipivot(nm),index(nm,2)
      equivalence (irow,jrow),(icolum,jcolum),(amax,t,swap)
      determ=1.0
      do j=1,n
         ipivot(j)=0
      end do
      do i=1,n
         amax=0.0
         do j=1,n
            if(ipivot(j).eq.1) go to 105
            do k=1,n
               if(ipivot(k)-1) 80,100,740
 80            if(abs(amax).ge.abs(a(j,k))) go to 100
               irow=j
               icolum=k
               amax=a(j,k)
 100           continue
            end do
 105        continue
         end do
         ipivot(icolum)=ipivot(icolum)+1
         if(irow.eq.icolum) go to 260
         determ=-determ
         do l=1,n
            swap=a(irow,l)
            a(irow,l)=a(icolum,l)
            a(icolum,l)=swap
         end do
         if(m.eq.0) go to 260
         swap=b(irow)
         b(irow)=b(icolum)
         b(icolum)=swap
 260     index(i,1)=irow
         index(i,2)=icolum
         pivot(i)=a(icolum,icolum)
         determ=determ*pivot(i)
         a(icolum,icolum)=1.0
         do l=1,n
            a(icolum,l)=a(icolum,l)/pivot(i)
         end do
         if(m.eq.0) go to 380
         b(icolum)=b(icolum)/pivot(i)
 380     continue
         do l1=1,n
            if(l1.eq.icolum) go to 550
            t=a(l1,icolum)
            a(l1,icolum)=0.0
            do l=1,n
               a(l1,l)=a(l1,l)-a(icolum,l)*t
            end do
            if(m.eq.0) go to 550
            b(l1)=b(l1)-b(icolum)*t
 550        continue
         end do
      end do
      do i=1,n
         l=n+1-i
         if(index(l,1).eq.index(l,2)) go to 710
         jrow=index(l,1)
         jcolum=index(l,2)
         do k=1,n
            swap=a(k,jrow)
            a(k,jrow)=a(k,jcolum)
            a(k,jcolum)=swap
         end do
 710     continue
      end do
 740  continue
      return
      end

      complex function cexpf(z)
      complex z,i
      data i/(0., 1.)/
      x=aimag(z)
      cexpf=cos(x)+i*sin(x)
      return
      end

      subroutine vrcp(dr,cr,nt)
      real dr(*),cr(*)
      do i=1,nt
         cr(i)=dr(i)
      end do
      return
      end

      subroutine vccp(ahkl,bhkl,nt)
      complex ahkl(*),bhkl(*)
      do i=1,nt
         bhkl(i)=ahkl(i)
      end do
      return
      end

      subroutine vcpyr(a,b,n)
      real a(*),b(*)
      do i=1,n
         b(i)=a(i)
      end do
      return
      end

      subroutine vcpyi(a,b,n)
      integer a(*),b(*)
      do i=1,n
         b(i)=a(i)
      end do
      return
      end

      subroutine vcpyc(dd,de,n)
      complex dd(*),de(*)
      do j=1,n
         de(j)=dd(j)
      end do
      return
      end

      subroutine norml(x,n)
      real x(*)
      data eps /0.000001/
c     normalization of x
      absh=vabs(x,n)
      if(absh.gt.eps) then
         do i=1,n
            x(i)=x(i)/absh
         end do
         return
      end if
      end

      subroutine unitmtrxi(m,n)
      integer m(n,n)
      do i=1,n
         do j=1,n
            m(i,j)=0
         end do
         m(i,i)=1
      end do
      return
      end

      subroutine unitmtrxr(m,n)
      real m(n,n)
      do i=1,n
         do j=1,n
            m(i,j)=0
         end do
         m(i,i)=1
      end do
      return
      end

      subroutine mcpy3(s1,s2)
      real s1(3,3)
      real s2(3,3)
      do i=1,3
         do j=1,3
            s2(i,j)=s1(i,j)
         end do
      end do
      return
      end

      subroutine mcpyi3(s1,s2)
      integer s1(3,3)
      integer s2(3,3)
      do i=1,3
         do j=1,3
            s2(i,j)=s1(i,j)
         end do
      end do
      return
      end

      subroutine trnsp3(s1)
      real s1(3,3)
      real s2(3,3)
      do i=1,3
         do j=1,3
            s2(i,j)=s1(j,i)
         end do
      end do
      call mcpy3(s2,s1)
      return
      end

      subroutine mcpy(from,to)
      real from(6,6),to(6,6)
      do  i=1,6
         do  j=1,6
            to(i,j)=from(i,j)
         end do
      end do
      return
      end

      subroutine mcpymnr(from,to,m,n)
      real from(m,n),to(m,n)
      do  i=1,m
         do  j=1,n
            to(i,j)=from(i,j)
         end do
      end do
      return
      end

      subroutine mcpymni(from,to,m,n)
      integer from(m,n),to(m,n)
      do  i=1,m
         do  j=1,n
            to(i,j)=from(i,j)
         end do
      end do
      return
      end

      subroutine mcpyi(from,to)
      integer from(6,6),to(6,6)
      do i=1,6
         do j=1,6
            to(i,j)=from(i,j)
         end do
      end do
      return
      end

      subroutine mcpyir(from,to)
      integer from(6,6)
      real to(6,6)
      do i=1,6
         do j=1,6
            to(i,j)=from(i,j)
         end do
      end do
      return
      end

      subroutine mtmpli6(a,b,c)   ! multiply integer 6x6 matrices
      integer a(6,6),b(6,6),c(6,6)
      do i=1,6
         do j=1,6
            c(i,j)=0.
            do k=1,6
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplirmno(a,b,c,m,n,o)
c     multiply integer mxn and real nxo matrices
      integer m,n,o
      integer a(m,n)
      real b(n,o),c(m,o)
      do i=1,m
         do k=1,o
            c(i,k)=0.
            do j=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmpl(a,b,c)
      real a(6,6),b(6,6),c(6,6)
      do i=1,6
         do j=1,6
            c(i,j)=0.
            do k=1,6
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplmno(a,b,c,m,n,o)
      integer m,n,o
      real a(m,n),b(n,o),c(m,o)
      do i=1,m
         do j=1,o
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplmnoi(a,b,c,m,n,o)
      integer m,n,o
      integer a(m,n),b(n,o),c(m,o)
      do i=1,m
         do j=1,o
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine trnsp(sm)
      real smd(6,6),sm(6,6)
      do i=1,6
         do j=1,6
            smd(i,j)=sm(j,i)
         end do
      end do
      do i=1,6
         do j=1,6
            sm(i,j)=smd(i,j)
         end do
      end do
      return
      end

      subroutine trnspi(am)
      integer am(6,6),bm(6,6)
      call mcpyi(am,bm)
      do i=1,6
         do j=1,6
            am(i,j)=bm(j,i)
         end do
      end do
      return
      end

      subroutine vrcpy(dd,de)
      real dd(*),de(*)
      do i=1,6
         de(i)=dd(i)
      end do
      return
      end

      function ivicmp(h,hr,n)
      integer h(*),hr(*)
      ivicmp=0
      do i=1,n
         if(h(i).ne.hr(i)) return
      end do
      ivicmp=1
      return
      end

      function ivrcmp(x,y,n,eps)
      real x(*),y(*)
      ivrcmp=0
      do i=1,n
         if(abs(x(i)-y(i)).gt.eps) return
      end do
      ivrcmp=1
      return
      end

      function vabs(x,n)
c*****absolute value of n-dimensional vector x
      dimension x(*)
      vabs=0
      do i=1,n
         vabs=vabs+x(i)**2
      end do
      vabs=sqrt(vabs)
      return
      end

      subroutine vaddr(v1,v2,v3,n)
      real v1(*),v2(*),v3(*)
      do j=1,n
         v3(j)=v1(j)+v2(j)
      end do
      return
      end

      subroutine vaddi(v1,v2,v3,n)
      integer v1(*),v2(*),v3(*)
      do j=1,n
         v3(j)=v1(j)+v2(j)
      end do
      return
      end

      subroutine vsubr(v1,v2,v3,n)
      real v1(*),v2(*),v3(*)
      do j=1,n
         v3(j)=v1(j)-v2(j)
      end do
      return
      end

      subroutine vsubi(v1,v2,v3,n)
      integer v1(*),v2(*),v3(*)
      do j=1,n
         v3(j)=v1(j)-v2(j)
      end do
      return
      end

      subroutine vnegate(x,n)
c*****absolute value of n-dimensional vector x
      real x(*)
      call vnegater(x,n)
      end

      subroutine vnegater(x,n)
c*****absolute value of n-dimensional vector x
      real x(*)
      do i=1,n
         x(i)=-x(i)
      end do
      return
      end

      subroutine vnegatei(x,n)
c*****absolute value of n-dimensional vector x
      integer x(*)
      do i=1,n
         x(i)=-x(i)
      end do
      return
      end

      function vinp(x,y,n)
c*****inner product of n-dimensional vactors, x,y
      real x(*),y(*)
      vinp=0
      do i=1,n
         vinp=vinp+x(i)*y(i)
      end do
      return
      end

      integer function vinpi(h,k,n)
      integer h(*),k(*)
      vinpi=0
      do i=1,n
         vinpi=vinpi+h(i)*k(i)
      end do
      return
      end

      function vinpri(x,h,n)
      integer h(*)
      real x(*)
      vinpri=0
      do i=1,n
         vinpri=vinpri+h(i)*x(i)
      end do
      return
      end

      function vinpir(h,x,n)
      integer h(*)
      real x(*)
      vinpir=0
      do i=1,n
         vinpir=vinpir+h(i)*x(i)
      end do
      return
      end

      function vdinp(h,x,n)
c*****inner product of n-dimensional integral and real vectors
      integer h(*)
      real x(*)
      vdinp=0
      do i=1,n
         vdinp=vdinp+h(i)*x(i)
      end do
      return
      end

      subroutine qsortd(x,st,ip,nx)
c     quick sort (descending order of x)
c     nx: the number of data x
c     ip: the initial order
c     st: a work array
      real x(*)
      integer r,s,st(0:1,*),ip(*)
      do i=1,nx
        ip(i)=i
      end do
      s=1
      st(0,1)=1
      st(1,1)=nx
    1 l=st(0,s)
      r=st(1,s)
      s=s-1
    2 i=l
      j=r
      xt=x((l+r)/2)
 3    if(i.lt.nx) then
         if(x(i).gt.xt) then
            i=i+1
            go to 3
         end if
      endif
 4    if(j.gt.1) then
         if(xt.gt.x(j)) then
            j=j-1
            go to 4
         end if
      endif
      if(i.le.j) then
        temp=x(j)
        x(j)=x(i)
        x(i)=temp
        itemp=ip(j)
        ip(j)=ip(i)
        ip(i)=itemp
        if(i.le.nx.and.j.ge.1) then
           i=i+1
           j=j-1
           go to 3
        end if
      endif
      if(j-l.le.r-i) go to 5
      if(i.lt.r) then
         s=s+1
         st(0,s)=i
         st(1,s)=r
      endif
      r=j
      go to 6
    5 if(l.lt.j) then
         s=s+1
         st(0,s)=l
         st(1,s)=j
      endif
      l=i
    6 if(l.lt.r) go to 2
      if(s.ne.0) go to 1
      return
      end

      subroutine qsort(x,st,ip,nx)
c     quick sort (ascending order of x)
c     nx: the number of data x
c     ip: the initial order
c     st: a work array
      real x(*)
      integer r,s,st(0:1,*),ip(*)
      do i=1,nx
         ip(i)=i
      end do
      s=1
      st(0,1)=1
      st(1,1)=nx
 1    l=st(0,s)
      r=st(1,s)
      s=s-1
 2    i=l
      j=r
      xt=x((l+r)/2)
 3    if(i.lt.nx) then
         if(x(i).lt.xt) then
            i=i+1
            go to 3
         endif
      endif
 4    if(j.gt.1) then
         if(xt.lt.x(j)) then
            j=j-1
            go to 4
         endif
      endif
      if(i.le.j) then
         temp=x(j)
         x(j)=x(i)
         x(i)=temp
         itemp=ip(j)
         ip(j)=ip(i)
         ip(i)=itemp
         if(i.le.nx.and.j.ge.1) then
            i=i+1
            j=j-1
            go to 3
         end if
      endif
      if(j-l.le.r-i) go to 5
      if(i.lt.r) then
         s=s+1
         st(0,s)=i
         st(1,s)=r
      endif
      r=j
      go to 6
 5    if(l.lt.j) then
         s=s+1
         st(0,s)=l
         st(1,s)=j
      endif
      l=i
 6    if(l.lt.r) go to 2
      if(s.ne.0) go to 1
      return
      end

      subroutine zerovl(vr,nt)
      logical vr(*)
      do i=1,nt
         vr(i)=.false.
      end do
      return
      end

      subroutine zerovr(vr,nt)
      real vr(*)
      do i=1,nt
         vr(i)=0.
      end do
      return
      end

      subroutine zerovi(vi,nt)
      integer vi(*)
      do i=1,nt
         vi(i)=0
      end do
      return
      end

      subroutine zerovc(vi,nt)
      complex vi(*)
      do i=1,nt
         vi(i)=(0.,0.)
      end do
      return
      end

      subroutine zeromtrxr(mr,m,n)
      real mr(m,n)
      do i=1,m
         do j=1,n
            mr(i,j)=0
         end do
      end do
      return
      end

      subroutine zeromtrxi(mi,m,n)
      integer mi(m,n)
      do i=1,m
         do j=1,n
            mi(i,j)=0
         end do
      end do
      return
      end

      subroutine zeromtrxc(mi,m,n)
      complex mi(m,n)
      do i=1,m
         do j=1,n
            mi(i,j)=(0.,0.)
         end do
      end do
      return
      end

      subroutine mtmltijk(x,y,z,i,j,k)
      real x(i,j), y(j,k), z(i,k)
      do id=1,i
         do kd=1,k
            z(id,kd)=0
            do jd=1,j
               z(id,kd)=z(id,kd)+x(id,jd)*y(jd,kd)
            end do
         end do
      end do
      return
      end

      subroutine mtmlt(x,y,z,n)
      real x(n,n), y(n,n), z(n,n)
      do i=1,n
         do j=1,n
            z(i,j)=0
            do k=1,n
               z(i,j)=z(i,j)+x(i,k)*y(k,j)
            end do
         end do
      end do
      return
      end

c      function todeg(ang)  ! angle in radian to degree
c      data pi /3.1415926536/
c      todeg=ang*180/pi
c      return
c      end

      function getpi()
      data pi /3.1415926536/
      getpi=pi
      return
      end

      function todeg(ang)       ! degree to radian
      data pi /3.1415926536/
      todeg=ang*180/pi
      return
      end

      function torad(ang)       ! radian to degree
      data pi /3.1415926536/
      torad=ang*pi/180
      return
      end

      function atan3(y,x)
      real x,y
      data pi /3.1415926536/
      data eps /0.00001/
      if(abs(x).lt.eps) then
         if(y.gt.eps) then
            atan3=pi/2
         else
            atan3=-pi/2
         end if
      else
         atan3=atan2(y,x)       ! -pi < atan3 <= pi
      end if
      return
      end

      function atan0(y,x)
      data pi/3.141592/, eps/0.00001/
      if(abs(x).lt.eps) then
         if(y.gt.0) then
            atan0=pi/2
         else
            atan0=-pi/2
         end if
      else if(abs(y).lt.0) then
         atan0=0.
      else
         atan0=atan2(y,x)
      end if
      return
      end

      subroutine wtvctrr(str,m,n)
      character*(*) str
      real m(*)
      write(6,'(a,$)') str
      write(6,*) (m(j),j=1,n)
      return
      end

      subroutine wtvctrrf(str,m,n,frmt)
      character*(*) str, frmt
      real m(*)
      write(6,'(a,$)') str
      write(6,frmt) (m(j),j=1,n)
      return
      end

      subroutine wtvctri(str,m,n)
      character*(*) str
      integer m(*)
      write(6,'(a,$)') str
      write(6,*) (m(j),j=1,n)
      return
      end

      subroutine wtvctrif(str,m,n,frmt)
      character*(*) str, frmt
      integer m(*)
      write(6,'(a,$)') str
      write(6,frmt) (m(j),j=1,n)
      return
      end

      subroutine wtmtrxr(str,m,n)
      character*(*) str
      real m(n,*)
      write(6,'(a)') str
      do i=1,n
         write(6,*) (m(i,j),j=1,n)
      end do
      return
      end

      subroutine wtmtrxi(str,m,n)
      character*(*) str
      integer m(n,*)
      write(6,'(a)') str
      do i=1,n
         write(6,*) (m(i,j),j=1,n)
      end do
      return
      end

      subroutine wtmtrxif(str,mtrx,n,frmt)
      character*(*) str,frmt
      integer mtrx(n,n)
      write(6,'(a)') str
      do i=1,n
         write(6,frmt) (mtrx(i,j),j=1,n)
      end do
      return
      end

      subroutine wtmtrxrf(str,mtrx,n,frmt)
      character*(*) str,frmt
      real mtrx(n,n)
      write(6,'(a)') str
      do i=1,n
         write(6,frmt) (mtrx(i,j),j=1,n)
      end do
      return
      end

c*************************************************************
c     random number generator
      function ranp(iran)
c*************************************************************
      iran=12869*iran+6925
      iran=mod(iran,2**15)
      ranp=float(iran)/2.0**15
      return
      end

      subroutine vscaler(v1,fac,v2,n)
      real v1(*),v2(*),fac
      do j=1,n
         v2(j)=v1(j)*fac
      end do
      return
      end

      subroutine vscalei(v1,fac,v2,n)
      integer v1(*),v2(*),fac
      do j=1,n
         v2(j)=v1(j)*fac
      end do
      return
      end
