      subroutine pksearch3d(cr,idm,pkmin) ! peak search in 3D space
      real cr(0:*)
      integer hmax(6)   ! number of divisions along x y z axes
      integer hkl(6),hd(6),h,k,l
      parameter (npkmax=10000)
      real x(6,npkmax),p(npkmax)
      integer st(npkmax,0:1),ip(npkmax)
      integer getxyztoj,getnt
      num=0  ! number of peak
      call gethmax(hmax)
      nt=getnt()
      do i=0,nt-1
         f=cr(i)
c        write(6,*) 'f',f
         call getitoxyz(i,hkl)
c     if(f.gt.0) then   ! positive peak
         
         do h=hkl(1)-1,hkl(1)+1
            do k=hkl(2)-1,hkl(2)+1
               do l=hkl(3)-1,hkl(3)+1
                  hd(1)=h
                  hd(2)=k
                  hd(3)=l
                  call tounitcell(hkl) ! added Apr. 22, 2004
                  j=getxyztoj(hd)
                  if(f.gt.0.and.cr(j).gt.f) goto 10
                  if(f.lt.0.and.cr(j).lt.f) goto 10
               end do
            end do
         end do
c     f is a local peak in 3D space
         if(abs(f).gt.pkmin) then
            num=num+1
            if(num.gt.npkmax) then
               write(6,*) 'num,npkmax=',num,npkmax
               call quit('too many peaks')
            end if
            do l=1,3
c               x(l,num)=float(hkl(l)-1)/hmax(l)
               x(l,num)=float(hkl(l))/hmax(l)
            end do
            p(num)=cr(i)
c     write(6,*) 'peak and x,y,z ',p(num),x(num),y(num),z(num)
         end if
c      end if
 10      continue
      end do

c      write(6,*)
c      write(6,*)

c     call qsort(p,st,ip,num)
c      do i=num,1,-1
      call qsortd(p,st,ip,num)
      do i=1,num
         j=ip(i)
         write(6,'(a,f10.1,3f10.6)') 'peak and x,y,z ',
     *        p(i),(x(k,j),k=1,3)
      end do
      return
      end

      subroutine pksearchnd(cr,pkmin)  ! peaksearch in nD space
      real cr(0:*)
      integer hmax(6)   ! number of divisions along x y z axes
      integer hkl(6),hd(6),h,k,l,m,n,o,dh(6)

      parameter (npkmax=100000)
      real x(6,npkmax),p(npkmax),xd(6)
      integer st(npkmax,0:1),ip(npkmax)
      integer getxyztoj,getnt
      logical isMem,isFourier,isDFourier

      if(pkmin.eq.0) then
         return
      end if

      num=0  ! number of peak
      call gethmax(hmax)
      nt=getnt()
      call getsmtr(ismtr)
      call getidm(idm)
      write(6,*) 'nt in pksearchnd',nt
      write(6,'(a,6i4)') 'hmax in pksearchnd',hmax
      write(6,*) 'idm in pksearchnd',idm
      do j=1,idm
         dh(j)=1
      end do
      do j=idm+1,6
         dh(j)=0
      end do
      pkmax=0
      do i=0,nt-1
         if(cr(i).gt.pkmax) then
            pkmax=cr(i)
         end if
      end do
      pkm=pkmax*pkmin

      do i=0,nt-1
         f=cr(i)
c        write(6,*) 'f',f
         call getitoxyz(i,hkl)  ! zero offset
c        if(f.gt.0) then   ! positive peak
c        get positive or negative peak
         do h=hkl(1)-dh(1),hkl(1)+dh(1)
            do k=hkl(2)-dh(2),hkl(2)+dh(2)
               do l=hkl(3)-dh(3),hkl(3)+dh(3)
                  do m=hkl(4)-dh(4),hkl(4)+dh(4)
                     do n=hkl(5)-dh(5),hkl(5)+dh(5)
                        do o=hkl(6)-dh(6),hkl(6)+dh(6)
                           hd(1)=h
                           hd(2)=k
                           hd(3)=l
                           hd(4)=m
                           hd(5)=n
                           hd(6)=o
                           call tounitcell(hd) ! use tounitcell Apr. 22, 2004
                           j=getxyztoj(hd)
c                           if(j.gt.nt) then
c                              write(6,*) 'hd=',(hd(jd),jd=1,idm)
c                              write(6,*) 'J=',j,' nt=',nt
c                              call quit('j > nt in pksearch')
c                           else if(j.lt.0) then
c                              write(6,*) 'j=',j
c                              call quit('j <= 0 in pksearch')
c                           end if
                           if(f.gt.0.and.cr(j).gt.f) goto 10
                           if(f.lt.0.and.cr(j).lt.f) goto 10
                        end do
                     end do
                  end do
               end do
            end do
         end do
c     f is a local peak in nD space
         if(isMem().or.isFourier()) then
            fd=f                ! exclude negative peak
         else if(isDFourier()) then
            fd=abs(f)           ! include both positive and negative peak
         end if
         if(fd.gt.pkm) then
            num=num+1
            if(num.gt.npkmax) then
               write(6,*) 'num,npkmax=',num,npkmax
               write(6,*) 'pkmax,pkmin=',pkmax,pkmin
               call quit('too many peaks. use larger pkmin')
            end if
            do j=1,idm
               xd(j)=float(hkl(j))/hmax(j)
            end do
            call ptocx(xd)      ! primitive to centered
            call smtrx(xd,x(1,num),ismtr) ! similarity transformation
            call reduc(x(1,num)) ! x in the unit cell
            p(num)=f
c     write(6,*) 'peak and coordinates',
c     *              p(i),(x(j,num),j=1,idm)
         end if
c     end if
 10      continue
      end do

c      write(6,*)
      write(6,*) 'num=',num
      if(num.eq.0) then  ! number of peaks is zero
         return
      end if
      call indatm(num,x,p)
      return
      end

      subroutine getpeakcrd(cr,xmn,xmx) ! get peak coordinates
      real cr(0:*)
      real xmn(6),xmx(6)

      integer hm(6),hmax(6)
      real xmin(6),xmax(6)
      integer getnt
      call getidm(idm)
      call gethmax(hmax)
      call getsmtr(ismtr)
      nt=getnt()
      dmin=cr(0)
      dmax=cr(0)
      imin=0
      imax=0
      do i=1,nt-1
         if(cr(i).lt.dmin) then
            dmin=cr(i)
            imin=i
         end if
         if(cr(i).gt.dmax) then
            dmax=cr(i)
            imax=i
         end if
      end do
c     call getitoxyz(imin,hm,idm)
      call getitoxyz(imin,hm)
      do i=1,idm
         xmin(i)=float(hm(i))/hmax(i)
      end do
c     call wtvctrrf('xmin=',xmin,idm,'(6f10.4)')
      call ptocx(xmin)          ! primitive to centered
      call smtrx(xmin,xmn,ismtr) ! similarity transformation
      call reduc(xmn)           ! x in the unit cell

c     write(6,*) 'imax,xyz=',imax,xyz
c      call getitoxyz(imax,hm,idm)
      call getitoxyz(imax,hm)
      do i=1,idm
         xmax(i)=float(hm(i))/hmax(i)
      end do
c     call wtvctrrf('xmax=',xmax,idm,'(6f10.4)')
      call ptocx(xmax)          ! primitive to centered
      call smtrx(xmax,xmx,ismtr) ! similarity transformation
      call reduc(xmx)           ! x in the unit cell
      return
      end

      subroutine indatm(na,xa,p)
c*****select independent atoms******
      real xa(6,*)
      real p(*)
      integer icell(3,8)
      integer ipc(2,12)
      parameter (mamax=500)
      real x0(6,mamax)
      integer iord(mamax),isub(mamax)
      parameter (namax=100000)
      real zmin(namax)
      integer ias(namax)
      integer ip(namax),st(namax*2)
      integer rcpmp1

c     integer isk(0:48,namax),irs(0:48,namax)
      parameter (ieqmax=300)
      integer isk(0:ieqmax,namax),irs(0:ieqmax,namax)
      real mpl(namax)

      character(8) atom
      common /cltc/ atom(namax)
      character(8) atom0(mamax)
      real p0(mamax)
      character(10) watm

      data icell/0,0,0,1,0,0,1,1,0,0,1,0,0,0,1,1,0,1,1,1,1,0,1,1/
      data ipc/1,2,2,3,3,4,4,1,5,6,6,7,7,8,8,5,1,5,2,6,3,7,4,8/
      data eps/0.001/,eps0/0.00001/
c     na: number of peaks <=namax
c     xa: coordinates of peak
c     p:  peak height
c*****select independent atoms******
      write(6,*) 'number of peaks ',na

c     isys=0                    ! crystal
c     call setsys(isys)

      call setsym()
      call getsym(nsymo,icent,nctr)
      call zerovi(ias,na)
      if(na.gt.namax) call quit('na > namax')

      na0=0
      do i=1,na
         if(ias(i).eq.0) then
            na0=na0+1           ! number of independent atoms
            if(na0.gt.mamax) then
               call quit('number of independent atoms > mamax')
            end if
            call vcpyr(xa(1,i),x0(1,na0),6)
            p0(na0)=p(i)
            ias(i)=1
c     mark atoms equivalent to x0(na0)
            do j=1,na
               if(ias(j).eq.0) then
                  ieq=iequiv0(xa(1,j),x0(1,na0))
                  if(ieq.eq.1) then
                     ias(j)=2
                  end if
               end if
            end do
         end if
      end do

c     write(6,*) 'ias=',(ias(j),j=1,na)
      write(6,*) 'number of independent peaks ',na0
      call sitesy1(na0,mpl,x0,isk,irs) 
      write(6,*) '  no  multpl. peak     coordinates'
      call qsortd(p0,st,ip,na0)
      call getidm(idm)
      do i=1,na0
         j=ip(i)
         write(6,'(i4,1x,i4,1x,f10.2,6f10.5)') i,isk(0,j),p0(i),
     *        (x0(k,j),k=1,idm)
      end do
      return
      end

      integer function iequiv0(xa,x0)
c     iequiv0=1 if xa and x0 are equivalent under the space group
      real xa(*),x0(*)
c     real rx(3)
      real rx(6)
      integer rcpmp1
      call getnsymo(nsymo)
      call geticent(icent)
c     integer rr
c     common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      
      call getnsymo(nsymo)
      call geticent(icent)
      call getsym(nsymo,icent,nctr)
c     write(6,*) 'nsymo=',nsymo,' icent=',icent
      
      do ns=1,nsymo
         do ic=0,icent
            call getrx(xa,rx,ns,ic)
            call reduc(rx)
            if(rcpmp1(rx,x0).eq.1) then
               iequiv0=1
               return
            end if
         end do
      end do
      iequiv0=0
      return
      end

      subroutine setsym()
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      common /cctr/ ctr(6,0:48),nctr
      common /cnct/ nct
      nct=nctr+1
      return
      end

      subroutine getsym(ns,ic,nctrd)
      common /cctr/ ctr(6,0:48),nctr
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      common /cnct/ nct
      ns=nsymo
      ic=icent
      nctrd=nct
      return
      end
