      logical function isFreecmp(i) ! free vector components
c     dummy for quasicrystals
      isFreecmp=.true.
      return
      end

      subroutine setitt(hmax)
      integer hmax(*)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      integer itt
      common /sym1/ itt(6,60)  ! for mem etc.
      do js=1,3
         do i=1,nsymo
            do j=1,6
               itt(j,i)=tt(j,i)*hmax(j)+sign(0.0001,tt(j,i))
               itt(j,i)=mod(itt(j,i),hmax(j))
            end do
         end do
      end do
      return
      end

      subroutine setsmopprm()
c     set symmetry operators for primitive lattice
      character brv
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      call getbrv(brv)
c      write(6,*) 'brv=',brv
c     call quit('stop in setsmopprm')

      if(brv.eq.'p') then        ! primitive lattice
         return
      else if(brv.eq.'f') then   ! face centered lattice
         do i=1,nsymo
            call ftopsmop(rr(1,1,i),tt(1,i))
         end do
      else if(brv.eq.'i') then   ! body centered lattice
         do i=1,nsymo
            call itopsmop(rr(1,1,i),tt(1,i))
         end do
      else
         call quit('invalid brv')
      end if
      idm=6
c     call wtsymo(rr,tt,nsymo,idm)      
      return
      end

      subroutine setsmopcnt()
c     restore symmetry operators for centered lattice
      character brv
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      call getbrv(brv)
      if(brv.eq.'p') then        ! primitive lattice
         return
      else if(brv.eq.'f') then   ! face centered lattice
         do i=1,nsymo
            call ptofsmop(rr(1,1,i),tt(1,i))
         end do
      else if(brv.eq.'i') then   ! body centered lattice
         do i=1,nsymo
            call ptoismop(rr(1,1,i),tt(1,i))
         end do
      else
         call quit('invalid brv')
      end if
      return
      end

      function getyt(hd,ns,ic)
      integer hd(*)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      call getidm(idm)
      yt=0
      do l=1,idm
         if(ic.eq.0) then
            yt=yt+hd(l)*tt(l,ns)
         else
            yt=yt-hd(l)*tt(l,ns)
         end if
      end do
      getyt=yt
      return
      end
     
      subroutine geticent(icentd)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      icentd=icent
      return
      end

      subroutine getnsymo(nsymod)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      nsymod=nsymo
      return
      end

      subroutine rdsymo(na,brv)
      common /cwflag/ iwflag(6)
      character brv
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      common /extcr/ nextnc,icef(7,60)
      common /cdim/ idm,nde
      common /cskip/ iskip,ltype
      integer imps(60),rg(6,6,5)
      real tg(6,5)
      character*60 coord
      character cltd(5)
      data cltd/'p','i','f','s','c'/      
c     initialization
      call getinp(inpu)
      call getout(iout)
c     iwflag(3)=1
      ige=1
c     
c     read(5,100) nsymo,icent,brv
      call freadi('nsymo=',1,nsymo,1)
      call freadi('icent=',1,icent,0)
      call freadc('brv=',1,brv,0)
      nde=3
      icom=0
c     
      write(iout,210) nsymo,icent,brv
      do i=1,5
         if(brv.eq.cltd(i)) then
            ltype=i
         end if
      end do
      if(ltype.eq.0) then
c     call quit('ltype incorrect')
         write(6,*) '******ltype=0*****'
      end if
      idm=nde+3
c     read(inpu,*) 'symmetry operator'
      call freadr('symmetry operator',0,dummy,1)
      do k=1,nsymo
         read(inpu,'(a)') coord
         call decode(coord,rr,tt,k)
      end do
      if(iwflag(3).eq.1) then
c     if(icent.eq.1) then
         if(icent.eq.1.or.icent.eq.-1) then
            write(iout,2022)
         else
            write(iout,2021)
         end if
         if(ige.eq.1) then
            write(iout,201) 'generating elements'
         end if
         write(iout,'(1h )')
      end if
      nn=nde+1
      if(iwflag(3).eq.1) then
         call wtsymo(rr,tt,nsymo,idm)
      end if
      if(ige.eq.1) then
         call ordr(rr,imps,nsymo,idm)
         do i=1,nsymo
            do j=1,idm
               tg(j,i)=tt(j,i)
               do k=1,idm
                  rg(j,k,i)=rr(j,k,i)
               end do
            end do
         end do
         impt=1
         do i=1,6
            tt(i,1)=0.0
            do j=1,6
               rr(i,j,1)=0.0
               rr(i,i,1)=1.0
            end do
         end do
         do ns=1,nsymo
            imp=imps(ns)
c     modified to include the pure translation
            if(imp.eq.1) then
               if(tg(1,ns).ne.0.or.tg(2,ns).ne.0.or.tg(3,ns).ne.0
     *              .or.tg(4,ns).ne.0.or.tg(5,ns).ne.0.or.tg(6,ns).ne.0)
     *              imp=2
            end if
            do i=2,imp
               do j=1,impt
                  mp1=j+(i-2)*impt
                  mp2=j+(i-1)*impt
                  call mpso(rg,tg,ns,rr,tt,mp1,mp2,idm)
               end do
            end do
            impt=impt*imp
         end do
         nsymo=impt
         if(iwflag(3).eq.1) then
            write(iout,207)
            write(iout,'(1h )')
            call wtsymo(rr,tt,nsymo,idm)
         end if
      end if
      if(nextnc.eq.0) return
      if(iwflag(3).eq.1) then
         write(iout,231)
      end if
c     do 90 i=1,nextnc
c     read(inpu,100) (icef(j,i),j=1,6),nmod(i)
c     call freadi('mi=',idm+1,icef(1,i),1)
c     if(iwflag(3).eq.1) then
c     write(iout,230) (icef(j,i),j=1,6),nmod(i)
c     write(iout,230) (icef(j,i),j=1,idm+1)
c     end if
c     90   continue
      return
 201  format(a)
 2021 format('symmetry operation',10x,'noncentrosymmetric')
 2022 format('symmetry operation',10x,'centrosymmetric')
 207  format('symmetry operators generated by generating elements')
 210  format('nsymo=',i3,2x,'icent=',i2,2x,'brv=',a)
 231  format('extinction rules for general reflections'/
     *     'm1,m2,..,m6,m of m1*h1+m2*h2+...+m6*h6=m*n')
      end

      logical function isUnitMtrx(r,idm)
      integer r(6,6)
      isUnitMtrx=.false.
      do k=1,idm
         if(r(k,k).ne.1) then
            return
         end if
         do l=1,idm
            if(k.ne.l.and.r(k,l).ne.0) then
               return
            end if
         end do
      end do
      isUnitMtrx=.true.
      return
      end

      subroutine ordr(re,imps,nsymo,idm) ! order of symmetry operators
      integer re(6,6,*),imps(*)
      integer r(6,6),a(6,6),b(6,6)
      logical isUnitMtrx
      data eps/0.001/
      
      call getinp(inpu)
      call getout(iout)
      do i=1,nsymo
         imps(i)=0
         call mcpyi(re(1,1,i),r)
         call mcpyi(r,b)
         do j=1,13
            if(isUnitMtrx(r,idm)) then
               imps(i)=j
               go to 10
            else
c     a=r
               call mcpyi(r,a)
c     r=a*b   ==> r=r*re
               call mtmpli6(a,b,r)
            end if
         end do
 10      continue
      end do
      do i=1,nsymo
         if(imps(i).eq.0.or.imps(i).ge.13) then
            ierror=1
            go to 21
         else
            ierror=0
         end if
      end do
 21   continue
      if(ierror.eq.1) then
         write(iout,'(''error in symmetry operator ?'',a,24i3)')
     *        '  order: ',(imps(i),i=1,nsymo)
      end if
      return
      end

      subroutine wtsymo(rr,tt,nsymo,idm)
      integer rr(6,6,*)
      real tt(6,*)
      common /cwflag/ iwflag(6)
      character*3 wtt(6,60)
      integer wd(3),w
      data wd/6,5,4/,eps/0.001/
      call getinp(inpu)
      call getout(iout)
      w=wd(idm-3)
      ll=(nsymo-1)/w+1
      le=nsymo-(ll-1)*w
      call wtsmop(rr,tt,nsymo,idm-3,3)
      write(iout,'(1h )')
      call getwtt(tt,wtt,nsymo,idm)
c      do 31 ii=1,ll
c      lbgn=(ii-1)*w+1
c      if(ii.ne.ll) lend=lbgn+w-1
c      if(ii.eq.ll) lend=lbgn+le-1
c      do 31 i=1,idm
c      if(idm.eq.4) write(iout,204) ((rr(i,j,k),j=1,idm),wtt(i,k),
c     *                 k=lbgn,lend)
c      if(idm.eq.5) write(iout,205) ((rr(i,j,k),j=1,idm),wtt(i,k),
c     *                 k=lbgn,lend)
c      if(idm.eq.6) write(iout,206) ((rr(i,j,k),j=1,idm),wtt(i,k),
c     *                 k=lbgn,lend)
c      if(i.eq.idm) write(iout,'(1h )')
c 31   continue
      return
 204  format(8(4i2,1x,a,2x))
 205  format(7(5i2,1x,a,2x))
 206  format(6(6i2,1x,a,2x))
      end

      subroutine getwtt(tt,wtt,nsymo,idm)
      real tt(6,*)
      character*3 wtt(6,*)
      real rt(8)
      character*3 wt(8)
      data rt/0.,0.5,0.333333,0.666666,0.25,0.75,0.166666,0.833333/
      data wt/'0','1/2','1/3','2/3','1/4','3/4','1/6','5/6'/
      data eps/0.00001/
      call getinp(inpu)
      call getout(iout)
      do 100 i=1,nsymo
      do 110 j=1,idm
      td=tt(j,i)
      td=mod(td,1.)
      if(td.lt.-eps) then
          td=td+1
      else if(td.gt.1-eps) then
          td=td-1
      end if
          do 120 k=1,8
          if(abs(td-rt(k)).lt.eps) then
               wtt(j,i)=wt(k)
               go to 110
          end if
 120      continue
 110  continue
 100  continue
      return
      end

      subroutine mpso(r1,t1,m1,r2,t2,m2,m3,idm)
      integer r1(6,6,*),r2(6,6,*)
      real t1(6,*),t2(6,*)
      do 10 i=1,idm
         t2(i,m3)=0.0
         do 11 j=1,idm
            t2(i,m3)=t2(i,m3)+r1(i,j,m1)*t2(j,m2)
 11      continue
         t2(i,m3)=t2(i,m3)+t1(i,m1)
         do 12 j=1,idm
            r2(i,j,m3)=0.0
            do 13 k=1,idm
               r2(i,j,m3)=r2(i,j,m3)+r1(i,k,m1)*r2(k,j,m2)
 13         continue
 12      continue
 10   continue
      return
      end

      subroutine sitesy(na,mpl,x,isk,irs) 
      real mpl(*),x(6,*)
      integer isk(0:120,*),irs(0:120,*)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      common /cdim/ idm,nde
      real rx(6)
      real rxs(6,120)
      integer rcomp
      call getsys(isys)
      if(isys.le.2) then
         icentd=icent
         istep=1
      else
         if(icent.eq.0) then
            icentd=icent
            istep=1
         else
            icentd=icent        ! include antisymmetric inversion -1
            istep=icent         ! include antisymmetric inversion -1
         end if
      end if
      do i=1,na
         nsym=0
         nrx=1
         isk(nrx,i)=1
         call savex(x(1,i),rxs(1,nrx))
         do ic=0,icentd,istep
            do ns=1,nsymo
               call getrx(x(1,i),rx,ns,ic)
               do irx=1,nrx
                  if(rcomp(rx,rxs(1,irx)).eq.1) go to 120
               end do
c     site symmetry operator
               nrx=nrx+1
               call savex(rx,rxs(1,nrx))
               if(ic.eq.0) then
                  isk(nrx,i)=ns
               else
                  isk(nrx,i)=ns+nsymo
               end if
 120           continue
c     symmetry operator generating equivalent positions
               if(rcomp(rx,x(1,i)).eq.1) then
                  nsym=nsym+1
                  if(ic.eq.0) then
                     irs(nsym,i)=ns
                  else
                     irs(nsym,i)=ns+nsymo
                  end if
               end if
            end do
         end do
         isk(0,i)=nrx
         irs(0,i)=nsym
         mpl(i)=1
c     if(icent.eq.1) then
         if(icent.eq.1.or.(icent.eq.-1.and.x(6,i).eq.0.)) then
c     compress symmetry element > nsymo
            n=0
            do j=1,isk(0,i)
               if(isk(j,i).gt.nsymo) go to 201
               n=n+1
            end do
 201        continue
c     n: number of equivalent positions generated by given operators
c     isk(0,i): number of equivalent positions generated by given
c     symmetry operators and inversion
            mpl(i)=float(isk(0,i))/(float(n)*2)
            isk(0,i)=n
         end if
      end do
      write(6,*) 'site symmetry group'
      do i=1,na
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(irs(j,i),j=1,irs(0,i))
c     write(6,'(a,i3/(20i4))') 'atom=',i,(irs(j,i),j=1,irs(0,i))
      end do
      write(6,*) 'equivalent position'
      do i=1,na
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(isk(j,i),j=1,isk(0,i))
c     write(6,'(a,i3/(20i4))') 'atom=',i,(isk(j,i),j=1,isk(0,i))
      end do
      write(6,*) 'multiplicity'
      do i=1,na
         write(6,*) 'atom',i,'  ',mpl(i)
      end do
      return
      end

      subroutine sitesy1(na,mpl,x,isk,irs) 
      real mpl(*),x(6,*)
      integer isk(0:120,*),irs(0:120,*)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      common /cdim/ idm,nde
      real rx(6)
      real rxs(6,120)
      integer rcomp
      call getsys(isys)
      if(isys.le.2) then
         icentd=icent
         istep=1
      else
         if(icent.eq.0) then
            icentd=icent
            istep=1
         else
            icentd=icent
            istep=icent
         end if
      end if
      do i=1,na
         nsym=0
         nrx=1
         isk(nrx,i)=1
         call savex(x(1,i),rxs(1,nrx))
c     do 130 ic=0,icent
         do ic=0,icentd,istep
            do ns=1,nsymo
               call getrx(x(1,i),rx,ns,ic)
               do irx=1,nrx
                  if(rcomp(rx,rxs(1,irx)).eq.1) go to 120
               end do
c     site symmetry operator
               nrx=nrx+1
               call savex(rx,rxs(1,nrx))
               if(ic.eq.0) then
                  isk(nrx,i)=ns
               else
                  isk(nrx,i)=ns+nsymo
               end if
 120           continue
c     symmetry operator generating equivalent positions
               if(rcomp(rx,x(1,i)).eq.1) then
                  nsym=nsym+1
                  if(ic.eq.0) then
                     irs(nsym,i)=ns
                  else
                     irs(nsym,i)=ns+nsymo
                  end if
               end if
            end do
         end do
         isk(0,i)=nrx
         irs(0,i)=nsym
         mpl(i)=1
      end do
      write(6,*) 'site symmetry group'
      do i=1,na
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(irs(j,i),j=1,irs(0,i))
c     write(6,'(a,i3/(20i4))') 'atom=',i,(irs(j,i),j=1,irs(0,i))
      end do
      write(6,*) 'equivalent position'
      do i=1,na
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(isk(j,i),j=1,isk(0,i))
c     write(6,'(a,i3/(20i4))') 'atom=',i,(isk(j,i),j=1,isk(0,i))
      end do
      return
      end

      subroutine getrxi(x,rx,ns,ic) ! symmetry operation for grid points
      integer x(*),rx(*)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      integer itt
      common /sym1/ itt(6,60)  ! for mem etc.
      common /cdim/ idm,nde
      do i=1,idm
         rx(i)=0
         do j=1,idm
            rx(i)=rx(i)+rr(i,j,ns)*x(j)
         end do
         rx(i)=rx(i)+itt(i,ns)
         if(ic.eq.1) then
            rx(i)=-rx(i)
         end if
      end do
      call reduci(rx)           ! reduce grid points into the unit cell
      return
      end

      subroutine getrx(x,rx,ns,ic) ! symmetry operation for coordinates
      real x(*),rx(*)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      call getsys(isys)
      if(isys.le.2) then
         do i=1,6
            rx(i)=0.
            do j=1,6
               rx(i)=rx(i)+rr(i,j,ns)*x(j)
            end do
            rx(i)=rx(i)+tt(i,ns)
            if(ic.eq.1) then
               rx(i)=-rx(i)
            end if
         end do
      else
*************************************
         do i=1,6
            rx(i)=0.
            do j=1,6
               rx(i)=rx(i)+rr(i,j,ns)*x(j)
            end do
            if(i.le.5) then
               rx(i)=rx(i)+tt(i,ns)
               if(ic.eq.1.or.ic.eq.-1) then
                  rx(i)=-rx(i)
               end if
            else if(i.eq.6) then
               if(ic.eq.-1) then
                  rx(i)=-rx(i)
               end if
            end if
         end do
*************************************
      end if
      return
      end

      subroutine gettr(tr,ns,ic)
      real tr(6)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      call vcpyr(tt(1,ns),tr,6)
      if(ic.eq.1) then
         call vnegate(tr,6)
      end if
      return
      end

      integer function multpl(h)
      integer h(*)
      integer hr(6)
      integer hs
      common /cmult/ hs(6,120)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      mul=0
      do ns=1,nsymo
         do j=0,1
            call gethr(h,hr,ns,j)
            do k=1,mul
               if(icomp(hr,hs(1,k)).eq.1) then
                  go to 100
               end if
            end do
            mul=mul+1
            do k=1,6
               hs(k,mul)=hr(k)
            end do
 100        continue
         end do
      end do
      multpl=mul
      return
      end

      subroutine gethr(h,hr,ns,icnt)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      integer h(*),hr(*)
      do i=1,6
         hr(i)=0.
         do j=1,6
            hr(i)=hr(i)+h(j)*rr(j,i,ns)
         end do
         if(icnt.eq.1) then
            hr(i)=-hr(i)
         else if(icnt.eq.-1) then
            hr(i)=-hr(i)
         end if
      end do
      return
      end

      function iequiv(h,heq,neq) 
      integer h(6),heq(6,*)
c     if h is equivalent to n-th heq return n else 0
c     if h is new add it to heq and increment neq
c     therefore neq gives the multiplicity of an independent reflection
      call getidm(idm)
      iequiv=0
      do n=1,neq
         if(icomp(h,heq(1,n)).eq.1) then
c            call wtvctrif('h  =',h,6,'(6i3)')
c            call wtvctrif('heq=',heq(1,n),6,'(6i3)')
            iequiv=n
            return
         end if
      end do
c     new indices
      neq=neq+1
      if(neq.gt.120) then
         write(6,*) 'neq > 120'
         call exit(1)
      end if
      call cpyhkl(h,heq(1,neq))
      iequiv=0
      return
      end

      function iequiv1(h,h0) 
c        if h is equivalent to h0 iequiv=1 else 0
      integer h(6),h0(6)
      integer hr(6)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      do ic=0,icent
         do ns=1,nsymo
            call gethr(h,hr,ns,ic)
            if(icomp(hr,h0).eq.1) then
               iequiv1=1
               return
            end if
         end do
      end do
      iequiv1=0
      return
      end

c      integer function rcomp(x,rx)
c      real x(*),rx(*)
c      common /cdim/ idm,nde
c      common /cskip/ iskip,ltype
c      integer ntrc(3)
c      real trc(6,32,3)
c      data ntrc/1,2,32/
c      data (trc(i,1,1),i=1,6) /6*0.0/
c      data ((trc(i,j,2),i=1,6),j=1,2) /6*0.0,6*0.5/
c      data ((trc(i,j,3),i=1,6),j=1,32) /
c     *   0.0,0.0,0.0,0.0,0.0,0.0,  0.5,0.5,0.0,0.0,0.0,0.0,
c     *   0.5,0.0,0.5,0.0,0.0,0.0,  0.5,0.0,0.0,0.5,0.0,0.0,
c     *   0.5,0.0,0.0,0.0,0.5,0.0,  0.5,0.0,0.0,0.0,0.0,0.5,
c     *   0.0,0.5,0.5,0.0,0.0,0.0,  0.0,0.5,0.0,0.5,0.0,0.0,
c     *   0.0,0.5,0.0,0.0,0.5,0.0,  0.0,0.5,0.0,0.0,0.0,0.5,
c     *   0.0,0.0,0.5,0.5,0.0,0.0,  0.0,0.0,0.5,0.0,0.5,0.0,
c     *   0.0,0.0,0.5,0.0,0.0,0.5,  0.0,0.0,0.0,0.5,0.5,0.0,
c     *   0.0,0.0,0.0,0.5,0.0,0.5,  0.0,0.0,0.0,0.0,0.5,0.5,
c     *   0.0,0.0,0.5,0.5,0.5,0.5,  0.0,0.5,0.0,0.5,0.5,0.5,
c     *   0.0,0.5,0.5,0.0,0.5,0.5,  0.0,0.5,0.5,0.5,0.0,0.5,
c     *   0.0,0.5,0.5,0.5,0.5,0.0,  0.5,0.0,0.0,0.5,0.5,0.5,
c     *   0.5,0.0,0.5,0.0,0.5,0.5,  0.5,0.0,0.5,0.5,0.0,0.5,
c     *   0.5,0.0,0.5,0.5,0.5,0.0,  0.5,0.5,0.0,0.0,0.5,0.5,
c     *   0.5,0.5,0.0,0.5,0.0,0.5,  0.5,0.5,0.0,0.5,0.5,0.0,
c     *   0.5,0.5,0.5,0.0,0.0,0.5,  0.5,0.5,0.5,0.0,0.5,0.0,
c     *   0.5,0.5,0.5,0.5,0.0,0.0,  0.5,0.5,0.5,0.5,0.5,0.5/
c      data eps/0.00001/
cc       ltype=1,2,3 mean p,i,f in icosahedral lattice
c      rcomp=0
c      do 110 j=1,ntrc(ltype)
c           do 100 i=1,6
c           xx=abs(x(i)-rx(i)-trc(i,j,ltype))+eps/2
c           xx=mod(xx,1.)
c           if(xx.gt.1-eps) then
c                xx=abs(xx-1)
c           else if(xx.lt.-1+eps) then
c                xx=abs(xx+1)
c           end if
c           if(xx.gt.eps) go to 110
c 100       continue
c      rcomp=1
c      return
c 110  continue
c      return
c      end

      integer function rcomp(x,rx)
      real x(*),rx(*)
      common /cskip/ iskip,ltype
      real trc(6,32)
      data eps/0.00001/
c     ltype=1,2,3,4,5 mean p,i,f,s,c in icosahedral lattice
      call gettrc(ltype,trc,ntrc)
      call getsys(isys)
      if(isys.le.2) then
         idm=6
      else
         idm=5
      end if
      rcomp=0
      do 110 j=1,ntrc
c           do 100 i=1,6
           do 100 i=1,idm
           xx=abs(x(i)-rx(i)-trc(i,j))+eps/2
           xx=mod(xx,1.)
           if(xx.gt.1.-eps) then
                xx=abs(xx-1.)
           else if(xx.lt.-1.+eps) then
                xx=abs(xx+1.)
           end if
           if(xx.gt.eps) go to 110
 100       continue
      rcomp=1
      return
 110  continue
      return
      end

      subroutine gettrc(ltype,trc0,ntrc0)
      real trc0(6,*)
      integer ntrc(5)
      real trc1(6,1),trc2(6,2),trc3(6,32),trc4(6,1),trc5(6,2)
      data ntrc/1,2,32,1,2/
      data (trc1(i,1),i=1,6) /6*0.0/
      data ((trc2(i,j),i=1,6),j=1,2) /6*0.0,6*0.5/
      data ((trc3(i,j),i=1,6),j=1,32) /
     *   0.0,0.0,0.0,0.0,0.0,0.0,  0.5,0.5,0.0,0.0,0.0,0.0,
     *   0.5,0.0,0.5,0.0,0.0,0.0,  0.5,0.0,0.0,0.5,0.0,0.0,
     *   0.5,0.0,0.0,0.0,0.5,0.0,  0.5,0.0,0.0,0.0,0.0,0.5,
     *   0.0,0.5,0.5,0.0,0.0,0.0,  0.0,0.5,0.0,0.5,0.0,0.0,
     *   0.0,0.5,0.0,0.0,0.5,0.0,  0.0,0.5,0.0,0.0,0.0,0.5,
     *   0.0,0.0,0.5,0.5,0.0,0.0,  0.0,0.0,0.5,0.0,0.5,0.0,
     *   0.0,0.0,0.5,0.0,0.0,0.5,  0.0,0.0,0.0,0.5,0.5,0.0,
     *   0.0,0.0,0.0,0.5,0.0,0.5,  0.0,0.0,0.0,0.0,0.5,0.5,
     *   0.0,0.0,0.5,0.5,0.5,0.5,  0.0,0.5,0.0,0.5,0.5,0.5,
     *   0.0,0.5,0.5,0.0,0.5,0.5,  0.0,0.5,0.5,0.5,0.0,0.5,
     *   0.0,0.5,0.5,0.5,0.5,0.0,  0.5,0.0,0.0,0.5,0.5,0.5,
     *   0.5,0.0,0.5,0.0,0.5,0.5,  0.5,0.0,0.5,0.5,0.0,0.5,
     *   0.5,0.0,0.5,0.5,0.5,0.0,  0.5,0.5,0.0,0.0,0.5,0.5,
     *   0.5,0.5,0.0,0.5,0.0,0.5,  0.5,0.5,0.0,0.5,0.5,0.0,
     *   0.5,0.5,0.5,0.0,0.0,0.5,  0.5,0.5,0.5,0.0,0.5,0.0,
     *   0.5,0.5,0.5,0.5,0.0,0.0,  0.5,0.5,0.5,0.5,0.5,0.5/
      data (trc4(i,1),i=1,6) /6*0.0/
      data ((trc5(i,j),i=1,6),j=1,2) /6*0.0,0.,0.,0.,0.,0.5,0./
      data eps/0.00001/
      call getsys(isys)
c     ltype=1,2,3,4,5 mean p,i,f,s,c in icosahedral lattice
      if(ltype.eq.0.or.ltype.eq.1) then
         ntrc0=1
         ltyped=1
         do j=1,ntrc0
            do i=1,6
               trc0(i,j)=trc1(i,j)
            end do
         end do
      else if(ltype.eq.2) then
         ntrc0=ntrc(ltype)
         ltyped=ltype
         do j=1,ntrc0
            do i=1,6
               trc0(i,j)=trc2(i,j)
            end do
         end do
      else if(ltype.eq.3) then
         ntrc0=ntrc(ltype)
         ltyped=ltype
         do j=1,ntrc0
            do i=1,6
               trc0(i,j)=trc3(i,j)
            end do
         end do
      else if(ltype.eq.4) then
         if(isys.le.2) then
            ntrc0=32
            ltyped=3
            do j=1,ntrc0
               do i=1,6
                  trc0(i,j)=trc3(i,j)
               end do
            end do
         else if(isys.eq.3) then
            ntrc0=1
            ltyped=1
            do j=1,ntrc0
               do i=1,6
                  trc0(i,j)=trc1(i,j)
               end do
            end do
         else if(isys.eq.4) then
            ntrc0=1
            ltyped=1
            do j=1,ntrc0
               do i=1,6
                  trc0(i,j)=trc1(i,j)
               end do
            end do
         else if(isys.eq.5) then
            ntrc0=1
            ltyped=1
            do j=1,ntrc0
               do i=1,6
                  trc0(i,j)=trc1(i,j)
               end do
            end do
         end if
      else if(ltype.eq.5) then
         ntrc0=2
         ltyped=ltype
         do j=1,ntrc0
            do i=1,6
               trc0(i,j)=trc5(i,j)
            end do
         end do
      end if
      return
      end

      subroutine gettrc1(ltype,trc0,ntrc0)
c      this is equivalent to gettrc but does not work in f2c
      real trc0(6,*)
      integer ntrc(5)
      real trc(6,32,5)
      data ntrc/1,2,32,1,2/
      data (trc(i,1,1),i=1,6) /6*0.0/
      data ((trc(i,j,2),i=1,6),j=1,2) /6*0.0,6*0.5/
      data ((trc(i,j,3),i=1,6),j=1,32) /
     *   0.0,0.0,0.0,0.0,0.0,0.0,  0.5,0.5,0.0,0.0,0.0,0.0,
     *   0.5,0.0,0.5,0.0,0.0,0.0,  0.5,0.0,0.0,0.5,0.0,0.0,
     *   0.5,0.0,0.0,0.0,0.5,0.0,  0.5,0.0,0.0,0.0,0.0,0.5,
     *   0.0,0.5,0.5,0.0,0.0,0.0,  0.0,0.5,0.0,0.5,0.0,0.0,
     *   0.0,0.5,0.0,0.0,0.5,0.0,  0.0,0.5,0.0,0.0,0.0,0.5,
     *   0.0,0.0,0.5,0.5,0.0,0.0,  0.0,0.0,0.5,0.0,0.5,0.0,
     *   0.0,0.0,0.5,0.0,0.0,0.5,  0.0,0.0,0.0,0.5,0.5,0.0,
     *   0.0,0.0,0.0,0.5,0.0,0.5,  0.0,0.0,0.0,0.0,0.5,0.5,
     *   0.0,0.0,0.5,0.5,0.5,0.5,  0.0,0.5,0.0,0.5,0.5,0.5,
     *   0.0,0.5,0.5,0.0,0.5,0.5,  0.0,0.5,0.5,0.5,0.0,0.5,
     *   0.0,0.5,0.5,0.5,0.5,0.0,  0.5,0.0,0.0,0.5,0.5,0.5,
     *   0.5,0.0,0.5,0.0,0.5,0.5,  0.5,0.0,0.5,0.5,0.0,0.5,
     *   0.5,0.0,0.5,0.5,0.5,0.0,  0.5,0.5,0.0,0.0,0.5,0.5,
     *   0.5,0.5,0.0,0.5,0.0,0.5,  0.5,0.5,0.0,0.5,0.5,0.0,
     *   0.5,0.5,0.5,0.0,0.0,0.5,  0.5,0.5,0.5,0.0,0.5,0.0,
     *   0.5,0.5,0.5,0.5,0.0,0.0,  0.5,0.5,0.5,0.5,0.5,0.5/
      data (trc(i,1,4),i=1,6) /6*0.0/
      data ((trc(i,j,5),i=1,6),j=1,2) /6*0.0,0.,0.,0.,0.,0.5,0./
      data eps/0.00001/
      call getsys(isys)
c     ltype=1,2,3,4,5 mean p,i,f,s,c in icosahedral lattice
      if(ltype.eq.0) then
         ntrc0=1
         ltyped=1
      else if(ltype.le.3) then
         ntrc0=ntrc(ltype)
         ltyped=ltype
      else if(ltype.eq.4) then
         if(isys.le.2) then
            ntrc0=32
            ltyped=3
         else if(isys.eq.3) then
            ntrc0=1
            ltyped=1
         else if(isys.eq.4) then
            ntrc0=1
            ltyped=1
         else if(isys.eq.5) then
            ntrc0=1
            ltyped=1
         end if
      else if(ltype.eq.5) then
c         ntrc0=ntrc(ltype)
         ntrc0=2
         ltyped=ltype
      end if
      do 110 j=1,ntrc0
           do 100 i=1,6
              trc0(i,j)=trc(i,j,ltyped)
 100       continue
 110  continue
      return
      end

      subroutine wtsmop(r1,t1,nsymo,d1,d2)
c*******************************************************************
c         representation of symmetry operators in the i.t. format
c*******************************************************************
      implicit integer (a-z)
      dimension r1(6,6,*)
      dimension r(6,6),lenc(60),ip(16)
      real t1(6,*),t(6),eps,cnt2(27,6),rtr(7)
      character xyz(6)
c     for (d2+d1) dimensional case
c      character*31 z1(60),bl
      character*61 z1(60),bl
      character*3 ntr(7)
      data xyz/'x','y','z','t','u','v'/
      data ntr/'1/2','1/3','2/3','1/4','3/4','1/6','5/6'/
      data rtr/0.5,0.333333,0.666666,0.25,0.75,0.166666,0.833333/
      data bl/'                            '/
      call getinp(inpu)
      call getout(iout)
      eps=0.00001
      d3=d1+d2
c******** write centering translations *********
c      if(ncnt.gt.1) then
c      do 50 i=1,ncnt
c      z1(i)=bl
c      cp=0
c      if(i.eq.1) then
c           z1(1)(1:1)='('
c           cp=1
c      end if
c      do 51 j=1,d3
c          do 52 k=1,7
c          if(abs(rtr(k)-cnt2(i,j)).lt.eps) then
c               z1(i)(cp+1:cp+3)=ntr(k)
c               cp=cp+3
c               go to 51
c          end if
c 52       continue
c          if(abs(cnt2(i,j)).lt.eps) then
c               z1(i)(cp+1:cp+1)='0'
c               cp=cp+1
c          end if
c 51   continue
c      if(i.lt.ncnt) then
c           z1(i)(cp+1:cp+1)=';'
c           cp=cp+1
c      else
c           z1(i)(cp+1:cp+1)=')'
c           cp=cp+1
c      end if
c      ip(i)=cp
c 50   continue
c      write(iout,'(6a)') (z1(i)(1:ip(i)),i=1,ncnt)
c      end if
c******** write symmetry operators *******
      do 10 ii=1,nsymo
         cp=1
         do i=1,d3
            t(i)=t1(i,ii)
            do  j=1,d3
               r(i,j)=r1(i,j,ii)
            end do
         end do
         do i=1,d3
            t(i)=mod(t(i),1.)
            if(t(i).lt.eps) then
               t(i)=t(i)+1
            else if(t(i).gt.1.0-eps) then
               t(i)=t(i)-1
            end if
         end do
         do i=1,22
            z1(ii)=bl
         end do
         do 13 i=1,d3
            do j=1,7
               if(abs(t(i)-rtr(j)).le.eps) then
                  z1(ii)(cp:cp+2)=ntr(j)
                  cp=cp+3
                  go to 132
               end if
            end do
 132        continue
            do 12 j=1,d3
               if(j.le.d2) then
                  k=j
               else if(j.gt.d2) then
                  k=j+(3-d2)
               end if
               if(r(i,j).eq.1) then
                  if(cp.eq.1) then
                     z1(ii)(cp:cp)=xyz(k)
                     cp=cp+1
                  else if(z1(ii)(cp-1:cp-1).eq.',') then
                     z1(ii)(cp:cp)=xyz(k)
                     cp=cp+1
                  else
                     z1(ii)(cp:cp+1)='+'//xyz(k)
                     cp=cp+2
                  end if
               else if(r(i,j).eq.-1) then
                  z1(ii)(cp:cp+1)='-'//xyz(k)
                  cp=cp+2
               end if
               if(j.eq.d3.and.i.ne.d3) then
                  z1(ii)(cp:cp)=','
                  cp=cp+1
               else if(j.eq.d3.and.i.eq.d3) then
                  z1(ii)(cp:cp)=';'
                  cp=cp+1
               end if
 12         continue
 13      continue
         lenc(ii)=istrln(z1(ii))
 10   continue
      write(iout,'(6(i3,1x,a,1x))') (ii,z1(ii)(1:lenc(ii)),
     *     ii=1,nsymo)
      return
      end

      subroutine decode(coord,r,t,n)
c     symmetry operation in I.T into matrix representation
      character coord*60
      integer r(6,6,*)
      real t(6,*)
      common /cdim/ idm,nde
      character sym(6)*20,xyz(6)
      data xyz/'x','y','z','t','u','v'/
      call getinp(inpu)
      call getout(iout)
c     position of ',' 
      i=1
      do k=1,idm-1
         m=index(coord(i:60),',')
         if(m.eq.0) call quit(' incorrect symmetry operation')
         sym(k)=coord(i:i+m-2)
         i=i+m
      end do
      sym(idm)=coord(i:60)
c     initialize
      do j=1,6
         t(j,n)=0
         do k=1,6
            r(j,k,n)=0
         end do
      end do
      do j=idm+1,6
         r(j,j,n)=1
      end do

c     rotation matrix
      do j=1,idm
         do k=1,idm
            i=index(sym(j),xyz(k))
            if(i.gt.0) then
               if(i.eq.1) then
                  r(j,k,n)=1
               else
                  if(sym(j)(i-1:i-1).eq.'+') then
                     r(j,k,n)=1
                  else
                     r(j,k,n)=-1
                  endif
               endif
            endif
         end do
c     
c     translation vector
         i=index(sym(j),'/')
         if(i.gt.0) then
            read(sym(j)(i-1:i-1),'(i1)') n1
            read(sym(j)(i+1:i+1),'(i1)') n2
            t(j,n)=float(n1)/float(n2)
            if(i.ne.2.and.sym(j)(i-2:i-2).eq.'-') t(j,n)=-t(j,n)
         endif
      end do
      end

      subroutine getnpt(ttd)    ! return nonprimitive translations
      real ttd(6,*)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      do i=1,nsymo
         call vcpyr(tt(1,i),ttd(1,i),6)
      end do
      return
      end

      subroutine cpyhkl(h1,h2)  ! copy h1 to h2
      integer h1(*),h2(*)
      call getidm(idm)
      do i=1,idm
         h2(i)=h1(i)
      end do
      do i=idm+1,6
         h2(i)=0
      end do
      return
      end

      subroutine setidm(idmd)
      common /cdim/ idm,nde
      idm=idmd
c     write(6,*) 'idm',idm
      return
      end

      subroutine getidm(idmd)
      common /cdim/ idm,nde
      idmd=idm
      return
      end

      subroutine getallqe(hkl,qe,nt)
      real qe(*)
      integer hkl(6,*)
      real q(6)
      call getsys(isys)
      do i=1,nt
         call getqe(hkl(1,i),q) ! for quasicrystals
         qe(i)=vabs(q,3)
      end do
      return
      end
