      subroutine fftm(a,b,n,m,isn,icon)
      complex a(*)
      real b(*)
      integer n(*)
      parameter (nhklt=125)   ! 5**3
c     parameter (nhklt=1730)  ! 12**3 (+2)
c     parameter (nhklt=2744)  ! 14**3
c     parameter (nhklt=3375)  ! 15**3
c     parameter (nhklt=4096)  ! 16**3
c     parameter (nhklt=5832)  ! 18**3
      real*4    c(nhklt*nhklt),d(nhklt*nhklt)
      nt=1
      do 50 i=1,m
         nt=nt*n(i)
 50   continue
      if(nt.gt.nhklt*nhklt) then
         call quit('nt > nhklt*nhklt in fftm')
      end if
      if(isn.eq.1) then
         do 10 i=1,nt
            c(i)=real(a(i))
            d(i)=aimag(a(i))
 10      continue
         call cft1(c,d,n,m,isn,icon)
         do 20 i=1,nt
            b(i)=c(i)
 20      continue
      else if(isn.eq.-1) then
         do 30 i=1,nt
            c(i)=b(i)
            d(i)=0
 30      continue
         call cft1(c,d,n,m,isn,icon)
         do 40 i=1,nt
            a(i)=cmplx(c(i),d(i))
 40      continue
      else
         call quit('invalid isn in fftm')
      end if
      return
      end

c     ******************************************************************
      subroutine cft1(a,b,n,m,isn,icon)
      implicit real*4 (a-h,o-z)
      dimension  a(*),b(*),n(*),mcode(6)
     *           ,nfac(11),np(209),vw(92)
      data       mcode/2hf1,2h2-,2h11,2h-0,2h10,2h1 /
c     -----------------------------------------------------------------
c         check the parameter .
c     -----------------------------------------------------------------
      if(m) 10,10,20
   10 icon=30000
      goto 8000
c
   20 maxp=210
      maxf=23
      i2=24
      i3=47
      i4=70
c     -----------------------------------------------------------------
c         charry out the multivariate transform by succesive calls
c         of singlevariable transform .
c     -----------------------------------------------------------------
      nt=1
      do 30 i=1,m
   30 nt=nt*n(i)
      ns=1
      do 40 i=1,m
      maxn=11
c
c     --- call ucftm , which evaluates the singlevariable transforms
c         using mixed radix fast fourier transform algorithm ,---------
c
      call udft1(a,b,nt,n(i),ns,isn,
     *            nfac,maxn,np,maxp,vw,vw(i2),vw(i3),vw(i4),maxf,icon)
      if(icon) 8000,40,8000
   40 ns=ns*n(i)
c
 8000 call mgssl(icon,mcode)
      return
      end

c*    *** ucftm  ***   *   *********************************************
c     *                                                                *
c     *   ssl2 copyright fujitsu ltd. 1979                             *
c     *                                                                *
c     *   slave          ucftm,ducftm,qucftm           version-1       *
c     *                                                                *
c     *   f12-11-0101    cftm                                          *
c     *                                                                *
c     *   author....j.mikami            1978.9                         *
c     *   coder.....j.mikami            1978.9                         *
c     *   improver                                     level-001       *
c     *                                                                *
c     *   'ucftm' evaluates the some sets of discrete complex fourier  *
c     *   transform , or its inverse transform using mixed radix       *
c     *   fast fourier transform algorithm .                           *
c     *                                                                *
c     *   usage                                                        *
c     *        call ucftm(a,b,nt,n,ns,isn,                             *
c     *                  nfac,maxn,np,maxp,rt,ct,bt,sk,maxf,icon)      *
c     *          a,b ....given real parts and imaginary parts of the   *
c     *                    time series data .                          *
c     *              ....resultant real parts and imaginary parts of   *
c     *                    the fourier coefficients .                  *
c     *                    1-dimensional array , size is nt .          *
c     *          nt  ....given the total number of the data .          *
c     *          n   ....given the term number of the transform .      *
c     *          ns  ....given the spanning number of consecutive      *
c     *                    nt data while n terms transform .           *
c     *                    (see. remark)                               *
c     *          isn ....given the control information .               *
c     *                    isn=+1 : fourier transform .                *
c     *                    isn=-1 : inverse fourier transform .        *
c     *          nfac....resultant decomposed factors.                 *
c     *                    1-dimensional array , size is maxn .        *
c     *          maxn....given maximum count of prime factors .        *
c     *          np  ....auxiliary 1 dimensional array, size is maxp . *
c     *          maxp....given maximum number of square free factors   *
c     *                    product .                                   *
c     *          rt  ....auxiliary 1 dimensional array, size is maxf . *
c     *          ct  ....auxiliary 1 dimensional array, size is maxf . *
c     *          bt  ....auxiliary 1 dimensional array, size is maxf . *
c     *          sk  ....auxiliary 1 dimensional array, size is maxf . *
c     *          maxf....given maximum prime factor .                  *
c     *          icon....resultant condition code .                    *
c     *                        0...normal end .                        *
c     *                    30000...parameter error (nt,n,ns,isn)       *
c     *                                                                *
c     *   method                                                       *
c     *        mixed radix fast fourier transform algorithm .          *
c     *                                                                *
c     *   slave subroutine                                             *
c     *        none                                                    *
c     *                                                                *
c     *   remark                                                       *
c     *        'this routine is normarization free , so that by two    *
c     *         succesive calls as following                           *
c     *             call ucftm(a,b,nt,n,ns,1,.......)                  *
c     *             call ucftm(a,b,nt,n,ns,-1,.......)                 *
c     *         , resultant values is scaled by n of original values . *
c     *        'this routine has applicability for multivaliate        *
c     *         transform .                                            *
c     *         let us say , for 3-variate transform ( the term of     *
c     *         each variable are n1 , n2 and n3 ) ,                   *
c     *                .                                               *
c     *             call ucftm(a,b,n1*n2*n3,n1,1,isn,.......)          *
c     *             call ucftm(a,b,n1*n2*n3,n2,n1,isn,.......)         *
c     *             call ucftm(a,b,n1*n2*n3,n3,n1*n2,isn,.......)      *
c     *                .                                               *
c     *         in this case , the multivariate data is indexed        *
c     *         according to the fortran array element successor       *
c     *         function .                                             *
c     ******************************************************************
      subroutine udft1(a,b,nt,n,ns,isn,
     *                  nfac,maxn,np,maxp,rt,ck,bt,sk,maxf,icon)
      implicit real*4 (a-h,o-z)
      dimension  a(*),b(*)
      dimension  nfac(*),np(*)
      dimension  rt(*),ck(*),bt(*),sk(*)
      icon=0
      if(ns.le.0.or.nt.lt.n.or.nt.lt.ns.or.isn.eq.0) goto 9000
      if(n.eq.1) goto 8000
      inc=isn
      one=1.0d0
      rad=-8.0d0*atan(one)
      s72=rad/5.0d0
      c72=cos(s72)
      s72=sin(s72)
      s75=0.75d0
      s120=-sqrt(s75)
      if(isn) 10,10,20
   10 s72=-s72
      s120=-s120
      rad=-rad
      inc=-inc
   20 ntt=inc*nt
      ntt1=ntt-inc
      ls=inc*ns
      ksp=ls*n
      ks=ksp
      radf=rad*ls*0.5d0
      i=0
      jf=0
c     ------------------------------------------------------------------
c         decompose n into its prime factors.
c         square factors are arranged symmetrically about the factors
c         of the square-free portion of n .
c     ------------------------------------------------------------------
      m=0
      k=n
      goto 40
c     --- seek square factors of 4 . -----------------------------------
   30 m=m+1
      if(maxn.lt.m) goto 9300
      nfac(m)=4
      k=k/16
   40 if(mod(k,16)) 50,30,50
   50 j=3
      jj=9
      goto 70
c     --- seek square factors of 3,5,7,..... ---------------------------
   60 m=m+1
      if(j.gt.maxf) goto 9100
      if(maxn.lt.m) goto 9300
      nfac(m)=j
      k=k/jj
   70 if(mod(k,jj)) 80,60,80
   80 j=j+2
      jj=j*j
      if(jj.le.k) goto 70
      if(k.gt.4) goto 90
      kt=m
      if(maxn.lt.m+1) goto 9300
      nfac(m+1)=k
      if(k.ne.1) m=m+1
      goto 170
c     --- seek square factors of 2 . -----------------------------------
   90 if(mod(k,4)) 110,100,110
  100 m=m+1
      if(maxn.lt.m) goto 9300
      nfac(m)=2
      k=k/4
  110 kt=m
      jm=1
c     --- seek square free factor of 2 . ------------------------------
      if(mod(k,2)) 130,120,130
  120 m=m+1
      jm=2
      nfac(m)=2
      k=k/2
  130 j=3
c     --- seek square free factors of 3,5,7,..... ----------------------
  140 if(mod(k,j)) 160,150,160
  150 m=m+1
      jm=jm*j
      if(j.gt.maxf) goto 9200
      if(maxn.lt.m) goto 9300
      if(jm.gt.maxp) goto 9400
      nfac(m)=j
      k=k/j
  160 j=j+2
      if(j.le.k) goto 140
  170 if(kt) 180,1000,180
  180 j=kt
  190 m=m+1
      if(maxn.lt.m) goto 9300
      nfac(m)=nfac(j)
      j=j-1
      if(j) 190,1000,190
 1000 maxn=m
      sd=radf/dfloat(ksp)
      cd=2.0d0*sin(sd)**2
      sd=sin(sd+sd)
      k0=1
      i=i+1
      k=nfac(i)
      kspt=ksp
      ksp=ksp/k
      if(k.eq.2) goto 2000
      if(k.eq.3) goto 3000
      if(k.eq.4) goto 4000
      if(k.eq.5) goto 5000
      goto 6000
c     ------------------------------------------------------------------
c         start 2 terms local transforms with rotation .
c     ------------------------------------------------------------------
 2000 k1=ksp+2
  210 k2=k0+ksp
      ak=a(k2)
      a(k2)=a(k0)-ak
      a(k0)=a(k0)+ak
      bk=b(k2)
      b(k2)=b(k0)-bk
      b(k0)=b(k0)+bk
      k0=k2+ksp
      if(k0.le.ntt1) goto 210
      k0=k0-ntt1
      if(k0.le.ls) goto 210
      if(k0.gt.ksp) goto 800
  220 c1=1.0d0-cd
      s1=sd
  230 k2=k0+ksp
      bk=b(k0)-b(k2)
      ak=a(k0)-a(k2)
      a(k0)=a(k0)+a(k2)
      a(k2)=c1*ak-s1*bk
      b(k0)=b(k0)+b(k2)
      b(k2)=s1*ak+c1*bk
      k0=k2+ksp
      if(k0.lt.ntt) goto 230
      k2=k0-ntt
      c1=-c1
      k0=k1-k2
      if(k0.gt.k2) goto 230
      ak=c1-(cd*c1+sd*s1)
      s1=(sd*c1-cd*s1)+s1
      c1=1.5d0-0.5d0*(ak*ak+s1*s1)
      s1=c1*s1
      c1=c1*ak
      k0=k0+ls
      if(k0.lt.k2) goto 230
      k1=k1+inc+inc
      k0=(k1-ksp)/2+ls
      if(k0.le.ls+ls) goto 220
      goto 1000
c     ------------------------------------------------------------------
c          start 3 terms local transforms without rotation .
c     ------------------------------------------------------------------
 3000 k1=k0+ksp
      k2=k1+ksp
      ak=a(k0)
      aj=a(k1)+a(k2)
      a(k0)=ak+aj
      bk=b(k0)
      bj=b(k1)+b(k2)
      b(k0)=bk+bj
      ak=-0.5d0*aj+ak
      bk=-0.5d0*bj+bk
      aj=(a(k1)-a(k2))*s120
      bj=(b(k1)-b(k2))*s120
      a(k1)=ak-bj
      a(k2)=ak+bj
      b(k1)=bk+aj
      b(k2)=bk-aj
      k0=k2+ksp
      if(k0.lt.ntt1) goto 3000
      k0=k0-ntt1
      if(k0.le.ksp) goto 3000
      goto 7000
c     ------------------------------------------------------------------
c         start 4 terms local transforms with rotation .
c     ------------------------------------------------------------------
 4000 c1=1.0d0
      s1=0
  420 k1=k0+ksp
      k2=k1+ksp
      k3=k2+ksp
      akp=a(k0)+a(k2)
      akm=a(k0)-a(k2)
      ajp=a(k1)+a(k3)
      ajm=a(k1)-a(k3)
      a(k0)=akp+ajp
      ajp=akp-ajp
      bkp=b(k0)+b(k2)
      bkm=b(k0)-b(k2)
      bjp=b(k1)+b(k3)
      bjm=b(k1)-b(k3)
      b(k0)=bkp+bjp
      bjp=bkp-bjp
      if(isn) 430,430,440
  430 akp=akm-bjm
      akm=akm+bjm
      bkp=bkm+ajm
      bkm=bkm-ajm
      goto 450
  440 akp=akm+bjm
      akm=akm-bjm
      bkp=bkm-ajm
      bkm=bkm+ajm
  450 if(s1) 460,470,460
  460 a(k1)=akp*c1-bkp*s1
      a(k2)=ajp*c2-bjp*s2
      a(k3)=akm*c3-bkm*s3
      b(k1)=akp*s1+bkp*c1
      b(k2)=ajp*s2+bjp*c2
      b(k3)=akm*s3+bkm*c3
      goto 480
  470 a(k1)=akp
      a(k2)=ajp
      a(k3)=akm
      b(k1)=bkp
      b(k2)=bjp
      b(k3)=bkm
  480 k0=k3+ksp
      if(k0.le.ntt) goto 420
      c2=c1-(cd*c1+sd*s1)
      s1=(sd*c1-cd*s1)+s1
      c1=1.5d0-0.5d0*(c2*c2+s1*s1)
      s1=c1*s1
      c1=c1*c2
      c2=c1*c1-s1*s1
      s2=2.0d0*c1*s1
      c3=c2*c1-s2*s1
      s3=c2*s1+s2*c1
      k0=k0-ntt+ls
      if(k0.le.ksp) goto 420
      k0=k0-ksp+inc
      if(k0.le.ls) goto 4000
      if(ksp.eq.ls) goto 800
      goto 1000
c     ------------------------------------------------------------------
c         start 5 terms local transforms without rotation .
c     ------------------------------------------------------------------
 5000 c2=c72*c72-s72*s72
      s2=2.0d0*c72*s72
  520 k1=k0+ksp
      k2=k1+ksp
      k3=k2+ksp
      k4=k3+ksp
      akp=a(k1)+a(k4)
      akm=a(k1)-a(k4)
      ajp=a(k2)+a(k3)
      ajm=a(k2)-a(k3)
      bkp=b(k1)+b(k4)
      bkm=b(k1)-b(k4)
      bjp=b(k2)+b(k3)
      bjm=b(k2)-b(k3)
      aa=a(k0)
      bb=b(k0)
      a(k0)=aa+akp+ajp
      b(k0)=bb+bkp+bjp
      ak=akp*c72+ajp*c2+aa
      bk=bkp*c72+bjp*c2+bb
      aj=akm*s72+ajm*s2
      bj=bkm*s72+bjm*s2
      a(k1)=ak-bj
      a(k4)=ak+bj
      b(k1)=bk+aj
      b(k4)=bk-aj
      ak=akp*c2+ajp*c72+aa
      bk=bkp*c2+bjp*c72+bb
      aj=akm*s2-ajm*s72
      bj=bkm*s2-bjm*s72
      a(k2)=ak-bj
      a(k3)=ak+bj
      b(k2)=bk+aj
      b(k3)=bk-aj
      k0=k4+ksp
      if(k0.lt.ntt1) goto 520
      k0=k0-ntt1
      if(k0.le.ksp) goto 520
      goto 7000
c     ------------------------------------------------------------------
c         start local transforms for odd factor without rotation .
c     ------------------------------------------------------------------
 6000 if(k.eq.jf) goto 640
      jf=k
      s1=rad/dfloat(k)
      c1=cos(s1)
      s1=sin(s1)
      ck(jf)=1.0d0
      sk(jf)=0.0d0
      j=1
  630 ck(j)=ck(k)*c1+sk(k)*s1
      sk(j)=ck(k)*s1-sk(k)*c1
      k=k-1
      ck(k)=ck(j)
      sk(k)=-sk(j)
      j=j+1
      if(j.lt.k) goto 630
  640 k1=k0
      k2=k0+kspt
      aa=a(k0)
      bb=b(k0)
      ak=aa
      bk=bb
      j=1
      k1=k1+ksp
  650 k2=k2-ksp
      j=j+1
      rt(j)=a(k1)+a(k2)
      ak=rt(j)+ak
      bt(j)=b(k1)+b(k2)
      bk=bt(j)+bk
      j=j+1
      rt(j)=a(k1)-a(k2)
      bt(j)=b(k1)-b(k2)
      k1=k1+ksp
      if(k1.lt.k2) goto 650
      a(k0)=ak
      b(k0)=bk
      k1=k0
      k2=k0+kspt
      j=1
  660 k1=k1+ksp
      k2=k2-ksp
      jj=j
      ak=aa
      bk=bb
      aj=0.0d0
      bj=0.0d0
      k=1
  670 k=k+1
      ak=rt(k)*ck(jj)+ak
      bk=bt(k)*ck(jj)+bk
      k=k+1
      aj=rt(k)*sk(jj)+aj
      bj=bt(k)*sk(jj)+bj
      jj=jj+j
      if(jj.gt.jf) jj=jj-jf
      if(k.lt.jf) goto 670
      k=jf-j
      a(k1)=ak-bj
      a(k2)=ak+bj
      b(k1)=bk+aj
      b(k2)=bk-aj
      j=j+1
      if(j.lt.k) goto 660
      k0=k0+kspt
      if(k0.le.ntt1) goto 640
      k0=k0-ntt1
      if(k0.le.ksp) goto 640
 7000 if(i.eq.m) goto 800
c     ------------------------------------------------------------------
c         multiply by rotation factor (except for factor of 2 and 4) .
c     ------------------------------------------------------------------
      k0=ls+1
  710 c2=1.0d0-cd
      s1=sd
  720 c1=c2
      s2=s1
      k0=k0+ksp
  730 ak=a(k0)
      a(k0)=c2*ak-s2*b(k0)
      b(k0)=s2*ak+c2*b(k0)
      k0=k0+kspt
      if(k0.le.ntt) goto 730
      ak=s1*s2
      s2=s1*c2+c1*s2
      c2=c1*c2-ak
      k0=k0-ntt+ksp
      if(k0.le.kspt) goto 730
      c2=c1-(cd*c1+sd*s1)
      s1=s1+(sd*c1-cd*s1)
      c1=1.5d0-0.5d0*(c2*c2+s1*s1)
      s1=c1*s1
      c2=c1*c2
      k0=k0-kspt+ls
      if(k0.le.ksp) goto 720
      k0=k0-ksp+ls+inc
      if(k0.le.ls+ls) goto 710
      goto 1000
c     ------------------------------------------------------------------
c         permutation for square factor of n .
c     ------------------------------------------------------------------
  800 np(1)=ks
      if(kt.eq.0) goto 890
      k=kt+kt+1
      if(m.lt.k) k=k-1
      j=1
      np(k+1)=ls
  810 np(j+1)=np(j)/nfac(j)
      np(k)=np(k+1)*nfac(j)
      j=j+1
      k=k-1
      if(j.lt.k) goto 810
      k3=np(k+1)
      ksp=np(2)
      k0=ls+1
      k2=ksp+1
      j=1
      if(n.ne.nt) goto 850
  820 ak=a(k0)
      a(k0)=a(k2)
      a(k2)=ak
      bk=b(k0)
      b(k0)=b(k2)
      b(k2)=bk
      k0=k0+inc
      k2=ksp+k2
      if(k2.lt.ks) goto 820
  830 k2=k2-np(j)
      j=j+1
      k2=np(j+1)+k2
      if(k2.gt.np(j)) goto 830
      j=1
  840 if(k0.lt.k2) goto 820
      k0=k0+inc
      k2=ksp+k2
      if(k2.lt.ks) goto 840
      if(k0.lt.ks) goto 830
      ls=k3
      goto 890
  850 k=k0+ls
  860 ak=a(k0)
      a(k0)=a(k2)
      a(k2)=ak
      bk=b(k0)
      b(k0)=b(k2)
      b(k2)=bk
      k0=k0+inc
      k2=k2+inc
      if(k0.lt.k) goto 860
      k0=k0+ks-ls
      k2=k2+ks-ls
      if(k0.lt.ntt) goto 850
      k2=k2-ntt+ksp
      k0=k0-ntt+ls
      if(k2.lt.ks) goto 850
  870 k2=k2-np(j)
      j=j+1
      k2=np(j+1)+k2
      if(k2.gt.np(j)) goto 870
      j=1
  880 if(k0.lt.k2) goto 850
      k0=k0+ls
      k2=ksp+k2
      if(k2.lt.ks) goto 880
      if(k0.lt.ks) goto 870
      ls=k3
  890 if(2*kt+1.ge.m) goto 8000
c     ------------------------------------------------------------------
c         permutation for square free factor of n .
c     ------------------------------------------------------------------
      kspt=np(kt+1)
      j=m-kt
      nfac(j+1)=1
  900 nfac(j)=nfac(j)*nfac(j+1)
      j=j-1
      if(j.ne.kt) goto 900
      kt=kt+1
      ntt1=nfac(kt)-1
      jj=0
      j=0
      goto 930
  910 jj=jj-k2
      k2=k0
      k=k+1
      k0=nfac(k)
  920 jj=k0+jj
      if(jj.ge.k2) goto 910
      np(j)=jj
  930 k2=nfac(kt)
      k=kt+1
      k0=nfac(k)
      j=j+1
      if(j.le.ntt1) goto 920
      j=0
      goto 950
  940 k=k0
      k0=np(k)
      np(k)=-k0
      if(k0.ne.j) goto 940
      k3=k0
  950 j=j+1
      k0=np(j)
      if(k0.lt.0) goto 950
      if(k0.ne.j) goto 940
      np(j)=-j
      if(j.ne.ntt1) goto 950
      maxf=inc*maxf
  960 j=k3+1
      ntt=ntt-kspt
      i=ntt-inc+1
      if(ntt) 8000,970,970
  970 j=j-1
      if(np(j).lt.0) goto 970
      jj=ls
  975 ksp=jj
      if(jj.gt.maxf) ksp=maxf
      jj=jj-ksp
      k=np(j)
      k0=ls*k+i+jj
      k1=k0+ksp
      k2=0
  980 k2=k2+1
      rt(k2)=a(k1)
      bt(k2)=b(k1)
      k1=k1-inc
      if(k1.ne.k0) goto 980
  985 k1=k0+ksp
      k2=k1-ls*(k+np(k))
      k=-np(k)
  990 a(k1)=a(k2)
      b(k1)=b(k2)
      k1=k1-inc
      k2=k2-inc
      if(k1.ne.k0) goto 990
      k0=k2
      if(k.ne.j) goto 985
      k1=k0+ksp
      k2=0
  995 k2=k2+1
      a(k1)=rt(k2)
      b(k1)=bt(k2)
      k1=k1-inc
      if(k1.ne.k0) goto 995
      if(jj.ne.0) goto 975
      if(j.ne.1) goto 970
      goto 960
c
 8000 return
c
 9000 icon=30000
      return
 9100 icon=29100
      maxf=j
      return
 9200 icon=29200
      maxf=j
      return
 9300 icon=29300
      return
 9400 icon=29400
      return
      end
c*    *** mgssl  ***   *   *********************************************
c     *                                                                *
c     *   ssl2 copyright fujitsu ltd. 1979                             *
c     *                                                                *
c     *   slave          mgssl                         version-1       *
c     *                                                                *
c     *   author....j.mikami            1976.7                         *
c     *   coder.....j.mikami            1976.7                         *
c     *   improver                                     level-001       *
c     *                                                                *
c     *   'mgssl' prints the condition message of ssl2 subroutine .    *
c     *   this routine has subentry 'mgset' .                          *
c     *   'mgset' sets the control information for 'mgssl' .           *
c     *                                                                *
c     *   usage                                                        *
c     *        call mgssl(icon,mcode)                                  *
c     *          icon....given condition code .                        *
c     *          mcode...given identification code of ssl2 subroutine .*
c     *        call mgset(iset,ifle)                                   *
c     *          iset....given control information of print level .    *
c     *          ifle....given identification number of data set for   *
c     *                    print out .                                 *
c     *                                                                *
c     *   remark                                                       *
c     *        normally 'mgssl' prints nothing .                       *
c     *                                                                *
c     ******************************************************************
      subroutine    mgssl(icon,mcode)
      dimension     mcode(6)
      data          iflg/-1/,ifil/6/
      if(iflg.lt.0)    return
      if(icon.lt.iflg) return
      write(ifil,100)  mcode,icon
      return
      entry         mgset(iset,ifle)
      iflg  = iset * 10000
      if(iset.lt.0)    return
      ifil  = ifle
      return
  100 format(1h ,12h**** ssl2 ( ,6a2,12h) condition ,i5,5h ****)
      end
c
c        calcomp graphic subroutine library for Postscript printers
c
c       postscript files 'temp:ps' is created in the current directry
c
c        circle and ellipse are not included in calcomp
c        but are efficient to draw circles and ellipses
c        by apple laserwriter.  to fill a circle or ellipse
c        or poligon written by line with gray
c        call fillarea with ncol>0 before circle or
c        ellipse
c        line color and text color are set by setcol(ncol)
c        where ncol=hue*10+lightness
c      for black and white Postscript printer ldev=1
c            hue=0 and ncol=lightness (0-10) (0:black, 10:white)
c      for color Postscript printer ldev=2
c        define color map in HLS color indeces 
c        for tectronics 4510 seies rasterizer
c           ncol=0 means default or background color (white: ncol=10)
c              hue      lightness   satulation
c           0 white        0              0
c           0 gray        1-10            0
c           1 blue        1-9            100
c           2 violet      1-9            100
c           3             1-9            100
c           4 magenta     1-9            100
c           5             1-9            100
c           6             1-9            100
c           7 red         1-9            100
c           8             1-9            100
c           9             1-9            100
c          10 yellow      1-9            100
c          11 lite greem  1-9            100
c          12             1-9            100
c          13 green       1-9            100
c          14             1-9            100
c          15             1-9            100
c          16 cyan        1-9            100
c          17             1-9            100
c          18             1-9            100
c                   lightness=0 or a means black or white
c                   satulation=0 means gray
c                   background color =10  white
c                   black  = 1
c                   white  =10
c                   gray           ( 1- 9)
c                   blue   =15     (11-19)
c                   magenta=45     (41-29)
c                   red    =75     (71-39)
c                   yellow =105    (101-109)
c                   green  =135    (131-139)
c                   cyan   =165    (161-169)
c        increase of color index in each color increase darkness
c        for example 0 is white and 20 is black

      subroutine plots(x,y,dev)
      integer dev
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
c      parameter (BUFLEN=256)
      parameter (BUFLEN=80)
      parameter (ibignum = BUFLEN)

      integer name, ldev
      common /calcmp/ name, ldev

      common /cplot/ xx(2),yy(2),idev
c     common /ccolor/ acol(20),bcol(10),ccol,dcol,kdsp,iplt
c     integer acol,bcol,ccol,dcol

      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc
      common /corien/ iorien
      integer gmode(4)
      integer apage, dpage
      common /cpage/ apage,dpage
c        apage: active page for nec pc98 color display
c        dpage: display page for nec pc98 color display
      common /cnopen/ nopen
      save itimes
      data itimes/0/
      data gmode/3,2,0,1/
      cr=char(13)
      nl=char(10)
      esc=char(27)
c     write(trm,fmt='(2a)') nl,' '
      trm= nl//' '
      if(itimes.eq.0) then
         apage=0
         dpage=17
      end if
      sigint = 2
c     junk = signal(sigint,psquit,-1)
      ldev = dev
      offsx=0
      offsy=0
      currx=0
      curry=0
      call sctbl
      if(ldev.eq.1.or.ldev.eq.2) then
          nopen=nopen+1
          call psopen(ldev,nopen,iorien)
          call fillarea(0)
c
          call psout(ldev,'%*****begin program*****')
c
          fact=1
          call psout(ldev,' 1 cm 1 cm scale ')
c           define world space
          if(iorien.eq.2) then
               call psout(ldev,'90 rotate')
               call psout(ldev,'0 -21.1 translate')
          end if
          call psout(ldev,'/cmtx matrix currentmatrix def')
          devx=21.1
          devy=29.7
          rdev=devx/devy
          if(iorien.eq.2) then
c              call cliparea(0.,0.,devy,devx)
c              call psout(ldev,'1 setgray fill')
               call window(0.,0.,devy,devx)
               call viewpt(0.,0.,1.,rdev)
          else
c              call cliparea(0.,0.,devx,devy)
c              call psout(ldev,'1 setgray fill')
               call window(0.,0.,devx,devy)
               call viewpt(0.,0.,rdev,1.)
          end if
          call psout(ldev,'clippath 1 setgray fill')
          call psout(ldev,' 0 setgray ')
          call setfont('/Courier-Bold')
          call newpen(0)
c         call fillcol(10)  ==> setcol(0)  May 16, 1990
c         set default color (black)
          call setcol(0)
          call plot(x,y,-3)
          return
      else
          write(6,*) 'ldev=',ldev,' not allowd'
      end if
      return
      end

      subroutine plote(str)
      character*80 str
      integer name, ldev
      common /calcmp/ name, ldev
      common /corien/ iorien
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc
      integer apage, dpage
      common /cpage/ apage,dpage
      common /cnopen/ nopen
      if(ldev.eq.1.or.ldev.eq.2) then
          call psout(ldev,'showpage ')
          call psclose(ldev,nopen,iorien)
          return
      end if
      return
      end


      subroutine plot(x,y,ipen)
      integer name, ldev
      common /calcmp/ name, ldev
c     move the pen to (x,y)
c     abs(ipen)=2: pen down
c     abs(ipen)=3: pen up
c     ipen < 0: reset the origin at (x,y)
          if (ipen .eq. 2) then
              call thickl(x,y)
              call currps(x,y)
          else if(ipen .eq. 3) then
              call currps(x,y)
          else if(ipen .eq. -2) then
              call thickl(x,y)
              call offset(x,y)
              call currps(0.,0.)
          else if(ipen .eq. -3) then
              call offset(x,y)
              call currps(0.,0.)
          else if(ipen.gt.31) then
              call plote(' ')
              call plots(0.,0.,ldev)
          end if
      return
      end

      subroutine offset(x,y)
      real x,y
      common /cwndv/ x1v,y1v,x2v,y2v
      common /cwndw/ x1w,y1w,x2w,y2w
c        shift origin to x,y in the same viewport
      call window(x1w-x,y1w-y,x2w-x,y2w-y)
      call viewpt(x1v,y1v,x2v,y2v)
      return
      end

      subroutine currps(x,y)
      real x,y
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
          currx=x
          curry=y
      return
      end

c      subroutine move(x,y)
c      call plot(x,y,3)
c      return
c      end

      subroutine rplprn(text,txtd,nchar)
      character*(*) text
      integer nchar
c      parameter (BUFLEN=256)
      parameter (BUFLEN=80)
      character*80 txtd
c     replace ( with \( and ) with \) if any
      nstr=len(text)
      j=0
      iend=min(nchar,nstr)
      do i=1,iend
         if(text(i:i).ne.'('.and.text(i:i).ne.')') then
            j=j+1
            txtd(j:j)=text(i:i)
         else
            j=j+1
            txtd(j:j)='\\'    ! for sun
c           txtd(j:j)='\'     ! for hp or titan
            j=j+1
            txtd(j:j)=text(i:i)
         end if
      end do
      nchar=j
      if(nchar.gt.BUFLEN) then
         write(6,*) 'nchar,text=',nchar,text
         call psquit('nchar > BUFLEN in rplprn')
      end if
      return
      end

      subroutine symbol(x,y,h,text,angle,nchar)
      character*(*) text
      integer name, ldev
      common /calcmp/ name, ldev
      common /csymbl/ nfnt,h0
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      real he,xy(2)
      character trm*2,cr,nl,esc
      character*80 sx,sy,sh,sa
      character*80 str
c      parameter (BUFLEN=256)
      parameter (BUFLEN=80)
      character*80 txtd
      common /plot1/ trm,cr,nl,esc
      data pi/3.141592/
c
c     x, y: coordinates of the starting point of the string in cm
c     h: hight in cm
c     text: text string to be printed
c     angle: angle in degree
c     nchar: number of characters in the string
c
      call rplprn(text,txtd,nchar)
      he=h/2
      xy(1)=x
      xy(2)=y
      if(ldev.eq.1.or.ldev.eq.2) then
          if(nchar.gt.0) then
              call pack1(x,sx,nx)
              call pack1(y,sy,ny)
              if(nfnt.eq.0) then
                  call pack1(h*1.66,sh,nh)
                  nfnt=1
              else
                  call pack1(h/h0,sh,nh)
              end if
              call pack1(angle,sa,na)
              str=sx(1:nx)//' '//sy(1:ny)//' '//sh(1:nh)
     *        //' '//sa(1:na)//' ('//txtd(1:nchar)//') textout'
              call psout(ldev,str)
              h0=h
              return
          else if(nchar.eq.-1.or.nchar.eq.-2) then
               if(nchar.le.-2) then
                   call plot(x,y,2)
               end if
               call cntsym(x,y,txtd(1:1),he)
          end if
      end if
      return
      end

      subroutine supscr(text,nchar)
c       write superscript
      character*(*) text
      integer name, ldev
      common /calcmp/ name, ldev
      common /csymbl/ nfnt,h0
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      character trm*2,cr,nl,esc
      character*80 str
c      parameter (BUFLEN=256)
      parameter (BUFLEN=80)
      character*80 txtd
      common /plot1/ trm,cr,nl,esc
      data pi/3.141592/
c
c     x, y: coordinates of the starting point of the string in cm
c     h: hight in cm
c     text: text string to be printed
c     angle: angle in degree
c     nchar: number of characters in the string
c
      call rplprn(text,txtd,nchar)
      if(ldev.eq.1.or.ldev.eq.2) then
          if(nchar.gt.0) then
              lenstr=nchar+11
              if(lenstr.gt.80) call quit('lenstr > 80 in supscr')
              str=' ('//txtd(1:nchar)//') supshow'
              call psout(ldev,str)
          else
             call psquit('nchar < 0 in supscr')
          end if
      end if
      return
      end

      subroutine subscr(text,nchar)
c       write suberscript
      character*(*) text
      integer name, ldev
      common /calcmp/ name, ldev
      common /csymbl/ nfnt,h0
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      character trm*2,cr,nl,esc
      character*80 str
c      parameter (BUFLEN=256)
      parameter (BUFLEN=80)
      character*80 txtd
      common /plot1/ trm,cr,nl,esc
      data pi/3.141592/
c
c     x, y: coordinates of the starting point of the string in cm
c     h: hight in cm
c     text: text string to be printed
c     angle: angle in degree
c     nchar: number of characters in the string
c
      call rplprn(text,txtd,nchar)
      if(ldev.eq.1.or.ldev.eq.2) then
          if(nchar.gt.0) then
              lenstr=nchar+11
              if(lenstr.gt.80) call quit('lenstr > 80 in subscr')
              str=' ('//txtd(1:nchar)//') subshow'
              call psout(ldev,str)
          else
             call psquit('nchar < 0 in subscr')
          end if
      end if
      return
      end

      subroutine plntxt(text,nchar)
c       write plain text
      character*(*) text
      integer name, ldev
      common /calcmp/ name, ldev
      common /csymbl/ nfnt,h0
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      character trm*2,cr,nl,esc
      character*80 str
c      parameter (BUFLEN=256)
      parameter (BUFLEN=80)
      character*80 txtd
      common /plot1/ trm,cr,nl,esc
      data pi/3.141592/
c
c     x, y: coordinates of the starting point of the string in cm
c     h: hight in cm
c     text: text string to be printed
c     angle: angle in degree
c     nchar: number of characters in the string
c
      call rplprn(text,txtd,nchar)
      if(ldev.eq.1.or.ldev.eq.2) then
          if(nchar.gt.0) then
              str=' ('//txtd(1:nchar)//') show'
              call psout(ldev,str)
          else
             call psquit('nchar < 0 in subscr')
          end if
      end if
      return
      end

      subroutine rsymbol(x,y,h,text,angle,nchar)
      character*(*) text
      integer name, ldev
      common /calcmp/ name, ldev
      common /csymbl/ nfnt,h0
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      real he,xy(2)
      character trm*2,cr,nl,esc
      character*80 sx,sy,sh,sa
      character*80 str
c      parameter (BUFLEN=256)
      parameter (BUFLEN=80)
      character*80 txtd
      common /plot1/ trm,cr,nl,esc
      data pi/3.141592/
c
c     x, y: coordinates of the starting point of the string in cm
c     h: hight in cm
c     text: text string to be printed
c     angle: angle in degree
c     nchar: number of characters in the string
c
      call rplprn(text,txtd,nchar)
      he=h/2
      xy(1)=x
      xy(2)=y
      if(ldev.eq.1.or.ldev.eq.2) then
          if(nchar.gt.0) then
              call pack1(x,sx,nx)
              call pack1(y,sy,ny)
              if(nfnt.eq.0) then
                  call pack1(h*1.66,sh,nh)
                  nfnt=1
              else
                  call pack1(h/h0,sh,nh)
              end if
              call pack1(angle,sa,na)
              str=sx(1:nx)//' '//sy(1:ny)//' '//sh(1:nh)
     *        //' '//sa(1:na)//' ('//txtd(1:nchar)//') rtextout'
              call psout(ldev,str)
              h0=h
              return
          else if(nchar.eq.-1.or.nchar.eq.-2) then
               if(nchar.le.-2) then
                   call plot(x,y,2)
               end if
               call cntsym(x,y,txtd(1:1),he)
          end if
      end if
      return
      end

      subroutine csymbol(x,y,h,text,angle,nchar)
      character*(*) text
      integer name, ldev
      common /calcmp/ name, ldev
      common /csymbl/ nfnt,h0
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      real he,xy(2)
      character trm*2,cr,nl,esc
      character*80 sx,sy,sh,sa
      character*80 str
c      parameter (BUFLEN=256)
      parameter (BUFLEN=80)
      character*80 txtd
      common /plot1/ trm,cr,nl,esc
      data pi/3.141592/
c
c     x, y: coordinates of the starting point of the string in cm
c     h: hight in cm
c     text: text string to be printed
c     angle: angle in degree
c     nchar: number of characters in the string
c
      call rplprn(text,txtd,nchar)
      he=h/2
      xy(1)=x
      xy(2)=y
      if(ldev.eq.1.or.ldev.eq.2) then
          if(nchar.gt.0) then
              call pack1(x,sx,nx)
              call pack1(y,sy,ny)
              if(nfnt.eq.0) then
                  call pack1(h*1.66,sh,nh)
                  nfnt=1
              else
                  call pack1(h/h0,sh,nh)
              end if
              call pack1(angle,sa,na)
              str=sx(1:nx)//' '//sy(1:ny)//' '//sh(1:nh)
     *        //' '//sa(1:na)//' ('//txtd(1:nchar)//') ctextout'
              call psout(ldev,str)
              h0=h
              return
          else if(nchar.eq.-1.or.nchar.eq.-2) then
               if(nchar.le.-2) then
                   call plot(x,y,2)
               end if
               call cntsym(x,y,txtd(1:1),he)
          end if
      end if
      return
      end

      subroutine fraction(x,y,h,c1,c2)
      character*(*) c1,c2
      real x,y,h
      integer name, ldev
      common /calcmp/ name, ldev
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      character*80 sx,sy,sh
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc
      data pi/3.141592/

      if(ldev.eq.1.or.ldev.eq.2) then
c
c     x, y: coordinates of the starting point of the string in cm
c     h: hight in cm
c     c1: numerator
c     c2: denominator
c
          call pack1(x,sx,nx)
          call pack1(y,sy,ny)
          call pack1(h,sh,nh)
          call setfont('/Helvetica')
          call psout(ldev,sh(1:nh)//' scalefont setfont ')
          call psout(ldev,sx(1:nx)//' '//sy(1:ny)//' moveto ')
          call psout(ldev,'(')
          call psout(ldev,c1)
          call psout(ldev,')')
          call psout(ldev,' (')
          call psout(ldev,c2)
          call psout(ldev,') fractionshow ')
          return
      end if
      return
      end

      subroutine setfont(fkey)
      character*(*) fkey
      integer name, ldev
      common /calcmp/ name, ldev
      common /csymbl/ nfnt,h0
      character*80 str

      if(ldev.eq.1.or.ldev.eq.2) then
c
c     fkey: font key (/Helvetica, /Times-Roman, /Times-Italic etc.)
c
c          call psout(ldev,fkey)
          lstr=len(fkey)
          str(1:lstr)=fkey
          call psout(ldev,str(1:lstr)//' findfont setfont ')
          nfnt=0
      end if
      return
      end

      subroutine arrow(x,y,h1,h2,w,ang,kind)
      real x,y,h1,h2,w
      real tailx,taily,tipx,tipy,wlin,warrw,headl
      integer name, ldev
      common /calcmp/ name, ldev
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      character trm*2,cr,nl,esc
      character*80 sx1,sx2,sy1,sy2,sh1,sw1,sw2
      common /plot1/ trm,cr,nl,esc
      data pi/3.141592/

      if(ldev.eq.1.or.ldev.eq.2) then
c     x,y:  coordinates of taile position
c     h1:   length of the arrow
c     h2:   length of the arrow head
c     w:    linewidth
c     ang:  angle in deg
c     kind: 1: arrow for two-fold axis, 2: screw axis
          ff=pi/180
          tailx=x
          taily=y
          tipx=(x+h1*cos(ang*ff))
          tipy=(y+h1*sin(ang*ff))
          wlin=w
          warrw=5*w
          headl=h2
          call pack1(tailx,sx1,nx1)
          call pack1(taily,sy1,ny1)
          call pack1(tipx,sx2,nx2)
          call pack1(tipy,sy2,ny2)
          call pack1(wlin,sw1,nw1)
          call pack1(warrw,sw2,nw2)
          call pack1(headl,sh1,nh1)
          if(kind.eq.1) then
               call psout(ldev,sx1(1:nx1)//' '//sy1(1:ny1)//' '//
     *         sx2(1:nx2)//' '//sy2(1:ny2)//' '//sw1(1:nw1)//' '//
     *         sw2(1:nw2)//' '//sh1(1:nh1)//
     *         ' arrow1 ')
          else if(kind.eq.2) then
               call psout(ldev,sx1(1:nx1)//' '//sy1(1:ny1)//' '//
     *         sx2(1:nx2)//' '//sy2(1:ny2)//' '//sw1(1:nw1)//' '//
     *         sw2(1:nw2)//' '//sh1(1:nh1)//
     *         ' arrow2 ')
          end if
          return
      end if
      return
      end

      subroutine cliparea(x1,y1,x2,y2)
      integer name, ldev
      common /calcmp/ name, ldev
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      character trm*2,cr,nl,esc
      character*80 sx1,sx2,sy1,sy2
      common /plot1/ trm,cr,nl,esc
      data pi/3.141592/

      if(ldev.eq.1.or.ldev.eq.2) then
c     x,y:  coordinates
          call pack1(x1,sx1,nx1)
          call pack1(x2,sx2,nx2)
          call pack1(y1,sy1,ny1)
          call pack1(y2,sy2,ny2)
          call psout(ldev,sx1(1:nx1)//' '//sy1(1:ny1)//' '//
     *            sx2(1:nx2)//' '//sy2(1:ny2)//' '//' cliparea ')
      end if
      return
      end

      subroutine number(x,y,h,num,angle,ndec)
      real x,y,h,num,angle
      integer ndec
      character*80 text, otext
      integer name, ldev
      common /calcmp/ name, ldev
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc
      data pi/3.141592/

c     x,y : coordinates of the starting point of the number in cm
c     h   : hight of the font in cm
c     num : the value of the number to be printed
c     angle : angle in degree
c     ndec : the number of characters after '.'
c
      if(ndec.ge.0) then
            if(ndec.eq.0) write(unit = text, fmt='(f12.0)') num
            if(ndec.eq.1) write(unit = text, fmt='(f12.1)') num
            if(ndec.eq.2) write(unit = text, fmt='(f12.2)') num
            if(ndec.eq.3) write(unit = text, fmt='(f12.3)') num
            if(ndec.eq.4) write(unit = text, fmt='(f12.4)') num
            if(ndec.eq.5) write(unit = text, fmt='(f12.5)') num
            if(ndec.eq.6) write(unit = text, fmt='(f12.6)') num
            if(ndec.eq.7) write(unit = text, fmt='(f12.7)') num
            if(ndec.eq.8) write(unit = text, fmt='(f12.8)') num
            if(ndec.eq.9) write(unit = text, fmt='(f12.9)') num
      else
            inum = num*10**(ndec+1)
            write(unit = text, fmt='(i12)') inum
      end if
c     compress space
      j = 0
      do 100 i=1,12
      if(text(i:i).ne.' ') then
           j = j + 1
           otext(j:j) = text(i:i)
      end if
 100  continue
      otext(j+1:j+1) = char(0)
      if(ldev.eq.1.or.ldev.eq.2) then
           call symbol(x,y,h,otext,angle,j)
          return
      end if
      return
      end

      subroutine thickl(x,y)
      real x,y
      real x1,x2,y1,y2,w
      character*8 scx,scy,sx,sy
      integer name, ldev
      common /calcmp/ name, ldev
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc
      integer pcol
      common /cpcol/ pcol
      real pwdt
      common /cpwdt/ pwdt
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx, offsy, currx, curry, fact
      data eps/0.0001/
c       draw thick line
c     pcol: current pen color
c     pwdt: current pen width
      w=pwdt
      x1=currx
      y1=curry
      x2=x
      y2=y
      if(ldev.eq.1.or.ldev.eq.2) then
          call pack1(x1,scx,ncx)
          call pack1(y1,scy,ncy)
          call pack1(x2,sx,nx)
          call pack1(y2,sy,ny)
          call psout(ldev,scx(1:ncx)//' '//scy(1:ncy)//' '//
     *                  sx(1:nx)//' '//sy(1:ny)//' plt ')
          return
      end if
      return
      end

      subroutine plylin(x,y,n,inc,ity,mrk)
      dimension x(*),y(*)
      integer name, ldev
      common /calcmp/ name, ldev
      character*80 str,sxd,syd
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc
      integer ifill
      common /cfill/ ifill
      integer icol,jcol
      common /ccol/ icol,jcol
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      data eps/0.0001/, imax/500/

      x1=(x(1)-x(n+1))/x(n+2)
      y1=(y(1)-y(n+1))/y(n+2)
      if(ldev.eq.1.or.ldev.eq.2) then
           call psout(ldev,'newpath ')
           if(inc.lt.0) then
              inc2=1
           else
              inc2=inc
           end if
           dst=sqrt((x(1)-x(n))**2+(y(1)-y(n))**2)
           do 20 i=1,n,inc2
              xd=(x(i)-x(n+1))/x(n+2)
              yd=(y(i)-y(n+1))/y(n+2)
              call pack1(xd,sxd,nx)
              call pack1(yd,syd,ny)
              if(i.eq.1) then
                  call psout(ldev,sxd(1:nx)//' '//syd(1:ny)//' mvt')
              else
                  call psout(ldev,sxd(1:nx)//' '//syd(1:ny)//' lnt')
              end if
              if(mod(i,1000*inc2).eq.0) then
                  call psout(ldev,'stroke ')
                  call psout(ldev,'newpath ')
                  j=i-inc2
                  xd=(x(j)-x(n+1))/x(n+2)
                  yd=(y(j)-y(n+1))/y(n+2)
                  call pack1(xd,sxd,nx)
                  call pack1(yd,syd,ny)
                  write(str,'(4a)') sxd(1:nx)//' '//syd(1:ny)//' mvt'
                  call psout(ldev,str)
              end if
 20        continue
c          call setcol(icol)
           if(ifill.eq.1) then
               call psout(ldev,'closepath ')
               call psout(ldev,'fill ')
           else if(dst.lt.eps) then
               call psout(ldev,'closepath ')
               call psout(ldev,'stroke ')
           else
               call psout(ldev,'stroke ')
           end if
           return
      end if

      return
      end

      subroutine gpl(n,x,y)
      integer n
      real x(*),y(*)
      x(n+1)=0.
      x(n+2)=1.
      y(n+1)=0.
      y(n+2)=1.
      call plylin(x,y,n,1,0,0)
      return
      end

      subroutine newpen(ipen)
      integer ipen
c     change pen or color
      integer name, ldev
      common /calcmp/ name, ldev
      integer pcol
      common /cpcol/ pcol
      real pwdt
      common /cpwdt/ pwdt
      character trm*2,cr,nl,esc
      character*80 str
      common /plot1/ trm,cr,nl,esc
      save ipeno
      data ipeno/-1/
      if(ldev.eq.1.or.ldev.eq.2) then
c          ipen/100 cm linewidth is used
           if(ipen.eq.0) then
               call pack1(2/100.0,str,ns)
           else
               call pack1(ipen/100.0,str,ns)
           end if
           if(ipen.ne.ipeno) then
               call psout(ldev,str(1:ns)//' setlinewidth ')
               ipeno=ipen
           end if
           return
      end if
      return
      end

      subroutine factor(facfig)
c     change the scale of the figure around the origin
      integer name, ldev
      common /calcmp/ name, ldev
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      character*80 str
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc

      if(ldev.eq.1.or.ldev.eq.2) then
          write(str,'(2f9.3,a)') facfig,facfig,' scale '
          call psout(ldev,str)
          return
      end if
      return
      end

      subroutine fillarea(n)
      integer n
      integer ifill
      common /cfill/ ifill
      integer name, ldev
      common /calcmp/ name, ldev

      if(ldev.eq.1.or.ldev.eq.2) then
           ifill = n
           return
      end if
      end

      subroutine fillcol(n)
      integer n
      integer icol,jcol
      common /ccol/ icol,jcol
      integer name, ldev
      common /calcmp/ name, ldev
      character*80 sx, sh, ss, sb
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc
      real hue, sat, brt
c           ncol=0 means default or background color (white: ncol=10)
c              hue      lightness   satulation
c           0 white        0              0
c           0 gray        1-10            0
c           1 blue        1-9            100
c           2 violet      1-9            100
c           3             1-9            100
c           4 magenta     1-9            100
c           5             1-9            100
c           6             1-9            100
c           7 red         1-9            100
c           8             1-9            100
c           9             1-9            100
c          10 yellow      1-9            100
c          11 lite greem  1-9            100
c          12             1-9            100
c          13 green       1-9            100
c          14             1-9            100
c          15             1-9            100
c          16 cyan        1-9            100
c          17             1-9            100
c          18             1-9            100
c                   lightness=0 or a means black or white
c                   satulation=0 means gray
c                   background color =10  white
c                   black  = 1
c                   white  =10
c                   gray           ( 1- 9)
c                   blue   =15     (11-19)
c                   magenta=45     (41-29)
c                   red    =75     (71-39)
c                   yellow =105    (101-109)
c                   green  =135    (131-139)
c                   cyan   =165    (161-169)
      if(ldev.eq.1.or.ldev.eq.2) then
           if(n.ne.icol) then
               if(n.le.9) then
                 hue=0
                 sat=0
                 brt=float(n)/10
               else if(n.eq.10) then
                 hue=0
                 sat=0
                 brt=1
               else
                  hue=float(n/10)/18
c                 if(hue.le.6) then
c                    hue=hue+float(12)/18
c                 else
c                    hue=hue-float(6)/18
c                 end if
c                 sat=1
c                 brt=float(mod(n,10))/10
                 if(hue.le.6) then
                    hue=float(n/10)/18
c                   hue=1/18 means blue  => 12/18
                    hue=mod(hue+float(11)/18,1.)
                 else
                    hue=float(n/10)/18
c                   hue=7/18 means red
                    hue=hue-float(7)/18
                 end if
                 brt=float(mod(n,10))/10
                 if(brt.gt.0.5) then
                    sat=(1-brt)*2
                 else
                    sat=1
                 end if
                 brt=min(brt*2,1.)
               end if
               if(ldev.eq.1) then
                   call pack1(brt,sx,nx)
                   call psout(ldev,sx(1:nx)//' setgray ')
               else if(ldev.eq.2) then
                   call pack1(hue,sh,nh)
                   call pack1(sat,ss,ns)
                   call pack1(brt,sb,nb)
                   sx=sh(1:nh)//' '//ss(1:ns)//' '//sb(1:nb)
                   nx=nh+ns+nb+2
                   call psout(ldev,sx(1:nx)//' sethsbcolor ')
               end if
               icol = n
               jcol = n
           end if
           return
      end if
      end


      subroutine linecol(n)
      integer n
      integer icol,jcol
      common /ccol/ icol,jcol
      integer name, ldev
      common /calcmp/ name, ldev
      character*80 sx, sh, ss, sb
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc
      real hue, sat, brt

      if(ldev.eq.1.or.ldev.eq.2) then
           if(n.ne.jcol) then
               if(n.le.9) then
                 hue=0
                 sat=0
                 brt=float(n)/10
               else if(n.eq.10) then
                 hue=0
                 sat=0
                 brt=1
               else
                 hue=float(n/10)/18
                 if(hue.le.6) then
                    hue=hue+float(12)/18
                 else
                    hue=hue-float(6)/18
                 end if
                 sat=1
                 brt=float(mod(n,10))/10
               end if
               if(ldev.eq.1) then
                   call pack1(brt,sx,nx)
                   call psout(ldev,sx(1:nx)//' setgray ')
               else if(ldev.eq.2) then
                   call pack1(hue,sh,nh)
                   call pack1(sat,ss,ns)
                   call pack1(brt,sb,nb)
                   sx=sh(1:nh)//' '//ss(1:ns)//' '//sb(1:nb)
                   nx=nh+ns+nb+2
                   call psout(ldev,sx(1:nx)//' sethsbcolor ')
               end if
               icol = n
               jcol = n
           end if
           return
      end if
      end

      subroutine setcol(n)
      integer name, ldev
      common /calcmp/ name, ldev
      if(ldev.eq.1.or.ldev.eq.2) then
          call fillcol(n)
      end if
      return
      end
      
      subroutine paint(x,ncol,bcol)
      dimension x(3)

      integer name, ldev
      common /calcmp/ name, ldev
      common /cplot/ xx(2),yy(2),idev

      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc

      integer bcol
      return
      end

      subroutine circle(ang1,ang2,rc,xy,jmod)
      real ang1,ang2,rc,xy(3)
      character*80 sx,sy,sr,s1,s2
      integer name, ldev
      common /calcmp/ name, ldev

      integer ifill
      common /cfill/ ifill
      common /sct/ sint(0:100),cost(0:100)
      integer icol,jcol
      common /ccol/ icol,jcol

      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      common /cplot/ xx(2),yy(2),idev

      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc

      real xd,yd,rd
      real pi2, eps
      save pi2, eps
      data pi2 /6.28318/, eps/0.0001/

c         ang1: start angle in degree(0<=ang1<=360)
c         ang2: end angle in degree    (0<=ang1<=ang2<=360)
c         rc: radius
c         xy: center of a circle (x, y, z  in the plotter system)
c         jmod: 0 connect beginning with end point when ifill=1
c               1 connect beginning and end point with the center
c                 for ifill=0,1
      fct=pi2/360
      xs=xy(1)+rc*cos(ang1*fct)
      ys=xy(2)+rc*sin(ang1*fct)
      xe=xy(1)+rc*cos(ang2*fct)
      ye=xy(2)+rc*sin(ang2*fct)
      if(ldev.eq.1.or.ldev.eq.2) then
          xd=xy(1)
          yd=xy(2)
          rd=rc
          call setcol(icol)
          call psout(ldev,'newpath ')
          call pack1(xd,sx,nx)
          call pack1(yd,sy,ny)
          call pack1(rd,sr,nr)
          call pack1(ang1,s1,n1)
          call pack1(ang2,s2,n2)
          call psout(ldev,sx(1:nx)//' '//sy(1:ny)//' '//
     *    sr(1:nr)//' '//s1(1:n1)//' '//s2(1:n2)//' arc ')
          if(jmod.eq.1) then
              call plot(xy(1),xy(2),2)
              call plot(xs,xs,2)
          end if
          if(ifill.ge.1) then
              call psout(ldev,'fill ')
          else
              call psout(ldev,'stroke ')
          end if
          return
      end if
      return
      end

      subroutine box(x1,y1,x2,y2)
      real x(7),y(7)
      integer ifill
      common /cfill/ ifill
      x(1)=x1
      y(1)=y1
      x(2)=x2
      y(2)=y1
      x(3)=x2
      y(3)=y2
      x(4)=x1
      y(4)=y2
      x(5)=x(1)
      y(5)=y(1)
      x(6)=0.
      y(6)=0.
      x(7)=1.
      y(7)=1.
      call plylin(x,y,5,1,0,0)
      end

      subroutine ellipse(ang1,ang2,ang3,rc1,rc2,xy,ncol)
      real ang1,ang2,ang3,rc1,rc2,xy(*)
      integer ncol
      integer name, ldev
      common /calcmp/ name, ldev
      integer ifill
      common /cfill/ ifill
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      character*80 str
      real xd,yd,rd1,rd2
      real pi2, eps
      save pi2, eps
      data pi2 /6.28318/, eps/0.0001/

c         ang1: start angle from first princial axis in degree
c         ang2: end angle in degree
c         ang3: rotation angle of ellipse  in degree
c            if ang3=0 first and second principal axes are
c            taken along x and y axes in the plinter
c         rc1: radius along the first principal axis
c         rc2: radius along the second principal axis
c         xy: center of an ellipse (x, y  in the plotter system)
c         ncol: fill color 0 black 10 white 1-9 gray
c
      if(ldev.eq.1.or.ldev.eq.2) then
          xd=xy(1)
          yd=xy(2)
          rd1=rc1
          rd2=rc2
          a1=ang1
          a2=ang2
          a3=ang3
          call setcol(ncol)
          call psout(ldev,'newpath ')
          write(str,'(7f9.3,a)') xd,yd,rd1,rd2,a1,a2,a3,' ellipse '
          call psout(ldev,str)
          if(ifill.ge.1) then
              call psout(ldev,'fill ')
          else
              call psout(ldev,'stroke ')
          end if
          return
      end if
      return
      end

      subroutine tssput(n,buf)
      character*80 buf
      integer n
      write(6,'(a)') buf(1:n)
      return
      end

      subroutine gipcc1(x1,y1,r1,x2,y2,r2,xc,yc,n,ill)
      real x1,y1,r1,x2,y2,r2,xc(2),yc(2)
      integer n,ill
      real xd1,yd1,xd2,yd2
      real dist,cosd,sind,cosn,sinn,dn,eps
      data eps /0.001/

      dist = sqrt((x2-x1)**2+(y2-y1)**2)
      cosd = (x2-x1)/dist
      sind = (y2-y1)/dist
      cosn = -sind
      sinn = cosd

      if(dist.gt.r1+r2) then
           n=0
           ill = 0
           return
      else if(dist+min(r1,r2).lt.max(r1,r2)) then
           n=0
           ill = 0
           return
      else if(abs(dist-r1-r2).lt.eps) then
           n=1
           ill = 1
           d1=-(r2**2-r1**2-dist**2)/(2*dist)
           xc(1)=x1+cosd*d1
           yc(1)=y1+sind*d1
           return
      else if(abs(dist+min(r1,r2)-max(r1,r2)).lt.eps) then
           n=1
           ill = 1
           d1=-(r2**2-r1**2-dist**2)/(2*dist)
           xc(1)=x1+cosd*d1
           yc(1)=y1+sind*d1
           return
      else
           n=2
           ill = 1
           d1=-(r2**2-r1**2-dist**2)/(2*dist)
           dn=sqrt(r1**2-d1**2)
           xd1=x1+cosd*d1+cosn*dn
           yd1=y1+sind*d1+sinn*dn
           xd2=x1+cosd*d1-cosn*dn
           yd2=y1+sind*d1-sinn*dn

           if(xd1.lt.xd2) then
                xc(1)=xd1
                yc(1)=yd1
                xc(2)=xd2
                yc(2)=yd2
           else if(xd1.gt.xd2) then
                xc(1)=xd2
                yc(1)=yd2
                xc(2)=xd1
                yc(2)=yd1
           else
                if(yd1.lt.yd2) then
                      xc(1)=xd1
                      yc(1)=yd1
                      xc(2)=xd2
                      yc(2)=yd2
                else
                      xc(1)=xd2
                      yc(1)=yd2
                      xc(2)=xd1
                      yc(2)=yd1
                end if
           end if
           return
      end if
      return
      end

      subroutine sctbl
      common /sct/ sint(0:100),cost(0:100)
      do 10 i=0,100
      x=6.28318*i/100.0
      sint(i)=sin(x)
 10   cost(i)=cos(x)
      return
      end

      subroutine psquit
      call plote('end of plot')
      call exit()
      end

      subroutine lntyp(ity)
      integer name, ldev
      common /calcmp/ name, ldev 
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc
      save lty
      data lty/0/

      if(ity.ne.lty.and.(ldev.eq.1.or.ldev.eq.2)) then
          lty=ity
          if(ity.eq.0) then
c          solid line
              call psout(ldev,'[] 0 setdash ')
          else if(ity.eq.10) then
c          dash line
              call psout(ldev,'[0.2 0.2] 0 setdash ')
          else if(ity.eq.20) then
c          dot line
              call psout(ldev,'[0.05 0.1] 0 setdash ')
          else if(ity.eq.30) then
c          dash and dot
              call psout(ldev,'[0.2 0.15 0.05 0.15 ] 0 setdash ')
          end if
      end if
      return
      end

      subroutine line(x,y,n,inc,ity,mrk)
      dimension x(*),y(*)
      integer name, ldev
      common /calcmp/ name, ldev

      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx, offsy, currx, curry, fact
      common /cplot/ xx(2),yy(2),idev
      character*80 sxd,syd
      character*2000 buf
c      character*80 buf
      character cinc*6,cmrk,ctyp*2,wjmod*2
      integer pcol
      common /cpcol/ pcol
      real pwdt
      common /cpwdt/ pwdt
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc
      write(cmrk,'(i1)') abs(mrk)
      write(cinc,'(i6)') inc
      write(ctyp,'(i2)') ity
      
      he=0.16
      if(ldev.eq.1.or.ldev.eq.2) then
          call psout(ldev,'newpath ')
c          if(inc.lt.0) then
             inc2=1
c          else
c             inc2=inc
c          end if
          np=0
          do 20 i=1,n,inc2
              xd=(x(i)-x(n+1))/x(n+2)
              yd=(y(i)-y(n+1))/y(n+2)
              call pack1(xd,sxd,nx)
              call pack1(yd,syd,ny)
              buf(np+1:np+nx+ny+2)=sxd(1:nx)//' '//syd(1:ny)//' '
              np=np+nx+ny+2
              if(mod(i,50).eq.0) then
                  if(i.eq.50) then
                     write(wjmod,'(i2)') 50
                  else
                     write(wjmod,'(i2)') 50+1
                  end if
c                 buf(np+1:np+18)=wjmod//' '//ctyp//' '//cmrk
                  buf(np+1:np+13)=wjmod//' '//ctyp//' '//cmrk
     *                                   //' '//'line '
c                 np=np+18
                  np=np+13
                  if(np.gt.2000) then
c                  if(np.gt.80) then
                     call psquit('buf full in subroutine line')
                  end if
                  call psout(ldev,buf(1:np))
                  call psout(ldev,'stroke ')
                  call psout(ldev,'newpath ')
                  np=0
                  buf(np+1:np+nx+ny+2)=sxd(1:nx)//' '//syd(1:ny)//' '
                  np=np+nx+ny+2
              end if
20         continue  
           jmod=mod(n,50)
           if(jmod.ne.0) then
               if(n.lt.50) then
                  write(wjmod,'(i2)') jmod
               else
                  write(wjmod,'(i2)') jmod+1
               end if
c               buf(np+1:np+18)=wjmod//' '//ctyp//' '//cmrk
               buf(np+1:np+13)=wjmod//' '//ctyp//' '//cmrk
     *                                   //' '//'line '
c               np=np+18
               np=np+13
               if(np.gt.2000) then
c               if(np.gt.80) then
                  call psquit('buf full in subroutine line')
               end if
               call psout(ldev,buf(1:np))
               call psout(ldev,'stroke ')
           end if
           return
      end if
      end

c     subroutine line(x,y,n,inc,ity,mrk)
c       he: size of the center symbol
      subroutine line1(x,y,n,inc,ity,mrk,he)
      dimension x(*),y(*)
      integer name, ldev
      common /calcmp/ name, ldev

      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx, offsy, currx, curry, fact
      common /cplot/ xx(2),yy(2),idev
      character*80 sxd,syd,che
      character*2000 buf
c      character*80 buf
      character cinc*6,cmrk,ctyp*2,wjmod*2
      integer pcol
      common /cpcol/ pcol
      real pwdt
      common /cpwdt/ pwdt
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc

      write(cmrk,'(i1)') abs(mrk)
      call pack1(he,che,nh)
      write(cinc,'(i6)') inc
      write(ctyp,'(i2)') ity
      if(ldev.eq.1.or.ldev.eq.2) then
          call psout(ldev,'newpath ')
c          if(inc.lt.0) then
             inc2=1
c          else
c             inc2=inc
c          end if
          np=0
          do 20 i=1,n,inc2
              xd=(x(i)-x(n+1))/x(n+2)
              yd=(y(i)-y(n+1))/y(n+2)
              call pack1(xd,sxd,nx)
              call pack1(yd,syd,ny)
              buf(np+1:np+nx+ny+2)=sxd(1:nx)//' '//syd(1:ny)//' '
              np=np+nx+ny+2
              if(mod(i,50).eq.0) then
                  if(i.eq.50) then
                     write(wjmod,'(i2)') 50
                  else
                     write(wjmod,'(i2)') 50+1
                  end if
                  buf(np+1:np+15+nh)=wjmod//' '//ctyp//' '//cmrk
     *                      //' '//che(1:nh)//' '//'line1 '
                  np=np+15+nh
                  if(np.gt.2000) then
c                  if(np.gt.80) then
                     call psquit('buf full in subroutine line1')
                  end if
                  call psout(ldev,buf(1:np))
                  call psout(ldev,'stroke ')
                  call psout(ldev,'newpath ')
                  np=0
                  buf(np+1:np+nx+ny+2)=sxd(1:nx)//' '//syd(1:ny)//' '
                  np=np+nx+ny+2
              end if
20       continue  
           jmod=mod(n,50)
           if(jmod.ne.0) then
               if(n.lt.50) then
                  write(wjmod,'(i2)') jmod
               else
                  write(wjmod,'(i2)') jmod+1
               end if
               buf(np+1:np+15+nh)=wjmod//' '//ctyp//' '//cmrk
     *                      //' '//che(1:nh)//' '//'line1 '
               np=np+15+nh
               if(np.gt.2000) then
c               if(np.gt.80) then
                  call psquit('buf full in subroutine line1')
               end if
               call psout(ldev,buf(1:np))
               call psout(ldev,'stroke ')
           end if
           return
      end if
      end

      subroutine cntsym(x,y,n,he)
      character n
      real x,y,he,xy(3)
      integer name, ldev
      common /calcmp/ name, ldev
      character*80 sx,sy,sh,str
      hh=he/2
      if(n.eq.'1') then
c         vertical bar "|"
          if(ldev.eq.3) then
              call plot(x,y-hh,3)
              call plot(x,y+hh,2)
              call plot(x,y,3)
          else if(ldev.eq.1.or.ldev.eq.2) then
              call pack1(x,sx,nx)
              call pack1(y,sy,ny)
              call pack1(he,sh,nh)
              str=sx(1:nx)//' '//sy(1:ny)//' '//sh(1:nh)//' vbar '
              call psout(ldev,str)
          end if
      else if(n.eq.'3') then
c         plus sign "+"
          if(ldev.eq.1.or.ldev.eq.2) then
              call pack1(x,sx,nx)
              call pack1(y,sy,ny)
              call pack1(he,sh,nh)
              str=sx(1:nx)//' '//sy(1:ny)//' '//sh(1:nh)//' pls '
              call psout(ldev,str)
          end if
      else
c         small circle "o"
          call fillarea(0)
          xy(1)=x
          xy(2)=y
          call circle(0.,360.,hh,xy,0)
          call plot(x,y,3)
      end if
      return
      end

      subroutine draw(x1,y1,x2,y2)
      real x(4), y(4)
      x(1)=x1
      x(2)=x2
      x(3)=0.
      x(4)=1.
      y(1)=y1
      y(2)=y2
      y(3)=0.
      y(4)=1.
      call line(x,y,2,1,0,0)
      return
      end

      subroutine axis(xmin,ymin,leng,delta,ang,iside,hght)
      real ax(4),ay(4),leng
      data pi2/6.28318/
c        write a scale for an axis
c        xmin, ymin: coordinates of the first scale
c        leng : length of the axis
c        ang: angle from hrizontal line (deg)
c        delta: increments of scale
      ax(3)=0.0
      ay(3)=0.0
      ax(4)=1.0
      ay(4)=1.0
      im=leng/delta+0.001
      do 60 i=0,im
           ax(1)=xmin+delta*float(i)*cos(pi2*ang/360)
           ay(1)=ymin+delta*float(i)*sin(pi2*ang/360)
c           ax(2)=ax(1)-0.1*sin(pi2*ang/360)*sign(1,iside)
c           ay(2)=ay(1)+0.1*cos(pi2*ang/360)*sign(1,iside)
           ax(2)=ax(1)-hght*sin(pi2*ang/360)*sign(1,iside)
           ay(2)=ay(1)+hght*cos(pi2*ang/360)*sign(1,iside)
 60        call line(ax,ay,2,1,0,0)
      return
      end

      subroutine encode(x,y)
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
*************************************************************
c      encode routine for tectronics 4510 seies rasterizer
*************************************************************
      ix=x*fact
      iy=y*fact
      call intpar(ix)
      call intpar(iy)
      return
      end

      subroutine intpar(ix)
      implicit integer (d,e)
      character lol,hil
      character*6 str,ostr
      integer ix
***********************************************************
c      encode routine for tectronics 4510 seies rasterizer
******************************************************
*  this routine is machine-dependent and applicable  *
*             only to the ascii code machine         *
******************************************************
      d1x=mod(abs(ix),16)
      if(ix.lt.0) then
          d1x=d1x+32
      else
          d1x=d1x+48
      end if
      lol=char(d1x)
      nchar=1
      str(nchar:nchar)=lol
      d2x=abs(ix)/16
 10   continue
      if(d2x.ne.0) then
          d3x=d2x/64
          d2x=mod(d2x,64)+64
          hil=char(d2x)
          nchar=nchar+1
          str(nchar:nchar)=hil
          d2x=d3x
          go to 10
      end if
      do 100 i=1,nchar
      ostr(i:i)=str(nchar-i+1:nchar-i+1)
 100  continue
c      write(1,'(a,$)') ostr(1:nchar)
      return
      end

      subroutine realpr(x)
*************************************************************
c      encode routine for tectronics 4510 seies rasterizer
c     x should be -32767=-2**15 to 32767=2**15
*************************************************************
      ix=x*2**15
      call intpar(ix)
      call intpar(-15)
      return
      end
      
      subroutine stmode(ix)
c       set status of tektronix mode
      save itmode
      data itmode /0/
      if(ix.ne.itmode) then
         itmode=ix
         if(ix.eq.1) then
c             write(1,'(a,$)') char(31)
         else if(ix.eq.2) then
c             write(1,'(a,$)') char(29)
         else if(ix.eq.3) then
c             write(1,'(a,$)') char(28)
         else
c             write(1,'(a,$)') char(31)
         end if
      end if
      return
      end

      subroutine window(x1,y1,x2,y2)
      real x1,y1,x2,y2
      integer name, ldev
      common /calcmp/ name, ldev
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      common /cplot/ xx(2),yy(2),idev
      common /cwndw/ x1w,y1w,x2w,y2w
      common /plot1/ trm,cr,nl,esc
      character trm*2,cr,nl,esc
c       save current window for viewpt() and offset()
          x1w=x1
          y1w=y1
          x2w=x2
          y2w=y2
      if(ldev.eq.1.or.ldev.eq.2) then
          call psout(ldev,'cmtx setmatrix initclip')
      end if
      return
      end

      subroutine viewpt(x1,y1,x2,y2)
      real x1,y1,x2,y2
      integer name, ldev
      common /calcmp/ name, ldev
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      common /cplot/ xx(2),yy(2),idev
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc
      common /cwndv/ x1v,y1v,x2v,y2v
      common /cwndw/ x1w,y1w,x2w,y2w
c      character*8 srx,sry,stx,sty,sx1,sx2,sy1,sy2
      character*8 sxw,syw,srx,sry,sx1,sy1,sx2,sy2
c       save current viewport for offset()
          x1v=x1
          y1v=y1
          x2v=x2
          y2v=y2
      if(ldev.eq.1.or.ldev.eq.2) then
c         set viewing transformation matrix
c           fct fct scale
c           x1 y1 translate
c           rx ry scale
c           -x1w -y1w translate
          rx=(x2-x1)/(x2w-x1w)
          ry=(y2-y1)/(y2w-y1w)
          call pack1(-x1w,sxw,nxw)
          call pack1(-y1w,syw,nyw)
          call pack1(rx,srx,nrx)
          call pack1(ry,sry,nry)
          call pack1(x1,sx1,nx1)
          call pack1(y1,sy1,ny1)
          call pack1(x2,sx2,nx2)
          call pack1(y2,sy2,ny2)
          call psout(ldev,'29.7 29.7 scale '
     *            //sx1(1:nx1)//' '//sy1(1:ny1)//' translate '
     *            //srx(1:nrx)//' '//sry(1:nry)//' scale '
     *            //sxw(1:nxw)//' '//syw(1:nyw)//' translate ')
          call cliparea(x1w,y1w,x2w,y2w)
          call psout(ldev,'clip ')
          call psout(ldev,'% view '//sx1(1:nx1)//' '//sy1(1:ny1)//
     *               ' '//sx2(1:nx2)//' '//sy2(1:ny2)//' ')
      end if
      return
      end

      subroutine orient(n)
      common /corien/ iorien
c      n=1: portrait mode
c      n=2: landscape mode
      iorien=n
      return
      end

      subroutine pack1(x,sxy,n)
      real x
      character*(*) sxy
      character*8 value
      ilen=len(sxy)
      write(value,'(f8.3)') x
      call pack2(value,is,ie)
      if(ilen.lt.ie-is+1) then
         write(6,*) 'ilen < strlen in pack1, sxy=',sxy
         call psquit(' ')
      end if
      write(sxy,'(a)') value(is:ie)
      n=ie-is+1
      end

      subroutine pack2(value,is,ie)
      character*8 value
      integer is,ie

      if (value .eq. '   0.000') then   ! for Sun & Titan
         is=4
         ie=4
         return
      end if
c      if (value .eq. '    .000') then    ! for HP
c         is=6
c         ie=6
c         return
c      end if
      do 10 j=1,4
         if (value(j:j) .ne. ' ' .and. value(j:j) .ne. '0') then
            go to 1
         end if
   10 continue
    1 is=j
      if (value(6:8) .eq. '000') then
         ie=4
      else
         do 20 j=8,7,-1
            if (value(j:j) .ne. '0') then
               go to 2
            end if
   20    continue
    2    ie=j
      end if
      return
      end

      subroutine sviewa(isn,iwi,ibi)
      integer isn,iwi,ibi
c       isn: surface number 1 or -1
c       iwi: wipe index   -1, 0<iwi<BUFLEN
c       ibi: border index  -1, 0<iwi<BUFLEN
c      write(1,'(2a,$)') esc,'RA'
      call intpar(isn)
      call intpar(iwi)
      call intpar(ibi)
      return
      end

c      subroutine psout(ldev,str)
c      integer ldev
c      character*(*) str
c      character*2001 str1
c      lenstr=len(str)
c      if(lenstr.gt.2000) call quit('lenstr > 2000')
c      do i=lenstr,1,-1
c         if(str(i:i).ne.' ') go to 10
c      end do
c 10   continue
c      if(i.eq.lenstr) then
c         jend=i
c      else
c         jend=i+1
c      end if
c      do j=1,jend
c         str1(j:j)=str(j:j)
c      end do
c      k=jend+1
c      str1(k:k)=char(0)
c      call psoutc(ldev,str1)
c      return
c      end

      subroutine psout(ldev,str)
      character*(*) str
      integer ldev,bufl
c      parameter (BUFLEN=256)
      parameter (BUFLEN=80)
      character*80 out
      data IPSOUT /12/

      bufl=BUFLEN-1
      len0=len(str)
      do i=len0,1,-1
         if(str(i:i).ne.' ') go to 10
      end do
 10   continue
c     i: address of last character
      if(i.eq.len0) then
         leng=i
      else
         leng=i+1  ! the last blank is necessary
      end if
      is=leng/bufl       ! number of lines - 1
      len1=leng-bufl*is  ! number of character in the last line
c     write(6,*) 'leng,is,len1=',leng,is,len1
      do i=0,is-1
         call strcpy(out,str,1,bufl*i+1,bufl)
         write(IPSOUT,'(a,$)') out(1:bufl)
      end do
      if(len1.gt.0) then
         call strcpy(out,str,1,bufl*is+1,len1)
         write(IPSOUT,'(a)') out(1:len1)
      end if
      return
      end

      subroutine setnfil(nfd)
      integer nfd
      common /cnfil/ nfil
      nfil=nfd
      return
      end

      subroutine psopen(ldev,nopen,orien)
      integer ldev, nopen, orien
      character*3 nf
      common /cnfil/ nfil
      parameter (MAXPATH=50)
      character*50 pathnm
      common /cpathn/ pathnm
      data IPSOUT /12/
      character*7 PSFIL
      data PSFIL /'calcomp'/

      nfd=mod(nopen-1,nfil)+1
      if(nfd.ge.1.and.nfd.lt.10) then
         lnf=1
         write(nf,'(i1)') nfd
      else if(nfd.ge.10.and.nfd.lt.100) then
         lnf=2
         write(nf,'(i2)') nfd
      else if(nfd.ge.100.and.nfd.lt.1000) then
         lnf=3
         write(nf,'(i3)') nfd
      end if         
      if(ldev.eq.1.or.ldev.eq.2) then
         call strcpy(pathnm,PSFIL,1,1,7)
         lpath=7+1
         call strcpy(pathnm,nf,lpath,1,lnf)
         lpath=lpath+lnf
         call strcpy(pathnm,'.ps',lpath,1,3)
c        write(6,*) '*****pathnm=',pathnm
      end if
      open(unit=IPSOUT,file=pathnm)
      call gprimv(1)
      return
      end

      subroutine psclose(ldev,nopen,orien)
      data IPSOUT /12/
      close(unit=IPSOUT)
      return
      end

      subroutine psflush(ldev)
      return
      end

      subroutine gprimv(ldev)
c      include 'gprim.h'
c	char *GPRIM="/home/yamamoto/fsrc/gprim.ps";
      character*50 GPRIM
      data GPRIM /'gprim.ps'/
      data IPSIN /11/
      data IPSOUT /12/
      parameter (MAXPATH=50)
      character*50 pathnm
      common /cpathn/ pathnm
c      parameter (BUFLEN=256)
      parameter (BUFLEN=80)
      character*80 bufd
      integer bufl

      bufl=BUFLEN-1
      len0=len(bufd)

      open(unit=IPSIN,file=GPRIM)
 10   continue
      read(unit=IPSIN,fmt='(a)',end=20) bufd
      do i=len0,1,-1
         if(bufd(i:i).ne.' ') go to 30
      end do
 30   continue
c     i: address of last character
      if(i.eq.len0) then
         leng=i
      else
         leng=i+1  ! the last blank is necessary
      end if

      write(unit=IPSOUT,fmt='(a)') bufd(1:leng)
      go to 10
 20   continue
      close(unit=IPSIN)
      return
      end

      subroutine strcpy(str1,str2,iadr1,iadr2,ilen)
      character*(*) str1,str2
      do i=1,ilen
         j=iadr1+i-1
         k=iadr2+i-1
         str1(j:j)=str2(k:k)
      end do
      return
      end

      subroutine getzap()
      return
      end

c      subroutine rdasf(ip)
c      common /asft/ ne,ascf(35,namax),df1(namax),df2(namax),iand
c      dimension a(4,namax),b(4,namax),c(namax)
c      character dummy*80
c      do 10 i=1,20
c      df1(i)=0.0
c 10   df2(i)=0.0
c      write(6,*) 'sctmdl=',ip
c      read(5,101) ne,iand,ia
c      call freadi('ne=',1,ne,1)
c      call freadi('iand=',1,iand,0)
c      call freadi('inpd=',1,ia,0)
c      write(6,205) ne,iand,ia
c      call freadc('scattering factor',0,dummy,1)
c      do 20 ik=1,ne
c      if(ia.eq.0) read(5,100) (ascf(i,ik),i=1,35)
c      if(ia.eq.1) read(5,102) (a(i,ik),b(i,ik),i=1,4),c(ik)
c      if(iand.eq.1) read(5,102) df1(ik),df2(ik)
c      if(ip.eq.-1) then
c          if(ia.eq.1) read(5,102) (a(i,ik+ne),b(i,ik+ne),
c     *        i=1,4),c(ik+ne)
c          if(ia.eq.0) read(5,100) (ascf(i,ik+ne),i=1,35)
c          if(iand.eq.1) read(5,100) df1(ik+ne),df2(ik+ne)
c      end if
c 20   continue
c      write(6,202)
c      do 30 ik=1,ne
c      if(ia.eq.1) then
c          do 31 i=1,35
c          sint=((i-1)*0.05)**2
c          ascf(i,ik)=c(ik)
c          if(ia.eq.1) ascf(i,ik+ne)=c(ik+ne)
c          do 31 j=1,4
c          ascf(i,ik)=ascf(i,ik)+a(j,ik)*exp(-b(j,ik)*sint)
c 31       if(ip.eq.-1) ascf(i,ik+ne)=ascf(i,ik+ne)+a(j,ik+ne)*
c     *         exp(-b(j,ik+ne)*sint)
c      end if
c      if(iand.ne.1) write(6,2001) ik
c      if(iand.eq.1) write(6,2002) ik,df1(ik),df2(ik)
c      if(ia.eq.1) write(6,203) (i,a(i,ik),i,b(i,ik),i=1,4),c(ik)
c      write(6,201) (ascf(i,ik),i=1,35)
c      if(ip.eq.-1) then
c          if(iand.ne.1) write(6,2041)
c          if(iand.eq.1) write(6,2042) df1(ik+ne),df2(ik+ne)
c          if(ia.eq.1) write(6,203) (i,a(i,ik+ne),i,b(i,ik+ne),i=1,4),
c     *          c(ik+ne)
c          write(6,201) (ascf(i,ik+ne),i=1,35)
c      end if
c 30   continue
c      return
c 100  format(12f6.3)
c 101  format(3i3)
c 102  format(9f8.5)
c 2001 format(1h ,'table',i3)
c 2002 format(1h ,'table',i2,8x,'real and imaginary parts of dispersion
c     *         correction',2f10.5)
c 201  format((1h ,12(f6.3,4x)))
c 202  format(1h ,'atomic scattering factor table')
c 203  format(1h ,'input data'/1h ,4('a',i1,'=',f10.6,1x,'b',i1,'=',
c     *         f10.6,1x),'c=',f10.6)
c 2041 format(1h ,'second species')
c 2042 format(1h ,'second species real and imaginary parts of dispersion
c     *          correction',2f10.5)
c 205  format(1h ,'ne=',i3,2x,'iand=',i3,2x,'inpd=',i3)
c      end

      function asf(yb,jk)
c      include 'qcdiff.inc'
      parameter (namax=50)
      parameter (nb=2000)
c      parameter (nb=80)
      parameter (nemax=50)
      parameter (nhkl=4000)
      parameter (nmax=6000)
      parameter (nrmax=20)
      parameter (nxprm=150)
      parameter (nxyz=2000)
      parameter (idsmax=2)
      parameter (jzm=70)

      common /asft/ ne,ascf(35,nemax),df1(nemax),df2(nemax),iand,
     *              iel(3,nemax)
      i=yb/0.05+1.0
      if(i.ge.29) i=(yb-1.4)/0.1+29.0
      if(i.ge.35) go to 20
      j=i+1
      if(i.ge.29) go to 21
      ai=float(i-1)*0.05
      asf=ascf(i,jk)+(ascf(j,jk)-ascf(i,jk))*(yb-ai)/0.05+df1(jk)
      return
 21   ai=float(i-29)*0.1+1.4
      asf=ascf(i,jk)+(ascf(j,jk)-ascf(i,jk))*(yb-ai)/0.1+df1(jk)
      return
 20   continue
      asf=0.0
      return
      end

      subroutine getnel(nelem)
c      include 'qcdiff.inc'
      parameter (namax=50)
      parameter (nb=2000)
c      parameter (nb=80)
      parameter (nemax=50)
      parameter (nhkl=4000)
      parameter (nmax=6000)
      parameter (nrmax=20)
      parameter (nxprm=150)
      parameter (nxyz=2000)
      parameter (idsmax=2)
      parameter (jzm=70)

      common /asft/ ne,ascf(35,nemax),df1(nemax),df2(nemax),iand,
     *              iel(3,nemax)
      nelem=ne
      return
      end

      subroutine rdsymo(na,brv)
      common /cwflag/ iwflag(7)
      character brv
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      common /extcr/ nextnc,icef(7,60)
      common /cdim/ idm,nde
      common /cskip/ iskip,ltype
      integer imps(60),rg(6,6,5)
      real tg(6,5)
      character*30 coord
      character cltd(4)
      data cltd/'p','i','f','s'/      
c     initialization
      call getinp(inpu)
      call getout(iout)
c     iwflag(3)=1
      ige=1
c
c      read(5,100) nsymo,icent,brv
       call freadi('nsymo=',1,nsymo,1)
       call freadi('icent=',1,icent,0)
       call freadc('brv=',1,brv,0)
      nde=3
      icom=0
c
      write(iout,210) nsymo,icent,brv
      do 15 i=1,4
      if(brv.eq.cltd(i)) then
           ltype=i
      end if
 15   continue
      if(ltype.eq.0) then
c          call quit('ltype incorrect')
         write(6,*) '******ltype=0*****'
      end if
      idm=nde+3
c      read(inpu,*) 'symmetry operator'
      call freadr('symmetry operator',0,dummy,1)
      do 10 k=1,nsymo
      read(inpu,'(a)') coord
      call decode(coord,rr,tt,k)
 10   continue
      if(iwflag(3).eq.1) then
           if(icent.eq.1) then
                 write(iout,2022)
           else
                 write(iout,2021)
           end if
           if(ige.eq.1) then
                write(iout,201) 'generating elements'
           end if
           write(iout,'(1h )')
      end if
      nn=nde+1
      if(iwflag(3).eq.1) then
          call wtsymo(rr,tt,nsymo,idm)
      end if
      if(ige.eq.1) then
           call ordr(rr,imps,nsymo,idm)
           do 123 i=1,nsymo
           do 123 j=1,idm
           tg(j,i)=tt(j,i)
           do 123 k=1,idm
           rg(j,k,i)=rr(j,k,i)
 123       continue
           impt=1
           do 13 i=1,6
           tt(i,1)=0.0
           do 13 j=1,6
           rr(i,j,1)=0.0
           rr(i,i,1)=1.0
 13        continue
           do 50 ns=1,nsymo
           imp=imps(ns)
c          modified to include the pure translation
           if(imp.eq.1) then
             if(tg(1,ns).ne.0.or.tg(2,ns).ne.0.or.tg(3,ns).ne.0
     *      .or.tg(4,ns).ne.0.or.tg(5,ns).ne.0.or.tg(6,ns).ne.0)
     *       imp=2
           end if
           do 11 i=2,imp
           do 11 j=1,impt
           mp1=j+(i-2)*impt
           mp2=j+(i-1)*impt
 11        call mpso(rg,tg,ns,rr,tt,mp1,mp2,idm)
 50        impt=impt*imp
           nsymo=impt
           if(iwflag(3).eq.1) then
                write(iout,207)
                write(iout,'(1h )')
                call wtsymo(rr,tt,nsymo,idm)
           end if
      end if
 81   continue
      if(nextnc.eq.0) return
      if(iwflag(3).eq.1) then
           write(iout,231)
      end if
c      do 90 i=1,nextnc
c      read(inpu,100) (icef(j,i),j=1,6),nmod(i)
c      call freadi('mi=',idm+1,icef(1,i),1)
c      if(iwflag(3).eq.1) then
c           write(iout,230) (icef(j,i),j=1,6),nmod(i)
c           write(iout,230) (icef(j,i),j=1,idm+1)
c      end if
c 90   continue
      return
 100  format(7i3)
 101  format(9i3,3f9.6,i3)
 102  format(3f8.5,2i3)
 103  format(24i3)
 200  format(1h ,2x,i2,4x,9f6.2,5x,3f10.6,5x,i3)
 201  format(1h ,a)
 2021 format(1h ,'symmetry operation',10x,'noncentrosymmetric')
 2022 format(1h ,'symmetry operation',10x,'centrosymmetric')
 204  format(1h ,'wavevector k',i1,10x,3f9.6,3x,'icorc=',i3,2x
     *       ,'ilm=',i3,2x,a2,'commensurate')
 205  format(1h ,'basic wavevectors')
 206  format(1h ,'generating elements')
 207  format(1h ,'symmetry operators generated by generating elements')
 208  format(1h ,i3,10x,24i3)
 209  format(1h ,'atom',9x,'symmetry operator to be skipped =1')
 210  format(1h ,'nsymo=',i3,2x,'icent=',i2,2x,'brv=',a)
 211  format(1h ,'periods along a,b,c axes' ,3i5)
 230  format(1h ,7i5)
 231  format(1h ,'extinction rules for general reflections'/1h ,
     *          'm1,m2,..,m6,m of m1*h1+m2*h2+...+m6*h6=m*n')
      end

      subroutine ordr(re,imps,nsymo,idm)
      integer re(6,6,*),imps(*)
      integer r(6,6),a(6,6),b(6,6)
      data eps/0.001/
      call getinp(inpu)
      call getout(iout)
      do 10 i=1,nsymo
           do 11 j=1,idm
           do 11 k=1,idm
           r(j,k)=re(j,k,i)
 11        b(j,k)=r(j,k)
           do 12 j=1,13
c    check whether r is identity operator or not
                do 16 k=1,idm
                if(r(k,k).ne.1) go to 15
                do 16 l=1,idm
                if(k.ne.l.and.r(k,l).ne.0) go to 15
 16             continue
                imps(i)=j
                go to 10
c       a=r
 15             do 13 k=1,idm
                do 13 l=1,idm
 13             a(k,l)=r(k,l)
c       r=a*b   ==> r=r*re
                do 14 k=1,idm
                do 14 l=1,idm
                r(k,l)=0
                do 14 m=1,idm
 14             r(k,l)=r(k,l)+a(k,m)*b(m,l)
 12        continue
 10   continue
      do 20 i=1,nsymo
      if(imps(i).ge.13) then
           ierror=1
           go to 21
      else
           ierror=0
      end if
 20   continue
 21   continue
      if(ierror.eq.1) then
           write(iout,'(1h ,''error in symmetry operator ?'',a,24i3)')
     *      '  order: ',(imps(i),i=1,nsymo)
      end if
      return
      end

      subroutine wtsymo(rr,tt,nsymo,idm)
      integer rr(6,6,*)
      real tt(6,*)
      common /cwflag/ iwflag(7)
      character*3 wtt(6,60)
      integer wd(3),w
      data wd/6,5,4/,eps/0.001/
      call getinp(inpu)
      call getout(iout)
      w=wd(idm-3)
      ll=(nsymo-1)/w+1
      le=nsymo-(ll-1)*w
      call wtsmop(rr,tt,nsymo,idm-3,3)
      write(iout,'(1h )')
      call getwtt(tt,wtt,nsymo,idm)
c      do 31 ii=1,ll
c      lbgn=(ii-1)*w+1
c      if(ii.ne.ll) lend=lbgn+w-1
c      if(ii.eq.ll) lend=lbgn+le-1
c      do 31 i=1,idm
c      if(idm.eq.4) write(iout,204) ((rr(i,j,k),j=1,idm),wtt(i,k),
c     *                 k=lbgn,lend)
c      if(idm.eq.5) write(iout,205) ((rr(i,j,k),j=1,idm),wtt(i,k),
c     *                 k=lbgn,lend)
c      if(idm.eq.6) write(iout,206) ((rr(i,j,k),j=1,idm),wtt(i,k),
c     *                 k=lbgn,lend)
c      if(i.eq.idm) write(iout,'(1h )')
c 31   continue
      return
 204  format(1h ,8(4i2,1x,a,2x))
 205  format(1h ,7(5i2,1x,a,2x))
 206  format(1h ,6(6i2,1x,a,2x))
      end

      subroutine getwtt(tt,wtt,nsymo,idm)
      real tt(6,*)
      character*3 wtt(6,*)
      real rt(8)
      character*3 wt(8)
      data rt/0.,0.5,0.333333,0.666666,0.25,0.75,0.166666,0.833333/
      data wt/'0','1/2','1/3','2/3','1/4','3/4','1/6','5/6'/
      data eps/0.00001/
      call getinp(inpu)
      call getout(iout)
      do 100 i=1,nsymo
      do 110 j=1,idm
      td=tt(j,i)
      td=mod(td,1.)
      if(td.lt.-eps) then
          td=td+1
      else if(td.gt.1-eps) then
          td=td-1
      end if
          do 120 k=1,8
          if(abs(td-rt(k)).lt.eps) then
               wtt(j,i)=wt(k)
               go to 110
          end if
 120      continue
 110  continue
 100  continue
      return
      end

      subroutine mpso(r1,t1,m1,r2,t2,m2,m3,idm)
      integer r1(6,6,*),r2(6,6,*)
      real t1(6,*),t2(6,*)
      do 10 i=1,idm
         t2(i,m3)=0.0
         do 11 j=1,idm
            t2(i,m3)=t2(i,m3)+r1(i,j,m1)*t2(j,m2)
 11      continue
         t2(i,m3)=t2(i,m3)+t1(i,m1)
         do 12 j=1,idm
            r2(i,j,m3)=0.0
            do 13 k=1,idm
               r2(i,j,m3)=r2(i,j,m3)+r1(i,k,m1)*r2(k,j,m2)
 13         continue
 12      continue
 10   continue
      return
      end

      subroutine sitesy(na,mpl,x,isk,irs) 
      real mpl(*),x(6,*)
      integer isk(0:120,*),irs(0:120,*)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      common /cdim/ idm,nde
      real rx(6)
      real rxs(6,120)
      integer rcomp
      do 50 i=1,na
      nsym=0
      nrx=1
      isk(nrx,i)=1
      call savex(x(1,i),rxs(1,nrx))
      do 130 ic=0,icent
      do 100 ns=1,nsymo
           call getrx(x(1,i),rx,rr,tt,ns,ic)
           do 110 irx=1,nrx
           if(rcomp(rx,rxs(1,irx)).eq.1) go to 120
 110       continue
c          site symmetry operator
           nrx=nrx+1
           call savex(rx,rxs(1,nrx))
           if(ic.eq.0) then
               isk(nrx,i)=ns
           else
               isk(nrx,i)=ns+nsymo
           end if
 120       continue
c          symmetry operator generating equivalent positions
           if(rcomp(rx,x(1,i)).eq.1) then
               nsym=nsym+1
               if(ic.eq.0) then
                    irs(nsym,i)=ns
               else
                    irs(nsym,i)=ns+nsymo
               end if
           end if
 100  continue
 130       continue
      isk(0,i)=nrx
      irs(0,i)=nsym
      mpl(i)=1
      if(icent.eq.1) then
c         compress symmetry element > nsymo
          n=0
          do 200 j=1,isk(0,i)
              if(isk(j,i).gt.nsymo) go to 201
              n=n+1
 200      continue
 201      continue
c         n: number of equivalent positions generated by given operators
c         isk(0,i): number of equivalent positions generated by given
c                   symmetry operators and inversion
          mpl(i)=float(isk(0,i))/(float(n)*2)
          isk(0,i)=n
      end if
 50   continue
      write(6,*) 'site symmetry group'
      do 55 i=1,na
      write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(irs(j,i),j=1,irs(0,i))
c      write(6,'(a,i3/(20i4))') 'atom=',i,(irs(j,i),j=1,irs(0,i))
 55   continue
      write(6,*) 'equivalent position'
      do 56 i=1,na
      write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(isk(j,i),j=1,isk(0,i))
c      write(6,'(a,i3/(20i4))') 'atom=',i,(isk(j,i),j=1,isk(0,i))
 56   continue
      write(6,*) 'multiplicity'
      do 57 i=1,na
      write(6,*) 'atom',i,'  ',mpl(i)
 57   continue
      return
      end

      subroutine sitesy1(na,mpl,x,isk,irs) 
      real mpl(*),x(6,*)
      integer isk(0:120,*),irs(0:120,*)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      common /cdim/ idm,nde
      real rx(6)
      real rxs(6,120)
      integer rcomp
      do 50 i=1,na
      nsym=0
      nrx=1
      isk(nrx,i)=1
      call savex(x(1,i),rxs(1,nrx))
      do 130 ic=0,icent
      do 100 ns=1,nsymo
           call getrx(x(1,i),rx,rr,tt,ns,ic)
           do 110 irx=1,nrx
           if(rcomp(rx,rxs(1,irx)).eq.1) go to 120
 110       continue
c          site symmetry operator
           nrx=nrx+1
           call savex(rx,rxs(1,nrx))
           if(ic.eq.0) then
               isk(nrx,i)=ns
           else
               isk(nrx,i)=ns+nsymo
           end if
 120       continue
c          symmetry operator generating equivalent positions
           if(rcomp(rx,x(1,i)).eq.1) then
               nsym=nsym+1
               if(ic.eq.0) then
                    irs(nsym,i)=ns
               else
                    irs(nsym,i)=ns+nsymo
               end if
           end if
 100  continue
 130       continue
      isk(0,i)=nrx
      irs(0,i)=nsym
      mpl(i)=1
 50   continue
      write(6,*) 'site symmetry group'
      do 55 i=1,na
      write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(irs(j,i),j=1,irs(0,i))
c      write(6,'(a,i3/(20i4))') 'atom=',i,(irs(j,i),j=1,irs(0,i))
 55   continue
      write(6,*) 'equivalent position'
      do 56 i=1,na
      write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(isk(j,i),j=1,isk(0,i))
c      write(6,'(a,i3/(20i4))') 'atom=',i,(isk(j,i),j=1,isk(0,i))
 56   continue
      return
      end

      subroutine savex(rx,rxs)
      real rx(*),rxs(*)
      common /cdim/ idm,nde
      do 100 i=1,idm
      rxs(i)=rx(i)
 100  continue
      return
      end

      subroutine getrx(x,rx,r,t,ns,ic)
      real x(*),rx(*),t(6,*)
      integer r(6,6,*)
      do 100 i=1,6
           rx(i)=0.
           do 101 j=1,6
                rx(i)=rx(i)+r(i,j,ns)*x(j)
 101       continue
      rx(i)=rx(i)+t(i,ns)
      if(ic.eq.1) then
         rx(i)=-rx(i)
      end if
 100  continue
      return
      end

      subroutine gethr(h,hr,r,ns,icnt)
      integer h(*),hr(*),r(6,6,*)
      do 100 i=1,6
           hr(i)=0.
           do 101 j=1,6
                hr(i)=hr(i)+h(j)*r(j,i,ns)
 101       continue
      if(icnt.eq.1) then
          hr(i)=-hr(i)
      end if
 100  continue
      return
      end

c      integer function rcomp(x,rx)
c      real x(*),rx(*)
c      common /cdim/ idm,nde
c      common /cskip/ iskip,ltype
c      integer ntrc(3)
c      real trc(6,32,3)
c      data ntrc/1,2,32/
c      data (trc(i,1,1),i=1,6) /6*0.0/
c      data ((trc(i,j,2),i=1,6),j=1,2) /6*0.0,6*0.5/
c      data ((trc(i,j,3),i=1,6),j=1,32) /
c     *   0.0,0.0,0.0,0.0,0.0,0.0,  0.5,0.5,0.0,0.0,0.0,0.0,
c     *   0.5,0.0,0.5,0.0,0.0,0.0,  0.5,0.0,0.0,0.5,0.0,0.0,
c     *   0.5,0.0,0.0,0.0,0.5,0.0,  0.5,0.0,0.0,0.0,0.0,0.5,
c     *   0.0,0.5,0.5,0.0,0.0,0.0,  0.0,0.5,0.0,0.5,0.0,0.0,
c     *   0.0,0.5,0.0,0.0,0.5,0.0,  0.0,0.5,0.0,0.0,0.0,0.5,
c     *   0.0,0.0,0.5,0.5,0.0,0.0,  0.0,0.0,0.5,0.0,0.5,0.0,
c     *   0.0,0.0,0.5,0.0,0.0,0.5,  0.0,0.0,0.0,0.5,0.5,0.0,
c     *   0.0,0.0,0.0,0.5,0.0,0.5,  0.0,0.0,0.0,0.0,0.5,0.5,
c     *   0.0,0.0,0.5,0.5,0.5,0.5,  0.0,0.5,0.0,0.5,0.5,0.5,
c     *   0.0,0.5,0.5,0.0,0.5,0.5,  0.0,0.5,0.5,0.5,0.0,0.5,
c     *   0.0,0.5,0.5,0.5,0.5,0.0,  0.5,0.0,0.0,0.5,0.5,0.5,
c     *   0.5,0.0,0.5,0.0,0.5,0.5,  0.5,0.0,0.5,0.5,0.0,0.5,
c     *   0.5,0.0,0.5,0.5,0.5,0.0,  0.5,0.5,0.0,0.0,0.5,0.5,
c     *   0.5,0.5,0.0,0.5,0.0,0.5,  0.5,0.5,0.0,0.5,0.5,0.0,
c     *   0.5,0.5,0.5,0.0,0.0,0.5,  0.5,0.5,0.5,0.0,0.5,0.0,
c     *   0.5,0.5,0.5,0.5,0.0,0.0,  0.5,0.5,0.5,0.5,0.5,0.5/
c      data eps/0.00001/
cc       ltype=1,2,3 mean p,i,f in icosahedral lattice
c      rcomp=0
c      do 110 j=1,ntrc(ltype)
c           do 100 i=1,6
c           xx=abs(x(i)-rx(i)-trc(i,j,ltype))+eps/2
c           xx=mod(xx,1.)
c           if(xx.gt.1-eps) then
c                xx=abs(xx-1)
c           else if(xx.lt.-1+eps) then
c                xx=abs(xx+1)
c           end if
c           if(xx.gt.eps) go to 110
c 100       continue
c      rcomp=1
c      return
c 110  continue
c      return
c      end

      integer function rcomp(x,rx)
      real x(*),rx(*)
      common /cskip/ iskip,ltype
      real trc(6,32)
      data eps/0.00001/
c     ltype=1,2,3,4 mean p,i,f,s in icosahedral lattice
      call gettrc(ltype,trc,ntrc)
      rcomp=0
      do 110 j=1,ntrc
           do 100 i=1,6
           xx=abs(x(i)-rx(i)-trc(i,j))+eps/2
           xx=mod(xx,1.)
           if(xx.gt.1-eps) then
                xx=abs(xx-1)
           else if(xx.lt.-1+eps) then
                xx=abs(xx+1)
           end if
           if(xx.gt.eps) go to 110
 100       continue
      rcomp=1
      return
 110  continue
      return
      end

      subroutine gettrc(ltype,trc0,ntrc0)
      real trc0(6,*)
      integer ntrc(4)
      real trc(6,32,4)
      data ntrc/1,2,32,1/
      data (trc(i,1,1),i=1,6) /6*0.0/
      data ((trc(i,j,2),i=1,6),j=1,2) /6*0.0,6*0.5/
      data ((trc(i,j,3),i=1,6),j=1,32) /
     *   0.0,0.0,0.0,0.0,0.0,0.0,  0.5,0.5,0.0,0.0,0.0,0.0,
     *   0.5,0.0,0.5,0.0,0.0,0.0,  0.5,0.0,0.0,0.5,0.0,0.0,
     *   0.5,0.0,0.0,0.0,0.5,0.0,  0.5,0.0,0.0,0.0,0.0,0.5,
     *   0.0,0.5,0.5,0.0,0.0,0.0,  0.0,0.5,0.0,0.5,0.0,0.0,
     *   0.0,0.5,0.0,0.0,0.5,0.0,  0.0,0.5,0.0,0.0,0.0,0.5,
     *   0.0,0.0,0.5,0.5,0.0,0.0,  0.0,0.0,0.5,0.0,0.5,0.0,
     *   0.0,0.0,0.5,0.0,0.0,0.5,  0.0,0.0,0.0,0.5,0.5,0.0,
     *   0.0,0.0,0.0,0.5,0.0,0.5,  0.0,0.0,0.0,0.0,0.5,0.5,
     *   0.0,0.0,0.5,0.5,0.5,0.5,  0.0,0.5,0.0,0.5,0.5,0.5,
     *   0.0,0.5,0.5,0.0,0.5,0.5,  0.0,0.5,0.5,0.5,0.0,0.5,
     *   0.0,0.5,0.5,0.5,0.5,0.0,  0.5,0.0,0.0,0.5,0.5,0.5,
     *   0.5,0.0,0.5,0.0,0.5,0.5,  0.5,0.0,0.5,0.5,0.0,0.5,
     *   0.5,0.0,0.5,0.5,0.5,0.0,  0.5,0.5,0.0,0.0,0.5,0.5,
     *   0.5,0.5,0.0,0.5,0.0,0.5,  0.5,0.5,0.0,0.5,0.5,0.0,
     *   0.5,0.5,0.5,0.0,0.0,0.5,  0.5,0.5,0.5,0.0,0.5,0.0,
     *   0.5,0.5,0.5,0.5,0.0,0.0,  0.5,0.5,0.5,0.5,0.5,0.5/
      data (trc(i,1,4),i=1,6) /6*0.0/
      data eps/0.00001/
      call getsys(isys)
c     ltype=1,2,3,4 mean p,i,f,s in icosahedral lattice
      if(ltype.eq.0) then
         ntrc0=1
         ltyped=1
      else if(ltype.le.3) then
         ntrc0=ntrc(ltype)
         ltyped=ltype
      else if(ltype.eq.4) then
         if(isys.le.2) then
            ntrc0=32
            ltyped=3
         else if(isys.eq.3) then
            ntrc0=1
            ltyped=1
         end if
      end if
      do 110 j=1,ntrc0
           do 100 i=1,6
              trc0(i,j)=trc(i,j,ltyped)
 100       continue
 110  continue
      return
      end

      subroutine wtsmop(r1,t1,nsymo,d1,d2)
c*******************************************************************
c         representation of symmetry operators in the i.t. format
c*******************************************************************
      implicit integer (a-z)
      dimension r1(6,6,*)
      dimension r(6,6),lenc(60)
      real t1(6,*),t(6),eps,rtr(7)
      character xyz(6)
c        for (d2+d1) dimensional case
      character*31 z1(60),bl
      character*3 ntr(7)
      data xyz/'x','y','z','t','u','v'/
      data ntr/'1/2','1/3','2/3','1/4','3/4','1/6','5/6'/
      data rtr/0.5,0.333333,0.666666,0.25,0.75,0.166666,0.833333/
      data bl/'                            '/
      call getinp(inpu)
      call getout(iout)
      eps=0.00001
      d3=d1+d2
c******** write centering translations *********
c      if(ncnt.gt.1) then
c      do 50 i=1,ncnt
c      z1(i)=bl
c      cp=0
c      if(i.eq.1) then
c           z1(1)(1:1)='('
c           cp=1
c      end if
c      do 51 j=1,d3
c          do 52 k=1,7
c          if(abs(rtr(k)-cnt2(i,j)).lt.eps) then
c               z1(i)(cp+1:cp+3)=ntr(k)
c               cp=cp+3
c               go to 51
c          end if
c 52       continue
c          if(abs(cnt2(i,j)).lt.eps) then
c               z1(i)(cp+1:cp+1)='0'
c               cp=cp+1
c          end if
c 51   continue
c      if(i.lt.ncnt) then
c           z1(i)(cp+1:cp+1)=';'
c           cp=cp+1
c      else
c           z1(i)(cp+1:cp+1)=')'
c           cp=cp+1
c      end if
c      ip(i)=cp
c 50   continue
c      write(iout,'(1h ,6a)') (z1(i)(1:ip(i)),i=1,ncnt)
c      end if
c******** write symmetry operators *******
      do 10 ii=1,nsymo
           cp=1
           do 11 i=1,d3
           t(i)=t1(i,ii)
           do 11 j=1,d3
 11        r(i,j)=r1(i,j,ii)
           do 15 i=1,d3
                t(i)=mod(t(i),1.)
                if(t(i).lt.eps) then
                     t(i)=t(i)+1
                else if(t(i).gt.1.0-eps) then
                     t(i)=t(i)-1
                end if
 15        continue
           do 14 i=1,22
           z1(ii)=bl
 14        continue
           do 13 i=1,d3
           do 131 j=1,7
           if(abs(t(i)-rtr(j)).le.eps) then
                z1(ii)(cp:cp+2)=ntr(j)
                cp=cp+3
                go to 132
           end if
 131       continue
 132       continue
           do 12 j=1,d3
           if(j.le.d2) then
                k=j
           else if(j.gt.d2) then
                k=j+(3-d2)
           end if
           if(r(i,j).eq.1) then
                if(cp.eq.1) then
                     z1(ii)(cp:cp)=xyz(k)
                     cp=cp+1
                else if(z1(ii)(cp-1:cp-1).eq.',') then
                     z1(ii)(cp:cp)=xyz(k)
                     cp=cp+1
                else
                     z1(ii)(cp:cp+1)='+'//xyz(k)
                     cp=cp+2
                end if
           else if(r(i,j).eq.-1) then
                z1(ii)(cp:cp+1)='-'//xyz(k)
                cp=cp+2
           end if
           if(j.eq.d3.and.i.ne.d3) then
                z1(ii)(cp:cp)=','
                cp=cp+1
           else if(j.eq.d3.and.i.eq.d3) then
                z1(ii)(cp:cp)=';'
                cp=cp+1
           end if
 12        continue
 13        continue
           lenc(ii)=istrln(z1(ii))
 10   continue
      write(iout,'(1h ,6(i3,1x,a,1x))') (ii,z1(ii)(1:lenc(ii)),
     *                                                 ii=1,nsymo)
      return
      end

      subroutine decode(coord,r,t,n)
c     symmetry operation in I.T into matrix representation
      character coord*30
      integer r(6,6,*)
      real t(6,*)
      common /cdim/ idm,nde
      character sym(6)*20,xyz(6)
      data xyz/'x','y','z','t','u','v'/
      call getinp(inpu)
      call getout(iout)
c     position of ',' 
      i=1
      do 10 k=1,idm-1
         m=index(coord(i:30),',')
         if(m.eq.0) call quit(' incorrect symmetry operation')
         sym(k)=coord(i:i+m-2)
         i=i+m
 10   continue
      sym(idm)=coord(i:30)
c
c     do 30 j=1,idm
      do 30 j=1,6
         t(j,n)=0
c        do 20 k=1,idm
         do 20 k=1,6
            r(j,k,n)=0
   20    continue
c
c        rotation matrix
         do 25 k=1,idm
            i=index(sym(j),xyz(k))
            if(i.gt.0) then
               if(i.eq.1) then
                  r(j,k,n)=1
               else
                  if(sym(j)(i-1:i-1).eq.'+') then
                     r(j,k,n)=1
                  else
                     r(j,k,n)=-1
                  endif
               endif
            endif
   25    continue
c
c        translation vector
         i=index(sym(j),'/')
         if(i.gt.0) then
            read(sym(j)(i-1:i-1),'(i1)') n1
            read(sym(j)(i+1:i+1),'(i1)') n2
            t(j,n)=float(n1)/float(n2)
            if(i.ne.2.and.sym(j)(i-2:i-2).eq.'-') t(j,n)=-t(j,n)
         endif
   30 continue
      end

      subroutine mcpy(from,to)
      real from(6,6),to(6,6)
      do 100 i=1,6
      do 100 j=1,6
      to(i,j)=from(i,j)
 100  continue
      return
      end

      subroutine mtmpl(a,b,c)
      real a(6,6),b(6,6),c(6,6)
      do 100 i=1,6
      do 100 j=1,6
           c(i,j)=0.
           do 200 k=1,6
                c(i,j)=c(i,j)+a(i,k)*b(k,j)
 200       continue
 100  continue
      return
      end

      subroutine trnsp(sm)
      real smd(6,6),sm(6,6)
      do 100 i=1,6
      do 100 j=1,6
           smd(i,j)=sm(j,i)
 100  continue
      do 110 i=1,6
      do 110 j=1,6
           sm(i,j)=smd(i,j)
 110  continue
      return
      end

      subroutine rdhkl(hk,mpl,q,fcal,nh)
      integer hk(6,*),mpl(*)
      real q(*),fcal(*)
      nh=0
 100  continue
      nh=nh+1
      read(1,'(1h ,6i2,i5,f12.6)',end=200)
     *                 (hk(i,nh),i=1,6),mpl(nh),q(nh)
           go to 100
 200  continue
      nh=nh-1
      return
      end

