      integer function getmed() ! get median level in the histgram
      common /cjhist/ jhist(0:19)
      med=0
      max=0
      do i=0,19
         if(jhist(i).gt.max) then
            med=i
            max=jhist(i)
         end if
      end do
c     getmed=med*50+25          ! center value
      getmed=med*50+50          ! maximum value
      return
      end

c     density modification
      subroutine denmod(cr,frc,iset,izero)
c     cr : density
      real cr(0:*)
      include 'nsetmx.inc'
      common /den/ rmmx(2,nsetmx)
      real rmax(0:1000)
      integer ihist(0:1000)           ! histgram
      common /chist/ ihist
      integer mm(7),hkl(6)
      integer ng(6)
      character*80 frmt
      integer getnt,getizero,getmed
      call getng(ng)
 1    continue
      call getminmax(cr,rmx,rmn,rmax) ! calculate rmx,rmn,rmax
      rc=getrc(rmax,ng)               ! average peak density
      rspan=rmx-rmn                   ! maximum peak height
      rdiv=rspan/1000                 ! division of each slot
      write(6,*) 'rmx = ',rmx
      write(6,*) 'rmn = ',rmn
      write(6,*) 'rspan = ',rspan
      write(6,*) 'rdiv  = ',rdiv
      nt=getnt()
      call gethistg(cr,rmn,rspan,ihist) ! calculate histgram
      izero=getizero(rmn,rdiv)  ! zero level in histgram
c     offset=rmn                ! average density
      offset=0.
      f000=calf000(cr,offset)
      call setf000(iset,f000)
      medlv=getmed()            ! median level in histgram
      if(izero.gt.500) then
         call inversex(cr)
         goto 1
      end if

      call showhstg(ihist)      ! show histgram
      call posnega(ihist,rdiv,rmn) ! positive and negative area
      r0=getr0(frc,ihist,rspan,rmn) ! center of gaussian
      rsl=0.2*(rc-r0)           ! measure from r0
c     call denmod0(cr,nt,r0,rsl) ! density modification
c     r1=getr1(izero,rspan,rmn) ! center of gaussian
      r1=getr1(medlv,rspan,rmn) ! center of gaussian
      call denmod0(cr,nt,r1,rsl) ! density modification
      offset = 0.0
      f001=calf000(cr,offset)
      call setf001(iset,f001)

      write(6,*) 'rc,r0,r1,rmn,rmx',rc,r0,r1,rmn,rmx
      frmt='(4(a,f10.1))'
      write(6,frmt) 'rhomax',rmx,' rhomin',rmn,' rho sresh',rsl,
     *     ' rav',rc
      write(30,frmt) 'rhomax',rmx,' rhomin',rmn,' rho sresh',rsl,
     *     ' rav',rc
      rmmx(1,iset)=rmx
      rmmx(2,iset)=rmn
c     call getminmax(cr,rmx,rmn,rmax)
      return
      end

      subroutine chsdenmodf(i)
      common /cislct/ islct
      islct=i
      return
      end

      subroutine denmod0(cr,nt,r0,rsl)
      real cr(0:*)
      common /cislct/ islct
      if(islct.eq.1) then       ! for ldem
         call denmod00(cr,nt,r0,rsl)         
      else if(islct.eq.2) then  ! for mem ldem
         call denmod01(cr,nt,r0,rsl)         
      else
         write(6,*) 'islct in denmod0=',islct
         call quit('islct should be 1 or 2')
      end if
      return
      end

c     density modifilaction function for lodem
      subroutine denmod00(cr,nt,r0,rsl)  ! for lodem
      real cr(0:*)
      r00=r0
      do ii=0,nt-1
         r=cr(ii)-r00           ! for gaussian
         if(r.le.0.0) then      ! cut r < r0
            r1=0.0
         else
            r1=r*(1.0-exp(-0.5*(r/rsl)**2)) ! modification function
         endif
         cr(ii)=r1              ! modified density
      end do
      return
      end

c     density modifilaction function for mem and lodem
      subroutine denmod01(cr,nt,r0,rsl)  ! mem and lodem
      real cr(0:*)
      do ii=0,nt-1
         r=cr(ii)-r0            ! for gaussian
c        r1=r*(1.0-0.8*exp(-0.5*(r/rsl)**2)) ! modification function
         r1=r*(1.0-exp(-0.5*(r/rsl)**2)) ! modification function
         cr(ii)=r1              ! modified density
      end do
      return
      end

      subroutine getminmax(cr,rmx,rmn,rmax)
c     get minimum and maximum densities
      real cr(0:*)
      real rmax(0:*)
      integer hkl(6)
      integer ng(6)
      integer getnt
      call getng(ng)
      write(6,*) 'ng=',ng
c     get minimum and maximum densities : rmn,rmx

      call zerovr(rmax,1001)
      nt=getnt()
      call getidm(idm)
      do ii=0,nt-1
         call getindx(ii,hkl)   ! hkl indices (0<= hkl< ng-1)
c        write(6,*) 'hkl=',(hkl(j),j=1,idm),' x=',x(ii)
         j1=hkl(1)              ! 1st index
         den=cr(ii)             ! real density
         if(ii.eq.0) then
            rmx=den
            rmn=den
         else
            rmx=max(rmx,den)    ! maximum density
            rmn=min(rmn,den)    ! minimum density
         end if
         rmax(j1)=max(rmax(j1),den) ! peak density
c        write(6,*) 'den,rmn,rmx',den,rmn,rmx
      end do
c     write(6,*) 'rmn,rmx=',rmn,rmx
c      write(6,*) 'rmax=',(rmax(j1),j1=0,ng(1)-1)
      return
      end

      function calf000(cr,offset)      ! estimate f000 from positive parts
      real cr(0:*)      
      integer getnt
      nt=getnt()
c     write(6,*) 'nt in calf000=',nt
      f00=0
      f01=0
      do jj=0,nt-1
         if(cr(jj)-offset.gt.0) then
            f00=f00+(cr(jj)-offset)
         else
            f01=f01-(cr(jj)-offset)
         end if
      end do
c     calf000=f00*getsc()/nt    ! average height
      f000=f00*getsc()/nt        ! average height for positive parts
      f001=f01*getsc()/nt        ! average depth for negative parts
      write(6,*) 'f000,f001:',f000,f001
      calf000=(f000+f001)
      return
      end

      integer function getizero(rmn,rdiv)
      getizero=int(abs(rmn/rdiv))  ! slot number for zero level
c     getizero=int(-rmn/rdiv)      ! slot number for zero level
      write(6,*) 'zero is ',getizero,' at histgram'
c     write(6,*) 'rdiv  = ',rdiv
      return
      end

      subroutine gethistg(cr,rmn,rspan,ihist)  ! calculate histgram
      real cr(0:*)
      integer ihist(0:1000)
      integer getnt
      nt=getnt()
      call zerovi(ihist,1001)
      do jj=0,nt-1
         dnsty=(cr(jj)-rmn)
         ii=int(1000*dnsty/rspan) ! slot number 0-1000
         ihist(ii)=ihist(ii)+1  ! count number of points in a slot
      end do
c     write(6,*) 'rspan = ',rspan
      return
      end

      subroutine showhstg(ihist)      ! show histgram
      integer ihist(0:*)
      character*80 frmt
      common /cjhist/ jhist(0:19)
      do i=19,0,-1
         item=0
         do j=1,50
            item=item+ihist(i*50+j)
         end do
         jhist(i)=item
         if(i.eq.0) then
            item=item+ihist(0)
            n0=log10(float(item))+1
            n=max(n0,1)
            call getfrmt(frmt,n)
            write(6,frmt) i*50,'--',(i+1)*50,'| ',item
         else
            n0=log10(float(item))+1
            n=max(n0,1)
            call getfrmt(frmt,n)
            write(6,frmt) i*50+1,'--',(i+1)*50,'| ',item
         end if
      end do
      return
      end

      subroutine getfrmt(frmt,n)
      character(*) frmt
      if(n.lt.1) then
         write(6,*) 'n in getfrmt=',n
         call quit('n should be positive')
      else if(n.lt.10) then
         write(frmt,'(a,i1,a)') ''//'(i4,a,i4,a,i',n,')'//''
      else
         write(frmt,'(a,i2,a)') ''//'(i4,a,i4,a,i',n,')'//''
      end if
      return
      end

      subroutine posnega(ihist,rdiv,rmn)  ! positive and negative area
      integer ihist(0:*)
      real nfrac
      common /cpfrac/ pfrac

      rpos=0.0        !  positiove area
      rneg=0.0        !  negative area
      do i=0,1000
         tem=i*rdiv+rmn
c         write(6,*) tem
         if(tem.ge.0.0) then
            rpos=rpos+float(ihist(i))
         else
            rneg=rneg+float(ihist(i))
         endif
      end do
      pfrac=rpos/(rpos+rneg)  
      nfrac=rneg/(rpos+rneg)  
      write(6,*) 'fraction of positive area in map = ',pfrac
c     write(6,*) 'fraction of negative area in map = ',nfrac
      return
      end

      function getr1(medlv,rspan,rmn) ! center of gaussian
      common /cislct/ islct
c     rmn : minimum density
c     rspan : max_density-min_density
      if(islct.eq.2) then  ! for MEM LDE
         getr1=(rspan*0.15+rmn) ! for LDE  width for gaussian is 5%
      else
         getr1=0                ! original
c     r1=(medlv*rspan/1000+rmn)/2 ! for LDE  (median)
c         r1=(medlv*rspan/1000+rmn) ! for LDE  (median)
c     median level is sometimes less than zero level then
c     use it
c         getr1=min(0.0,r1)
c        write(6,*) '*********medlv,r1,getr1=',medlv,r1,getr1
      end if
      return
      end

      function getr0(frc,ihist,rspan,rmn)
c     center of gaussian used in density modification function
c     this is zero for LDEM while minimum density for MEM
      integer ihist(0:*)
      common /cislct/ islct
      integer getnt
      if(islct.eq.2) then  ! for MEM LDE
         getr0=rmn
      else
         getr0=0
c        getr0=rspan*10/1000.0+rmn ! run from rmn to rmx
         return
      end if

c     the following is only for LDE
c     frc positive area in map  (0.3 etc)  (1.0 for memlde)
c     this should not be zero
      nt=getnt()
      p=1.0-frc                    ! cut below frc
      ii=0
      do i=0,1000
         j=i
         ii=ii+ihist(i)
         p1=float(ii)/nt
         if(p1.ge.p) goto 10
      end do
 10   continue
      write(6,*) 'p,frc,j=',p,frc,j
      getr0=rspan*j/1000.0+rmn        ! run from rmn to rmx
      return
      end

      function getrc(rmax,ng)   ! get average peak density
      real rmax(0:*)
      integer ng(*)
      rc=0.0
      do i=0,ng(1)-1
         rc=rc+rmax(i)
      end do
      rc=rc/float(ng(1))        ! average peak density
      getrc=rc
      return
      end

      subroutine inversex(x)
c      complex x(0:*)
      real x(0:*)
      integer getnt
      nt= getnt()
      do i=0,nt-1
         x(i)=-x(i)
      end do
      return
      end

      function calph(fr,fi,ff)  ! calculate phase
      call geticent(icent)
      if(ff.eq.0.0) then
         ph=0.0
      else
         ph=todeg(atan3(fi,fr)) ! phase angle in degree
         if(icent.eq.1) then
            if(ph.gt.90.or.ph.lt.-90) then
               ph=180
            else
               ph=0
            end if
         endif
      endif
      calph=ph
      return
      end

c                 idph=caldph(iph1,iph2)
      integer function caldph(iph1,iph2)
      idph=mod(abs(iph1-iph2),360) ! phase change
      if(idph.gt.180) then
         idph=360-idph
      end if
      caldph=idph
      return
      end
      
      subroutine statist(cr,ci,fcc,igoto99,fsh,iset,iwr,sc2,sc3,
     *     ic,ic2,dp)
c     cr,ci : calculated structure factor obtained from modified density
      real cr(0:*),ci(0:*)
      real fcc
      include 'nrmax.inc'
      common /ref0/ fcal0(nrmax),iphas0(nrmax)
      character*80 frmt1
      integer id(6)
      save cor2old
      integer getnt,getnref,getiphas,getirefindx,caldph
      logical isFixed

      call getncycle(ncycle)
      tpi=atan(1.0)*8.0
      call getidm(idm)
      nt= getnt()
      call geticent(icent)
c     eps average phase change allowed in degree at the final cycle
c      eps=0.05
      eps=0.01
      dp=0.0
      sdp=0.0
      sc2=0.0
      sff=0.0
      see=0.0
      sef=0.0
      sf=0.0
      se=0.0
      sn=0.0
      sff2=0.0
      see2=0.0
      sef2=0.0
      sf2=0.0
      se2=0.0
      sn2=0.0

      nref=getnref()
      do i=1,nref               ! all reflections used
         ii=getirefindx(i)      ! address of independent refl. in cr,ci
         fr=cr(ii)
         fi=ci(ii)
c        fi=-ci(ii)
         ff=sqrt(fr**2+fi**2)
         call setfcali(i,ff)
c     if(i.le.100) then
c     write(6,*) 'ff=',ff
c     end if
         sc2=sc2+ff
         iph1=getiphas(i)       ! old phase
         if(isFixed(i)) then
            ph=iph1
         else
            ph=calph(fr,fi,ff)  ! calculate new phase
         end if
         iph2=ph                ! new phase
         call setiphas(i,iph2)  ! set new phase
         idph=caldph(iph1,iph2)
         fobsi=getfobsi(i)
         fcali=getfcali(i)
c        write(6,*) 'fobsi,fcali=',fobsi,fcali
         if(fobsi.ge.fsh) then
            sdp=sdp+float(idph)
            sff=sff+fcali*fcali
            see=see+fobsi*fobsi
            sef=sef+fobsi*fcali
            sf=sf+fcali
            se=se+fobsi
            sn=sn+1.0
         else
            sff2=sff2+fcali*fcali
            see2=see2+fobsi*fobsi
            sef2=sef2+fobsi*fcali
            sf2=sf2+fcali
            se2=se2+fobsi
            sn2=sn2+1.0
         end if
      end do

      write(6,*) '**** above fsh ****'
      write(6,*) 'sum of Fcal**2   : sff = ',sff
      write(6,*) 'sum of Fobs**2   : see = ',see
      write(6,*) 'sum of Fobs*Fcal : sef = ',sef
      write(6,*) 'sum of Fcal      :  sf = ',sf
      write(6,*) 'sum of Fobs      :  se = ',se
      write(6,*) 'number of ref1   :  sn = ',sn
c
      write(6,*) '**** below fsh ****'
      write(6,*) 'sum of Fcal**2   : sff2= ',sff2
      write(6,*) 'sum of Fobs**2   : see2= ',see2
      write(6,*) 'sum of Fobs*Fcal : sef2= ',sef2
      write(6,*) 'sum of Fcal      :  sf2= ',sf2
      write(6,*) 'sum of Fobs      :  se2= ',se2
      write(6,*) 'number of ref2   :  sn2= ',sn2

      sc2=float(nref)/sc2
      sc3=1.0
      dp=sdp/sn

      top=sef-se*sf/sn
      bot=sqrt((see-se*se/sn)*(sff-sf*sf/sn))
      cor=100.0*top/bot

      top=sef2-se2*sf2/sn2
      bot=sqrt((see2-se2*se2/sn2)*(sff2-sf2*sf2/sn2))
      cor2=100.0*top/bot

      frmt1='(2(a,2f10.2))'
      write(6,frmt1) 'c.c.',cor,sn,'  free c.c.',cor2,sn2
      write(30,frmt1) 'c.c.',cor,sn,'  free c.c.',cor2,sn2
      call exam(iset,iwr)
c      write(6,*) 'sdp,sn,dp=',sdp,sn,dp
c      write(6,*) 'ic,ncycle=',ic,ncycle
      if(ic.ge.ncycle) then     ! loop
         goto 999
      else if(ic.le.3) then     ! loop
c     else if(ic.eq.1) then     ! loop
         goto 888
      end if
      if(dp.gt.eps) then        ! convergence condition
         goto 888
      else
         ic2=ic2+1         
c         if(ic2.lt.2) then
c            goto 888
c         end if
         goto 999
      end if
 888  continue
      cor2old=cor2
      igoto99=1                 ! goto beginning of loop
      return
 999  continue                  ! stop 
      fcc=cor2
      igoto99=0
      return
      end

      function getpfrac()
      common /cpfrac/ pfrac
      getpfrac=pfrac
      return
      end

      subroutine initpfrac(frc0)
      common /cpfrac/ pfrac
      pfrac=frc0
      return
      end

      subroutine getf(cr,ci,ic2,fsh,sc2)
c     get real and imaginary part of structre factor cr,ci
c     from fobs and phase for all reflections
      real cr(0:*),ci(0:*)
      include 'nrmax.inc'
c     common /tbl/ stbl(0:451),dtor,rtod,id(6)
      integer hkl(6)
      integer getnt,getnref,getiphas,getirefindx
      data pi /3.141592/
      nt= getnt()
c     write(6,*) 'nt,nref,ic2=',nt,nref,ic2
c     write(6,*) 'sc=',getsc()
      call getidm(idm)
      call zerovr(cr,nt)
      call zerovr(ci,nt)
      nref=getnref()
      do i=1,nref
         fobsi=getfobsi(i)
         fcali=getfcali(i)
         if(fobsi.ge.fsh) then
            iph=getiphas(i)   ! phase angle in degree
            ph=torad(float(iph)) ! phase angle in radian
            if(ic2.eq.0) then
               w=tanh(sc2*fcali*fobsi)  
               fr=w*fobsi*cos(ph)  ! cos
               fi=w*fobsi*sin(ph)  ! sin
            else
               fr=fobsi*cos(ph)    ! cos
               fi=fobsi*sin(ph)    ! sin
            endif
            ii=getirefindx(i)
            cr(ii)=fr   ! real part of new structure factor
            ci(ii)=fi   ! imaginary part of new structure factor
c           call getindx(ii,hkl) ! hkl indices (0<= hkl< ng-1)
c           write(6,*) 'iref,x=',(iref(j,i),j=1,idm),cr(ii),ci(ii),hkl
         end if
      end do
      return
      end

      integer function getirefindx(i) ! get index for independent reflections
      integer id(6)
      call getiref(i,id)
      call tounitcell(id)       ! id: positive hkl indices
      getirefindx=indx(id)      ! ii: 1D index for id
      return
      end

      subroutine sclnt(cr,ci,nt,scl)  ! scaling by 1/nt
      real cr(0:*),ci(0:*)
      do i=0,nt-1
         cr(i)=cr(i)*scl/nt
         ci(i)=ci(i)*scl/nt
      end do
      return
      end

      function getfsh(fmax)     ! threshold for structure factor
c     fmax : maximum structure factor
      include 'nrmax.inc'
      integer hist(10001)
      integer getnref
c     calculate threshold for structure factor
      nref=getnref()
      nr=nref/2       ! important ?

      call zerovi(hist,10001)
      do i=1,nref
         nn=10000*getfobsi(i)/fmax+1 ! slot number
         hist(nn)=hist(nn)+1  ! histgram
      end do
      nn=0
      do i=10001,1,-1
         nn=nn+hist(i)
         if(nn.gt.nr) goto 53
         n=i-1
      end do

   53 continue
      fsh=float(n-1)*fmax/10000.  ! threashold for structure factor
      write(6,*) 'fs greater than',fsh,'  are used'
      write(30,*) 'fs greater than',fsh,'  are used'
      getfsh=fsh
      return
      end

      subroutine setncycle(incycle)
      common /cncycle/ incycled
      incycled=incycle
      return
      end

      subroutine getncycle(incycle)
      common /cncycle/ incycled
      incycle=incycled
      return
      end

      function getscl()
      common /cscl/ scl
      getscl=scl
      return
      end

      subroutine setscl(scld)
      common /cscl/ scl
      scl=scld
      return
      end

      subroutine exam(iset,iwr)
      include 'nrmax.inc'
      include 'nsetmx.inc'
      common /examin/ pest(2,nsetmx),rfact(nsetmx)
      common /cscl/ scl
      real per(2),wer(2),wfr(2),wefr(2)
      integer irefi(6)
      integer iorg(2,6)
      integer mmo(7),mm(7)
      integer ngo(6),ng(6)
      character*80 frmt1,frmt2
      real d(6)
      save ng
      integer dh(6)
      integer getnt,getnref,getiphas,getiphic
      data ng /2,2,2,2,2,2/     ! for j1,j2,..,jidm 0 or 1

      call getmm(mmo)           ! save original mm
      call getng(ngo)           ! save original ng
c     write(6,*) 'mmo=',mmo
c     write(6,*) 'ngo=',ngo
      call getidm(idm)
      call calmm(ng,idm)        ! cal mm for ng in this subroutine

      se=0.0
      sf=0.0
      sef=0.0
      nref=getnref()
      do i=1,nref
         fobsi=getfobsi(i)
         fcali=getfcali(i)
         se=se+fobsi
         sf=sf+fcali
         sef=sef+fobsi*fcali
c       write(6,*) 'fobsi,fcali=',fobsi,fcali
      end do
      scl=se/sf  ! scale for fcal

      write(6,*) 'scl in exam',scl
      frmt1='('' phase error1 '',4f7.2)'
      frmt2='('' phase error2 '',4f7.2)'
      per(1)=10000.0
      wefr(2)=10000.0
      dd=0.5

      nt= getnt()               ! nt for ng in the subroutine
      do ii=0,nt-1              ! j1,j2,..,jidm=0,1
         call getindx(ii,dh)    ! hkl indices (dh(j)=0 or 1)         
         do j=1,idm
            d(j)=dh(j)*dd       ! d(j)=0 or 0.5
         end do
         dph=0.0
         dpe=0.0
         dpf=0.0
         dpef=0.0
         df=0
         do i=1,nref
            call getiref(i,irefi)
            dp=vinpri(d,irefi,idm)
            dp=mod(dp,1.0)
            iph1=getiphas(i)
            dp=abs(amod(360.0*dp-iph1,360.0))
c     iph2=getiphic(i)
c     dp=abs(amod(360.0*dp-iph1+iph2,360.0))
            if(dp.gt.180) dp=360-dp
            dph=dph+dp
            fobsi=getfobsi(i)
            fcali=getfcali(i)*scl
            dpe=dpe+dp*fobsi
            dpf=dpf+dp*fcali
            dpef=dpef+dp*fobsi*fcali
            df=df+abs(fobsi-fcali)
         end do
c     rfct=df/sf
         rfct=df/se

c        write(6,'(f12.5,6i3)') dp,(dh(j),j=1,idm)
         dph=dph/float(nref)
         dpe=dpe/se
         if(sf.ne.0.0) then
            dpf=dpf/sf
            dpef=dpef/sef
         else
            dpe=0.0
            dpef=0.0
         endif
         if(dph.lt.per(1)) then
            per(1)=dph
            wer(1)=dpe
            wfr(1)=dpf
            wefr(1)=dpef
         endif
         if(dpef.lt.wefr(2)) then
            per(2)=dph
            wer(2)=dpe
            wfr(2)=dpf
            wefr(2)=dpef
         endif
      end do
      pest(1,iset)=per(1)
      pest(2,iset)=wefr(1)
      rfact(iset)=rfct
      write(6,frmt1) per(1),wer(1),wfr(1),wefr(1)
      write(6,frmt2) per(2),wer(2),wfr(2),wefr(2)
      if(iwr.ne.0) write(30,frmt1) per(1),wer(1),wfr(1),wefr(1)
      if(iwr.ne.0) write(30,frmt2) per(2),wer(2),wfr(2),wefr(2)
      call setmm(mmo)      ! restore mm
      call setng(ngo)      ! restore ng
c      call getmm(mmo)
c      call getng(ngo)
c      write(6,*) 'mmo=',mmo
c      write(6,*) 'ngo=',ngo
c      stop
      return
      end

      subroutine setmode(moded)
      common /cmode/mode
      mode=moded
      return
      end

      subroutine getmode(moded)
      common /cmode/mode
      moded=mode
      return
      end

      function getfrc(mode,frc0)
      if(mode.eq.0) then
         frc=frc0               ! fixed frc (original)
      else if(mode.eq.1) then
         frc=getpfrac()         ! calculated frc
      else
         call quit('mode should be 0 or 1')
      end if
      getfrc=frc
      return
      end

      subroutine getdensity(cr,ci,ic2,fsh,sc2)
      real cr(0:*),ci(0:*)
      integer ng(6)
c     get structre factor from fobs and phase
      call getf(cr,ci,ic2,fsh,sc2)
c     cr,ci : real and imag parts of structure factor for all reflactions
c     from fobs and iphas
      call getng(ng)
      call getidm(idm)
      call cft1(cr,ci,ng,idm,1,icon) ! cr: density
      return
      end

      subroutine denmodloop(iset,frc0,cr,ci,ic2,sc2,fsh,fcc)
c     before calling this, iphas should be set
      real cr(0:*),ci(0:*),fcc
      common /cpfrac/ pfrac
      character*80 prefix,flnm,flnm1,flnm2,frmt
      include 'nrmax.inc'
      common /ref0/ fcal0(nrmax),iphas0(nrmax)
      integer ng(6)
      integer getnt,getnref

      call getmode(mode)
      call getng(ng)
      call getidm(idm)
      izero0=500                ! center of the histgram
c     call initpfrac(frc0)      ! for mode=0

      nrall=getnref()
      nt=getnt()
      dp=0
      ic=0
      ic2=0

 99   continue

      ic=ic+1
      write(6,*) '#-------'
      write(6,'(a,f10.5,a)') 'fs greater than ',fsh,'  are used'
      frmt='(a,i3,a,f10.5,a,i8)'
      write(6,frmt) 'ic = ',ic,' dp = ',dp,' nrall=',nrall
      write(30,frmt) 'ic = ',ic,' dp = ',dp,' nrall=',nrall

c     get structre factor from fobs and phase
      call getdensity(cr,ci,ic2,fsh,sc2)

      frc=getfrc(mode,frc0)
      call denmod(cr,frc,iset,izero) ! cr: modified density
      call cft1(cr,ci,ng,idm,-1,icon) ! cr,ci: structure factor
c     scl=1.0
      scl=getf000(iset)/getf001(iset) ! scale factor
      write(6,*) 'scl in denmodloop:',scl
      call setscl(scl)
      call sclnt(cr,ci,nt,scl)  ! scaled structure factor
      write(6,'(a,i5,2(a,f10.5))') '******izero=',izero,
     *     ' frc used=',frc,' scl=',scl

      call getfcalall(fcal0)    ! separated from statist
      call getiphasall(iphas0)  ! separated from statist

      call statist(cr,ci,fcc,igoto99,fsh,iset,iwr,sc2,
     *     sc3,ic,ic2,dp)

      if(igoto99.eq.1) then
         go to 99
      end if
c     ***** end of loop *****         

      call getf(cr,ci,ic2,fsh,sc2)
c     cr,ci : real and imag parts of structure factor for all reflactions

c     if(izero.ge.izero0) then
c     call setfcalall(fcal0)
c     call setiphasall(iphase0)
c     end if

      write(6,*) '********final cycle********'
c     write(6,'(a,i6)') 'n = ',n
      write(6,'(a,f10.5,a)') 'fs greater than ',fsh,'  are used'
      frmt='(a,i3,a,f10.5,a,i8)'
      ic=ic+1
      write(6,frmt) 'ic = ',ic,' dp = ',dp,' nrall=',nrall
      write(30,frmt) 'ic = ',ic,' dp = ',dp,' nrall=',nrall
c     call wthklf(hkli,nind,sc3,iset)
      return
      end

c     initialize lodem
      subroutine initlodem(hkli,foi,sgi,nind,fmax)
      integer hkli(6,*)
      real foi(*),sgi(*)
      include 'nrmax.inc'
      include 'qsort.inc'      ! for use of t,ks,kp
      include 'origin.inc'

c     nind : number of observed reflections
      write(6,*) 'nind=',nind
c     set random phases for all reflections with
c     specified symmetry
      call symstflde(foi,sgi,hkli,nind,fmax) !  nref: total reflections
      write(6,*) 'number of independent reflections used',nind
c     write(6,*) 'fmax=',fmax
c     irefn : reflection number of reflections for fixing the origin
      call vcpyr(foi,t,nind)    ! for qsor
c     call qsort(t,ks,kp,nind)  ! sort in order of fobs
      call qsortd(t,ks,kp,nind) ! sort in order of fobs
      call fndirefn(hkli,kp,nind,irefn) ! irefn : refl. no.
      call getidm(idm)
      write(6,'(a,6i6)') 'fixed phase irefection number',
     *     (irefn(j),j=1,idm)
      return
      end

c     this should select strong reflections with linearly independent
c     diffraction vectors to each other
c     ***** not complete******
c     Schmit orthogonalization is necessary
      subroutine fndirefn(hkl,ip,nref,irefn) ! irefn : refl. no.
      integer hkl(6,*),ip(*),irefn(*)
      call getidm(idm)
      call zerovi(irefn,idm)
      if(nref.lt.idm) then
         write(6,*) 'nref should be larger than or equal to idm'
         call quit('stop in fndirefn')
      end if
      nind=0
c     do ii=nref,1,-1
      do ii=1,nref
         i=ip(ii)
         if(ischmit(nind,hkl(1,i),idm).eq.1) then
            irefn(nind)=i
c           write(6,*) 'nind,irefn(nind)',nind,irefn(nind)
         end if
         if(nind.eq.idm) then
            return
         end if
      end do
      write(6,*) 'no idm independent diffractions were found'
      return
      end

c     if y is linearly independent of nind vectors return 1 else 0
      integer function ischmit(nind,iy,idm)
      integer iy(6)
      common /cys/ys(6,6)
      real y(6)
      data eps /0.00001/
      do i=1,idm
         y(i)=iy(i)
      end do
      if(nind.eq.0) then
         call norml(y,idm)      ! normalization
         call vcpyr(y,ys(1,1),idm) ! unit vector
         nind=1
         ischmit=1
         return
      end if

      do i=1,nind
         if(icompr(y,ys(1,i),idm).eq.1) then  ! parallel to some vector
            ischmit=0
            return
         end if
      end do

      do i=1,nind
         sclrpr = vinp(ys(1,i),y,idm) ! scaler product of y and ys
c        write(6,*) sclrpr, ysnorm
c        Schmit orthogonalization
         if(abs(sclrpr).gt.eps) then ! orthogonalization
            do j=1,idm
               y(j)=y(j)-sclrpr*ys(j,i)
            end do               
         end if
      end do
c     y is a vector orthogonal to nind vectors ys

      absy = vabs(y,idm)      ! norm of a real vector
      if(absy.gt.eps) then
         nind=nind+1
         call vscaler(y,1.0/absy,ys(1,nind),idm) ! save normalized y in ys
         ischmit=1            
         return
      end if
      ischmit=0
      return
      end

      integer function icompr(v1,v2,n)  ! if v1=v2 or v1=-v2 return 1 else 0
      real v1(*),v2(*)
      data eps /0.00001/
      do i=1,n 
         if(abs(v1(i)-v2(i)).gt.eps) then ! parallel
            go to 100
         end if
      end do
      icompr = 1
      return
 100  continue
      do i=1,n 
         if(abs(v1(i)+v2(i)).gt.eps) then ! antiparallel
            icompr=0
            return
         end if
      end do
      icompr = 1
      return
      end

      subroutine setf000(iset,f0)
      include 'nsetmx.inc'
      include 'ldmsort.inc'
      f000(iset)=f0
      return
      end

      function getf000(iset)
      include 'nsetmx.inc'
      include 'ldmsort.inc'
      getf000=f000(iset)
      return
      end

      subroutine setf001(iset,f0)
      include 'nsetmx.inc'
      include 'ldmsort.inc'
      f001(iset)=f0
      return
      end

      function getf001(iset)
      include 'nsetmx.inc'
      include 'ldmsort.inc'
      getf001=f001(iset)
      return
      end
