      subroutine getfrmthklfs(idm,frmt)
      character(*) frmt
      if(idm.eq.3) then
         frmt='(a,3i4,2f12.4)'
      else if(idm.eq.4) then
         frmt='(a,4i4,2f12.4)'
      else if(idm.eq.5) then
         frmt='(a,5i4,2f12.4)'
      else if(idm.eq.6) then
         frmt='(a,6i4,2f12.4)'
      end if
      return
      end

c*************************************************************
      subroutine rdhklf(foi,sgi,hkli,nind,flnm,frmt)
c*************************************************************
      character(*) flnm,frmt
      real foi(*),sgi(*)
      integer hkli(6,*)
      integer ng(6)     ! number of divisions in the unit cell
      integer hkl(6),hr(6),hd(6)
      character(50) frmt1
      logical isSkipedref
      call openfile(1,flnm,'OLD')
      call getng(ng)
      call getidm(idm)
      call getsys(isys)
      call getsmtr(ismtr)
      ilen=istrln(flnm)
      write(6,'(2a,9i4)') 'flnm,ng,idm,isys,ismtr: ',
     &     flnm(1:ilen),(ng(j),j=1,idm),idm,isys,ismtr

      nind=0
      nrjc=0
      call getfrmthklfs(idm,frmt1)
c************* roop
 1    continue
      read(1,frmt,end=2) (hr(i),i=1,idm),fo,sg
c     write(6,frmt1) 'h=',(hr(j),j=1,idm),fo,sg
      if(hr(1).eq.999) then
         goto 2
      end if
      call smtrh(hr,hd,ismtr)    ! similarity transformation
      call ctoph(hd)  ! for ng limit  ******** 2002.04.16
      if(isSkipedref(hd)) then
         go to 1
      end if
      call ptoch(hd)            ! ****** 2002.04.16
      nind=nind+1
      foi(nind)=fo
      sgi(nind)=sg              ! for mem
      call vcpyi(hd,hkli(1,nind),6)
c      write(6,*) 'hkli=',(hkli(j,nind),j=1,idm),foi(nind)
      goto 1
c**************roop end

 2    continue
      close(1)
      write(6,*) 'nind',nind,' nrjc',nrjc
      return
      end

c*************************************************************
      subroutine wthklf(hkli,nind,iset)
c     output independent reflections and their phases
c*************************************************************
      integer hkli(6,*)  ! hkl indices of independent reflections
      include 'nrmax.inc'
      include 'iref.inc'
      integer hi(6),hr(6),heq(6,120),hd(6)

      real foi(nrmax)           ! fo for independent reflections
      real sgi(nrmax)           ! sigma for independent reflections
      common /cfoi/ foi,sgi

      character chr
      character(80) frmt2
      call getidm(idm)
      call getnsymo(nsymo)
      write(10,*) 'set number',iset
      write(chr,'(i1)') idm
      frmt2='('//chr//'i4,2f10.4,i5,f10.4)'
      call getsmtr(ismtr)
      sc=getsc()                ! average structure factor for fobs
      scl=getscl()              ! scale for fcal
      nn=0
      do i=1,nind
         if(iskip(hkli(1,i)).eq.1) go to 20 ! important
         call vcpyi(hkli(1,i),hi,6) ! *****2002.04.18
         neq=0
         do ns=1,nsymo
            do ic=0,1
               call gethr(hi,hr,ns,ic) ! *****2002.04.18
               if(iequiv(hr,heq,neq).eq.0) then ! independent reflections
                  nn=nn+1
                  if(nn.gt.nrmax) then
                     write(6,*) 'nn=',nn,' nrmax=',nrmax
                     call quit('nn > nrmax')
                  end if
c                 if(neq.eq.1) then
                  if(ns.eq.1.and.ic.eq.0) then
                     call smtrh(hr,hd,-ismtr) ! inverse similarity transf.
                     write(10,frmt2) (hd(j),j=1,idm),fobs(nn)*sc,
     *                    fcal(nn)*sc*sc,iphas(nn),sig(nn)*sc
                  end if
               end if
            end do
         end do
 20      continue
      end do
      f000=getf000(iset)
      write(10,frmt2) (0,j=1,idm),f000*sc,f000*sc,0,f000*sc/100
      return
      end


c*************************************************************
      subroutine wthklf1_0(hkli,nind,iset,x0)
c     output independent reflections and their phases
c     x0 : the new origin selected
c*************************************************************
      integer hkli(6,*)  ! hkl indices of independent reflections
      real x0(*)

      include 'nrmax.inc'
      include 'iref.inc'
      include 'newphs.inc'
      integer hi(6),hr(6),heq(6,120),hd(6)

      real foi(nrmax)           ! fo for independent reflections
      real sgi(nrmax)           ! sigma for independent reflections
      common /cfoi/ foi,sgi

      character chr
      character(80) frmt2
      integer getnewphas

      call getidm(idm)
      call getnsymo(nsymo)
      write(10,*) 'set number',iset
      write(chr,'(i1)') idm
      frmt2='('//chr//'i4,2f10.4,i5,f10.4)'
      call getsmtr(ismtr)
      sc=getsc()                ! average structure factor for fobs
      scl=getscl()              ! scale for fcal
      write(6,*) 'nind,nsymo,idm=',nind,nsymo,idm
      nn=0
      do i=1,nind
         if(iskip(hkli(1,i)).eq.1) go to 20 ! important
         call vcpyi(hkli(1,i),hi,6) ! *****2002.04.18
         neq=0
         do ns=1,nsymo
            do ic=0,1
               call gethr(hi,hr,ns,ic) ! *****2002.04.18
               if(iequiv(hr,heq,neq).eq.0) then
                  nn=nn+1
                  if(nn.gt.nrmax) then
                     write(6,*) 'nn=',nn,' nrmax=',nrmax
                     call quit('nn > nrmax')
                  end if
                  newph=getnewphas(iphas(nn),hr,x0,idm)
                  call setfphase(nn,newph)
c     if(neq.eq.1) then
                  if(ns.eq.1.and.ic.eq.0) then
                     call smtrh(hr,hd,-ismtr) ! inverse similarity transf.
                     write(10,frmt2) (hd(j),j=1,idm),fobs(nn)*sc,
     *                    fcal(nn)*sc*scl,newphas,sig(nn)*sc
                  end if
               end if
            end do
         end do
 20      continue
      end do
      f000=getf000(iset)
      write(10,frmt2) (0,j=1,idm),f000*sc,f000*sc,0,f000*sc/100
      return
      end

      subroutine wthklf1(hkli,nind,iset,x0)
      integer hkli(6,*)  ! hkl indices of independent reflections
      real x0(*)         ! new origin
c     call wthklf1_0(hkli,nind,iset,x0)
      call wthklf1_1(hkli,nind,iset,x0)
      return
      end
      
c*************************************************************
      subroutine wthklf1_1(hkli,nind,iset,x0)
c     output independent reflections and their phases
c     x0 : the new origin selected
c*************************************************************
      integer hkli(6,*)  ! hkl indices of independent reflections
      real x0(*)

      include 'nrmax.inc'
      include 'iref.inc'
      include 'newphs.inc'
      integer hi(6),hd(6)

      real foi(nrmax)           ! fo for independent reflections
      real sgi(nrmax)           ! sigma for independent reflections
      common /cfoi/ foi,sgi

      character chr
      character(80) frmt2
      integer getnewphas

      call zerovr(x0,6)  ! ***** reset x0

      call getidm(idm)
      call getnsymo(nsymo)
      write(10,*) 'set number',iset
      write(chr,'(i1)') idm
      frmt2='('//chr//'i4,2f10.4,i5,f10.4)'

      call getsmtr(ismtr)
c     write(6,*) 'ismtr=',ismtr

      sc=getsc()                ! average structure factor for fobs
      scl=getscl()              ! scale for fcal
c     write(6,*) 'getsc=',sc
c     write(6,*) 'getscl=',scl
c     write(6,*) 'nind,nsymo,idm=',nind,nsymo,idm
      nn=0

      do i=1,nind
         if(iskip(hkli(1,i)).eq.1) go to 20 ! important
         call vcpyi(hkli(1,i),hi,6) ! *****2002.04.18
         nn=iindx(i)            ! address of independent ref in cr,iphas
         newph=getnewphas(iphas(nn),hi,x0,idm)
         call smtrh(hi,hd,-ismtr) ! inverse similarity transf.
         write(10,frmt2) (hd(j),j=1,idm),fobs(nn)*sc,
     *        fcal(nn)*sc*scl,newph,sig(nn)*sc
 20      continue
      end do
      f000=getf000(iset)
      write(10,frmt2) (0,j=1,idm),f000*sc,f000*sc,0,f000*sc/100
      return
      end

      integer function getnewphas(iphas,hd,x0,idm)
      integer hd(*)
      real x0(*)
      nf=vinpir(hd,x0,idm)*360  ! phase in degree
      nf=mod(nf,360)
      getnewphas=iphas-nf
c     getnewphas=iphas+nf
c     write(6,'(a,8i5)') 'hd,iphas,nf=',(hd(j),j=1,3),iphas,nf
      getnewphas=mod(getnewphas,360)
      if(getnewphas.le.-180) then
         getnewphas=getnewphas+360
      else if(getnewphas.gt.180) then
         getnewphas=getnewphas-360
      end if
c     write(6,*) 'getnewphas=',getnewphas,' x0=',(x0(j),j=1,idm)
      return
      end

