      subroutine setiaslct(iaslct,irs)
      integer iaslct(*),irs(0:*)
      call zerovi(iaslct,120)
      call  getnsymo(nsymo,icent) ! get nsymo,icentd
      do i=1,irs(0)
c        write(6,*) 'irs(i)=',irs(i)
         iaslct(irs(i))=1
      end do
c     call wtvctrif('iaslct=',iaslct,nsymo*(1+icent),'(120i1)')
      return
      end

      subroutine choosesmop(rd,iaslct,m)
      integer rd(6,6,*),iaslct(*)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      n=0                       ! number of total symmetry operations
      m=0                       ! number of site symmetry operations
      do icnt=0,icent  ! copy site symmetry operators for large OD center
         do ns=1,nsymo
            n=n+1
            if(iaslct(n).eq.1) then
               m=m+1
               call mcpyi(r(1,1,ns),rd(1,1,m),6)
               if(icnt.eq.1) then
                  call invr(rd(1,1,m))
               end if
            end if
         end do
      end do
      return
      end

      subroutine gcoset1(iaslct0,iaslct,j) ! coset number for all R
      integer iaslct0(120),iaslct(120)
c   
c     calculate coset representatives (cosetrep) for j-th OD
c     ncst : number of cossets (number of coset representatives)
c     iaslct0(k) 1 for k-th symmetry operator is included in the site symmetry
c                0 otherweise
c     iaslct(k) 1 for k-th symmetry operator is included in the site symmetry
c                0 otherweise
c     
      include 'polygn.inc'
      integer coset,cosrep
      common /ccoset/ coset(120,namax),ncst(namax),cosrep(120,namax)
      integer rd,rsub
      common /cgetson/ rd(6,6,120),rsub(6,6,120),icost(120)
      real mpl
      common /toqcd2/ na,mpl(namax),isk(0:120,namax),irs(0:120,namax),
     *     isymo(0:120)
      real t0(6)
c     calculate coset for real-sitesymmetry
c     generate all the symmetry operation including inversion (rd)
c     copy site symmetry operations for large OD center
      call choosesmop(rd,iaslct0,ne)
c     copy site symmetry operations of occupation domain (rsub)
      call choosesmop(rsub,iaslct,nsub)
c     ne : no. of symmetry op. in site symmetry for center of large OD
c     nsub : no. of symmetry op. in site symmetry for small OD
      ncst(j)=ne/nsub           ! number of cosets
c     write(6,*) 'rsub created, nsub, ncst', nsub, ncst
c     generate cosets
      nc=ne/nsub                ! number of cosets
c      write(6,*) 'ne,nsub=',ne,nsub
c      write(6,*) 'number of cosets=',nc
      call zerovi(icost,120)    ! initialize
      ncst(j)=nc                ! number of cosets for j-th OD
      do ns=1,nc                ! ns : coset number
         call getcos(ns,nsub,coset(1,j)) ! set icost here
         call setcosrep(icost,cosrep,ns,j)
      end do
c      write(6,*) 'p.o.d. ',j,' number of cosets=',nc
c      write(6,'(a,20i4/(7x,20i4))') 'coset =',(coset(k,j),k=1,nc)
c      write(6,'(a,20i4/(7x,20i4))') 'cosrep=',(cosrep(k,j),k=1,ncst(j))
c     stop
      return
      end 

      integer function getncst(j)  ! get number of cosets for j-th OD
      include 'polygn.inc'
      integer coset,cosrep
      common /ccoset/ coset(120,namax),ncst(namax),cosrep(120,namax)
      getncst=ncst(j)
      return
      end

      integer function getcosrep(ns,j)
      include 'polygn.inc'
      integer coset,cosrep
      common /ccoset/ coset(120,namax),ncst(namax),cosrep(120,namax)
      getcosrep=cosrep(ns,j)
      return
      end

      subroutine setcosrep(icost,cosrep,ns,j)
c     cosrep(ns,j)
      integer icost(*),cosrep(120,*)
      call getnsymo(nsymo,icent) ! get nsymo,icentd            
      do k=1,nsymo*(1+icent)
c        write(6,*) 'k,icost(k),ns=',k,icost(k),ns
         if(icost(k).eq.ns) then
            cosrep(ns,j)=k      ! coset representativ of the nc-th coset
            go to 100
         end if
      end do
 100  continue
      return
      end

      subroutine getcos(ns,nsub,coset)
c     ns : coset number
c     get coset elements of the nc-th coset with the
c     coset representative for ns
      integer coset(*)
      integer rd,rsub
      common /cgetson/ rd(6,6,120),rsub(6,6,120),icost(120)
      integer rx(6,6)
      real t0(6)
      call zerov(t0,6)          ! initialize
      do i=1,nsub
c         call wtmtrxif('rsub',rsub(1,1,i),6,'(6i3)')
c         call wtmtrxif('rd',rd(1,1,ns),6,'(6i3)')
         call mtmpli(rd(1,1,ns),rsub(1,1,i),rx,6)
c         call wtmtrxif('rx',rx,6,'(6i3)')
         call getson1(nsd,rx)   ! rd(ns)*rsub(i) = r(nsd)
c        write(6,*) 'ns,nsd=',ns,nsd
         icost(nsd)=ns
         coset(ns)=ns
      end do
      return
      end

      subroutine getson(nsd,rx)  ! original
c     get symmetry operation number (ns) from matrix rd
      integer rx(6,6)
      integer rd,rsub
      common /cgetson/ rd(6,6,120),rsub(6,6,120),icost(120)
      real t0(6)
      call zerov(t0,6)
      call getnsymo(nsymo,icent) ! get nsymo,icentd
      do ns=1,nsymo*(1+icent)
         if(isamem(rx,rd(1,1,ns)).eq.1) go to 100
c        rx is equal to ns-th symmetry operator
         nsd=ns
         return    ! return ns
 100     continue
      end do
      call quit('error in getson')
      return
      end

      subroutine getson1(nsd,rx)
c     get symmetry operation number (ns) from matrix rd
      integer rx(6,6)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      real t0(6)
      integer ry(6,6)
      integer expnsic
      call zerov(t0,6)
      call getnsymo(nsymo,icent) ! get nsymo,icentd
c     write(6,*) 'nsymo,icent=',nsymo,icent
      do ic=0,icent
         do ns=1,nsymo
            call mcpyi(r(1,1,ns),ry,6)
c     write(6,*) 'ns=',ns
c     call wtmtrxif('ry0',ry,6,'(6i3)')
            if(ic.eq.1) then
               call mnegatei(ry,6)
            end if
c     call wtmtrxif('ry',ry,6,'(6i3)')
            if(isamem(rx,ry).eq.1) then
               nsd=expnsic(ns,ic)               
               return           ! return nsd
            end if
c     rx is equal to ns-th symmetry operator
         end do
      end do
      call quit('error in getson')
      return
      end

      subroutine invr(r)
      integer r(6,6)
      do i=1,6
         do j=1,6
            r(i,j)=-r(i,j)
         end do
      end do
      return
      end

      subroutine rtors(brv)     ! get symmetry operators for superstructures
      character brv
      call rtors1(brv)  ! new verstion
      return
      end

c     copy original symmetry operator
      subroutine orgsymo()
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer r0
      common /sym0/ r0(6,6,60),t0(6,60),nsymo0,icent0
      nsymo0=nsymo
      icent0=icent
      do ns=1,nsymo
         call mcpyi(r(1,1,ns),r0(1,1,ns),6)
         call vcpyr(t(1,ns),t0(1,ns),6)
      end do
      return
      end

c     copy superstructure symmetry operator
      subroutine supersymo()
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer rs
      common /syms/ rs(6,6,60),ts(6,60),nsymos,icents
      nsymos=nsymo
      icents=icent
      do ns=1,nsymo
         call mcpyi(r(1,1,ns),rs(1,1,ns),6)
         call vcpyr(t(1,ns),ts(1,ns),6)
      end do
      return
      end

      subroutine toorgsymo()    ! switch symmetry operator expression
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer r0
      common /sym0/ r0(6,6,60),t0(6,60),nsymo0,icent0
      nsymo=nsymo0
      icent=icent0
      do ns=1,nsymo
         call mcpyi(r0(1,1,ns),r(1,1,ns),6)
         call vcpyr(t0(1,ns),t(1,ns),6)
c        call wtmtrxif('r0',r0(1,1,ns),6,'(6i3)')
      end do
      return
      end

      subroutine tosupersymo()  ! switch symmetry operator expression
      integer rs
      common /syms/ rs(6,6,60),ts(6,60),nsymos,icents
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      nsymo=nsymos
      icent=icents
      do ns=1,nsymo
         call mcpyi(rs(1,1,ns),r(1,1,ns),6)
         call vcpyr(ts(1,ns),t(1,ns),6)
c        call wtmtrxif('rs',rs(1,1,ns),6,'(6i3)')
      end do
      return
      end

      subroutine rtors1(brv)    ! get symmetry operators for superstructures
c     save original symmetry operator at sym0 common block
      character brv
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer rs
      common /syms/ rs(6,6,60),ts(6,60),nsymos,icents

      real rc(6,6),rd(6,6),td(6)
      real trm1(6,6),trm2(6,6)
      common /ccelltr/ trm1,trm2
      integer getidm
      call orgsymo()  ! save original symmetry operators
      if(brv.ne.'s') then
c     just copy
         do ns=1,nsymo
            call mtcpyi(r(1,1,ns),rs(1,1,ns),6)
            call vcpyr(t(1,ns),ts(1,ns),6)
         end do
         nsymos=nsymo
         icents=icent
         return
      end if
      do ns=1,nsymo
         call mtmplrmno(trm1,t(1,ns),td,6,6,1)
         call mtmplri6(trm1,r(1,1,ns),rc)
         call mtmplr6(rc,trm2,rd)
         call mround(rd,rs(1,1,ns),0.001,6)
         do i=1,6
            ts(i,ns)=mod(td(i),1.)
         end do
      end do
      nsymos=nsymo
      icents=icent
      idm=getidm()
      call wtsymo(rs,ts,nsymo,idm)
      return
      end

      subroutine setcelltr()
c     cell transformation matrix for decagonal superstructures
      real b(6)
      real trm1(6,6),trm2(6,6)
      common /ccelltr/ trm1,trm2
c      data trm1 /2, 2,-3, 2,0,0,   ! transformation matrix*5
c     *          -1, 4,-1,-1,0,0,
c     *           1, 1, 1, 1,0,0,
c     *          -2, 3,-2, 3,0,0,
c     *           0, 0, 0, 0,5,0,
c     *           0, 0, 0, 0,0,5/
      data trm2 /1, 0, 1,-1,0,0,   ! inverse transformation matrix for d*
     *           0, 1, 1, 0,0,0,
     *          -1, 0, 2, 0,0,0,
     *           0,-1, 1, 1,0,0,
     *           0, 0, 0, 0,1,0,
     *           0, 0, 0, 0,0,1/
      call mcpyr6(trm2,trm1)    ! transformation matrix for d*
      call matinv6(trm1,b,0,det)
      call wtmtrxrf('trm1',trm1,6,'(6f10.5)')
      call wtmtrxrf('trm2',trm2,6,'(6f10.5)')
      return
      end

      subroutine setcelltr6()  ! does not work
c     cell transformation matrix for decagonal superstructures in 6D rep.
      real b(6)
      real trm3(6,6),trm4(6,6)
      common /ccelltr6/ trm3,trm4
      data trm4 /1, 0, 0,-1, 0,0,   ! inverse transformation matrix for d*
     *           0, 1, 0, 0,-1,0,
     *          -1, 0, 1, 0, 0,0,
     *           0,-1, 0, 1, 0,0,
     *           0, 0,-1, 0, 1,0,
     *           0, 0, 0, 0, 0,1/
      call mcpyr6(trm4,trm3)
      call matinv6(trm3,b,0,det)
      call wtmtrxrf('trm3',trm3,6,'(6f10.5)')
      call wtmtrxrf('trm4',trm4,6,'(6f10.5)')
      return
      end

      subroutine celltr6(x,mode)
      real x(*)
      call  celltr6_1(x,mode)
c     call  celltr6_0(x,mode)  ! does not work
      return
      end

      subroutine celltr6_1(x,mode)
      real x(*)
      real xd(6)
      real trm3(6,6),trm4(6,6)
      common /ccelltr6/ trm3,trm4
      call tr6to5e(x,xd)
      call celltr(xd,mode)
      call tr5to6e(xd,x)
      return
      end

      subroutine celltr6_0(x,mode)
c     coordinate transformation for decagonal superstructures in 6D rep.
      real x(*)
      real xd(6)
      real trm3(6,6),trm4(6,6)
      common /ccelltr6/ trm3,trm4
      if(mode.eq.1) then
         call mtmplrmno(trm3,x,xd,6,6,1)
         call vcpyr(xd,x,6)
      else if(mode.eq.-1) then
         call mtmplrmno(trm4,x,xd,6,6,1)
         call vcpyr(xd,x,6)
      else
         call quit('invalid mode in celltr')
      end if
      return
      end

      subroutine celltr(x,mode)
      real x(*)
c     call celltr1(x,mode)
      call celltr0(x,mode)
      return
      end

      subroutine celltr1(x,mode)
c     coordinate transformation for decagonal superstructures
      real x(*)
      real xd(6)
      real trm1(6,6),trm2(6,6)
      common /ccelltr/ trm1,trm2
      if(mode.eq.1) then
         call mtmplrmno(trm1,x,xd,6,6,1)
         call vcpyr(xd,x,6)
      else if(mode.eq.-1) then
         call mtmplrmno(trm2,x,xd,6,6,1)
         call vcpyr(xd,x,6)
      else
         call quit('invalid mode in celltr')
      end if
      return
      end

      subroutine celltr0(x,mode)
c     coordinate transformation for decagonal superstructures
      real x(*)
      real xd(6)
      real trm1(6,6),trm2(6,6)
      common /ccelltr/ trm1,trm2
      if(mode.eq.1) then
         do i=1,6
            xd(i)=0
            do j=1,6
               xd(i)=xd(i)+trm1(i,j)*x(j)
            end do
         end do
         do i=1,6
            x(i)=xd(i)
         end do
      else if(mode.eq.-1) then
         do i=1,6
            xd(i)=0
            do j=1,6
               xd(i)=xd(i)+trm2(i,j)*x(j)
            end do
         end do
         do i=1,6
            x(i)=xd(i)
         end do
      else
         call quit('invalid mode in celltr')
      end if
      return
      end

      subroutine reduc(ry)
      real ry(*)
      do 100 i=1,6
          ry(i)=mod(ry(i),1.)
          rd=ry(i)
          if(rd.lt.-0.499) then
               ry(i)=ry(i)+1
          else if(rd.gt.0.501) then
               ry(i)=ry(i)-1
          end if
 100  continue
      return
      end

      subroutine tr5to6e(ei,fi)
      real fi(*),ei(*)
      integer sd(6,6)
      data sd/ 1,0,0,0,-1,0,
     *         0,1,0,0,-1,0,
     *         0,0,1,0,-1,0,
     *         0,0,0,1,-1,0,
     *         0,0,0,0, 0,1,
     *         0,0,0,0, 0,0/
      do j=1,6
         fi(j)=0.
         do k=1,5
             fi(j)=fi(j)+sd(j,k)*ei(k)
          end do
      end do
      return
      end


      subroutine setbrv(brv)  ! set brvais lattice type
      character brv0,brv
      common /cbrv/ brv0
      brv0=brv
      return
      end

      subroutine getbrv(brv)  ! get brvais lattice type
      character brv0,brv
      common /cbrv/ brv0
      brv=brv0
      return
      end

      subroutine setskp(iskp)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      cskip=iskp
      return
      end

      subroutine getskp(iskp)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      iskp=cskip
      return
      end

      integer function getisys()  ! get crystal system
      call getsys(isysd)
      getisys=isysd
      return
      end

      subroutine getsys(isysd)  ! get crystal system
      real d0,d1,d2,d3
      common /cisys/ isys
      isysd=isys
c     write(6,*) 'isys in getsys=',isysd
      return
      end            

      subroutine setsys(isysd)  ! set crystal system
      real d0,d1,d2,d3
      common /cisys/ isys
      isys=isysd
c     write(6,*) 'isys in setsys=',isys
      return
      end            

      subroutine  getnsymo(nsymod,icentd) ! get nsymo,icentd
c     nsymo : number of symmetry operators
c     icentd: 0 or 1 for noncentrosymmetric and centrosymmetric
      integer rr
      real tt
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      nsymod=nsymo
      icentd=icent
      return
      end

      integer function getidm()
      common /cdim/ idm,nde
      getidm=idm
      return
      end

      subroutine rdsymo(na,brv)  ! read symmetry operators
c     read generators of the symmetry operators
      common /cwflag/ iwflag(6)
      character brv
      character*80 dummy
      integer rr
      real tt
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      common /extcr/ nextnc,icef(7,60)
      common /cdim/ idm,nde
      common /cskip/ iskip,ltype

      integer imps(60),rg(6,6,5)
      real tg(6,5)
      character*30 coord
      character cltd(5)

      data cltd/'p','i','f','s','c'/      

c     initialization
      call setcelltr()  ! initialize cell transformation matrix for decag.
      call setcelltr6() ! initialize cell transformation matrix for 6D rep.
      call set7to5emtrx() ! initialize cell transformation matrix for dodec.
      call getinp(inpu)
      call getout(iout)
c     iwflag(3)=1
      ige=1
c
c      read(inpu,100) nsymo,icent,brv
       call freadi('nsymo=',1,nsymo,1)
       call freadi('icent=',1,icent,0)
       call freadc('brv=',1,brv,0)
      nde=3
      icom=0
c
      write(iout,210) nsymo,icent,brv
      do i=1,5
         if(brv.eq.cltd(i)) then
            ltype=i
         end if
      end do
      if(ltype.eq.0) then
c          call quit('ltype incorrect')
         write(6,*) '******ltype=0*****'
      end if
      idm=nde+3
c      read(inpu,*) 'symmetry operator'
      call freadc('symmetry operator',0,dummy,1)
      do k=1,nsymo
         read(inpu,'(a)') coord
         call decode(coord,rr,tt,k)
      end do

      if(iwflag(3).eq.1) then
         if(icent.eq.1.or.icent.eq.-1) then
            write(iout,2022)
         else
            write(iout,2021)
         end if
         if(ige.eq.1) then
            write(iout,201) 'generating elements'
         end if
         write(iout,'(1h )')
      end if
      nn=nde+1
      if(iwflag(3).eq.1) then
          call wtsymo(rr,tt,nsymo,idm)
      end if
      if(ige.eq.1) then
           call ordr(rr,imps,nsymo,idm)
           do i=1,nsymo
              call vcpyr(tt(1,i),tg(1,i),6)
              call mcpyi(rr(1,1,i),rg(1,1,i),6)
           end do
           impt=1
           call zerov(tt(1,1),6)
           call unitmtrxi(rr(1,1,1),6)
           do ns=1,nsymo
           imp=imps(ns)
c          modified to include the pure translation
           if(imp.eq.1) then
             if(tg(1,ns).ne.0.or.tg(2,ns).ne.0.or.tg(3,ns).ne.0
     *      .or.tg(4,ns).ne.0.or.tg(5,ns).ne.0.or.tg(6,ns).ne.0)
     *       imp=2
           end if
           do i=2,imp
              do j=1,impt
                 mp1=j+(i-2)*impt
                 mp2=j+(i-1)*impt
                 call mpso(rg,tg,ns,rr,tt,mp1,mp2,idm)
              end do
           end do
           impt=impt*imp
        end do
        nsymo=impt
        if(iwflag(3).eq.1) then
           write(iout,207)
           write(iout,'(1h )')
           call wtsymo(rr,tt,nsymo,idm)
        end if
      end if
      call getsys(isys)

c     transformation of x0,x and ej for the 5-fold superstructures
      call rtors(brv)           ! set symmetry operators for superstructures
c     for normal structures symmetry operators are just copied
c      end if

      if(nextnc.eq.0) return
      if(iwflag(3).eq.1) then
           write(iout,231)
      end if
c
c      do 90 i=1,nextnc
c      read(inpu,100) (icef(j,i),j=1,6),nmod(i)
c      call freadi('mi=',idm+1,icef(1,i),1)
c      if(iwflag(3).eq.1) then
c           write(iout,230) (icef(j,i),j=1,6),nmod(i)
c           write(iout,230) (icef(j,i),j=1,idm+1)
c      end if
c 90   continue
      return
 100  format(7i3)
 101  format(9i3,3f9.6,i3)
 102  format(3f8.5,2i3)
 103  format(24i3)
 200  format(1h ,2x,i2,4x,9f6.2,5x,3f10.6,5x,i3)
 201  format(1h ,a)
 2021 format(1h ,'symmetry operation',10x,'noncentrosymmetric')
 2022 format(1h ,'symmetry operation',10x,'centrosymmetric')
 204  format(1h ,'wavevector k',i1,10x,3f9.6,3x,'icorc=',i3,2x
     *       ,'ilm=',i3,2x,a2,'commensurate')
 205  format(1h ,'basic wavevectors')
 206  format(1h ,'generating elements')
 207  format(1h ,'symmetry operators generated by generating elements')
 208  format(1h ,i3,10x,24i3)
 209  format(1h ,'atom',9x,'symmetry operator to be skipped =1')
 210  format(1h ,'nsymo=',i3,2x,'icent=',i2,2x,'brv=',a)
 211  format(1h ,'periods along a,b,c axes' ,3i5)
 230  format(1h ,7i5)
 231  format(1h ,'extinction rules for general reflections'/1h ,
     *          'm1,m2,..,m6,m of m1*h1+m2*h2+...+m6*h6=m*n')
      end

      subroutine ordr(re,imps,nsymo,idm)
      integer re(6,6,*),imps(*)
      integer r(6,6),a(6,6),b(6,6)
      data eps/0.001/
      call getinp(inpu)
      call getout(iout)
      do i=1,nsymo
         do j=1,idm
            do k=1,idm
               r(j,k)=re(j,k,i)
               b(j,k)=r(j,k)
            end do
         end do
         do 12 j=1,13
c     check whether r is identity operator or not
            do k=1,idm
               if(r(k,k).ne.1) go to 15
               do l=1,idm
                  if(k.ne.l.and.r(k,l).ne.0) go to 15
               end do
            end do
            imps(i)=j
            go to 10
c     a=r
 15         continue
            do k=1,idm
               do l=1,idm
                  a(k,l)=r(k,l)
               end do
            end do
c     r=a*b   ==> r=r*re
            do k=1,idm
               do l=1,idm
                  r(k,l)=0
                  do m=1,idm
                     r(k,l)=r(k,l)+a(k,m)*b(m,l)
                  end do
               end do
            end do
 12      continue
 10      continue
      end do
      do i=1,nsymo
         if(imps(i).ge.13) then
            ierror=1
            go to 21
         else
            ierror=0
         end if
      end do
 21   continue
      if(ierror.eq.1) then
         write(iout,'(1h ,''error in symmetry operator ?'',a,24i3)')
     *        '  order: ',(imps(i),i=1,nsymo)
      end if
      return
      end

      subroutine wtsymo(rr,tt,nsymo,idm) ! print out symmetry operators
      integer rr(6,6,*)
      real tt(6,*)
      common /cwflag/ iwflag(6)
      character*3 wtt(6,60)
      integer wd(3),w
      data wd/6,5,4/,eps/0.001/

      call getinp(inpu)
      call getout(iout)
      w=wd(idm-3)
      ll=(nsymo-1)/w+1
      le=nsymo-(ll-1)*w
      call wtsmop(rr,tt,nsymo,idm-3,3)
      write(iout,'(1h )')
      call getwtt(tt,wtt,nsymo,idm)
c      do 31 ii=1,ll
c      lbgn=(ii-1)*w+1
c      if(ii.ne.ll) lend=lbgn+w-1
c      if(ii.eq.ll) lend=lbgn+le-1
c      do 31 i=1,idm
c      if(idm.eq.4) write(iout,204) ((rr(i,j,k),j=1,idm),wtt(i,k),
      return
 204  format(1h ,8(4i2,1x,a,2x))
 205  format(1h ,7(5i2,1x,a,2x))
 206  format(1h ,6(6i2,1x,a,2x))
      end

      subroutine getwtt(tt,wtt,nsymo,idm)
      real tt(6,*)
      character*3 wtt(6,*)
      real rt(8)
      character*3 wt(8)
      data rt/0.,0.5,0.333333,0.666666,0.25,0.75,0.166666,0.833333/
      data wt/'0','1/2','1/3','2/3','1/4','3/4','1/6','5/6'/
      data eps/0.00001/
      
      call getinp(inpu)
      call getout(iout)
      do i=1,nsymo
         do j=1,idm
            td=tt(j,i)
c     td=mod(td,1.)
            td=mod(td,1.)
            if(td.lt.-eps) then
               td=td+1
            else if(td.gt.1-eps) then
               td=td-1
            end if
            do k=1,8
               if(abs(td-rt(k)).lt.eps) then
                  wtt(j,i)=wt(k)
                  go to 110
               end if
            end do
 110        continue
         end do
      end do
      return
      end

      subroutine mpso(r1,t1,m1,r2,t2,m2,m3,idm)
      integer r1(6,6,*),r2(6,6,*)
      real t1(6,*),t2(6,*)
      do i=1,idm
         t2(i,m3)=0.0
         do j=1,idm
            t2(i,m3)=t2(i,m3)+r1(i,j,m1)*t2(j,m2)
         end do
         t2(i,m3)=t2(i,m3)+t1(i,m1)
         do j=1,idm
            r2(i,j,m3)=0.0
            do k=1,idm
               r2(i,j,m3)=r2(i,j,m3)+r1(i,k,m1)*r2(k,j,m2)
            end do
         end do
      end do
      return
      end

      subroutine sitesy0_s(na,mpl,x,isk,irs) ! silent version
c     site symmetry in original (non super) coordinate systems
      real mpl(*),x(6,*)
      integer isk(0:120,*),irs(0:120,*)
      call sitesy_s(na,mpl,x,isk,irs) ! silent version
      return
      end

      subroutine sitesy1_s(na,mpl,x,isk,irs) 
c     site symmetry in  coordinate in super cell
      real mpl(*),x(6,*)
      integer isk(0:120,*),irs(0:120,*)
      call tosupersymo()        ! restore superstructure symmetry operators
      call sitesy_s(na,mpl,x,isk,irs) ! transform coordinates in super cell
      call toorgsymo()          ! switch to original symmetry operators
      return
      end

      subroutine sitesy(na,mpl,x,isk,irs) ! original (printout sym. op.)
      real mpl(*),x(6,*)
      integer isk(0:120,*),irs(0:120,*)
      call sitesy_s(na,mpl,x,isk,irs) ! silent version
      write(6,*) 'site symmetry group'
      do i=1,na
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(irs(j,i),j=1,irs(0,i))
c     write(6,'(a,i3/(20i4))') 'atom=',i,(irs(j,i),j=1,irs(0,i))
      end do
      write(6,*) 'equivalent position'
      do i=1,na
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(isk(j,i),j=1,isk(0,i))
c     write(6,'(a,i3/(20i4))') 'atom=',i,(isk(j,i),j=1,isk(0,i))
      end do
      write(6,*) 'multiplicity'
      do i=1,na
         write(6,'(a,i4,f10.5)') 'atom',i,mpl(i)
      end do
      return
      end

      subroutine sitesy_s(na,mpl,x,isk,irs)   ! silent 
c     site symmetry for selected subgroup
      real mpl(*),x(6,*)
      integer isk(0:120,*),irs(0:120,*)
      common /cdim/ idm,nde

      real rx(6)
      real rxs(6,120)
      integer rcomp,expnsic
      call getnsymo(nsymo,icent)
      call getsys(isys)
      if(isys.le.2) then
         icentd=icent
         istep=1
      else
         if(icent.eq.0) then
            icentd=icent
            istep=1
         else
            icentd=icent   ! include antisymmetric inversion -1
            istep=icent    ! include antisymmetric inversion -1
         end if
      end if

      do i=1,na
         nsym=0
         nrx=1
         isk(nrx,i)=1
         call savex(x(1,i),rxs(1,nrx))
         do ic=0,icentd,istep
            do ns=1,nsymo
               nst=expnsic(ns,ic)
               call getrx(x(1,i),rx,ns,ic)
               do irx=1,nrx
                  if(rcomp(rx,rxs(1,irx)).eq.1) go to 120
               end do
c     site symmetry operator
               nrx=nrx+1
               call savex(rx,rxs(1,nrx))
               isk(nrx,i)=expnsic(ns,ic)
 120           continue
c     symmetry operator generating equivalent positions
               if(rcomp(rx,x(1,i)).eq.1) then
                  nsym=nsym+1
                  irs(nsym,i)=expnsic(ns,ic)
               end if
            end do
         end do
         isk(0,i)=nrx
         irs(0,i)=nsym
         mpl(i)=1

c         if(icent.eq.1.or.(icent.eq.-1.and.x(6,i).eq.0.)) then
cc           compress symmetry element > nsymo
c            n=0
c            do j=1,isk(0,i)
c               if(isk(j,i).gt.nsymo) go to 201
c               n=n+1
c            end do
c 201        continue
cc     n: number of equivalent positions generated by given operators
cc     isk(0,i): number of equivalent positions generated by given
cc     symmetry operators and inversion
c            mpl(i)=float(isk(0,i))/(float(n)*2)
c            isk(0,i)=n
c         end if
      end do
      return
      end

      subroutine getrx(x,rx,ns,ic)   ! symmetry operation
      real x(*),rx(*)
      integer r
      real t
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer getisys
      isys=getisys()
      call mtmplmnoir(r(1,1,ns),x,rx,6,6,1)
      if(isys.le.2) then
         call vadd(rx,t(1,ns),rx,6)
         if(ic.eq.1) then
            call vnegater(rx,6)
         end if
      else
         call vadd(rx,t(1,ns),rx,5)
         if(ic.eq.1.or.ic.eq.-1) then
            call vnegater(rx,5)
         end if
         if(ic.eq.-1) then
            rx(6)=-rx(6)            
         end if
      end if
      return
      end

      subroutine getrx1(x,rx,tt,ns,ic)  ! extra translation tt after symm. op.
      real x(6),rx(6),tt(6)
      integer r
      real x0(6),rx0(6)
      integer getisys
      isys=getisys()
*******************************
c     call rmvdst(x,x0)   ! remove distortion is necessary ?
      call vcpyr(x,x0,6)        ! no distortion
*******************************
c     write(6,'(a,2i3,6f10.5)') 'ns,ic,tt',ns,ic,tt
      call getrx(x0,rx0,ns,ic)
      if(isys.le.2) then
         call vadd(rx0,tt,rx0,6)  ! additional translation 
      else
         call vadd(rx0,tt,rx0,5)  ! additional translation
      end if
*******************************
c      call adddst(rx0,rx)    ! restore distortion
      call vcpyr(rx0,rx,6)          ! no distortion
*******************************
      return
      end

      subroutine getrx0(x,rx,ns,ic)  ! just rotate 6D vector
      real x(*),rx(*)
      integer rr
      real tt
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      call getsys(isys)
      call mtmplmnoir(rr,x,rx,6,6,1)
      if(isys.le.2) then
         if(ic.eq.1) then
            call vnegater(rx,6)         
         end if
      else
         call vadd(rx,tt,rx,5)
         if(ic.eq.1.or.ic.eq.-1) then
            call vnegater(rx,5)
         end if
         if(ic.eq.-1) then
            rx(6)=-rx(6)
         end if
      end if
      return
      end

      subroutine gethr(h,hr,r,ns,icnt)
      integer h(*),hr(*)
      integer rr
      real tt
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      call mtmplmnoi(h,rr,hr,1,6,6)
      if(icnt.eq.1.or.icnt.eq.-1) then
         call vnegatei(hr,6)
      end if
      return
      end

      integer function rcomp(x,rx)
      real x(*),rx(*)
      common /cskip/ iskip,ltype
      real trc(6,32)
      real xx,eps
      data eps/0.00001/

c     ltype=1,2,3,4,5 mean p,i,f,s,c in icosahedral lattice
      call gettrc(ltype,trc,ntrc)
      call getsys(isys)
      if(isys.le.2) then
         idm=6
      else
         idm=5
      end if
      rcomp=0
      do j=1,ntrc
         do i=1,idm
            xx=abs(x(i)-rx(i)-trc(i,j))+eps/2
            xx=mod(xx,1.)
            if(xx.gt.1.-eps) then
               xx=abs(xx-1.)
            end if
            if(xx.gt.eps) go to 110
         end do
         rcomp=1
         return
 110     continue
      end do
      return
      end

      subroutine gettrc(ltype,trc0,ntrc0)
      real trc0(6,*)
      integer ntrc(5)
      real trc1(6,1),trc2(6,2),trc3(6,32),trc4(6,1),trc5(6,2)
c      data ntrc/1,2,32,1,2/
      data ntrc/1,2,32,32,2/
      data (trc1(i,1),i=1,6) /6*0.0/
      data ((trc2(i,j),i=1,6),j=1,2) /6*0.0,6*0.5/
      data ((trc3(i,j),i=1,6),j=1,32) /
     *   0.0,0.0,0.0,0.0,0.0,0.0,  0.5,0.5,0.0,0.0,0.0,0.0,
     *   0.5,0.0,0.5,0.0,0.0,0.0,  0.5,0.0,0.0,0.5,0.0,0.0,
     *   0.5,0.0,0.0,0.0,0.5,0.0,  0.5,0.0,0.0,0.0,0.0,0.5,
     *   0.0,0.5,0.5,0.0,0.0,0.0,  0.0,0.5,0.0,0.5,0.0,0.0,
     *   0.0,0.5,0.0,0.0,0.5,0.0,  0.0,0.5,0.0,0.0,0.0,0.5,
     *   0.0,0.0,0.5,0.5,0.0,0.0,  0.0,0.0,0.5,0.0,0.5,0.0,
     *   0.0,0.0,0.5,0.0,0.0,0.5,  0.0,0.0,0.0,0.5,0.5,0.0,
     *   0.0,0.0,0.0,0.5,0.0,0.5,  0.0,0.0,0.0,0.0,0.5,0.5,
     *   0.0,0.0,0.5,0.5,0.5,0.5,  0.0,0.5,0.0,0.5,0.5,0.5,
     *   0.0,0.5,0.5,0.0,0.5,0.5,  0.0,0.5,0.5,0.5,0.0,0.5,
     *   0.0,0.5,0.5,0.5,0.5,0.0,  0.5,0.0,0.0,0.5,0.5,0.5,
     *   0.5,0.0,0.5,0.0,0.5,0.5,  0.5,0.0,0.5,0.5,0.0,0.5,
     *   0.5,0.0,0.5,0.5,0.5,0.0,  0.5,0.5,0.0,0.0,0.5,0.5,
     *   0.5,0.5,0.0,0.5,0.0,0.5,  0.5,0.5,0.0,0.5,0.5,0.0,
     *   0.5,0.5,0.5,0.0,0.0,0.5,  0.5,0.5,0.5,0.0,0.5,0.0,
     *   0.5,0.5,0.5,0.5,0.0,0.0,  0.5,0.5,0.5,0.5,0.5,0.5/
      data (trc4(i,1),i=1,6) /6*0.0/
      data ((trc5(i,j),i=1,6),j=1,2) /6*0.0,0.,0.,0.,0.,0.5,0./
      data eps/0.00001/
      call getsys(isys)
c     ltype=1,2,3,4,5 mean p,i,f,s,c in icosahedral lattice
      if(ltype.eq.0.or.ltype.eq.1) then
         ntrc0=1
         ltyped=1
         do j=1,ntrc0
            call vcpyr(trc1(1,j),trc0(1,j),6)
         end do
      else if(ltype.eq.2) then
         ntrc0=ntrc(ltype)
         ltyped=ltype
         do j=1,ntrc0
            call vcpyr(trc2(1,j),trc0(1,j),6)
         end do
      else if(ltype.eq.3) then
         ntrc0=ntrc(ltype)
         ltyped=ltype
         do j=1,ntrc0
            call vcpyr(trc3(1,j),trc0(1,j),6)
         end do
      else if(ltype.eq.4) then
         if(isys.le.2) then
            ntrc0=32
            ltyped=3
            do j=1,ntrc0
               call vcpyr(trc3(1,j),trc0(1,j),6)
            end do
         else if(isys.eq.3) then
            ntrc0=1
            ltyped=1
            do j=1,ntrc0
               call vcpyr(trc1(1,j),trc0(1,j),6)
            end do
         else if(isys.eq.4) then
            ntrc0=1
            ltyped=1
            do j=1,ntrc0
               call vcpyr(trc1(1,j),trc0(1,j),6)
            end do
         else if(isys.eq.5) then
            ntrc0=1
            ltyped=1
            do j=1,ntrc0
               call vcpyr(trc1(1,j),trc0(1,j),6)
            end do
         end if
      else if(ltype.eq.5) then
         ntrc0=2
         ltyped=ltype
         do j=1,ntrc0
            call vcpyr(trc5(1,j),trc0(1,j),6)
         end do
      end if
      return
      end

      subroutine wtsmop(r1,t1,nsymo,d1,d2)
c*******************************************************************
c         representation of symmetry operators in the i.t. format
c*******************************************************************
      implicit integer (a-z)
      integer r1(6,6,*)
      integer r(6,6),lenc(60),ip(16)
      real t1(6,*),t(6),eps,cnt2(27,6),rtr(7)
      character xyz(6)
c        for (d2+d1) dimensional case
      character*31 z1(60),bl
      character*3 ntr(7)

      data xyz/'x','y','z','t','u','v'/
      data ntr/'1/2','1/3','2/3','1/4','3/4','1/6','5/6'/
      data rtr/0.5,0.333333,0.666666,0.25,0.75,0.166666,0.833333/
      data bl/'                            '/

      call getinp(inpu)
      call getout(iout)
      eps=0.00001
      d3=d1+d2
c******** write symmetry operators *******
      do ii=1,nsymo
         cp=1
         do i=1,d3
            t(i)=t1(i,ii)
            do j=1,d3
               r(i,j)=r1(i,j,ii)
            end do
         end do
         do i=1,d3
c     t(i)=mod(t(i),1.)
            t(i)=mod(t(i),1.)
            if(t(i).lt.eps) then
               t(i)=t(i)+1
            else if(t(i).gt.1.0-eps) then
               t(i)=t(i)-1
            end if
         end do
         do i=1,22
            z1(ii)=bl
         end do
         do i=1,d3
            do j=1,7
               if(abs(t(i)-rtr(j)).le.eps) then
                  z1(ii)(cp:cp+2)=ntr(j)
                  cp=cp+3
                  go to 132
               end if
            end do
 132        continue
            do j=1,d3
               if(j.le.d2) then
                  k=j
               else if(j.gt.d2) then
                  k=j+(3-d2)
               end if
               if(r(i,j).eq.1) then
                  if(cp.eq.1) then
                     z1(ii)(cp:cp)=xyz(k)
                     cp=cp+1
                  else if(z1(ii)(cp-1:cp-1).eq.',') then
                     z1(ii)(cp:cp)=xyz(k)
                     cp=cp+1
                  else
                     z1(ii)(cp:cp+1)='+'//xyz(k)
                     cp=cp+2
                  end if
               else if(r(i,j).eq.-1) then
                  z1(ii)(cp:cp+1)='-'//xyz(k)
                  cp=cp+2
               end if
               if(j.eq.d3.and.i.ne.d3) then
                  z1(ii)(cp:cp)=','
                  cp=cp+1
               else if(j.eq.d3.and.i.eq.d3) then
                  z1(ii)(cp:cp)=';'
                  cp=cp+1
               end if
            end do
         end do
         lenc(ii)=istrln(z1(ii))
      end do
      write(iout,'(1h ,6(i3,1x,a,1x))') (ii,z1(ii)(1:lenc(ii)),
     *                                                 ii=1,nsymo)
      return
      end

      subroutine decode(coord,r,t,n)
c     symmetry operation in I.T into matrix representation
      character coord*30
      integer r(6,6,*)
      real t(6,*)
      common /cdim/ idm,nde
      character sym(6)*20,xyz(6)
      data xyz/'x','y','z','t','u','v'/

      call getinp(inpu)
      call getout(iout)
c     position of ',' 
      i=1
      do k=1,idm-1
         m=index(coord(i:30),',')
         if(m.eq.0) call quit(' incorrect symmetry operation')
         sym(k)=coord(i:i+m-2)
         i=i+m
      end do
      sym(idm)=coord(i:30)
c
c     do 30 j=1,idm
      do j=1,6
         t(j,n)=0
c        do k=1,idm
         do k=1,6
            r(j,k,n)=0
         end do
c
c        rotation matrix
         do k=1,idm
            i=index(sym(j),xyz(k))
            if(i.gt.0) then
               if(i.eq.1) then
                  r(j,k,n)=1
               else
                  if(sym(j)(i-1:i-1).eq.'+') then
                     r(j,k,n)=1
                  else
                     r(j,k,n)=-1
                  endif
               endif
            endif
         end do
c
c        translation vector
         i=index(sym(j),'/')
         if(i.gt.0) then
            read(sym(j)(i-1:i-1),'(i1)') n1
            read(sym(j)(i+1:i+1),'(i1)') n2
            t(j,n)=float(n1)/float(n2)
            if(i.ne.2.and.sym(j)(i-2:i-2).eq.'-') t(j,n)=-t(j,n)
         endif
      end do
      end

      subroutine trhtole(yd)   ! coordinates in the minimal dimension
      real yd(*)
      real xd(7)
      integer getisys
      isys=getisys()
      if(isys.le.2) then       ! icosahedral
         return
      else if(isys.eq.3) then  ! decagonal
         call vcpyr(yd,xd,6)
         call tr6to5e(xd,yd)
      else if(isys.eq.4) then  ! octagonal
         return
      else if(isys.eq.5) then  ! dodecagonal
         call vcpyr(yd,xd,7)
         call tr7to5e(xd,yd)   ! 7D coordinates to 5D coordinates
      end if
      return
      end

      subroutine set7to5emtrx()
      integer sd0(7,7),sd1(7,7),sd(7,7)
      common /c7to5e/ sd0,sd1,sd
      data sd0 / 0, 1, 0, 0, 0,-1, 0,
     *          1, 0, 1, 0, 0, 0, 0,
     *          0, 1, 0, 1, 0, 0, 0,
     *          0, 0, 1, 0, 1, 0, 0,
     *          1, 0,-1, 0, 1, 0, 0,
     *          0, 1, 0,-1, 0, 1, 0,
     *          0, 0, 0, 0, 0, 0, 1/
      data sd1 /1, 0, 0, 0,-1, 0, 0,
     *          0, 1, 0, 0, 0, -1, 0,
     *          0,  0, 1, 0, 1,  0, 0,
     *          0,  0, 0, 1, 0, 1,  0,
     *          1, 0,-1, 0, 1, 0, 0,
     *          0, 1, 0,-1, 0, 1, 0,
     *          0, 0, 0, 0, 0, 0, 1/
c      data sd/ 2, 0, 1, 0,-1, 0, 0,
c     *         0, 2, 0, 1, 0,-1, 0,
c     *         1, 0, 2, 0, 1, 0, 0,
c     *         0, 1, 0, 2, 0, 1, 0,
c     *         1, 0,-1, 0, 1, 0, 0,
c     *         0, 1, 0,-1, 0, 1, 0,
c     *         0, 0, 0, 0, 0, 0, 1/
      return
      end

      subroutine tr7to5e(ei,fi) ! 7D to 5D coordinates
c     for dodecagonal      
      real fi(*),ei(*)
      integer sd0(7,7),sd1(7,7),sd(7,7)
      common /c7to5e/ sd0,sd1,sd
c      do j=1,7
c      call mcpyr(sd0,sd,7)
      call mcpyi(sd0,sd,7)
      do j=1,6
         fi(j)=0.
         if(j.le.4) then
            do k=1,6
               fi(j)=fi(j)+sd(k,j)*ei(k)
c     fi(j)=fi(j)+sd(k,j)*ei(k)/3
            end do
         else if (j.eq.5) then
            fi(5)=ei(7)
            fi(6)=0
         end if
      end do
      return
      end


      subroutine tr7to5i(ei,fi)  ! 7D to 5D indices (hkl)
c       for dodecagonal      
      integer fi(*),ei(*)
c      integer sd(7,7)
      integer sd0(7,7),sd1(7,7),sd(7,7)
      common /c7to5e/ sd0,sd1,sd
c      do 12 j=1,7
c      call mcpyr(sd1,sd,7)
      call mcpyi(sd1,sd,7)
      do j=1,6
         fi(j)=0.
         if(j.le.4) then
         do k=1,6
            fi(j)=fi(j)+sd(k,j)*ei(k)
         end do
         else if (j.eq.5) then
             fi(5)=ei(7)
             fi(6)=0
         end if
      end do
      return
      end
 
      subroutine tr6to5e(ei,fi)  ! 6D to 5D coordinates
      real fi(*),ei(*)
      integer sd(6,6)
      data sd/ 4,-1,-1,-1, 0, 0,
     *        -1, 4,-1,-1, 0, 0,
     *        -1,-1, 4,-1, 0, 0,
     *        -1,-1,-1, 4, 0, 0,
     *        -1,-1,-1,-1, 0, 0,
     *         0, 0, 0, 0, 5, 0/
      do j=1,6
         fi(j)=0.
         do k=1,6
            fi(j)=fi(j)+sd(j,k)*ei(k)/5
         end do
      end do
      return
      end

      subroutine tr6to5i(ei,fi) ! 6D to 5D indices (hkl)
      integer fi(*),ei(*)
      integer sd(6,6)
      data sd/ 1, 0, 0, 0, 0, 0,
     *         0, 1, 0, 0, 0, 0,
     *         0, 0, 1, 0, 0, 0,
     *         0, 0, 0, 1, 0, 0,
     *        -1,-1,-1,-1, 0, 0,
     *         0, 0, 0, 0, 1, 0/
      do j=1,6
         fi(j)=0.
         do k=1,6
            fi(j)=fi(j)+sd(j,k)*ei(k)
         end do
      end do
      return
      end

      subroutine invoptbl()  ! inverse operator table
      common /cinvtbl/ invtbl(120)
      integer getinvop
      do i=1,nsymo
         invtbl(i)=getinvop(i)
      end do
      return
      end

      integer function getinvop(i)
      integer r
      real t
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer iord(60),rr(6,6)
      call ordr(r,iord,nsymo,6)
      call rednsic(i,ns,ic)
      do j=1,nsymo
         if(iord(ns).eq.iord(j)) then
            call mtmpli(r(1,1,i),r(1,1,j),rr,6)
            if(identm(rr).eq.1) then
               if(ic.eq.0) then
                  getinvop=j
               else
                  getinvop=j+nsymo
               end if
               return
            end if
         end if
      end do
      call quit('no inverse op. found')
      return
      end

      subroutine invisk(na,isk,iski)
      integer isk(0:120,*),iski(0:120,*)
c      integer r
c      real t
c      common /sym/ r(6,6,60),t(6,60),nsymo,icent
c      integer iord(60),rr(6,6)
      integer getinvop
      write(6,*) 'inverse operator for each atom'
c     call ordr(r,iord,nsymo,6)
      do n=1,na
         iski(0,n)=isk(0,n)
         do i=1,isk(0,n)
            nsy=isk(i,n)
            iski(i,n)=getinvop(nsy)
 200        continue
         end do
         write(6,*) 'atom',n,'  ',(iski(j,n),j=1,isk(0,n))
      end do
      return
      end

      integer function mpltblv(i,j) ! get multiplied symm. op. no.
      common /cmpltbl/ mpltbl(120,120)
      integer rr
      real tt
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      call rednsic(i,nsi,ici)
      call rednsic(j,nsj,icj)
c     write(6,*) 'i,j,nsi,ici,nsj,icj=',i,j,nsi,ici,nsj,icj
      mpltblv=mpltbl(nsi,nsj)
      if(ici.eq.0.and.icj.eq.0) then
         return
      else if(ici.eq.1.and.icj.eq.1) then
         return
      else if(ici.eq.1.and.icj.eq.0) then
         mpltblv=nsymo+mpltblv
      else if(ici.eq.0.and.icj.eq.1) then
         mpltblv=nsymo+mpltblv
      end if
      return
      end

      subroutine setmpltbl()    ! set multiplication table for symm. op.
      common /cmpltbl/ mpltbl(120,120)
      integer rd(6,6)
      integer rr
      real tt
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      do i=1,nsymo
         do j=1,nsymo
            call mtmpli(rr(1,1,i),rr(1,1,j),rd,6)
            mpltbl(i,j)=identm1(rd)
         end do
      end do
      if(icent.eq.1) then
         do i=1,nsymo
            do j=1,nsymo
               mpltbl(i,j+nsymo)=mpltbl(i,j)+nsymo
               mpltbl(i+nsymo,j)=mpltbl(i,j)+nsymo
               mpltbl(i+nsymo,j+nsymo)=mpltbl(i,j)
            end do
         end do
      end if
      write(6,*) 'multiplication table of symmetry operators'
      do i=1,nsymo
         write(6,'(60i3)')
     *        (mpltbl(i,j),j=1,nsymo)
      end do
      return
      end

      function identm1(rr)
      integer rr(6,6)
      integer r
      real t
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
c     if rr is identity matrix identm=1 else 0
      identm1=0
      do ns=1,nsymo
         do i=1,6
            do j=1,6
               if(rr(i,j).ne.r(i,j,ns)) goto 10
            end do
         end do
         identm1=ns
         return
 10      continue
      end do

      do ns=1,nsymo
         do i=1,6
            do j=1,6
               if(-rr(i,j).ne.r(i,j,ns)) goto 20
            end do
         end do
         identm1=ns+nsymo
         return
 20      continue
      end do
      return
      end

      subroutine rednsic(nsd,ns,ic)
      integer getnsym
      nsymo=getnsym()
      if(nsd.gt.nsymo) then
         ns=nsd-nsymo
         ic=1
      else
         ns=nsd
         ic=0
      end if
      return
      end

      integer function expnsic(ns,ic)
      integer getnsym
      nsymo=getnsym()
      if(ic.eq.0) then
         expnsic=ns
      else
         expnsic=ns+nsymo
      end if
      return
      end

      integer function getnsym()
      integer rr
      real tt
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      getnsym=nsymo
      return
      end

      integer function geticnt()
      integer rr
      real tt
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      geticnt=icent
      return
      end

