c
c                  only for decagonal phase
c      coordinate transformation from the normal phase to the superstructure
c                             x to xs
c          operate given symmetry operations generated by generators
c          write xs and xis in the superstructure cell if xs agrees with
c                    specified vector in (4)
c     **** in  x: 6D rep. xi 6D rep  out x: 5D rep. xi: 6D rep ***
c     (1) nsymo,icent,brv
c          nsymo: number of generators in symmetry operations
c          icent: give 1 for centrosymmetric
c                 otherwise give 0
c          brv  : 'p','i','f' 's' 'c' bravais lattice
c                  s in icosahedral  ==> face-centered superlattice
c                  s in decagonal    ==> Edagawa type superlattice
c                  s translates x,ej,xi in the normal lattice into those
c                                   in superlattice
c                  in decagonal case, s also translates sym. op in normal
c                     lattice into those in superlattice
c                  c P_2c for color symmetry
c     (2) 'symmetry operator'        header  and
c     (3)  symmetry operator in the I.T. format: x,y,z,t,u,v etc.
c     (4)  xs0 (*)  : coordinate in superstructure
c     (5)  x  (*)
c     (6)  xi (*)
c         ******* repeat (4)-(6) necessary times *******
      integer r(6,6)
      real t(6)
      real x(6),xi(6),xd(6),yd(6),xs0(6)
      integer rcomp
      character brv

      call setinp(5)
      call setout(6)
      call setsys(3) ! decagonal
      call setskp(0)
      call setiwflg(1)
      call rdsymo(1,brv)
      call getnsym(nsymo)
      call geticnt(icent)
      write(6,*) 'nsymo=',nsymo,' icent=',icent
 100  continue
      read(5,*) xs0
      read(5,*,end=200) x
      read(5,*) xi
      write(6,'(a,6f10.5)') 'xs0=',xs0
      do n=1,nsymo
         call getsymo(r,t,n)
         do icnt=0,icent
            call tr6to5e(x,yd)
            call getrx(yd,xd,r,t,1,icnt)
            call celltr(xd,1)
            if(rcomp(xs0,xd).eq.1) then
               write(6,'(a,6f10.5)') 'x  =',xd
               call tr6to5e(xi,yd)
               call getrx(yd,xd,r,t,1,icnt)
               call celltr(xd,1)
               call tr5to6e(xd,yd)
               write(6,'(a,6f10.5)') 'xi =',yd
            end if
         end do
      end do
      go to 100
 200  continue
      stop
      end

      subroutine celltr(x,mode)
      real x(*)
      real xd(6),trm1(6,6),trm2(6,6)
      save trm1,trm2
      data trm1 /2, 2,-3, 2,0,0,
     *          -1, 4,-1,-1,0,0,
     *           1, 1, 1, 1,0,0,
     *          -2, 3,-2, 3,0,0,
     *           0, 0, 0, 0,5,0,
     *           0, 0, 0, 0,0,5/
      data trm2 /1, 0, 1,-1,0,0,
     *           0, 1, 1, 0,0,0,
     *          -1, 0, 2, 0,0,0,
     *           0,-1, 1, 1,0,0,
     *           0, 0, 0, 0,1,0,
     *           0, 0, 0, 0,0,1/
      if(mode.eq.1) then
         do i=1,6
            xd(i)=0
            do j=1,6
               xd(i)=xd(i)+trm1(i,j)*x(j)/5.
            end do
         end do
         do i=1,6
            x(i)=xd(i)
         end do
      else if(mode.eq.-1) then
         do i=1,6
            xd(i)=0
            do j=1,6
               xd(i)=xd(i)+trm2(i,j)*x(j)
            end do
         end do
         do i=1,6
            x(i)=xd(i)
         end do
      else
         call quit('invalid mode in celltr')
      end if
      return
      end

      subroutine quit(str)
      character*(*) str
      write(6,*) str
      call exit()
      end

      subroutine tr5to6e(ei,fi)
      real fi(*),ei(*)
      integer sd(6,6)
      data sd/ 1,0,0,0,-1,0,
     *         0,1,0,0,-1,0,
     *         0,0,1,0,-1,0,
     *         0,0,0,1,-1,0,
     *         0,0,0,0, 0,1,
     *         0,0,0,0, 0,0/
      do 12 j=1,6
         fi(j)=0.
         do 13 k=1,5
             fi(j)=fi(j)+sd(j,k)*ei(k)
 13      continue
 12   continue
      return
      end

      subroutine tr6to5e(ei,fi)
      real fi(*),ei(*)
      integer sd(6,6)
      data sd/ 4,-1,-1,-1, 1, 0,
     *        -1, 4,-1,-1, 1, 0,
     *        -1,-1, 4,-1, 1, 0,
     *        -1,-1,-1, 4, 1, 0,
     *        -1,-1,-1,-1, 1, 0,
     *         0, 0, 0, 0, 0, 1/
      do 12 j=1,6
         fi(j)=0.
         if(j.le.4) then
             do 13 k=1,5
             fi(j)=fi(j)+sd(j,k)*ei(k)/5
 13          continue
         else if (j.eq.5) then
             fi(5)=ei(6)
             fi(6)=0
         end if
 12   continue
      return
      end

      subroutine reduc(ry)
      real ry(*)
      do 100 i=1,6
          ry(i)=mod(ry(i),1.)
          rd=ry(i)
          if(rd.lt.-0.499) then
               ry(i)=ry(i)+1
          else if(rd.gt.0.501) then
               ry(i)=ry(i)-1
          end if
 100  continue
      return
      end

      subroutine setinp(inpu)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      cinpu=inpu
      return
      end

      subroutine setout(iout)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      coutu=iout
      return
      end

      subroutine getinp(inpu)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      inpu=cinpu
      return
      end

      subroutine getout(iout)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      iout=coutu
      return
      end

      subroutine getsys(isysd)
c      common /cgethk/ d0(6,6),d1(6,6),d2(6,6),d3(6,6),d4(6,6),isys
      common /cisys/ isys
      isysd=isys
      return
      end            

      subroutine setsys(isysd)
c      common /cgethk/ d0(6,6),d1(6,6),d2(6,6),d3(6,6),d4(6,6),isys
      common /cisys/ isys
      isys=isysd
      return
      end            

      subroutine setskp(iskp)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      cskip=iskp
      return
      end

      subroutine getskp(iskp)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      iskp=cskip
      return
      end
