c***********************************************************01.03.84***c
c             program for drawing crystal and twin figures             c
c                   (hamburg 1971 / tsukuba 1982)                      c
c                   crfg mv31 06.07.83  k.kato                         c
c                                                                      c
c            file   5    normal input device                           c
c            file   6    normal output device                          c
c            file   7    output file for k- and f-lists                c
c            file   9    stack for memory (dynamic)                    c
c            file  16    xy-plotter                                    c
c                                                                      c
c     abnormal stops :                                                 c
c                                                                      c
c     stop 001   illegal crystal class symbol input       (hptprg)     c
c          011   memory overflow                          (ffrei )     c
c          021   illegal try to separate head element     (lsche )     c
c          022   list empty                               (lsche )     c
c          023   element does not belong to the list      (lsche )     c
c          031   list of edges empty                      (neupkt)     c
c          032   point cannot be paired                   (neupkt)     c
c          033   crazy combination of points              (neupkt)     c
c          041   list of edges empty                      (kpunkt)     c
c                                                                      c
c       graphic and plotter subroutine library:  plot-10, calcomp      c
c                                                                      c
c*  please note:                                                      *c
c*                                                                    *c
c*  this source program can be obtained only directly from the author *c
c*    of the program.                                                 *c
c*  those who obtained the source program must not give it or its     *c
c*    copy to a third person without permission of the author.        *c
c*  any change of the source program is not permitted except for      *c
c*    those necessary for the program to run unter the given          *c
c*    operating system.                                               *c
c*                                                                    *c
c   reference: k.kato and k-h.klaska, n.jb.miner.mh. jg.1979 489-494   c
c**********************************************************************c
      common /euler/ prj(3,3)
      parameter (nmem=20000)
c     common /frei/ ifrei,r(10,1000)
      common /frei/ ifrei,r(10,nmem)
      common /sym/ isym,jsym(3,42),infsym(2,3,236)
      common /kdt/ a,b,c,al,be,ga,tr(3,3),aa(3,3)
      common /kkl/ klasse,kkls
      common /psp/ erstpl
      common /twin/ lzk,lzf,lgl,izk,izf
      common /epslon/ eps1,eps2,vs
      character klasse*5,kkls(42)*5
      character titel*72,modus*9
      character asgb*4,isent*1
      logical erstpl
      real   h(3),d
      data modus/'tss      '/
      data asgb/'    '/,isent/' '/
      write(6,'(''1crfg mv31 06.07.83'')')
      call vfrei(23)
      read(5,'(a9)') modus
      if(modus(1:3).eq.'tss') then
      call tss
      go to 100
      end if
c     view distance
      read(modus(4:9),'(f6.0)') vv
      write(6,'(1h+,t22,''(view distance '',g11.3,'')'')') vv
      if(vv.ne.0.0) vs=1.0/vv
      read(5,'(a)') titel
      write(6,'(1h0,a)') titel
c     crystal class as well as axial ratio and angles
      read(5,'(a5)') klasse
      do 20 isym=1,42
      if(kkls(isym).eq.klasse) go to 30
   20 continue
      stop 001
   30 write(6,'(''0crystal class: '',a5)') kkls(isym)
      read(5,'(6f9.6)') a,b,c,al,be,ga
      write(6,'(''0axial ratio and angles'', 3f9.4,3f9.2)')
     *  a,b,c,al,be,ga
      call geomet
c     hkl and d
      write(6,20050)
20050 format('0input faces/forms'/'0',5x,'f   h   k   l',12x,'d'/' ')
   40 read(5,'(a1,f8.0,3f9.0)') isent,h,d
      if(isent.eq.'e') go to 50
      write(6,'(1h ,5x,a1,1x,3i4,6x,g10.3)') isent,(int(h(i)),i=1,3),d
c     generate equivalent faces
      if(isent.eq.'n') then
      call nff(1,h,d)
      else
      call nff(isym,h,d)
      endif
c     add new faces
      call neupkt
      go to 40
c     rotate crystal to set view direction
   50 write(6,'(''0rotation of crystal''/1h )')
   52 read(5,'(i3,f9.2)') ix,ph
      if(ix.eq.0) go to 60
      call prmtrx(ix,ph)
      go to 52
c     output
   60 read(5,'(a4,5x,i1,3f10.3)',end=90) asgb,iz,vergrf,delta,deltx
      if(asgb.eq.'prnt') then
        call ausg(2,1,6)
        go to 60
      else if(asgb.eq.'plot') then
        if(erstpl) then
        erstpl=.false.
cp
        call plots(0.0,0.0,4)
        end if
        if(iz.eq.0) then
          call zeichn(1,.false.,vergrf,delta,deltx)
        else
          call zeichn(1,.true.,vergrf,delta,deltx)
        end if
        write(6,'(''0plotter output'',i5,3g11.3)')
     *                          iz,vergrf,delta,deltx
        go to 60
      end if
cp
c  90 if(.not.erstpl) call plot(0.0,0.0,999)
 90   call plote(' ')
      write(6,'(''0end'')')
  100 stop
      end
c**********************************************************************c
      block data
      parameter (nmem=20000)
c     common /frei/ ifr,i(10,1000)
      common /frei/ ifr,i(10,nmem)
      common /euler/ prj(3,3)
      common /sym/ isym,jsym(3,42),infsym(2,3,236)
      common /kkl/ klasse,kkls
      common /psp/ erstpl
      common /twin/ lzk,lzf,lgl,izk,izf
      common /epslon/ eps1,eps2,vs
      common /format/ c001,c002,c003,c004,c005,c006,c007,c008,c009,
     *                c010,c011,c012,c013
      character*53 c001,c002,c003,c004,c005,c006,c007,c008,c009,c010
      character*53 c011,c012,c013*1
      character klasse*5,kkls(42)*5
      integer ism(1416)
      logical erstpl
c     real r(10,1000)
      real r(10,nmem)
      equivalence (infsym(1,1,1),ism(1))
      equivalence (i(1,1),r(1,1))
      data prj/1.0,3*0.0,1.0,3*0.0,1.0/
      data i(1,1),r(2,1),i(8,1),i(9,1),i(10,1)/16,9e70,1,5,5/
      data i(1,5),r(2,5),r(3,5),r(4,5),r(5,5),r(6,5),r(7,5),i(8,5),
     1  i(9,5),i(10,5)/1,100.0,-100.0,100.0,100.0,-100.0,-100.0,
     2  17,20,6/
      data i(1,6),r(2,6),r(3,6),r(4,6),r(5,6),r(6,6),r(7,6),i(8,6),
     1  i(9,6),i(10,6)/5,100.0,-100.0,100.0,100.0,100.0,100.0,21,17,7/
      data i(1,7),r(2,7),r(3,7),r(4,7),r(5,7),r(6,7),r(7,7),i(8,7),
     1  i(9,7),i(10,7)/6,100.0,100.0,100.0,100.0,100.0,-100.0,19,17,8/
      data i(1,8),r(2,8),r(3,8),r(4,8),r(5,8),r(6,8),r(7,8),i(8,8),
     1  i(9,8),i(10,8)/7,100.0,100.0,-100.0,100.0,-100.0,-100.0,22,17,9/
      data i(1,9),r(2,9),r(3,9),r(4,9),r(5,9),r(6,9),r(7,9),i(8,9),
     1 i(9,9),i(10,9)/8,-100.0,-100.0,100.0,-100.0,100.0,100.0,18,21,10/
      data i(1,10),r(2,10),r(3,10),r(4,10),r(5,10),r(6,10),r(7,10),
     1  i(8,10),i(9,10),i(10,10)/9,-100.0,100.0,100.0,-100.0,100.0,
     2  -100.0,18,19,11/
      data i(1,11),r(2,11),r(3,11),r(4,11),r(5,11),r(6,11),r(7,11),
     1  i(8,11),i(9,11),i(10,11)/10,-100.0,100.0,-100.0,-100.0,-100.0,
     2  -100.0,18,22,12/
      data i(1,12),r(2,12),r(3,12),r(4,12),r(5,12),r(6,12),r(7,12),
     1  i(8,12),i(9,12),i(10,12)/11,-100.0,-100.0,-100.0,-100.0,-100.0,
     2  100.0,18,20,13/
      data i(1,13),r(2,13),r(3,13),r(4,13),r(5,13),r(6,13),r(7,13),
     1  i(8,13),i(9,13),i(10,13)/12,100.0,100.0,100.0,-100.0,100.0,
     2  100.0,21,19,14/
      data i(1,14),r(2,14),r(3,14),r(4,14),r(5,14),r(6,14),r(7,14),
     1  i(8,14),i(9,14),i(10,14)/13,100.0,-100.0,100.0,-100.0,-100.0,
     2  100.0,20,21,15/
      data i(1,15),r(2,15),r(3,15),r(4,15),r(5,15),r(6,15),r(7,15),
     1  i(8,15),i(9,15),i(10,15)/14,100.0,-100.0,-100.0,-100.0,-100.0,
     2  -100.0,22,20,16/
      data i(1,16),r(2,16),r(3,16),r(4,16),r(5,16),r(6,16),r(7,16),
     1  i(8,16),i(9,16),i(10,16)/15,100.0,100.0,-100.0,-100.0,100.0,
     2  -100.0,19,22,1/
      data i(1,2),r(2,2),i(8,2),i(9,2),i(10,2)/22,9e70,2,17,17/
      data i(1,17),r(2,17),r(3,17),r(4,17),r(5,17),r(6,17),r(7,17),
     1  r(8,17),i(9,17),i(10,17)/2,2*99.0,1.0,1.0,0.0,0.0,100.0,4,18/
      data i(1,18),r(2,18),r(3,18),r(4,18),r(5,18),r(6,18),r(7,18),
     1  r(8,18),i(9,18),i(10,18)/17,2*99.0,2.0,-1.0,0.0,0.0,100.0,4,19/
      data i(1,19),r(2,19),r(3,19),r(4,19),r(5,19),r(6,19),r(7,19),
     1  r(8,19),i(9,19),i(10,19)/18,2*99.0,3.0,0.0,1.0,0.0,100.0,4,20/
      data i(1,20),r(2,20),r(3,20),r(4,20),r(5,20),r(6,20),r(7,20),
     1  r(8,20),i(9,20),i(10,20)/19,2*99.0,4.0,0.0,-1.0,0.0,100.0,4,21/
      data i(1,21),r(2,21),r(3,21),r(4,21),r(5,21),r(6,21),r(7,21),
     1  r(8,21),i(9,21),i(10,21)/20,2*99.0,5.0,0.0,0.0,1.0,100.0,4,22/
      data i(1,22),r(2,22),r(3,22),r(4,22),r(5,22),r(6,22),r(7,22),
     1  r(8,22),i(9,22),i(10,22)/21,2*99.0,6.0,0.0,0.0,-1.0,100.0,4,2/
      data i(1,3),r(2,3),i(8,3),i(9,3),i(10,3)/3,9e70,3*3/
      data i(1,4),r(2,4),i(8,4),i(9,4),i(10,4)/4,9e70,3*4/
      data kkls
     1/'1    ','-1   ','2    ','m    ','2/m  ','222  ','mm2  ','mmm  ',
     2 '4    ','-4   ','4/m  ','422  ','4mm  ','-42m ','-4m2 ','4/mmm',
     3 '3    ','r3   ','-3   ','r-3  ','312  ','321  ','r32  ','3m1  ',
     4 '31m  ','r3m  ','-31m ','-3m1 ','r-3m ','6    ','-6   ','6/m  ',
     5 '622  ','6mm  ','-6m2 ','-62m ','6/mmm','23   ','m3   ','432  ',
     6 '-43m ','m3m  '/
      data jsym
     1/  1,  1,  1,  1,  5,  4,  1,  3,  2,  1,  7,  6,  1,  7,  2,
     2   1,  4,  1,137,140,  1,  1,  8,  1,113,116,  1,129,132,  1,
     3 129,136,  1,121,128,  1,113,120,  1, 97,104,  1, 97,111,  2,
     4  97,112,  1,141,143,  1,  1, 17,  8,213,218,  1,  1, 21,  4,
     5 189,194,  1,177,182,  1, 73, 93,  4,141,146,  1,225,230,  1,
     6   1, 41,  8,225,236,  1,213,224,  1,  1, 45,  4,201,206,  1,
     7 165,170,  1,201,212,  1,189,200,  1,141,152,  1,165,176,  1,
     8 177,188,  1,141,164,  1, 49, 60,  1,  1, 24,  1, 73, 96,  1,
     9  49, 72,  1,  1, 48,  1/
      data (ism(j),j=1,180)
     1  / 1, 0, 2, 0, 3, 0, 1, 0,-2, 0,-3, 0,-1, 0, 2, 0,-3, 0,-1, 0,
     2   -2, 0, 3, 0,-1, 0,-2, 0,-3, 0,-1, 0, 2, 0, 3, 0, 1, 0,-2, 0,
     3    3, 0, 1, 0, 2, 0,-3, 0, 3, 0, 1, 0, 2, 0, 3, 0,-1, 0,-2, 0,
     4   -3, 0, 1, 0,-2, 0,-3, 0,-1, 0, 2, 0,-3, 0,-1, 0,-2, 0,-3, 0,
     5    1, 0, 2, 0, 3, 0,-1, 0, 2, 0, 3, 0, 1, 0,-2, 0, 2, 0, 3, 0,
     6    1, 0, 2, 0,-3, 0,-1, 0,-2, 0, 3, 0,-1, 0,-2, 0,-3, 0, 1, 0,
     7   -2, 0,-3, 0,-1, 0,-2, 0, 3, 0, 1, 0, 2, 0,-3, 0, 1, 0, 2, 0,
     8    3, 0,-1, 0, 1, 0, 3, 0, 2, 0, 1, 0,-3, 0,-2, 0,-1, 0, 3, 0,
     9   -2, 0,-1, 0,-3, 0, 2, 0,-1, 0,-3, 0,-2, 0,-1, 0, 3, 0, 2, 0/
      data (ism(j),j=181,360)
     1  / 1, 0,-3, 0, 2, 0, 1, 0, 3, 0,-2, 0, 2, 0, 1, 0, 3, 0, 2, 0,
     2   -1, 0,-3, 0,-2, 0, 1, 0,-3, 0,-2, 0,-1, 0, 3, 0,-2, 0,-1, 0,
     3   -3, 0,-2, 0, 1, 0, 3, 0, 2, 0,-1, 0, 3, 0, 2, 0, 1, 0,-3, 0,
     4    3, 0, 2, 0, 1, 0, 3, 0,-2, 0,-1, 0,-3, 0, 2, 0,-1, 0,-3, 0,
     5   -2, 0, 1, 0,-3, 0,-2, 0,-1, 0,-3, 0, 2, 0, 1, 0, 3, 0,-2, 0,
     6    1, 0, 3, 0, 2, 0,-1, 0, 1, 0, 2, 0, 3, 0, 1, 0,-2, 0,-3, 0,
     7   -1, 0, 2, 0,-3, 0,-1, 0,-2, 0, 3, 0, 3, 0, 1, 0, 2, 0, 3, 0,
     8   -1, 0,-2, 0,-3, 0, 1, 0,-2, 0,-3, 0,-1, 0, 2, 0, 2, 0, 3, 0,
     9    1, 0, 2, 0,-3, 0,-1, 0,-2, 0, 3, 0,-1, 0,-2, 0,-3, 0, 1, 0/
      data (ism(j),j=361,540)
     1  / 1, 0, 3, 0, 2, 0, 1, 0,-3, 0,-2, 0,-1, 0, 3, 0,-2, 0,-1, 0,
     2   -3, 0, 2, 0, 2, 0, 1, 0, 3, 0, 2, 0,-1, 0,-3, 0,-2, 0, 1, 0,
     3   -3, 0,-2, 0,-1, 0, 3, 0, 3, 0, 2, 0, 1, 0, 3, 0,-2, 0,-1, 0,
     4   -3, 0, 2, 0,-1, 0,-3, 0,-2, 0, 1, 0, 1, 0, 2, 0, 3, 0, 1, 0,
     5   -2, 0,-3, 0,-1, 0, 2, 0,-3, 0,-1, 0,-2, 0, 3, 0, 3, 0, 1, 0,
     6    2, 0, 3, 0,-1, 0,-2, 0,-3, 0, 1, 0,-2, 0,-3, 0,-1, 0, 2, 0,
     7    2, 0, 3, 0, 1, 0, 2, 0,-3, 0,-1, 0,-2, 0, 3, 0,-1, 0,-2, 0,
     8   -3, 0, 1, 0,-1, 0,-3, 0,-2, 0,-1, 0, 3, 0, 2, 0, 1, 0,-3, 0,
     9    2, 0, 1, 0, 3, 0,-2, 0,-2, 0,-1, 0,-3, 0,-2, 0, 1, 0, 3, 0/
      data (ism(j),j=541,720)
     1  / 2, 0,-1, 0, 3, 0, 2, 0, 1, 0,-3, 0,-3, 0,-2, 0,-1, 0,-3, 0,
     2    2, 0, 1, 0, 3, 0,-2, 0, 1, 0, 3, 0, 2, 0,-1, 0, 1, 0, 2, 0,
     3    3, 0, 1, 0,-2, 0,-3, 0,-1, 0,-2, 0, 3, 0,-1, 0, 2, 0,-3, 0,
     4    2, 0,-1, 0,-3, 0, 2, 0, 1, 0, 3, 0,-2, 0, 1, 0,-3, 0,-2, 0,
     5   -1, 0, 3, 0,-1, 0, 2, 0, 3, 0,-1, 0,-2, 0,-3, 0, 1, 0,-2, 0,
     6    3, 0, 1, 0, 2, 0,-3, 0,-2, 0,-1, 0,-3, 0,-2, 0, 1, 0, 3, 0,
     7    2, 0, 1, 0,-3, 0, 2, 0,-1, 0, 3, 0, 1, 0, 2, 0, 3, 0,-1, 0,
     8   -2, 0, 3, 0,-2, 0, 1, 0, 3, 0, 2, 0,-1, 0, 3, 0, 2, 0, 1, 0,
     9    3, 0,-2, 0,-1, 0, 3, 0,-1, 0, 2, 0, 3, 0, 1, 0,-2, 0, 3, 0/
      data (ism(j),j=721,900)
     1  / 1, 0, 2, 0, 3, 0, 1, 0,-2, 0,-3, 0,-1, 0,-2, 0, 3, 0,-1, 0,
     2    2, 0,-3, 0,-2, 0, 1, 0, 3, 0,-2, 0,-1, 0,-3, 0, 2, 0,-1, 0,
     3    3, 0, 2, 0, 1, 0,-3, 0, 1, 0, 2, 0, 3, 0,-1, 0,-2, 0, 3, 0,
     4    2, 0,-1, 0,-3, 0,-2, 0, 1, 0,-3, 0,-2, 0, 1, 0, 3, 0, 2, 0,
     5   -1, 0, 3, 0,-1, 0,-2, 0,-3, 0, 1, 0, 2, 0,-3, 0, 1, 0, 2, 0,
     6    3, 0,-1, 0,-2, 0, 3, 0,-1, 0, 2, 0, 3, 0, 1, 0,-2, 0, 3, 0,
     7    1, 0, 2, 0, 3, 0,-2, 0, 1,-2, 3, 0, 2,-1,-1, 0, 3, 0,-2, 0,
     8   -1, 0, 3, 0, 1, 0, 1,-2, 3, 0, 2,-1, 2, 0, 3, 0, 2, 0, 1, 0,
     9    3, 0,-1, 0, 2,-1, 3, 0, 1,-2,-2, 0, 3, 0,-1, 0,-2, 0, 3, 0/
      data (ism(j),j=901,1080)
     1  / 2, 0, 2,-1, 3, 0, 1,-2, 1, 0, 3, 0, 1, 0, 2, 0,-3, 0,-2, 0,
     2    1,-2,-3, 0, 2,-1,-1, 0,-3, 0, 2, 0, 1, 0,-3, 0,-1, 0, 2,-1,
     3   -3, 0, 1,-2,-2, 0,-3, 0,-1, 0,-2, 0,-3, 0, 2, 0, 2,-1,-3, 0,
     4    1,-2, 1, 0,-3, 0,-2, 0,-1, 0,-3, 0, 1, 0, 1,-2,-3, 0, 2,-1,
     5    2, 0,-3, 0, 1, 0, 2, 0, 3, 0,-2, 0, 1,-2, 3, 0, 2,-1,-1, 0,
     6    3, 0, 1, 0, 2, 0,-3, 0,-2, 0, 1,-2,-3, 0, 2,-1,-1, 0,-3, 0,
     7   -2, 0,-1, 0, 3, 0, 1, 0, 1,-2, 3, 0, 2,-1, 2, 0, 3, 0,-2, 0,
     8   -1, 0,-3, 0, 1, 0, 1,-2,-3, 0, 2,-1, 2, 0,-3, 0, 1, 0, 2, 0,
     9    3, 0,-2, 0, 1,-2, 3, 0, 2,-1,-1, 0, 3, 0, 2, 0, 1, 0,-3, 0/
      data (ism(j),j=1081,1260)
     1  /-1, 0, 2,-1,-3, 0, 1,-2,-2, 0,-3, 0, 2, 0, 1, 0, 3, 0,-1, 0,
     2    2,-1, 3, 0, 1,-2,-2, 0, 3, 0, 1, 0, 2, 0,-3, 0,-2, 0, 1,-2,
     3   -3, 0, 2,-1,-1, 0,-3, 0, 1, 0, 2, 0, 3, 0,-2, 0, 1,-2, 3, 0,
     4    2,-1,-1, 0, 3, 0,-2, 0,-1, 0,-3, 0, 1, 0, 1,-2,-3, 0, 2,-1,
     5    2, 0,-3, 0,-1, 0,-2, 0, 3, 0, 2, 0, 2,-1, 3, 0, 1,-2, 1, 0,
     6    3, 0, 2, 0, 1, 0,-3, 0,-1, 0, 2,-1,-3, 0, 1,-2,-2, 0,-3, 0,
     7    1, 0, 2, 0, 3, 0,-2, 0, 1,-2, 3, 0, 2,-1,-1, 0, 3, 0,-1, 0,
     8   -2, 0, 3, 0, 2, 0, 2,-1, 3, 0, 1,-2, 1, 0, 3, 0, 1, 0, 2, 0,
     9   -3, 0,-2, 0, 1,-2,-3, 0, 2,-1,-1, 0,-3, 0,-1, 0,-2, 0,-3, 0/
      data (ism(j),j=1261,1416)
     1  / 2, 0, 2,-1,-3, 0, 1,-2, 1, 0,-3, 0, 1, 0, 2, 0, 3, 0,-2, 0,
     2    1,-2, 3, 0, 2,-1,-1, 0, 3, 0,-1, 0,-2, 0,-3, 0, 2, 0, 2,-1,
     3   -3, 0, 1,-2, 1, 0,-3, 0,-2, 0,-1, 0, 3, 0, 1, 0, 1,-2, 3, 0,
     4    2,-1, 2, 0, 3, 0, 2, 0, 1, 0,-3, 0,-1, 0, 2,-1,-3, 0, 1,-2,
     5   -2, 0,-3, 0, 1, 0, 2, 0, 3, 0,-2, 0, 1,-2, 3, 0, 2,-1,-1, 0,
     6    3, 0, 2, 0, 1, 0, 3, 0,-1, 0, 2,-1, 3, 0, 1,-2,-2, 0, 3, 0,
     7   -1, 0,-2, 0,-3, 0, 2, 0, 2,-1,-3, 0, 1,-2, 1, 0,-3, 0,-2, 0,
     8   -1, 0,-3, 0, 1, 0, 1,-2,-3, 0, 2,-1, 2, 0,-3, 0/
      data erstpl/.true./
      data lzk/0/,lzf/0/,lgl/0/,izk/0/,izf/0/
c     data eps1/1e-4/,eps2/1e-2/,vs/0.0/
      data eps1/1e-3/,eps2/1e-3/,vs/0.0/
      data c001/'('' crystal in initial orientation'')'/
      data c002/'('' rotated about '',a1,''-axis '',f7.2,'' degree'')'/
      data c003/'('' crazy requirement'')'/
      data c004/'(1h ,7x,3i4,17x,''does not cut the crystal'')'/
      data c005/'(14h0list of faces/1h0,5x,9hh   k   l,9x,1hd/1h )'/
      data c006/'(14h0list of edges/1h0,13x,6hbgnpnt,16x,6hendpnt,'/
      data c007/'14x,6hvb,nvb/1h ,12x,1hx,7x,1hy,13x,1hx,7x,1hy/1h )'/
      data c008/'('' * back side (y,n)? *'')'/
      data c009/'('' * scale factor? *'')'/
      data c010/'('' * output into graphic data file (y,n)? *'')'/
      data c011/'('' * member name? *'')'/
      data c012/'('' * output on plotter (y,n)? *'')'/
      data c013/'y'/
      end
c**********************************************************************c
      subroutine tss
      common /sym/ isym,jsym(3,42),infsym(2,3,236)
      common /kdt/ a,b,c,al,be,ga,tr(3,3),aa(3,3)
      common /kkl/ klasse,kkls
      common /psp/ erstpl
      parameter (nmem=20000)
c     common /frei/ ifrei,rsp(10,1000)
      common /frei/ ifrei,rsp(10,nmem)
      common /twin/ lzk,lzf,lgl,izk,izf
      common /epslon/ eps1,eps2,vs
      character klasse*5,kkls(42)*5
      character zzff(0:1)*3
      character jn*1,symop(2,3)*2,vertlr*4,zof*1
      character cxyz(-3:3,1:2)*2
      integer istack
      logical erstpl,spgl
      logical lgen
      real   h(3),u(3),v(3),delta,deltx,vv
      data delta/0.0/,deltx/20.0/,vv/0.0/
      data istack/0/
      data cxyz/'-z','-y','-x','  ',' x',' y',' z',
     *     '-z','-y','-x','  ','+x','+y','+z'/
      data jn/'n'/
      data zzff/'zon','pln'/
      data lgen/.true./
c      open (9,status='scratch',form='unformatted')
      call lkreii(lzk)
      call lkreii(lzf)
      call lkreii(lgl)
      call lkreii(izk)
      call lkreii(izf)
   10 write(6,'('' * instruction? *'')')
   11 read(5,'(a4)') vertlr
      if(vertlr.eq.'help') then
      write(6,'('' * instructions: *'')')
      write(6,'(''    axis: input axial ratio and angles'')')
      write(6,'(''    back: one step backward'')')
      write(6,'(''    ccls: input crystal class'')')
      write(6,'(''    ceps: change epsilon and view distance'')')
      write(6,'(''    disp: display on graphic device'')')
      write(6,'(''    dmax: maximum distance to plane'')')
      write(6,'(''    end : end of the program run'')')
      write(6,'(''    face: addition of a face to the crystal'')')
      write(6,'(''    form: addition of a form to the crystal'')')
      write(6,'(''    flst: display list of faces existing'')')
      write(6,'(''    iadd: addition of the individual to the twin'')')
      write(6,'(''    igen: generation of an individual'')')
      write(6,'(''    iinv: inversion of the individual'')')
      write(6,'(''    itrs: translation of the individual'')')
***************
      write(6,'(''    ktrs: translation of the crystal'')')
***************
      write(6,'(''    ortn: orientation of crystal'')')
      write(6,'(''    outd: output crystal data'')')
      write(6,'(''    plot: draw by xy-plotter'')')
      write(6,'(''    prnt: output in file(6 or 7)'')')
      write(6,'(''    rotn: rotation of crystal'')')
      write(6,'(''    scal: scaling of crystal'')')
      write(6,'(''    tdsp: display twin on graphic device'')')
      write(6,'(''    tplt: draw twin figure by xy-plotter'')')
      go to 11
      end if
      if(vertlr.eq.'axis') go to 100
      if(vertlr.eq.'back') go to 500
      if(vertlr.eq.'ccls') go to 200
      if(vertlr.eq.'ceps') go to 2040
      if(vertlr.eq.'disp') go to 900
      if(vertlr.eq.'dmax') go to 450
      if(vertlr.eq.'form') go to 400
      if(vertlr.eq.'face') go to 410
      if(vertlr.eq.'flst') go to 600
      if(vertlr.eq.'iadd') go to 2300
      if(vertlr.eq.'igen') go to 2100
      if(vertlr.eq.'iinv') go to 2150
      if(vertlr.eq.'itrs') go to 2200
************
      if(vertlr.eq.'ktrs') go to 2201
************
      if(vertlr.eq.'ortn') go to 750
      if(vertlr.eq.'outd') go to 300
      if(vertlr.eq.'plot') go to 1000
      if(vertlr.eq.'prnt') go to 800
      if(vertlr.eq.'rotn') go to 700
      if(vertlr.eq.'scal') go to 1100
      if(vertlr.eq.'tdsp') go to 2500
      if(vertlr.eq.'tplt') go to 2600
      if(vertlr.eq.'end ') go to 9000
      write(6,'('' ??? '',a4,'' ???'')') vertlr
      go to 10
  100 write(6,'('' * axial ratio and angles? *'')')
      read(5,*) a,b,c,al,be,ga
      call geomet
      go to 10
  200 write(6,'('' * crystal class? *'')')
  201 read(5,'(a5)') klasse
      if(klasse(1:1).eq.'h') then
      write(6,'('' * crystal class symbols: *''/(1h ,5a8))') kkls
      go to 201
      end if
      do 210 isym=1,42
      if(klasse.eq.kkls(isym)) go to 10
  210 continue
      go to 200
  300 write(6,'('' * crystal data *'')')
      write(6,'('' crystal class: ''a5)') klasse
      write(6,'(''  a'',g16.7,''     b'',g16.7,''     c'',g16.7/'' al'',
     *g16.7,''    be'',g16.7,''    ga'',g16.7)') a,b,c,al,be,ga
      write(6,'('' * symop output(y,n)? *'')')
      read(5,'(a1)') jn
      if(jn.eq.'y') then
      do 320 i=jsym(1,isym),jsym(2,isym),jsym(3,isym)
      do 310 j=1,3
      symop(1,j)=cxyz(infsym(1,j,i),1)
      symop(2,j)=cxyz(infsym(2,j,i),2)
  310 continue
      write(6,'(1h ,5x,2a2,2x,2a2,2x,2a2)') symop
  320 continue
      end if
      go to 10
  400 write(6,'('' * hkl(form)? distance? *'')')
      j=isym
      go to 420
  410 write(6,'('' * hkl(face)? distance? *'')')
      j=1
  420 read(5,*) h,d
c      write(6,'(1h ,3i4,f10.3)') (int(h(i)),i=1,3),d
      write(6,'(1h ,3f10.6,f10.4)') (h(i),i=1,3),d
c      write(9) ifrei,rsp
      istack=istack+1
      call nff(j,h,d)
      call neupkt
      go to 10
  450 write(6,'('' * maximum distance to  plane *''/'' * hkl? *'')')
      read(5,*) h
      call dmax(h,d)
c      write(6,'(1h ,3i4,f10.3)') (int(h(i)),i=1,3),d
      write(6,'(1h ,3f10.6,f10.3)') (h(i),i=1,3),d
      go to 10
  500 if(istack.ge.1) then
c       backspace (unit=9)
c       read(9) ifrei,rsp
c       backspace (unit=9)
       istack=istack-1
       write(6,'('' * step backward performed *'')')
      else
       write(6,'('' * ground state reached *'')')
      end if
      go to 10
  600 write(6,'('' * list of faces *''/''0   h   k   l       d'')')
      call zzgr(2)
  610 call gibne(2,i,ind)
      if(ind.eq.0) then
c        write(6,'(1h ,3i4,f10.3)') (int(rsp(k,i)),k=2,4),rsp(8,i)
        write(6,'(1h ,3f10.6,f10.3)') (rsp(k,i),k=2,4),rsp(8,i)
        go to 610
      else if(ind.gt.0) then
        go to 10
      end if
      write(6,'(''     list of faces empty'')')
      go to 10
  700 write(6,'('' * rotation of crystal *''/'' * axis(0,1,2,3)? angle?
     **'')')
      read(5,*) ix,ph
      call prmtrx(ix,ph)
      go to 10
  750 write(6,'('' * orientation of crystal * ''/''     case     v1//
     *v1*v2//'')')
      write(6,'(''       1       x        z'')')
      write(6,'(''       2       y        x'')')
      write(6,'(''       3       z        y'')')
  751 write(6,'('' * case(1,2,3)? *'')')
      read(5,*) ix
      if(ix.lt.1.or.ix.gt.3) go to 751
  752 write(6,'('' * zone axis / plane normal (0,1)? v1? *'')')
      read(5,*) iz,u
      if(iz.lt.0.or.iz.gt.1) go to 752
  753 write(6,'('' * zone axis / plane normal (0,1)? v2? *'')')
      read(5,*) jz,v
      if(jz.lt.0.or.jz.gt.1) go to 753
      write(6,'('' case:'',i3)') ix
      write(6,'('' v1:  '',a3,3x,3i4)') zzff(iz),(int(u(j)),j=1,3)
      write(6,'('' v2:  '',a3,3x,3i4)') zzff(jz),(int(v(j)),j=1,3)
      if(iz.eq.0) call mv(aa,u,u)
      if(jz.eq.0) call mv(aa,v,v)
      call prjmtx(ix,u,v)
      go to 10
  800 write(6,'('' * output lists of faces and edges *'')')
  801 write(6,'('' * file no.(6,7)? *'')')
      read(5,*) naus
      if(naus.le.5.or.naus.ge.8) go to 801
      call ausg(2,1,naus)
      go to 10
  900 write(6,'('' * crystal/individual/twin (c,i,t)? *'')')
      read(5,'(a1)') jn
      if(jn.eq.'c') then
        kliste=1
      else if(jn.eq.'i') then
        call zzgr(izk)
        call gibne(izk,i,ind)
        if(ind.eq.-1) go to 2030
        kliste=izk
      else if(jn.eq.'t') then
        call zzgr(lzk)
        call gibne(lzk,i,ind)
        if(ind.eq.-1) go to 2020
        kliste=lzk
      else
        go to 900
      end if
      call graphn(kliste)
      go to 10
 1000 write(6,'('' * crystal/individual/twin (c,i,t)? *'')')
      read(5,'(a1)') jn
      if(jn.eq.'c') then
        kliste=1
      else if(jn.eq.'i') then
        call zzgr(izk)
        call gibne(izk,i,ind)
        if(ind.eq.-1) go to 2030
        kliste=izk
      else if(jn.eq.'t') then
        call zzgr(lzk)
        call gibne(lzk,i,ind)
        if(ind.eq.-1) go to 2020
        kliste=lzk
      else
        go to 1000
      end if
      if(erstpl) then
        erstpl=.false.
cp
        call plots(0.0,0.0,4)
      end if
      write(6,'('' * back side(y,n)? *'')')
      read(5,'(a1)') jn
      write(6,'('' * scale? linewidth/2? paper transport? *'')')
      read(5,*) vergrf,delta,deltx
      if(jn.eq.'y') then
        call zeichn(kliste,.true.,vergrf,delta,deltx)
      else
        call zeichn(kliste,.false.,vergrf,delta,deltx)
      endif
      go to 10
 1100 write(6,'('' * scaling of crystal *''/'' * scale factor? *'')')
      read(5,*) vergrf
c      write(9) ifrei,rsp
      istack=istack+1
      call kvergr(1,2,vergrf)
      if(vergrf.ge.1.0) then
       write(6,'('' * crystal enlarged *'')')
      else
       write(6,'('' * crystal reduced *'')')
      end if
      go to 10
 2020 write(6,'('' * twin does not exist *'')')
      go to 10
 2030 write(6,'('' * individual does not exist *'')')
      go to 10
 2040 write(6,'('' * tolerance intervals are eps1='',e9.2,
     *''  eps2='',e9.2,'' *''/'' * view distance is '',g11.3,'' *''/
     *'' * change? *'')') eps1,eps2,vv
      read(5,*) eps1,eps2,vv
      write(6,'('' new tolerance intervals'',2e11.2)') eps1,eps2
      write(6,'('' new view distance'',g11.3)') vv
      if(vv.ne.0.0) then
        vs=1.0/vv
      else
        vs=0.0
      end if
      go to 10
 2100 call zzgr(izk)
      call gibne(izk,i,ind)
      if(ind.ne.-1) then
       write(6,'('' * an individual already exists *'')')
       go to 10
      end if
      write(6,'('' * twinning axis/plane or copy (a,p,c)? *'')')
 2110 read(5,'(a1)') zof
      if(zof.eq.'p') then
       write(6,'('' * hkl? *'')')
       read(5,*) h
       write(6,'('' * twinning plane ('',3i3,'') *'')')
     *                                              (int(h(i)),i=1,3)
       spgl=.true.
       lgen=.false.
      else if(zof.eq.'a') then
       write(6,'('' * uvw? rotation angle? *'')')
       read(5,*) u,rho
c       write(6,'('' * twinning axis (/'',3i3,''/) *''/
       write(6,'('' * twinning axis (/'',3f10.6,''/) *''/
     *       '' * rotation '',i4,'' degree *'')')
c     *        (int(u(i)),i=1,3),int(rho)
     *        (u(i),i=1,3),int(rho)
       call mv(aa,u,h)
       spgl=.false.
       lgen=.false.
      else if(zof.eq.'c') then
       write(6,'('' * copy of single crystal generated *'')')
       lgen=.true.
      else
       go to 2110
      end if
c      write(9) ifrei,rsp
      istack=istack+1
      call igen(lgen,spgl,h,rho)
      go to 10
 2150 call zzgr(izk)
      call gibne(izk,i,ind)
      if(ind.eq.-1) go to 2030
      call iinv
      write(6,'('' * individual inverted *'')')
      go to 10
 2200 call zzgr(izk)
      call gibne(izk,i,ind)
      if(ind.eq.-1) go to 2030
      write(6,'('' * translation of the individual *''/'' * parallel to
     *a zone axis or a plane normal (a,p)? *'')')
 2210 read(5,'(a1)') zof
      if(zof.eq.'p') then
       write(6,'('' * hkl? distance? *'')')
       read(5,*) h,d
       write(6,'('' * translation normal to ('',3i3,''), ditance'',
     * g12.4,'' *'')') (int(h(i)),i=1,3),d
      else if(zof.eq.'a') then
       write(6,'('' * uvw? distance? *'')')
       read(5,*) u,d
       write(6,'('' * translation parallel to (/'',3i3,''/), distance'',
     * g12.4,'' *'')') (int(u(i)),i=1,3),d
       call mv(aa,u,h)
      else
       go to 2210
      end if
      call itrns(h,d)
      go to 10
 2201 continue
      izl=1
      call zzgr(izl)
      call gibne(izl,i,ind)
      if(ind.eq.-1) go to 2030
      write(6,'('' * translation of the individual *''/'' * parallel to
     *a zone axis or a plane normal (a,p)? *'')')
 2211 read(5,'(a1)') zof
      if(zof.eq.'p') then
       write(6,'('' * hkl? distance? *'')')
       read(5,*) h,d
       write(6,'('' * translation normal to ('',3i3,''), ditance'',
     * g12.4,'' *'')') (int(h(i)),i=1,3),d
      else if(zof.eq.'a') then
       write(6,'('' * uvw? distance? *'')')
       read(5,*) u,d
       write(6,'('' * translation parallel to (/'',3i3,''/), distance'',
     * g12.4,'' *'')') (int(u(i)),i=1,3),d
       call mv(aa,u,h)
      else
       go to 2211
      end if
      call ktrns(h,d)
      go to 10
 2300 call zzgr(izk)
      call gibne(izk,i,ind)
      if(ind.eq.-1) go to 2030
      write(6,'('' * penetration (y,n)? *'')')
 2310 read(5,'(a1)') jn
      if(jn.eq.'y') then
       write(6,'('' * penetration twinning *'')')
       call iadd
      else if(jn.eq.'n') then
       write(6,'('' * no penetration *'')')
       call iadd2
      else
       go to 2310
      end if
      write(6,'('' * individual added to the twin *'')')
      go to 10
 2500 call zzgr(lzk)
      call gibne(lzk,i,ind)
      if(ind.eq.-1) go to 2020
c      write(9) ifrei,rsp
      istack=istack+1
      call graphz
c      backspace (unit=9)
c      read(9) ifrei,rsp
c      backspace (unit=9)
      istack=istack-1
      go to 10
 2600 call zzgr(lzk)
      call gibne(lzk,i,ind)
      if(ind.eq.-1) go to 2020
c      write(9) ifrei,rsp
      istack=istack+1
      if(erstpl) then
        erstpl=.false.
        call plots(0.0,0.0,4)
      end if
      write(6,'('' * scale factor? linewidth/2? paper transport? *'')')
      read(5,*) vergrf,delta,deltx
      call zzchnn(vergrf,delta,deltx)
c      backspace (unit=9)
c      read(9) ifrei,rsp
c      backspace (unit=9)
      istack=istack-1
      go to 10
 9000 write(6,'('' * end *'')')
c     if(.not.erstpl) call plot(0.0,0.0,999)
      if(.not.erstpl)  call plote(' ')
c      close (unit=9)
      return
      end
c**********************************************************************c
      subroutine zeichn(kliste,iz,vergrf,delta,deltx)
c     plotter subroutines used
      common /euler/ prj(3,3)
      parameter (nmem=20000)
c     common /frei/ ifrei,isp(10,1000)
      common /frei/ ifrei,isp(10,nmem)
      common /sym/ isym,jsym(3,42),infsym(2,3,236)
      common /kdt/ a,b,c,al,be,ga,tr(3,3),bb(3,3)
      common /epslon/ eps,eps2,vs
c     real   rsp(10,1000)
      real   rsp(10,nmem)
      real xa(3),xe(3),x8(3),x9(3)
      logical sichtb,iz,l1
      equivalence (isp(1,1),rsp(1,1))
c     paper height 27 cm, plot in cm units
      call factor(1.0)
c     call set(deltx,13.5)
      call plot(deltx,13.5,-3)
      call factor(vergrf)
      call zzgr(kliste)
   10 call gibne(kliste,ik,ind)
      if(ind.eq.0) then
************************************************
      if(abs(rsp(2,ik)).lt.eps.and.
     *   abs(rsp(3,ik)).lt.eps.and.
     *   abs(rsp(4,ik)).lt.eps) go to 10
      if(abs(rsp(5,ik)).lt.eps.and.
     *   abs(rsp(6,ik)).lt.eps.and.
     *   abs(rsp(7,ik)).lt.eps) go to 10
************************************************
      call mv(prj,rsp(5,abs(isp(8,ik))),x8)
      call mv(prj,rsp(5,abs(isp(9,ik))),x9)
      l1=.false.
      if(vs.ne.0.0) l1=x8(3)/vs-rsp(8,abs(isp(8,ik))).ge.0.0 .or.
     *                 x9(3)/vs-rsp(8,abs(isp(9,ik))).ge.0.0
      sichtb=l1.or.(vs.eq.0.0.and.(x8(3).ge.0.0.or.x9(3).ge.0.0))
      if(iz.or.sichtb) then
      call mv(prj,rsp(2,ik),xa)
      call mv(prj,rsp(5,ik),xe)
      xa(1)=xa(1)/(1.0-xa(3)*vs)
      xa(2)=xa(2)/(1.0-xa(3)*vs)
      xe(1)=xe(1)/(1.0-xe(3)*vs)
      xe(2)=xe(2)/(1.0-xe(3)*vs)
      p=xa(2)-xe(2)
      q=xe(1)-xa(1)
      sqrtpq=sqrt(p*p+q*q)
      if(sqrtpq.lt.eps) go to 10
c     edges in back side
      if(.not.sichtb) then
        call plot(xa(1),xa(2),3)
        call plot(xe(1),xe(2),2)
        go to 20
      end if
c     edges in front side
      call plot(xa(1),xa(2),3)
      call plot(xe(1),xe(2),2)
      if(sichtb.and.delta.gt.0.0) then
      dx=delta*p/sqrtpq
      dy=delta*q/sqrtpq
      call plot(xe(1)+dx,xe(2)+dy,2)
      call plot(xa(1)+dx,xa(2)+dy,2)
      call plot(xa(1)-dx,xa(2)-dy,2)
      call plot(xe(1)-dx,xe(2)-dy,2)
      call plot(xe(1),xe(2),2)
      end if
  20  end if
      go to 10
      end if
      call plot(0.0,0.0,3)
      return
      end
c**********************************************************************c
      subroutine zzchnn(vergrf,delta,deltx)
c     plotter subroutines used
      common /euler/ prj(3,3)
      parameter (nmem=20000)
c     common /frei/ ifrei,ir(10,1000)
      common /frei/ ifrei,ir(10,nmem)
      common /twin/ lzk,lzf,lgl,izk,izf
      common /epslon/ eps,eps2,vs
c     real r(10,1000)
      real r(10,nmem)
      equivalence (ir(1,1),r(1,1))
      call filt2(lzk)
      call zzgr(lzk)
    1 call gibne(lzk,ik,ind)
      if(ind.eq.0) then
      call mv(prj,r(2,ik),r(2,ik))
      call mv(prj,r(5,ik),r(5,ik))
      go to 1
      end if
      call zzgr(lgl)
    2 call gibne(lgl,ik,ind)
      if(ind.eq.0) then
      call mv(prj,r(2,ik),r(2,ik))
      call mv(prj,r(5,ik),r(5,ik))
      go to 2
      end if
      call zzgr(lzf)
    3 call gibne(lzf,ik,ind)
      if(ind.eq.0) then
      call mv(prj,r(5,ik),r(5,ik))
      go to 3
      end if
      call lkreii(nkl)
      call factor(1.0)
c     call set(deltx,13.5)
      call plot(deltx,13.5,-3)
      call factor(vergrf)
      do 20 lll=lzk,lgl,lgl-lzk
      call zzgr(lll)
   10 call gibne(lll,ik,ind)
      if(ind.eq.0) then
      if(ir(8,ik).le.0.or.ir(9,ik).le.0) go to 10
************************************************
      if(abs(r(2,ik)).lt.eps.and.
     *   abs(r(3,ik)).lt.eps.and.
     *   abs(r(4,ik)).lt.eps) go to 10
      if(abs(r(5,ik)).lt.eps.and.
     *   abs(r(6,ik)).lt.eps.and.
     *   abs(r(7,ik)).lt.eps) go to 10
************************************************
      call hidden(lzk,lzf,ik,nkl)
      call zzgr(nkl)
   11 call gibne(nkl,jk,ind)
      if(ind.eq.0) then
      r(2,jk)=r(2,jk)/(1.0-r(4,jk)*vs)
      r(3,jk)=r(3,jk)/(1.0-r(4,jk)*vs)
      r(5,jk)=r(5,jk)/(1.0-r(7,jk)*vs)
      r(6,jk)=r(6,jk)/(1.0-r(7,jk)*vs)
      p=r(3,jk)-r(6,jk)
      q=r(5,jk)-r(2,jk)
      sqrtpq=sqrt(p*p+q*q)
      if(sqrtpq.lt.eps) go to 11
      call plot(r(2,jk),r(3,jk),3)
      call plot(r(5,jk),r(6,jk),2)
      if(delta.gt.0.0) then
      dx=delta*p/sqrtpq
      dy=delta*q/sqrtpq
      call plot(r(5,jk)+dx,r(6,jk)+dy,2)
      call plot(r(2,jk)+dx,r(3,jk)+dy,2)
      call plot(r(2,jk)-dx,r(3,jk)-dy,2)
      call plot(r(5,jk)-dx,r(6,jk)-dy,2)
      call plot(r(5,jk),r(6,jk),2)
      end if
      go to 11
      end if
      go to 10
      end if
   20 continue
      call lverni(nkl)
      call plot(0.0,0.0,3)
      return
      end
c**********************************************************************c
      subroutine graphn(kliste)
c     graphic subroutine library 'plot-10' used
      common /euler/ prj(3,3)
      parameter (nmem=20000)
c     common /frei/ ifrei,isp(10,1000)
      common /frei/ ifrei,isp(10,nmem)
      common /epslon/ eps1,eps2,vs
      common /format/ c001,c002,c003,c004,c005,c006,c007,c008,c009,
     *                c010,c011,c012,c013
      character*53 c001,c002,c003,c004,c005,c006,c007,c008,c009,c010
      character*53 c011,c012,c013*1
      character jn*1
      logical l1
      real xa(3),xe(3),x8(3),x9(3)
c     real rsp(10,1000)
      real rsp(10,nmem)
      equivalence (isp(1,1),rsp(1,1))
      data jn/'n'/
      write(6,fmt=c008)
      read(5,'(a1)') jn
      write(6,fmt=c009)
      read(5,*) vergrf
c     display device tektronix 4010 series 4096*4096 logical dots
c     initialize terminal and set graphic mode
      call orient(2)
      call initt(960)
      call term(1,1024)
c      call twindo(0,1023,0,780)
      xu=(40.0/vergrf)*0.5
      yu=(30.5/vergrf)*0.5
      call dwindo(-xu,xu,-yu,yu)
      call twindo(0,1023,0,780)
      call erase
      call zzgr(kliste)
   10 call gibne(kliste,ik,ind)
      if(ind.eq.0) then
      call mv(prj,rsp(5,abs(isp(8,ik))),x8)
      call mv(prj,rsp(5,abs(isp(9,ik))),x9)
      l1=.false.
      if(vs.ne.0.0) l1=x8(3)/vs-rsp(8,abs(isp(8,ik))).ge.0.0 .or.
     *                 x9(3)/vs-rsp(8,abs(isp(9,ik))).ge.0.0
      if(l1.or.(vs.eq.0.0.and.(x8(3).ge.0.0.or.x9(3).ge.0.0))) then
      call mv(prj,rsp(2,ik),xa)
      call mv(prj,rsp(5,ik),xe)
      xa(1)=xa(1)/(1.0-xa(3)*vs)
      xa(2)=xa(2)/(1.0-xa(3)*vs)
      xe(1)=xe(1)/(1.0-xe(3)*vs)
      xe(2)=xe(2)/(1.0-xe(3)*vs)
c     draw solid lines
      call movea(xa(1),xa(2))
      call drawa(xe(1),xe(2))
      end if
      go to 10
      end if
      if(jn.eq.c013) then
      call zzgr(kliste)
   20 call gibne(kliste,ik,ind)
      if(ind.eq.0) then
      call mv(prj,rsp(5,abs(isp(8,ik))),x8)
      call mv(prj,rsp(5,abs(isp(9,ik))),x9)
      l1=.false.
      if(vs.ne.0.0) l1=x8(3)/vs-rsp(8,abs(isp(8,ik))).ge.0.0 .or.
     *                 x9(3)/vs-rsp(8,abs(isp(9,ik))).ge.0.0
      if(.not.
     *  (l1.or.(vs.eq.0.0.and.(x8(3).ge.0.0.or.x9(3).ge.0.0)))) then
      call mv(prj,rsp(2,ik),xa)
      call mv(prj,rsp(5,ik),xe)
      xa(1)=xa(1)/(1.0-xa(3)*vs)
      xa(2)=xa(2)/(1.0-xa(3)*vs)
      xe(1)=xe(1)/(1.0-xe(3)*vs)
      xe(2)=xe(2)/(1.0-xe(3)*vs)
c     draw dashed lines
      call movea(xa(1),xa(2))
      call dasha(xe(1),xe(2),12)
      end if
      go to 20
      end if
      end if
c     terminate graphic terminal
      call finitt(0,767)
      call getzap()
      return
      end
c**********************************************************************c
      subroutine graphz
c     graphic subroutines used,  see the comment lines in 'graphn'
      common /euler/ prj(3,3)
      parameter (nmem=20000)
c     common /frei/ ifrei,ir(10,1000)
      common /frei/ ifrei,ir(10,nmem)
      common /twin/ lzk,lzf,lgl,izk,izf
      common /epslon/ eps1,eps2,vs
      common /format/ c001,c002,c003,c004,c005,c006,c007,c008,c009,
     *                c010,c011,c012,c013
      character*53 c001,c002,c003,c004,c005,c006,c007,c008,c009,c010
      character*53 c011,c012,c013*1
c     real r(10,1000)
      real r(10,nmem)
      equivalence (ir(1,1),r(1,1))
      write(6,fmt=c009)
      read(5,*) vergrf
      call filt2(lzk)
      call zzgr(lzk)
1     call gibne(lzk,ik,ind)
      if(ind.eq.0) then
      call mv(prj,r(2,ik),r(2,ik))
      call mv(prj,r(5,ik),r(5,ik))
      go to 1
      end if
      call zzgr(lgl)
2     call gibne(lgl,ik,ind)
      if(ind.eq.0) then
      call mv(prj,r(2,ik),r(2,ik))
      call mv(prj,r(5,ik),r(5,ik))
      go to 2
      end if
      call zzgr(lzf)
3     call gibne(lzf,ik,ind)
      if(ind.eq.0) then
      call mv(prj,r(5,ik),r(5,ik))
      go to 3
      end if
      call lkreii(nkl)
      call orient(2)
      call initt(960)
      call term(1,1024)
c      call twindo(0,1023,0,780)
      xu=(40.0/vergrf)*0.5
      yu=(30.5/vergrf)*0.5
      call dwindo(-xu,xu,-yu,yu)
      call twindo(0,1023,0,780)
      call erase
      do 20 lll=lzk,lgl,lgl-lzk
      call zzgr(lll)
10    call gibne(lll,ik,ind)
      if(ind.eq.0) then
      if(ir(8,ik).le.0.or.ir(9,ik).le.0) go to 10
      call hidden(lzk,lzf,ik,nkl)
      call zzgr(nkl)
11    call gibne(nkl,jk,ind)
      if(ind.eq.0) then
      r(2,jk)=r(2,jk)/(1.0-r(4,jk)*vs)
      r(3,jk)=r(3,jk)/(1.0-r(4,jk)*vs)
      r(5,jk)=r(5,jk)/(1.0-r(7,jk)*vs)
      r(6,jk)=r(6,jk)/(1.0-r(7,jk)*vs)
      call movea(r(2,jk),r(3,jk))
      call drawa(r(5,jk),r(6,jk))
      go to 11
      end if
      go to 10
      end if
20    continue
      call lverni(nkl)
      call finitt(0,767)
      call getzap()
      return
      end
c**********************************************************************c
      subroutine geomet
      parameter (raddeg=3.14159265/180.0)
      common /kdt/ a,b,c,al,be,ga,t(3,3),aa(3,3)
      cosal=cos(al*raddeg)
      sinal=sin(al*raddeg)
      cosbe=cos(be*raddeg)
      sinbe=sin(be*raddeg)
      cosga=cos(ga*raddeg)
      cosgas=(cosal*cosbe-cosga)/(sinal*sinbe)
      singas=sqrt(1.0-cosgas*cosgas)
      t(1,1)=1.0/(a*sinbe*singas)
      t(1,2)=0.0
      t(1,3)=0.0
      t(2,1)=cosgas/(b*sinal*singas)
      t(2,2)=1.0/(b*sinal)
      t(2,3)=0.0
      t(3,2)=-cosal/(c*sinal)
      t(3,1)=-(cosal*cosgas)/(c*sinal*singas)-(cosbe/(c*sinbe*singas))
      t(3,3)=1.0/c
      aa(1,1)=a*a
      aa(1,2)=a*b*cosga
      aa(1,3)=a*c*cosbe
      aa(2,1)=aa(1,2)
      aa(2,2)=b*b
      aa(2,3)=b*c*cosal
      aa(3,1)=aa(1,3)
      aa(3,2)=aa(2,3)
      aa(3,3)=c*c
      return
      end
c**********************************************************************c
      subroutine prmtrx(ix,pph)
      common /euler/ prj(3,3)
      common /format/ c001,c002,c003,c004,c005,c006,c007,c008,c009,
     *                c010,c011,c012,c013
      character*53 c001,c002,c003,c004,c005,c006,c007,c008,c009,c010
      character*53 c011,c012,c013*1
      character achse(3)*1
      logical l1
      real   a(3,3)
      data achse/'x','y','z'/
      ph=pph*0.01745329
      cosph=cos(ph)
      sinph=sin(ph)
      l1=.true.
      go to 5
c     entry prmx(ix,cosph,sinph)
      entry prmx(ix,cosph0,sinph0)
      cosph=cosph0
      sinph=sinph0
      l1=.false.
    5 go to (20,30,40), ix
      if(ix.gt.3) return
      do 10 j=1,3
      do  9 i=1,3
      prj(i,j)=0.0
    9 continue
   10 continue
      prj(1,1)=1.0
      prj(2,2)=1.0
      prj(3,3)=1.0
      if(l1) write(6,fmt=c001)
      return
   20 a(1,1)=1.0
      a(1,2)=0.0
      a(1,3)=0.0
      a(2,1)=0.0
      a(2,2)=cosph
      a(2,3)=-sinph
      a(3,1)=0.0
      a(3,2)=sinph
      a(3,3)=cosph
      go to 50
   30 a(1,1)=cosph
      a(1,2)=0.0
      a(1,3)=sinph
      a(2,1)=0.0
      a(2,2)=1.0
      a(2,3)=0.0
      a(3,1)=-sinph
      a(3,2)=0.0
      a(3,3)=cosph
      go to 50
   40 a(1,1)=cosph
      a(1,2)=-sinph
      a(1,3)=0.0
      a(2,1)=sinph
      a(2,2)=cosph
      a(2,3)=0.0
      a(3,1)=0.0
      a(3,2)=0.0
      a(3,3)=1.0
   50 call mm(a,prj,prj)
      if(l1) write(6,fmt=c002) achse(ix),pph
      return
      end
c**********************************************************************c
      subroutine prjmtx(ih,hh1,hh2)
      real hh1(3),hh2(3),ee(3,3),h(3),g(3)
      common /euler/ prj(3,3)
      common /kdt/ a1,b1,c1,al,be,ga,t(3,3),aa(3,3)
      common /epslon/ eps,eps2,vs
      common /format/ c001,c002,c003,c004,c005,c006,c007,c008,c009,
     *                c010,c011,c012,c013
      character*53 c001,c002,c003,c004,c005,c006,c007,c008,c009,c010
      character*53 c011,c012,c013*1
      call prmx(0,0.0,0.0)
      call vm(hh1,t,h)
      call vm(hh2,t,g)
      r=sqrt(h(1)**2+h(2)**2+h(3)**2)
      h(1)=h(1)/r
      h(2)=h(2)/r
      h(3)=h(3)/r
      h1=sqrt(h(2)**2+h(3)**2)
      h2=sqrt(h(3)**2+h(1)**2)
      h3=sqrt(h(1)**2+h(2)**2)
      go to (10,20,30), ih
      go to 40
   10 if(h1.ne.0.0) then
      ee(1,1)=h(1)
      ee(1,2)=h(2)
      ee(1,3)=h(3)
      ee(2,1)=-h1
      ee(2,2)=h(1)*h(2)/h1
      ee(2,3)=h(3)*h(1)/h1
      ee(3,1)=0.0
      ee(3,2)=-h(3)/h1
      ee(3,3)=h(2)/h1
      call mm(ee,prj,prj)
      call mv(ee,g,g)
      end if
      gg=sqrt(g(2)**2+g(3)**2)
      if(gg.gt.eps) then
      c= g(2)/gg
      s=-g(3)/gg
      go to 40
      else
      go to 50
      end if
   20 if(h2.ne.0.0) then
      ee(1,1)=h(3)/h2
      ee(1,2)=0.0
      ee(1,3)=-h(1)/h2
      ee(2,1)=h(1)
      ee(2,2)=h(2)
      ee(2,3)=h(3)
      ee(3,1)=h(1)*h(2)/h2
      ee(3,2)=-h2
      ee(3,3)=h(2)*h(3)/h2
      call mm(ee,prj,prj)
      call mv(ee,g,g)
      end if
      gg=sqrt(g(3)**2+g(1)**2)
      if(gg.gt.eps) then
      c= g(3)/gg
      s=-g(1)/gg
      go to 40
      else
      go to 50
      end if
   30 if(h3.ne.0.0) then
      ee(1,1)=h(3)*h(1)/h3
      ee(1,2)=h(2)*h(3)/h3
      ee(1,3)=-h3
      ee(2,1)=-h(2)/h3
      ee(2,2)=h(1)/h3
      ee(2,3)=0.0
      ee(3,1)=h(1)
      ee(3,2)=h(2)
      ee(3,3)=h(3)
      call mm(ee,prj,prj)
      call mv(ee,g,g)
      end if
      gg=sqrt(g(1)**2+g(2)**2)
      if(gg.gt.eps) then
      c= g(1)/gg
      s=-g(2)/gg
      go to 40
      else
      go to 50
      end if
   40 call prmx(ih,c,s)
      go to 60
   50 write(6,fmt=c003)
      call prmtrx(0,0.0)
   60 return
      end
c**********************************************************************c
      subroutine nff(iisym,hkl,d)
      common /kdt/ a1,b1,c1,al,be,ga,tr(3,3),aa(3,3)
      common /sym/ isym,jsym(3,42),infsym(2,3,236)
      parameter (nmem=20000)
c     common /frei/ ifrei,isp(10,1000)
      common /frei/ ifrei,isp(10,nmem)
c     real rsp(10,1000)
      real rsp(10,nmem)
      real   hkl(3),ahkl(3),c(3)
      equivalence (isp(1,1),rsp(1,1))
      call lzfrei(4)
      do 1000 j=jsym(1,iisym),jsym(2,iisym),jsym(3,iisym)
      call zzgr(4)
      do 316 i=1,3
      ahkl(i)=0.0
      do 315 k=1,3
      do 314 l=1,2
      m=infsym(l,k,j)
      if(m-i) 312,311,312
  311 ahkl(i)=ahkl(i)+hkl(k)
      go to 314
  312 if(m+i) 314,313,314
  313 ahkl(i)=ahkl(i)-hkl(k)
  314 continue
  315 continue
  316 continue
  318 call gibne(4,ifl,ind)
      if(ind) 330,319,330
  319 if(ahkl(1)-rsp(2,ifl)) 318,320,318
  320 if(ahkl(2)-rsp(3,ifl)) 318,321,318
  321 if(ahkl(3)-rsp(4,ifl)) 318,1000,318
  330 call ffrei(ifl)
      do 331 k=1,3
      rsp(k+1,ifl)=ahkl(k)
  331 continue
      call vm(ahkl,tr,c)
      s=1.0/sqrt(c(1)*c(1)+c(2)*c(2)+c(3)*c(3))
      rsp(5,ifl)=c(1)*s
      rsp(6,ifl)=c(2)*s
      rsp(7,ifl)=c(3)*s
      rsp(8,ifl)=d
      isp(9,ifl)=0
      call leinf(4,ifl)
 1000 continue
      return
      end
c**********************************************************************c
      subroutine neupkt
      parameter (nmem=20000)
c     common /frei/ ifrei,isp(10,1000)
      common /frei/ ifrei,isp(10,nmem)
      common /format/ c001,c002,c003,c004,c005,c006,c007,c008,c009,
     *                c010,c011,c012,c013
      character*53 c001,c002,c003,c004,c005,c006,c007,c008,c009,c010
      character*53 c011,c012,c013*1
      logical l1
c     real rsp(10,1000)
      real rsp(10,nmem)
      equivalence (isp(1,1),rsp(1,1))
      call zzgr(4)
      call zzgr(1)
    5 call gibne(4,ifn,ind)
      if(ind) 100,9,100
    9 l1=.false.
      a=rsp(5,ifn)
      b=rsp(6,ifn)
      c=rsp(7,ifn)
      d=rsp(8,ifn)
      call lzfrei(3)
   10 call gibne(1,ikn,ind)
      if(ind) 11,12,60
   11 stop 031
   12 r1=a*rsp(2,ikn)+b*rsp(3,ikn)+c*rsp(4,ikn)
      r2=a*rsp(5,ikn)+b*rsp(6,ikn)+c*rsp(7,ikn)
      if(r1.ge.d.and.r2.ge.d) then
       isp(9,isp(8,ikn))=isp(9,isp(8,ikn))-1
       isp(9,isp(9,ikn))=isp(9,isp(9,ikn))-1
       call lsche(1,ikn)
       call rfrei(ikn)
       l1=.true.
      else if(r1.lt.d.and.r2.lt.d)  then
      else
       p=(d-r1)/(r2-r1)
       call ffrei(ikp)
       do 50 i=2,4
       rsp(i,ikp)=(1.0-p)*rsp(i,ikn)+p*rsp(i+3,ikn)
   50  continue
       isp(5,ikp)=isp(8,ikn)
       isp(6,ikp)=isp(9,ikn)
       if(r2.ge.d) then
        do 52 i=2,4
        rsp(i+3,ikn)=rsp(i,ikp)
   52   continue
        isp(8,ikp)=1
       else
        do 54 i=2,4
        rsp(i,ikn)=rsp(i,ikp)
   54   continue
        isp(8,ikp)=-1
       end if
       call leinf(3,ikp)
       l1=.true.
      end if
      go to 10
   60 if(.not.l1) then
       write(6,fmt=c004) (int(rsp(i,ifn)),i=2,4)
       go to 5
      end if
      call lsche(4,ifn)
      call leinf(2,ifn)
   68 call zzgr(3)
   69 call gibne(3,ikp1,ind)
      if(ind.ne.0) go to 5
      if1=isp(5,ikp1)
      if(if1.eq.0) then
       if1=isp(6,ikp1)
       if(if1.eq.0) then
        call lsche(3,ikp1)
        call rfrei(ikp1)
        go to 69
       else
        ihv1=-isp(8,ikp1)
        isp(6,ikp1)=0
       end if
      else
       ihv1=isp(8,ikp1)
       isp(5,ikp1)=0
      end if
   75 call gibne(3,ikp2,ind)
      if(ind.ne.0) stop 032
      if(if1.eq.isp(5,ikp2)) then
       ihv2=isp(8,ikp2)
       isp(5,ikp2)=0
      else if(if1.eq.isp(6,ikp2)) then
       ihv2=-isp(8,ikp2)
       isp(6,ikp2)=0
      else
       go to 75
      end if
********* bug fixed by K. Kato, Nov. 1, 1989
c      if((rsp(2,ikp1).ne.rsp(2,ikp2)).or.(rsp(3,ikp1).ne.rsp(3,ikp2))
c     * .or.(rsp(4,ikp1).ne.rsp(4,ikp2)))  then
       call ffrei(ikn)
       isp(8,ikn)=if1
       isp(9,ikn)=ifn
       isp(9,if1)=isp(9,if1)+1
       isp(9,ifn)=isp(9,ifn)+1
       if(ihv1.eq.1.and.ihv2.eq.-1) then
       else if(ihv1.eq.-1.and.ihv2.eq.1) then
        ikpp=ikp1
        ikp1=ikp2
        ikp2=ikpp
       else
        stop 033
       end if
********* bug fixed by K. Kato, Nov. 1, 1989
c      else
c       go to 68
c      end if
      do 78 i=2,4
      rsp(i,ikn)=rsp(i,ikp1)
      rsp(i+3,ikn)=rsp(i,ikp2)
   78 continue
      call leinf(1,ikn)
      go to 68
  100 call zzgr(2)
  101 call gibne(2,ifl,ind)
      if(ind) 105,102,105
  102 if(isp(9,ifl)-3) 103,101,101
  103 call lsche(2,ifl)
      call rfrei(ifl)
      go to 101
  105 return
      end
c**********************************************************************c
      subroutine dmax(h,d)
      parameter (nmem=20000)
c     common /frei/ ifrei,r(10,1000)
      common /frei/ ifrei,r(10,nmem)
      common /kdt/  a,b,c,al,be,ga,tr(3,3),aa(3,3)
      real   h(3),g(3)
      call vm(h,tr,g)
      s=1.0/sqrt(g(1)**2+g(2)**2+g(3)**2)
      do 10 i=1,3
      g(i)=g(i)*s
   10 continue
      d=0.0
      call zzgr(1)
   20 call gibne(1,i,ind)
      if(ind.eq.0) then
       d=max(d,r(2,i)*g(1)+r(3,i)*g(2)+r(4,i)*g(3),
     *         r(5,i)*g(1)+r(6,i)*g(2)+r(7,i)*g(3))
       go to 20
      end if
      return
      end
c**********************************************************************c
      subroutine kvergr(lk,lf,vergrf)
      parameter (nmem=20000)
c     common /frei/ ifrei,rs(10,1000)
      common /frei/ ifrei,rs(10,nmem)
      call zzgr(lk)
   10 call gibne(lk,i,ind)
      if(ind.eq.0) then
       do 11 j=2,7
       rs(j,i)=rs(j,i)*vergrf
   11  continue
       go to 10
      end if
      call zzgr(lf)
   20 call gibne(lf,i,ind)
      if(ind.eq.0) then
       rs(8,i)=rs(8,i)*vergrf
       go to 20
      end if
      return
      end
c**********************************************************************c
      subroutine igen(lgen,spgl,h,rho)
      common /kdt/ a,b,c,al,be,ga,tr(3,3),aa(3,3)
      parameter (nmem=20000)
c     common /frei/ ifrei,isp(10,1000)
      common /frei/ ifrei,isp(10,nmem)
      common /twin/ lzk,lzf,lgl,izk,izf
      logical lgen,spgl
c     real rsp(10,1000)
      real rsp(10,nmem)
      real   h(3),uvw(3),t(3,3)
      equivalence (isp(1,1),rsp(1,1))
      call kopie(1,izk,2,izf)
      if(lgen)  return
      call vm(h,tr,uvw)
      uxy=sqrt(uvw(1)**2+uvw(2)**2)
      uxyz=sqrt(uvw(1)**2+uvw(2)**2+uvw(3)**2)
      if(uxy.ne.0.0) then
       ct=uvw(1)/uxy
       st=uvw(2)/uxy
      else
       ct=1.0
       st=0.0
      end if
      cp=uvw(3)/uxyz
      sp=uxy/uxyz
      if(spgl) then
       t(1,1)=1.0-2.0*sp**2*ct**2
       t(1,2)=-2.0*sp**2*st*ct
       t(1,3)=-2.0*sp*cp*ct
       t(2,1)=-2.0*sp**2*st*ct
       t(2,2)=1.0-2.0*sp**2*st**2
       t(2,3)=-2.0*sp*cp*st
       t(3,1)=-2.0*sp*cp*ct
       t(3,2)=-2.0*sp*cp*st
       t(3,3)=sp**2-cp**2
      else
       sr=sin(rho*0.017453293)
       cr=cos(rho*0.017453293)
       t(1,1)=cr*(cp**2*ct**2+st**2)+sp**2*ct**2
       t(1,2)=(1.0-cr)*sp**2*st*ct-sr*cp
       t(1,3)=(1.0-cr)*sp*cp*ct+sr*sp*st
       t(2,1)=(1.0-cr)*sp**2*st*ct+sr*cp
       t(2,2)=cr*(cp**2*st**2+ct**2)+sp**2*st**2
       t(2,3)=(1.0-cr)*sp*cp*st-sr*sp*ct
       t(3,1)=(1.0-cr)*sp*cp*ct-sr*sp*st
       t(3,2)=(1.0-cr)*sp*cp*st+sr*sp*ct
       t(3,3)=cr*sp**2+cp**2
      end if
      call zzgr(izk)
   10 call gibne(izk,k,ind)
      if(ind.eq.0) then
       call mv(t,rsp(2,k),rsp(2,k))
       call mv(t,rsp(5,k),rsp(5,k))
       if(spgl) then
        ii=isp(8,k)
        isp(8,k)=isp(9,k)
        isp(9,k)=ii
       end if
       go to 10
      end if
      call zzgr(izf)
   20 call gibne(izf,k,ind)
      if(ind.eq.0) then
       call mv(t,rsp(5,k),rsp(5,k))
       go to 20
      end if
      return
      end
c**********************************************************************c
      subroutine iinv
      parameter (nmem=20000)
c     common /frei/ ifrei,isp(10,1000)
      common /frei/ ifrei,isp(10,nmem)
      common /twin/ lzk,lzf,lgl,izk,izf
c     real rsp(10,1000)
      real rsp(10,nmem)
      equivalence (isp(1,1),rsp(1,1))
      call zzgr(izk)
   10 call gibne(izk,i,ind)
      if(ind.eq.0) then
      do 20 j=2,7
      rsp(j,i)=-rsp(j,i)
   20 continue
      ii=isp(8,i)
      isp(8,i)=isp(9,i)
      isp(9,i)=ii
      go to 10
      end if
      call zzgr(izf)
   30 call gibne(izf,i,ind)
      if(ind.eq.0) then
      do 40 j=5,7
      rsp(j,i)=-rsp(j,i)
   40 continue
      go to 30
      end if
      return
      end
c**********************************************************************c
      subroutine itrns(hh,dd)
      parameter (nmem=20000)
c     common /frei/ ifrei,isp(10,1000)
      common /frei/ ifrei,isp(10,nmem)
      common /kdt/ a,b,c,al,be,ga,tr(3,3),aa(3,3)
      common /twin/ lzk,lzf,lgl,izk,izf
c     real rsp(10,1000)
      real rsp(10,nmem)
      real   hh(3),uvw(3),v(3)
      equivalence (isp(1,1),rsp(1,1))
      call vm(hh,tr,uvw)
      u=sqrt(uvw(1)**2+uvw(2)**2+uvw(3)**2)
      do 5 i=1,3
      v(i)=uvw(i)*dd/u
    5 continue
      call zzgr(izk)
   10 call gibne(izk,j,ind)
      if(ind.eq.0) then
       do 12 i=1,3
       rsp(i+1,j)=rsp(i+1,j)+v(i)
       rsp(i+4,j)=rsp(i+4,j)+v(i)
   12  continue
       go to 10
      end if
      call zzgr(izf)
   20 call gibne(izf,j,ind)
      if(ind.eq.0) then
       rsp(8,j)=rsp(8,j)+rsp(5,j)*v(1)+rsp(6,j)*v(2)+rsp(7,j)*v(3)
       go to 20
      end if
      return
      end
c**********************************************************************c
      subroutine ktrns(hh,dd)
      parameter (nmem=20000)
c     common /frei/ ifrei,isp(10,1000)
      common /frei/ ifrei,isp(10,nmem)
      common /kdt/ a,b,c,al,be,ga,tr(3,3),aa(3,3)
      common /twin/ lzk,lzf,lgl,izk,izf
c     real rsp(10,1000)
      real rsp(10,nmem)
      real   hh(3),uvw(3),v(3)
      equivalence (isp(1,1),rsp(1,1))
      izl=1
      izg=2
      call vm(hh,tr,uvw)
      u=sqrt(uvw(1)**2+uvw(2)**2+uvw(3)**2)
      do 5 i=1,3
      v(i)=uvw(i)*dd/u
    5 continue
      call zzgr(izl)
   10 call gibne(izl,j,ind)
      if(ind.eq.0) then
       do 12 i=1,3
       rsp(i+1,j)=rsp(i+1,j)+v(i)
       rsp(i+4,j)=rsp(i+4,j)+v(i)
   12  continue
       go to 10
      end if
      call zzgr(izg)
   20 call gibne(izg,j,ind)
      if(ind.eq.0) then
       rsp(8,j)=rsp(8,j)+rsp(5,j)*v(1)+rsp(6,j)*v(2)+rsp(7,j)*v(3)
       go to 20
      end if
      return
      end
c**********************************************************************c
      subroutine iadd
      common /epslon/ eps,eps2,vs
      parameter (nmem=20000)
c     common /frei/ ifrei,is(10,1000)
      common /frei/ ifrei,is(10,nmem)
      common /twin/ lzk,lzf,lgl,izk,izf
      logical lkp,lhv,kpunkt
c     real rs(10,1000)
      real rs(10,nmem)
      real   x(3)
      equivalence (is(1,1),rs(1,1))
      call lkreii(lgll)
      call zzgr(lzf)
   50 call gibne(lzf,i,ind)
      if(ind.ne.0) go to 400
      call lzfrei(3)
      call zzgr(izk)
  100 call gibne(izk,j,ind)
      if(ind.eq.0) then
       if(kpunkt(j,i,lzk,lkp,lhv,x)) then
        call ffrei(ikp)
        rs(2,ikp)=x(1)
        rs(3,ikp)=x(2)
        rs(4,ikp)=x(3)
        is(5,ikp)=is(8,j)
        is(6,ikp)=is(9,j)
        if(lhv) then
         is(8,ikp)=-1
         is(9,ikp)=1
        else
         is(8,ikp)=1
         is(9,ikp)=-1
        end if
        call leinf(3,ikp)
       end if
       go to 100
      end if
  200 call zzgr(lzk)
  210 call gibne(lzk,k,ind)
      if(ind.eq.0) then
       if(is(8,k).eq.i) then
        ihv=1
       else if(is(9,k).eq.i) then
        ihv=-1
       else
        go to 210
       end if
       call zzgr(izf)
  220  call gibne(izf,l,ind)
       if(ind.eq.0) then
        if(kpunkt(k,l,izk,lkp,lhv,x)) then
         call ffrei(ikp)
         rs(2,ikp)=x(1)
         rs(3,ikp)=x(2)
         rs(4,ikp)=x(3)
         is(5,ikp)=0
         is(6,ikp)=l
         is(9,ikp)=0
         if(lhv) then
          is(8,ikp)=-ihv
         else
          is(8,ikp)=ihv
         end if
         call leinf(3,ikp)
        end if
        go to 220
       end if
       go to 210
      end if
  320 call zzgr(3)
  321 call gibne(3,j,ind)
      if(ind.ne.0) then
       go to 50
      else
       if1=is(5,j)
       if(if1.eq.0) then
        if1=is(6,j)
        if(if1.eq.0) then
         call lsche(3,j)
         call rfrei(j)
         go to 321
        else
         ihvj1=is(9,j)
         ihvj2=is(8,j)
         is(6,j)=0
        end if
       else
        ihvj1=is(8,j)
        ihvj2=is(9,j)
        is(5,j)=0
       end if
  330  call gibne(3,k,ind)
       if(ind.eq.0) then
        if(if1.eq.is(5,k)) then
         is(5,k)=0
         ihvk1=is(8,k)
         ihvk2=is(9,k)
        else if(if1.eq.is(6,k)) then
         is(6,k)=0
         ihvk1=is(9,k)
         ihvk2=is(8,k)
        else
         go to 330
        end if
        if(abs(rs(2,j)-rs(2,k)).gt.eps.or.abs(rs(3,j)-rs(3,k)).gt.eps
     *     .or.abs(rs(4,j)-rs(4,k)).gt.eps) then
         call ffrei(l)
         is(8,l)=if1
         is(9,l)=i
         if(ihvj1-ihvk1-ihvj2+ihvk2.gt.0) then
          l1=1
          l2=4
         else
          l1=4
          l2=1
         end if
         do 335 ll=1,3
         rs(ll+l1,l)=rs(ll+1,j)
         rs(ll+l2,l)=rs(ll+1,k)
  335    continue
         call leinf(lgll,l)
        else
         go to 330
        end if
       end if
       go to 320
      end if
  400 call zfzl(izk,lzk)
      call zfzl(izf,lzf)
      call filt1(lgll)
      call zzgr(lgll)
  510 call gibne(lgll,l,ind)
      if(ind.eq.0) then
       call zzgr(lzk)
  520  call gibne(lzk,k,ind)
       if(ind.eq.0) then
        if(is(8,k).eq.is(8,l).or.is(8,k).eq.is(9,l)) then
         k=is(9,k)
        else if(is(9,k).eq.is(8,l).or.is(9,k).eq.is(9,l)) then
         k=is(8,k)
        else
         go to 520
        end if
        if(abs(rs(5,k)*rs(2,l)+rs(6,k)*rs(3,l)+rs(7,k)*rs(4,l)-rs(8,k))
     *     .le.eps .and.
     *     abs(rs(5,k)*rs(5,l)+rs(6,k)*rs(6,l)+rs(7,k)*rs(7,l)-rs(8,k))
     *     .le.eps) then
         call lsche(lgll,l)
         call rfrei(l)
         go to 510
        end if
        go to 520
       end if
       go to 510
      end if
      call zfzl(lgll,lgl)
      call lverni(lgll)
      return
      end
c**********************************************************************c
      subroutine iadd2
      common /twin/ lzk,lzf,lgl,izk,izf
      call zfzl(izk,lzk)
      call zfzl(izf,lzf)
      return
      end
c**********************************************************************c
      logical function kpunkt(j,i,lk,lkp,lhv,x)
      parameter (nmem=20000)
c     common /frei/ ifrei,rs(10,1000)
      common /frei/ ifrei,rs(10,nmem)
      common /epslon/ eps,eps2,vs
c     integer is(10,1000)
      integer is(10,nmem)
      equivalence (rs(1,1),is(1,1))
      real x(3)
      logical lkp,lhv,l1,l2
      r1=rs(5,i)*rs(2,j)+rs(6,i)*rs(3,j)+rs(7,i)*rs(4,j)-rs(8,i)
      r2=rs(5,i)*rs(5,j)+rs(6,i)*rs(6,j)+rs(7,i)*rs(7,j)-rs(8,i)
      l1=abs(r1).le.eps
      l2=abs(r2).le.eps
      lkp=l1.and.l2
      if(min(r1,r2).gt.eps .or. max(r1,r2).lt.-eps .or. lkp) then
       kpunkt=.false.
       return
      else
       if(l1) then
        p=0.0
       else if(l2) then
        p=1.0
       else
        p=r1/(r1-r2)
       end if
       x0=(1.0-p)*rs(2,j)+p*rs(5,j)
       y0=(1.0-p)*rs(3,j)+p*rs(6,j)
       z0=(1.0-p)*rs(4,j)+p*rs(7,j)
       call zzgr2(lk)
  110  call gibne2(lk,k,ind)
       if(ind.eq.0)  then
        if(abs(is(8,k)).eq.i) then
         l=abs(is(9,k))
        else if(abs(is(9,k)).eq.i) then
         l=abs(is(8,k))
        else
         go to 110
        end if
        if(rs(5,l)*x0+rs(6,l)*y0+rs(7,l)*z0-rs(8,l).gt.eps) then
         kpunkt=.false.
         return
        else
         go to 110
        end if
       else if(ind.gt.0) then
        x(1)=x0
        x(2)=y0
        x(3)=z0
        if(r2.gt.eps.or.(l2.and.r1.le.-eps)) then
         lhv=.true.
        else
         lhv=.false.
        end if
        kpunkt=.true.
        lkp=l1.or.l2
        return
       else
        stop 041
       end if
      end if
      end
c**********************************************************************c
      subroutine filt1(l)
      parameter (nmem=20000)
c     common /frei/ ifrei,r(10,1000)
      common /frei/ ifrei,r(10,nmem)
      common /epslon/ eps1,eps2,vs
c     integer ir(10,1000)
      integer ir(10,nmem)
      logical m1,gleich
      equivalence (r(1,1),ir(1,1))
      m1=.true.
      eps3=eps1
      go to 2
      entry filt2(l)
      m1=.false.
      eps3=eps2
    2 call zzgr(l)
   10 call gibne(l,i,ind)
      if(ind.eq.0) then
       if(ir(8,i).lt.0) go to 10
       call zzgl(l)
   20  call gibne2(l,j,ind)
       if(ind.eq.0) then
        if(ir(8,j).lt.0) go to 20
        if((abs(r(2,j)-r(2,i)).gt.eps3.or.
     *      abs(r(3,j)-r(3,i)).gt.eps3.or.
     *      abs(r(4,j)-r(4,i)).gt.eps3.or.
     *      abs(r(5,j)-r(5,i)).gt.eps3.or.
     *      abs(r(6,j)-r(6,i)).gt.eps3.or.
     *      abs(r(7,j)-r(7,i)).gt.eps3) .and.
     *     (abs(r(2,j)-r(5,i)).gt.eps3.or.
     *      abs(r(3,j)-r(6,i)).gt.eps3.or.
     *      abs(r(4,j)-r(7,i)).gt.eps3.or.
     *      abs(r(5,j)-r(2,i)).gt.eps3.or.
     *      abs(r(6,j)-r(3,i)).gt.eps3.or.
     *      abs(r(7,j)-r(4,i)).gt.eps3)) go to 20
        if(m1) then
         call lsche(l,j)
         call rfrei(j)
         go to 20
        else
         if((gleich(ir(8,i),-ir(8,j)).and.gleich(ir(9,i),ir(9,j))).or.
     *      (gleich(ir(8,i),-ir(9,j)).and.gleich(ir(9,i),ir(8,j))).or.
     *      (gleich(ir(9,i),-ir(8,j)).and.gleich(ir(8,i),ir(9,j))).or.
     *      (gleich(ir(9,i),-ir(9,j)).and.gleich(ir(8,i),ir(8,j)))) then
          ir(8,j)=-ir(8,j)
          ir(9,j)=-ir(9,j)
          ir(8,i)=-ir(8,i)
          ir(9,i)=-ir(9,i)
          go to 10
         end if
         go to 20
        end if
       end if
       go to 10
      end if
      return
      end
c**********************************************************************c
      logical function gleich(i,j)
      parameter (nmem=20000)
c     common /frei/ ifrei,r(10,1000)
      common /frei/ ifrei,r(10,nmem)
      common /epslon/ eps1,eps2,vs
      real u(4),v(4)
      if(i.lt.0) then
       do 11 k=1,4
       u(k)=-r(k+4,-i)
   11  continue
      else
       do 12 k=1,4
       u(k)=r(k+4,i)
   12  continue
      end if
      if(j.lt.0) then
       do 13 k=1,4
       v(k)=-r(k+4,-j)
   13  continue
      else
       do 14 k=1,4
       v(k)=r(k+4,j)
   14  continue
      end if
      do 21 k=1,4
      if(abs(u(k)-v(k)).gt.eps2) then
       gleich=.false.
       return
      end if
   21 continue
      gleich=.true.
      return
      end
c**********************************************************************c
      subroutine hidden(lkl,lfl,k,nkl)
      parameter (nmem=20000)
c     common /frei/ ifrei,r(10,1000)
      common /frei/ ifrei,r(10,nmem)
      common /epslon/ eps,eps2,vs
c     integer ir(10,1000)
      integer ir(10,nmem)
      logical kpunkt,lkp,lhv,kkp,lm1,lm2,lm3
      real   x(3)
      equivalence (r(1,1),ir(1,1))
      call lzfrei(nkl)
      if(vs.ne.0.0) then
        lm1=r(7,abs(ir(8,k)))/vs-r(8,abs(ir(8,k))).ge.0.0.or.
     *      r(7,abs(ir(9,k)))/vs-r(8,abs(ir(9,k))).ge.0.0
      else if(vs.eq.0.0) then
        lm1=r(7,abs(ir(8,k))).ge.0.0.or.r(7,abs(ir(9,k))).ge.0.0
      end if
      if(.not.lm1) return
      call lkreii(lwork)
      call lkreii(li)
      call lkreii(la)
      call ekopie(nkl,k,kk)
      call zzgr(lfl)
21    call gibne(lfl,ll,ind)
      if(ind.eq.0) then
      if(ll.eq.abs(ir(8,k)).or.ll.eq.abs(ir(9,k))) go to 21
      if(   abs(r(2,ll)).gt.1.0
     *  .or.abs(r(3,ll)).gt.1.0
     *  .or.abs(r(4,ll)).gt.1.0) go to 21   
      if(vs.ne.0.0) then
        cs=r(7,ll)/vs-r(8,ll)
      else
        cs=r(7,ll)
      end if
      if(cs.le.eps) go to 21
30    call zzgr(nkl)
31    call gibne(nkl,kk,ind)
      if(ind.eq.0) then
      f4=1.0-r(4,kk)*vs
      f7=1.0-r(7,kk)*vs
      if(abs(r(5,kk)/f7-r(2,kk)/f4).le.eps.and.
     *   abs(r(6,kk)/f7-r(3,kk)/f4).le.eps) then
        call lsche(nkl,kk)
        call rfrei(kk)
        go to 31
      end if
      kkp=kpunkt(kk,ll,lkl,lkp,lhv,x)
      if(kkp.and..not.lkp) then
      call ffrei(k1)
      call ffrei(k2)
      do 110 i=1,3
      r(i+1,k1)=r(i+1,kk)
      r(i+4,k1)=x(i)
      r(i+1,k2)=x(i)
      r(i+4,k2)=r(i+4,kk)
110   continue
      call leinf(nkl,k1)
      call leinf(nkl,k2)
      call lsche(nkl,kk)
      call rfrei(kk)
      else if((kkp.and.lkp).or..not.(kkp.or.lkp)) then
      call kppr(kk,ll,lkl,li,la,lm1,ai,bi,ci,lln)
      call zzgr(li)
      call gibne(li,l1,ind)
      if(ind.ne.0) then
      call zfzl(la,lwork)
      else if((r(5,ll)*(r(2,l1)+r(5,l1))+r(6,ll)*(r(3,l1)+r(6,l1))
     *    +r(7,ll)*(r(4,l1)+r(7,l1)))/2.0-r(8,ll).lt.0.0) then
      call zfzl(la,lwork)
      else
      call ekopie(lwork,kk,kdummy)
      end if
      else if(.not.kkp.and.lkp) then
      call kppr(kk,ll,lkl,li,la,lm1,ai,bi,ci,lln)
      call zzgr(li)
      call gibne(li,l1,ind)
      if(ind.eq.0) then
      vkx=r(5,k)-r(2,k)
      vky=r(6,k)-r(3,k)
      vkz=r(7,k)-r(4,k)
      vk=sqrt(vkx**2+vky**2+vkz**2)
      vkx=vkx/vk
      vky=vky/vk
      vkz=vkz/vk
      x8=(r(6,abs(ir(8,k)))*vkz-r(7,abs(ir(8,k)))*vky)+r(2,k)
      y8=(r(7,abs(ir(8,k)))*vkx-r(5,abs(ir(8,k)))*vkz)+r(3,k)
      z8=(r(5,abs(ir(8,k)))*vky-r(6,abs(ir(8,k)))*vkx)+r(4,k)
      x9=(r(7,abs(ir(9,k)))*vky-r(6,abs(ir(9,k)))*vkz)+r(2,k)
      y9=(r(5,abs(ir(9,k)))*vkz-r(7,abs(ir(9,k)))*vkx)+r(3,k)
      z9=(r(6,abs(ir(9,k)))*vkx-r(5,abs(ir(9,k)))*vky)+r(4,k)
      lm2=r(5,ll)*x8+r(6,ll)*y8+r(7,ll)*z8-r(8,ll).gt.eps.or.
     *    r(5,ll)*x9+r(6,ll)*y9+r(7,ll)*z9-r(8,ll).gt.eps
      if(lm1.and..not.lm2) then
      if(vs.ne.0.0) then
        csn=r(7,lln)/vs-r(8,lln)
      else
        csn=r(7,lln)
      end if
      lm3=(ai*x8+bi*y8)/(1.0-vs*z8)-ci.gt.eps.or.
     *    (ai*x9+bi*y9)/(1.0-vs*z9)-ci.gt.eps.or.csn.le.0.0
      else
      lm3=.false.
      end if
      if(lm2.or.lm3) then
      call ekopie(lwork,kk,kdummy)
      else
      call zfzl(la,lwork)
      end if
      else
      call ekopie(lwork,kk,kdummy)
      end if
      end if
      go to 31
      else if(ind.gt.0) then
      l1=nkl
      nkl=lwork
      lwork=l1
      call lzfrei(lwork)
      go to 21
      end if
      end if
      call lverni(lwork)
      call lverni(li)
      call lverni(la)
      call lzfrei(3)
      return
      end
c**********************************************************************c
      subroutine kppr(kk,l,lk,li,la,l0,a,b,c,lln)
      parameter (nmem=20000)
c     common /frei/ ifrei,r(10,1000)
      common /frei/ ifrei,r(10,nmem)
      common /epslon/ eps,eps2,vs
c     integer ir(10,1000)
      integer ir(10,nmem)
      equivalence (r(1,1),ir(1,1))
      logical l0,l1,l11,l2,l22
      call lzfrei(li)
      call lzfrei(la)
      call lzfrei(3)
      p=0.0
      q=0.0
      l1=.true.
      l2=.true.
      l0=.false.
      invk=0
      call zzgr2(lk)
21    call gibne2(lk,ii,ind)
      if(ind.eq.0) then
        if(abs(ir(8,ii)).eq.l) then
          ln=abs(ir(9,ii))
        else if(abs(ir(9,ii)).eq.l) then
          ln=abs(ir(8,ii))
          call tausch(r(1,ii))
        else
        go to 21
        end if
        ai=(r(3,ii)*r(7,ii)-r(6,ii)*r(4,ii))*vs+r(6,ii)-r(3,ii)
        bi=(r(4,ii)*r(5,ii)-r(7,ii)*r(2,ii))*vs+r(2,ii)-r(5,ii)
        di=r(2,ii)*r(6,ii)-r(5,ii)*r(3,ii)
        ci=di*vs
        d=sqrt(ai**2+bi**2+ci**2)
        if(d.le.eps) go to 21
        invk=invk+1
        ai=ai/d
        bi=bi/d
        ci=ci/d
        di=di/d
        call ffrei(m1)
        r(2,m1)=ai
        r(3,m1)=bi
        r(4,m1)=ci
        r(5,m1)=di
        call leinf(3,m1)
        r1=ai*r(2,kk)+bi*r(3,kk)+ci*r(4,kk)-di
        r2=ai*r(5,kk)+bi*r(6,kk)+ci*r(7,kk)-di
        l11=.false.
        l22=.false.
        if(abs(r1).le.eps .and. abs(r2).le.eps) then
          l0=.true.
          lln=ln
          d=sqrt(ai**2+bi**2)
          a=ai/d
          b=bi/d
          c=di/d
        else if(r1.gt.eps .and. r2.gt.eps) then
          l11=.true.
          l22=.true.
        else if(r1.gt.eps .and. r2.le.eps) then
          l11=.true.
          l22=.false.
          p=max(p,r1/(r1-r2))
        else if(r2.gt.eps .and. r1.le.eps) then
          l11=.false.
          l22=.true.
          q=max(q,r2/(r2-r1))
        end if
        l1=l1.and..not.l11
        l2=l2.and..not.l22
        go to 21
      end if
      if(invk.lt.3) then
        l0=.false.
        call ekopie(la,kk,m1)
        return
      end if
      if(p.eq.0.0 .and. q.eq.0.0) then
        if(l1.and.l2) then
          call ekopie(li,kk,m1)
        else
          call ekopie(la,kk,m1)
        end if
      else if(p.gt.0.0 .and. q.eq.0.0) then
        if(l2) then
          call ffrei(m1)
          call ffrei(m2)
          do 31 j=2,4
            r(j,m1)=r(j,kk)
            r(j+3,m1)=(1.0-p)*r(j,kk)+p*r(j+3,kk)
            r(j,m2)=r(j+3,m1)
            r(j+3,m2)=r(j+3,kk)
   31     continue
          call leinf(la,m1)
          call leinf(li,m2)
        else
          call ekopie(la,kk,m1)
        end if
      else if(p.eq.0.0 .and. q.gt.0.0) then
        if(l1) then
          call ffrei(m1)
          call ffrei(m2)
          do 32 j=2,4
            r(j,m1)=(1.0-q)*r(j+3,kk)+q*r(j,kk)
            r(j+3,m1)=r(j+3,kk)
            r(j,m2)=r(j,kk)
            r(j+3,m2)=r(j,m1)
   32     continue
          call leinf(la,m1)
          call leinf(li,m2)
        else
          call ekopie(la,kk,m1)
        end if
      else if(p.gt.0.0 .and. q.gt.0.0) then
        call ffrei(m2)
        do 33 j=2,4
          r(j  ,m2)=(1.0-p)*r(j,kk)+p*r(j+3,kk)
          r(j+3,m2)=(1.0-q)*r(j+3,kk)+q*r(j,kk)
   33   continue
        x=(r(2,m2)+r(5,m2))*0.5
        y=(r(3,m2)+r(6,m2))*0.5
        z=(r(4,m2)+r(7,m2))*0.5
        call zzgr(3)
   34   call gibne(3,i,ind)
        if(ind.eq.0) then
          if(r(2,i)*x+r(3,i)*y+r(4,i)*z-r(5,i).gt.eps) go to 36
          go to 34
        end if
        call ffrei(m1)
        call ffrei(m3)
        do 35 j=2,4
          r(j  ,m1)=r(j,kk)
          r(j+3,m1)=r(j,m2)
          r(j  ,m3)=r(j+3,m2)
          r(j+3,m3)=r(j+3,kk)
   35   continue
        call leinf(la,m1)
        call leinf(li,m2)
        call leinf(la,m3)
        go to 37
   36   call ekopie(la,kk,m1)
   37 end if
      return
      end
c**********************************************************************c
      subroutine tausch(r)
      real   r(10)
      rr=r(2)
      r(2)=r(5)
      r(5)=rr
      rr=r(3)
      r(3)=r(6)
      r(6)=rr
      rr=r(4)
      r(4)=r(7)
      r(7)=rr
      rr=r(8)
      r(8)=r(9)
      r(9)=rr
      return
      end
c**********************************************************************c
      subroutine ausg(lf,lk,naus)
      common /euler/ prj(3,3)
      parameter (nmem=20000)
c     common /frei/ ifrei,isp(10,1000)
      common /frei/ ifrei,isp(10,nmem)
      common /epslon/ eps1,eps2,vs
      common /format/ c001,c002,c003,c004,c005,c006,c007,c008,c009,
     *                c010,c011,c012,c013
      character*53 c001,c002,c003,c004,c005,c006,c007,c008,c009,c010
      character*53 c011,c012,c013*1
      logical l1
c     real rsp(10,1000)
      real rsp(10,nmem)
      real xa(3),xe(3),x8(3),x9(3)
      equivalence (isp(1,1),rsp(1,1))
      write(naus,fmt=c005)
      call zzgr(lf)
    1 call gibne(lf,ifl,ind)
      if(ind.eq.0) then
      write(naus,310) (int(rsp(i,ifl)),i=2,4),rsp(8,ifl)
  310 format(' ',2x,3i4,6x,g10.3)
      go to 1
      end if
      write(naus,fmt=c006//c007)
      call zzgr(lk)
   10 call gibne(lk,ik,ind)
      if(ind.eq.0) then
      call mv(prj,rsp(2,ik),xa)
      call mv(prj,rsp(5,ik),xe)
      xa(1)=xa(1)/(1.0-xa(3)*vs)
      xa(2)=xa(2)/(1.0-xa(3)*vs)
      xe(1)=xe(1)/(1.0-xe(3)*vs)
      xe(2)=xe(2)/(1.0-xe(3)*vs)
      call mv(prj,rsp(5,isp(8,ik)),x8)
      call mv(prj,rsp(5,isp(9,ik)),x9)
      l1=.false.
      if(vs.ne.0.0) l1=x8(3)/vs-rsp(8,abs(isp(8,ik))).ge.0.0 .or.
     *                 x9(3)/vs-rsp(8,abs(isp(9,ik))).ge.0.0
      if(l1.or.(vs.eq.0.0.and.(x8(3).ge.0.0.or.x9(3).ge.0.0))) then
        isicht=1
      else
        isicht=0
      end if
      write(naus,200) xa(1),xa(2),xe(1),xe(2),isicht
  200 format(' ',9x,f6.2,2x,f6.2,8x,f6.2,2x,f6.2,12x,i1)
      go to 10
      end if
      return
      end
c**********************************************************************c
      subroutine mm(prj,a,c)
      real prj(3,3),a(3,3),c(3,3),d(3,3)
      do 80 i=1,3
      do 70 j=1,3
      d(i,j)=0.0
      do 60 k=1,3
      d(i,j)=d(i,j)+prj(i,k)*a(k,j)
   60 continue
   70 continue
   80 continue
      do 100 i=1,3
      do  90 j=1,3
      c(i,j)=d(i,j)
   90 continue
  100 continue
      return
      end
c**********************************************************************c
      subroutine vm(a,b,c)
      real a(3),b(3,3),c(3),h(3)
      do 20 i=1,3
      h(i)=0.0
      do 10 j=1,3
      h(i)=h(i)+a(j)*b(j,i)
   10 continue
   20 continue
      do 30 i=1,3
      c(i)=h(i)
   30 continue
      return
      end
c**********************************************************************c
      subroutine mv(a,b,c)
      real a(3,3),b(3),c(3),d(3)
      do 20 i=1,3
      d(i)=0.0
      do 10 j=1,3
      d(i)=d(i)+a(i,j)*b(j)
   10 continue
   20 continue
      do 30 i=1,3
      c(i)=d(i)
   30 continue
      return
      end
c**********************************************************************c
      subroutine vfrei(n)
      parameter (nmem=20000)
c     common /frei/ ifrei,ispv(10,1000)
      common /frei/ ifrei,ispv(10,nmem)
c     do 10 i=n,999
      do 10 i=n,nmem-1
      ispv(10,i)=i+1
   10 continue
      ifrei=n
c     ispv(10,1000)=0
      ispv(10,nmem)=0
      return
      end
c**********************************************************************c
      subroutine ffrei(ix)
      parameter (nmem=20000)
c     common /frei/ ifrei,ispv(10,1000)
      common /frei/ ifrei,ispv(10,nmem)
      if(ifrei) 10,10,20
   10 stop 011
   20 ix=ifrei
      ifrei=ispv(10,ifrei)
      return
      end
c**********************************************************************c
      subroutine rfrei(ix)
      parameter (nmem=20000)
c     common /frei/ ifrei,ispv(10,1000)
      common /frei/ ifrei,ispv(10,nmem)
      ispv(10,ix)=ifrei
      ifrei=ix
      return
      end
c**********************************************************************c
      subroutine leinf(k,i)
      parameter (nmem=20000)
c     common /frei/ ifrei,isp(10,1000)
      common /frei/ ifrei,isp(10,nmem)
      j=isp(1,k)
      isp(10,j)=i
      isp(1,i)=j
      isp(10,i)=k
      isp(1,k)=i
      if(isp(9,k).eq.k) isp(9,k)=i
      if(isp(3,k).eq.k) isp(3,k)=i
      return
      end
c**********************************************************************c
      subroutine gibne(k,i,ind)
      parameter (nmem=20000)
c     common /frei/ ifrei,isp(10,1000)
      common /frei/ ifrei,isp(10,nmem)
      j=isp(9,k)
      if(j-k) 20,10,20
   10 ind=1
      if(isp(1,k)-k) 21,11,21
   11 ind=-1
      go to 30
   20 ind=0
      i=j
   21 isp(9,k)=isp(10,j)
   30 return
      end
c**********************************************************************c
      subroutine gibne2(k,i,ind)
      parameter (nmem=20000)
c     common /frei/ ifrei,isp(10,1000)
      common /frei/ ifrei,isp(10,nmem)
      j=isp(3,k)
      if(j-k) 20,10,20
   10 ind=1
      if(isp(1,k)-k) 21,11,21
   11 ind=-1
      go to 30
   20 ind=0
      i=j
   21 isp(3,k)=isp(10,j)
   30 return
      end
c**********************************************************************c
      subroutine zzgl(k)
      parameter (nmem=20000)
c     common /frei/ ifrei,isp(10,1000)
      common /frei/ ifrei,isp(10,nmem)
      isp(3,k)=isp( 9,k)
      return
      end
c**********************************************************************c
      subroutine zzgr(k)
      parameter (nmem=20000)
c     common /frei/ ifrei,isp(10,1000)
      common /frei/ ifrei,isp(10,nmem)
      isp(9,k)=isp(10,k)
      return
      end
c**********************************************************************c
      subroutine zzgr2(k)
      parameter (nmem=20000)
c     common /frei/ ifrei,isp(10,1000)
      common /frei/ ifrei,isp(10,nmem)
      isp(3,k)=isp(10,k)
      return
      end
c**********************************************************************c
      subroutine lsche(k,i)
      parameter (nmem=20000)
c     common /frei/ ifrei,isp(10,1000)
      common /frei/ ifrei,isp(10,nmem)
      if(i.eq.k) stop 021
      if(isp(1,k).eq.k) stop 022
      in=isp(10,k)
   21 if(in.ne.k) then
      if(in.eq.i) go to 30
      in=isp(10,in)
      go to 21
      else
      stop 023
      end if
   30 if(isp(9,k).eq.i) isp(9,k)=isp(10,i)
      if(isp(3,k).eq.i) isp(3,k)=isp(10,i)
      isp(10,isp( 1,i))=isp(10,i)
      isp( 1,isp(10,i))=isp( 1,i)
      return
      end
c**********************************************************************c
      subroutine lzfrei(k)
      parameter (nmem=20000)
c     common /frei/ ifrei,isp(10,1000)
      common /frei/ ifrei,isp(10,nmem)
      if(isp(1,k).ne.k) then
      isp(10,isp(1,k))=ifrei
      ifrei=isp(10,k)
      isp(1,k)=k
      isp(8,k)=k
      isp(9,k)=k
      isp(10,k)=k
      end if
      return
      end
c**********************************************************************c
      subroutine lkreii(l)
      parameter (nmem=20000)
c     common /frei/ ifrei,isp(10,1000)
      common /frei/ ifrei,isp(10,nmem)
c     real rsp(10,1000)
      real rsp(10,nmem)
      equivalence (isp(1,1),rsp(1,1))
      call ffrei(l)
      isp(1,l)=l
      rsp(2,l)=9e+70
      isp(8,l)=l
      isp(9,l)=l
      isp(10,l)=l
      return
      end
c**********************************************************************c
      subroutine zfzl(k,l)
      parameter (nmem=20000)
c     common /frei/ ifrei,isp(10,1000)
      common /frei/ ifrei,isp(10,nmem)
      if(isp(1,k).ne.k) then
      isp(10,isp(1,k))=isp(10,isp(1,l))
      isp(10,isp(1,l))=isp(10,k)
      isp(1,isp(10,k))=isp(1,l)
      isp(1,l)        =isp(1,k)
      isp(1,k)        =k
      isp(10,k)       =k
      isp(9,k)        =k
      end if
      isp(9,l)        =isp(10,l)
      return
      end
c**********************************************************************c
      subroutine lverni(l)
      parameter (nmem=20000)
c     common /frei/ ifrei,i(10,1000)
      common /frei/ ifrei,i(10,nmem)
      call lzfrei(l)
      call rfrei(l)
      l=0
      return
      end
c**********************************************************************c
      subroutine kopie(k1,k2,l1,l2)
      parameter (nmem=20000)
c     common /frei/ ifrei,isp(10,1000)
      common /frei/ ifrei,isp(10,nmem)
c     integer*2 hsp(20,1000)
      integer*2 hsp(20,nmem)
      equivalence (isp(1,1),hsp(1,1))
      call zzgr(l1)
   10 call gibne(l1,i,ind)
      if(ind.eq.0) then
       call ffrei(j)
       do 20 m=2,9
       isp(m,j)=isp(m,i)
   20  continue
       hsp(17,i)=j
       call leinf(l2,j)
       go to 10
      end if
      call zzgr(k1)
   30 call gibne(k1,i,ind)
      if(ind.eq.0) then
       call ffrei(j)
       do 40 m=2,7
       isp(m,j)=isp(m,i)
   40  continue
       isp(8,j)=int(hsp(17,isp(8,i)))
       isp(9,j)=int(hsp(17,isp(9,i)))
       call leinf(k2,j)
       go to 30
      end if
      call zzgr(l1)
   50 call gibne(l1,i,ind)
      if(ind.eq.0) then
       isp(9,i)=int(hsp(18,i))
       go to 50
      end if
      return
      end
c**********************************************************************c
      subroutine ekopie(l,j,k)
      parameter (nmem=20000)
c     common /frei/ ifrei,r(10,1000)
      common /frei/ ifrei,r(10,nmem)
      call ffrei(k)
      do 10 m=2,9
      r(m,k)=r(m,j)
   10 continue
      call leinf(l,k)
      return
      end

      subroutine quit(str)
      character*(*) str
      write(6,*) str
      stop
      end
