c
c     draw polyhedrawith triangle planes by saveing them with the use of
c     call savetri(rx,ry,rz,nrm,dstd,kcl,npln) 
c     then you can use drwphd package for drawing
c
c
      subroutine drwdom()  ! drow occupation domains
      common /cnpln/ npln
      real shiftx,shifty
      common /cdevi/ ldev,linw,klin,jcol,inum
      common /cdevr/ shiftx,shifty
      real rgb(3)
      call plot(shiftx,shifty,-3)
      call newpen(2)
      call setend(0)
c     draw occupation domains

      if(npln.eq.0) call quit('npln=0')
      call getimd(imode)
      if(imode.eq.0) then
        call rmvtri(npln)         ! remove same triangles if any
        call drwrhm(npln)         ! draw shaded domain
      else
         call drwrhm1(npln)       ! draw wireframe and create xyz_file
         call wrwrlf(npln)        ! create wrl file
      end if
      write(6,*) 'npln=',npln
      return
      end

      subroutine rmvtri(npln)
      include 'impr8.inc'
c     remove same triangles if any
      include 'drw.inc'
      real eps0
      common /ceps0/ eps0

      integer iskip(memax)
      integer nszd(memax)
      integer st(memax*2)
      real tmind(memax)

c     initialize
      do i=1,npln
         iskip(i)=0
         tmind(i)=zmin(i)
      end do

      call qsort(tmin,st,nszd,npln)

      do id=1,npln-1
         i=nszd(id)
         if(iskip(i).eq.0) then
            do jd=id+1,npln
               j=nszd(jd)
               if(zmin(j).gt.zmin(i)+eps0*2) go to 250
               if(ismtri(i,j).eq.1) then ! i and j are the same triangle
                  iskip(j)=1
               end if
            end do
         end if
 250     continue
      end do
      call fpack(iskip,npln)
      write(6,*) 'npln=',npln
      return
      end

      subroutine drwrhm1(npln)
c     write wireframe
      include 'impr8.inc'
      include 'drw.inc'

      common /ctmin/ nsz(memax)
      integer nszd(memax),nsze(memax)
      real eps0
      common /ceps0/ eps0
      common /ctst/ itst, nmax, iout

      integer ipr(memax)
      integer st(memax*2)
      real e1xe2(3),e2e1(3),e3e2(3)

      do i=1,npln
         call wirefr(i)      ! draw edge of the i-th triangle
      end do
      return
      end

      subroutine wirefr(i)   ! draw edge of the i-th triangle
      real shiftx,shifty
c      common /cdev/ ldev,shiftx,shifty,linw,klin,jcol
      common /cdevi/ ldev,linw,klin,jcol,inum
      common /cdevr/ shiftx,shifty
      include 'drw.inc'
      real xlin(5),ylin(5)

      xlin(1)=edge1(1,i)
      ylin(1)=edge1(2,i)
      xlin(2)=edge2(1,i)
      ylin(2)=edge2(2,i)
      xlin(3)=edge3(1,i)
      ylin(3)=edge3(2,i)
      xlin(4)=0
      ylin(4)=0
      xlin(5)=1
      ylin(5)=1

      call fillarea(0)
      call newpen(2)
      if(ldev.eq.2) then     ! color mode
         call fillcolor(10)
c        call fillcolor(0)
      else                   ! B&W mode
         call fillcolor(0)
      end if
      call plot(xlin(1),ylin(1),3)
      if(indx1(i).eq.0) then
         call plot(xlin(2),ylin(2),2)
      else
         call plot(xlin(2),ylin(2),3) 
      end if
      call plot(xlin(2),ylin(2),3)
      if(indx2(i).eq.0) then
         call plot(xlin(3),ylin(3),2)
      else
         call plot(xlin(3),ylin(3),3)
      end if
      call plot(xlin(3),ylin(3),3)
      if(indx3(i).eq.0) then
         call plot(xlin(1),ylin(1),2)
      else
         call plot(xlin(1),ylin(1),3)
      end if
      return
      end

c
c    there are three versions for drwrhm : drwrhm, drwrhmo, drwrhm0
c                    (using ispps isppso ispps0)
c    but drwrhm (ispps) seems to be most stable
c
      subroutine drwrhm(npln)   ! use this in the current version
      include 'impr8.inc'
      include 'drw.inc'

      common /ctmin/ nsz(memax)
      integer nszd(memax),nsze(memax)

      real eps0
      common /ceps0/ eps0
      common /ctst/ itst, nmax, iout

      integer ipr(memax)
      integer st(memax*2)

c     initialize
      do id=1,npln
         ipr(id)=0
         tmin(id)=zmin(id)
      end do
      call qsort(tmin,st,nsz,npln)
      is=1
      nerr=0

c     take an average if several points are within a specified small range
      call averg(npln)
c     remove common edge in the same plane
      call rmvedg(npln) ! remove common edge in the same plane

c       Newell-Newell-Snacha algolithm for drawing polygon      

 312  continue
      i=nsz(is)
c     write(6,*) 'is,npln=',is,npln
      do jd=is+1,npln
         j=nsz(jd)

c        this does not work if a triangle is divided into two peaces ?

         if(zmax(i).lt.zmin(j)-eps0) then
c           i-th plane does not hide j-th plane
            go to 310
         end if
         
         if(ibbox(i,j).eq.0) then
c           bounding boxes do not overlap
c           therefore i-th plane does not hide j-th plane
            go to 310
         end if

c          idepth(i,j,iw) gives
c          0 if i-th plane is on j-th plane
c          1 if i-th plane is behind j-th plane
c          2 if i-th plane is before j-th plane
c         -1 else
         
         iw=0
         idpth1=idepth(i,j,iw)
c        idpth1=idepth0(i,j,iw)
         if(idpth1.eq.1.or.idpth1.eq.0) then
c           i behind j
            go to 310   ! i does not hide j
         end if

         idpth2=idepth(j,i,iw)
c        idpth2=idepth0(j,i,iw)
         if(idpth2.eq.2) then
c           j before i 
            go to 310   ! i does not hide j
         end if
         
c        idpth=-1
c        function ispps(i,j) gives
c         1 if i hides j
c         0 else

         if(ispps(i,j).eq.0) then
            go to 310  ! i does not cross j
         end if         

c     i-th triangle hides j-th one
c     
         if(ipr(j).eq.0) then 
c           interchange i and j (interchange P and Q)
            nsz(is)=j
            nsz(jd)=i
c           set mark
c            ipr(j)=1 
            ipr(i)=1 
            go to 312
         end if
         
c     ipr(j)=1  previously interchanged
c     i-th plane partly hides j-th plane
c     divide i and j-th triangle into two or three parts

         jdivide=idivide(i,j,is,npln,0) ! divide i-th triangle if possible
         if(jdivide.ne.0) then  ! i divided
                                ! nplane increased                           
            do id=is,npln    
               ipr(nsz(id))=0      ! reset mark
            end do 
            go to 312
         end if 

 310     continue
      end do

c     draw i-th triangle
      if(itst.eq.0) then  
        call trangl0(i)    
      else
c        call tranglt(i)    
        call trangl0(i)    
      end if              
      is=is+1
      
c     reset mark
      do id=is,npln
         ipr(nsz(id))=0
      end do 
      
      if(is.le.npln) then
         go to 312
      end if
      return
      end

      subroutine drwrhmo(npln)
      include 'impr8.inc'
      include 'drw.inc'

      common /ctmin/ nsz(memax)
      integer nszd(memax),nsze(memax)

      real eps0
      common /ceps0/ eps0
      common /ctst/ itst, nmax, iout

      integer ipr(memax)
      integer st(memax*2)

c     initialize
      do id=1,npln
         ipr(id)=0
         tmin(id)=zmin(id)
      end do
      call qsort(tmin,st,nsz,npln)
      is=1
      nerr=0

c     take an average if several points are within a specified small range
      call averg(npln)
c     remove common edge in the same plan
      call rmvedg(npln)
c     Newell-Newell-Snacha algolithm for drawing polygon      

 312  continue
      i=nsz(is)
      do 310 jd=is+1,npln
         j=nsz(jd)
         
         if(zmax(i).lt.zmin(j)) then
c           i-th plane does not hide j-th plane
            go to 310
         end if
         
         if(ibbox(i,j).eq.0) then
c           bounding boxes do not overlap
c           therefore i-th plane does not hide j-th plane
            go to 310
         end if

c          idepth(i,j,iw) gives
c          0 if i-th plane is on j-th plane
c          1 if i-th plane is behind j-th plane
c          2 if i-th plane is before j-th plane
c         -1 else
         
         iw=0
         idpth1=idepth(i,j,iw)
c        idpth1=idepth0(i,j,iw)
         if(idpth1.eq.1.or.idpth1.eq.0) then
c           i behind j
            go to 310   ! i does not hide j
         end if

         idpth2=idepth(j,i,iw)
c        idpth2=idepth0(j,i,iw)
         if(idpth2.eq.2) then
c           j before i 
            go to 310   ! i does not hide j
         end if
         
c        idpth=-1
c        function ispps(i,j) gives
c         1 if i hides j
c         0 else

         if(isppso(i,j).eq.0) then
            go to 310  ! i does not cross j
         end if         

c     i-th triangle hides j-th one
c     
         if(ipr(j).eq.0) then 
c           interchange i and j (interchange P and Q)
            nsz(is)=j
            nsz(jd)=i
c           set mark
c            ipr(j)=1 
            ipr(i)=1 
            go to 312
         end if
         
c     ipr(j)=1  previously interchanged
c     i-th plane partly hides j-th plane
c     divide i and j-th triangle into two or three parts

         jdivide=idivide(i,j,is,npln,0) ! divide i-th triangle if possible
         if(jdivide.ne.0) then  ! i divided
                                ! nplane increased                           
c           reset mark
            do id=is,npln
               ipr(nsz(id))=0
            end do 
            go to 312 
         end if
 310  continue
c     draw i-th triangle
      if(itst.eq.0) then  
        call trangl0(i)    
      else
c        call tranglt(i)    
        call trangl0(i)    
      end if              
      is=is+1
      
c     reset mark
      do id=is,npln
         ipr(nsz(id))=0
      end do 
      
      if(is.le.npln) then
         go to 312
      end if
      return
      end

      subroutine drwrhm0(npln)
      include 'impr8.inc'
      include 'drw.inc'

      common /ctmin/ nsz(memax)
      integer nszd(memax),nsze(memax)

      real eps0
      common /ceps0/ eps0
      common /ctst/ itst, nmax, iout

      integer ipr(memax)
      integer st(memax*2)

c     initialize
      do id=1,npln
         ipr(id)=0
         tmin(id)=zmin(id)
      end do
      call qsort(tmin,st,nsz,npln)
      is=1
      nerr=0

c     take an average if several points are within a specified small range
      call averg(npln)
c     remove common edge in a plane
      call rmvedg(npln)

c       Newell-Newell-Snacha algolithm for drawing polygon      

 312  continue
      i=nsz(is)

      do jd=is+1,npln
         j=nsz(jd)
         
         if(zmax(i).lt.zmin(j)) then
c           i-th plane does not hide j-th plane
            go to 310
         end if
         
         if(ibbox(i,j).eq.0) then
c           bounding boxes do not overlap
c           therefore i-th plane does not hide j-th plane
            go to 310
         end if

c          idepth(i,j,iw) gives
c          0 if i-th plane is on j-th plane
c          1 if i-th plane is behind j-th plane
c          2 if i-th plane is before j-th plane
c         -1 else
         
         iw=0
         idpth1=idepth(i,j,iw)
c        idpth1=idepth0(i,j,iw)
         if(idpth1.eq.1.or.idpth1.eq.0) then
c           i behind j
            go to 310   ! i does not hide j
         end if

         idpth2=idepth(j,i,iw)
c        idpth2=idepth0(j,i,iw)
         if(idpth2.eq.2) then
c           j before i 
            go to 310   ! i does not hide j
         end if
         
c        idpth=-1
c        function ispps(i,j) gives
c         1 if i hides j
c         0 else

         if(ispps0(i,j).eq.0) then
            go to 310  ! i does not cross j
         end if         

c     i-th triangle hides j-th one
c     
         if(ipr(j).eq.0) then 
c           interchange i and j (interchange P and Q)
            nsz(is)=j
            nsz(jd)=i
c           set mark
c            ipr(j)=1 
            ipr(i)=1 
            go to 312
         end if
         
c     ipr(j)=1  previously interchanged
c     i-th plane partly hides j-th plane
c     divide i and j-th triangle into two or three parts

         jdivide=idivide(i,j,is,npln,0) ! divide i-th triangle if possible
         if(jdivide.eq.0) go to 310     ! i not divided
             ! nplane increased                           
c        reset mark
         do id=is,npln
            ipr(nsz(id))=0
         end do 
         go to 312 

 310     continue
      end do
c     draw i-th triangle
      if(itst.eq.0) then  
        call trangl0(i)    
      else
c        call tranglt(i)    
        call trangl0(i)    
      end if              
      is=is+1
      
c     reset mark
      do id=is,npln
         ipr(nsz(id))=0
      end do 
      
      if(is.le.npln) then
         go to 312
      end if
      return
      end

      subroutine averg(npln)
      include 'impr8.inc'
c     take an average of vectors within a distance eps0
      include 'drw.inc'
      real eps0
      common /ceps0/ eps0

      integer nsz(memax*3),st(memax*6)
      real rx1(memax*3),rx2(memax*3),rx3(memax*3),tmp(memax*3)
      real avr1,avr2,avr3,dst
      integer isk(memax*3),imm(memax*3)

      do i=1,npln
         rx1(i)=edge1(1,i)
         rx2(i)=edge1(2,i)
         rx3(i)=edge1(3,i)
         rx1(i+npln)=edge1(4,i)
         rx2(i+npln)=edge1(5,i)
         rx3(i+npln)=edge1(6,i)
         rx1(i+npln*2)=edge2(4,i)
         rx2(i+npln*2)=edge2(5,i)
         rx3(i+npln*2)=edge2(6,i)
      end do
      do i=1,npln*3
         tmp(i)=rx3(i)
         isk(i)=0
      end do
      call qsort(tmp,st,nsz,npln*3)

      is=1
 200  continue
      nc=1
      do ii=is,npln*3-1
         i=nsz(ii)
         j=nsz(ii+1)
         if(abs(rx3(j)-rx3(i)) .gt. eps0) go to 100
         nc=nc+1
      end do
 100  continue
c      write(6,*) 'nc',nc
c      ie=is+nc-1
c      do ii=is,ie
c         i=nsz(ii)
c         write(6,*) rx1(i),rx2(i),rx3(i)
c      end do

 150  continue
      ie=is+nc-1
      do ii=is,ie
         i=nsz(ii)
         if(isk(i).eq.0) then
            ic=1
            imm(ic)=i
            avr1=rx1(i)
            avr2=rx2(i)
            avr3=rx3(i)
            do jj=ii+1,is+nc-1
               j=nsz(jj)
               if(isk(j).eq.0) then
                  dst=sqrt(sqrt((rx1(i)-rx1(j))**2+(rx2(i)-rx2(j))**2+
     *                 (rx3(i)-rx3(j))**2))
                  if(dst.lt.eps0) then
                     ic=ic+1
                     imm(ic)=j
                     avr1=avr1+rx1(j)
                     avr2=avr2+rx2(j)
                     avr3=avr3+rx3(j)
                  end if
               end if
            end do
            avr1=avr1/ic
            avr2=avr2/ic
            avr3=avr3/ic
            do jj=1,ic
               j=imm(jj)
               if(abs(rx1(j)-avr1).gt.eps0)  write(6,*) 'wrong avr1',
     *               abs(rx1(j)-avr1),' dev1 > eps0, eps0=',eps0
               if(abs(rx2(j)-avr2).gt.eps0)  write(6,*) 'wrong avr2',
     *               abs(rx2(j)-avr2),' dev2 > eps0, eps0=',eps0
               if(abs(rx3(j)-avr3).gt.eps0)  write(6,*) 'wrong avr3',
     *               abs(rx3(j)-avr3),' dev3 > eps0, eps0=',eps0
               rx1(j)=avr1
               rx2(j)=avr2
               rx3(j)=avr3
               isk(j)=1
            end do
c            write(6,*) 'ic,avr1,avr2,avr3',ic,avr1,avr2,avr3
         end if
      end do
      do ii=1,npln*3
         i=nsz(ii)
         if(isk(i).eq.0) then
            is=ii
            go to 200
         end if
      end do
      do i=1,npln
         edge1(1,i)=rx1(i)
         edge1(2,i)=rx2(i)
         edge1(3,i)=rx3(i)
         edge1(4,i)=rx1(i+npln)
         edge1(5,i)=rx2(i+npln)
         edge1(6,i)=rx3(i+npln)

         edge2(1,i)=rx1(i+npln)
         edge2(2,i)=rx2(i+npln)
         edge2(3,i)=rx3(i+npln)
         edge2(4,i)=rx1(i+npln*2)
         edge2(5,i)=rx2(i+npln*2)
         edge2(6,i)=rx3(i+npln*2)

         edge3(1,i)=rx1(i+npln*2)
         edge3(2,i)=rx2(i+npln*2)
         edge3(3,i)=rx3(i+npln*2)
         edge3(4,i)=rx1(i)
         edge3(5,i)=rx2(i)
         edge3(6,i)=rx3(i)
      end do
      return
      end

      subroutine rmvedg(npln)
      include 'impr8.inc'
c     remove common edge in a plane
      include 'drw.inc'

      common /ctmin/ nsz(memax)
      integer nszd(memax),nsze(memax)
      real eps0
      common /ceps0/ eps0
      common /ctst/ itst, nmax, iout
      integer ipr(memax)
      integer st(memax*2)
      real eps1
      real nrmld(3)

      if(npln.gt.memax) then
         write(6,*) 'npln, memax in rmvedg=',npln,memax
         call quit('npln > memax')
      end if
      eps1=eps0*1.5

      do i=1,npln
         indx1(i)=0
         indx2(i)=0
         indx3(i)=0
      end do
      do id=1,npln-1
         i=nsz(id)
         do jd=id+1,npln
            j=nsz(jd)
            if(zmin(j).gt.zmax(i)+eps1) go to 250
            if(abs(dstn(i)-dstn(j)).lt.eps1) then
               call vsub(nrml(1,i),nrml(1,j),nrmld,3)
               if(vabs(nrmld,3).lt.eps1) then
c     i-th plane and j-th plane are on a common plane
c     remove common edge on a plane if any
                  call rmvedg0(edge1,edge2,edge3,indx1,indx2,indx3,i,j)
               end if
            end if
         end do
 250     continue
      end do
      return
      end

      integer function idivide(i,j,is,npln,iw)
      include 'impr8.inc'
c     i-th and j-th plane intersect to each other
c     idivide=1  divide i-th triangle into two triangles
c     idivide=2  divide i-th triangle into three triangles
c     idivide=0  does not divide i-th triangle
      include 'drw.inc'
      common /ctmin/ nsz(memax)
      real eps0
      common /ceps0/ eps0

      integer mp(3)
      real tp(3)
      real rx(3),ry(3),rz(3)
      real e12(3),e23(3),e31(3),xx(3)
      real e1(3),e2(3),e3(3),nrm(3)
      real ex1(3),ex2(3),ex3(3),dst
      real t
      integer getindx

c     intersection of i-th and j-th plane      
c***************************************************
c     cross point of edge of i-triangle on the j-plane      
c***************************************************
      call vcpyr(edge1(1,i),e1,3)
      call vcpyr(edge2(1,i),e2,3)
      call vcpyr(edge3(1,i),e3,3)
      call vcpyr(nrml(1,i),nrm,3)
      ind1=indx1(i)
      ind2=indx2(i)
      ind3=indx3(i)
      dst=dstn(i)
      kcl=kcol(i)
      call vsub(e1,e2,e12,3)
      call vsub(e2,e3,e23,3)
      call vsub(e3,e1,e31,3)

      np=0
      do k=1,3
         mp(k)=0
         tp(k)=0
      end do

      if(ixpos(e2,e12,xx,t,j).eq.1) then
         np=np+1
         mp(np)=1
         tp(np)=t
         call vcpyr(xx,ex1,3)
      end if

      if(ixpos(e3,e23,xx,t,j).eq.1) then
         np=np+1
         mp(np)=2
         tp(np)=t
         call vcpyr(xx,ex2,3)
      end if

      if(ixpos(e1,e31,xx,t,j).eq.1) then
         np=np+1
         mp(np)=3
         tp(np)=t
         call vcpyr(xx,ex3,3)
      end if

c     iwe=1    !  divided line is not written
      if(np.eq.0.or.np.eq.3) then
c     write(6,*) 'np=',np,' i=',i,' j=',j
      end if

      if(np.eq.0) then
         idivide=0              ! do not divide         
      else if(np.eq.1) then
         idivide=1     !  npln=npln+1
c        divide i-th triangle into two
         if(mp(1).eq.1) then
            call save1tri(e1,e2,e3,nrm,dst,kcl,ind1,ind2,ind3,ex1,i,
     *           j,is,npln)
         else if(mp(1).eq.2) then
            call save1tri(e2,e3,e1,nrm,dst,kcl,ind2,ind3,ind1,ex2,i,
     *           j,is,npln)
         else if(mp(1).eq.3) then
            call save1tri(e3,e1,e2,nrm,dst,kcl,ind3,ind1,ind2,ex3,i,
     *           j,is,npln)
         end if
      else if(np.eq.2) then
c        divide i-th triangle into three
         idivide=2   ! npln=npln+2
         if(mp(1).eq.1.and.mp(2).eq.2) then
            call save2tri(e1,e2,e3,nrm,dst,kcl,ind1,ind2,ind3,ex1,
     *           ex2,i,j,is,npln)
         else if(mp(1).eq.2.and.mp(2).eq.3) then
            call save2tri(e2,e3,e1,nrm,dst,kcl,ind2,ind3,ind1,ex2,
     *           ex3,i,j,is,npln)
         else if(mp(1).eq.1.and.mp(2).eq.3) then
            call save2tri(e3,e1,e2,nrm,dst,kcl,ind3,ind1,ind2,ex3,
     *           ex1,i,j,is,npln)
         end if            
      end if
      return
      end

      integer function getindx(e1,e2,i,j)
      real e1(*),e2(*)
      integer getindx0,getindx1
      getindx=getindx1(e1,e2,i,j) ! edge e1-e2 is not written
c     getindx=getindx0(e1,e2,i,j) ! edge e1-e2 is written
      return
      end

      integer function getindx1(e1,e2,i,j)
      real e1(*),e2(*)
      getindx1=1     ! edge e1-e2 is not written
      return
      end

      integer function getindx0(e1,e2,i,j)
c     if devided line is written 1 else 0
      include 'impr8.inc'
      real e1(*),e2(*)
      real cnt(3),d1(3),d2(3)
      real n1(3),n2(3),n3(3),d(3)
      include 'drw.inc'
      real eps0
      common /ceps0/ eps0
      real vinp

c     get normal to the edges from the other corner of the triangle
      call ni2(edge1(1,j),edge2(1,j),edge3(1,j),n1,n2,n3)

      do k=1,3
         cnt(k)=(edge1(k,j)+edge2(k,j)+edge3(k,j))/3
      end do
      d(1)=vinp(n1,edge1(1,j),2)-eps0
      d(2)=vinp(n2,edge2(1,j),2)-eps0
      d(3)=vinp(n3,edge3(1,j),2)-eps0

      d1(1)=e1(1)-cnt(1)
      d1(2)=e1(2)-cnt(2)
      d2(1)=e2(1)-cnt(1)
      d2(2)=e2(2)-cnt(2)
      if(vinp(d1,n1,2).ge.d(1).and.vinp(d1,n2,2).ge.d(2).and.
     *     vinp(d1,n3,2).ge.d(3)) then
         if(vinp(d2,n1,2).ge.d(1).and.vinp(d2,n2,2).ge.d(2).and.
     *        vinp(d2,n3,2).ge.d(3)) then
            getindx0=0    ! edge e1-e2 is written
c     return
         end if
      end if
      if(getindx0.eq.0.and.vinp(nrml(1,i),nrml(1,j),3).gt.1-eps0) then
         getindx0=1              ! edge e1-e2 is not written
      else
         getindx0=0              ! edge e1-e2 is written
      end if
      return
      end

      subroutine saveindx(i1,i2,i3,i)
      include 'drw.inc'

      indx1(i)=i1
      indx2(i)=i2
      indx3(i)=i3
      return
      end
      
      subroutine savetri(rx,ry,rz,nrm,dst,kcl,i)
c
c     rx,ry,rz : x,y,z coordinates of three corners of a triangle
c     nrm      : outward normal to it
c     d        : distance to the triangle
c     kcl      : color table number
c     i        : index for the triangle
c
      include 'impr8.inc'
      real  rx(3),ry(3),rz(3),nrm(3),dst
      include 'drw.inc'
      common /ctmin/ nsz(memax)

      if(i.gt.memax) then
         write(6,*) 'npln,memax',i,memax
         call quit('npln > memax')
      end if
      xmin(i)=min(rx(1),rx(2),rx(3))
      ymin(i)=min(ry(1),ry(2),ry(3))
      zmin(i)=min(rz(1),rz(2),rz(3))

      xmax(i)=max(rx(1),rx(2),rx(3))
      ymax(i)=max(ry(1),ry(2),ry(3))
      zmax(i)=max(rz(1),rz(2),rz(3))

      tmin(i)=zmin(i)

      edge1(1,i)=rx(1)
      edge1(2,i)=ry(1)
      edge1(3,i)=rz(1)
      edge1(4,i)=rx(2)
      edge1(5,i)=ry(2)
      edge1(6,i)=rz(2)

      edge2(1,i)=rx(2)
      edge2(2,i)=ry(2)
      edge2(3,i)=rz(2)
      edge2(4,i)=rx(3)
      edge2(5,i)=ry(3)
      edge2(6,i)=rz(3)

      edge3(1,i)=rx(3)
      edge3(2,i)=ry(3)
      edge3(3,i)=rz(3)
      edge3(4,i)=rx(1)
      edge3(5,i)=ry(1)
      edge3(6,i)=rz(1)

      nrml(1,i)=nrm(1)
      nrml(2,i)=nrm(2)
      nrml(3,i)=nrm(3)
      dstn(i)=dst
      kcol(i)=kcl
      return
      end

      subroutine save1tri(e1,e2,e3,nrm,dst,kcl,ind1,ind2,ind3,ex1,
     *     i,j,is,npln)
      include 'impr8.inc'
      real e1(*),e2(*),e3(*),nrm(*),ex1(*),dst

      include 'drw.inc'
      common /ctmin/ nsz(memax)
      real rx(3),ry(3),rz(3)      
      integer getindx

      call getrxyz(e2,e3,ex1,rx,ry,rz)            
      call savetri(rx,ry,rz,nrm,dst,kcl,i)
      iwe=getindx(e3,ex1,i,j)   ! if devided line is written 1 else 0
      call saveindx(ind2,iwe,ind1,i)
      call getrxyz(e1,e3,ex1,rx,ry,rz)
      call savetri(rx,ry,rz,nrm,dst,kcl,npln+1)
      call saveindx(ind3,iwe,ind1,npln+1)
      call repnsz1(nsz,is,npln)
      return
      end

      subroutine save2tri(e1,e2,e3,nrm,dst,kcl,ind1,ind2,ind3,ex1,ex2,
     *     i,j,is,npln)
      include 'impr8.inc'
      real e1(*),e2(*),e3(*),nrm(*),ex1(*),ex2(*),dst
      include 'drw.inc'
      common /ctmin/ nsz(memax)
      integer getindx
      real rx(3),ry(3),rz(3)
      call getrxyz(e2,ex1,ex2,rx,ry,rz)
      call savetri(rx,ry,rz,nrm,dst,kcl,i)
      iwe=getindx(ex1,ex2,i,j)  ! if devided line is written 1 else 0
      call saveindx(ind1,iwe,ind2,i)
      call getrxyz(e1,ex1,e3,rx,ry,rz)
      call savetri(rx,ry,rz,nrm,dst,kcl,npln+1)
      call saveindx(ind1,1,ind3,npln+1)
      call getrxyz(e3,ex1,ex2,rx,ry,rz)
      call savetri(rx,ry,rz,nrm,dst,kcl,npln+2)
      call saveindx(1,iwe,ind2,npln+2)
      call repnsz2(nsz,is,npln)
      return
      end

      integer function ismtri(i,j)
      include 'impr8.inc'
c     if i-th and j-th triangle is the same ismtri=1 else 0
      include 'drw.inc'

      if(  ivsub0(edge1(1,i),edge1(1,j)).eq.0.and.
     *     ivsub0(edge2(1,i),edge2(1,j)).eq.0.and.
     *     ivsub0(edge3(1,i),edge3(1,j)).eq.0) then
         ismtri=1
         return
      end if

      if(  ivsub0(edge1(1,i),edge2(1,j)).eq.0.and.
     *     ivsub0(edge2(1,i),edge3(1,j)).eq.0.and.
     *     ivsub0(edge3(1,i),edge1(1,j)).eq.0) then
         ismtri=1
         return
      end if

      if(  ivsub0(edge1(1,i),edge3(1,j)).eq.0.and.
     *     ivsub0(edge2(1,i),edge1(1,j)).eq.0.and.
     *     ivsub0(edge3(1,i),edge2(1,j)).eq.0) then
         ismtri=1
         return
      end if

      if(  ivsub0(edge1(1,i),edge1(1,j)).eq.0.and.
     *     ivsub0(edge2(1,i),edge3(1,j)).eq.0.and.
     *     ivsub0(edge3(1,i),edge2(1,j)).eq.0) then
         ismtri=1
         return
      end if

      if(  ivsub0(edge1(1,i),edge2(1,j)).eq.0.and.
     *     ivsub0(edge2(1,i),edge1(1,j)).eq.0.and.
     *     ivsub0(edge3(1,i),edge3(1,j)).eq.0) then
         ismtri=1
         return
      end if

      if(  ivsub0(edge1(1,i),edge3(1,j)).eq.0.and.
     *     ivsub0(edge2(1,i),edge2(1,j)).eq.0.and.
     *     ivsub0(edge3(1,i),edge1(1,j)).eq.0) then
         ismtri=1
         return
      end if

      ismtri=0
      return
      end

      integer function ivsub0(x1,x2)
      include 'impr8.inc'
      real x1(*),x2(*)
      real eps0
      common /ceps0/ eps0
      real x12(6),dstn1,dstn2
      real eps1

      eps1=eps0*1.5
      call vsub(x1,x2,x12,6)
      dstn1=sqrt(x12(1)**2+x12(2)**2+x12(3)**2)
      dstn2=sqrt(x12(4)**2+x12(5)**2+x12(6)**2)
      if(dstn1.le.eps1.and.dstn2.le.eps1) then
         ivsub0=0
      else
         ivsub0=1
      end if
      return
      end

      subroutine wrwrlf(npln)   ! write image in .wrl file
      include 'impr8.inc'
      include 'drw.inc'
      parameter (nmax=700000)
      real x(nmax),y(nmax),z(nmax)
      integer icor(nmax),ind(nmax)
      real e1xe2(3),e2e1(3),e3e2(3)
      real rgb(3)
      integer nc
      save nc
      data nc /0/
      call getrgb(rgb)
c     write(6,*) 'rgb=',rgb
      if(nc.eq.0) then
         write(3,'(a)') '#VRML V2.0 utf8 '
         write(3,'(a)') 'WorldInfo { title "poly2vrml" } '
         write(3,'(a)') 'NavigationInfo { type "EXAMINE" } '
         write(3,'(a)')
     *        'DEF BKG Background { skyColor [ 0.0 0.0 0.5 ] } '
         nc=1
      end if
      n=0
      do i=1,npln
         call vsub(edge2(1,i),edge1(1,i),e2e1,3)
         call vsub(edge3(1,i),edge2(1,i),e3e2,3)
         call vprd(e2e1,e3e2,e1xe2)
         if(vinp(nrml(1,i),e1xe2,3).gt.0) then
            x(n+1)=edge1(1,i)
            y(n+1)=edge1(2,i)
            z(n+1)=edge1(3,i)
            x(n+2)=edge2(1,i)
            y(n+2)=edge2(2,i)
            z(n+2)=edge2(3,i)
            x(n+3)=edge3(1,i)
            y(n+3)=edge3(2,i)
            z(n+3)=edge3(3,i)
            n=n+3
         else
            x(n+1)=edge1(1,i)
            y(n+1)=edge1(2,i)
            z(n+1)=edge1(3,i)
            x(n+2)=edge3(1,i)
            y(n+2)=edge3(2,i)
            z(n+2)=edge3(3,i)
            x(n+3)=edge2(1,i)
            y(n+3)=edge2(2,i)
            z(n+3)=edge2(3,i)
            n=n+3
         end if
         if(n.gt.nmax) then
            write(6,*) 'n,nmax',n,nmax
            write(6,*) 'n > nmax'
            stop
         end if
      end do

      nvrtx=n
c     write(6,*) 'nvrtx=',nvrtx

      write(3,*) 'Transform { children [ Shape{ '
      write(3,*) 'appearance Appearance { material Material '
      write(3,*) '{ diffuseColor '
      write(3,'(3f10.5)')  rgb(1),rgb(2),rgb(3)
      write(3,*) ' specularColor'
      write(3,*) ' 1 1 1 shininess 0.9 transparency 0.0 } } '
      write(3,*) 'geometry IndexedFaceSet { coord Coordinate{ point[ '

      mode = 0
c     mode = 1

      if(mode.eq.1) then
         call indvct(x,y,z,nvrtx,nind,icor,ind)
         write(6,*) 'nind=',nind
      end if

      if(mode.eq.0) then
         do i=1,nvrtx
            write(3,'(3f10.5,a)') x(i),y(i),z(i),','
         end do
         write(3,*) ']} coordIndex[' !//VRML end
         do i=1,nvrtx,3
            i1=i -1
            i2=i
            i3=i+1
            write(3,'(3(i6,a),i3,a)') i1,',',i2,',',i3,',',-1,','
         end do
      else
         do ii=1,nind
            i=ind(ii)
            write(3,'(3f10.5,a)') x(i),y(i),z(i),','
         end do
         write(3,*) ']} coordIndex[' !//VRML end
         do i=1,nvrtx,3
            i1=icor(i)  -1
            i2=icor(i+1)-1
            i3=icor(i+2)-1
            write(3,'(3(i6,a),i3,a)') i1,',',i2,',',i3,',',-1,','
         end do
      end if
      write(3,*) '] creaseAngle 0.0 }}]}'
      return
      end

      subroutine indvct(x,y,z,n,nind,icor,ind)
      include 'impr8.inc'
c     find independent vectors
      real x(*),y(*),z(*)
      integer icor(*),ind(*)
      parameter (nmax=200000)
      integer st(2*nmax),ns(nmax),iskp(nmax)
      real t(nmax)
c      data eps /0.000001/
      data eps /0.00001/
c     icor : independent vector number
      
      call vcpyr(z,t,n)
      call qsort(t,st,ns,n)
      
      nind=0
      do id=1,n
         i=ns(id)
         if(iskp(i).eq.0) then
c     find independent vertices        
            nind=nind+1
            iskp(i)=1
            icor(i)=nind
            ind(nind)=i
         else
            go to 150
         end if
c     find vertices same as ii-th one
         do jd=id+1,n
            j=ns(jd)
            if(iskp(j).eq.0) then
               ieq=isame(x(i),y(i),z(i),x(j),y(j),z(j))
               if(ieq.eq.1) then  
                  iskp(j)=1
                  icor(j)=icor(i)
               else
                  if(t(jd)-t(id).gt.eps) then
                     go to 150
                  end if
               end if
            end if
         end do
 150     continue
      end do
      return
      end

      integer function isame(x1,y1,z1,x2,y2,z2)
      include 'impr8.inc'
c      data eps /0.000001/
      data eps /0.00001/
      d=sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)
      if(d.lt.eps) then
         isame=1
      else
         isame=0
      end if
      return
      end

      subroutine fpack(iskip,npln)
      include 'impr8.inc'
      integer iskip(*)
      include 'drw.inc'
      ic=0
      do i=1,npln
         if(iskip(i).eq.0) then
            ic=ic+1
            xmin(ic)=xmin(i)
            ymin(ic)=ymin(i)
            zmin(ic)=zmin(i)
            xmax(ic)=xmax(i)
            ymax(ic)=ymax(i)
            zmax(ic)=zmax(i)
            call vcpyr(edge1(1,i),edge1(1,ic),6)
            call vcpyr(edge2(1,i),edge2(1,ic),6)
            call vcpyr(edge3(1,i),edge3(1,ic),6)
            call vcpyr(nrml(1,i),nrml(1,ic),3)
            dstn(ic)=dstn(i)
            kcol(ic)=kcol(i)
            tmin(ic)=tmin(i)
            indx1(ic)=indx1(i)
            indx2(ic)=indx2(i)
            indx3(ic)=indx3(i)
         end if
      end do
      npln=ic
      return
      end

      subroutine repnsz1(nsz,i,npln)
      include 'impr8.inc'
      integer nsz(*)
      include 'drw.inc'
      integer nszt(memax)
      npln=npln+1
      call vcpyi(nsz,nszt,i)
      nszt(i+1)=npln
      call vcpyi(nsz(i+1),nszt(i+2),npln-i-1)
c      write(6,*) 'inserted position',i
c      write(6,'(a,(120i3))') 'nsz ',(nsz(k),k=1,npln-1)
c      write(6,'(a,(120i3))') 'nszt',(nszt(k),k=1,npln)
      call vcpyi(nszt,nsz,npln)
      return
      end

      subroutine repnsz2(nsz,i,npln)
      include 'impr8.inc'
      integer nsz(*)
      include 'drw.inc'
      integer nszt(memax)
      npln=npln+2
      call vcpyi(nsz,nszt,i)
      nszt(i+1)=npln-1
      nszt(i+2)=npln
      call vcpyi(nsz(i+1),nszt(i+3),npln-i-2)
c      write(6,*) 'inserted position',i
c      write(6,'(a,(20i5))') 'nsz ',(nsz(k),k=1,npln-2)
c      write(6,'(a,(20i5))') 'nszt',(nszt(k),k=1,npln)
      call vcpyi(nszt,nsz,npln)
      return
      end

      integer function ixpos(e2,e12,xx,t,j)
      include 'impr8.inc'
      real e2(*),e12(*),xx(*),t
      include 'drw.inc'
      common /ctmin/ nsz(memax)
      real eps0
      real vinp,dstn12,dstn2
      common /ceps0/ eps0
c     cross point of edge e12 of i-triangle on the j-plane      

      dstn12=vinp(nrml(1,j),e12,3)
      dstn2 =vinp(nrml(1,j),e2,3)
      if(abs(dstn12).le.eps0) then
c     e12 is parallel to the j-th plane and has no cross point
         ixpos=0
         return
      else
         t=(dstn(j)-dstn2)/dstn12
         if(t.ge.eps0.and.t.le.1-eps0) then
c           cross point is on the edge of triangle
c           call vadd(e2,e12*t,xx,3)
            xx(1)=e2(1)+e12(1)*t
            xx(2)=e2(2)+e12(2)*t
            xx(3)=e2(3)+e12(3)*t
            ixpos=1
            return
         else
c        cross point exists but  is out of the edge e12
            ixpos=0
            return
         end if
      end if
      end

      subroutine trangl(i)
      include 'impr8.inc'
      real shiftx,shifty
c      common /cdev/ ldev,shiftx,shifty,linw,klin,jcol
      common /cdevi/ ldev,linw,klin,jcol,inum
      common /cdevr/ shiftx,shifty

      include 'drw.inc'
      common /ctmin/ nsz(memax)

      real xlin(5),ylin(5)

      xlin(1)=edge1(1,i)
      ylin(1)=edge1(2,i)
      xlin(2)=edge2(1,i)
      ylin(2)=edge2(2,i)
      xlin(3)=edge3(1,i)
      ylin(3)=edge3(2,i)
      xlin(4)=0
      ylin(4)=0
      xlin(5)=1
      ylin(5)=1
c      write(6,*) 'xlin=',xlin
c      write(6,*) 'ylin=',ylin
      call fillarea(1)
      if(kcol(i).ne.-1) then    ! shading
c      call getshd(ishd)
c      if(ishd.eq.1) then
         lcol=igetcol(nrml(1,i),jcol,ldev)
         if(ldev.eq.1) then
            call fillcolor(lcol)
         else if(ldev.eq.2) then
            call fillcolor(lcol+10*kcol(i))
         end if
      else                      ! no shading
         if(ldev.eq.1) then
            call fillcolor(10)
         else if(ldev.eq.2) then
            call fillcolor(10)  ! white
         end if
      end if

      call plylin(xlin,ylin,3,1,0,0)
      call fillarea(0)
      call newpen(2)
      if(ldev.eq.2) then
c         call fillcolor(10)  ! white
         call fillcolor(0)  ! black
      else
         call fillcolor(0)   ! black
      end if
      call plot(xlin(2),ylin(2),2)
      call plot(xlin(3),ylin(3),2)
      call plot(xlin(1),ylin(1),2)
      return
      end

      integer function igetcol(nrml,jcol,ldev)  ! return shading color
      include 'impr8.inc'
      real nrml(*)
      if(jcol.ge.0) then
         igetcol=jcol
      else if(jcol.eq.-1) then
         if(ldev.eq.1) then
            igetcol=1+int(nrml(3)*9)
         else
            igetcol=2+int(nrml(3)*5)
         end if
      else if(jcol.eq.-2) then
         if(ldev.eq.1) then
            igetcol=1+int((nrml(1)+nrml(2)+2*nrml(3))*9/sqrt(6.))
         else
            igetcol=2+int((nrml(1)+nrml(2)+2*nrml(3))*5/sqrt(6.))
         end if
      else if(jcol.eq.-3) then
         if(ldev.eq.1) then
            igetcol=1+int((nrml(1)+nrml(2)+nrml(3))*9/sqrt(3.))
         else
            igetcol=1+int((nrml(1)+nrml(2)+nrml(3))*5/sqrt(3.))
         end if
      end if
      if((ldev.eq.1).and.igetcol.gt.9) then
         igetcol=9
      else if((ldev.eq.2).and.igetcol.gt.6) then
         igetcol=6
      else if(igetcol.lt.0) then
         igetcol=0
      end if
      return
      end

      subroutine setfillcol(i)
      include 'impr8.inc'
      real shiftx,shifty
c     common /cdev/ ldev,shiftx,shifty,linw,klin,jcol
      common /cdevi/ ldev,linw,klin,jcol,inum
      common /cdevr/ shiftx,shifty
      include 'drw.inc'

      if(kcol(i).ne.-1) then     ! shading
c      call getshd(ishd)
c      if(ishd.eq.1) then
         lcol=igetcol(nrml(1,i),jcol,ldev)
         if(ldev.eq.1) then
            call fillcolor(lcol)
         else if(ldev.eq.2) then
            call fillcolor(lcol+10*kcol(i))
         end if
      else                     ! no shading
         if(ldev.eq.1) then
            call fillcolor(10)
         else if(ldev.eq.2) then
            call fillcolor(10)  ! white
         end if
      end if
      return
      end

      subroutine tranglt(i)
      include 'impr8.inc'
      real shiftx,shifty
c      common /cdev/ ldev,shiftx,shifty,linw,klin,jcol
      common /cdevi/ ldev,linw,klin,jcol,inum
      common /cdevr/ shiftx,shifty
      include 'drw.inc'

      common /ctmin/ nsz(memax)

      real xlin(5),ylin(5)

      xlin(1)=edge1(1,i)
      ylin(1)=edge1(2,i)
      xlin(2)=edge2(1,i)
      ylin(2)=edge2(2,i)
      xlin(3)=edge3(1,i)
      ylin(3)=edge3(2,i)
      xlin(4)=0
      ylin(4)=0
      xlin(5)=1
      ylin(5)=1
      call fillarea(1)
      call setfillcol(i)
      call plylin(xlin,ylin,3,1,0,0)
      call fillarea(0)
      call newpen(2)
      if(ldev.eq.2) then
c         call fillcolor(10)
         call fillcolor(0)
      else
         call fillcolor(0)
      end if
      call plot(xlin(1),ylin(1),3)
      call plot(xlin(2),ylin(2),2)
      call plot(xlin(2),ylin(2),3)
      call plot(xlin(3),ylin(3),2)
      call plot(xlin(3),ylin(3),3)
      call plot(xlin(1),ylin(1),2)
      return
      end

      subroutine trangl0(i)
      include 'impr8.inc'
      real shiftx,shifty
c      common /cdev/ ldev,shiftx,shifty,linw,klin,jcol
      common /cdevi/ ldev,linw,klin,jcol,inum
      common /cdevr/ shiftx,shifty
      include 'drw.inc'

      real xlin(5),ylin(5)

         xlin(1)=edge1(1,i)
         ylin(1)=edge1(2,i)
         xlin(2)=edge2(1,i)
         ylin(2)=edge2(2,i)
         xlin(3)=edge3(1,i)
         ylin(3)=edge3(2,i)
         xlin(4)=0
         ylin(4)=0
         xlin(5)=1
         ylin(5)=1
         call fillarea(1)
         call setfillcol(i)
         call plylin(xlin,ylin,3,1,0,0)
         call fillarea(0)
         call newpen(2)
         if(ldev.eq.2) then
c            call fillcolor(10)
            call fillcolor(0)
         else
            call fillcolor(0)
         end if
         call plot(xlin(1),ylin(1),3)
         if(indx1(i).eq.0) then
              call plot(xlin(2),ylin(2),2)
         else
              call plot(xlin(2),ylin(2),3) 
         end if
         call plot(xlin(2),ylin(2),3)
         if(indx2(i).eq.0) then
              call plot(xlin(3),ylin(3),2)
         else
              call plot(xlin(3),ylin(3),3)
         end if
         call plot(xlin(3),ylin(3),3)
         if(indx3(i).eq.0) then
              call plot(xlin(1),ylin(1),2)
         else
              call plot(xlin(1),ylin(1),3)
         end if
      return
      end

      integer function ibbox(i,j)
      include 'impr8.inc'
c      if bounding boxes are overlapped then ibbox=1 else 0
      include 'drw.inc'
      real eps0
      common /ceps0/ eps0
      real eps2

      ibbox=0
      eps2=eps0/2
      if(xmax(j).lt.xmin(i)-eps2.or.xmin(j).gt.xmax(i)+eps2) then
          return
      end if
      if(ymax(j).lt.ymin(i)-eps2.or.ymin(j).gt.ymax(i)+eps2) then
          return
      end if
      ibbox=1
      return
      end

      integer function idepth0(i,j,iw)
      include 'impr8.inc'
      include 'drw.inc'

      real tf(3),atf(3)
      real eps0
      common /ceps0/ eps0
      real xi(3)
      real eps1
      real vinp
c     if i-th plane is on the j-th plane idepth0=0
c     if i-th plane is behind the j-th plane idepth0=1
c     if i-th plane is before the j-th plane idepth0=2
c     else idepth0=-1

      eps1=eps0*1.5

      do 10 k=1,3
          if(k.eq.1) then
             call vrcpy(edge1(1,i),xi,3)
          else if(k.eq.2) then
             call vrcpy(edge2(1,i),xi,3)
          else if(k.eq.3) then
             call vrcpy(edge3(1,i),xi,3)
          end if
c         xi : coordinates of a corner of i-th triangle
          tf(k)=dstn(j)-vinp(nrml(1,j),xi,3)
          atf(k)=abs(tf(k))
 10   continue

c        three points are on the j-th plane
      if(atf(1).lt.eps1.and.atf(2).lt.eps1.and.atf(3).lt.eps1) then
c         i-th triangle is on j-th plane
          idepth0=0
          return

c         three points are behind the j-th plane
      else if(tf(1).ge.eps1.and.tf(2).ge.eps1.and.tf(3).ge.eps1) then
c         i-th triangle is behind j-th plane
          idepth0=1
          return

c         three points are before the j-th plane
      else if(tf(1).le.-eps1.and.tf(2).le.-eps1.and.tf(3).le.-eps1) then
c         i-th triangle is before j-th plane
          idepth0=2
          return

c           two points are on the j-th plane and one behind it
      else if(atf(1).lt.eps1.and.atf(2).lt.eps1.and.tf(3).ge.eps1) then
          idepth0=1
          return
      else if(atf(2).lt.eps1.and.atf(3).lt.eps1.and.tf(1).ge.eps1) then
          idepth0=1
          return
      else if(atf(3).lt.eps1.and.atf(1).lt.eps1.and.tf(2).ge.eps1) then
          idepth0=1
          return

c           two points are on the j-th plane and one before it
      else if(atf(1).lt.eps1.and.atf(2).lt.eps1.and.tf(3).le.-eps1) then
          idepth0=2
          return
      else if(atf(2).lt.eps1.and.atf(3).lt.eps1.and.tf(1).le.-eps1) then
          idepth0=2
          return
      else if(atf(3).lt.eps1.and.atf(1).lt.eps1.and.tf(2).le.-eps1) then
          idepth0=2
          return

c           one point is on the j-th plane and two behind it
      else if(atf(1).lt.eps1.and.tf(2).ge.eps1.and.tf(3).ge.eps1) then
          idepth0=1
          return
      else if(atf(2).lt.eps1.and.tf(3).ge.eps1.and.tf(1).ge.eps1) then
          idepth0=1
          return
      else if(atf(3).lt.eps1.and.tf(1).ge.eps1.and.tf(2).ge.eps1) then
          idepth0=1
          return

c           one point is on the j-th plane and two before it
      else if(atf(1).lt.eps1.and.tf(2).le.-eps1.and.tf(3).le.-eps1) then
          idepth0=2
          return
      else if(atf(2).lt.eps1.and.tf(3).le.-eps1.and.tf(1).le.-eps1) then
          idepth0=2
          return
      else if(atf(3).lt.eps1.and.tf(1).le.-eps1.and.tf(2).le.-eps1) then
          idepth0=2
          return

      else 
         if(iw.ne.0) then
            write(6,*) 'i,j,eps1,tf=',i,j,eps1,tf
            write(6,*) 'xi,nrml=',xi,(nrml(k,j),k=1,3)
         end if
         idepth0=-1
         return
      end if
      end

      integer function idepth(i,j,iw)
      include 'impr8.inc'
      include 'drw.inc'

      real tf(3),atf(3)
      real eps0
      common /ceps0/ eps0
      real xi(3)
      real eps1
      real vinp

c     if i-th plane is on the j-th plane idepth=0
c     if i-th plane is behind the j-th plane idepth=1
c     if i-th plane is before the j-th plane idepth=2
c     else idepth=-1

      eps1=eps0*1.5
      do 10 k=1,3
          if(k.eq.1) then
             call vrcpy(edge1(1,i),xi,3)
          else if(k.eq.2) then
             call vrcpy(edge2(1,i),xi,3)
          else if(k.eq.3) then
             call vrcpy(edge3(1,i),xi,3)
          end if
c         xi : coordinates of a corner of i-th triangle
          tf(k)=dstn(j)-vinp(nrml(1,j),xi,3)
          atf(k)=abs(tf(k))
 10   continue
      if(atf(1).lt.eps1.and.atf(2).lt.eps1.and.atf(3).lt.eps1) then
         idepth=0
         return
      else if((atf(1).lt.eps1.or.tf(1).ge.eps1).and.
     *        (atf(2).lt.eps1.or.tf(2).ge.eps1).and.
     *        (atf(3).lt.eps1.or.tf(3).ge.eps1)) then
         idepth=1
         return
      else if((atf(1).lt.eps1.or.tf(1).le.-eps1).and.
     *        (atf(2).lt.eps1.or.tf(2).le.-eps1).and.
     *        (atf(3).lt.eps1.or.tf(3).le.-eps1)) then
         idepth=2
         return
      end if
      idepth=-1
      return
      end

      integer function ivsub1(x1,x2)
      include 'impr8.inc'
      real x1(*),x2(*)
      real eps0
      common /ceps0/ eps0
      real x12(2),dstn

      call vsub(x1,x2,x12,2)
      dstn=sqrt(x12(1)**2+x12(2)**2)
      if(dstn.le.eps0) then
         ivsub1=0
      else
         ivsub1=1
      end if
      return
      end

      integer function ispps(i,j)
      include 'impr8.inc'
c     if i triangle intersects j-th one ispps=1 else ispps=0
      include 'drw.inc'
      parameter (maxp=32)
      real six(3),siy(3),sjx(3),sjy(3),xpc(maxp),ypc(maxp)
c     order edges in counter-clockwise
      call getsixy(six,siy,edge1(1,i),edge2(1,i),edge3(1,i))
      call getsixy(sjx,sjy,edge1(1,j),edge2(1,j),edge3(1,j))
      ior=1
      call ovrlap2(3,six,siy,3,sjx,sjy,isec,nc,xpc,ypc,ior)
      if(isec.eq.0) then
         ispps=0
      else
         ispps=1
      end if
      return
      end

      subroutine getsixy(six,siy,edge1,edge2,edge3)
      real six(3),siy(3),edge1(6),edge2(6),edge3(6)
c     order edges in counter-clockwise
      six(1)=edge1(1)
      siy(1)=edge1(2)
      six(2)=edge2(1)
      siy(2)=edge2(2)
      six(3)=edge3(1)
      siy(3)=edge3(2)
      if(iorien2(six(1),siy(1),six(2),siy(2),six(3),siy(3)).eq.-1) then
         six(1)=edge3(1)
         siy(1)=edge3(2)
         six(2)=edge2(1)
         siy(2)=edge2(2)
         six(3)=edge1(1)
         siy(3)=edge1(2)
      end if
      return
      end

      integer function isppso(i,j)
      include 'impr8.inc'
c     if i triangle intersects j-th one isppso=1
c     else isppso=0
      include 'drw.inc'
      real eps0
      common /ceps0/ eps0
      real x1(2),x2(2),x3(2),x4(2)
      real det,t1,t2
c     based on a book by angell et al.
      do k=1,3
         if(k.eq.1) then
            call vrcpy(edge1(1,i),x1,2)
            call vsub(edge2(1,i),edge1(1,i),x2,2)
         else if(k.eq.2) then
            call vrcpy(edge2(1,i),x1,2)
            call vsub(edge3(1,i),edge2(1,i),x2,2)
         else if(k.eq.3) then
            call vrcpy(edge3(1,i),x1,2)
            call vsub(edge1(1,i),edge3(1,i),x2,2)
         end if
         ic1=0
         ic2=0
         do l=1,3
            if(l.eq.1) then
               call vrcpy(edge1(1,j),x3,2)
               call vsub(edge2(1,j),edge1(1,j),x4,2)
            else if(l.eq.2) then
               call vrcpy(edge2(1,j),x3,2)
               call vsub(edge3(1,j),edge2(1,j),x4,2)
            else if(l.eq.3) then
               call vrcpy(edge3(1,j),x3,2)
               call vsub(edge1(1,j),edge3(1,j),x4,2)
            end if
            det=x2(1)*x4(2)-x2(2)*x4(1)
            if(det.ge.eps0) then
c              two lines are not parallel and have a cross point
               t1=((x3(1)-x1(1))*x4(2)-(x3(2)-x1(2))*x4(1))/det
               t2=((x3(1)-x1(1))*x2(2)-(x3(2)-x1(2))*x2(1))/det
               if(t1.gt.-eps0.and.t1.lt.1+eps0.and.
     *            t2.gt.-eps0.and.t2.lt.1+eps0) then
c              at least a cross point is on a edges of both triangles
                  isppso=1
                  return
               end if
               if(t2.gt.-eps0.and.t2.lt.1+eps0.and.
     *                 t1.lt.-eps0) then
                  ic1=ic1+1
               else if(t2.gt.-eps0.and.t2.lt.1+eps0.and.
     *                 t1.gt.1+eps0) then
                  ic2=ic2+1               
               end if
            end if
         end do
         if(ic1.eq.1.and.ic2.eq.1) then
c           edge k is in j
            isppso=1
            write(6,*) 'ic1=ic2=1'
            return
         end if
      end do
c     no cross point of two triangles
      isppso=0
      return
      end

      integer function ispps0(i,j)
      include 'impr8.inc'
c     i and j-th planes overlap ?
      include 'drw.inc'

      real n1(2),n2(2),n3(2),cnt(3),xed(2),d(3)
      real eps0
      real vinp
      common /ceps0/ eps0
c     get outward normal
      call ni2(edge1(1,i),edge2(1,i),edge3(1,i),n1,n2,n3)

      do i=1,3
         cnt(k)=(edge1(k,j)+edge2(k,j)+edge3(k,j))/3
      end do

      do k=1,3
         if(k.eq.1) then
            xed(1)=edge1(1,j)-cnt(1)
            xed(2)=edge1(2,j)-cnt(2)
            d(1)=vinp(n1,xed,2)
         else if(k.eq.2) then
            xed(1)=edge2(1,j)-cnt(1)
            xed(2)=edge2(2,j)-cnt(2)
            d(2)=vinp(n1,xed,2)
         else if(k.eq.3) then
            xed(1)=edge3(1,j)-cnt(1)
            xed(2)=edge3(2,j)-cnt(2)
            d(3)=vinp(n1,xed,2)
         end if
         
         if(vinp(n1,xed,2).lt.d(1).and.
     *        vinp(n2,xed,2).lt.d(2).and.
     *        vinp(n3,xed,2).lt.d(3)) then
c           xed is in the i-the triangle
            ispps0=1
            return
         end if
      end do
      
c     get outward normal
      call ni2(edge1(1,j),edge2(1,j),edge3(1,j),n1,n2,n3)
      do k=1,3
         if(k.eq.1) then
            xed(1)=edge1(1,i)-cnt(1)
            xed(2)=edge1(2,i)-cnt(2)
         else if(k.eq.2) then
            xed(1)=edge2(1,i)-cnt(1)
            xed(2)=edge2(2,i)-cnt(2)
         else if(k.eq.3) then
            xed(1)=edge3(1,i)-cnt(1)
            xed(2)=edge3(2,i)-cnt(2)
         end if
         
         if(vinp(n1,xed,2).lt.d(1).and.
     *        vinp(n2,xed,2).lt.d(2).and.
     *        vinp(n3,xed,2).lt.d(3)) then
c           xed is in the j-the triangle
            ispps0=1
            return
         end if
      end do

      ispps0=0
      return
      end

      real function getz(b,x)
      include 'impr8.inc'
      real b(*),x(*)
      real eps0
      common /ceps0/ eps0
      real d,t
      d=sqrt((x(4)-x(1))**2+(x(5)-x(2))**2)
      t=sqrt((b(1)-x(1))**2+(b(2)-x(2))**2)
      if(d.gt.eps0) then
         getz=x(3)+(x(6)-x(3))*t/d
      else
         getz=x(3)
c         call quit('cross point is on the termanal?')
      end if
      return
      end

      subroutine ni2(e1,e2,e3,n1,n2,n3)
      include 'impr8.inc'
      real e1(*),e2(*),e3(*),n1(*),n2(*),n3(*)
c     real cnt(*)
c     get normal to the line  (n and d)
      call getni2(e1,e2,e3,n1,d)
      call getni2(e2,e3,e1,n2,d)
      call getni2(e3,e1,e2,n3,d)
      return
      end 

      subroutine getni2(e1,e2,e3,n1,d)
      include 'impr8.inc'
      real e1(*),e2(*),e3(*),n1(*),d
      real e12(2),e1c(2)
      real vinp,d1

      call vsub(e1,e2,e12,2)
      call vsub(e1,e3,e1c,2)
      n1(1)=-e12(2)
      n1(2)=e12(1)
      d1=1/sqrt(n1(1)**2+n1(2)**2)
      do i=1,2
         n1(i)=n1(i)*d1
      end do
      d=vinp(n1,e1c,2)
      if(d.lt.0) then
         d=-d
         do i=1,2
            n1(i)=-n1(i)
         end do
      end if
      return
      end

      subroutine ni3(e1,e2,e3,e0,n1,n2,n3,n4)
      include 'impr8.inc'
      real e1(*),e2(*),e3(*),e0(*)
      real n1(*),n2(*),n3(*),n4(*)
      real d

c     get normal to the plane
      call getni3(e1,e2,e0,e3,n1,d)  ! normal to e1,e2,e0 plane from e3
      call getni3(e2,e3,e0,e1,n2,d)
      call getni3(e3,e1,e0,e2,n3,d)
      call getni3(e1,e2,e3,e0,n4,d)
      return
      end 

      subroutine getni3(e1,e2,e3,e4,n1,dst)
      include 'impr8.inc'
      real e1(*),e2(*),e3(*),e4(*),n1(*),dst
      real d0(3),d1(3),d2(3)
      real vinp,dst1,dst2
      real eps0
      common /ceps0/ eps0

      call vsub(e1,e2,d1,3)
      call vsub(e3,e2,d2,3)
c     n1 : vector product of d1 and d2
      n1(1)=d1(2)*d2(3)-d1(3)*d2(2)
      n1(2)=d1(3)*d2(1)-d1(1)*d2(3)
      n1(3)=d1(1)*d2(2)-d1(2)*d2(1)

      ! normalize
      dst1=sqrt(n1(1)**2+n1(2)**2+n1(3)**2)
      if(dst1.le.eps0) then
         do i=1,3
            n1(i)=0
         end do
         d=0
      else
         do i=1,3
            n1(i)=n1(i)/dst1   ! normalization
         end do
      end if

      call vsub(e1,e4,d0,3)
      dst2=vinp(n1,d0,3)
      if(dst2.lt.0) then    ! take outward normal
         do i=1,3
            n1(i)=-n1(i)
         end do
      end if
      dst=vinp(n1,e1,3)
      return
      end

      integer function sametrgl(e1,e2,e3,indx1,indx2,indx3,i,j)
      include 'impr8.inc'
      real e1(6,*),e2(6,*),e3(6,*)
      integer indx1(*),indx2(*),indx3(*) 
      if((icheck(e1(1,i),e1(1,j)).eq.1.and.
     *    icheck(e2(1,i),e2(1,j)).eq.1.and.
     *    icheck(e3(1,i),e3(1,j)).eq.1).or.
     *   (icheck(e1(1,i),e1(1,j)).eq.1.and.
     *    icheck(e3(1,i),e2(1,j)).eq.1.and.
     *    icheck(e2(1,i),e3(1,j)).eq.1).or.
     *   (icheck(e2(1,i),e2(1,j)).eq.1.and.
     *    icheck(e1(1,i),e3(1,j)).eq.1.and.
     *    icheck(e3(1,i),e1(1,j)).eq.1).or.
     *   (icheck(e3(1,i),e3(1,j)).eq.1.and.
     *    icheck(e1(1,i),e2(1,j)).eq.1.and.
     *    icheck(e2(1,i),e1(1,j)).eq.1)) then
         sametrgl=1
         return
      else
         sametrgl=0
         return
      end if
      end

      subroutine getnorm(nrmld,i)
      real nrmld(*)
      include 'drw.inc'
      call vcpyr(nrml(1,i),nrmld,3)
      return
      end

      subroutine twodcoord(e1,e2,e3,x1,x2,x3,i)
      real e1(*),e2(*),e3(*),x1(2),x2(2),x3(2)
      real nrml(3),n1(3),n2(3),n3(3),d(3),v1(3),v2(3)
      call getnorm(nrml,i)
      call norml(nrml,3)  ! normalized plane normal
      ve1=vinp(e1,nrml,3)  ! inner product
      call vcpyr(nrml,d,3)
      call sclvctr(d,ve1,3)
c     three vector in the plane through e1,e2,e3
      call vsub(e1,d,n1,3)
      call vsub(e2,d,n2,3)
      call vsub(e3,d,n3,3)
      ve1=vabs(n1,3)
      ve2=vabs(n2,3)
      ve3=vabs(n3,3)
      call norml(n1,3)   ! normalized vector
      call norml(n2,3)
      call norml(n3,3)

c     find maximum vector
      vemx=ve1
      imx=1
      if(vemx.lt.ve2) then
         vemx=ve2
         imx=2
      end if
      if(vemx.lt.ve3) then
         vemx=ve3
         imx=3
      end if

c     choose the maximum vector as the first vector 
      if(imx.eq.1) then
         call vcpyr(n1,v1,3)   ! normalized vector in the plane
         call vprd(nrml,n1,v2) ! 2-nd vector (vector product of nrml and n1)
      else if(imx.eq.2) then
         call vcpyr(n2,v1,3)  ! normalized vector in the plane
         call vprd(nrml,n2,v2)
      else if(imx.eq.3) then
         call vcpyr(n3,v1,3)  ! normalized vector in the plane
         call vprd(nrml,n3,v2)
      end if
c     2-dim coordinates of e1,e2,e3:  x1(1),x1(2) etc.
      x1(1)=vinp(n1,v1,3)*ve1
      x1(2)=vinp(n1,v2,3)*ve1
      x2(1)=vinp(n2,v1,3)*ve2
      x2(2)=vinp(n2,v2,3)*ve2
      x3(1)=vinp(n3,v1,3)*ve3
      x3(2)=vinp(n3,v2,3)*ve3
c      write(6,'(6f10.5)') x1,x2,x3
      return
      end

      integer function intrngl(x1,x2,x3,y)
c     if y is in a triangle with given by x1,x2,x3 points
c     return 1 else 0
      real x1(2),x2(2),x3(2),y(2)
      real n1(2),n2(2),n3(2),s1(2),s2(2),s3(2)
c      data eps /0.00001/
      data eps /0.0001/
      call getni2(x1,x2,x3,n1,d1)  ! n1:outward normal for x1-x2
      call getni2(x2,x3,x1,n2,d2)  ! n2:outward normal for x2-x3
      call getni2(x3,x1,x2,n3,d3)  ! n3:outward normal for x3-x1
      call vsub(x1,y,s1,2)
      call vsub(x2,y,s2,2)
      call vsub(x3,y,s3,2)
      d1=vinp(s1,n1,2)
      d2=vinp(s2,n2,2)
      d3=vinp(s3,n3,2)
      if(d1.gt.eps.and.d2.gt.eps.and.d3.gt.eps) then
c     y is in the triangle defined by x1,x2,x3
         intrngl=1
      else
         intrngl=0
      end if
      return
      end

      integer function inclpnt(e1,e2,e3,indx1,indx2,indx3,i,j)
c     if a point of j-th triangle is included in i-th triangle incltrgl=1
c     and remove two edges going out from it
      include 'impr8.inc'
      real e1(6,*),e2(6,*),e3(6,*)
      integer indx1(*),indx2(*),indx3(*) 

      real x1(2),x2(2),x3(2)        ! 2 dimensional coord for i-th triangle
      real y1(2),y2(2),y3(2)        ! 2 dimensional coord for j-th triangle
      real n12(2),n23(2),n31(2)     ! normal to x1-x2 etc. from y1,y2,y3
      real xc(2)
      data xc /0.,0./
c     write(6,*) 'i,j=',i,j
      call twodcoord(e1(1,i),e2(1,i),e3(1,i),x1,x2,x3,i)
      call twodcoord(e1(1,j),e2(1,j),e3(1,j),y1,y2,y3,j)
      if(intrngl(x1,x2,x3,y1).eq.1) then
         indx1(j)=1
         indx3(j)=1
         inclpnt=1
         return
      else if(intrngl(x1,x2,x3,y2).eq.1) then
         indx2(j)=1
         indx1(j)=1
         inclpnt=1
         return
      else if(intrngl(x1,x2,x3,y3).eq.1) then
         indx3(j)=1
         indx2(j)=1
         inclpnt=1
         return
      else
         inclpnt=0
         return
      end if
      end

      integer function commonedg(e1,e2,e3,indx1,indx2,indx3,i,j)
c     if i-th and j-th triangle have a common edge remove it
      include 'impr8.inc'
      real e1(6,*),e2(6,*),e3(6,*)
      integer indx1(*),indx2(*),indx3(*) 
      commonedg=0
      if(icheck(e1(1,i),e1(1,j)).eq.1) then
         indx1(i)=1
         indx1(j)=1
         commonedg=1
c         return
      else if(icheck(e1(1,i),e2(1,j)).eq.1) then
         indx1(i)=1
         indx2(j)=1
         commonedg=1
c         return
      else if(icheck(e1(1,i),e3(1,j)).eq.1) then
         indx1(i)=1
         indx3(j)=1
         commonedg=1
c         return
      else if(icheck(e2(1,i),e1(1,j)).eq.1) then
         indx2(i)=1
         indx1(j)=1
         commonedg=1
c         return
      else if(icheck(e2(1,i),e2(1,j)).eq.1) then
         indx2(i)=1
         indx2(j)=1
         commonedg=1
c         return
      else if(icheck(e2(1,i),e3(1,j)).eq.1) then
         indx2(i)=1
         indx3(j)=1
         commonedg=1
c         return
      else if(icheck(e3(1,i),e1(1,j)).eq.1) then
         indx3(i)=1
         indx1(j)=1
         commonedg=1
c         return
      else if(icheck(e3(1,i),e2(1,j)).eq.1) then
         indx3(i)=1
         indx2(j)=1
         commonedg=1
c         return
      else if(icheck(e3(1,i),e3(1,j)).eq.1) then
         indx3(i)=1
         indx3(j)=1
         commonedg=1
c         return
      end if
      return
      end

      subroutine rmvedg0(e1,e2,e3,indx1,indx2,indx3,i,j)
c     remove common edges between two triangles on the same plane
      include 'impr8.inc'
      real e1(6,*),e2(6,*),e3(6,*)
      integer indx1(*),indx2(*),indx3(*) 
      integer sametrgl,commonedg
      if(sametrgl(e1,e2,e3,indx1,indx2,indx3,i,j).eq.1) then
c       i-th and j-th triangles are the same
         return
      end if

c     i-th and j-th triangles are different
      if(commonedg(e1,e2,e3,indx1,indx2,indx3,i,j).eq.1) then
c       i-th and j-th triangles have a common edge and remove it
         return
      end if

      if(inclpnt(e1,e2,e3,indx1,indx2,indx3,i,j).eq.1) then
c       a point of j-th triangle is in a i-th triangle
c       remove two edge of j-th triangle going out from the point
         return
      else if(inclpnt(e1,e2,e3,indx1,indx2,indx3,j,i).eq.1) then
c       a point of i-th triangle is in a j-th triangle
c       remove two edge of j-th triangle going out from the point
         return
      end if
      return
      end

      integer function icheck1(e1,e2)
      include 'impr8.inc'
      real e1(*),e2(*)
      real eps0
      common /ceps0/ eps0
c     if e1 and e2 are the same edge icheck1=1 else icheck1=0
      if(abs(e1(1)-e2(1)).lt.eps0.and.
     *   abs(e1(2)-e2(2)).lt.eps0.and.
     *   abs(e1(3)-e2(3)).lt.eps0.and.
     *   abs(e1(4)-e2(4)).lt.eps0.and.
     *   abs(e1(5)-e2(5)).lt.eps0.and.
     *   abs(e1(6)-e2(6)).lt.eps0) then
         icheck1=1
         return
      else if(abs(e1(1)-e2(4)).lt.eps0.and.
     *        abs(e1(2)-e2(5)).lt.eps0.and.
     *        abs(e1(3)-e2(6)).lt.eps0.and.
     *        abs(e1(4)-e2(1)).lt.eps0.and.
     *        abs(e1(5)-e2(2)).lt.eps0.and.
     *        abs(e1(6)-e2(3)).lt.eps0) then
         icheck1=1
         return
      else
         icheck1=0
         return
      end if
      end

      integer function icheck(e1,e2)
      include 'impr8.inc'
      real e1(*),e2(*)
      real eps0
      common /ceps0/ eps0
c        if e1 and e2 are the same edge icheck=1 else icheck=0
      if(abs(e1(1)-e2(1)).lt.eps0.and.
     *   abs(e1(2)-e2(2)).lt.eps0.and.
     *   abs(e1(3)-e2(3)).lt.eps0.and.
     *   abs(e1(4)-e2(4)).lt.eps0.and.
     *   abs(e1(5)-e2(5)).lt.eps0.and.
     *   abs(e1(6)-e2(6)).lt.eps0) then
         icheck=1
         return
      else if(abs(e1(1)-e2(4)).lt.eps0.and.
     *        abs(e1(2)-e2(5)).lt.eps0.and.
     *        abs(e1(3)-e2(6)).lt.eps0.and.
     *        abs(e1(4)-e2(1)).lt.eps0.and.
     *        abs(e1(5)-e2(2)).lt.eps0.and.
     *        abs(e1(6)-e2(3)).lt.eps0) then
         icheck=1
         return
      else
         icheck=0
         return
      end if
      end

      subroutine rescl(x,scl,n)
      real x(*),scl
      do i=1,n
         x(i)=x(i)*scl
      end do
      return
      end

      subroutine simeq1(m,n,a,d)
      include 'impr8.inc'
c
c     a(m,n) 1<=m<=n  a(m,m) matrix a(m,m+1) solution
c     d determinant
c     
      real a(m,n),d,ax

      if(m.gt.n) go to 20
      if(m.ge.2) go to 30
c     m<=1
      if(m.lt.1) go to 20
c     m=1
      d=a(1,1)
      if(d.eq.0) return
      do 10 j=1,n
         a(1,j)=a(1,j)/d
 10   continue
      return
c     m>n m<1, or d=0
 20   d=0
      return
c     2<=m<=n
 30   d=1
      do 110 j=1,m
         do 40 k=j,m
            if(a(k,j).ne.0) go to 50
 40      continue
         go to 20
 50      if(k.eq.j) go to 70
         do 60 l=j,n
            ax=a(j,l)
            a(j,l)=a(k,l)
            a(k,l)=ax
 60      continue
         d=-d
 70      ax=a(j,j)
         d=ax*d
         a(j,j)=1
         do 80 k=j+1,n
            a(j,k)=a(j,k)/ax
 80      continue
         do 100 k=1,m
            if(j.eq.k) go to 100
            ax=a(k,j)
            a(k,j)=0
            do 90 l=j+1,n
               a(k,l)=a(k,l)-a(j,l)*ax
 90         continue
 100     continue
 110     continue
         return
         end

      subroutine simeq2(m,n,a,d)
      include 'impr8.inc'
c
c     a(m,n) 1<=m<=n  a(m,m) matrix a(m,m+1) solution
c     d determinant
c     
      real a(m,n),d,ax

      if(m.gt.n) go to 20
      if(m.ge.2) go to 30
c     m<=1
      if(m.lt.1) go to 20
c     m=1
      d=a(1,1)
      if(d.eq.0) return
      do 10 j=1,n
         a(1,j)=a(1,j)/d
 10   continue
      return
c     m>n m<1, or d=0
 20   d=0
      return
c     2<=m<=n
 30   d=1
      do 100 j=1,m
         km=j
         am=abs(a(j,j))
         do 40 k=j+1,m
            ax=abs(a(k,j))
            if(ax.gt.am) then
               km=k
               am=ax
            end if
 40      continue
         if(am.eq.0) go to 20
         if(km.eq.j) go to 60
         do 50 k=j,n
             ax=a(j,k)
            a(j,k)=a(km,k)
            a(km,k)=ax
 50      continue
         d=-d
 60      ax=a(j,j)
         d=ax*d
         a(j,j)=1
         do 70 k=j+1,n
            a(j,k)=a(j,k)/ax
 70      continue
         do 90 k=1,m
            if(j.eq.k) go to 90
            ax=a(k,j)
            a(k,j)=0
            do 80 l=j+1,n
               a(k,l)=a(k,l)-a(j,l)*ax
 80         continue
 90      continue
 100  continue
      return
      end

      subroutine simeq3(m,n,a,d)
      include 'impr8.inc'
c
c     a(m,n) 1<=m<=n  a(m,m) matrix a(m,m+1) solution
c     d determinant
c     
      real a(m,n),d,ax

      if(m.gt.n) go to 20
      if(m.ge.2) go to 30
c     m<=1
      if(m.lt.1) go to 20
c     m=1
      d=a(1,1)
      if(d.eq.0) return
      do 10 j=1,n
         a(1,j)=a(1,j)/d
 10   continue
      return
c     m>n m<1, or d=0
 20   d=0
      return
c     2<=m<=n
 30   d=1
      do 130 j=1,m
         km=j
         lm=j
         am=abs(a(j,j))
         do 50 k=j+1,m
            do 40 l=j+1,m
               ax=abs(a(k,l))
               if(ax.gt.am) then
                  km=k
                  lm=l
                  am=ax
               end if
 40         continue
 50      continue
         if(am.eq.0) go to 20
         if(km.eq.j) go to 70
         do 60 k=j,n
            ax=a(j,k)
            a(j,k)=a(km,k)
            a(km,k)=ax
 60      continue
         d=-d
 70      if(lm.eq.j) go to 90
         do 80 k=1,m
            ax=a(k,j)
            a(k,j)=a(k,lm)
            a(k,lm)=ax
 80      continue
         d=-d
 90      ax=a(j,j)
         d=ax*d
         a(j,j)=lm
         do 100 k=j+1,n
            a(j,k)=a(j,k)/ax
 100     continue
         do 120 k=1,m
            if(j.eq.k) go to 120
            ax=a(k,j)
            a(k,j)=0
            do 110 l=j+1,n
               a(k,l)=a(k,l)-a(j,l)*ax
 110         continue
 120      continue
 130  continue
      do 160 j=m,1,-1
         k=a(j,j)
         if(k.eq.j) go to 150
         do 140 l=m+1,n
            ax=a(j,l)
            a(j,l)=a(k,l)
            a(k,l)=ax
 140     continue
 150     continue
 160  continue
      return
      end

      subroutine ovrlap2(na,xpa,ypa,nb,xpb,ypb,isec,nc,xpc,ypc,ior)
      include 'impr8.inc'
c     from High-resolution Computer Graphics Using Fortran77 
c             ******  A and B must be convex ******
c     Finds the area of intersection between the two polygons A and B
c     with orientations defined by IOR:
c     IOR=1 means anti-clockweise, IOR=-1 means clockweise.
c     A has vertices (XPA(1)YPA(1)),...,(XPA(na),YPA(na))
c     B has vertices (XPB(1)YPB(1)),...,(XPB(na),YPB(na))
c     The area of intersection is returned with NC vertices stored in
c     the arrays XPC(1,..,nc) and YPC(1,..,nc).
c     If no intersection exists then ISEC is returned as 0, otherwise 1.
c     Maximum size of facets is 32=MAXP.

      parameter (maxp=32)
      real xpa(na),ypa(na),xpb(nb),ypb(nb)
      real xpc(maxp),ypc(maxp),xf(2,maxp),yf(2,maxp)
      real eps0
      common /ceps0/ eps0
      real a1,a2,x1,y1,x2,y2,xi1,xi2,yi1,yi2,vi1,vi2
c     Copy the details of polygon A into the first store.
      l1=1
      nc=na
      do i=1,nc
         xf(l1,i)=xpa(i)
         yf(l1,i)=ypa(i)
      end do
c     Slice the feasible polygon ( in arrays xf(1,2,..,nc) and
c     yf(1,2,..,nc) with each edge of B.
c     The end points of the slicing edge are (x1,y1) and (x2,y2).
      x1=xpb(nb)
      y1=ypb(nb)
      do i=1,nb
c     The sliced area will be stored in the second strage
c     area (xf(l2,1..nc),yf(l2,1..nc)).
         l2=3-l1
         x2=xpb(i)
         y2=ypb(i)
c     Calculate the functional representation of the line
c     (x1,y1) to (x2,y2): f(x,y)=ca*y+cb*x+cc.
         ca=x2-x1
         cb=y1-y2
         cc=-x1*cb-y1*ca
c     Consider the feasible polygon one edge at a time. The edge
c     under consideration is from (xi1,yi1) to (xi2,yi2).
         xi1=xf(l1,nc)
         yi1=yf(l1,nc)
c     Calculate F(xi1,yi1) and determine whether it lies on,
c     to the inside of or to the outside of the slicing edge.
         vi1=ca*yi1+cb*xi1+cc
         a1=abs(vi1)
         if(a1.lt.eps0) then
            i1=0
         else
            i1=nsgn1(vi1)*ior
         end if
         ncd=0
         do j=1,nc
            xi2=xf(l1,j)
            yi2=yf(l1,j)
c     Calculate whether (xi2,yi2) lies on, to the inside
c     of or to the outside of the slicing edge.
            vi2=ca*yi2+cb*xi2+cc
            a2=abs(vi2)
            if(a2.lt.eps0) then
               i2=0
            else
               i2=nsgn1(vi2)*ior
            end if
c     If (xi1,yi1) lies on or to the insede of the slicing
c     edge then include it in the new feasible polygon.
            if(i1.ge.0) then
               ncd=ncd+1
               xf(l2,ncd)=xi1
               yf(l2,ncd)=yi1
            end if
c     If (xi1,yi1) and (xi2,yi2) lie on strictly opposite
c     sides of the slicing edge then include the point of
c     intersection in the new feasible polygon.
            if(i1.ne.0.and.i1.ne.i2.and.i2.ne.0) then
               delta=a1+a2
               ncd=ncd+1
               xf(l2,ncd)=(a2*xi1+a1*xi2)/delta
               yf(l2,ncd)=(a2*yi1+a1*yi2)/delta
            end if
c     The second point of this edge will be the first of the next.
            vi1=vi2
            i1=i2
            a1=a2
            xi1=xi2
            yi1=yi2
         end do
c     If the feasible polygon degenerates then no overlap exists
         if(ncd.lt.3) then
            isec=0
            return
         end if
c     The new feasible polygon becomes the polygon to be sliced.
         nc=ncd
         l1=l2
c     Move on to the next edge of B.
         x1=x2
         y1=y2
      end do
c     Reach here when all slicing is complete. Copy the remaining 
c     feasible polygon to the arrays for return.
      isec=1
      do i=1,nc
         xpc(i)=xf(l1,i)
         ypc(i)=yf(l1,i)
      end do
      return
      end

      integer function iorien2(x1,y1,x2,y2,x3,y3)
      include 'impr8.inc'
      real x1,y1,x2,y2,x3,y3
c     Returns the orientation of the polygon with consecutive
c     vertices (x1,y1(,(x2,y2),(x3,y3).
c     -1 : clockweise orientation
c     1 : anti-clockwise orientation
c     0 : degenerate - line or point
      dx1=x2-x1
      dy1=y2-y1
      dx2=x3-x2
      dy2=y3-y2
      iorien2=nsgn1(dx1*dy2-dx2*dy1)
      return
      end
      
      integer function nsgn(x)
      include 'impr8.inc'
      real x
c     returns 1 if X>0
c             0 if x=0
c         or -1 if X<0
      real eps0
      common /ceps0/ eps0
      nsgn=0
      if(x.gt.eps0) then
         nsgn=1
      else if(x.lt.-eps0) then
         nsgn=-1
      end if
      return
      end

      integer function nsgn1(x)
      include 'impr8.inc'
      real x
c     returns 1 if X>0
c             0 if x=0
c         or -1 if X<0
      real eps0
      common /ceps0/ eps0
      nsgn1=0
      if(x.gt.eps0) then
         nsgn1=1
      else if(x.lt.-eps0) then
         nsgn1=-1
      end if
      return
      end

      subroutine ovrlap3(m1,n1,front,back,nv,xv,yv,x,y,z,xp,yp,ior)
      include 'impr8.inc'
c     Finds the area of intersection between the window projections of
c     facets m1 and n1. The 3-D coordinate system is given by arrays 
c     x,y and z while the projected coordinates are stored in xp and yp.
c     The nv vertices of the intersection area are returned in arrays
c     xv and yv.

      parameter (maxv=400,maxf=400,maxif=2000,maxp=32)
      real x(maxv),y(maxv),z(maxv),xp(maxv),yp(maxv)
      real xv(maxp),yv(maxp),xf(2,maxp),yf(2,maxp)
      common /counts/ nov,ntv,nof,ntf,last
      common /atrib/ nfac(maxf),icol(maxf),nsup(maxf),lsup(maxf)
      common /facets/ istart(maxf),isiz(maxf),ifac(maxf)
      common /window1/ horiz,vert,xyscal,ppd
      real eps0
      common /ceps0/ eps0
      real mu(2)
      integer front, back
      real a,b,c,x1,y1,x2,y2,a1,v1,a2,v2,xi1,xi2,yi1,yi2

c     nov  : number of vertices
c     itv  :
c     nof  : number of facets
c     last : last vetrices

c     nfac : facet number
c     icol : facet color
c     nsup : host facets for superficial facet
c     lsup :

c     istart : starting point (vertex number) of a facet
c     isiz  : number of vertices in a facet
c     ifac : vertex number corresponding to current vertex
c


c     m and n are the indices of the facets representing m1 and n1.
      m=nfac(m1)
      n=nfac(n1)
c     copy facet n to first storage arrays.
      l1=1
      ism=isiz(m)
      do i=1,ism
         xf(l1,i)=xp(ifac(istart(m)+i))
         yf(l1,i)=yp(ifac(istart(m)+i))
      end do
c     the first storage arrays xf(l1,1..ism) and yf(l1,i..ism) now
c     contain the vertices of the feasible polygon.
c     slicing edge has endpoints (x1,y1) and (x2,y2) with analytic
c     function ay+bx+c=0.
      isn=isiz(n)
      x1=xp(ifac(istart(n)+isn))
      y1=yp(ifac(istart(n)+isn))
      do i=1,isn
         x2=xp(ifac(istart(n)+i))
         y2=yp(ifac(istart(n)+i))
         a=x2-x1
         b=y1-y2
         c=-x1*b-y1*a
c     slice the feasible polygon edge by edge : (xi1,yi1) to (xi2,yi2)
c     k1 and k2 indicate whether the first and second points respectivley
c     lie on the slicing edge, on its positive side or on its negative
c     side.
         xi1=xf(l1,ism)
         yi1=yf(l1,ism)
         v1=a*yi1+b*xi1+c
         a1=abs(v1)
         if(a1.lt.eps0) then
            k1=0
         else
            k1=nsgn(v1)*ior
         end if
c     initialise second storage array.
         nv=0
         l2=3-l1
         do j=1,ism
            xi2=xf(l1,j)
            yi2=yf(l1,j)
            v2=a*yi2+b*xi2+c
            a2=abs(v2)
            if(a2.lt.eps0) then
               k2=0
            else
               k2=nsgn(v2)*ior
            end if
c     if (xi1,yi1) is not on negative side of slicing edge then
c     include in new strage array.
            if(k1.ge.0) then
               nv=nv+1
               xf(l2,nv)=xi1
               yf(l2,nv)=yi1
            end if
c     if (xi1,yi1) and (xi2,yi2) lie on opposite sides of slicing edge
c     then include the intersection with the edge.
            if(k1.ne.0.and.k1.ne.k2.and.k2.ne.0) then
               denom=a1+a2
               nv=nv+1
               xf(l2,nv)=(a2*xi1+a1*xi2)/denom
               yf(l2,nv)=(a2*yi1+a1*yi2)/denom
            end if
c     second point on current edge becomes first point on next edge.
            v1=v2
            k1=k2
            a1=a2
            xi1=xi2
            yi1=yi2
         end do
c     if second storage array contains fewer than 3 vertices then no
c     overlap exists.
         if(nv.lt.3) then 
            front=0
            return
         end if
c     feasible polygon now becomes that stored in second storage array
c     refer l1 to this polygon and slice with next edge of facet n.
         ism=nv
         l1=l2
         x1=x2
         y1=y2
      end do
c     reach here if non-empty overlap found.
c     find point within area of overlap
      xmid=(xf(l1,1)+xf(l1,2)+xf(l1,3))/3
      ymid=(yf(l1,1)+yf(l1,2)+yf(l1,3))/3
c     find corresponding points on facets in 3-D
      l=m1
      zero=0.0d0
      do i=1,2
         call normal(l,xn,yn,zn,a,x,y,z)
c         call ilpl(0.,0.,0.,xmid,ymid,-ppd,xn,yn,zn,a,rmu,xi,yi,zi,is)
         
         call ilpl(zero,zero,zero,xmid,ymid,-ppd,xn,yn,zn,a,
     *        rmu,xi,yi,zi,is)
         mu(i)=rmu
         l=n1
      end do
c     determine which lies in front.
      if(mu(1).gt.mu(2)) then
         front=n1
         back=m1
      else
         front=m1
         back=n1
      end if
c     copy area of overlap ot arrays for return
      do i=1,nv
         xv(i)=xf(l1,i)
         yv(i)=yf(l1,i)
      end do
      return
      end

      integer function iorien3(i,x,y)
      include 'impr8.inc'
c     finds orientation of facet i when projected into
c     2-D coordinate system defined by arrays x and y
c     1=anticlockwise, -1= clockwise, 0=degenerage
      parameter (maxv=400,maxf=400,maxif=2000)
      real x(maxv),y(maxv)
      common /atrib/ nfac(maxf),icol(maxf),nsup(maxf),lsup(maxf)
      common /facets/ istart(maxf),isiz(maxf),ifac(maxf)
      real dx1,dx2,dy1,dy2
      j=nfac(i)
      if(j.eq.0) then
         iorien3=0
         return
      end if
      iv1=ifac(istart(j)+1)
      iv2=ifac(istart(j)+2)
      iv3=ifac(istart(j)+3)
      dx1=x(iv2)-x(iv1)
      dy1=y(iv2)-y(iv1)
      dx2=x(iv3)-x(iv2)
      dy2=y(iv3)-y(iv2)
      iorien3=nsgn1(dx1*dy2-dx2*dy1)
      return
      end

      subroutine netwrk(nvis,nob,lis,x,y,z,xp,yp,ior)
      include 'impr8.inc'
c     constructs network of information on hidden surface ordering
      parameter (maxv=400,maxf=400,maxif=2000,maxp=32)
      real x(maxv),y(maxv),z(maxv),xp(maxv),yp(maxv)
      real xv(maxp),yv(maxp)
      integer nob(maxf),lis(maxf)
      common /counts/ nov,ntv,nof,ntf,last
      common /atrib/ nfac(maxf),icol(maxf),nsup(maxf),lsup(maxf)
      common /facets/ istart(maxf),isiz(maxf),ifac(maxf)
      integer front, back
c     initialise number of visible facets
      nvis=0
c     check orientation of each facet, incrementing nvis by one for
c     each visible one (orientation=ior)
      do i=1,nof
         if(iorien3(i,xp,yp).eq.ior) then
            nob(i)=0
            lis(i)=0
            nvis=nvis+1
         else
            nob(i)=-1
         end if
      end do
c     compare each pair of visible non-superficial facets.
      do i=1,nof-1
         if(nob(i).ne.-1.and.nsup(i).eq.0) then
            do j=i+1,nof
               if(nob(j).ne.-1.and.nsup(j).eq.0) then
                  call ovrlap3(i,j,front,back,nv,xv,yv,x,y,z,xp,yp,ior)
c                  write(6,*) 'i,j,front,back',i,j,front,back
c     if overlap exists then front obscures back.
                  if(front.ne.0) then
                     nob(front)=nob(front)+1
                     call push(lis(back),front)
                  end if
               end if
            end do
         end if
      end do
      return
      end

      subroutine hidden
      include 'impr8.inc'
c     executes topological sort on hidden surface network
      parameter (maxv=400,maxf=400,maxif=2000,maxp=32)
      integer lis(maxf),nob(maxf)
      common /counts/ nov,ntv,nof,ntf,last
      common /atrib/ nfac(maxf),icol(maxf),nsup(maxf),lsup(maxf)
      common /facets/ istart(maxf),isiz(maxf),ifac(maxf)
      real xp,yp
      common /projpt/ xp(maxv),yp(maxv)
      real xo,yo,zo
      common /obsrv/ xo(maxv),yo(maxv),zo(maxv)

c     set up the network data structure
************************
      call heapst
************************
      call netwrk(nvis,nob,lis,xo,yo,zo,xp,yp,1)
c     nvis: number of visible facets
c     nob(i): number of facets hidden by i-th facet
c     
c      write(6,*) 'nvis=',nvis
c      write(6,*) 'lis=',(lis(i),i=1,nof)
c      write(6,*) 'nob=',(nob(i),i=1,nof)
c     initialise stack and push on all back facets.
      istack=0
      do i=1,nof
         if(nob(i).eq.0.and.nsup(i).eq.0) call push(istack,i)
      end do
c     pop nvis facets off stack in turn.
c     draw each and adjust data structure.
      do i=1,nvis
         call pop(istack,k)
         if(k.eq.0) return
         call seefac(k)
         call unstck(k,lis,nob,istack)
      end do
      return
      end

      subroutine unstck(k,lis,nob,istack)
      include 'impr8.inc'
c     adjusts network structure after facet k ahs been drawn.
      parameter (maxf=400)
      integer lis(maxf),nob(maxf)
 99   continue
      if(lis(k).gt.0) then
         call pop(lis(k),nf)
         nob(nf)=nob(nf)-1
         if(nob(nf).eq.0) then
            call push(istack,nf)
         end if
         go to 99
      end if
      return
      end

      subroutine seefac(k)
      include 'impr8.inc'
c     color host facet k and all superficial facets.
      parameter (maxv=400,maxf=400,maxhp=2000)
      common /atrib/ nfac(maxf),icol(maxf),nsup(maxf),lsup(maxf)
      common /heap/ infop(maxhp),iptrp(maxhp),ifree
      call facfil(k)
      ipt=lsup(k)
 99   continue
      if(ipt.eq.0) return
      kk=infop(ipt)
      ipt=iptrp(ipt)
      call facfil(kk)
      go to 99
      end

      subroutine facfil(k)
      include 'impr8.inc'
      parameter (maxv=400,maxf=400,maxhp=2000,maxp=50)
      real xv(maxp),yv(maxp)
      common /projpt/ xp(maxv),yp(maxv)
      common /atrib/ nfac(maxf),icol(maxf),nsup(maxf),lsup(maxf)
      common /facets/ istart(maxf),isiz(maxf),ifac(maxf)
c     stoer projected vertices fo facet in xv,yv arrays
      j=nfac(k)
      do i=1,isiz(j)
         iv=ifac(istart(j)+i)
         xv(i)=xp(iv)
         yv(i)=yp(iv)
      end do
c     draw the facet in given color
      call setcol(icol(k))
      call polfil(isiz(j),xv,yv)
c     color edge lines in black.
      call setcol(0)
      call moveto(xv(isiz(j)),yv(isiz(j)))
      do i=1,isiz(j)
         call lineto(xv(i),yv(i))
      end do
      return
      end

      subroutine push(list,i)
      include 'impr8.inc'
c     routine of push the integer value onto the stack-type linear
c     list list which is stored in the heap arrays info and iptr.
      parameter (maxhp=2000)
      common /heap/ infop(maxhp),iptrp(maxhp),ifree
      if(ifree.eq.0) then
         write(6,*) 'heap size exceeded'
         stop
      end if
c     obtain location loc from heap, and delete it from free list.
      loc=ifree
      ifree=iptrp(ifree)
c     add loc to front of list, and store i there.
      infop(loc)=i
      iptrp(loc)=list
      list=loc
      return
      end

      subroutine pop(list,k)
      include 'impr8.inc'
c     routine to pop the first value from the linear list list
c     and return the value as k.
      parameter (maxhp=2000)
      common /heap/ infop(maxhp),iptrp(maxhp),ifree
c k is the value stored at the front of list (index loc).
      if(list.eq.0) then
         write(6,*) 'stack is empty'
         stop
      end if
      loc=list
      k=infop(loc)
c     delete front element of list, and add it to free list.
      list=iptrp(loc)
      iptrp(loc)=ifree
      ifree=loc
      return
      end

      subroutine heapst
      include 'impr8.inc'
c     initialise the heap. at first no information is
c     stored and each iptr points to the next cell in the list
      parameter (maxhp=2000)
      common /heap/ infop(maxhp),iptrp(maxhp),ifree
      ifree=1
      do i=1,maxhp-1
         iptrp(i)=i+1
      end do
      iptrp(maxhp)=0
      return
      end

      subroutine normal(k,rnx,rny,rnz,rnk,x,y,z)
      include 'impr8.inc'
c     to find the plane rnx.x+rny.y+rnz.z=rnk for facet k.
      parameter (maxv=400,maxf=400,maxif=2000)
      real x(maxv),y(maxv),z(maxv)
      common /facets/ istart(maxf),isiz(maxf),ifac(maxf)

c     kv1,kv2,kv3 are first three vertices on facet k.
      kbegin=istart(k)+1
      kv1=ifac(kbegin)
      kv2=ifac(kbegin+1)
      kv3=ifac(kbegin+2)
c     (dx1,dy1,dz1) and (dx2,dy2,dz2) are 3-D directions of the
c     first two lines in the 3-D facet K.
      dx1=x(kv2)-x(kv1)
      dy1=y(kv2)-y(kv1)
      dz1=z(kv2)-z(kv1)
      dx2=x(kv3)-x(kv2)
      dy2=y(kv3)-y(kv2)
      dz2=z(kv3)-z(kv2)
c     facet lies in plane rnx.x+rny.y+rnz.z=rnk
      rnx=dy1*dz2-dy2*dz1
      rny=dz1*dx2-dz2*dx1
      rnz=dx1*dy2-dx2*dy1
      rnk=rnx*x(kv1)+rny*y(kv1)+rnz*z(kv1)
      return
      end

      subroutine ilpl(bx,by,bz,dx,dy,dz,nx,ny,nz,k,rmu,xi,yi,zi,isec)
      include 'impr8.inc'
c     calculates the point of intersection (xi,yi,zi)
c     of a line (bx,by,bz)+u(dx,dy,dz) and the plane with 
c     equation (nx,ny,nz).v=k.
c     isec is returned as 1 if an intersection exists, 0
c      if not.
      real eps0
      common /ceps0/ eps0
      real nx,ny,nz,k
      d1=dot3(dx,dy,dz,nx,ny,nz)
c     if the line and plane are parallel then return isec=0.
      if(abs(d1).lt.eps0) then
         isec=0
         return
      end if
c     else a point of intersection does exist.
      isec=1
      d2=dot3(bx,by,bz,nx,ny,nz)
      rmu=(k-d2)/d1
      xi=bx+rmu*dx
      yi=by+rmu*dy
      zi=bz+rmu*dz
      return
      end

      real function dot3(x1,y1,z1,x2,y2,z2)
      include 'impr8.inc'
c     scalar product of 3-D vectors
      dot3=x1*x2+y1*y2+z1*z2
      return
      end

      subroutine scale3(sx,sy,sz,a)
      include 'impr8.inc'
c     calculate 3-D scaling matrix a
c     one unit on the x axis becomes sx units
c     one unit on the y axis becomes sy units
c     one unit on the z axis becomes sz units

      real a(4,4)
      do i=1,4
         do j=1,4
            a(i,j)=0
         end do
      end do
      a(1,1)=sx
      a(2,2)=sy
      a(3,3)=sz
      a(4,4)=1
      return
      end

      subroutine rot3(m,theta,a)
      include 'impr8.inc'
c     calculate 3-D axis rotation matrix a
c     the axes are rotated anti-clockwise through an angle
c     theta radians about an axis specified by m:
c     m=1 means x axis, 2, yaxis and 3, z axis.

      real a(4,4)
      do i=1,4
         do j=1,4
            a(i,j)=0
         end do
      end do
      a(4,4)=1
      a(m,m)=1
      m1=mod(m,3)+1
      m2=mod(m1,3)+1
      c=cos(theta)
      s=sin(theta)
      a(m1,m1)=c
      a(m2,m2)=c
      a(m1,m2)=s
      a(m2,m1)=-s
      return
      end

      subroutine mult3(a,b,c)
      include 'impr8.inc'
      real a(4,4),b(4,4),c(4,4)
      do i=1,4
         do j=1,4
            ab=0
            do k=1,4
               ab=ab+a(i,k)*b(k,j)
            end do
            c(i,j)=ab
         end do
      end do
      return
      end

      subroutine tran3(tx,ty,tz,a)
      include 'impr8.inc'
      real a(4,4)
      do i=1,4
         do j=1,4
            a(i,j)=0
         end do
         a(i,i)=1
      end do
      a(1,4)=-tx
      a(2,4)=-ty
      a(3,4)=-tz
      return
      end

      subroutine projec0
      include 'impr8.inc'
c     orthographic projection of observed vertices
      parameter (maxv=400)
      common /counts/ nov,ntv,nof,ntf,last
      common /obsrv/ xo(maxv),yo(maxv),zo(maxv)
      common /projpt/ xp(maxv),yp(maxv)
      do i=1,ntv
         xp(i)=xo(i)
         yp(i)=yo(i)
      end do
      return
      end

      subroutine projec1
      include 'impr8.inc'
c     perspective projection of observed vertices
      parameter (maxv=400)
      common /counts/ nov,ntv,nof,ntf,last
      common /obsrv/ xo(maxv),yo(maxv),zo(maxv)
      common /projpt/ xp(maxv),yp(maxv)
      common /window1/ horiz,vert,xyscal,ppd
      horiz=20.
      ppd=3.0*horiz
      do i=1,ntv
         if(zo(i).lt.0) then
            xp(i)=-xo(i)*ppd/zo(i)
            yp(i)=-yo(i)*ppd/zo(i)
         end if
      end do
      return
      end

      subroutine drawit0
      include 'impr8.inc'
      parameter (maxv=400,maxf=400)
      common /counts/ nov,ntv,nof,ntf,last
      common /obsrv/ xo(maxv),yo(maxv),zo(maxv)
      common /atrib/ nfac(maxf),icol(maxf),nsup(maxf),lsup(maxf)
      common /facets/ istart(maxf),isiz(maxf),ifac(maxf)      
      common /projpt/ xp(maxv),yp(maxv)
      real xv(maxv),yv(maxv)
      ntv=nov
      ntf=nof
      call projec0
      do i=1,nof
        iv=ifac(istart(i)+isiz(i))
        xv(iv)=xp(iv)
        yv(iv)=yp(iv)
        call moveto(xv(iv),yv(iv))
        do j=1,isiz(i)
           iv=ifac(istart(i)+j)
           xv(iv)=xp(iv)
           yv(iv)=yp(iv)
           call lineto(xv(iv),yv(iv))
        end do
      end do
      return
      end

      subroutine drawit1()
      include 'impr8.inc'
      common /counts/ nov,ntv,nof,ntf,last
c     set vertex count
      ntv=nov
      ntf=nof
      call projec1
      call hidden
      return
      end

      subroutine look3()
      include 'impr8.inc'
c     calculates the observation matrix q for an observer (ex,ey,ez)
c     looking in direction (dx,dy,dz)
      real e(4,4),f(4,4),g(4,4),h(4,4),v(4,4)
      common /eyepos/ ex,ey,ez,dx,dy,dz,q(4,4)
c     calculate translation matrix f.
      call tran3(ex,ey,ez,f)
c     calculate rotation matrix g.
      alpha=angle(-dx,-dy)
      call rot3(3,alpha,g)
c     calculate rotation matrix h.
      beta=angle(-dz,sqrt(dx*dx+dy*dy))
      call rot3(2,beta,h)
c     calculate rotation matrix v.
      gamma=angle(-dx*sqrt(dx*dx+dy*dy+dz*dz),dy*dz)
      call rot3(3,-gamma,v)
c     combine the transformations to find q
      call mult3(g,f,q)
      call mult3(h,q,e)
      call mult3(v,e,q)
      return
      end

      real function angle(ax,ay)
      include 'impr8.inc'
c     returns the angle whose tangent is ay/ax
c     all anomalies such as ax=0 are also checked.
      real eps0
      common /ceps0/ eps0
      pi=acos(-1.0)
      if(abs(ax).le.eps0) then
         angle=pi/2
         if(ay.lt.0) angle=1.5*pi
         if(abs(ay).lt.eps0) angle=0
         return
      end if
      angle=atan(ay/ax)
      if(ax.lt.0) angle=atan(ay/ax)+pi
      return
      end

      subroutine observ()
      include 'impr8.inc'
      parameter (maxv=400)
      common /counts/ nov,ntv,nof,ntf,last
      common /actual/ xa(maxv),ya(maxv),za(maxv)
      common /obsrv/ xo(maxv),yo(maxv),zo(maxv)
      common /eyepos/ ex,ey,ez,dx,dy,dz,q(4,4)
      do i=1,nov
         xo(i)=q(1,1)*xa(i)+q(1,2)*ya(i)+q(1,3)*za(i)+q(1,4)
         yo(i)=q(2,1)*xa(i)+q(2,2)*ya(i)+q(2,3)*za(i)+q(2,4)
         zo(i)=q(3,1)*xa(i)+q(3,2)*ya(i)+q(3,3)*za(i)+q(3,4)
c         write(6,*) 'zo=',zo(i)
      end do
      return
      end

      subroutine cube(p)
      include 'impr8.inc'
c     construction routine for a rectanbular block. initialy a cube
c     the block is distorted by the scaling matrix component of p.
c     assume cube ahs logical color 3.
      parameter (maxv=400,maxf=400,maxif=2000)
      real p(4,4)
      common /counts/ nov,ntv,nof,ntf,last
      common /actual/ xa(maxv),ya(maxv),za(maxv)
      common /atrib/ nfac(maxf),icol(maxf),nsup(maxf),lsup(maxf)
      common /facets/ istart(maxf),isiz(maxf),ifac(maxf)      
      common /cubsto/ xc(8),yc(8),zc(8),ifc(6,4)

c     update facet data base with 6 new facets.
      do i=1,6
         do j=1,4
            ifac(last+j)=ifc(i,j)+nov
         end do
         nof=nof+1
         istart(nof)=last
         isiz(nof)=4
         last=last+isiz(nof)
         icol(nof)=5
         nfac(nof)=nof
         nsup(nof)=0
         lsup(nof)=0
      end do
c     update vertex data base with 8 new vertices in actual position.
      do i=1,8
         nov=nov+1
         xa(nov)=p(1,1)*xc(i)+p(1,2)*yc(i)+p(1,3)*zc(i)+p(1,4)
         ya(nov)=p(2,1)*xc(i)+p(2,2)*yc(i)+p(2,3)*zc(i)+p(2,4)
         za(nov)=p(3,1)*xc(i)+p(3,2)*yc(i)+p(3,3)*zc(i)+p(3,4)
      end do
      return
      end

      block data cubein
      include 'impr8.inc'
      common /cubsto/ xc(8),yc(8),zc(8),ifc(6,4)
      data xc/1., 1., 1., 1., -1., -1., -1., -1./
      data yc/1., -1., -1., 1., 1., -1., -1., 1./
      data zc/1., 1., -1., -1., 1., 1., -1., -1./
      data ((ifc(i,j),j=1,4),i=1,6)/ 1,2,3,4,  1,4,8,5,  1,5,6,2,
     *     3,7,8,4, 2,6,7,3, 5,8,7,6/
      end

      subroutine setrgb(rgbv)
      real rgbv(3)
      common /crgb/rgb(3)
      call vcpyr(rgbv,rgb,3)
      return
      end

      subroutine getrgb(rgbv)
      real rgbv(3)
      common /crgb/rgb(3)
      call vcpyr(rgb,rgbv,3)
      return
      end
