c      get symmetry operator number for domains around 3-fold axis
c                in icosahedral Al-Pd-Mn quasicrystals
      character brv
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      real xg(6),rx(6),q(6),q3(6)
      integer isym(120)
      data xg /1.,-1.,0.,-1.,0.,0./
      isys=1
      call setsys(isys)
      call setd()
      call setinp(5)
      call setout(6)
      call rdsymo(na,brv)
      call getqe0(xg,q3)
      np=0
      nm=0
      do icnt=0,icent
         do ns=1,nsymo
            call getrx(xg,rx,r,t,ns,icnt)
            call getqe0(rx,q)
            if(vinp(q3(4),q(4),3).gt.0) then
               isym(ns+icnt*nsymo)=1
               np=np+1
            else
               isym(ns+icnt*nsymo)=0
               nm=nm+1
            end if
         end do
      end do
      write(6,*) 'n+=',np,' n-=',nm
      write(6,'(60i1)') (isym(j),j=1,nsymo*2)
      stop
      end

      function vinp(x,y,n)
c*****inner product of n-dimensional vactors, x,y
      dimension x(*),y(*)
      vinp=0
      do 10 i=1,n
 10   vinp=vinp+x(i)*y(i)
      return
      end

      subroutine getsys(isysd)
      common /cgethk/ d0(6,6),d1(6,6),d2(6,6),d3(6,6),isys
      isysd=isys
      return
      end            

      subroutine setsys(isysd)
      common /cgethk/ d0(6,6),d1(6,6),d2(6,6),d3(6,6),isys
      isys=isysd
      return
      end            

      subroutine getqe0(h,q)
      real h(*),q(*)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,cl,eps1,eps2,eps3,eps4
      call getsys(isys)
      do 100 i=1,6
           q(i)=0.
           do 101 j=1,6
                q(i)=q(i)+dr(i,j)*h(j)
 101       continue
c      if(isys.le.2) then
c          if(i.le.3) q(i)=q(i)*al
c      else
c          if(i.le.2) q(i)=q(i)*al
c          if(i.eq.3) q(i)=q(i)*cl
c      end if
 100  continue
      return
      end
      subroutine setd()
      common /cgethk/ d0(6,6),d1(6,6),d2(6,6),d3(6,6),isys
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,cl,eps1,eps2,eps3,eps4
      dimension ipv(6),ind(6,2),piv(6),b(6)
      common /cgetd/ det
      save icount
      parameter (sr=0.894427191,ct=0.447213596)
      parameter (su=-sr,cu=-ct)
      parameter (c1=0.309016994,c2=-0.809016994)
      parameter (c3=-c2,c4=-c1)
      parameter (s1=0.951056516,s2=0.587785252)
      parameter (s3=-s2,s4=-s1)
      parameter (c1sr=c1*sr,c2sr=c2*sr,c3sr=c3*sr,c4sr=c4*sr)
      parameter (s1sr=s1*sr,s2sr=s2*sr,s3sr=s3*sr,s4sr=s4*sr)
      parameter (tau=1.618034,tav=-tau)
      parameter (sqr2=1.41421, sqr3=1.73205, tqr3=-sqr3)
      parameter (t1=0.7071, t2=-0.7071)
      data  d0/ 0.,   0.,   1., 0.,   0.,   1.,
     *          c2sr, s2sr, ct, c4sr, s1sr, cu,
     *          c2sr, s3sr, ct, c4sr, s4sr, cu,
     *          c1sr, s4sr, ct, c3sr, s2sr, cu,
     *          sr,   0.,   ct, su,   0.,   cu,
     *          c1sr, s1sr, ct, c3sr, s3sr, cu/
c     for cubic and trigonal
      data  d1/ 1., tau,  0.,  tau, -1., 0.,
     *          tau, 0.,  1.,  -1,  0.,  tau,
     *          tau, 0., -1.,  -1., 0.,  tav,
     *          0.,  1., tav,   0., tau, 1.,
     *          -1., tau, 0.,  tav, -1., 0.,
     *          0.,  1., tau,   0., tau, -1./
c      for decagonal  (******reciprocal lattice*******)
      data d2/  c1, s1, 0., c2, s2, 0.,
     *          c2, s2, 0., c1, s4, 0.,
     *          c2, s3, 0., c1, s1, 0.,
     *          c1, s4, 0., c2, s3, 0.,
     *          0., 0., 1., 0., 0., 0.,
     *          0., 0., 0., 0., 0., 1./       
c     for octagonal
      data d3/  1., 0., 0., 1., 0., 0.,
     *          t1, t1, 0., t2, t1, 0.,
     *          0., 1., 0., 0.,-1., 0.,
     *          t2, t1, 0., t1, t1, 0.,
     *          0., 0., 1., 0., 0., 0.,
     *          0., 0., 0., 0., 0., 1./
      data icount /0/
      icount=icount+1
      if(icount.eq.1) then
c        initialize
         do 3 i=1,6
         do 3 j=1,6
 3       d0(i,j)=d0(i,j)/2
         do 4 i=1,6
         do 4 j=1,6
 4       d1(i,j)=d1(i,j)/sqrt(1+tau**2)/2
         do 5 i=1,6
         do 5 j=1,4
 5       d2(i,j)=d2(i,j)/sqrt(5.)
         do 6 i=1,6
         do 6 j=1,4
 6       d3(i,j)=d3(i,j)/2
         call trnsp(d0)
         call trnsp(d1)
         call trnsp(d2)
         call trnsp(d3)
      end if
      if(isys.eq.1) then
          call mcpy(d0,dq)
      else if(isys.eq.2) then
          call mcpy(d1,dq)
      else if(isys.eq.3.or.isys.eq.4) then
          call mcpy(d2,dq)
      else if(isys.eq.5) then
          call mcpy(d3,dq)
      else
          call quit('wrong isys')
      end if
      call mcpy(dq,dr)
      call matinv(dr,6,6,b,0,det,ipv,ind,piv)
      return
      end

      subroutine quit(str)
      character*(*) str
      write(6,*) str
      close(unit=3)
      close(unit=4)
      close(unit=91)
      close(unit=92)
      stop
      end

      subroutine matinv(a,nm,n,b,m,determ,ipivot,index,pivot)
c
c    n*n matrix a is replaced by its inverse matrix a**-1
c    if m is nonzero vector b is replaced by a**-1*b
c
      dimension a(nm,nm),b(nm),ipivot(nm),index(nm,2),pivot(nm)
      equivalence (irow,jrow),(icolum,jcolum),(amax,t,swap)
      determ=1.0
      do 20 j=1,n
  20  ipivot(j)=0
      do 555 i=1,n
      amax=0.0
      do 105 j=1,n
      if(ipivot(j).eq.1) go to 105
      do 100 k=1,n
      if(ipivot(k)-1) 80,100,740
  80  if(abs(amax).ge.abs(a(j,k))) go to 100
      irow=j
      icolum=k
      amax=a(j,k)
 100  continue
 105  continue
      ipivot(icolum)=ipivot(icolum)+1
      if(irow.eq.icolum) go to 260
      determ=-determ
      do 200 l=1,n
      swap=a(irow,l)
      a(irow,l)=a(icolum,l)
 200  a(icolum,l)=swap
      if(m.eq.0) go to 260
      swap=b(irow)
      b(irow)=b(icolum)
      b(icolum)=swap
 260  index(i,1)=irow
      index(i,2)=icolum
      pivot(i)=a(icolum,icolum)
      determ=determ*pivot(i)
      a(icolum,icolum)=1.0
      do 350 l=1,n
 350  a(icolum,l)=a(icolum,l)/pivot(i)
      if(m.eq.0) go to 380
      b(icolum)=b(icolum)/pivot(i)
 380  do 550 l1=1,n
      if(l1.eq.icolum) go to 550
      t=a(l1,icolum)
      a(l1,icolum)=0.0
      do 450 l=1,n
 450  a(l1,l)=a(l1,l)-a(icolum,l)*t
      if(m.eq.0) go to 550
      b(l1)=b(l1)-b(icolum)*t
 550  continue
 555  continue
      do 710 i=1,n
      l=n+1-i
      if(index(l,1).eq.index(l,2)) go to 710
      jrow=index(l,1)
      jcolum=index(l,2)
      do 700  k=1,n
      swap=a(k,jrow)
      a(k,jrow)=a(k,jcolum)
 700  a(k,jcolum)=swap
 710  continue
 740  continue
      return
      end

      subroutine getinp(inpu)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      inpu=cinpu
      return
      end

      subroutine getout(iout)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      iout=coutu
      return
      end

      subroutine setskp(iskp)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      cskip=iskp
      return
      end

      subroutine getskp(iskp)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      iskp=cskip
      return
      end

      subroutine setinp(inpu)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      cinpu=inpu
      return
      end

      subroutine setout(iout)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      coutu=iout
      return
      end
