c     
c                    projection of quasi-crystals
c                   note the following assumption
c
c                         input data
c     *********************************************************
c           origin of the vector ej should be in a occupation
c                             domain
c     *********************************************************
c
c     (0) inpm, iapprx
c         inpm=0 separatel file (standard input, flnm1 and flnm2)
c             =1 standard input only
c         iapprx 0 : no approximation
c                1 : approximation with domain distortion by linier phason
c     (1) title
c     (2) isys,a,(c),eps1,eps2,eps3,eps4,eps5,eps6,ists
c           isys: 1 icosahedral or its pentagonal distortion
c                 2 icosahedral or its cubic or orthrhombi distortion
c                   (icosahedral or its trigonal distortion)
c                 3 decagonal or its orthorhombic distortion
c                 4 octagonal
c                 5 dodecagonal
c         a,c : lattice papameter
c           eps1:  pentagonal phason distortion (isys=1)
c                  cubic phason distortion  (isys=2)
c           eps2: orthorhombic phason distortion 1 (1,1 element) (isys=1,3..)
c                 orthorhombic phason distortion (3,3) element (isys=2)
c                 (trigonal phason distortion (3,3) element (isys=2))
c           eps3: orthorhombic phason distortion 2 (2,2 element) (isys=1,3..)
c                 orthorhombic phason distortion (1,1)=(2,2) element (isys=2)
c                 (trigonal phason distortion (1,1)=(2,2) element (isys=2))
c           eps4: monoclinic phason distortion 3 (1,2 element) (isys=1,3..)
c           eps5: monoclinic phason distortion 4 (2,1 element) (isys=1,3..)
c           eps6: phonon distortion (along z-axis isys=1,3)
c                 trigonal phonon distortion 2 (isys=2)
c           ists: 0 true site symmetry operators are used
c               1 fictitious site symmetry operators are used for all atoms
c     (3) na npod ne isim imod
c          na: number of atoms
c          npod : number of predefined occupation domsins
c          ne : number of elements
c          isim: order of similarity transformation
c                isim = 0 no magnification
c                isim > 0 deflate by tau**-isim times
c                isim < 0 inflate by tau**-isim times   
c                      isim=-2,-1,0,1, or 2  etc.
c                tau: ratio of selfsymilarity
c                    =(1+sqrt(5))/2=1.618 for decagonal
c                                             and face-centered icosahedral
c                    =sqrt(2)=1.414 ? for octagonal
c          imod: 1: lattice constant a is multiplied by tau**isim
c                   this makes inflation or deflation impossible
c                   but isim > 0 and imod=1 may be effective for
c                   reducing the value of ihmax in (8) and for 
c                   fast calculation
c                0: no multiplication for the lattice constant

c     ******** if inpm=0 skip (4) ******
c     (4) flnm1
c         flnm1 : filename which gives the following items
c     

c     ******** if inpm=1 skip (01)-(07) ******
c#############################################################################
c      (01) nsymo,icent,brv
c          nsymo: number of generators in symmetry operations
c          icent: give 1 for centrosymmetric
c                 otherwise give 0
c          brv  : 'p','i','f' 's' 'c' bravais lattice
c                  s in icosahedral  ==> face-centered superlattice
c                  s in decagonal    ==> Edagawa type superlattice
c                  s translates x,ej,xi in the normal lattice into those
c                                   in superlattice
c                  in decagonal case, s also translates sym. op in normal
c                     lattice into those in superlattice
c                  c P_2c for color symmetry
c                  'g' is for the groupoid symmetry in quasicrystal
c          **************************************************************
c          when brv='s',  give x0,xe,xi,ej in the fundamental cell.
c          they are transformed into those of the supercell in the program.
c          **************************************************************
c     (02) 'symmetry operator'        header  and
c     (03)  symmetry operator in the I.T. format: x,y,z,t,u,v etc.
c            ***** repeat (03) nsymo times
c     (03') if brv='g'
c           hull element   (header)
c           hull operator in the IT format including x,y,z,t,u,v
c                    and centering translations
c           repeat this ig times.
c     (03")   innn: number of repeats of transformation given above 
c               ****** (isys=4,brv='s' only)******
c     (04) n,ne0,itype,st
c         n    : serial number for the guide to the eye
c         nej0 :number of edge vectors for predefined occupation domain (<=nemax=20)
c         itype  :  1 domain with icosahedral, degagonal or octagonal symmetry
c                   2 domain with other symmetry
c                  -1 domain with icosahedral, degagonal or octagonal symmetry for test
c                  -2 domain with other symmetry for test
c         str  : string for comments
c     (05) ej  : edge vectors of their internal components or principal axes
c         ej(1)-ej(6)
c               repeat (02) ne times
c     (06) nth, (mej(1),mej(2),,),... nth times
c          nth: number of tetrahedra
c          mej: a triplet of vector numbers specifying a tetrahedron
c                           (for isys=1,2)
c          mej: a pair of vector numbers specifying a rhombus
c                           (for isys=3,4,5)
c     (07) iaslct(1-(nsymo+icent*nsymo)) (60i1) 1:selected, 0:skipped **na times
c       ******** repeat (01)-(07) npod times
c ###########################################################################

c     ******** if inpm=0 skip (5) ******
c     (5) flnm2
c         flnm2 : filename which gives the following items

c     ******** if inpm=1 skip (01)-(08) ******
c ###########################################################################
c     (01) no,symb,ien,ish,nev,be,bi,ramin,ramax,p,s1,s2  (*)
c         no: atom number
c         symb: site symbol
c         ien: element number (1:Al 2:Mn etc.)
c         if ish > 0:  ish-th predefined occupation domain
c         else
c           for icosahedral case
c             ish=0 polyhedron
c             ish=-1: ellipsoid
c             ish=-2: sphere   ( rmax: the radius of the sphere in a )
c           for dihedral case
c             ish=0 triangle
c             ish=-1: ellips
c             ish=-2: circle   ( rmax: the radius of the sphere in a )
c         nev: number of edge vectors for ish=0    (<=nemax=50)
c              number of principal axes (=2 or 3) for ish=1
c              consequtive three vectors are regarded as the edge vectors 
c              of a tetrahedron defining the occupation domain (ish=0)
c         be: isotropic temperature factor in external space
c         bi: isotropic temperature factor in internal space
c    ******     for decagonal case    *****
c         be: isotropic temperature factor in the plane normal to 10
c         bi: isotropic temperature factor along 10
c    
c         ramin :  scale for unoccupied tetrahedron or rhombohedron
c         ramax :  scale for occupied tetrahedron or rhombohedron
c            if ish=2 ramax=1 means shere with radius of 1.4325 (ca)
c            (radius of the shere equivalent to unit triacontahedron
c                    creating the 3d penrose pattern)
c         p    : occupation probability
c         s1    : percentage of first component
c         s2    : percentage of second component
c         (** one site is assumed to be occupied by two atoms**)

c          ***** ish=-1 to use truncated triacontahedron *****
c              ra or rb=1 corresponds to the triacontahedron with
c                   unit edge length

c     (02)  x0(1)-x0(6): coordinate of atom in 5D, or 6D for dihedral and ico
c     (03)  xe1(1)-xe1(6),u1 shift vector in ve and magnitude  (5D,6D or 7D)
c     (04)  xe2(1)-xe2(6),u2 shift vector in ve and magnitude  (5D,6D or 7D)
c     (05)  xe3(1)-xe3(6),u3 shift vector in ve and magnitude  (5D,6D or 7D)
c     (06)  xi(1)-xi(6),v shift vector in vi and magnitude  (5D,6D or 7D)
c           5D: octagonal, 6D: decagonal and icosahedral 7D: dodecagonal
c       ****** for colored atom give xi(6)=1 (normal color)
c                      or -1 (inverse color)********
c     ****** colored atom should be black (icol=0) or white (icol=10) ****
c     ******** colored symmetry is only available for polygonal cases ******
c        ******* if(ish.gt.0) skip (07) (08)****

c                     the following judge is used for icosahedral cases
c                     rimax: maximum |ej|
c                     rimin: minumum |ej| which is calculated in getnii
c                                                   or in getnid
c                     ri > rimax out of the domain
c                     ri < rimin in the domain
c                     rimax > ri > rimin need accurate calculation
c                        using the domain shape
c               Note that this is not correct in general
c               Please include the origin in the domain
c      ************************************************  
c     (07) ej
c          ej:  edge vectors of two triangles in the 6D coordinate system
c               repeat (5) ne times
c                ***************notice****************
c               the internal components of consecutive ej are regarded as
c               the consecutive edge vectors of the polyhedron defining
c               the occupation domain
c                ***************notice***************
c     (08) nth, (mej(1),mej(2),,),... nth times
c          nth: number of tetrahedra
c          mej: a triplet of vector numbers specifying a tetrahedron
c                           (for isys=1,2)
c          mej: a pair of vector numbers specifying a tetrahedron
c                           (for isys=3,4,5)
c         ******** repeat (01) (08) na times

c ############################################################################
c     (5') itempf

c          If itempf=1

c          xe1,xe2,xe3 are used to describe anisotropic temperature factor
c          however if xe1 and xe2 are orthogonal then third axis orthogonal
c          to them are used neglecting specified xe3. in this case
c          zero vector xe3 can be specified if it is not necessary
c          as a shift vector

c          but if more than two of them is zero, cartesian coordinate system
c          in the external space is used instead for that atoms (or OD)
c
c     (6) nx
c     (7) z,jz,(ja1(j),ja2(j),ea(j),j=1,jz)
c          z  : independent parameter
c          jz : number of terms related with z
c          ja1: atom number
c          ja2: u,v,be,be,ramin,ramax,p,s for 1-8
c          ea : coefficient
c               u,v,etc. = z*ea
c           *******repeat (7) nx times********
c            if itempfi=0 skip (7')      
c      (7')  itempfi  (80i1)
c            itempfi : 0 for iso 1 for anisotropic temperature factor
c            for individual atom
c
c      (8) icont
c           *******if icont = 0 skip (9) **********
c      (9) flnm3
c             filename of the parameter file
c
c      (10) jaslct (80i)
c          atom selection: if j-th column is 1 or 0 j-th atom is selected or skipped
c      (11) iel (iel(1)-iel(3)) (repeat ne times) atp
c      (12) job,icase,ihmax,iatom,iwxy,ldev,inum
c          job=0 plot projection of quasi-crystal along an axis
c             =1 generation of structural data
c                (x, y, z u11 u22 u33 u23 u31 u12 p1 p2 p3)
c             =2 interatomic distances (nearest neighbor)
c          icase= 1: projection along n-fold axis  (n=5,8,10,12)
c                    z: n-fold (z-) axis in dihedral quasicrystal
c                    y: y axis in dihedral quasicrystal
c                 2: projection along 3-fold axis
c                    z: 3-fold axis in cubic approximant
c                    x: 2-fold axis in cubic approximant
c                 3: projection along 2-fold axis
c                    z: 2-fold (y-) axis in pentagonal quasicrystal
c                    x: 5-fold axis (z-) in pentagonal quasicrystal
c                 4: projection along z-axis in cubic approximant
c                    z: z-axis in cubic approximant
c                    x: x-axis in cubic approximant
c                 5: projection along specified direction
c                    
c          ihmax: maximum indices, -ihmax<=h(i)<=ihmax 
c               default=3 for decagonal (usually ihmax<=5)
c               for job=2 ihmax=1 should be sufficient
c               if an appropriate isim is chosen ? (isim = -1 ?)
c          iatom= 1: plot atoms
c                 0: plot no atoms
c          iwxy : give 1 to output x-y coordinate of plotted atoms
c                                  and bond length
c                 (if job=1, output x, y, z coordinates)
c          ldev : 1 B & W display or printer, 2 color display or printer
c          inum : 1 plot atom number 0 no atom number
c    **************if(icase is not equal to 5, skip (13)************
c      (13) q3,q2      (six-dimensional vector specifying directions)
c           q3: z-axis (projection axis) 
c           q2: y axis 
c             0,1,1,0,0,0    x-axis in cubic approximant
c             1,0,0,0,1,0    y-axis in cubic approximant
c             0,0,0,-1,0,1   z-axis in cubic approximant
c    **************************************************************
c       ********if iatom=0 skip (14) *******
c      (14) icntsm
c          icntsm(i) i=1,ne : center symbol coresponding to ien
c                 0: sphere
c                 1: sphere
c                 2: triangle
c                 3: square
c                 4: pentagon
c                 5: star
c      (15) amag,orign,ismode
c          amag:  magnification  (cm/angstrom)
c          when brv='s', give orign in the fundamental cell.
c          orign(1)-orign(6): origin within -0.5<orign(i)<0.5 is taken
c          ismode : 0 6d shift
c                   1 internal shift
c                   2 external shift     
c               ****if job !=2 then
c      (16) xmin,xmax,ymin,ymax,zmin,zmax,shiftx,shifty
c          xmin-xmax: view area in angstrom
c          ymin-ymax: view area in angstrom
c          zmin-zmax: view area in angstrom
c          shiftx: shift before plot in cm
c                  default max(2,-xmin*amag+2)
c          shifty: shift before plot in cm
c                  default max(2,-ymin*amag+2)
c               ****if job =2 then
c      (16) dmin, dmax   
c          dmin : minimum interatomic distances to be calculated
c          dmax : maximum interatomic distances 
c      (17) ncp      (ncp <= 20)
c           ncp: number of atoms with concave parts in the occupation domain
c            ***** if ncp=0 skip (18)
c      (18) npart atm 
c           npart : number of concave parts (with a negative occupation
c                   probability) of the occupation domains of                  
c                   the atom specified by atm0
c           atm : atom number with positive occupation probabilities
c                 followed by (npart) related atoms with negative occupation 
c                 probabilities
c               ***** repeat (18) ncp times *****
c **********if job=0 or 1 then (19)-(23)
c      (19) raplt
c          raplt(1)-raplt(ne): radus of elements
c      (20) icolor : color of ne elements
c                   lightness=0 or a means black or white
c                   satulation=0 means gray
c                   background color =10  white
c                   black  = 1
c                   white  =10
c                   gray           ( 1- 9)
c                   blue   =15     (11-19)
c                   magenta=45     (41-29)
c                   red    =75     (71-39)
c                   yellow =105    (101-109)
c                   green  =135    (131-139)
c                   cyan   =165    (161-169)
c
c      (21) nbond
c          different kinds of bonds   (<=10)
c      (22) ie1, ie2, bmin, bmax, bcol, bwdt, klin
c          ie1,ie2: element pair to be joined by a bond
c          bmin: minimum length of a bond  in angstrom
c          bmax: maximum length of a bond  in angstrom
c          bcol: bond color
c          bdwt: bond width
c          klin: kind of lines  0: bold, 1: dashed 2: dotted
c             ******bond length affected by isim******
c             repeat (22) nbond times
c      (23) nsl,no1,no2
c          nsl: number of slices upward and downward
c               along the projection axis
c          no1-th to no2-th slices are calculated (default: all 
c                         slices are calculated)
c          **** if job != 1 skip (24) ****
c      (24) flnm4
c          file name of xyz file for the output of x,y,z coordinates of plotted atoms
c
      parameter (ngm=6)
      parameter (ng=6)
      parameter (nl2=1000)
      parameter (imax=30)
      parameter (ncm=(ngm*(ngm-1)*(ngm-2))/6)
      include 'qcstrc.inc'
      parameter (tau=1.61803399)
      common /ccolor/ icolor(namax),raplt(nemax)
      integer bcol,bwdt
      common /cbond/ nbond,ie1(20),ie2(20),bmin(20),bmax(20),bcol(20),
     *     bwdt(20),klin(20)
      common /ccntsm/ icntsm(nemax)
      common /cplt/ job,icase,ihmax,iatom,iwxy,ldev,amag,shftx,shfty
      common /cnum/ inum
      integer ind(2*ngm)
      common /cgetat/ isl2(imax+1,imax+1,nl2),nsl2(imax+1,imax+1)
      common /cnpart/ ncp, npart(namax),iatm(0:namax,namax)

      common /csave1/ dt(nmax),ds(nmax),xs(3,nmax),hs(6,nmax)
      common /csave2/ ms(nmax),ns(nmax)

c     for distance calculations
      common /cifatm/ ifatms(nmax),vol(nmax),nss(nmax),hrs(6,nmax),
     *     dst(nmax),uixy(6,nmax)

      real shifto(6),xd(6),yd(6)
      integer isk(0:120),irs(0:120)
      character brv
      character*72 flnm1,flnm2,flnm3,flnm4
      real dt1(nmax),ds1(nmax),xs1(3,nmax), hs1(6,nmax)
      real dt2(nmax),ds2(nmax),xs2(3,nmax),hs2(6,nmax)
      real uixy1(6,nmax),uixy2(6,nmax)
      integer ms1(nmax),ns1(nmax)
      integer ms2(nmax),ns2(nmax)

      integer nsd(nmax),st0(2,nmax)
      character star(nmax)
      real orign(6),qe(6)
      real n1,n2,n3,n3x
      common /clmt1/ ram,rbm,dx,dy,n1(6),n2(6),n3(6),n3x
      real qb(6),zc(6)
      common /cnatm/ natom(namax)
      real z(nxprm),df(nxprm)
      real zs(nmax)
      character*72 title

      real x0(6,namax)
      real x00(6,namax)
      real x(6)
      integer getnsym,geticnt,getish

      common /ctrc/ trc(6,32),trcd(6,32), ntrc
      common /cislct/ iaslct(120,namax),jaslct(namax)
      common /cskip/ iskip,ltype
      common /cpcol/ pcol
      common /ceps/ epsd
      integer pcol
      common /cpnf1/ ne,atp(3),atp0(3),iel(3,nemax)
      integer q3(6),q2(6)
      real xg(6,2)
      real td(6)
      character*80 stsym
      character*50 frmt1,frmt2
      common /cinnn/ innn
      real pocc(3)
c      data innn /1/
      data td/6*0./
      data ind/2,1,4,3,6,5,8,7,10,9,12,11/
      data xg
     */ 0.5,     -0.223607,-0.223607,-0.223607,-0.223607,-0.223607,
     *  0.723607,-0.723607, 0.0     ,-0.447214,-0.447214,0.0    /
      data eps/0.0001/
c
      call setinp(5)  ! for fread
      call setout(6)  ! for fread

      call freadi('inpm=',1,inpm,1)
      call freadi('iapprx=',1,iapprx,0)
      call setapprx(iapprx)
      write(6,'(2(a,i3))') 'inpm=',inpm,' iapprx=',iapprx
c      read(5,'(a)') title
      call freadc('title=',1,title,1)
      write(6,'(a)') title
c      read(5,'(3f8.5,i3)') isys,al,eps1,eps2,eps3,eps4,eps5,eps6
      call freadi('isys=',1,isys,1)
      call setsys(isys)
      call rdac(al,cl)   ! read lattice constants and set a and c
      call rdeps(eps1,eps2,eps3,eps4,eps5,eps6)
      call freadi('ists=',1,ists,0)
      if(isys.le.2) then
      write(6,'(a,i3,7(a,f8.5),a,i1)') 'isys=',isys,' al=',al,
     *  '  eps1=',eps1,' eps2=',eps2,' eps3=',eps3,' eps4=',eps4,
     *  '  eps5=',eps5,' eps6=',eps6,' ists=',ists
      else
      write(6,'(a,i3,8(a,f8.5),a,i1)') 'isys=',isys,' al=',al,
     * ' cl=',cl,'  eps1=',eps1,' eps2=',eps2,' eps3=',eps3,' eps4=',
     * eps4,'  eps5=',eps5,' eps6=',eps6,' ists=',ists
      end if

      call seteps(eps1,eps2,eps3,eps4,eps5,eps6)
      call setlcnst(al,cl)
c     am=al                 ! necessary for l. phason
 40   continue
c     read(5,'(i3)') na
      call freadi('na=',1,na,1)
      call freadi('npod=',1,npod,0)
      call freadi('ne=',1,ne,0)
      call freadi('isim=',1,isim,0)
      call freadi('imod=',1,imod,0)
      write(6,*) 'na=',na,' ne=',ne, ' isim=',isim, ' imod=',imod
      call setna(na)
      call setnpod(npod)

      call setd()        ! set lattice data for quasicrystals
      call settrm(isys)  ! set system (isys=1,2 for icosahedral etc.)
      call setdei()      ! set deformation matrix
      call saveisim(isim)
      call setsmtrm(isim) ! set simirality transformation matrix

      call setprjop0()   ! calculate projection operator
      call setprjop()    ! calculate projection operator
c
      if(isys.le.2) then
         call inttri()
      end if

      if(inpm.eq.0) then
         call freadc('flnm1=',1,flnm1,1)
         lfn1=istrln(flnm1)
         call freadc('flnm2=',1,flnm2,1)
         lfn2=istrln(flnm2)
         write(6,*) 'flnm1=',flnm1(1:lfn1)
         write(6,*) 'flnm2=',flnm2(1:lfn2)
         
         call openfile(7,flnm1,'OLD')
         call setinp(7)
      end if
      call setout(6)
      call rdsymo(na,brv)
      call setbrv(brv)
      call setmpltbl()
      call setsymei()       ! set rotation operator in ext. and int. spaces
      if(isys.eq.4.and.brv.eq.'s') then
         call freadi('innn=',1,innn,1)
      end if
      call rdpod(npod)
      close(7)
      call setnpod(npod)

      if(inpm.eq.0) then
         call openfile(8,flnm2,'OLD')
         call setinp(8)
      end if
      call setout(6)
      call rdap(na)             ! read initial OD informations
      call btouij(na)           ! tempf transformation coeff
      close(8)

      call xtoxs(na) 
      call gettrc(brv,trc,ntrc)
c      write(6,*) 'ntrc=',ntrc
      do i=1,ntrc
c         call wtvctrr('trc=',trc(1,i),6)
         call vcpyr(trc(1,i),trcd(1,i),6)
      end do

      call setinp(5)
      call setout(6)
      idm=6
      nde=3
      do i=1,na
         call getx0(i,x0(1,i))  ! calculate initial coordinates
      end do
      call sitesyx0(na,x00)     ! set x00
      call getx00(x00)
      call sitesyx(na,x00)      ! calculate site symmetry for x00
      call setiski()
      nd=0
      do j=1,na
         if(getish(j).gt.0) then
            nd=1
         end if
      end do
c     replace site symmetry operator with fictitious one
      call setiaslct()
      call setirsd()            ! set site symmetry operators used

      call rdintl(z,ny)         ! read independent parameters
      call setequi0()           ! set equivalent bi0 or ui0
      call ificont(z,ny,flnm3)     ! read z from a file
      call zerov(df,ny)         ! init df
      call setxbp(z,ny)         ! calculate structural parameters
      call prmtbl(df,ny)     ! print out parameter tables

      call setuixy(na)          ! set anisotropic temperature factor in q system

      qemax=0
      call getni()
      call rdjaslct()
      call resetjaslct()

      do i=1,ne
         if(i.eq.1) then
            call freadi('iel=',3,iel(1,i),1)
         else
            call freadi('iel=',3,iel(1,i),0)
         end if
      end do
      call freadr('atp=',3,atp0,0)
      write(6,'(4(a,3i2))') (' iel=',(iel(i,j),i=1,3),j=1,ne)
      write(6,'(a,3f10.3)') ' atp=',(atp0(i),i=1,3)
      if(isys.le.2) then
         call vivoli(na)
      else if(isys.eq.3.or.isys.eq.4.or.isys.eq.5) then
         call vivold(na)
      else
         call quit('invalid isys')
      end if
      call getocc(na)

      pcol=1
      icol=1
c     read(5,'(6i3)') job,icase,ihmax,iatom,iwxy,ldev
      call freadi('job=',1,job,1)
      call freadi('icase=',1,icase,0)
      call freadi('ihmax=',1,ihmax,0)
      call freadi('iatom=',1,iatom,0)
      call freadi('iwxy=',1,iwxy,0)
      call freadi('ldev=',1,ldev,0)
      call freadi('inum=',1,inum,0)

      write(6,'(7(a,i3))') 'job=',job,' icase=',icase,
     *     ' ihmax=',ihmax,' iatom=',iatom,' iwxy=',iwxy,
     *     ' ldev=',ldev,' inum=',inum

      call setn123(icase)       ! set unit vectors for plotter system

      if(isys.le.2) then
         call getbrv(brv)
         if(brv.eq.'i') then
            call redtrc(trc,ntrc) ! select vectors nearest to the origin in ve
         else if(brv.eq.'f'.or.brv.eq.'s') then
c     this is necessary for similarity transformations
c          *****  this should be later than call sitesy(na,x00)
            ihmax=ihmax*2       ! for similarity transformations
         else if(brv.eq.'p') then
            ihmax=ihmax*2       ! for similarity transformations
         end if
      end if

      if(job.gt.2) then
         call quit('job should be less than 3 in this version')
      end if

      if(icase.eq.5) then
         call freadi('q3=',6,q3,1)
         call freadi('q2=',6,q2,1)
         call setq23(q2,q3)
      end if
      if(iatom.eq.1) then
c          read(5,'(5i3)') (icntsm(i),i=1,ne)
           call freadi('icntsm=',ne,icntsm,1)
      end if

c      read(5,'(7f8.5)') amag,orign
      call freadr('amag=',1,amag,1)
      call freadr('orign=',6,orign,0)
      call freadi('ismode=',1,ismode,0)
c     read(5,*) xmin,xmax,ymin,ymax,zmin,zmax,shiftx,shifty
      if(job.ne.2) then
         call freadr('xmin=',1,xmin,1)
         call freadr('xmax=',1,xmax,0)
         call freadr('ymin=',1,ymin,0)
         call freadr('ymax=',1,ymax,0)
         call freadr('zmin=',1,zmin,0)
         call freadr('zmax=',1,zmax,0)
         call freadr('shiftx=',1,shftx,0)
         call freadr('shifty=',1,shfty,0)
      else if(job.eq.2) then
         call freadr('dmin=',1,dmin,1)
         call freadr('dmax=',1,dmax,0)
         call setdminmax(dmin,dmax)
         xmin=-dmax
         xmax=dmax
         ymin=-dmax
         ymax=dmax
         zmin=-dmax
         zmax=dmax
      end if

      call freadi('ncp=',1,ncp,1)
      eps=0.01    ! in angstrome

      do i=1,ncp
         call freadi('npart=',1,npart(i),1)
         call freadi('atm=',npart(i)+1,iatm(0,i),0)
      end do

      if(job.eq.0.or.job.eq.1) then
c        read(5,'(4f8.3)') raplt
         call freadr('raplt=',ne,raplt,1)
         call freadi('icolor=',ne,icolor,1)
c        read(5,'(i3)') nbond
         call freadi('nbond=',1,nbond,1)
         if(nbond.gt.0) then
c        read(5,'(8f8.5)') ie1,ie2,bmin,bmax,bcol,bwdt,klin
            do 700 i=1,nbond
               call freadi('ie1=',1,ie1(i),1)
               call freadi('ie2=',1,ie2(i),0)
               call freadr('bmin=',1,bmin(i),0)
               call freadr('bmax=',1,bmax(i),0)
               call freadi('bcol=',1,bcol(i),0)
               call freadi('bwdt=',1,bwdt(i),0)
               call freadi('klin=',1,klin(i),0)
 700        continue
         end if
c     read(5,'(3i3)') nsl,no1,no2
         call freadi('nsl=',1,nsl,1)
         call freadi('no1=',1,no1,0)
         call freadi('no2=',1,no2,0)
      end if
      if(job.eq.1) then
         call freadc('flnm4=',1,flnm4,1)
         call openfile(3,flnm4,'UNKNOWN')
      end if

      if(amag.eq.0) amag=1.
      if(no1.eq.0) no1=1
      if(no2.eq.0) no2=2*nsl+1
c
      if(icase.eq.5) then
         write(6,*) 'q3=',q3
         write(6,*) 'q2=',q2
      end if

      if(iatom.eq.1) then
           write(6,'(a,10i3)') 'icntsm=',(icntsm(i),i=1,ne)
      end if
      write(6,'(a,f8.5,a,6f8.5,a,i2)')
     *     'amag=',amag,' orign=',orign,' ismode=',ismode
      
      write(6,'(8(a,f8.3))') 'xmin=',xmin,' xmax=',xmax,
     *     ' ymin=',ymin,' ymax=',ymax,' zmin=',zmin,' zmax=',zmax,
     *     ' shiftx=',shftx,' shifty=',shfty
      if(job.eq.2) then
         write(6,'(2(a,f8.3))') 'dmin=',dmin,' dmax=',dmax
      end if

      eps=0.01    ! in angstrome

      xmin=xmin-eps
      xmax=xmax+eps
      ymin=ymin-eps
      ymax=ymax+eps
      zmin=zmin-eps
      zmax=zmax+eps

      write(6,'(a,i2)') 'ncp=',ncp
      do i=1,ncp
         write(6,*) 'npart=',npart(i),' atm=',(iatm(j,i),j=0,npart(i))
         do j=1,npart(i)
            if(getp0(iatm(j,i)).gt.0) then
               call quit('p0 for atm specified is positive')
            end if
         end do
      end do
      if(job.eq.0.or.job.eq.1) then
         write(6,'(a,10f8.3)') 'raplt=',(raplt(i),i=1,ne)
         write(6,'(a,10i3)') 'icolor=',(icolor(i),i=1,ne)
         write(6,'(a,i3)') 'nbond=',nbond
         if(nbond.gt.0) then
            write(6,'(2a)') 'ie1,ie2,bmin(i),bmax(i),bcol(i),',
     *           'bwdt(i),klin(i)'
            do i=1,nbond
               write(6,'(2i3,2f8.2,3i3)') ie1(i),ie2(i),bmin(i),
     *              bmax(i),bcol(i),bwdt(i),klin(i)
            end do
         end if
         write(6,'(3(a,i3))') 'nsl=',nsl,' no1=',no1,
     *        ' no2=',no2
      end if

      xmin0=xmin-1.
      xmax0=xmax+1.
      ymin0=ymin-1.
      ymax0=ymax+1.
      if(isys.le.2) then
         zmin0=zmin-1.
         zmax0=zmax+1.
      else
         zmin0=zmin
         zmax0=zmax
      end if
      call setlimit0(xmin0,xmax0,ymin0,ymax0,zmin0,zmax0)
      call setlimit(xmin,xmax,ymin,ymax,zmin,zmax)

      depth=(zmax0+zmin0)/2
      dx=(xmax0-xmin0)/imax
      dy=(ymax0-ymin0)/imax

      if(job.eq.2) then
         nsl=0                  ! number of slices is zero
      end if

      call vfact(raplt,amag,ne)
      call celltr(orign,1)
      if(ismode.eq.1) then
         call prjext0(orign,qe)
         call vcpyr(qe,orign,6)
         write(6,'(a,6f10.5)') 'orign_i=',orign
      else if(ismode.eq.2) then
         call prjext0(orign,qe)
         call vcpyr(qe,orign,6)
         call vcpyr(qe,orign,6)
         write(6,*) 'orign_e=',orign
      end if
      call vcpyr(orign,shifto,6)
c      write(6,*) 'shifto=',shifto
      call wtvctrrf('shifto=',shifto,6,'(6f10.5)')

      if(icase.eq.0) then
           icase=1
           iixx=0
      else
           iixx=1
      end if

c****  slice loop  (slice along the projection axis)
 1000 continue
c*****unit vectors in the projection plane (n1,n2)********************
c
      nocnt=0
      do isl=-nsl,nsl    ! slice loop
         nocnt=nocnt+1
         if(nocnt.lt.no1.or.nocnt.gt.no2) go to 301
c     3d coordinates of slice center
         do i=1,3
            qb(i)=2*depth*isl*n3(i)
         end do
         abszc=2*depth*isl
         do i=4,6
            qb(i)=0
         end do
         call getxe(qb,zc)
c        find nearlest lattice points of zc
         call sethc(zc)
         mo2=0

         frmt1='(i5,i5,1x,3f10.5,i3)'
         frmt2='(i5,a,i3,a,f6.3,a,e9.3,a,i4,2(a,6f7.3))'

         if(job.ne.2) then
            call setshfto(shifto)  ! set origin at shifto
            call getatm( 1,mo1,job)
            call getdt(dt1)
            call getds(ds1)
            call gettrns(hs1)    ! translation vector
            call getxs(xs1)      ! 3D coordinates
            call getms(ms1)      ! color or OD number
            call getns(ns1)      ! symmetry operation number
            call getuixy(uixy1)  ! anisotropic temp. factor

            call getatm(-1,mo2,job)
            call getdt(dt2)
            call getds(ds2)
            call gettrns(hs2)    ! translation vector
            call getxs(xs2)      ! 3D coordinates
            call getms(ms2)      ! color or OD number
            call getns(ns2)      ! symmetry operation number
            call getuixy(uixy2)  ! anisotropic temp. factor

            call rmvatm(xs1,ds1,hs1,ms1,ns1,mo1,uixy1,
     *           xs2,ds2,hs2,ms2,ns2,mo2,uixy2,no)
            call wtnatom(no,ns)
         else
            do n=1,na
               if(jaslct(n).ne.0) then
                  call setn0(n) ! save n for getdst
                  call getx(n,x)
                  call vcpyr(x,shifto,6)    ! choose x as the origin
                  call setshfto(shifto)     ! position from shifto
                  write(6,*) 'inter-atomic distanses from OD# ',n
                  call getatm( 1,mo1,job)
                  call getdt(dt1)
                  call getds(ds1)
                  call gettrns(hs1) ! translation vector
                  call getxs(xs1) ! 3D coordinates
                  call getms(ms1) ! color or OD number
                  call getns(ns1) ! symmetry operation number
                  call getuixy(uixy1)

                  do i=1,mo1
c                    d=vabs(xs1(1,i),3)
                     d=dst(i)
                     write(6,frmt2) i,' #',ns1(i),' d=',d,' vol=',
     *                    vol(i),' symo.',nss(i),' trns.',
     *                    (hrs(j,i),j=1,6)
                     write(3,frmt2) i,'#',ns1(i),'d=',d,'vol=',
     *                    vol(i),'symo.',nss(i),'trns.',
     *                    (hrs(j,i),j=1,6)
                  end do
               end if
            end do
         end if

         write(6,*) 'before qsort no=',no
         do i=1,no
            zs(i)=xs(3,i)
         end do
         
c     rearrange ds in ascending order of dd
         if(no.gt.nmax) then
            call quit('no > nmax')
         end if

         call wtheader(job,iwxy)
         call qsort(zs,st0,nsd,no)
         if(iwxy.eq.1.or.job.eq.1) then
            call wtxyzbp(no,nsd)
         end if
         if(job.eq.0) then
            call pltatm(no,nsd,star)
         end if
 301     continue
      end do
      if(iixx.eq.0.and.icase.le.4) then
         icase=icase+1
         go to 1000
      end if
      close(3)
      close(4)
      stop
      end

      subroutine wtheader(job,iwxy)
      integer getitempf
      if(job.eq.0) then
         if(iwxy.eq.1) then
            write(6,'(a)') 'no,h,x(1),x(2),icol'
         end if
      else if(job.eq.1) then
         if(getitempf().eq.1) then
            write(6,'(4a)') '  no, atom,     x         y         z  ',
     *           '       u11       u22       u33',
     *           '       u23       u31       u12',
     *           '       p1        p2        p3'
         else
            write(6,'(4a)') '  no, atom,     x         y         z  ',
     *           '       p1        p2        p3'
         end if
      end if
      return
      end

      subroutine rdac(al,cl)
      integer getisys
      isys=getisys()
      if(isys.le.2) then      
         call freadr('a=',1,al,0)
         call seta(al,al) !  am=al necessary for l. phason
         ndm=6
      else
         call freadr('a=',1,al,0)
         call freadr('c=',1,cl,0)
         call seta(al,al) !  am=al necessary for l. phason
         call setc(cl)
c         write(6,*) 'al,cl=',al,cl
         ndm=5
      end if
      call setndm(ndm)
      return
      end

      subroutine ificont(z,ny,flnm3)
      real z(*)
      character*(*) flnm3
c     set ui equivalent to B or Beq equivalent to ui
      call freadi('icont=',1,icont,1)
      call freadc('flnm3=',1,flnm3,1)
      write(6,*) 'icont=',icont
      call seticont(icont)      ! set icont for setxbp

      if(icont.eq.1) then       ! read independent parameters from a file
         call openfile(4,flnm3,'OLD')
         read(4,212) (z(j),j=1,ny)
c        write(6,212)  (z(j),j=1,ny)
 212     format(8e14.6)
      else
         call openfile(4,flnm3,'UNKNOWN')
      end if
      return
      end

      subroutine rdeps(eps1,eps2,eps3,eps4,eps5,eps6)
      call freadr('eps1=',1,eps1,0)
      call freadr('eps2=',1,eps2,0)
      call freadr('eps3=',1,eps3,0)
      call freadr('eps4=',1,eps4,0)
      call freadr('eps5=',1,eps5,0)
      call freadr('eps6=',1,eps6,0)
      return
      end

      subroutine setn0(n)
      common /csetn0/ n0
      n0=n
      return
      end

      integer function getn0()
      common /csetn0/ n0
      getn0=n0
      return
      end

      subroutine setq23(q2d,q3d)
      integer q3d(*),q2d(*)
      integer q2,q3
      common /cq23/ q2(6),q3(6)
      call vcpyi(q2d,q2,6)
      call vcpyi(q3d,q3,6)
      return
      end

      subroutine getq23(q2d,q3d)
      integer q3d(*),q2d(*)
      integer q2,q3
      common /cq23/ q2(6),q3(6)
      call vcpyi(q2,q2d,6)
      call vcpyi(q3,q3d,6)
      return
      end

      subroutine setiaslct()  ! set iaslct
      include 'qcstrc.inc'
      common /cislct0/ iaslct0(120,namax)
      common /cislct/ iaslct(120,namax),jaslct(namax)
      integer geticnt,getnsym,getish,getna
      na=getna()
      write(6,*) 'na in setirsd=',na
      icent=geticnt()
      nsymo=getnsym()
      do j=1,na
         if(getish(j).gt.0) then  ! polyhedral OD
            call vcpyi(iaslct0(1,getish(j)),iaslct(1,j),
     *           nsymo*(abs(icent)+1))
         end if
      end do
      return
      end

      subroutine setirsd()  ! set site symmetry operators used
      include 'qcstrc.inc'
      common /cislct/ iaslct(120,namax),jaslct(namax)
      integer irs(0:120)
      integer geticnt,getnsym,getish,getna
      na=getna()
c     write(6,*) 'na in setirsd=',na
      icent=geticnt()
      nsymo=getnsym()
      write(6,*) 'site symmetry operator used'
      do n=1,na
         if(getish(n).gt.0) then  ! polyhedral OD
            irs0=0
            do i=1,nsymo*(1+abs(icent))
               if(iaslct(i,n).eq.1) then
                  irs0=irs0+1
                  irs(irs0)=i
               end if
            end do
            irs(0)=irs0
         end if
         call setirs(n,irs)   ! save site symmetry op. used for n-th atom
         write(6,'(a,i3,2x,20i4/(10x,20i4))')
     *        'atom=',n,(irs(j),j=1,irs(0))
      end do
      return
      end

      subroutine pltatm(no,nsd,star)   ! plot atoms
      character star(*)
      integer nsd(*)
      include 'qcstrc.inc'
      common /csave1/ dt(nmax),ds(nmax),xs(3,nmax),hs(6,nmax)
      common /csave2/ ms(nmax),ns(nmax)
      real xy(3),x1(3),x2(3),xw(3)
      real h(6),h1(6),h2(6)
      common /ccolor/ icolor(namax),raplt(nemax)
      integer bcol,bwdt
      common /cbond/ nbond,ie1(20),ie2(20),bmin(20),bmax(20),bcol(20),
     *     bwdt(20),klin(20)
      common /ccntsm/ icntsm(nemax)
      common /cplt/ job,icase,ihmax,iatom,iwxy,ldev,amag,shftx,shfty
      common /cnum/ inum
      character*2 text
      integer getisys
      call geta(al,am)
      isys=getisys()
      call plots(0.0,0.0,ldev)
c     call plot(shftx,shfty,-3)
      call getlimit(xmin,xmax,ymin,ymax,zmin,zmax)
      call wtbox(xmin,ymin,xmax,ymax,amag,shftx,shfty)
      do ib=1,nbond
         write(6,'(a)') 'bond length'
         call lntyp(klin(ib)*10)
         do i=1,no
            do j=i+1,no
               do k=1,3
                  x1(k)=xs(k,nsd(i))*amag
                  x2(k)=xs(k,nsd(j))*amag
                  xy(k)=x1(k)-x2(k)
               end do
               icol1=ms(nsd(i))
               icol2=ms(nsd(j))
               do k=1,6
                  h1(k)=hs(k,nsd(i))
                  h2(k)=hs(k,nsd(j))
               end do
               if(isys.le.2) then
                  dw=vabs(xy,3)/amag
               else
c     dw=vabs(xy(1),2)/amag
                  dw=vabs(xy,3)/amag
               end if
               if(icol1.eq.ie1(ib).and.icol2.eq.ie2(ib).or.
     *              icol1.eq.ie2(ib).and.icol2.eq.ie1(ib)) then
                  if (dw.gt.bmin(ib).and.dw.lt.bmax(ib)) then
                     call setcol(bcol(ib))
                     call newpen(bwdt(ib))
                     call draw(x1(1),x1(2),x2(1),x2(2))
                     if(iwxy.eq.1) then
c     write(6,'(6i2,1x,6i2,2f10.5)') h1,h2,dw
                        write(6,'(6f4.1,1x,6f4.1,2f10.5)')
     *                       h1,h2,dw
                     end if
                  end if
               end if
            end do
         end do
      end do

      call newpen(1)            ! reset linwidth
      if(iatom.eq.1) then       ! write atoms
         n=0
         do i=1,no
            ii=nsd(i)
            ii=i
            xy(1)=xs(1,ii)*amag
            xy(2)=xs(2,ii)*amag
            xy(3)=xs(3,ii)*amag
            xw(1)=xs(1,ii)
            xw(2)=xs(2,ii)
            xw(3)=xs(3,ii)
c     call vcpyi(hs(1,ii),h,6)
            call vcpyr(hs(1,ii),h,6)
c     ic=ms(ii)
            ic=abs(ms(ii))
            if(iwxy.eq.1) then
               n=n+1
c              rr=dep*al
               write(6,'(i5,2x,6f4.1,2x,2f10.5,i3)')
     *              n,h,xw(1),xw(2),ic
            end if
            rc=raplt(ic)
            if(ms(ii).gt.0) then
               icol=icolor(ic)
            else if(ms(ii).lt.0) then
               if(icolor(ic).eq.0) then
                  icol=10
               else if(icolor(ic).eq.10) then
                  icol=0
               end if
            else
               call quit('ms(ii)=0 in pltatm')
            end if
            ics=icntsm(ic)
            if(ics.ge.0.and.ics.le.5) then
               call cntsymd(0.0,ics,rc,xy,icol)
            else
               call quit('center symbol incorrect')
            end if
            if(inum.eq.1) then
               if(ns(ii).le.9) then
                  write(text,fmt='(i1)') ns(ii)
                  nchr=1
               else 
                  write(text,fmt='(i2)') ns(ii)
                  nchr=2
               end if
               call csymbol(xy(1),xy(2)+0.05,0.16,text,0.,nchr)
            end if
            call fillarea(0)
         end do
      end if
      if(ldev.eq.1.or.ldev.eq.2) then
         call plote('end of plot')
c     call getzap()
      end if
      return
      end

      subroutine wrthkl(hkl)
      integer hkl(*)
      integer getndm
      ndm=getndm()
      write(6,'(a,6i4)') 'hkl=',(hkl(j),j=1,ndm)
      return
      end

      integer function getihdmi()
      character brv
      call getbrv(brv)
      if(brv.eq.'p') then
         ihdm=1                 ! primitive
      else if(brv.eq.'f'.or.brv.eq.'s') then  ! face-centered
         ihdm=0                 
      else if(brv.eq.'g') then  ! groupoid
         ihdm=0 
      else
         call quit(' body-centered lattice unimplimented')
      end if
      getihdmi=ihdm
      return
      end

      integer function getihdmd()
      character brv
      call getbrv(brv)
      if(brv.eq.'c') then
         ihdm=1
      else if(brv.eq.'g') then
         ihdm=0
      else
         ihdm=0
      end if
      getihdmd=ihdm
      return
      end

      subroutine getatm(ipsig,no,jobd)
      include 'qcstrc.inc'
      common /cnpart/ ncp, npart(namax),iatm(0:namax,namax)
      integer getisys
      isys=getisys()
      if(ipsig.eq.-1.and.ncp.eq.0) then
         no=0
         return
      end if
      if(isys.le.2) then
         call getatmi0(ipsig,no,jobd)
      else
         call getatmd0(ipsyg,no,jobd)
      end if
      return
      end

      subroutine getatmi0(ipsig,no,jobd)
      include 'qcstrc.inc'
      common /cnatm/ natom(namax)
      character brv
      integer isk(0:120)
      real shifto(6)
      common /cplt/ job,icase,ihmax,iatom,iwxy,ldev,amag,shftx,shfty
      common /clmt1/ ram,rbm,dx,dy,n1(6),n2(6),n3(6),n3x
      parameter (mmax=100000)
      parameter (nl2=1000)
      parameter (imax=30)       !  parameter (imax=15)
      common /ccolor/ icolor(namax),raplt(nemax)
      common /cislct/ iaslct(120,namax),jaslct(namax)
      common /cgetat/ isl2(imax+1,imax+1,nl2),nsl2(imax+1,imax+1)
      real ra(namax),rb(namax)
      character star(mmax)
      real q(6),qd(6)
      real hr(6),rx(6),ry(6),rz(6),rx0(6)
      real h(6),hd(6)
      real x(6),x0(6),x1(6),x2(6),xd(6)
      real xy(3)   ! coordinates in cubic coordinate sys. with a=1
      real uixy(6) ! anisotropic temperature factor in cubic coordinate sys.
      common /cpcol/ pcol
      common /ceps/ epsd
      real ht(6)
      integer natm(namax),iski(0:120)
      integer pcol
      real td(6)
      common /ctrc/ trc(6,32),trcd(6,32), ntrc
      integer rh(6,6,60)
      real th(6,60)
      integer ityp(namax)
      integer ii(6)
      integer hmax(6),mm(7)
      integer select
      integer getndm,geticnt,getish,getien,getna,getapprx,getcol
      integer getihdmi,getntrc,getisim
c     include 'nhkl.inc'
      data eps/0.00001/
c     data td/6*0./
c     data ht/1.0,0.5,0.5,0.5,0.5,0.5/
      data ht/0.5,0.,0.,0.,0.,0./
c********initialize
      call getityp(ityp)
      call getiski(iski)
      call getbrv(brv)
      call geta(al,am)
      na=getna()
      do i=1,na
         ra(i)=getramin(i)
         rb(i)=getramax(i)
      end do
      ihdm=getihdmi()
      call gethul(rh,th,ig)
c     write(6,*) 'ihmax=',ihmax
      call gethmaxi(hmax,ihmax)
c     call wrthkl(hmax)
      call getmm(hmax,mm,nt)
      call getshfto(shifto)
      isim=getisim()
      no=0
      do nd=1,nt   ! lattice vector loop
         call gethkl(nd,hmax,ii,mm)  ! get lattice vector ii
c        call wtvctri('ii=',ii,6)
         call vcpyir(ii,hd,6)        ! copy integer vector to real vector
         if(brv.eq.'f'.or.brv.eq.'s'.or.brv.eq.'p') then
            if(iprty(ii,2).eq.1) go to 106  ! skip odd parity sublattice
c           even parity sublattice
         end if
         
         do ihd=0,ihdm            ! 0 even parity sublattice 1 odd parity one
            call smtrx(hd,h,isim) ! similarity transformation for f-lattice
            do i=1,6
               h(i)=h(i)/2        ! include centering translations
            end do
c           write(6,'(a,i2,12f6.2)') 'iprty,hd,h=',iprty(ii,2),hd,h
            if(brv.eq.'p') then
c              add odd parity sublattice for brv='p'
               do i=1,6
                  h(i)=h(i)+ht(i)*ihd ! ihd=0 even ihd=1 odd sublattice
                  h(i)=h(i)*2   ! only for primitive lattice
               end do
            end if
c           call vsub(h,shifto,hr,6)  ! hr : lattice vector from selected org.
            call vcpyr(h,hr,6)        ! hr : lattice vector
            call seths(h)              ! for inter atomic dist.
c     *********  atom loop
            do n=1,na
               if(jaslct(n).eq.0) go to 201
               if(ipsig.eq. 1.and.getp0(n).lt.0) go to 201
               if(ipsig.eq.-1.and.getp0(n).gt.0) go to 201
               icol=getcol(n)
c               call getx(n,x)      ! get coordinate of OD (in 6D space)
c               call vsub(x,shifto,x1,6) ! x1: coordinate from shifto
c              call getx0(n,x0)    ! get coordinate of Large OD (in 6D space)
c              call vsub(x,x0,x1,6) ! x-x0

               call geticistp(n,icentd,istep)
               if(brv.eq.'g') then
                  itce=ig
               else
                  itce=1
               end if
               call getisk(n,isk)
               do itc=1,itce             ! hull elements for the groupoid
                  do icnt=0,icentd,istep !  symmetry operator loop
                     do nsd=1,isk(0)     ! equivalent site
                        nsy=isk(nsd)     ! symmetry operator generating eq.atm
                        call setnsic(nsy,icnt)    ! set current symo.

c                       ! ***** test when nsy is included in the site sym. grp. for x0c 
c                       call getrx(x1,x2,nsy,icnt) ! site equivalent to x
c                       call vsum(x2,x0,ry,6)     ! add x0
c                       ! ***************
c                        call getrx2(x1,ry,nsy,icnt) ! site equivalent to x (rotation around shifto)
c                       call getrx(x,ry,nsy,icnt) ! site equivalent to x
                        call getrx00d(n,nsy,icnt,rx) ! rotated position x under phason
                        call vsub(rx,shifto,ry,6)
                        call reduc(ry)            ! reduced coordinates
                        call addhrryi(hr,ry,rx,itc) ! rx=hr+ry+trc(itc)
                        call getqed(rx,qd)        ! qd distorted for polyhd
                        call vcpyr(qd,q,6)
                        call trcs(qd,xy)          ! plotter system coord. xy
                        if(iflimit(xy).eq.1) go to 204
                        call vcpyr(q,qd,6)
                        ito204=ifatmi(qd,n)  ! -qd in n-th OD 0 else 1
                        if(ito204.eq.1) go to 204
                        call setifatm(ito204)
c                       write(6,*) 'before setodn, n=',n
                        call setodn(n)       ! set OD number, n, for select
                        islct=select(no,xy,h,icol,3,isl2,
     *                       nsl2,imax,nl2)
                        if(no.ge.mmax) then
                           write(6,'(a)') '*** no >= mmax **'
                           go to 108
                        end if
 204                    continue
                     end do
                  end do
               end do
 201           continue
            end do
         end do
 106     continue
      end do
 108  continue
********end of atom loop********
      return
      end

      subroutine getihik(xy,ih,ik)
      real xy(*)
      common /climit0/ xmin0,ymin0,xmax0,ymax0,zmin0,zmax0,depth0
      common /clmt1/ ram,rbm,dx,dy,n1(6),n2(6),n3(6),n3x
      ih=(xy(1)-xmin0)/dx+1
      ik=(xy(2)-ymin0)/dy+1
      return
      end

      subroutine gethmaxi(hmax,ihmax)
      integer hmax(*)
      integer getndm
      ndm=getndm()
      do i=1,ndm
         hmax(i)=ihmax
      end do
      do i=ndm+1,6
         hmax(i)=1
      end do
      return
      end

      subroutine gethmaxd(hmax,ihmax)
      integer hmax(*)
      integer getndm
      ndm=getndm()
      do i=1,ndm-1
         hmax(i)=ihmax
      end do
      do i=ndm,6
         hmax(i)=1
      end do
      return
      end

      function iprty(h,n)
      integer h(*)
      ip=0
      do i=1,6
         ip=ip+h(i)
      end do
      iprty=mod(ip,n)
      if(iprty.lt.0) then
         iprty=iprty+n
      end if
      return
      end

c     generation of atom position in dihedral cases
      subroutine getatmd0(ipsig,no,jobd)
      include 'qcstrc.inc'
      character brv
      common /cislct/ iaslct(120,namax),jaslct(namax)
      integer hc(6)
      real shifto(6)

      common /cplt/ job,icase,ihmax,iatom,iwxy,ldev,amag,shftx,shfty
      parameter (mmax=100000)
      parameter (nl2=1000)
      parameter (imax=30)       !  parameter (imax=15)
      common /ccolor/ icolor(namax),raplt(nemax)
      real n1,n2,n3,n3x
      common /clmt1/ ram,rbm,dx,dy,n1(6),n2(6),n3(6),n3x
      common /cgetat/ isl2(imax+1,imax+1,nl2),nsl2(imax+1,imax+1)
      real xy(3)
      real ra(namax),rb(namax)
      character star(mmax)
      real q(6),qd(6)
      real hr(6),rx(6),ry(6),rz(6),rx0(6)
      integer rh(6,6,60)
      real th(6,60)
      real h(6),hd(6)
      real hh(6)
      real x(6),x0(6),x1(6),xd(6)
      integer select
      integer getndm,geticnt,getish,getien,getna,getapprx,getcol
      integer getihdmd,getisim
      common /cpcol/ pcol
      common /ceps/ epsd
      integer iski(0:120),isk(0:120)
      common /cnatm/ natom(namax)
      integer ityp(namax)
      integer pcol
      real td(6),ht(6)
      integer ii(6)
      integer hmax(6),mm(7)

      data eps/0.00001/
c     data td/6*0./
c********initialize
      call getityp(ityp)
      call getiski(iski)
      call getbrv(brv)
      call geta(al,am)
      na=getna()
      do i=1,na
         ra(i)=getramin(i)
         rb(i)=getramax(i)
      end do
      ihdm=getihdmd()
      call gethul(rh,th,ig)
      call gethmaxd(hmax,ihmax)
c     call wrthkl(hmax)
      call getmm(hmax,mm,nt)
      call getshfto(shifto)
      isim=getisim()

      no=0
      do nd=1,nt  ! lattice vector loop
         call gethkl(nd,hmax,ii,mm)
         ii(6)=0
c*********lattice vector loop
         call gethc(hc)
         call vsumir(ii,hc,hh,6)
         call vcpyr(hh,hd,6)
         call smtrx(hd,h,isim) ! similarity transformation for f-lattice
c        call vsub(h,shifto,hr,6)
         call vcpyr(h,hr,6)
         hr(6)=0
         call seths(h)          ! for inter atomic dist.

         do ihd=0,ihdm          ! centering translation for color group
            do n=1,na
               if(jaslct(n).eq.0) go to 201
               if(ipsig.eq. 1.and.getp0(n).lt.0) go to 201
               if(ipsig.eq.-1.and.getp0(n).gt.0) go to 201
               call getx(n,x)
               call vsub(x,shifto,x1,6) ! x1: coordinate from shifto
               call geticistp(n,icentd,istep)
               if(brv.eq.'g') then
                  itce=ig
               else
                  itce=1
               end if
               call getisk(n,isk)
               do itc=1,itce              ! hull elements for the groupoid
                  do icnt=0,icentd,istep  ! symmetry operator loop
                     do nsd=1,isk(0)      ! equivalent site
                        nsy=isk(nsd)
                        call setnsic(nsy,icnt)    ! set current symo
c                       call getrx(x,ry,nsy,icnt) ! equivalent site
                        call getrx2(x1,ry,nsy,icnt)
                        call reduc(ry)
                        call addhrryd(hr,ry,rx,itc,ihd) ! rx=hr+ry
                        icol=getcol(n)

                        if(rx(6).eq.-1.) then  ! for color symmetry
                           icol=-icol
                        end if

                        call getqed(rx,qd)   ! distorted for polyg
                        call trcs(qd,xy)
                        if(iflimit0(xy).eq.1) go to 204
                        ito204=ifatmd(qd,n)  ! -qd in n-th OD 0 else 1
                        if(ito204.eq.1) go to 204

                        call getihik(xy,ih,ik)
                        call setifatm(ito204)
                        call setodn(n)       ! set OD number, n, for select
                        islct=select(no,xy,h,icol,3,isl2,
     *                       nsl2,imax,nl2)
                        if(no.ge.mmax) then
                           write(6,'(a)') '*** no >= mmax **'
                           go to 108
                        end if
 204                    continue
                     end do
                  end do
               end do
 201           continue
            end do
         end do
 106     continue
      end do
 108  continue
********end of atom loop********
      return
      end

      subroutine geticistp(n,icentd,istep)
      integer geticnt
      icent=geticnt()
      if(icent.eq.0.or.getmpl(n).lt.0.51) then
         icentd=0
         istep=1
      else 
         icentd=icent           ! 1 or -1
         istep=icent
      end if
c      write(6,*) 'icentd,istep=',icentd,istep
c      stop
      return
      end

      integer function getjob()
      common /cplt/ job,icase,ihmax,iatom,iwxy,ldev,amag,shftx,shfty
      getjob=job
      return
      end

      subroutine setlimit(xmind,xmaxd,ymind,ymaxd,zmind,zmaxd)
      common /climit/ xmin,ymin,xmax,ymax,zmin,zmax,depth
      xmin=xmind
      xmax=xmaxd
      ymin=ymind
      ymax=ymaxd
      zmin=zmind
      zmax=zmaxd
      return
      end

      subroutine getlimit(xmind,xmaxd,ymind,ymaxd,zmind,zmaxd)
      common /climit/ xmin,ymin,xmax,ymax,zmin,zmax,depth
      xmind=xmin
      xmaxd=xmax
      ymind=ymin
      ymaxd=ymax
      zmind=zmin
      zmaxd=zmax
      return
      end

      function iflimit(xy)
      real xy(*)
      common /climit/ xmin,ymin,xmax,ymax,zmin,zmax,depth
      if(xy(1).lt.xmin.or.xy(1).gt.xmax.or.
     *     xy(2).lt.ymin.or.xy(2).gt.ymax.or.
     *     xy(3).lt.zmin.or.xy(3).gt.zmax) then
         iflimit=1
      else
         iflimit=0
      end if
      return
      end

      function iflimit0(xy)
      real xy(*)
      common /climit0/ xmin0,ymin0,xmax0,ymax0,zmin0,zmax0,depth0
      if(xy(1).lt.xmin0.or.xy(1).gt.xmax0.or.
     *     xy(2).lt.ymin0.or.xy(2).gt.ymax0.or.
     *     xy(3).lt.zmin0.or.xy(3).gt.zmax0) then
         iflimit0=1
      else
         iflimit0=0
      end if
      return
      end

      subroutine setlimit0(xmind,xmaxd,ymind,ymaxd,zmind,zmaxd)
      common /climit0/ xmin0,ymin0,xmax0,ymax0,zmin0,zmax0,depth0
      xmin0=xmind
      xmax0=xmaxd
      ymin0=ymind
      ymax0=ymaxd
      zmin0=zmind
      zmax0=zmaxd
      return
      end

      subroutine getlimit0(xmind,xmaxd,ymind,ymaxd,zmind,zmaxd)
      common /climit0/ xmin0,ymin0,xmax0,ymax0,zmin0,zmax0,depth0
      xmind=xmin0
      xmaxd=xmax0
      ymind=ymin0
      ymaxd=ymax0
      zmind=zmin0
      zmaxd=zmax0
      return
      end

      integer function getcol(n)
      common /cplt/ job,icase,ihmax,iatom,iwxy,ldev,amag,shftx,shfty
      integer getien
      if(job.ne.1) then
         getcol=getien(n)
      else
         getcol=n
      end if
      return
      end

      function lttcp(h)
      real h(*)
      data eps /0.00001/
      do i=1,4
         if(abs(mod(h(i),1.)).gt.eps) then
            lttcp=0
            return
         end if
      end do
      lttcp=1
      return
      end

      subroutine wtnatom(no,ns)
      integer ns(*)
      include 'qcstrc.inc'
      common /cnatm/ natom(namax)
      integer getna
      na=getna()
      do i=1,na
         natom(i)=0
      end do
      do j=1,no
         do i=1,na
            if(ns(j).eq.i) then
               natom(i)=natom(i)+1
               go to 998
            end if
         end do
 998     continue
      end do
      write(6,'(a)') 'number of points for each atom'
      write(6,'(a,10i6/(6x,10i6))') 'natom=',(natom(j),j=1,na)
      return
      end
    
      function ivcomp(x,y)
      real x(3),y(3)
      data eps /0.00001/
c        if x=y then ivcomp=1 else 0
      if(abs(x(1)-y(1)).lt.eps.and.
     *   abs(x(2)-y(2)).lt.eps.and.
     *   abs(x(3)-y(3)).lt.eps) then
         ivcomp=1
      else
         ivcomp=0
      end if
      return
      end

      function ifskp(n,m)
      include 'qcstrc.inc'
      common /cnpart/ ncp, npart(namax),iatm(0:namax,namax)
      do i=1,ncp
         if(iatm(0,i).eq.n) then
            ifskp=0
            m=i
c           atom n has concave parts in the occupation domain
            return
         end if
      end do
c           atom n has no concave parts in the occupation domain
      ifskp=1
      return
      end

****************????
      subroutine isskp(x,isk,i)
      real x(*),rx(6),rxs(6,120)
      integer isk(0:120,*)
      integer geticnt,getnsym
      icent=geticnt()
      nsymo=getnsym()
      n=1
      isk(i,1)=0
      call vcpyr(x(1),rxs(1,n),6)
c     do k=0,icent
      do k=0,abs(icent)
         do j=2,nsymo
            isk(i,j)=0
            call getrx(x,rx,j,k)
            inew=newatm(n,rx,rxs)
            if(inew.eq.0) isk(i,j)=1
         end do
      end do
c     write(6,'(60i1)') (isk(i,j),j=1,nsymo)
      return
      end
****************????
   
      integer function newatm(n,rx,rxs)
      real rx(6),rxs(6,*)
c***    zero translation vector is assumed
      integer getisys
      data eps/0.0001/
      isys=getisys()
      if(isys.le.2) then
         jend=6
      else
         jend=5
      end if
      do i=1,n
c     do j=1,6
         do j=1,jend
            if(abs(rx(j)-rxs(j,i)).ge.eps) go to 100
         end do
         newatm=0
         return
 100     continue
      end do
      n=n+1
      do j=1,6
         rxs(j,n)=rx(j)
      end do
      newatm=1
      return
      end

      subroutine seths(hs)
      real hs(*)
      common /cifatm2/ x(6),h(6)
      call vcpyr(hs,h,6)
      return
      end

      subroutine geths(hs)
      real hs(*)
      common /cifatm2/ x(6),h(6)
      call vcpyr(h,hs,6)
      return
      end

      subroutine setifatm(ifatmd)
      common /cifatm1/ ifatm
      ifatm=ifatmd
      return
      end

      integer function getifatm()
      common /cifatm1/ ifatm
      getifatm=ifatm
      return
      end

      subroutine setvol(vold)
      common /cvol1/ vol
      vol=vold
      return
      end

      function getvol()
      common /cvol1/ vol
      getvol=vol
      return
      end

      subroutine redtrc(trc,ntrc)
      real trc(6,32)
c      select vectors nearest to the origin in vi
      real xd(6),trcd(6),trcm(6),q(6)
      integer hmax(6),mm(7),ji(6)
      integer getisys
      isys=getisys()
      do i=1,6
         hmax(i)=1
      end do
c     call wrthkl(hmax)
      call getmm(hmax,mm,nt)
      write(6,*) 'trc with smallest vi component'
      if(isys.le.2) then
         do i=1,ntrc
            n=0
            do nd=1,nt
               call gethkl(nd,hmax,ji,mm)               
               call vcpyir(ji,xd,6)
               n=n+1
               call vsum(trc(1,i),xd,trcd,6)
               call getqe(trcd,q)
               if(n.eq.1) then
                  vmin=vabs(q(4),3)
                  call vcpyr(trcd,trcm,6)
               else if(vabs(q(4),3).lt.vmin) then
                  vmin=vabs(q(4),3)
                  call vcpyr(trcd,trcm,6)
               end if
            end do
            call vcpyr(trcm,trc(1,i),6)
c     write(6,'(a,6f5.1)') 'trc=',(trc(k,i),k=1,6)
         end do
      else
         call quit('invalid isys in redtrc')
      end if
      return
      end

      function iext(h)
      integer h(*)
      iext=1
      ii=mod(h(1)+h(2)+h(3)+h(4)+h(5)+h(6),2)
      if(ii.eq.1.or.ii.eq.-1) iext=0
      return
      end

      subroutine trcs(x,y)
      real x(*),y(*)
      real n1,n2,n3,n3x
      common /clmt1/ ram,rbm,dx,dy,n1(6),n2(6),n3(6),n3x
c*****transformation of coordinate systems********************
c     x: coordinates in primary system
c     y: coordinates in plotter system
c        y(1),y(2) are x and y coordinates in plotter system
      y(1)= vinpr(n1,x,3)
      y(2)= vinpr(n2,x,3)
      y(3)= vinpr(n3,x,3)
      return
      end

      subroutine openfile(iun,flnm,st)
      integer iun
      character*(*) flnm,st
      lflnm=istrln(flnm)
      lst=istrln(st)
      open (unit=iun,file=flnm(1:lflnm),status=st(1:lst),err=910)
      go to 810
 910  write(6,*) 'can''t open ',flnm(1:lflnm)
      call exit(1)
 810  continue
      return
      end

