      subroutine setiavrg(id,iavrgd)
      include 'qcdiff.inc'
      common /cavrg/ iavrg(idsmax)
      iavrg(id)=iavrgd
      return
      end

      integer function getiavrg(id)
      include 'qcdiff.inc'
      common /cavrg/ iavrg(idsmax)
      getiavrg=iavrg(id)
      return
      end

      integer function getnds()
      include 'qcdiff.inc'
      common /ctorms0/ job,ids,mthd(idsmax)
      getnds=ids
      return
      end


      subroutine wtfout3(nind)
      include 'qcdiff.inc'
      real foind(nhkl),woind(nhkl)
      integer hind(6,nhkl)
      common /cfind/ foind,woind,hind
      character*(80) frmt
      integer getndm
      nde=getndm()
      idm=3+nde
      if(idm.eq.5) then
         frmt='(5i4,4x,2f11.5)'
      else
         frmt='(6i4,4x,2f11.5)'
      end if
      do i=1,nind
         write(6,frmt) (hind(j,i),j=1,idm),foind(i),woind(i)
      end do
      return
      end

      subroutine setiweq(iweqd)
      common /ciweq/ iweq
      iweq=iweqd
      return
      end

      integer function getiweq()
      common /ciweq/ iweq
      getiweq=iweq
      return
      end

      subroutine average(nfobs,sgn,isgn)
      include 'qcdiff.inc'
      real foind(nhkl),woind(nhkl)
      integer hind(6,nhkl)
      common /cfind/ foind,woind,hind
      complex fc
      real qk
      integer hklm,fmpl
      common /chklfm/ hklm(6,nhkl),qk(nhkl),fmpl(nhkl),fc(nhkl),
     *   fo(nhkl),theta0(nhkl),ext(nhkl),wg(nhkl),sigmf(nhkl)
      common /cim/ im(20)
      integer getnds,getndm
      integer imd(0:20),ind(0:20)

      nds=getnds()
      nde=getndm()
      idm=3+nde
c     write(6,*) 'nds,idm=',nds,idm
      inde=max(1,nds)
      imd(0)=0
      ind(0)=0
      do inds=1,inde
         imd(inds)=imd(inds-1)+im(inds)
      end do

      nfind=0                   ! sum of independent reflections
      do inds=1,inde            ! runs over number of data sets
         nfob=imd(inds)-imd(inds-1)
         k=imd(inds-1)  ! offset
         call average0(k,nfob,sgn,isgn,nind)
         ind(inds)=nind         ! number of independent refl. in inds-th data
         nfind = nfind+nind
      end do
      
c      call wtvctrif('number of independent reflections',
c     *     ind(1),inde,'(20i6)')
c     call wrtfhkl(hind,foind,woind,nfobs)

      call vcpyi(ind,im,inde+1) ! copy ind to im
c     call wtvctrif('im=',im,inde+1,'(20i6)')
      do i=1,nfind
         call vcpyi(hind(1,i),hklm(1,i),idm)
         fo(i)=foind(i)
         sigmf(i)=woind(i)
      end do
      nfobs=nfind  ! replace nfobs by nfind
c      call wrtfhkl(hklm,fo,sigmf,nfobs)
      return
      end

      subroutine wtequiv(ihkl,fobs,wcor)
      integer ihkl(6)
      integer getndm
      character*50 frmt
      nde=getndm()
      idm=3+nde
      if(idm.eq.3) then
         frmt='(3i4,2f10.2,6f10.5)'
      else if(idm.eq.4) then
         frmt='(4i4,2f10.2,6f10.5)'
      else if(idm.eq.5) then
         frmt='(5i4,2f10.2,6f10.5)'
      else if(idm.eq.6) then
         frmt='(6i4,2f10.2,6f10.5)'
      else
         write(6,*) 'idm=',idm
         call quit('invalid idm in wtequiv')
      end if
      write(6,frmt) (ihkl(k),k=1,idm),fobs,wcor
      return
      end

      function iequiv(h,h0) 
c     if h is equivalent to h0 iequiv=1 else 0
c     if h is equivalent to -h0 iequiv=-1 in noncentrosymmetric case
      integer h(6),h0(6)
      integer hr(6)
      call getnsyic(nsymo,icent)
      do ic=0,icent
         do ns=1,nsymo
            call gethr0(h,hr,ns,ic)
            if(icomp(hr,h0).eq.1) then
               iequiv=1
               return
            end if
         end do
      end do
      if(icent.eq.1) then
         iequiv=0
         return
      end if

      call getiand(iand)
      if(icent.eq.0.and.iand.eq.0) then
         do ns=1,nsymo
            call gethr0(h,hr,ns,1)
            if(icomp(hr,h0).eq.1) then
               iequiv=-1
               return
            end if
         end do
      end if
      iequiv=0
      return
      end

      subroutine getabsymc(absy,ihkl,nfobs)
c     get absolute value of diffraction vector for modulated structures
      real absy(*)
      integer ihkl(6,*)
      common /kwave/ y(3,3,3),vc(3)
      real ys(3)
      integer getndm
      nde=getndm()
      do i=1,nfobs
         do j=1,3
            ys(j)=ihkl(j,i)
            do k=1,nde
               ys(j)=ys(j)+ihkl(3+k,i)*y(j,k,1)
            end do
         end do
         call yyy(ys)
         absy(i)=vabs(ys,3)
      end do
      return
      end

      subroutine getabsyqc(absy,ihkl,nfobs)
c     get absolute value of diffraction vector for quasicrystals structures
      real absy(*)
      integer ihkl(6,*)
      real q(6)
      do i=1,nfobs
         call getqi(ihkl(1,i),q)
         absy(i)=vabs(q,3)
      end do
      return
      end

      subroutine seteqiv(neq,ii,iweq)
      include 'qcdiff.inc'
      real foind(nhkl),woind(nhkl)
      integer hind(6,nhkl)
      common /cfind/ foind,woind,hind

      complex fc
      real qk
      integer hklm,fmpl
      common /chklfm/ hklm(6,nhkl),qk(nhkl),fmpl(nhkl),fc(nhkl),
     *   fo(nhkl),theta0(nhkl),ext(nhkl),wg(nhkl),sigmf(nhkl)

      integer hklmeq(6,240)
      real fobseq(240)
      real wobseq(240)
      integer isk(240)
      integer lfeq(240)
      real fslct(240)
      common /cfeqiv/ hklmeq,fobseq,wobseq,isk,lfeq,fslct

      fslct(neq)=fo(ii)
      if(iweq.eq.1) then
         call wtequiv(hklm(1,ii),fo(ii),sigmf(ii))
      end if
      call vcpyi(hklm(1,ii),hklmeq(1,neq),6)
      fobseq(neq)=fo(ii)
      wobseq(neq)=sigmf(ii)
c      write(6,*) 'neq,fobseq(neq),wobseq(neq)=',
c     *     neq,fobseq(neq),wobseq(neq)
      return
      end

      subroutine chksigcnd(neq,jj,sgn,isgn)
      include 'qcdiff.inc'
      real foind(nhkl),woind(nhkl)
      integer hind(6,nhkl)
      common /cfind/ foind,woind,hind

      complex fc
      real qk
      integer hklm,fmpl
      common /chklfm/ hklm(6,nhkl),qk(nhkl),fmpl(nhkl),fc(nhkl),
     *   fo(nhkl),theta0(nhkl),ext(nhkl),wg(nhkl),sigmf(nhkl)

      integer hklmeq(6,240)
      real fobseq(240)
      real wobseq(240)
      integer isk(240)
      integer lfeq(240)
      real fslct(240)
      common /cfeqiv/ hklmeq,fobseq,wobseq,isk,lfeq,fslct

      integer getiweq
      iweq=getiweq()
      call getwght(iwght)
      if(isgn.eq.0) then
         if(iwght.eq.2) then
            sgni=sgn*((fo(jj)+sigmf(jj))**2-fo(jj)**2)
            if(fo(jj)**2.ge.sgni) then
               neq=neq+1
               call seteqiv(neq,jj,iweq)
            end if
         else
            neq=neq+1
            call seteqiv(neq,jj,iweq)
         end if
      else if(isgn.eq.1) then
         if(iwght.eq.2) then
            if(fo(jj).ge.sgn*sigmf(jj)) then
               neq=neq+1
               call seteqiv(neq,jj,iweq)
            end if
         else
            neq=neq+1
            call seteqiv(neq,jj,iweq)
         end if
      end if
      return
      end

      subroutine average0(offs,nfobs,sgn,isgn,nind)
      include 'qcdiff.inc'
      integer offs  ! offset
      real foind(nhkl),woind(nhkl)
      integer hind(6,nhkl)
      common /cfind/ foind,woind,hind
      complex fc
      real qk
      integer hklm,fmpl
      common /chklfm/ hklm(6,nhkl),qk(nhkl),fmpl(nhkl),fc(nhkl),
     *   fo(nhkl),theta0(nhkl),ext(nhkl),wg(nhkl),sigmf(nhkl)

      real lfmin
      integer st(nhkl*2),ns(nhkl)
      integer iskip(nhkl)
      real absy(nhkl)

      integer hklmeq(6,240)
      real fobseq(240)
      real wobseq(240)
      integer isk(240)
      integer lfeq(240)
      real fslct(240)
      common /cfeqiv/ hklmeq,fobseq,wobseq,isk,lfeq,fslct
      real ys(3)

      character*80 flnm1,flnm2
      character*4 watom
      character*40 frmt1,frmt2
      integer ihend(6)
      integer getndm,getiweq

      nde=getndm()
      idm=3+nde
      call getabsyqc(absy,hklm,nfobs)
      call qsort(absy,st,ns,nfobs)
      nind=0
      nsg=0
      df=0
      sf=0
      id=1
      call zerovi(iskip,nhkl)

      lfmin=0.001
      epsy=0.1
c     assumes ka1 and ka2 separation is less than epsy A**-1
c     loop
c      write(6,*) 'offs,nfobs=',offs,nfobs
      do id=1+offs,nfobs+offs
         ii=ns(id)
c        select first independent reflection h0
         if(iskip(ii).eq.0) then
            nind=nind+1
c           write(6,*) 'nind=',nind
            iskip(ii)=1
            neq=0               ! reset neq
            call chksigcnd(neq,ii,sgn,isgn)
c            write(6,*) 'neq=',neq
         else if(iskip(ii).eq.1) then
            go to 150
         end if

c     find equivalent reflections
         do jd=id+1,nfobs+offs
            jj=ns(jd)
            if(iskip(jj).eq.0) then
               ieq=iequiv(hklm(1,jj),hklm(1,ii))
c              if h(jj) is equivalent to h(ii) ieq=1
c              else if h(jj) is equivalent to -h(ii) ieq=-1
               if(ieq.eq.1.or.ieq.eq.-1) then
c                 h(jj) is equivalent to h(ii) or -h(ii)
                  iskip(jj)=1
                  call chksigcnd(neq,jj,sgn,isgn)
c                  write(6,*) 'neq=',neq
               else if(absy(jd)-absy(id).gt.epsy) then            
                  go to 360
               end if
            else
               if(absy(jd)-absy(id).gt.epsy) then
                  go to 360
               end if
            end if
         end do
 360     continue
         call caldfsf(neq,df,sf,nsg)  ! calculate Rint for equivalent refl.
 150     continue
      end do

      write(6,'(a,i8)') 'number of independent reflections', nind
      write(6,'(a,i8)') 'number of reflections >=sgn*sigma', nsg
      if(sf.gt.0.0) then
         write(6,'(a,f10.5,2(a,e12.6))') 
     *        'Rint=',df/sf, ' df=',df,' sf=',sf
      else
         write(6,*) 'all reflections are independent'
      end if
      return
      end

      subroutine caldfsf(neq,df,sf,nsg)
      integer hklmeq(6,240)
      real fobseq(240)
      real wobseq(240)
      integer isk(240)
      integer lfeq(240)
      real fslct(240)
      common /cfeqiv/ hklmeq,fobseq,wobseq,isk,lfeq,fslct

      include 'qcdiff.inc'
      real foind(nhkl),woind(nhkl)
      integer hind(6,nhkl)
      common /cfind/ foind,woind,hind
      integer getndm,getiweq
      call getwght(iwght)
c     write(6,*) 'iwght,neq=',iwght,neq
      nde=getndm()
      idm=3+nde

      if(neq.eq.0) then
         return
      end if

      if(getiweq().eq.1) then
         write(6,*) ' '
      end if
      fs=0
      ss=0
      do i=1,neq
         fs=fs+fobseq(i)**2
         ss=ss+2*wobseq(i)*fobseq(i)
c         if(neq.ge.2) then
c            write(6,*) 'fobseq(i),wobseq(i)',fobseq(i),wobseq(i)
c         end if
      end do            
      fs=fs/neq                 ! averaged intensity
      ss=ss/neq                 ! averaged sigma(I)
      sfs=sqrt(fs)              ! averaged F
      f0=0
      s0=0
      s2=0
      neq0=0
      call zerovi(isk,240)
      do i=1,neq
         sigmi=(fobseq(i)+wobseq(i))**2-fobseq(i)**2
         f2=f2+fobseq(i)**2
         s2=s2+sigmi**2
         neq0=neq0+1
      end do
      f2=f2/neq                 ! average I
      sg=sqrt(s2)/neq           ! sigmaI for average I
      f0=sqrt(f2)               ! averaged F
      s0=sqrt(f2+sg)-sqrt(f2)   ! sigmaF for average F

      if(neq0.gt.0) then
         nsg=nsg+1
         call vcpyi(hklmeq(1,1),hind(1,nsg),idm)
         foind(nsg)=f0
         woind(nsg)=s0
      end if
      
      do j=1,neq
         if(neq0.ge.2.and.isk(j).eq.0) then
            df=df+abs(fobseq(j)**2-f0**2)
            sf=sf+fobseq(j)**2
         end if
      end do
      return
      end

