      function iext(h)
      integer h(6)
      iext=1
      ii=mod(h(1)+h(2)+h(3)+h(4)+h(5)+h(6),2)
      if(ii.eq.1.or.ii.eq.-1) iext=0
      return
      end

      subroutine cprvec(x,y)
      real x(*),y(*)
      do i=1,6
         y(i)=x(i)
      end do
      return
      end

c      subroutine cpivec(x,y)
c      integer x(*),y(*)
c      do i=1,6
c         y(i)=x(i)
c      end do
c      return
c      end

      subroutine trcs(x,y,n1,n2,n3)
      dimension x(*),y(*),n1(*),n2(*),n3(*)
      real n1,n2,n3
c*****transformation of coordinate systems********************
c     x: coordinates in primary system
c     y: coordinates in plotter system
c        y(1),y(2) are x and y coordinates in plotter system
      y(1)= (n1(1)*x(1)+n1(2)*x(2)+n1(3)*x(3))
      y(2)= (n2(1)*x(1)+n2(2)*x(2)+n2(3)*x(3))
      y(3)= (n3(1)*x(1)+n3(2)*x(2)+n3(3)*x(3))
      return
      end

      subroutine intskp()
c     initialization of ifskip
      common /cskp/ q1(6),q2(6),q3(6)
      integer n1(6),n2(6),n3(6)
c     data n1 /0,1,0,0,-1,0/
c     data n2 /-1,0,0,1,0,0/
c     data n3 /0,0,-1,0,1,0/
      data n1 /0,-1,0,1,0,0/
      data n2 /-1,0,0,0,-1,0/
      data n3 /0,0,-1,0,0,1/
c      n1, n2, n3: vectors normal to the planes of independent area
c                  in the reciprocal space (icosahedral)
      call getsys(isys)
      if(isys.le.2) then
          call getqi0(n1,q1)
          call getqi0(n2,q2)
          call getqi0(n3,q3)
          call norml(q1,3)
          call norml(q2,3)
          call norml(q3,3)
      else
         call quit('invalid isys in intskp')
      end if
c      write(6,*) 'q1=',q1
c      write(6,*) 'q2=',q2
c      write(6,*) 'q3=',q3
      return
      end

      function ifskip(q)
      real q(*)
      common /cskp/ q1(6),q2(6),q3(6)
      integer getiwg
c     data eps/0.001/
      data eps/0.0001/
c    iwg=1: m35, iwg=2: 10/mmm, iwg=3: -10m2, iwg=4: 8/mmm, iwg=5: 12/mmm
c      call getsys(isys)
      iwg=getiwg()
      ifskip=1
      if(iwg.eq.1) then
          if(-0.58778525*q(1)+0.80901699*q(2).lt.-eps) return
          if(0.6882*q(1)+0.5*q(2)+0.5257*q(3).lt.-eps) return
          if(q(2).gt.eps) return
          if(q(3).lt.-eps) return
c          if(vinpr(q1,q,3).gt.eps) return
c          if(vinpr(q2,q,3).gt.eps) return
c          if(vinpr(q3,q,3).gt.eps) return
          ifskip=0
          return
      else if(iwg.eq.2) then
c           decagonal
          if(q(3).lt.-eps) return
          if(q(2).gt.eps) return
          if(-.30901699*q(1)+0.95105652*q(2).lt.-eps) return
          ifskip=0
          return
      else if(iwg.eq.3) then
c           pentagonal
          if(q(3).lt.-eps) return
          if(q(2).gt.eps) return
          if(-.58778525*q(1)+0.80901699*q(2).lt.-eps) return
          ifskip=0
          return
      else if(iwg.eq.4) then
c           octagonal
          if(q(3).lt.-eps) return
          if(q(2).gt.eps) return
          if(-.38268343*q(1)+0.92387953*q(2).lt.-eps) return
          ifskip=0
          return
      else if(iwg.eq.5) then
c           dodecagonal
          if(q(3).lt.-eps) return
          if(q(2).gt.eps) return
          if(-.25881905*q(1)+0.96592583*q(2).lt.-eps) return
          ifskip=0
          return
      else
         call quit('invalid isys in ifskip')
      end if 
      end

      integer function ngrp(h,hs,mult,qs,absq,fmpl)
      integer h(*),hs(6,*),mult(*),fmpl
      real qs(6,*),absq(*)
      integer hr(6)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      real q(6)
      data eps /0.00005/
**********************
      ifct=(nsymo*2)/fmpl
**********************
      ngrp=0
      do i=1,120
         absq(i)=0
         mult(i)=0
      end do
      do ns=1,nsymo
c     do j=0,1
c          call gethr(h,hr,r,ns,j)
           call gethr(h,hr,r,ns,0)
           call getqi(hr,q)
           sqrq=vabs(q,3)
           do k=1,ngrp
              if(abs(sqrq-absq(k)).le.eps) then
c     hr belongs to an old group
                 mult(k)=mult(k)+1
                 go to 100
              end if
           end do
c          new group
           ngrp=ngrp+1
           mult(ngrp)=1
           absq(ngrp)=sqrq
           call vcpyi(hr,hs(1,ngrp),6)
           call vcpyr(q,qs(1,ngrp),6)
c          write(6,*) 'hr=',hr,' ngrp=',ngrp,' q=',q
 100  continue
      end do
      do i=1,ngrp
         mult(i)=mult(i)*2/ifct
      end do
      return
      end

c     find x,y,z and w used in the numerical gauss integral
c     boundary is assumed to be ellipsoidal or convex polyhedral
      subroutine table1(mp,mq,mr,nbf,n)
      integer mp(*),mq(*),mr(*)
      dimension a(3,3),b(3),ipivot(3),index(3,2),pivot(3)
      common /tbl/ xx(10,10,10,10),yy(10,10,10,10),zz(10,10,10,10),
     *     wxyz(10,10,10,10),aa(30,10),bb(30,10),cc(30,10),ff(30,10)
      common /bgn1/ilm(3),icorc(3),pxj(100,3),hj(100,3)
      wt(x1,x2,x3,h,p,q,f)=h*x1+p*x2+q*x3-f
      fuvw(c,f)=-sqrt(f/c)
      eps=1.e-06
      ilm(1)=mp(n)
      ilm(2)=mq(n)
      ilm(3)=mr(n)
      do i=1,3
         icorc(i)=1
      end do
c     interval of gauss integral along x, y, z axes
      call gauss1
c
      if(nbf.eq.1) then
c     ellipsoical boundary
c     principal axes along x,y,z are assumed
         do np=1,mp(n)
            do nq=1,mq(n)
               do nr=1,mr(n)
                  do i=1,nbf
                     f0=ff(i,n)
                     ua=fuvw(aa(i,n),f0)
                     ub=-ua
                     du=ub-ua
                     rx=hj(np,1)*du
                     xx(np,nq,nr,n)=ua+(pxj(np,1)+0.5)*du
                     f1=f0-aa(i,n)*xx(np,nq,nr,n)**2
c     va:-r along the first principal axis
                     va=fuvw(bb(i,n),f1)
                     vb=-va
                     dv=vb-va
                     ry=hj(nq,2)*dv
                     yy(np,nq,nr,n)=va+(pxj(nq,2)+0.5)*dv
                     f2=f1-bb(i,n)*yy(np,nq,nr,n)**2
                     wa=fuvw(cc(i,n),f2)
                     wb=-wa
                     dw=wb-wa
                     rz=hj(nr,3)*dw
                     zz(np,nq,nr,n)=wa+(pxj(nr,3)+0.5)*dw
                     wxyz(np,nq,nr,n)=rx*ry*rz
                  end do
               end do
            end do
         end do
      else
c     polyhedral boundary
c     nbf: number of boundary planes
c     direction cos aa,bb,cc
         do i=1,nbf
            absa=sqrt(aa(i,n)**2+bb(i,n)**2+cc(i,n)**2)
            aa(i,n)=aa(i,n)/absa
            bb(i,n)=bb(i,n)/absa
            cc(i,n)=cc(i,n)/absa
            ff(i,n)=ff(i,n)/absa
         end do
         nbf2=nbf-2
         nbf1=nbf-1
         ua=1000.
         ub=-1000.
c     find verteces of the polyhedron
         do i=1,nbf2
            ip=i+1
            do j=ip,nbf1
               jp=j+1
               if(1.0-abs(aa(i,n)*aa(j,n)
     *              +bb(i,n)*bb(j,n)+cc(i,n)*cc(j,n)).lt.eps) then
c     i-th and j-th planes are parallel
                  go to 11
               end if
               do k=jp,nbf
                  if(1.0-abs(aa(i,n)*aa(k,n)
     *                 +bb(i,n)*bb(k,n)+cc(i,n)*cc(k,n)).lt.eps) then
c     i-th and k-th planes are parallel
                     go to 12
                  else if(1.0-abs(aa(j,n)*aa(k,n)
     *                    +bb(j,n)*bb(k,n)+cc(j,n)*cc(k,n)).lt.eps) then
c     j-th and k-th planes are parallel
                     go to 12
                  end if
                  a(1,1)=aa(i,n)
                  a(1,2)=bb(i,n)
                  a(1,3)=cc(i,n)
                  a(2,1)=aa(j,n)
                  a(2,2)=bb(j,n)
                  a(2,3)=cc(j,n)
                  a(3,1)=aa(k,n)
                  a(3,2)=bb(k,n)
                  a(3,3)=cc(k,n)
                  b(1)=ff(i,n)
                  b(2)=ff(j,n)
                  b(3)=ff(k,n)
                  call matinv(a,3,3,b,1,det,ipivot,index,pivot)
c     b(1),b(2),b(3): x,y,z coordinates of the vertex
c     which is defined by i,j,k planes
c     
c     remove vertees outside the polyhedron
c     when the point is inside the polyhedron wt<=0
                  do l=1,nbf
                     if(wt(b(1),b(2),b(3),aa(l,n),
     *                    bb(l,n),cc(l,n),ff(l,n)).gt.eps) then
                        go to 12
                     end if
                  end do
c     ua,ub: minimum and maximum x coordinates
                  if(b(1).lt.ua) ua=b(1)
                  if(b(1).gt.ub) ub=b(1)
 12               continue
               end do
 11            continue
            end do
 10         continue
         end do
c     du: integral range along x axis
         du=ub-ua
         do np=1,mp(n)
c     x: x-coordinate used in the gauss integral
            rx=hj(np,1)*du
            do nq=1,mq(n)
               do nr=1,mr(n)
                  xx(np,nq,nr,n)=ua+(pxj(np,1)+0.5)*du
               end do
            end do
            va=1000.
            vb=-1000.
            do i=1,nbf1
               jp=i+1
               if(1.0-abs(aa(i,n)).lt.eps) go to 20
               do j=jp,nbf
                  if(1.0-abs(aa(j,n)).lt.eps) go to 21
                  if(1.0-abs(aa(i,n)*aa(j,n)
     *                 +bb(i,n)*bb(j,n)+cc(i,n)*cc(j,n)).lt.eps)
     *                 go to 21
                  a(1,1)=bb(i,n)
                  a(1,2)=cc(i,n)
                  a(2,1)=bb(j,n)
                  a(2,2)=cc(j,n)
                  b(1)=ff(i,n)-aa(i,n)*xx(np,1,1,n)
                  b(2)=ff(j,n)-aa(j,n)*xx(np,1,1,n)
                  call matinv(a,3,2,b,1,det,ipivot,index,pivot)
c     b: y,z coordinates of the vertex of polyhedron
c     on the plane passes at a given x
c     remove vertex outside the polyhedron
                  do l=1,nbf
                     if(wt(xx(np,1,1,n),b(1),b(2),
     *                    aa(l,n),bb(l,n),cc(l,n),ff(l,n))
     *                    .gt. eps) go to 21
                  end do
c     va,vb: minimum and maximum y coordinates at the plane
                  if(b(1).lt.va) va=b(1)
                  if(b(1).gt.vb) vb=b(1)
 21               continue
               end do
 20            continue
            end do
            dv=vb-va
c     y: y-coordinate for given x
            do nq=1,mq(n)
               ry=hj(nq,2)*dv
               do nr=1,mr(n)
                  yy(np,nq,nr,n)=va+(pxj(nq,2)+0.5)*dv
               end do
               wa=1000.
               wb=-1000.
               do i=1,nbf
                  if(abs(cc(i,n)).lt.eps) go to 30
                  b(1)=(ff(i,n)-aa(i,n)*xx(np,1,1,n)
     *                 -bb(i,n)*yy(np,nq,1,n))/cc(i,n)
                  do l=1,nbf
                     if(wt(xx(np,1,1,n),yy(np,nq,1,n),
     *                    b(1),aa(l,n),bb(l,n),cc(l,n),ff(l,n))
     *                     .gt. eps) go to 30
                  end do
                  if(b(1).lt.wa) wa=b(1)
                  if(b(1).gt.wb) wb=b(1)
 30               continue
               end do
               dw=wb-wa
c     z: z-coordinate for given x and y
               do nr=1,mr(n)
                  rz=hj(nr,3)*dw
                  zz(np,nq,nr,n)=wa+(pxj(nr,3)+0.5)*dw
                  wxyz(np,nq,nr,n)=rx*ry*rz
               end do
            end do
         end do
      end if
      return
      end

      function fd(q,ramax,ramin,n,mp,mq,mr)
      real q(*),ramax(*),ramin(*)
      integer mp(*),mq(*),mr(*)
      common /tbl/ xx(10,10,10,10),yy(10,10,10,10),zz(10,10,10,10),
     *     wxyz(10,10,10,10),aa(30,10),bb(30,10),cc(30,10),ff(30,10)
      common /dsp/ ux(10,10,10,10),uy(10,10,10,10),uz(10,10,10,10)
      real qx,pi2
      data pi2/6.28318/
      fd=0
      do np=1,mp(n)
         do nq=1,mq(n)
            do nr=1,mr(n)
               qx=q(4)*xx(np,nq,nr,n)+q(5)*yy(np,nq,nr,n)+
     *              q(6)*zz(np,nq,nr,n)
               fd=fd+ramax(n)**3*wxyz(np,nq,nr,n)*cos(pi2*ramax(n)*qx)
     *              -ramin(n)**3*wxyz(np,nq,nr,n)*cos(pi2*ramin(n)*qx)
            end do
         end do
      end do
      return
      end
c
      subroutine shape(ish,n)
      common /tbl/ xx(10,10,10,10),yy(10,10,10,10),zz(10,10,10,10),
     *     wxyz(10,10,10,10),aa(30,10),bb(30,10),cc(30,10),ff(30,10)
      real q(6)
      integer ishpe,ish(*)
      integer nr(6,15)
c      data ras/1.4325/, rat/1.3763/
      data ras/1./, rat/1.3763/
      data nr/1,1,0,0,0,0,  1,0,1,0,0,0,  1,0,0,1,0,0,
     *        1,0,0,0,1,0,  1,0,0,0,0,1,  0,1,1,0,0,0,
     *        0,0,1,1,0,0,  0,0,0,1,1,0,  0,0,0,0,1,1,
     *        0,1,0,0,0,1,  0,1,0,-1,0,0, 0,0,1,0,-1,0,
     *        0,0,0,1,0,-1, 0,-1,0,0,1,0, 0,0,-1,0,0,1/
c     nr: normal to surface of triacontahedron
      ishpe=ish(n)
      if(ishpe.eq.0) then
c**********sphere
         aa(1,n)=1.
         bb(1,n)=1.
         cc(1,n)=1.
         ff(1,n)=ras**2
      else if(ishpe.eq.1) then
c**********triacontahedron (vertex)
         do i=1,15
            call getqi0(nr(1,i),q)
            absq=sqrt(q(4)**2+q(5)**2+q(6)**2)
            aa(i,n)=q(4)/absq
            bb(i,n)=q(5)/absq
            cc(i,n)=q(6)/absq
            ff(i,n)=rat
         end do
         do i=16,30
            j=i-15
            aa(i,n)=-aa(j,n)
            bb(i,n)=-bb(j,n)
            cc(i,n)=-cc(j,n)
            ff(i,n)=rat
         end do
c     else if(ishpe.eq.2) then
c**********rhombic icosahedron (edge center)
c     else if(ishpe.eq.3) then
c**********rhombic dodecahedron (face center i)
c     else if(ishpe.eq.4) then
c**********rhombic dodecahedron (face center ii)
c     else if(ishpe.eq.5) then
c**********rhombohedra (body center)
      else
           write(6,'(1h ,a)') '*****undefined shape is used*****'
           stop
      end if
      return
      end


      subroutine cubhkl(hs,fmpl,qk,fcal,no,w)
      integer hs(6,*),fmpl(*)
      real qk(*),fcal(*),w(6,*),hc(6),hold(6,120),hw(3)
      integer h(6),hr(6)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      data eps /0.0001/, tau /1.618/
      do i=1,no
         do j=1,6
            h(j)=hs(j,i)
         end do
         ndiff=0
         do icnt=0,1
            do nsy=1,nsymo
               call gethr(h,hr,r,nsy,icnt)
               do j=1,6
                  hc(j)=0
                  do k=1,6
                     hc(j)=hc(j)+hr(k)*w(k,j)
                  end do
               end do
c     select independent diffraction spots
               do nd=1,ndiff
                  if(abs(hc(1)-hold(1,nd)).lt.eps.and.
     *                 abs(hc(2)-hold(2,nd)).lt.eps.and.
     *                 abs(hc(3)-hold(3,nd)).lt.eps.and.
     *                 abs(hc(4)-hold(4,nd)).lt.eps.and.
     *                 abs(hc(5)-hold(5,nd)).lt.eps.and.
     *                 abs(hc(6)-hold(6,nd)).lt.eps) then
                     go to 165
                  end if
               end do
               ndiff=ndiff+1
               call savehc(hc,hold,ndiff)
               do j=1,3
                  hw(j)=hc(j)+tau*hc(j+3)
               end do
               write(6,'(1h ,3f9.4,f9.2,2x,6i2,i5,f9.4)')
     *              hw,fcal(i),hr,fmpl(i),qk(i)
 165           continue
            end do
         end do
      end do
      return
      end

      subroutine savehc(hc,hold,ndiff)
      real hc(*),hold(6,*)
      do i=1,6
         hold(i,ndiff)=hc(i)
      end do
      return
      end

      function ifatom(q,ra,rb,ishpe)
      real q(*),ra,rb,cent(6)
      integer ishpe
      integer triach
      real xg(6,2)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      common /cfatm/ nasym(2),nnsym(60,2),qg(6,60,2)
      data xg
     */ 0.5,     -0.223607,-0.223607,-0.223607,-0.223607,-0.223607,
     *  0.723607,-0.723607, 0.0     ,-0.447214,-0.447214,0.0    /

c      data ras/1.4325/, rat/1.3763/
      data ras/1./, rat/1.3763/
c     ************vertex position
c      if atom appears in ve then ifatom=0
      ifatom=1
      if(ishpe.eq.0) then
c**********sphere
           di=q(4)**2+q(5)**2+q(6)**2
           if(di.gt.(rb*ras)**2) return
      else if(ishpe.eq.1) then
c**********triacontahedron (vertex)
           do  i=1,6
              cent(i)=0
           end do
           if(triach(q,rb*rat,cent).eq.1) return
      else
           write(6,'(1h ,a)') 'undefined shape used'
           stop
      end if
      ifatom=0
      return
      end

      integer function triach(q,ra,cent)
      real q(*),cent(*)
      real qi(6,15),qc(6)
      integer nr(6,15),ic(6)
      save icount,qi
      data nr/1,1,0,0,0,0,  1,0,1,0,0,0,  1,0,0,1,0,0,
     *        1,0,0,0,1,0,  1,0,0,0,0,1,  0,1,1,0,0,0,
     *        0,0,1,1,0,0,  0,0,0,1,1,0,  0,0,0,0,1,1,
     *        0,1,0,0,0,1,  0,1,0,-1,0,0, 0,0,1,0,-1,0,
     *        0,0,0,1,0,-1, 0,-1,0,0,1,0, 0,0,-1,0,0,1/
      data icount /0/
      icount=icount+1
      if(icount.eq.1) then
         do i=1,15
           call getqi0(nr(1,i),qi(1,i))
           call norml(qi(4,i),3)            
         end do
      end if
c     nr: normal to surface of triacontahedron
      do i=1,6
         ic(i)=cent(i)
      end do
c      call getqi0(ic,qc)
      call getqi(ic,qc)
      triach=1
      do i=1,15
         qn=(q(4)-qc(4))*qi(4,i)+
     *        (q(5)-qc(5))*qi(5,i)+
     *        (q(6)-qc(6))*qi(6,i)
         if(qn.lt.-ra.or.qn.gt.ra) return
      end do
      triach=0
      return
      end

      integer function iand(i,j)
      iand=mod(i,j*2)
      return
      end

      integer function ior(i,j)
      ior=i+j
      return
      end

      complex function cexpf(z)
      complex z,i
      data i/(0., 1.)/
      x=aimag(z)
      cexpf=cos(x)+i*sin(x)
      return
      end

      subroutine setsmtrm(ind)
      integer s
      common /csmtrm/ s(6,6)
      integer s0(6,6),t0(6,6),s1(6,6),t1(6,6),s2(6,6),t2(6,6)
      integer s3(6,6),t3(6,6)
*************icosahedral f or i*************
      data s0/ 1, 1, 1, 1, 1, 1,
     *         1, 1, 1,-1,-1, 1,
     *         1, 1, 1, 1,-1,-1,
     *         1,-1, 1, 1, 1,-1,
     *         1,-1,-1, 1, 1, 1,
     *         1, 1,-1,-1, 1, 1/
      data t0/-1, 1, 1, 1, 1, 1,
     *         1,-1, 1,-1,-1, 1,
     *         1, 1,-1, 1,-1,-1,
     *         1,-1, 1,-1, 1,-1,
     *         1,-1,-1, 1,-1, 1,
     *         1, 1,-1,-1, 1,-1/
***************decagonal*********************
      data s1/ 0, 0,-1,-1, 0, 0,
     *         1, 1, 1, 0, 0, 0,
     *         0, 1, 1, 1, 0, 0,
     *        -1,-1, 0, 0, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
      data t1/-1, 0,-1,-1, 0, 0,
     *         1, 0, 1, 0, 0, 0,
     *         0, 1, 0, 1, 0, 0,
     *        -1,-1, 0,-1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
***************octagonal*********************
      data s2/ 1, 1, 0,-1, 0, 0,
     *         1, 1, 1, 0, 0, 0,
     *         0, 1, 1, 1, 0, 0,
     *        -1, 0, 1, 1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
      data t2/-1, 1, 0,-1, 0, 0,
     *         1,-1, 1, 0, 0, 0,
     *         0, 1,-1, 1, 0, 0,
     *        -1, 0, 1,-1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
***************dodecagonal*********************
      data s3/ 1, 0, 0,-1, 0, 0,
     *         1, 1, 0, 0, 0, 0,
     *         0, 1, 1, 1, 0, 0,
     *         0, 0, 1, 1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
      data t3/ 0, 1, -1, 1, 0, 0,
     *         0, 0, 1, -1, 0, 0,
     *         1,-1, 1, 0, 0, 0,
     *        -1, 1,-1, 1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
c      data s3/ 2, 1, 0,-1, 0, 0,
c     *         2, 2, 1, 0, 0, 0,
c     *         0, 1, 2, 2, 0, 0,
c     *        -1, 0, 1, 2, 0, 0,
c     *         0, 0, 0, 0, 1, 0,
c     *         0, 0, 0, 0, 0, 1/
c      data t3/ 2,-1, 0, 1, 0, 0,
c     *        -2, 2,-1, 0, 0, 0,
c     *         0,-1, 2,-2, 0, 0,
c     *         1, 0,-1, 2, 0, 0,
c     *         0, 0, 0, 0, 1, 0,
c     *         0, 0, 0, 0, 0, 1/
      call getsys(isys)
c     write(6,*) 'isys,ind=',isys,ind
      if(isys.le.2) then
         if(ind.gt.0) call mcpyi6(s0,s)
         if(ind.lt.0) call mcpyi6(t0,s)
      else if(isys.eq.3) then
         if(ind.gt.0) call mcpyi6(s1,s)
         if(ind.lt.0) call mcpyi6(t1,s)
      else if(isys.eq.4) then
         if(ind.gt.0) call mcpyi6(s2,s)
         if(ind.lt.0) call mcpyi6(t2,s)
      else if(isys.eq.5) then
         if(ind.gt.0) call mcpyi6(s3,s)
         if(ind.lt.0) call mcpyi6(t3,s)
      else
         write(6,*) 'isys=',isys
         call quit('invalid isys in setsmtrm')
      end if
      return
      end

      subroutine smtrh(h,hd,ind)
      integer h(*),hd(*),ht(6)
      integer s
      common /csmtrm/ s(6,6)
c        similarity transformation for decagonal and icosahedral

c     call wtmtrxi('s',s,6)

      call getsys(isys)
      call vcpyi(h,ht,6)
      if(ind.eq.0) then
         call vcpyi(ht,hd,6)
      else if(ind.gt.0) then
c        ext ==> tau  int ==> tau**-1
         do n=1,ind
            do i=1,6
               hd(i)=0
               do j=1,6
                  hd(i)=hd(i)+s(i,j)*ht(j)
               end do
            end do
            if(n.ne.ind) call vcpyi(hd,ht,6)
         end do
         if(isys.le.2) then
            do j=1,6
               hd(j)=hd(j)/2**ind
            end do
         end if
         return
      else if(ind.lt.0) then
c        ext ==> tau**-1  int ==> tau
         do n=1,-ind
            do i=1,6
               hd(i)=0
               do j=1,6
                  hd(i)=hd(i)+s(i,j)*ht(j)
               end do
            end do
            if(n.ne.-ind) call vcpyi(hd,ht,6)
         end do
         if(isys.le.2) then
            do j=1,6
               hd(j)=hd(j)/2**abs(ind)
            end do
         end if
         return
      end if
      end

      subroutine mtbld(nfcal,md,delt,rw,rw0,r,id)
c     normal matrix calculations for single crystals
      real md(*),delt(*)
      include 'qcdiff.inc'
      common /csimul/ dfdx(nxprm,nhkl),nxx
      common /cdfdbi/ dfdbi(nhkl)
      common /ctodrw7/ iwl,ixax,ilp,alpha,iyax
      common /ctodrw9/ pbt(0:12), dpbt(0:12), zpst(2)
      common /cupdat/ tanxk(nb),tfct(nb),hwhme(2,nb),c1(nb),c2(nb)
      common /ccoeff/ coeff(10),coeff0(10),coeff1(10),coeff2(10),
     *     coeff3(10)
      common /ctodrw8/ ipt(0:38),nlc
      complex fc
      real qk
      integer hklm,fmpl
      common /chklfm/ hklm(6,nhkl),qk(nhkl),fmpl(nhkl),fc(nhkl),
     *   fo(nhkl),theta0(nhkl),ext(nhkl),wg(nhkl)
      character*80 fmt
      common /cfmt/ fnsig(idsmax),fminc(idsmax),wg0(idsmax),nst(idsmax),
     *   inp(idsmax),iorf(idsmax),fmt(idsmax)
      integer getisxt

      call getwght(iwght)
      isext=abs(getisxt(id))
      syobs=0
      syobs0=0
      sfobs=0
      nstar=0
      if(isext.eq.0) then
         jde=0
      else if(isext.eq.1) then
         jde=2
      else if(isext.eq.2) then
         jde=3
      end if

      do ih=1,nfcal
         if(iwght.eq.1) then
            if(abs(fc(ih)).lt.fminc(id)) then
               nstar=nstar+1
            end if
         end if
         syobs=syobs+wg(ih)*fo(ih)**2
         syobs0=syobs0+fo(ih)**2
         if(wg(ih).gt.0) then
            sfobs=sfobs+fo(ih)
         end if
      end do
      write(6,*) 'number of asterisked refl.=',nstar

      sydef=0
      sydef0=0
      sfdef=0
      sfo=0
      sfc=0

      if(pbt(0).eq.0) then
         do ih=1,nfcal
            sfo=sfo+fo(ih)
            sfc=sfc+abs(fc(ih))
         end do
         pbt(0)=sfo/sfc
      end if

      do ih=1,nfcal
         call updat0(hklm(1,ih),abs(fc(ih)),ext(ih),dfdbi(ih),id)
         dfoc=fo(ih)-abs(fc(ih))*coeff1(1)
         sydef=sydef+wg(ih)*dfoc**2
         sydef0=sydef0+dfoc**2
         if(wg(ih).gt.0) then
            sfdef=sfdef+abs(dfoc)
         end if
         do j=1,nxx
           dfdx(j,ih)=dfdx(j,ih)*coeff1(1)    ! structural parameters
         end do

         j=0
         nyy=0
c     scale for single crystal for jd=1
         if(ipt(0).eq.1) then
            j=j+1
            nyy=nyy+1
            dfdx(nxx+j,ih)=coeff0(1)
            j=1
         end if

         do jd=1,jde
c     extinction correction for single crystal for jd=2,3
            if(ipt(jd).eq.1) then
               j=j+1
               nyy=nyy+1
               dfdx(nxx+j,ih)=coeff2(jd)
            end if
         end do

c     for bia
         if(ipt(jde+1).eq.1) then 
            j=j+1
            nyy=nyy+1
            dfdx(nxx+j,ih)=coeff3(1)
         end if

         lk=0
         do j=1,nxx+nyy
            dej=wg(ih)*dfdx(j,ih)/syobs
            delt(j)=delt(j)+dfoc*dej
            do k=1,j
               lk=lk+1
               md(lk)=md(lk)+dej*dfdx(k,ih)
            end do
         end do
      end do
c      write(6,*) 'nxx,nyy,delt(1),md(1),detl(n),md(n)=',
c     *     nxx,nyy,delt(1),md(1),delt(nxx+nyy),md(lk)
      rw=sqrt(sydef/syobs)     ! weighted r-factor for given weight
      rw0=sqrt(sydef0/syobs0)  ! weighted r-factor for unit weight
      r =sfdef/sfobs
      return
      end

      subroutine setac(a,c)
      common /extcr0/ a0,c0
      a0=a
      c0=c
      return
      end

      subroutine getyd(q,yd)
      real q(6),yd(3)
      common /extcr0/ a0,c0
      call getsys(isys)
      if(isys.le.2) then
         yd(1)=q(1)
         yd(2)=q(2)
         yd(3)=q(3)
      else
         yd(1)=q(1)
         yd(2)=q(2)
         yd(3)=q(3)
c        write(6,*) 'a0=',a0, ' c0=',c0
      end if
      return
      end

      subroutine updat0(h,absfc,ext,dfdbi,id)
      integer h(*)
      real absfc
      real q(6)
      include 'qcdiff.inc'
      common /ctodrw9/ pbt(0:12), dpbt(0:12), zpst(2)
      common /ctodrw10/ biat
      common /cupdat/ tanxk(nb),tfct(nb),hwhme(2,nb),c1(nb),c2(nb)
      common /ccoeff/ coeff(10),coeff0(10),coeff1(10),coeff2(10),
     *     coeff3(10)
      common /cisie/ is,ie
      real sqrtpi,ln2,fact
      common /clins/ sqrtpi,ln2,fact
      real extd(3),yd(3),ads(2)

      common /ctodrw8/ ipt(0:38),nlc
      common /extcr2/ ex(1000),ey(1000),ez(1000),wxyz(1000),mp,mq,mr
      integer getisxt
      data pi/3.141592/
      isext=abs(getisxt(id))
c     coefficient for single crystal method
      scl=pbt(0)  ! scale factor
      ads(1)=pbt(1)  ! extinction parameter
      if(isext.eq.1) then
         ads(2)=0               ! extinction parameter
         ama=pbt(2)             ! extinction parameter
      else if(isext.eq.2) then
         ads(2)=pbt(2)          ! extinction parameter
         ama=pbt(3)             ! extinction parameter
      end if
      bia=biat   ! overall phason temperature factor

      coeff(1)=1
      if(pbt(0).eq.0) then
         coeff0(1)=absfc
      end if
      
c************extinction correction
      if(isext.eq.1.or.isext.eq.2) then  ! isotropic extinction correction
c        call getqi0(h,q)  ! q: diffraction vector in inverse angstrome
         call getqi(h,q)  ! q: diffraction vector in inverse angstrome
         call getyd(q,yd)  ! get 3D hkl for given hklm
c         call wtvctri('h=',h,6)
c         call wtvctrr('q=',q,6)
         call extcor(ads,ama,yd,absfc,ext,extd)
c         write(6,*) 'ext,extd1,extd2,absfc=',ext,extd(1),extd(2),absfc
c         write(6,*) 'scl,ads,ama=',scl,ads,ama
c        coefficient for scale factor
         coeff0(1)=absfc*ext               ! for scl
         coeff1(1)=scl*ext                 ! for structural parameters
         coeff3(1)=ext*dfdbi*scl           ! for bia
      end if

      if(isext.eq.1) then  ! isotropic extinction correction
c        coefficient for extinction parameters
         coeff2(1)=absfc*extd(1)*scl       ! for extinction prm.
         coeff2(2)=absfc*extd(2)*scl       ! for extinction prm.
c        coefficient for structural parameters
      else if(isext.eq.2) then  ! anisotropic extinction correction
c        coefficient for extinction parameters
         coeff2(1)=absfc*extd(1)*scl       ! for extinction prm.
         coeff2(2)=absfc*extd(2)*scl       ! for extinction prm.
         coeff2(3)=absfc*extd(3)*scl       ! for extinction prm.  aniso
c        coefficient for structural parameters
      else  ! no extinction correction
c        coefficient for scale factor
         ext=1.
         coeff0(1)=absfc                   ! for scl
         coeff1(1)=scl                     ! for structural parameters
         coeff3(1)=dfdbi*scl               ! for bia
c        coefficient for structural parameters
      end if
      return
      end

