c
c     lattice class
c

      subroutine initalamcl()
      real al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      real alamcl,ralamcl
      common /csclmtrx/ alamcl(6,6),ralamcl(6,6)
      real dalamcl(6),rdalamcl(6)
      common /cslcmtrxd/ dalamcl,rdalamcl
      call getsys(isys)
      if(isys.le.2) then        ! icosahedral
         do i=1,3
            dalamcl(i)=al
            rdalamcl(i)=1.0/al
         end do
         do i=4,6
            dalamcl(i)=am
            rdalamcl(i)=1.0/am
         end do
      else                      ! dihedral
         do i=1,2
            dalamcl(i)=al
            rdalamcl(i)=1.0/al
         end do
         dalamcl(i)=cl
         rdalamcl(3)=1.0/cl
         do i=4,5
            dalamcl(i)=am
            rdalamcl(i)=1.0/am
         end do
         dalamcl(i)=1.0
         rdalamcl(6)=1.0
      end if
      return
      end

      subroutine rdlc()   ! read lattice constant and phason strain
      real al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      real alamcl,ralamcl
      common /csclmtrx/ alamcl(6,6),ralamcl(6,6)
      real dalamcl(6),rdalamcl(6)
      common /cslcmtrxd/ dalamcl,rdalamcl
      real eps0

c      read(5,'(3f8.5,i3)') isys,al,eps1,eps2,eps3,eps4,eps5,eps6
      call freadi('isys=',1,isys,1)
      call setsys(isys)
      call rdac(al,cl)   ! read lattice constants and set a and c
      call rdeps(eps1,eps2,eps3,eps4,eps5,eps6)
      call freadi('ists=',1,ists,0)
      if(isys.le.2) then
      write(6,'(a,i3,7(a,f8.5),a,i1)') 'isys=',isys,' al=',al,
     *  '  eps1=',eps1,' eps2=',eps2,' eps3=',eps3,' eps4=',eps4,
     *  '  eps5=',eps5,' eps6=',eps6,' ists=',ists
      else
      write(6,'(a,i3,8(a,f8.5),a,i1)') 'isys=',isys,' al=',al,
     * ' cl=',cl,'  eps1=',eps1,' eps2=',eps2,' eps3=',eps3,' eps4=',
     * eps4,'  eps5=',eps5,' eps6=',eps6,' ists=',ists
      end if

      call seteps(eps1,eps2,eps3,eps4,eps5,eps6)
      call setlcnst(al,cl)
      call initalamcl()
c     dalamcl : diagonal part of alamcl
      call dagmtrxr(dalamcl,alamcl,6)  ! get diagonal matrix with dalamcl
      call dagmtrxr(rdalamcl,ralamcl,6) ! get diagonal matrix with rdalamcl
      call wtmtrxrf('alamcl',alamcl,6,'(6f10.5)')
      call wtmtrxrf('ralamcl',ralamcl,6,'(6f10.5)')
      return
      end

      integer function iforthg(abccos) ! if orthogonal lattice 1 else 0
      real abccos(*)
      data eps /0.000001/
      iforthg=1
      if(abs(abccos(4)).ge.eps.or.abs(abccos(5)).ge.eps.or.
     *     abs(abccos(6)).ge.eps) then
         iforthg=0
      end if
      return
      end

      subroutine calgab(q1,q2,q3,gab) ! calculation of metric tensor
      real q1(*),q2(*),q3(*),gab(3,3)
      gab(1,1)=vinpr(q1,q1,3)
      gab(2,2)=vinpr(q2,q2,3)
      gab(3,3)=vinpr(q3,q3,3)
      gab(1,2)=vinpr(q1,q2,3)
      gab(2,1)=vinpr(q1,q2,3)
      gab(2,3)=vinpr(q2,q3,3)
      gab(3,2)=vinpr(q2,q3,3)
      gab(3,1)=vinpr(q3,q1,3)
      gab(1,3)=vinpr(q3,q1,3)
c      write(6,'(a,3f8.4)') 'q1,q2,q3=',vabs(q1,3),vabs(q2,3),
c     *     vabs(q3,3)
c      write(6,'(a,9f8.4)') 'gab=',gab(1,1),gab(2,2),gab(3,3),
c     *     gab(2,3),gab(1,3),gab(1,2)
      return
      end

      subroutine setd()  ! set geometric constants
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      common /cgethk/ d0(6,6),d1(6,6),d2(6,6),d3(6,6),d4(6,6)
      real dtmp(6,6),b(6)
      common /cgetd/ det
      integer getisys

      parameter (sr=0.894427191,ct=0.447213596)
      parameter (su=-sr,cu=-ct)
      parameter (c1=0.309016994,c2=-0.809016994)
      parameter (c3=-c2,c4=-c1)
      parameter (s1=0.951056516,s2=0.587785252)
      parameter (s3=-s2,s4=-s1)
      parameter (c1sr=c1*sr,c2sr=c2*sr,c3sr=c3*sr,c4sr=c4*sr)
      parameter (s1sr=s1*sr,s2sr=s2*sr,s3sr=s3*sr,s4sr=s4*sr)
      parameter (tau=1.61803399,tav=-tau)
      parameter (sqr2=1.41421356, sqr3=1.73205081, tqr3=-sqr3)
      parameter (t1=0.70710678, t2=-0.70710678)
      parameter (u1=0.8660254, u2=-u1) 
      data innn /1/
      data  d0/ 0.,   0.,   1., 0.,   0.,   1.,
     *          c2sr, s2sr, ct, c4sr, s1sr, cu,
     *          c2sr, s3sr, ct, c4sr, s4sr, cu,
     *          c1sr, s4sr, ct, c3sr, s2sr, cu,
     *          sr,   0.,   ct, su,   0.,   cu,
     *          c1sr, s1sr, ct, c3sr, s3sr, cu/
c     for cubic and trigonal
      data  d1/ 1., tau,  0.,  tau, -1., 0.,
     *          tau, 0.,  1.,  -1,  0.,  tau,
     *          tau, 0., -1.,  -1., 0.,  tav,
     *          0.,  1., tav,   0., tau, 1.,
     *          -1., tau, 0.,  tav, -1., 0.,
     *          0.,  1., tau,   0., tau, -1./
c      for decagonal  (******reciprocal lattice*******)
      data d2/  c1, s1, 0., c2, s2, 0.,
     *          c2, s2, 0., c1, s4, 0.,
     *          c2, s3, 0., c1, s1, 0.,
     *          c1, s4, 0., c2, s3, 0.,
     *          0., 0., 1., 0., 0., 0.,
     *          0., 0., 0., 0., 0., 1./       
c     for octagonal
      data d3/  1., 0., 0., 1., 0., 0.,
     *          t1, t1, 0., t2, t1, 0.,
     *          0., 1., 0., 0.,-1., 0.,
     *          t2, t1, 0., t1, t1, 0.,
     *          0., 0., 1., 0., 0., 0.,
     *          0., 0., 0., 0., 0., 1./
c     for dodecagonal
      data d4/  1., 0., 0., 1., 0., 0.,
     *          u1, 0.5, 0., u2, 0.5, 0.,
     *          0.5, u1, 0., 0.5, u2, 0.,
     *          0., 1.,  0., 0., 1.,  0.,
     *          0., 0.,  1., 0., 0.,  0.,
     *          0., 0.,  0., 0., 0.,  1./

      save icount
      data icount /0/
      icount=icount+1
      if(icount.eq.1) then
c     initialize
         call sclmtrx(d0,0.5,6)
         call sclmtrx(d1,1.0/sqrt(1+tau**2)/2,6)
c         call sclmtrx(d2,1.0/sqrt(5.),6)
c         call sclmtrx(d3,0.5,6)
c         call sclmtrx(d4,1.0/sqrt(2.),6)
         do i=1,6
            do j=1,4  ! important
               d2(i,j)=d2(i,j)/sqrt(5.)
            end do
         end do
         do i=1,6
            do j=1,4  ! important
               d3(i,j)=d3(i,j)/2
            end do
         end do
         do i=1,6
            do j=1,4  ! important
               d4(i,j)=d4(i,j)/sqrt(2.)
            end do
         end do
         call setinp(5)
         call setout(6)
         call trnspr6(d0)
         call trnspr6(d1)
         call trnspr6(d2)
         call trnspr6(d3)
         call trnspr6(d4)
      end if
      isys=getisys()
      if(isys.eq.1) then
          call mcpyr6(d0,dq)
      else if(isys.eq.2) then
          call mcpyr6(d1,dq)
      else if(isys.eq.3) then
          call mcpyr6(d2,dq)
      else if(isys.eq.4) then
          call mcpyr6(d3,dq)
      else if(isys.eq.5) then
          call mcpyr6(d4,dq)
      else
          call quit('wrong isys')
      end if
      call mcpyr6(dq,dr)
c      call matinv(dr,6,6,b,0,det,ipv,ind,piv)
      call matinv6(dr,b,0,det)
c        orthogonality check
      if(icount.eq.1) then
         call wtmtrxrf('dr',dr,6,'(6f9.5)')
         call wtmtrxrf('dq',dq,6,'(6f9.5)')
         call mtmplr(dq,dr,dtmp,6)
         call wtmtrxrf('dq*dr',dtmp,6,'(6f9.5)')
      end if
      return
      end

      subroutine setdei()   ! set phason distortion
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      common /cphasn/ amij1(3,3),amij2(3,3),amij3(3,3),
     *      amij4(3,3),amij5(3,3)
      common /cphonn/ bmij1(3,3)
      real fij1(3,3),fij2(3,3),fij3(3,3),fij4(3,3),fij5(3,3),fij6(3,3)
      real fij7(3,3),fij8(3,3),fij9(3,3),fij10(3,3)
      integer q50(6,6),q30(6,10),q20(6,15)
      common /cprjax/ q5p(6,6),q3p(6,10),q2p(6,15)
      real ctoh(6,6),htoc(6,6),ded(6,6)
      real b(6)
      integer getisys
c     for pentagonal D5
      data fij1 /0,0,0,0,0,0,0,0,1/ ! pentagonal
      data fij2 /1,0,0,0,0,0,0,0,0/
      data fij3 /0,0,0,0,1,0,0,0,0/
c     for cubic T and trigonal 
      data fij4 /1,0,0,0,1,0,0,0,1/ ! cubic phason
      data fij5 /0,0,0,0,0,0,0,0,1/ ! tetragonal phason
      data fij6 /1,0,0,0,1,0,0,0,0/ ! tetragonal phason
c     for monoclinic distortion for dihedral quasicrystals
      data fij7 /0,0,0,1,0,0,0,0,0/
      data fij8 /0,1,0,0,0,0,0,0,0/
c     for trigonal
      data fij9 /0,1,0,0,0,1,1,0,0/ ! trigonal
      data fij10 /0,1,0,0,0,0,0,0,0/
      data ctoh /0.0,     -0.816496, 0.816496, 0., 0., 0.,
     *           0.816496,-0.816496, 0.0,      0., 0., 0.,
     *           0.577350, 0.577350, 0.577350, 0., 0., 0.,
     *           0., 0., 0., 0.0,     -0.816496, 0.816496,
     *           0., 0., 0., 0.816496,-0.816496, 0.0,
     *           0., 0., 0., 0.577350, 0.577350, 0.577350/
      data q50/1,0,0,0,0,0,    ! 1
     *         0,1,0,0,0,0,    ! 2
     *         0,0,1,0,0,0,    ! 3
     *         0,0,0,1,0,0,    ! 4
     *         0,0,0,0,1,0,    ! 5 z-axis in isys=3,4
     *         0,0,0,0,0,1/    ! 6
      data q30/1,1,1,0,0,0,    ! 1
     *         1,0,1,1,0,0,    ! 2
     *         1,0,0,1,1,0,    ! 3
     *         1,0,0,0,1,1,    ! 4
     *         1,1,0,0,0,1,    ! 5
     *         0,1,1,0,-1,0,   ! 6
     *         0,0,1,1,0,-1,   ! 7
     *         0,-1,0,1,1,0,   ! 8
     *         0,0,-1,0,1,1,   ! 9
     *         0,1,0,-1,0,1/   ! 10
      data q20/1,1,0,0,0,0,    ! 1
     *         1,0,1,0,0,0,    ! 2
     *         1,0,0,1,0,0,    ! 3
     *         1,0,0,0,1,0,    ! 4  y-axis in cubic approximant
     *         1,0,0,0,0,1,    ! 5
     *         0,1,1,0,0,0,    ! 6  x-axis in cubic approximant
     *         0,0,1,1,0,0,    ! 7
     *         0,0,0,1,1,0,    ! 8
     *         0,0,0,0,1,1,    ! 9
     *         0,1,0,0,0,1,    ! 10
     *         0,1,0,0,-1,0,   ! 11
     *         0,0,1,0,0,-1,   ! 12
     *         0,-1,0,1,0,0,   ! 13
     *         0,0,-1,0,1,0,   ! 14
     *         0,0,0,-1,0,1/   ! 15  z-axis in cubic approximant

c     cubic 3 fold axis => 1 1 1 -1 1 1

      call trnspr6(ctoh)
      call mcpyr6(ctoh,htoc)   ! cubic to trigonal
c      call matinv(htoc,6,6,b,0,det,ipv,ind,piv)
      call matinv6(htoc,b,0,det)
      isys=getisys()
      do i=1,6
         call getqi0(q50(1,i),q5p(1,i))
         call norml(q5p(1,i),3)
         call norml(q5p(4,i),3)
      end do
      do i=1,10
         call getqi0(q30(1,i),q3p(1,i))
         call norml(q3p(1,i),3)
         call norml(q3p(4,i),3)
      end do
      do i=1,15
         call getqi0(q20(1,i),q2p(1,i))
         call norml(q2p(1,i),3)
         call norml(q2p(4,i),3)
      end do
      if(isys.eq.1) then
c          Y. Ishii, Phys Rev. B39 (1989) 11862
c          D5 distortion
         call mcpyr3(fij1,amij1)
         call mcpyr3(fij2,amij2)
         call mcpyr3(fij3,amij3)
         call mcpyr3(fij7,amij4)
         call mcpyr3(fij8,amij5)
         call mcpyr3(fij1,bmij1)
      else if(isys.eq.2) then
c     O (cubic) distortion     : eps1
         call mcpyr3(fij4,amij1)
c     T (tetragonal,orthorhombic) phason distortion : eps2,eps3
         call mcpyr3(fij5,amij2)
         call mcpyr3(fij6,amij3)
c     R (trigonal) phason distortion : eps3
         call mcpyr3(fij9,amij4)
         call mcpyr3(fij10,amij5)
c     T tetragonal phonon distortion : eps6
         call mcpyr3(fij5,bmij1)
      else if(isys.eq.3.or.isys.eq.4.or.isys.eq.5) then
c       ortho and monocli phason strain for dihedral cases
         call mcpyr3(fij1,amij1)
         call mcpyr3(fij2,amij2)
         call mcpyr3(fij3,amij3)
         call mcpyr3(fij7,amij4)
         call mcpyr3(fij8,amij5)
         call mcpyr3(fij1,bmij1)
      end if
      call wtmtrxrf('amij1=',amij1,3,'(3f9.5)')
      call wtmtrxrf('amij2=',amij2,3,'(3f9.5)')
      call wtmtrxrf('amij3=',amij3,3,'(3f9.5)')
      call wtmtrxrf('amij4=',amij4,3,'(3f9.5)')
      call wtmtrxrf('amij5=',amij5,3,'(3f9.5)')
      call wtmtrxrf('bmij1=',bmij1,3,'(3f9.5)')
      call unitmtrxr(de,6)
      call unitmtrxr(di,6)
      if(isys.eq.1) then
         call setamij(de,eps1,amij1)
         call setamij(de,eps2,amij2)         
         call setamij(de,eps3,amij3)         
         call setamij(de,eps4,amij4)         
         call setamij(de,eps5,amij5)         
         call setbmij(de,eps6,bmij1)
      else if(isys.eq.2) then
c     set cubic phason
         call setamij(de,eps1,amij1)         
c     set tetragonal,orthorhombic
         call setamij(de,eps2,amij2)         
         call setamij(de,eps3,amij3)         
c     set trigonal phason
         call setamij(de,eps4,amij4)         
         call setamij(de,eps5,amij5)         
*************necessary for trigonal distortion************
c         call mtmplr6(de,ctoh,ded)
c         call mtmplr6(htoc,ded,de)
**********************************************************
      else if(isys.eq.3.or.isys.eq.4.or.isys.eq.5) then
         call setamij(de,eps2,amij2)         
         call setamij(de,eps3,amij3)         
         call setamij(de,eps4,amij4)         
         call setamij(de,eps5,amij5)         
         call setbmij(de,eps6,bmij1)
      end if
      call mcpyr6(de,di)
c      call matinv(di,6,6,b,0,det,ipv,ind,piv)
      call matinv6(di,b,0,det)
      call wtmtrxrf('deformation matrix de',de,6,'(6f10.5)')
      call wtmtrxrf('deformation matrix di',di,6,'(6f10.5)')
      return
      end

      subroutine setamij(de,eps,amij) ! set phason matrix
      real de(6,6)              ! phonon-phason matrix
      real amij(3,3)            ! phason matrix
      do i=4,6
         do j=1,3
            de(i,j)=de(i,j)+eps*amij(i-3,j)
         end do
      end do
      return
      end
      
      subroutine setbmij(de,eps,bmij) ! set phonon matrix
      real de(6,6)              ! phonon-phason matrix
      real bmij(6,6)            ! phonon matrix
      do i=1,3
         do j=1,3
            de(i,j)=de(i,j)+eps*bmij(i,j)
         end do
      end do
      return
      end

      subroutine ptoch(ii)
c      primitive to centered lattice in octagonal system
      integer ii(*),ij(6)
      integer trm2
      common /ctrm/trm1(6,6),trm2(6,6)
      common /cinnn/ innn
c      coordinate transformation from primitive to face-centerd
      do in=1,innn
         call mtmplmnoi(trm2,ii,ij,6,6,1)
         call vcpyi(ij,ii,6)
      end do
      return
      end

      subroutine getqi0(h,q)
c     q space components of diffraction vector h  (a=1)
      integer h(*)
      real q(*)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      integer getisys
      isys=getisys()
      call mtmplmnoir(h,dq,q,1,6,6)
      return
      end

      subroutine getqi0r(h,q)  ! same as getqi0 but h is real
      real h(*)
      real q(*)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      integer getisys
      isys=getisys()
      call mtmplmnor(h,dq,q,1,6,6)
      return
      end

      subroutine getqi(h,q)
c     q space comp. of diffraction vector h under no phason
      integer h(*)
      real q(*)
      real qd(6),q1(6)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      real alamcl,ralamcl
      common /csclmtrx/ alamcl(6,6),ralamcl(6,6)
      integer getisys
      isys=getisys()
      call getqi0(h,qd)
      call mtmplmnor(qd,di,q1,1,6,6)
      call mtmplmnor(ralamcl,q1,q,6,6,1)
      return
      end

      subroutine getqid(h,q)
c     q space comp. of diffraction vector h under phason
      integer h(*)
      real q(*)
      real qd(6)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
c      call getqi0(h,qd)
      call getqi(h,qd)
c     phason distortion in reciprocal space
      call mtmplmnor(qd,di,q,1,6,6)
      return
      end

      subroutine geta(a,ai)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      a=al
      ai=am
      return
      end

      subroutine seta(a,ai)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      al=a
      am=ai
      return
      end

      subroutine getc(c)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      c=cl
      return
      end

      subroutine setc(c)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      cl=c
      return
      end

      subroutine celltr(x,mode)
      real x(*)
      real xd(6)
      integer trm2
      common /ctrm/ trm1(6,6),trm2(6,6)
      integer getisys
      character brv
c     mode + cell transformation      
c     mode - inverse cell transformation      
      isys=getisys()
      call getbrv(brv)
      if(brv.ne.'s') then
         return
      end if

c     only for 's' lattice
      if(isys.le.2) then
         if(mode.eq.1) then
            call sclvctr(x,0.5,6)
         else if(mode.eq.-1) then
            call sclvctr(x,2.0,6)
         end if
      else if(isys.eq.3.or.isys.eq.4) then
         if(mode.gt.0) then
            do nn=1,mode
               call mtmplmnor(trm1,x,xd,6,6,1)
               call vcpyr(xd,x,6)
            end do
         else if(mode.lt.0) then
            do nn=1,-mode
               call mtmplmnoir(trm2,x,xd,6,6,1)               
               call vcpyr(xd,x,6)
            end do
         else
            call quit('invalid mode in celltr')
         end if
      else
         call quit('invalid isys in celltr')
      end if
      return
      end

      subroutine gettrc(brv,trc0,ntrc0)  ! get centering translations
      character brv
      real trc0(6,*)
      integer ntrc(5)
      real trc1(6,1),trc2(6,2),trc3(6,32),trc4(6,1),trc5(6,2)
      integer getisys,getisim
      data ntrc/1,2,32,1,2/
      data (trc1(i,1),i=1,6) /6*0.0/
      data ((trc2(i,j),i=1,6),j=1,2) /6*0.0,6*0.5/
      data ((trc3(i,j),i=1,6),j=1,32) /
     *   0.0,0.0,0.0,0.0,0.0,0.0,  0.5,0.5,0.0,0.0,0.0,0.0,
     *   0.5,0.0,0.5,0.0,0.0,0.0,  0.5,0.0,0.0,0.5,0.0,0.0,
     *   0.5,0.0,0.0,0.0,0.5,0.0,  0.5,0.0,0.0,0.0,0.0,0.5,
     *   0.0,0.5,0.5,0.0,0.0,0.0,  0.0,0.5,0.0,0.5,0.0,0.0,
     *   0.0,0.5,0.0,0.0,0.5,0.0,  0.0,0.5,0.0,0.0,0.0,0.5,
     *   0.0,0.0,0.5,0.5,0.0,0.0,  0.0,0.0,0.5,0.0,0.5,0.0,
     *   0.0,0.0,0.5,0.0,0.0,0.5,  0.0,0.0,0.0,0.5,0.5,0.0,
     *   0.0,0.0,0.0,0.5,0.0,0.5,  0.0,0.0,0.0,0.0,0.5,0.5,
     *   0.0,0.0,0.5,0.5,0.5,0.5,  0.0,0.5,0.0,0.5,0.5,0.5,
     *   0.0,0.5,0.5,0.0,0.5,0.5,  0.0,0.5,0.5,0.5,0.0,0.5,
     *   0.0,0.5,0.5,0.5,0.5,0.0,  0.5,0.0,0.0,0.5,0.5,0.5,
     *   0.5,0.0,0.5,0.0,0.5,0.5,  0.5,0.0,0.5,0.5,0.0,0.5,
     *   0.5,0.0,0.5,0.5,0.5,0.0,  0.5,0.5,0.0,0.0,0.5,0.5,
     *   0.5,0.5,0.0,0.5,0.0,0.5,  0.5,0.5,0.0,0.5,0.5,0.0,
     *   0.5,0.5,0.5,0.0,0.0,0.5,  0.5,0.5,0.5,0.0,0.5,0.0,
     *   0.5,0.5,0.5,0.5,0.0,0.0,  0.5,0.5,0.5,0.5,0.5,0.5/
      data (trc4(i,1),i=1,6) /6*0.0/
      data ((trc5(i,j),i=1,6),j=1,2) /6*0.0,0.,0.,0.,0.,0.5,0./
      data eps/0.00001/
      isys=getisys()
      
c     ltype=1,2,3,4,5 mean p,i,f,s,c in icosahedral lattice
      ntrc0=1
      if(brv.eq.' '.or.brv.eq.'p') then
         ntrc0=ntrc(1)
         do j=1,ntrc0
            call vcpyr(trc1(1,j),trc0(1,j),6)
         end do
      else if(brv.eq.'i') then
         ntrc0=ntrc(2)
         do j=1,ntrc0
            call vcpyr(trc2(1,j),trc0(1,j),6)
         end do
      else if(brv.eq.'f') then
         ntrc0=ntrc(3)          ! reset ntrc in this program
         do j=1,ntrc0
            call vcpyr(trc3(1,j),trc0(1,j),6)
c            isim=getisim()
c            call setsmtrm(-1)
c            call smtrx(trc3(1,j),trc0(1,j),-1)
c            call saveisim(isim)
         end do
      else if(brv.eq.'s') then
         if(isys.le.2) then
            ntrc0=ntrc(3)        ! reset ntrc in this program
            do j=1,ntrc0
               call vcpyr(trc3(1,j),trc0(1,j),6)
c               isim=getisim()
c               call setsmtrm(-1)
c               call smtrx(trc3(1,j),trc0(1,j),-1)
c               call saveisim(isim)
            end do
         else if(isys.eq.3) then
            ntrc0=ntrc(1)
            do j=1,ntrc0
               call vcpyr(trc1(1,j),trc0(1,j),6)
            end do
         else if(isys.eq.4) then
            ntrc0=ntrc(1)
            do j=1,ntrc0
               call vcpyr(trc1(1,j),trc0(1,j),6)
            end do
         else if(isys.eq.5) then
            ntrc0=ntrc(1)
            do j=1,ntrc0
               call vcpyr(trc1(1,j),trc0(1,j),6)
            end do
         end if
      else if(brv.eq.'c') then
         ntrc0=2
         do j=1,ntrc0
            call vcpyr(trc5(1,j),trc0(1,j),6)
         end do
      else if(brv.eq.'g') then
         ntrc0=1
         do j=1,ntrc0
            call vcpyr(trc5(1,j),trc0(1,j),6)
         end do
      end if
      return
      end

      subroutine gettrc1(brv,trc0,ntrc0)
      character brv
c      this is equivalent to gettrc but does not work in f2c
      real trc0(6,*)
      integer ntrc(5)
      real trc(6,32,5)
      integer getisys
      data ntrc/1,2,32,1,2/
      data (trc(i,1,1),i=1,6) /6*0.0/
      data ((trc(i,j,2),i=1,6),j=1,2) /6*0.0,6*0.5/
      data ((trc(i,j,3),i=1,6),j=1,32) /
     *   0.0,0.0,0.0,0.0,0.0,0.0,  0.5,0.5,0.0,0.0,0.0,0.0,
     *   0.5,0.0,0.5,0.0,0.0,0.0,  0.5,0.0,0.0,0.5,0.0,0.0,
     *   0.5,0.0,0.0,0.0,0.5,0.0,  0.5,0.0,0.0,0.0,0.0,0.5,
     *   0.0,0.5,0.5,0.0,0.0,0.0,  0.0,0.5,0.0,0.5,0.0,0.0,
     *   0.0,0.5,0.0,0.0,0.5,0.0,  0.0,0.5,0.0,0.0,0.0,0.5,
     *   0.0,0.0,0.5,0.5,0.0,0.0,  0.0,0.0,0.5,0.0,0.5,0.0,
     *   0.0,0.0,0.5,0.0,0.0,0.5,  0.0,0.0,0.0,0.5,0.5,0.0,
     *   0.0,0.0,0.0,0.5,0.0,0.5,  0.0,0.0,0.0,0.0,0.5,0.5,
     *   0.0,0.0,0.5,0.5,0.5,0.5,  0.0,0.5,0.0,0.5,0.5,0.5,
     *   0.0,0.5,0.5,0.0,0.5,0.5,  0.0,0.5,0.5,0.5,0.0,0.5,
     *   0.0,0.5,0.5,0.5,0.5,0.0,  0.5,0.0,0.0,0.5,0.5,0.5,
     *   0.5,0.0,0.5,0.0,0.5,0.5,  0.5,0.0,0.5,0.5,0.0,0.5,
     *   0.5,0.0,0.5,0.5,0.5,0.0,  0.5,0.5,0.0,0.0,0.5,0.5,
     *   0.5,0.5,0.0,0.5,0.0,0.5,  0.5,0.5,0.0,0.5,0.5,0.0,
     *   0.5,0.5,0.5,0.0,0.0,0.5,  0.5,0.5,0.5,0.0,0.5,0.0,
     *   0.5,0.5,0.5,0.5,0.0,0.0,  0.5,0.5,0.5,0.5,0.5,0.5/
      data (trc(i,1,4),i=1,6) /6*0.0/
      data ((trc(i,j,5),i=1,6),j=1,2) /6*0.0,0.,0.,0.,0.,0.5,0./
      data eps/0.00001/
      isys=getisys()
c     ltype=1,2,3,4,5 mean p,i,f,s,c in icosahedral lattice
      if(brv.eq.' '.or.brv.eq.'p') then
         ntrc0=1
         ltyped=1
      else if(brv.eq.'i') then
         ltyped=2
         ntrc0=ntrc(ltyped)
      else if(brv.eq.'f'.or.brv.eq.'s') then
         if(isys.le.2) then
            ntrc0=32
            ltyped=3
         else if(isys.eq.3) then
            ntrc0=1
            ltyped=1
         else if(isys.eq.4) then
            ntrc0=1
            ltyped=1
         else if(isys.eq.5) then
            ntrc0=1
            ltyped=1
         end if
c      else if(brv.eq.'c') then
c         ltype=1
c         ntrc0=ntrc(ltype)
      end if
      do j=1,ntrc0
         call vcpyr(trc(1,j,ltyped),trc0(1,j),6)
      end do
      return
      end

      integer function getisys()
      common /cisys/ isys
      getisys=isys
      return
      end            

      subroutine getsys(isys)
      integer getisys
      isys=getisys()
      return
      end            

      subroutine setsys(isysd)
      common /cisys/ isys
      isys=isysd
      return
      end            

      subroutine seteps(eps1d,eps2d,eps3d,eps4d,eps5d,eps6d)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      integer getisys
      eps1=eps1d
      eps2=eps2d
      eps3=eps3d
      eps4=eps4d
      eps5=eps5d
      eps6=eps6d
      isys=getisys()
      if(isys.le.2) then
          write(6,*) 'a=',al,
     *      '  eps1=',eps1,' eps2=',eps2,' eps3=',eps3,' eps4=',eps4,
     *      ' eps5=',eps5,' eps6=',eps6
      else 
          write(6,*) ' a=',al,' c=',cl,
     *      '  eps1=',eps1,' eps2=',eps2,' eps3=',eps3,' eps4=',eps4,
     *      ' eps5=',eps5,' eps6=',eps6
      end if
      return
      end

      subroutine geteps(eps1d,eps2d,eps3d,eps4d,eps5d,eps6d)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      eps1d=eps1
      eps2d=eps2
      eps3d=eps3
      eps4d=eps4
      eps5d=eps5
      eps6d=eps6
      return
      end

      subroutine getqe0(h,q)  ! q space component of 6D vector h (a=1)
c     q : q(1)-q(3) external q(4)-q(6) internal space components
      real h(*),q(*)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      call mtmplmnor(dr,h,q,6,6,1)
      call getsys(isys)
      if(isys.ge.3) then ! dihedral case
         q(6)=0
      end if
      return
      end

      subroutine getqe(h,q)  ! q space component of 6D vector h
      real h(*),q(*)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      integer getisys
c      real lcnst(6),qd(6)
      real qd(6)
      real alamcl,ralamcl
      common /csclmtrx/ alamcl(6,6),ralamcl(6,6)
      call getqe0(h,qd)
      call mtmplmnor(alamcl,qd,q,6,6,1)
c     call getlcnst(lcnst)
c     call vmult(q,lcnst,qd,6)
c     call vcpyr(qd,q,6)
      return
      end

      subroutine getqed(h,q)  ! distorted
      real h(*),q(*)
      real qd(6)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      integer getisys
c     phason distortion in real space
      call getqe(h,qd)
      call mtmplmnor(de,qd,q,6,6,1)
      return
      end

      subroutine getxe(q,x)  ! undistorted
      real q(*),x(*)
      real qd(6)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      real alamcl,ralamcl
      common /csclmtrx/ alamcl(6,6),ralamcl(6,6)
      integer getisys
      isys=getisys()
c     write(6,*) 'al,am,cl=',al,am,cl
      call mtmplmnor(ralamcl,q,qd,6,6,1)
      call mtmplmnor(dq,qd,x,6,6,1)
      return
      end

      subroutine getxed(q,x)  ! distorted to undistorted x 
c     inverse transformation of getqed
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      real q(*),x(*)
      real qd(6)
      save ncount
      data ncount /0/
      if(ncount.eq.0) then
         write(6,*) '****************************'
         write(6,*) 'caution : unchecked getxed is used !'
         write(6,*) '****************************'
      end if
      ncount=ncount+1
c     call getxe(q,x)   ! original
      call mtmplmnor(di,q,qd,6,6,1) ! remove distortion
      call getxe(qd,x)          ! undistorted x
      return
      end

      integer function getntrc()
      common /ctrc/ trc(6,32),trcd(6,32), ntrc
      getntrc=ntrc
      return
      end

      subroutine reduc(ry)
      real ry(*)
      call reduc0(ry)
      return
      end

      subroutine reduc1(ry)
c     obtain ry within a wigner saitz cell in 6D
      real ry(*)
      common /ctrc/ trc(6,32),trcd(6,32), ntrc
      real rx(6),rm(6),q(6)
      do i=1,6
         ry(i)=mod(ry(i),1.)
         rd=ry(i)
         if(rd.lt.-0.001) then
            ry(i)=ry(i)+1
         end if
      end do

      n=0
      do j=1,ntrc
         n=n+1
         do i=1,6
            rx(i)=ry(i)-trcd(i,j)
         end do
         call getqe(rx,q)
         if(n.eq.1) then
            vmin=vabs(q,6)
            call vcpyr(rx,rm,6)
         else if(vabs(q,6).lt.vmin) then
            vmin=vabs(q,6)
            call vcpyr(rx,rm,6)
         end if            
      end do
      call vcpyr(rm,ry,6)
      return
      end

      subroutine reduc0(ry)
      real ry(*)
c     obtain ry within a wigner saitz cell in 6D
      integer getisys
      isys=getisys()
      if(isys.le.2) then
         iend=6
      else
         iend=5
      end if

      do i=1,iend
         ry(i)=mod(ry(i),1.)
         rd=ry(i)
         if(rd.lt.-0.499) then
            ry(i)=ry(i)+1
         else if(rd.gt.0.501) then
            ry(i)=ry(i)-1
         end if
      end do
      return
      end

      subroutine setlcnst(al,cl)
      real lcnst
      common /clcnst/ lcnst(6)
      integer getisys
      isys=getisys()
      do i=1,6
         lcnst(i)=al
      end do
      if(isys.ge.3) then
         lcnst(3)=cl
         lcnst(6)=0
      end if
      return
      end

      subroutine getlcnst(lcnstd)
      real lcnstd(*)
      real lcnst
      common /clcnst/ lcnst(6)
      call vcpyr(lcnst,lcnstd,6)
      return
      end

      subroutine setdd(brv)   ! for dihedral ?
      character brv
      parameter (tau=1.61803399)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      dimension ipv(6),ind(6,2),piv(6),b(6)
      real dd(6,6)
      if(brv.eq.'s') then
         call mcpyr6(dq,dd)
         do i=1,6
            do j=1,6
               if(j.eq.4.or.j.eq.5) then
                  dq(i,j)=dd(i,j)*tau
               else
                  dq(i,j)=dd(i,j)
               end if
            end do
         end do
      else
         call quit('invalid brv in setdd')
      end if
      call mcpyr6(dq,dr)
c      call matinv(dr,6,6,b,0,det,ipv,ind,piv)
      call matinv(dr,b,0,det)
      do i=1,6
         write(6,'(6f7.3)') (dr(i,j),j=1,6)
      end do
      write(6,*) ' '
      do i=1,6
         write(6,'(6f7.3)') (dq(i,j),j=1,6)
      end do
      return
      end 

      subroutine settrm(isys)
      integer trm2
      common /ctrm/ trm1(6,6),trm2(6,6)
      integer trm01(6,6),trm02(6,6),trm03(6,6),trm04(6,6)
c     decagonal
      data trm01 /2, 2,-3, 2,0,0,
     *          -1, 4,-1,-1,0,0,
     *           1, 1, 1, 1,0,0,
     *          -2, 3,-2, 3,0,0,
     *           0, 0, 0, 0,5,0,
     *           0, 0, 0, 0,0,5/
      data trm02 /1, 0, 1,-1,0,0,
     *           0, 1, 1, 0,0,0,
     *          -1, 0, 2, 0,0,0,
     *           0,-1, 1, 1,0,0,
     *           0, 0, 0, 0,1,0,
     *           0, 0, 0, 0,0,1/
c     octagonal
      data trm03 /1, 1,-1, 1,0,0,
     *          -1, 1, 1,-1,0,0,
     *           1,-1, 1, 1,0,0,
     *          -1, 1,-1, 1,0,0,
     *           0, 0, 0, 0,2,0,
     *           0, 0, 0, 0,0,2/
      data trm04 /1, 0, 0,-1,0,0,
     *           1, 1, 0, 0,0,0,
     *           0, 1, 1, 0,0,0,
     *           0, 0, 1, 1,0,0,
     *           0, 0, 0, 0,1,0,
     *           0, 0, 0, 0,0,1/
      if(isys.eq.3) then   ! decagonal
         do i=1,6
            do j=1,6
               trm1(i,j)=trm01(i,j)/5.
            end do
         end do
         do i=1,6
            do j=1,6
               trm2(i,j)=trm02(i,j)
            end do
         end do
      else if(isys.eq.4) then  ! octagonal
         do i=1,6
            do j=1,6
               trm1(i,j)=trm03(i,j)/2.
            end do
         end do
         do i=1,6
            do j=1,6
               trm2(i,j)=trm04(i,j)
            end do
         end do
      end if
      return
      end

      subroutine setn123(icase)  ! set unit vectors of cartesian coord.
      real n1,n2,n3,n3x
      integer q3(6),q2(6)
      common /clmt1/ ram,rbm,dx,dy,n1(6),n2(6),n3(6),n3x
      common /cprjax/ q5p(6,6),q3p(6,10),q2p(6,15)
      common /corntm/ orntm(3,3) ! orientation matrix for uijxy

      real q10(6),q2x(6),q2y(6)
      data q10 /0,0,1,0,0,0/
      data q2y /0,1,0,0,0,0/
      data q2x /1,0,0,0,0,0/
      integer getisys

      isys=getisys()
      if(isys.le.2) then      
         if(icase.eq.1) then
c     projection along 5-fold axis
            write(6,'(a)') '5-fold axis'
            call vcpyr(q5p(1,1),n3,6)  ! z axis in pentagonal quasicrystal
            call vcpyr(q2p(1,15),n2,6) ! y axis in pentagonal quasicrystal
            call vprd(n2,n3,n1)        ! vector product of n2 and n3
            call vprd(n2(4),n3(4),n1(4))       ! vector product of n2 and n3
         else if(icase.eq.2) then
c     projection along 3-fold axis
            write(6,'(a)') '3-fold axis'
            call vcpyr(q3p(1,5),n3,6)  ! 3-fold axis in cubic approximant
            call vcpyr(q2p(1,14),n1,6) ! 2-fold axis in cubic approximant
            call vprd(n3,n1,n2)
            call vprd(n3(4),n1(4),n2(4))
         else if(icase.eq.3) then
c     projection along 2-fold axis
            write(6,'(a)') '2-fold axis'
            call vcpyr(q2p(1,15),n3,6) ! 2-fold axis in pentagonal quasicrystal
            call vcpyr(q5p(1,1),n1,6)  ! 5-fold axis in pentagonal quasicrystal
            call vprd(n3,n1,n2)
            call vprd(n3(4),n1(4),n2(4))
         else if(icase.eq.4) then
c     projection along 2-fold axis
            call vcpyr(q2p(1,15),n3,6) ! z-axis in cubic approximant
c            call vcpyr(q2p(1,6),n1,6)  ! x-axis in cubic approximant
c            call vprd(n3,n1,n2)
            call vcpyr(q2p(1,4),n2,6)  ! y-axis in cubic approximant
            call vprd(n2,n3,n1)
            call vprd(n2(4),n3(4),n1(4))
c           write(6,'(a)') 'along (000-101)'
         else if(icase.eq.5) then
c     projection along a specified direction
            call getq23(q2,q3)
            call getqi0(q3,n3)
            call norml(n3(1),3)
            call norml(n3(4),3)
            call getqi0(q2,n2)
            call norml(n2(1),3)
            call norml(n2(4),3)
            call vprd(n2,n3,n1)
            call vprd(n2(4),n3(4),n1(4))
         else
            call quit('wrong icase')
         end if
      else if(isys.eq.3) then
c     projection along 10 or 5-fold axis
         if(icase.eq.1) then
            write(6,'(a)') '10-fold axis'
            call vcpyr(q10,n3,6) ! z axis in pentagonal quasicrystal
            call vcpyr(q2y,n2,6) ! y axis in pentagonal quasicrystal
            call vprd(n2,n3,n1)
         else if(icase.eq.2) then 
            call vcpyr(q2x,n3,6) ! x axis in pentagonal quasicrystal
            call vcpyr(q10,n2,6) ! z axis in pentagonal quasicrystal
            call vprd(n2,n3,n1)
         else if(icase.eq.3) then 
            call vcpyr(q2x,n3,6) ! x axis in pentagonal quasicrystal
            call vcpyr(q10,n2,6) ! z axis in pentagonal quasicrystal
            call vprd(n2,n3,n1)
         else
            call quit('wrong icase')
         end if
      else if(isys.eq.4) then
c     projection along 8-fold axis
         if(icase.eq.1) then
            write(6,'(a)') '8-fold axis'
            call vcpyr(q10,n3,6) ! z axis in octagonal quasicrystal
            call vcpyr(q2y,n2,6) ! y axis in octagonal quasicrystal
            call vprd(n2,n3,n1)
         else if(icase.eq.2) then 
            call vcpyr(q2x,n3,6) ! x axis in octagonal quasicrystal
            call vcpyr(q10,n2,6) ! z axis in octagonal quasicrystal
            call vprd(n2,n3,n1)
         else if(icase.eq.3) then 
            call vcpyr(q2x,n3,6) ! x axis in octagonal quasicrystal
            call vcpyr(q10,n2,6) ! z axis in octagonal quasicrystal
            call vprd(n2,n3,n1)
         else
            call quit('wrong icase')
         end if
      else if(isys.eq.5) then
c     projection along 12-fold axis
         if(icase.eq.1) then
            write(6,'(a)') '12-fold axis'
            call vcpyr(q10,n3,6) ! z axis in dodecagonal quasicrystal
            call vcpyr(q2y,n2,6) ! y axis in dodecagonal quasicrystal
            call vprd(n2,n3,n1)
         else if(icase.eq.2) then 
            call vcpyr(q2x,n3,6) ! x axis in dodecagonal quasicrystal
            call vcpyr(q10,n2,6) ! z axis in dodecagonal quasicrystal
            call vprd(n2,n3,n1)
         else if(icase.eq.3) then 
            call vcpyr(q2x,n3,6) ! x axis in dodecagonal quasicrystal
            call vcpyr(q10,n2,6) ! z axis in dodecagonal quasicrystal
            call vprd(n2,n3,n1)
         else
            call quit('wrong icase')
         end if
      end if
      call vcpyr(n1,orntm(1,1),3)
      call vcpyr(n2,orntm(1,2),3)
      call vcpyr(n3,orntm(1,3),3)
      call trnspr3(orntm)          ! orientation matrix for uixy
      call wtmtrxrf('orientation matrix',orntm,3,'(3f10.5)')
c     stop
c      call wtvctrr('n1=',n1,3)
c      call wtvctrr('n2=',n2,3)
c      call wtvctrr('n3=',n3,3)
c     stop
      return
      end

      subroutine setbrv(brv)
      character brv0,brv
      common /cbrv/ brv0
      brv0=brv
      return
      end

      subroutine getbrv(brv)
      character brv0,brv
      common /cbrv/ brv0
      brv=brv0
      return
      end

      subroutine getabc(gab,abccos)
      real abccos(6),gab(3,3)
      abccos(1)=sqrt(gab(1,1))
      abccos(2)=sqrt(gab(2,2))
      abccos(3)=sqrt(gab(3,3))
      abccos(4)=gab(2,3)/(abccos(2)*abccos(3))
      abccos(5)=gab(1,3)/(abccos(1)*abccos(3))
      abccos(6)=gab(1,2)/(abccos(1)*abccos(2))
      return
      end

      subroutine saveisim(isimd)
      common /cisim/ isim
      isim=isimd
      return
      end

      integer function getisim()
      common /cisim/ isim
      getisim=isim
      return
      end

      subroutine smtrx(h,hd,ind)
      real h(*),hd(*)
      real ht(6)
      common /csmtrm/ s(6,6)
      integer getisys
      isys=getisys()
c     call wtmtrxr('s',s,6)
      nend=ind
c     similarity transformation for decagonal and icosahedral
      call vcpyr(h,ht,6)
      if(ind.eq.0) then
           call vcpyr(ht,hd,6)
      else if(ind.gt.0) then
c        ext ==> tau  int ==> tau**-1
         do n=1,nend
            call mtmplmnor(ht,s,hd,1,6,6)
            if(n.ne.nend) call vcpyr(hd,ht,6)
         end do
         if(isys.le.2) then
            do j=1,6
               hd(j)=hd(j)/2**nend
            end do
         end if
         return
      else if(ind.lt.0) then
c        ext ==> tau**-1  int ==> tau
          do n=1,-nend
             call mtmplmnor(ht,s,hd,1,6,6)
             if(n.ne.-nend) call vcpyr(hd,ht,6)
          end do
          if(isys.le.2) then
              do j=1,6
                 hd(j)=hd(j)/2**abs(nend)
              end do
          end if
          return
      end if
      end

      subroutine setsmtrm(ind)  ! similarity transformation matrix
      common /csmtrm/ s(6,6)
      real s0(6,6),t0(6,6),s1(6,6),t1(6,6),s2(6,6),t2(6,6)
      real s3(6,6),t3(6,6)
      integer getisys
*************icosahedral f or i*************
      data s0/ 1, 1, 1, 1, 1, 1,
     *         1, 1, 1,-1,-1, 1,
     *         1, 1, 1, 1,-1,-1,
     *         1,-1, 1, 1, 1,-1,
     *         1,-1,-1, 1, 1, 1,
     *         1, 1,-1,-1, 1, 1/
      data t0/-1, 1, 1, 1, 1, 1,
     *         1,-1, 1,-1,-1, 1,
     *         1, 1,-1, 1,-1,-1,
     *         1,-1, 1,-1, 1,-1,
     *         1,-1,-1, 1,-1, 1,
     *         1, 1,-1,-1, 1,-1/
***************decagonal*********************
      data s1/ 0, 0,-1,-1, 0, 0,
     *         1, 1, 1, 0, 0, 0,
     *         0, 1, 1, 1, 0, 0,
     *        -1,-1, 0, 0, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
      data t1/-1, 0,-1,-1, 0, 0,
     *         1, 0, 1, 0, 0, 0,
     *         0, 1, 0, 1, 0, 0,
     *        -1,-1, 0,-1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
***************octagonal*********************
      data s2/ 1, 1, 0,-1, 0, 0,
     *         1, 1, 1, 0, 0, 0,
     *         0, 1, 1, 1, 0, 0,
     *        -1, 0, 1, 1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
      data t2/-1, 1, 0,-1, 0, 0,
     *         1,-1, 1, 0, 0, 0,
     *         0, 1,-1, 1, 0, 0,
     *        -1, 0, 1,-1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
***************dodecagonal*********************
      data s3/ 1, 0, 0,-1, 0, 0,
     *         1, 1, 0, 0, 0, 0,
     *         0, 1, 1, 1, 0, 0,
     *         0, 0, 1, 1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
      data t3/ 0, 1, -1, 1, 0, 0,
     *         0, 0, 1, -1, 0, 0,
     *         1,-1, 1, 0, 0, 0,
     *        -1, 1,-1, 1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
c      data s3/ 2, 1, 0,-1, 0, 0,
c     *         2, 2, 1, 0, 0, 0,
c     *         0, 1, 2, 2, 0, 0,
c     *        -1, 0, 1, 2, 0, 0,
c     *         0, 0, 0, 0, 1, 0,
c     *         0, 0, 0, 0, 0, 1/
c      data t3/ 2,-1, 0, 1, 0, 0,
c     *        -2, 2,-1, 0, 0, 0,
c     *         0,-1, 2,-2, 0, 0,
c     *         1, 0,-1, 2, 0, 0,
c     *         0, 0, 0, 0, 1, 0,
c     *         0, 0, 0, 0, 0, 1/
      isys=getisys()
      if(isys.le.2) then
         if(ind.gt.0) then
            call mcpyr6(s0,s)
         else if(ind.lt.0) then
            call mcpyr6(t0,s)
         else
            call unitmtrxr(s,6)
         end if
      else if(isys.eq.3) then
         if(ind.gt.0) then
            call mcpyr6(s1,s)
         else if(ind.lt.0) then
            call mcpyr6(t1,s)
         else
            call unitmtrxr(s,6)
         end if
      else if(isys.eq.4) then
         if(ind.gt.0) then
            call mcpyr6(s2,s)
         else if(ind.lt.0) then
            call mcpyr6(t2,s)
         else
            call unitmtrxr(s,6)
         end if
      else if(isys.eq.5) then
         if(ind.gt.0) then
            call mcpyr6(s3,s)
         else if(ind.lt.0) then
            call mcpyr6(t3,s)
         else
            call unitmtrxr(s,6)
         end if
      end if
c      write(6,*) 'isys=',isys,' ind=',ind
c      write(6,*) '*******************'
c      call wtmtrxr('s1',s1,6)
c      call wtmtrxr('s2',s2,6)
c      call wtmtrxr('s3',s3,6)
c      call wtmtrxr('t1',t1,6)
c      call wtmtrxr('t2',t2,6)
c      call wtmtrxr('t3',t3,6)
c      call wtmtrxr('s',s,6)
c      write(6,*) '*******************'
c      stop
      return
      end
