      subroutine setiphas(iphasd)
      common /phason/ iphas
      iphas=iphasd
      return
      end

      integer function getiphas()
      common /phason/ iphas
      getiphas=iphas
      return
      end

      subroutine getkp(k,kp,waveln)
      integer k(6)   ! wave vector in 6D
      real kp(3)     ! wave vector for the periodic phason
      real q(6)
c     
      call getqi(k,q)      ! q coordinates
      call zerovr(q(4),3)  ! the internal component is the zero vector
      call norml(q,3)      ! the external component is the unit vector
      scl=1.0/waveln       ! wave vector with a given wavelength
      call sclvctr(q,scl,3)
      call vcpyr(q,kp,3)
      return
      end

      subroutine getpa(x,pa,amp)  ! get phason amplitudes
      real x(6)      ! direction of the phason shift in 6D
      real pa(6)     ! phason amplitude in q coordinate system
      real q(6)
      call getqe(x,q)      ! q coordinates
      call zerovr(q,3)     ! the external component is the zero vector
      call norml(q(4),3)   ! the internal component is the unit vector
      call sclvctr(q,amp,6) ! phason with a given amplitude and direction
      call vcpyr(q,pa,6)   ! phason amplitudes for the periodic phason
      return
      end

      subroutine phasonsft(qd,qdp,pa,kp)
      real qd(6),qdp(6),pa(6),kp(3)
c     qd : the center of small OD (in q coordinate system)
c     qdp : the center of small OD (in q coordinate system) under the phason
c     pa: phason amplitude of the periodic phason (in q coordinate system)
c     kp : phason wave vector of the periodic phason
      call vcpyr(qd,qdp,6)
c     periodic shift is added
      do i=4,6
         qdp(i)=qdp(i)+pa(i)*cos(2*getpi()*vinpr(kp,qd,3))
      end do
      return
      end

         
