      integer function polyhd0(qd,n,isg)    ! undistorted OD
      real qd(*)
      integer irs(0:120)
      integer iski(0:120)
      real ej1(6),ej2(6),ej3(6),nii(0:6,4)
      real q(6),qe(6),xe(6)
      integer getnsym,geticnt,getnth,expnsic
      integer getisyd
      data  eps1/0.00001/
      data  eps /0.00001/
      ra=getramax(n)
      isyd=getisyd(n)
      call getiski(iski)        ! get inverse operator table
c     if -qd is in the polyhedron polyhd0=0 else polyhd0=1
c         e(1,i)-e(6,i) : i-th edge vector defining a primitive of a polyhedron
c         polyhedron is given by the primitive and site symmetry operations
c         e(1,i)-e(3,i) external components
c         e(4,i)-e(6,i) internal components
c         -qd should be in the occupation domain.  the occupation domain
c         is devided into independent tetrahedra and those induced from
c         them by the site symmetry operations.  when -qd is in a tetra-
c         hedron obtained from an independent one by r(nsy), -r(nsyi)qd
c         is in the original (independent) tetrahedron, where r(nsyi)
c         is the inverse operator of r(nsy).  therefore if -r(nsyi)qd
c         or -q=-r(nsy)qd (since r(nsy)'s construct a group) is in an
c         independent tetrahedron, -qd is in the occupation domain.
c     irs(0): number of site symmetry operators
      call getnsic(ns,icn)      ! get current symmetry operator
      ns1=expnsic(ns,icn)

      call getirs(n,irs)        ! site symmetry operator for n-th atom
      nth=getnth(n)
      polyhd0=1

      do nsd=1,irs(0)           ! site symmetry used
         nsj=irs(nsd)           ! site symmetry operator
         ns2=mpltblv(isyd,nsj)
         nst=mpltblv(ns1,ns2)
         ns3=iski(nst)          ! inverse operator
         call getrx1i(qd,q,ns3) ! inverse rotation 
         do i=1,nth
            call getej123(n,i,ej1,ej2,ej3) ! i-th tetrahedron in n-th OD
            call getnii1(ej1,ej2,ej3,nii,sig) ! undistorted
            if(nii(0,4).le.eps) go to 100
            q1=-vinpr(q(4),nii(4,1),3) ! direction cos to 1st plane normal
            q2=-vinpr(q(4),nii(4,2),3) ! direction cos to 2nd plane normal
            q3=-vinpr(q(4),nii(4,3),3) ! direction cos to 3rd plane normal
            q4=-vinpr(q(4),nii(4,4),3) ! direction cos to 4tj plane normal
            fx= vinpr(ej1(4),nii(4,4),3)*(ra*(1+eps1)) ! distance to 4th plane
            if(q1.le.eps .and. q2.le.eps .and. q3.le.eps
     *           .and. q4.le.fx) then
               polyhd0=0
               return
            end if
 100        continue
         end do
      end do
      return
      end

      integer function polyhd1(qd,n,isg)  ! distorted OD under phason
      real qd(*)
      integer irs(0:120)
      real fj10(6),fj20(6),fj30(6),nii(0:6,4)
      real q(6),qe(6),xe(6)
      real fj1(6),fj2(6),fj3(6),fj1d(6),fj2d(6),fj3d(6)
      integer getnsym,geticnt,getnth,expnsic,getisyd
      data  eps1/0.00001/
      data  eps /0.00001/
      ra=getramax(n)
      isyd=getisyd(n)
c     qd : q under phason distortion
c     if -qd is in the polyhedron polyhd1=0 else polyhd1=1
c     e(1,i)-e(6,i) : i-th edge vector defining a primitive of a polyhedron
c         polyhedron is given by the primitive and site symmetry operations
c     e(1,i)-e(3,i) external components
c     e(4,i),e(6,i) internal components
c         -qd should be in the occupation domain.  the occupation domain
c         is devided into independent tetrahedra and those induced from
c         them by the site symmetry operations.  when -qd is in a tetra-
c         hedron obtained from an independent one by r(nsy)
c         
c     irs(0): number of site symmetry operators
      call getnsic(ns,icn) ! current symmetry operator
      ns1=expnsic(ns,icn)  ! current symmetry operator
      call vcpyr(qd,q,6)    ! rotated OD coordinates under phason

      call getirs(n,irs)    ! get site symmetry operations for n-th atom
      nth=getnth(n)
      polyhd1=1

      do nsd=1,irs(0)                  ! site symmetry used
         nsj=irs(nsd)                  ! site symmetry operator
         ns2=mpltblv(isyd,nsj)
         ns3=mpltblv(ns1,ns2)
         do i=1,nth
            call getfj123(n,i,fj10,fj20,fj30) ! original 6D vectors
            call getfjd0(fj10,fj1,ns3) ! fj1 : rotated vector
            call getfjd0(fj20,fj2,ns3) ! fj2 : rotated vector
            call getfjd0(fj30,fj3,ns3) ! fj3 : rotated vector
            call getfjd3(fj1,fj2,fj3)  ! x to q vector under linear phason
            call getnii1(fj1,fj2,fj3,nii,sig) ! getnii vectors for tetrahedron
            if(nii(0,4).le.eps) go to 100
            q1=-vinpr(q(4),nii(4,1),3) ! direction cos to 1st plane normal
            q2=-vinpr(q(4),nii(4,2),3) ! direction cos to 2nd plane normal
            q3=-vinpr(q(4),nii(4,3),3) ! direction cos to 3rd plane normal
            q4=-vinpr(q(4),nii(4,4),3) ! direction cos to 4th plane normal
            fx= vinpr(fj1(4),nii(4,4),3)*(ra*(1+eps1)) ! distance to 4th plane
            if(q1.le.eps .and. q2.le.eps .and. q3.le.eps
     *           .and. q4.le.fx) then
c     -q is in the tetrahedron induced from an independent one
c     by the site symmetry operator r(nsyi)
               polyhd1=0
               return
            end if
 100        continue
         end do
      end do
      return
      end

      integer function polyg0(qd,n,isg)  ! undeformed OD
      real qd(*)
      integer irs(0:120)
      real ej10(6),ej20(6),nid(0:6,4)
      real q(6),qe(6)
      integer iski(0:120)
      integer getnsym,geticnt,getnth,expnsic,getisyd
      data  eps1/0.00001/
      data  eps /0.00001/
      ra=getramax(n)
      isyd=getisyd(n)
      call getiski(iski)
c     e(1,i)-e(5,i) : i-th edge vector defining a primitive of a polygon
c       polygon is given by the primitive and site symmetry operations
c     e(1,i)-e(3,i) external components
c     e(4,i),e(5,i) internal components
c     isg=-1 means the inverse poligon
c         -qd should be in the occupation domain.  the occupation domain
c         is devided into independent triangles and those induced from
c         them by the site symmetry operations.  when -qd is in a tetra-
c         hedron obtained from an independent one by r(nsy), -r(nsyi)qd
c         is in the original (independent) triangle, where r(nsyi)
c         is the inverse operator of r(nsy).  therefore if -r(nsyi)qd
c         or -q=-r(nsy)qd (since r(nsy)'s construct a group) is in an
c         independent triangle, -qd is in the occupation domain.
c     irs(0): number of site symmetry operators
c     if qd is in the polygon polyg0=0 else polyg0=1
      call getnsic(ns,icn)      ! current symmetry operator
      nsi=iski(ns)
      ns1=expnsic(nsi,icn)
      call getrx1i(qd,qe,ns1)   ! rotation

      call getirs(n,irs)        ! site symmetry operations for n-atom
      nth=getnth(n)
      polyg0=1
      if(ra.le.0) return
c      write(6,*) n,(irs(nsd),nsd=1,irs(0))

      do nsd=1,irs(0)
         nsj=irs(nsd)           ! site symmetry operator
         ns2=mpltblv(isyd,nsj)
         ns3=iski(ns2)          ! inverse operator
         call getrx1i(qe,q,ns3) ! rotation
         do i=1,nth
            call getej12(n,i,ej10,ej20)
            call getnid1(ej10,ej20,nid,sig)
            q1=-vinpr(q(4),nid(4,1),2)*isg ! direction cos to 1st edge normal
            q2=-vinpr(q(4),nid(4,2),2)*isg ! direction cos to 2nd edge normal
            q3=-vinpr(q(4),nid(4,3),2)*isg ! direction cos to 3rd edge normal
            fx= vinpr(ej10(4),nid(4,3),2)*(ra*(1+eps1)) ! distance to 3rd edge
            if(q1.le.eps.and.q2.le.eps.and.q3.le.fx) then
c     -q is in the triangle induced from an independent one
c     by the site symmetry operator r(nsyi)
               polyg0=0
               return
            end if
         end do
      end do
      return
      end

      integer function polyg1(qd,n,isg)   ! reshaped OD under phason
      real qd(*)
      integer irs(0:120)
      real fj10(6),fj20(6),nid(0:6,4)
      real fj1(6),fj2(6),fj1d(6),fj2d(6)
      real q(6),qe(6),xe(6)
      integer getnsym,geticnt,getnth,expnsic,getisyd
      data  eps1/0.00001/
      data  eps /0.00001/
      ra=getramax(n)
      isyd=getisyd(n)
c     e(1,i)-e(5,i) : i-th edge vector defining a primitive of a polygon
c       polygon is given by the primitive and site symmetry operations
c     e(1,i)-e(3,i) external components
c     e(4,i),e(5,i) internal components
c     isg=-1 means the inverse poligon
c         -qd should be in the occupation domain.  the occupation domain
c         is devided into independent triangles and those induced from
c         them by the site symmetry operations.
c     irs(0): number of site symmetry operators
c     if qd is in the polygon polyg=0 else polyg=1
      call getnsic(ns,icn) ! current symmetry operator
      ns1=expnsic(ns,icn)
      call vcpyr(qd,q,6)   ! rotated OD coordinates under phason
      call getirs(n,irs)   ! site symmetry operations for n-atom
      nth=getnth(n)
      polyg1=1
      if(ra.le.0) return
c     write(6,*) n,(irs(nsd),nsd=1,irs(0))

      do nsd=1,irs(0)
         nsj=irs(nsd)                     ! site symmetry operator
         ns2=mpltblv(isyd,nsj)
         ns3=mpltblv(ns1,ns2)
         do i=1,nth
            call getfj12(n,i,fj10,fj20)
            call getfjd0(fj10,fj1,ns3)    ! fj1 : rotated vector
            call getfjd0(fj20,fj2,ns3)    ! fj2 : rotated vector
            call getfjd2(fj1,fj2)         ! internal vector under linear phason
            call getnid1(fj1,fj2,nid,sig) ! getnid vectors
            q1=-vinpr(q(4),nid(4,1),2)*isg ! direction cos to 1st edge normal
            q2=-vinpr(q(4),nid(4,2),2)*isg ! direction cos to 2nd edge normal
            q3=-vinpr(q(4),nid(4,3),2)*isg ! direction cos to 3rd edge normal
            fx= vinpr(fj1(4),nid(4,3),2)*(ra*(1+eps1)) ! distance to 3rd edge
            if(q1.le.eps.and.q2.le.eps.and.q3.le.fx) then
c     -q is in the triangle induced from an independent one
c     by the site symmetry operator r(nsyi)
               polyg1=0
               return
            end if
         end do
      end do
      return
      end

      subroutine inttri
      common /ctriac/ qi(6,15), qj(6,6)
      real ni(6)
      integer nr(6,15),mr(6,6)
      data nr/1,1,0,0,0,0,  1,0,1,0,0,0,  1,0,0,1,0,0,
     *        1,0,0,0,1,0,  1,0,0,0,0,1,  0,1,1,0,0,0,
     *        0,0,1,1,0,0,  0,0,0,1,1,0,  0,0,0,0,1,1,
     *        0,1,0,0,0,1,  0,1,0,-1,0,0, 0,0,1,0,-1,0,
     *        0,0,0,1,0,-1, 0,-1,0,0,1,0, 0,0,-1,0,0,1/
      data mr/1,0,0,0,0,0,  0,1,0,0,0,0,  0,0,1,0,0,0,
     *        0,0,0,1,0,0,  0,0,0,0,1,0,  0,0,0,0,0,1/
c     nr: normal to surface of triacontahedron
c     mr: normal to surface of regular dodecahedron
      do i=1,15
         do j=1,6
            ni(j)=nr(j,i)
         end do
         call getqe(ni,qi(1,i))
         dnr=vabs(qi(4,i),3)
         do k=4,6
            qi(k,i)=qi(k,i)/dnr
         end do
      end do
      do i=1,6
         do j=1,6
            ni(j)=mr(j,i)
         end do
         call getqe(ni,qj(1,i))
         dnr=vabs(qj(4,i),3)
         do k=4,6
            qj(k,i)=qj(k,i)/dnr
         end do
      end do
      return
      end

      integer function triach(q,ra,cent,ishpe)
      real q(*),cent(*),qc(6)
      common /ctriac/ qi(6,15), qj(6,6)
      real qd(6)
      data eps/0.00001/, fact/0.97905/
      call getqe(cent,qc)
c      if vector q is in the triacontahedron in vi then triach=0
      triach=1
      if(ra.lt.eps) return
      do i=1,15
         call vsubr(q,qc,qd,6)
         qn=vinpr(qd(4),qi(4,i),3)
         if(qn.lt.-ra.or.qn.gt.ra) return
      end do
      if(ishpe.lt.0) then
c        truncated triacontahedron
         do i=1,6
            call vsubr(q,qc,qd,6)
            qn=vinpr(qd(4),qj(4,i),3)
            if(qn.lt.-ra*fact.or.qn.gt.ra*fact) return
         end do
      end if
      triach=0
      return
      end


      subroutine getfjd0(x,rx,ns)
      real x(*),rx(*)
      call rednsic(ns,nsd,icd)
      call getrx0(x,rx,nsd,icd) ! 6D vector rotation
      return
      end 

      subroutine getejd0(qd,q,ns)
      real qd(*),q(*)
      real ejd(6)
      call rednsic(ns,nsd,icd)
      call getrx0i(qd,q,nsd,icd) ! domain rotation
      return
      end 

      subroutine getejd(qd,q,jsd,icd,nsy,icnt)
      real qd(*),q(*)
      real ejd(6)
      call getrx0i(qd,ejd,jsd,icd) ! domain rotation
      call getrx0i(ejd,q,nsy,icnt) ! site symmetry
      return
      end 

      subroutine pnrml1(ei,ej,ni)
      real ei(6),ej(6),ni(0:6)
      data eps /0.000001/
c       ei x ej : vector product
      ni(4)=(ei(5)*ej(6)-ei(6)*ej(5))
      ni(5)=(ei(6)*ej(4)-ei(4)*ej(6))
      ni(6)=(ei(4)*ej(5)-ei(5)*ej(4))
c             normalization
      absei=vabs(ni(4),3)
      if(absei.gt.eps) then
         ni(4)=ni(4)/absei
         ni(5)=ni(5)/absei
         ni(6)=ni(6)/absei
         ni(0)=absei
      else
         do k=4,6
            ni(k)=0.
         end do
         ni(0)=0.
      end if
      return
      end

      subroutine pnrml2(ei,ej,ek,ni)
      real ei(6),ej(6),ek(6),ni(0:6)
      real a(3,3),b(3),piv(3),cent(6)
      integer ipv(3),ind(6)
      data eps /0.00001/
      do j=1,3
         a(1,j)=ei(j+3)
         a(2,j)=ej(j+3)
         a(3,j)=ek(j+3)
         b(j)=1
      end do
      call matinv(a,3,3,b,1,det,ipv,ind,piv)
c     normalization
      absei=vabs(b,3)
      if(absei.gt.eps) then
          ni(4)=b(1)/absei
          ni(5)=b(2)/absei
          ni(6)=b(3)/absei
          ni(0)=absei
      else
         do k=4,6
            ni(k)=0.
         end do
         ni(0)=0.
      end if
      do i=4,6
         cent(i)=(ei(i)+ej(i)+ek(i))/3
      end do
      if(vinpr(cent(4),ni(4),3).gt.0.) then
          sig=1.
      else
          sig=-1.
c         write(6,*) 'sig in getni is negative'
      end if
      do j=4,6
         ni(j)=ni(j)*sig
      end do
      return
      end
