      subroutine setprjop0()
c     initialize projection operators (no phason)
      common /cprjop0/ prjoext0(6,6),prjoint0(6,6)
      real x(6),xe(6),xi(6),qe(6),qi(6)
      data x /0.1,0.2,0.3,0.4,0.5,0.6/
      call prjopext0(prjoext0)
      call prjopint0(prjoint0)
      call wtrmtrx6('prjoext0',prjoext0)
      call wtrmtrx6('prjoint0',prjoint0)
c     test for projection operators
c      call prjext0(x,xe)
c      call prjint0(x,xi)
c      call getqe(xe,qe)
c      call getqe(xi,qi)
c      call wtvctrr('x =',x,6)
c      call wtvctrr('xe=',xe,6)
c      call wtvctrr('xi=',xi,6)
c      call wtvctrr('qe=',qe,6)
c      call wtvctrr('qi=',qi,6)
      return
      end

      subroutine setprjop()
c     initialize projection operators (under linear phason)
      common /cprjop/ prjoext(6,6),prjoint(6,6)
      real x(6),xe(6),xi(6),qe(6),qi(6)
      data x /0.1,0.2,0.3,0.4,0.5,0.6/
      call prjopext(prjoext)
      call prjopint(prjoint)
      call wtrmtrx6('prjoext',prjoext)
      call wtrmtrx6('prjoint',prjoint)
c     test for projection operators
c      call prjext(x,xe)
c      call prjint(x,xi)
c      call getqed(xe,qe)
c      call getqed(xi,qi)
c      call wtvctrr('x =',x,6)
c      call wtvctrr('xe=',xe,6)
c      call wtvctrr('xi=',xi,6)
c      call wtvctrr('qe=',qe,6)
c      call wtvctrr('qi=',qi,6)
      return
      end

      subroutine prjext(x,xe)
c     project x onto external space  (under linear phason)
      real x(*),xe(*)
      common /cprjop/ prjoext(6,6),prjoint(6,6)
      call mtmplmnor(prjoext,x,xe,6,6,1)
      return
      end

      subroutine prjint(x,xi)
c     project x onto internal space  (under linear phason)
      real x(*),xi(*)
      common /cprjop/ prjoext(6,6),prjoint(6,6)
      call mtmplmnor(prjoint,x,xi,6,6,1)
      return
      end

      subroutine prjext0(x,xe) ! project x onto external space (no phason)
      real x(*),xe(*)
      common /cprjop0/ prjoext0(6,6),prjoint0(6,6)
      call mtmplmnor(prjoext0,x,xe,6,6,1)
      return
      end
   
      subroutine prjint0(x,xi)
c     projection onto int. space and normalize (no phason)
      real x(*),xi(*)
      common /cprjop0/ prjoext0(6,6),prjoint0(6,6)
      call mtmplmnor(prjoint0,x,xi,6,6,1)
      return
      end

      subroutine prjext1(x,xe)
c     projection onto ext. space and normalize (no phason)
      real x(*),xe(*)
      real q(6)
      common /cprjop0/ prjoext0(6,6),prjoint0(6,6)
      call mtmplmnor(prjoext0,x,xe,6,6,1)
      call getqe(xe,q)
      call norml(q,6)    ! normalize
      call getxe(q,xe)
      return
      end

      subroutine prjopext0(pext)
c     get projection operator onto ext. space (no phason)
      real pext(6,6)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      do i=1,6
         do j=1,6
            pext(i,j)=0
            do k=1,3      ! important
               pext(i,j)=pext(i,j)+dq(i,k)*dr(k,j)
            end do
         end do
      end do
      return
      end

      subroutine prjopint0(pint)
c     projection operator onto int. space (no phason)
      real pint(6,6)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      do i=1,6
         do j=1,6
            pint(i,j)=0
            do k=4,6      ! important
               pint(i,j)=pint(i,j)+dq(i,k)*dr(k,j)
            end do
         end do
      end do
      return
      end

      subroutine prjopext(pext)
c     projection operator onto ext. space (under linear phason)
      real pext(6,6)
      real drd(6,6),dqd(6,6)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call mtmplr6(de,dr,drd)
      call mtmplr6(dq,di,dqd)
      do i=1,6
         do j=1,6
            pext(i,j)=0
            do k=1,3       ! important
               pext(i,j)=pext(i,j)+dqd(i,k)*drd(k,j)
            end do
         end do
      end do
      return
      end

      subroutine prjopint(pint)
c     projection operator onto int. space (under linear phson)
      real pint(6,6)
      real drd(6,6),dqd(6,6)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call mtmplr6(de,dr,drd)
      call mtmplr6(dq,di,dqd)
      do i=1,6
         do j=1,6
            pint(i,j)=0
            do k=4,6       ! important
               pint(i,j)=pint(i,j)+dqd(i,k)*drd(k,j)
            end do
         end do
      end do
      return
      end
